/* HashMap.c generated by valac 0.54.7, the Vala compiler
 * generated from HashMap.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * GXml.HashMap.vala
 *
 * Copyright (C) 2016  Daniel Espinosa <esodan@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Daniel Espinosa <esodan@gmail.com>
 */

#include "gxml/gxml.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include "gxml.h"

enum  {
	GXML_HASH_MAP_0_PROPERTY,
	GXML_HASH_MAP_ATTRIBUTE_KEY_PROPERTY,
	GXML_HASH_MAP_KEYS_SET_PROPERTY,
	GXML_HASH_MAP_NUM_PROPERTIES
};
static GParamSpec* gxml_hash_map_properties[GXML_HASH_MAP_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

static gpointer gxml_hash_map_parent_class = NULL;
static GXmlMapIface * gxml_hash_map_gxml_map_parent_iface = NULL;

static gboolean gxml_hash_map_real_has_key (GXmlMap* base,
                                     const gchar* key);
static gboolean gxml_hash_map_real_validate_append (GXmlBaseCollection* base,
                                             gint index,
                                             GXmlDomElement* element,
                                             GError** error);
static void gxml_hash_map_real_clear (GXmlBaseCollection* base,
                               GError** error);
static GXmlDomElement* gxml_hash_map_real_item (GXmlMap* base,
                                         const gchar* key);
static void gxml_hash_map_finalize (GObject * obj);
static GType gxml_hash_map_get_type_once (void);
static void _vala_gxml_hash_map_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_gxml_hash_map_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const gchar*
gxml_hash_map_real_get_attribute_key (GXmlMap* base)
{
	const gchar* result;
	GXmlHashMap* self;
	const gchar* _tmp0_;
#line 70 "../gxml/HashMap.vala"
	self = (GXmlHashMap*) base;
#line 70 "../gxml/HashMap.vala"
	_tmp0_ = self->_attribute_key;
#line 70 "../gxml/HashMap.vala"
	result = _tmp0_;
#line 70 "../gxml/HashMap.vala"
	return result;
#line 86 "HashMap.c"
}

static void
gxml_hash_map_real_set_attribute_key (GXmlMap* base,
                                      const gchar* value)
{
	GXmlHashMap* self;
	gchar* _tmp0_;
#line 70 "../gxml/HashMap.vala"
	self = (GXmlHashMap*) base;
#line 70 "../gxml/HashMap.vala"
	_tmp0_ = g_strdup (value);
#line 70 "../gxml/HashMap.vala"
	_g_free0 (self->_attribute_key);
#line 70 "../gxml/HashMap.vala"
	self->_attribute_key = _tmp0_;
#line 70 "../gxml/HashMap.vala"
	g_object_notify_by_pspec ((GObject *) self, gxml_hash_map_properties[GXML_HASH_MAP_ATTRIBUTE_KEY_PROPERTY]);
#line 105 "HashMap.c"
}

/**
   * Convenient function to initialize a {@link GXml.HashMap} collection, using
   * given element, items' type and name.
   */
void
gxml_hash_map_initialize_element_with_key (GXmlHashMap* self,
                                           GXmlElement* element,
                                           GType items_type,
                                           const gchar* attribute_key,
                                           GError** error)
{
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 76 "../gxml/HashMap.vala"
	g_return_if_fail (self != NULL);
#line 76 "../gxml/HashMap.vala"
	g_return_if_fail (element != NULL);
#line 76 "../gxml/HashMap.vala"
	g_return_if_fail (attribute_key != NULL);
#line 80 "../gxml/HashMap.vala"
	gxml_collection_initialize ((GXmlCollection*) self, items_type, &_inner_error0_);
#line 80 "../gxml/HashMap.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 80 "../gxml/HashMap.vala"
		g_propagate_error (error, _inner_error0_);
#line 80 "../gxml/HashMap.vala"
		return;
#line 135 "HashMap.c"
	}
#line 81 "../gxml/HashMap.vala"
	gxml_base_collection_initialize_element ((GXmlBaseCollection*) self, element, &_inner_error0_);
#line 81 "../gxml/HashMap.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 81 "../gxml/HashMap.vala"
		g_propagate_error (error, _inner_error0_);
#line 81 "../gxml/HashMap.vala"
		return;
#line 145 "HashMap.c"
	}
#line 82 "../gxml/HashMap.vala"
	_tmp0_ = g_strdup (attribute_key);
#line 82 "../gxml/HashMap.vala"
	_g_free0 (self->_attribute_key);
#line 82 "../gxml/HashMap.vala"
	self->_attribute_key = _tmp0_;
#line 153 "HashMap.c"
}

/**
   * Convenient function to initialize a {@link GXml.HashMap} collection, using
   * given element, items' type and name.
   *
   * Using this method at construction time of derived classes.
   */
void
gxml_hash_map_initialize_with_key (GXmlHashMap* self,
                                   GType items_type,
                                   const gchar* attribute_key,
                                   GError** error)
{
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 91 "../gxml/HashMap.vala"
	g_return_if_fail (self != NULL);
#line 91 "../gxml/HashMap.vala"
	g_return_if_fail (attribute_key != NULL);
#line 94 "../gxml/HashMap.vala"
	gxml_collection_initialize ((GXmlCollection*) self, items_type, &_inner_error0_);
#line 94 "../gxml/HashMap.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 94 "../gxml/HashMap.vala"
		g_propagate_error (error, _inner_error0_);
#line 94 "../gxml/HashMap.vala"
		return;
#line 182 "HashMap.c"
	}
#line 95 "../gxml/HashMap.vala"
	_tmp0_ = g_strdup (attribute_key);
#line 95 "../gxml/HashMap.vala"
	_g_free0 (self->_attribute_key);
#line 95 "../gxml/HashMap.vala"
	self->_attribute_key = _tmp0_;
#line 190 "HashMap.c"
}

/**
   * Returns an {@link DomElement} in the collection using a string key.
   */
GXmlDomElement*
gxml_hash_map_get (GXmlHashMap* self,
                   const gchar* key)
{
	GeeHashMap* _tmp0_;
	gint i = 0;
	GeeHashMap* _tmp1_;
	gpointer _tmp2_;
	GXmlElement* _tmp3_;
	GXmlDomNodeList* _tmp4_;
	GXmlDomNodeList* _tmp5_;
	GXmlDomNodeList* _tmp6_;
	gpointer _tmp7_;
	GXmlDomNode* _tmp8_;
	GXmlDomElement* _tmp9_;
	GXmlDomElement* _tmp10_;
	GXmlDomElement* result = NULL;
#line 100 "../gxml/HashMap.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 100 "../gxml/HashMap.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 101 "../gxml/HashMap.vala"
	_tmp0_ = self->_hashtable;
#line 101 "../gxml/HashMap.vala"
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, key)) {
#line 101 "../gxml/HashMap.vala"
		result = NULL;
#line 101 "../gxml/HashMap.vala"
		return result;
#line 225 "HashMap.c"
	}
#line 102 "../gxml/HashMap.vala"
	_tmp1_ = self->_hashtable;
#line 102 "../gxml/HashMap.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, key);
#line 102 "../gxml/HashMap.vala"
	i = (gint) ((gintptr) _tmp2_);
#line 106 "../gxml/HashMap.vala"
	_tmp3_ = ((GXmlBaseCollection*) self)->_element;
#line 106 "../gxml/HashMap.vala"
	_tmp4_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) _tmp3_);
#line 106 "../gxml/HashMap.vala"
	_tmp5_ = _tmp4_;
#line 106 "../gxml/HashMap.vala"
	_tmp6_ = _tmp5_;
#line 106 "../gxml/HashMap.vala"
	_tmp7_ = gee_list_get ((GeeList*) _tmp6_, i);
#line 106 "../gxml/HashMap.vala"
	_tmp8_ = (GXmlDomNode*) _tmp7_;
#line 106 "../gxml/HashMap.vala"
	_tmp9_ = GXML_IS_DOM_ELEMENT (_tmp8_) ? ((GXmlDomElement*) _tmp8_) : NULL;
#line 106 "../gxml/HashMap.vala"
	if (_tmp9_ == NULL) {
#line 106 "../gxml/HashMap.vala"
		_g_object_unref0 (_tmp8_);
#line 251 "HashMap.c"
	}
#line 106 "../gxml/HashMap.vala"
	_tmp10_ = _tmp9_;
#line 106 "../gxml/HashMap.vala"
	_g_object_unref0 (_tmp6_);
#line 106 "../gxml/HashMap.vala"
	result = _tmp10_;
#line 106 "../gxml/HashMap.vala"
	return result;
#line 261 "HashMap.c"
}

/**
   * Returns true if @key is used in collection.
   */
static gboolean
gxml_hash_map_real_has_key (GXmlMap* base,
                            const gchar* key)
{
	GXmlHashMap * self;
	GeeHashMap* _tmp0_;
	gboolean result = FALSE;
#line 111 "../gxml/HashMap.vala"
	self = (GXmlHashMap*) base;
#line 111 "../gxml/HashMap.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 112 "../gxml/HashMap.vala"
	_tmp0_ = self->_hashtable;
#line 112 "../gxml/HashMap.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, key)) {
#line 112 "../gxml/HashMap.vala"
		result = TRUE;
#line 112 "../gxml/HashMap.vala"
		return result;
#line 286 "HashMap.c"
	}
#line 113 "../gxml/HashMap.vala"
	result = FALSE;
#line 113 "../gxml/HashMap.vala"
	return result;
#line 292 "HashMap.c"
}

/**
   * Returns list of keys used in collection.
   */
GList*
gxml_hash_map_get_keys (GXmlHashMap* self)
{
	GList* l = NULL;
	GList* result = NULL;
#line 118 "../gxml/HashMap.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 119 "../gxml/HashMap.vala"
	l = NULL;
#line 307 "HashMap.c"
	{
		GeeIterator* _k_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 120 "../gxml/HashMap.vala"
		_tmp0_ = self->_hashtable;
#line 120 "../gxml/HashMap.vala"
		_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp0_);
#line 120 "../gxml/HashMap.vala"
		_tmp2_ = _tmp1_;
#line 120 "../gxml/HashMap.vala"
		_tmp3_ = _tmp2_;
#line 120 "../gxml/HashMap.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 120 "../gxml/HashMap.vala"
		_tmp5_ = _tmp4_;
#line 120 "../gxml/HashMap.vala"
		_g_object_unref0 (_tmp3_);
#line 120 "../gxml/HashMap.vala"
		_k_it = _tmp5_;
#line 120 "../gxml/HashMap.vala"
		while (TRUE) {
#line 334 "HashMap.c"
			GeeIterator* _tmp6_;
			gchar* k = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
#line 120 "../gxml/HashMap.vala"
			_tmp6_ = _k_it;
#line 120 "../gxml/HashMap.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 120 "../gxml/HashMap.vala"
				break;
#line 347 "HashMap.c"
			}
#line 120 "../gxml/HashMap.vala"
			_tmp7_ = _k_it;
#line 120 "../gxml/HashMap.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 120 "../gxml/HashMap.vala"
			k = (gchar*) _tmp8_;
#line 120 "../gxml/HashMap.vala"
			_tmp9_ = k;
#line 120 "../gxml/HashMap.vala"
			_tmp10_ = g_strdup (_tmp9_);
#line 120 "../gxml/HashMap.vala"
			l = g_list_append (l, _tmp10_);
#line 120 "../gxml/HashMap.vala"
			_g_free0 (k);
#line 363 "HashMap.c"
		}
#line 120 "../gxml/HashMap.vala"
		_g_object_unref0 (_k_it);
#line 367 "HashMap.c"
	}
#line 121 "../gxml/HashMap.vala"
	result = l;
#line 121 "../gxml/HashMap.vala"
	return result;
#line 373 "HashMap.c"
}

/**
   * Validates if given element has a {@link GXml.HashMap.attribute_key} set,
   * if so adds a new key pointing to given index and returns true.
   *
   * Attribute should be a valid {@link DomElement} attribute or
   * a {@link GXml.Object} property identified using a nick with a '::' prefix.
   *
   * If there are more elements with same key, they are kept as child nodes
   * but the one in collection will be the last one to be found.
   *
   * Return: false if element should not be added to collection.
   */
static gboolean
gxml_hash_map_real_validate_append (GXmlBaseCollection* base,
                                    gint index,
                                    GXmlDomElement* element,
                                    GError** error)
{
	GXmlHashMap * self;
	gchar* key = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp14_;
	GeeHashMap* _tmp15_;
	const gchar* _tmp16_;
	gboolean result = FALSE;
#line 135 "../gxml/HashMap.vala"
	self = (GXmlHashMap*) base;
#line 135 "../gxml/HashMap.vala"
	g_return_val_if_fail (element != NULL, FALSE);
#line 136 "../gxml/HashMap.vala"
	if (!GXML_IS_ELEMENT (element)) {
#line 136 "../gxml/HashMap.vala"
		result = FALSE;
#line 136 "../gxml/HashMap.vala"
		return result;
#line 412 "HashMap.c"
	}
#line 142 "../gxml/HashMap.vala"
	key = NULL;
#line 143 "../gxml/HashMap.vala"
	_tmp0_ = gxml_map_get_attribute_key ((GXmlMap*) self);
#line 143 "../gxml/HashMap.vala"
	_tmp1_ = _tmp0_;
#line 143 "../gxml/HashMap.vala"
	if (_tmp1_ != NULL) {
#line 422 "HashMap.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
#line 144 "../gxml/HashMap.vala"
		_tmp2_ = gxml_map_get_attribute_key ((GXmlMap*) self);
#line 144 "../gxml/HashMap.vala"
		_tmp3_ = _tmp2_;
#line 144 "../gxml/HashMap.vala"
		_tmp4_ = gxml_dom_element_get_attribute (G_TYPE_CHECK_INSTANCE_CAST (element, GXML_TYPE_DOM_ELEMENT, GXmlDomElement), _tmp3_);
#line 144 "../gxml/HashMap.vala"
		_g_free0 (key);
#line 144 "../gxml/HashMap.vala"
		key = _tmp4_;
#line 145 "../gxml/HashMap.vala"
		_tmp5_ = key;
#line 145 "../gxml/HashMap.vala"
		if (_tmp5_ == NULL) {
#line 441 "HashMap.c"
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
#line 146 "../gxml/HashMap.vala"
			_tmp6_ = gxml_map_get_attribute_key ((GXmlMap*) self);
#line 146 "../gxml/HashMap.vala"
			_tmp7_ = _tmp6_;
#line 146 "../gxml/HashMap.vala"
			_tmp8_ = g_utf8_strdown (_tmp7_, (gssize) -1);
#line 146 "../gxml/HashMap.vala"
			_tmp9_ = _tmp8_;
#line 146 "../gxml/HashMap.vala"
			_tmp10_ = gxml_dom_element_get_attribute (G_TYPE_CHECK_INSTANCE_CAST (element, GXML_TYPE_DOM_ELEMENT, GXmlDomElement), _tmp9_);
#line 146 "../gxml/HashMap.vala"
			_g_free0 (key);
#line 146 "../gxml/HashMap.vala"
			key = _tmp10_;
#line 146 "../gxml/HashMap.vala"
			_g_free0 (_tmp9_);
#line 463 "HashMap.c"
		}
	} else {
		GType _tmp11_;
		GType _tmp12_;
#line 148 "../gxml/HashMap.vala"
		_tmp11_ = gxml_collection_get_items_type ((GXmlCollection*) self);
#line 148 "../gxml/HashMap.vala"
		_tmp12_ = _tmp11_;
#line 148 "../gxml/HashMap.vala"
		if (g_type_is_a (_tmp12_, GXML_TYPE_MAPPEABLE_ELEMENT)) {
#line 474 "HashMap.c"
			gchar* _tmp13_;
#line 149 "../gxml/HashMap.vala"
			if (!GXML_IS_MAPPEABLE_ELEMENT (element)) {
#line 149 "../gxml/HashMap.vala"
				result = FALSE;
#line 149 "../gxml/HashMap.vala"
				_g_free0 (key);
#line 149 "../gxml/HashMap.vala"
				return result;
#line 484 "HashMap.c"
			}
#line 150 "../gxml/HashMap.vala"
			_tmp13_ = gxml_mappeable_element_get_map_key (G_TYPE_CHECK_INSTANCE_CAST (element, GXML_TYPE_MAPPEABLE_ELEMENT, GXmlMappeableElement));
#line 150 "../gxml/HashMap.vala"
			_g_free0 (key);
#line 150 "../gxml/HashMap.vala"
			key = _tmp13_;
#line 492 "HashMap.c"
		}
	}
#line 153 "../gxml/HashMap.vala"
	_tmp14_ = key;
#line 153 "../gxml/HashMap.vala"
	if (_tmp14_ == NULL) {
#line 153 "../gxml/HashMap.vala"
		result = FALSE;
#line 153 "../gxml/HashMap.vala"
		_g_free0 (key);
#line 153 "../gxml/HashMap.vala"
		return result;
#line 505 "HashMap.c"
	}
#line 157 "../gxml/HashMap.vala"
	_tmp15_ = self->_hashtable;
#line 157 "../gxml/HashMap.vala"
	_tmp16_ = key;
#line 157 "../gxml/HashMap.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp15_, _tmp16_, (gpointer) ((gintptr) index));
#line 158 "../gxml/HashMap.vala"
	result = TRUE;
#line 158 "../gxml/HashMap.vala"
	_g_free0 (key);
#line 158 "../gxml/HashMap.vala"
	return result;
#line 519 "HashMap.c"
}

static void
gxml_hash_map_real_clear (GXmlBaseCollection* base,
                          GError** error)
{
	GXmlHashMap * self;
	GeeHashMap* _tmp0_;
#line 160 "../gxml/HashMap.vala"
	self = (GXmlHashMap*) base;
#line 161 "../gxml/HashMap.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_INT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 161 "../gxml/HashMap.vala"
	_g_object_unref0 (self->_hashtable);
#line 161 "../gxml/HashMap.vala"
	self->_hashtable = _tmp0_;
#line 536 "HashMap.c"
}

static GXmlDomElement*
gxml_hash_map_real_item (GXmlMap* base,
                         const gchar* key)
{
	GXmlHashMap * self;
	GXmlDomElement* _tmp0_;
	GXmlDomElement* result = NULL;
#line 163 "../gxml/HashMap.vala"
	self = (GXmlHashMap*) base;
#line 163 "../gxml/HashMap.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 163 "../gxml/HashMap.vala"
	_tmp0_ = gxml_hash_map_get (self, key);
#line 163 "../gxml/HashMap.vala"
	result = _tmp0_;
#line 163 "../gxml/HashMap.vala"
	return result;
#line 556 "HashMap.c"
}

static GeeSet*
gxml_hash_map_real_get_keys_set (GXmlMap* base)
{
	GeeSet* result;
	GXmlHashMap* self;
	GeeHashSet* l = NULL;
	GeeHashSet* _tmp0_;
#line 165 "../gxml/HashMap.vala"
	self = (GXmlHashMap*) base;
#line 166 "../gxml/HashMap.vala"
	_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 166 "../gxml/HashMap.vala"
	l = _tmp0_;
#line 572 "HashMap.c"
	{
		GeeIterator* _k_it = NULL;
		GeeHashMap* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 167 "../gxml/HashMap.vala"
		_tmp1_ = self->_hashtable;
#line 167 "../gxml/HashMap.vala"
		_tmp2_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp1_);
#line 167 "../gxml/HashMap.vala"
		_tmp3_ = _tmp2_;
#line 167 "../gxml/HashMap.vala"
		_tmp4_ = _tmp3_;
#line 167 "../gxml/HashMap.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 167 "../gxml/HashMap.vala"
		_tmp6_ = _tmp5_;
#line 167 "../gxml/HashMap.vala"
		_g_object_unref0 (_tmp4_);
#line 167 "../gxml/HashMap.vala"
		_k_it = _tmp6_;
#line 167 "../gxml/HashMap.vala"
		while (TRUE) {
#line 599 "HashMap.c"
			GeeIterator* _tmp7_;
			gchar* k = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GeeHashSet* _tmp10_;
			const gchar* _tmp11_;
#line 167 "../gxml/HashMap.vala"
			_tmp7_ = _k_it;
#line 167 "../gxml/HashMap.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 167 "../gxml/HashMap.vala"
				break;
#line 612 "HashMap.c"
			}
#line 167 "../gxml/HashMap.vala"
			_tmp8_ = _k_it;
#line 167 "../gxml/HashMap.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 167 "../gxml/HashMap.vala"
			k = (gchar*) _tmp9_;
#line 167 "../gxml/HashMap.vala"
			_tmp10_ = l;
#line 167 "../gxml/HashMap.vala"
			_tmp11_ = k;
#line 167 "../gxml/HashMap.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 167 "../gxml/HashMap.vala"
			_g_free0 (k);
#line 628 "HashMap.c"
		}
#line 167 "../gxml/HashMap.vala"
		_g_object_unref0 (_k_it);
#line 632 "HashMap.c"
	}
#line 168 "../gxml/HashMap.vala"
	result = (GeeSet*) l;
#line 168 "../gxml/HashMap.vala"
	return result;
#line 638 "HashMap.c"
}

GXmlHashMap*
gxml_hash_map_construct (GType object_type)
{
	GXmlHashMap * self = NULL;
#line 54 "../gxml/HashMap.vala"
	self = (GXmlHashMap*) gxml_base_collection_construct (object_type);
#line 54 "../gxml/HashMap.vala"
	return self;
#line 649 "HashMap.c"
}

GXmlHashMap*
gxml_hash_map_new (void)
{
#line 54 "../gxml/HashMap.vala"
	return gxml_hash_map_construct (GXML_TYPE_HASH_MAP);
#line 657 "HashMap.c"
}

static void
gxml_hash_map_class_init (GXmlHashMapClass * klass,
                          gpointer klass_data)
{
#line 54 "../gxml/HashMap.vala"
	gxml_hash_map_parent_class = g_type_class_peek_parent (klass);
#line 54 "../gxml/HashMap.vala"
	((GXmlBaseCollectionClass *) klass)->validate_append = (gboolean (*) (GXmlBaseCollection*, gint, GXmlDomElement*, GError**)) gxml_hash_map_real_validate_append;
#line 54 "../gxml/HashMap.vala"
	((GXmlBaseCollectionClass *) klass)->clear = (void (*) (GXmlBaseCollection*, GError**)) gxml_hash_map_real_clear;
#line 54 "../gxml/HashMap.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gxml_hash_map_get_property;
#line 54 "../gxml/HashMap.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gxml_hash_map_set_property;
#line 54 "../gxml/HashMap.vala"
	G_OBJECT_CLASS (klass)->finalize = gxml_hash_map_finalize;
#line 676 "HashMap.c"
	/**
	   * An attribute's name in items to be added and used to retrieve elements
	   * as key.
	   */
#line 54 "../gxml/HashMap.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_HASH_MAP_ATTRIBUTE_KEY_PROPERTY, gxml_hash_map_properties[GXML_HASH_MAP_ATTRIBUTE_KEY_PROPERTY] = g_param_spec_string ("attribute-key", "attribute-key", "attribute-key", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 54 "../gxml/HashMap.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_HASH_MAP_KEYS_SET_PROPERTY, gxml_hash_map_properties[GXML_HASH_MAP_KEYS_SET_PROPERTY] = g_param_spec_object ("keys-set", "keys-set", "keys-set", GEE_TYPE_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 685 "HashMap.c"
}

static void
gxml_hash_map_gxml_map_interface_init (GXmlMapIface * iface,
                                       gpointer iface_data)
{
#line 54 "../gxml/HashMap.vala"
	gxml_hash_map_gxml_map_parent_iface = g_type_interface_peek_parent (iface);
#line 54 "../gxml/HashMap.vala"
	iface->has_key = (gboolean (*) (GXmlMap*, const gchar*)) gxml_hash_map_real_has_key;
#line 54 "../gxml/HashMap.vala"
	iface->item = (GXmlDomElement* (*) (GXmlMap*, const gchar*)) gxml_hash_map_real_item;
#line 54 "../gxml/HashMap.vala"
	iface->get_attribute_key = gxml_hash_map_real_get_attribute_key;
#line 54 "../gxml/HashMap.vala"
	iface->set_attribute_key = gxml_hash_map_real_set_attribute_key;
#line 54 "../gxml/HashMap.vala"
	iface->get_keys_set = gxml_hash_map_real_get_keys_set;
#line 704 "HashMap.c"
}

static void
gxml_hash_map_instance_init (GXmlHashMap * self,
                             gpointer klass)
{
	GeeHashMap* _tmp0_;
#line 58 "../gxml/HashMap.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_INT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 58 "../gxml/HashMap.vala"
	self->_hashtable = _tmp0_;
#line 716 "HashMap.c"
}

static void
gxml_hash_map_finalize (GObject * obj)
{
	GXmlHashMap * self;
#line 54 "../gxml/HashMap.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GXML_TYPE_HASH_MAP, GXmlHashMap);
#line 58 "../gxml/HashMap.vala"
	_g_object_unref0 (self->_hashtable);
#line 64 "../gxml/HashMap.vala"
	_g_free0 (self->_attribute_key);
#line 54 "../gxml/HashMap.vala"
	G_OBJECT_CLASS (gxml_hash_map_parent_class)->finalize (obj);
#line 731 "HashMap.c"
}

/**
 * A class implementing {@link Collection} to store references to
 * child {@link DomElement} of {@link Collection.element}, using an attribute in
 * items as key or {@link MappeableElement.get_map_key} method if implemented
 * by items to be added. If key is not defined in node, it is not added; but
 * keeps it as a child node of actual {@link Collection.element}.
 *
 * If {@link GXml.Element} to be added is of type {@link Collection.items_type}
 * and implements {@link MappeableElement}, you should set {@link GXml.HashMap.attribute_key}
 * to null in order to use returned value of {@link MappeableElement.get_map_key}
 * as key.
 *
 * {{{
 *   public class YourObject : GXml.Element {
 *    [Description (nick="::Name")]
 *    public string name { get; set; }
 *   }
 *   public class YourList : GXml.HashMap {
 *    construct {
 *      try { initialize_with_key (typeof (YourObject),"Name"); }
 *      catch (GLib.Error e) {
 *        warning ("Initialization error for collection type: %s : %s"
 *             .printf (get_type ().name(), e.message));
 *      }
 *    }
 *   }
 * }}}
 */
static GType
gxml_hash_map_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GXmlHashMapClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_hash_map_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GXmlHashMap), 0, (GInstanceInitFunc) gxml_hash_map_instance_init, NULL };
	static const GInterfaceInfo gxml_map_info = { (GInterfaceInitFunc) gxml_hash_map_gxml_map_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gxml_hash_map_type_id;
	gxml_hash_map_type_id = g_type_register_static (GXML_TYPE_BASE_COLLECTION, "GXmlHashMap", &g_define_type_info, 0);
	g_type_add_interface_static (gxml_hash_map_type_id, GXML_TYPE_MAP, &gxml_map_info);
	return gxml_hash_map_type_id;
}

GType
gxml_hash_map_get_type (void)
{
	static volatile gsize gxml_hash_map_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_hash_map_type_id__volatile)) {
		GType gxml_hash_map_type_id;
		gxml_hash_map_type_id = gxml_hash_map_get_type_once ();
		g_once_init_leave (&gxml_hash_map_type_id__volatile, gxml_hash_map_type_id);
	}
	return gxml_hash_map_type_id__volatile;
}

static void
_vala_gxml_hash_map_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	GXmlHashMap * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_HASH_MAP, GXmlHashMap);
#line 54 "../gxml/HashMap.vala"
	switch (property_id) {
#line 54 "../gxml/HashMap.vala"
		case GXML_HASH_MAP_ATTRIBUTE_KEY_PROPERTY:
#line 54 "../gxml/HashMap.vala"
		g_value_set_string (value, gxml_map_get_attribute_key ((GXmlMap*) self));
#line 54 "../gxml/HashMap.vala"
		break;
#line 54 "../gxml/HashMap.vala"
		case GXML_HASH_MAP_KEYS_SET_PROPERTY:
#line 54 "../gxml/HashMap.vala"
		g_value_take_object (value, gxml_map_get_keys_set ((GXmlMap*) self));
#line 54 "../gxml/HashMap.vala"
		break;
#line 807 "HashMap.c"
		default:
#line 54 "../gxml/HashMap.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 54 "../gxml/HashMap.vala"
		break;
#line 813 "HashMap.c"
	}
}

static void
_vala_gxml_hash_map_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	GXmlHashMap * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_HASH_MAP, GXmlHashMap);
#line 54 "../gxml/HashMap.vala"
	switch (property_id) {
#line 54 "../gxml/HashMap.vala"
		case GXML_HASH_MAP_ATTRIBUTE_KEY_PROPERTY:
#line 54 "../gxml/HashMap.vala"
		gxml_map_set_attribute_key ((GXmlMap*) self, g_value_get_string (value));
#line 54 "../gxml/HashMap.vala"
		break;
#line 833 "HashMap.c"
		default:
#line 54 "../gxml/HashMap.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 54 "../gxml/HashMap.vala"
		break;
#line 839 "HashMap.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 36 "../gxml/Document.vala"
	if (mem && byte_size != 0) {
#line 36 "../gxml/Document.vala"
		new_mem = g_malloc (byte_size);
#line 36 "../gxml/Document.vala"
		memcpy (new_mem, mem, byte_size);
#line 854 "HashMap.c"
	} else {
#line 36 "../gxml/Document.vala"
		new_mem = NULL;
#line 858 "HashMap.c"
	}
#line 36 "../gxml/Document.vala"
	return new_mem;
#line 862 "HashMap.c"
}

