/* Node.c generated by valac 0.54.7, the Vala compiler
 * generated from Node.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; c-basic-offset: 2; tab-width: 2 -*- */
/*
 *
 * Copyright (C) 2016  Daniel Espinosa <esodan@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Daniel Espinosa <esodan@gmail.com>
 */

#include "gxml/gxml.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include "gxml.h"

enum  {
	GXML_NODE_0_PROPERTY,
	GXML_NODE_NODE_TYPE_PROPERTY,
	GXML_NODE_NODE_NAME_PROPERTY,
	GXML_NODE_BASE_URI_PROPERTY,
	GXML_NODE_OWNER_DOCUMENT_PROPERTY,
	GXML_NODE_PARENT_NODE_PROPERTY,
	GXML_NODE_PARENT_ELEMENT_PROPERTY,
	GXML_NODE_CHILD_NODES_PROPERTY,
	GXML_NODE_FIRST_CHILD_PROPERTY,
	GXML_NODE_LAST_CHILD_PROPERTY,
	GXML_NODE_PREVIOUS_SIBLING_PROPERTY,
	GXML_NODE_NEXT_SIBLING_PROPERTY,
	GXML_NODE_NODE_VALUE_PROPERTY,
	GXML_NODE_TEXT_CONTENT_PROPERTY,
	GXML_NODE_NUM_PROPERTIES
};
static GParamSpec* gxml_node_properties[GXML_NODE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	GXML_NODE_LIST_0_PROPERTY,
	GXML_NODE_LIST_LENGTH_PROPERTY,
	GXML_NODE_LIST_NUM_PROPERTIES
};
static GParamSpec* gxml_node_list_properties[GXML_NODE_LIST_NUM_PROPERTIES];

static gpointer gxml_node_parent_class = NULL;
static GXmlDomEventTargetIface * gxml_node_gxml_dom_event_target_parent_iface = NULL;
static GXmlDomNodeIface * gxml_node_gxml_dom_node_parent_iface = NULL;
static gpointer gxml_node_list_parent_class = NULL;
static GXmlDomNodeListIface * gxml_node_list_gxml_dom_node_list_parent_iface = NULL;

static gboolean gxml_node_real_has_child_nodes (GXmlDomNode* base);
static void gxml_node_real_normalize (GXmlDomNode* base);
static gboolean gxml_node_real_is_equal_node (GXmlDomNode* base,
                                       GXmlDomNode* node);
static GXmlDomNodeDocumentPosition gxml_node_real_compare_document_position (GXmlDomNode* base,
                                                                      GXmlDomNode* other);
static gboolean gxml_node_real_contains (GXmlDomNode* base,
                                  GXmlDomNode* other);
static gchar* gxml_node_real_lookup_prefix (GXmlDomNode* base,
                                     const gchar* nspace);
static gchar* gxml_node_real_lookup_namespace_uri (GXmlDomNode* base,
                                            const gchar* prefix);
static gboolean gxml_node_real_is_default_namespace (GXmlDomNode* base,
                                              const gchar* nspace);
VALA_EXTERN void gxml_node_set_parent (GXmlNode* self,
                           GXmlDomNode* node,
                           GError** error);
static GXmlDomNode* gxml_node_real_insert_before (GXmlDomNode* base,
                                           GXmlDomNode* node,
                                           GXmlDomNode* child,
                                           GError** error);
static GXmlDomNode* gxml_node_real_append_child (GXmlDomNode* base,
                                          GXmlDomNode* node,
                                          GError** error);
static GXmlDomNode* gxml_node_real_replace_child (GXmlDomNode* base,
                                           GXmlDomNode* node,
                                           GXmlDomNode* child,
                                           GError** error);
static GXmlDomNode* gxml_node_real_remove_child (GXmlDomNode* base,
                                          GXmlDomNode* child,
                                          GError** error);
static void gxml_node_real_add_event_listener (GXmlDomEventTarget* base,
                                        const gchar* type,
                                        GXmlDomEventListener* callback,
                                        gboolean capture);
static void gxml_node_real_remove_event_listener (GXmlDomEventTarget* base,
                                           const gchar* type,
                                           GXmlDomEventListener* callback,
                                           gboolean capture);
static gboolean gxml_node_real_dispatch_event (GXmlDomEventTarget* base,
                                        GXmlDomEvent* event,
                                        GError** error);
static GObject * gxml_node_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static void gxml_node_finalize (GObject * obj);
static GType gxml_node_get_type_once (void);
static void _vala_gxml_node_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_gxml_node_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
static GXmlDomNode* gxml_node_list_real_item (GXmlDomNodeList* base,
                                       gint index);
static GType gxml_node_list_get_type_once (void);
static void _vala_gxml_node_list_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GXmlDomNodeNodeType
gxml_node_real_get_node_type (GXmlDomNode* base)
{
	GXmlDomNodeNodeType result;
	GXmlNode* self;
#line 66 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 66 "../gxml/Node.vala"
	result = self->_node_type;
#line 66 "../gxml/Node.vala"
	return result;
#line 146 "Node.c"
}

static gchar*
gxml_node_real_get_node_name (GXmlDomNode* base)
{
	gchar* result;
	GXmlNode* self;
	const gchar* _tmp0_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
#line 68 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 69 "../gxml/Node.vala"
	_tmp0_ = self->_local_name;
#line 69 "../gxml/Node.vala"
	if (_tmp0_ == NULL) {
#line 169 "Node.c"
		gchar* _tmp1_;
#line 69 "../gxml/Node.vala"
		_tmp1_ = g_strdup ("NO NAME");
#line 69 "../gxml/Node.vala"
		result = _tmp1_;
#line 69 "../gxml/Node.vala"
		return result;
#line 177 "Node.c"
	}
#line 70 "../gxml/Node.vala"
	_tmp3_ = self->_prefix;
#line 70 "../gxml/Node.vala"
	if (_tmp3_ == NULL) {
#line 70 "../gxml/Node.vala"
		_tmp2_ = TRUE;
#line 185 "Node.c"
	} else {
		const gchar* _tmp4_;
#line 70 "../gxml/Node.vala"
		_tmp4_ = self->_prefix;
#line 70 "../gxml/Node.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "") == 0;
#line 192 "Node.c"
	}
#line 70 "../gxml/Node.vala"
	if (_tmp2_) {
#line 196 "Node.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 70 "../gxml/Node.vala"
		_tmp5_ = self->_local_name;
#line 70 "../gxml/Node.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 70 "../gxml/Node.vala"
		result = _tmp6_;
#line 70 "../gxml/Node.vala"
		return result;
#line 207 "Node.c"
	}
#line 71 "../gxml/Node.vala"
	_tmp7_ = self->_prefix;
#line 71 "../gxml/Node.vala"
	_tmp8_ = g_strconcat (_tmp7_, ":", NULL);
#line 71 "../gxml/Node.vala"
	_tmp9_ = _tmp8_;
#line 71 "../gxml/Node.vala"
	_tmp10_ = self->_local_name;
#line 71 "../gxml/Node.vala"
	_tmp11_ = g_strconcat (_tmp9_, _tmp10_, NULL);
#line 71 "../gxml/Node.vala"
	_tmp12_ = _tmp11_;
#line 71 "../gxml/Node.vala"
	_g_free0 (_tmp9_);
#line 71 "../gxml/Node.vala"
	result = _tmp12_;
#line 71 "../gxml/Node.vala"
	return result;
#line 227 "Node.c"
}

static const gchar*
gxml_node_real_get_base_uri (GXmlDomNode* base)
{
	const gchar* result;
	GXmlNode* self;
	const gchar* _tmp0_;
#line 75 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 75 "../gxml/Node.vala"
	_tmp0_ = self->_base_uri;
#line 75 "../gxml/Node.vala"
	result = _tmp0_;
#line 75 "../gxml/Node.vala"
	return result;
#line 244 "Node.c"
}

static GXmlDomDocument*
gxml_node_real_get_owner_document (GXmlDomNode* base)
{
	GXmlDomDocument* result;
	GXmlNode* self;
	GXmlDomDocument* _tmp0_;
	GXmlDomDocument* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 79 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 80 "../gxml/Node.vala"
	if (GXML_IS_DOM_DOCUMENT (self)) {
#line 80 "../gxml/Node.vala"
		result = G_TYPE_CHECK_INSTANCE_CAST (self, GXML_TYPE_DOM_DOCUMENT, GXmlDomDocument);
#line 80 "../gxml/Node.vala"
		return result;
#line 263 "Node.c"
	}
#line 81 "../gxml/Node.vala"
	_tmp0_ = self->_document;
#line 81 "../gxml/Node.vala"
	if (_tmp0_ == NULL) {
#line 269 "Node.c"
		GXmlDocument* _tmp1_;
#line 82 "../gxml/Node.vala"
		_tmp1_ = gxml_document_new ();
#line 82 "../gxml/Node.vala"
		_g_object_unref0 (self->_document);
#line 82 "../gxml/Node.vala"
		self->_document = (GXmlDomDocument*) _tmp1_;
#line 83 "../gxml/Node.vala"
		if (GXML_IS_DOM_ELEMENT (self)) {
#line 279 "Node.c"
			{
				GXmlDomDocument* _tmp2_;
				GXmlDomNode* _tmp3_;
				GXmlDomNode* _tmp4_;
#line 84 "../gxml/Node.vala"
				_tmp2_ = self->_document;
#line 84 "../gxml/Node.vala"
				_tmp3_ = gxml_dom_node_append_child ((GXmlDomNode*) _tmp2_, (GXmlDomNode*) self, &_inner_error0_);
#line 84 "../gxml/Node.vala"
				_tmp4_ = _tmp3_;
#line 84 "../gxml/Node.vala"
				_g_object_unref0 (_tmp4_);
#line 84 "../gxml/Node.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 294 "Node.c"
					goto __catch0_g_error;
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				GError* _tmp5_;
				const gchar* _tmp6_;
#line 84 "../gxml/Node.vala"
				e = _inner_error0_;
#line 84 "../gxml/Node.vala"
				_inner_error0_ = NULL;
#line 85 "../gxml/Node.vala"
				_tmp5_ = e;
#line 85 "../gxml/Node.vala"
				_tmp6_ = _tmp5_->message;
#line 85 "../gxml/Node.vala"
				g_warning ("Node.vala:85: %s", _tmp6_);
#line 84 "../gxml/Node.vala"
				_g_error_free0 (e);
#line 316 "Node.c"
			}
			__finally0:
#line 84 "../gxml/Node.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 84 "../gxml/Node.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 84 "../gxml/Node.vala"
				g_clear_error (&_inner_error0_);
#line 84 "../gxml/Node.vala"
				return NULL;
#line 327 "Node.c"
			}
		}
	}
#line 88 "../gxml/Node.vala"
	_tmp7_ = self->_document;
#line 88 "../gxml/Node.vala"
	result = _tmp7_;
#line 88 "../gxml/Node.vala"
	return result;
#line 337 "Node.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 90 "../gxml/Node.vala"
	return self ? g_object_ref (self) : NULL;
#line 345 "Node.c"
}

static void
gxml_node_real_set_owner_document (GXmlDomNode* base,
                                   GXmlDomDocument* value)
{
	GXmlNode* self;
	GXmlDomDocument* _tmp0_;
#line 90 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 90 "../gxml/Node.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 90 "../gxml/Node.vala"
	_g_object_unref0 (self->_document);
#line 90 "../gxml/Node.vala"
	self->_document = _tmp0_;
#line 90 "../gxml/Node.vala"
	g_object_notify_by_pspec ((GObject *) self, gxml_node_properties[GXML_NODE_OWNER_DOCUMENT_PROPERTY]);
#line 364 "Node.c"
}

static GXmlDomNode*
gxml_node_real_get_parent_node (GXmlDomNode* base)
{
	GXmlDomNode* result;
	GXmlNode* self;
	GXmlDomNode* _tmp0_;
	GXmlDomNode* _tmp1_;
#line 93 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 93 "../gxml/Node.vala"
	_tmp0_ = self->_parent;
#line 93 "../gxml/Node.vala"
	_tmp1_ = _g_object_ref0 (GXML_IS_DOM_NODE (_tmp0_) ? ((GXmlDomNode*) _tmp0_) : NULL);
#line 93 "../gxml/Node.vala"
	result = _tmp1_;
#line 93 "../gxml/Node.vala"
	return result;
#line 384 "Node.c"
}

static GXmlDomElement*
gxml_node_real_get_parent_element (GXmlDomNode* base)
{
	GXmlDomElement* result;
	GXmlNode* self;
	GXmlDomNode* _tmp0_;
#line 95 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 96 "../gxml/Node.vala"
	_tmp0_ = self->_parent;
#line 96 "../gxml/Node.vala"
	if (GXML_IS_DOM_ELEMENT (_tmp0_)) {
#line 399 "Node.c"
		GXmlDomNode* _tmp1_;
		GXmlDomElement* _tmp2_;
#line 96 "../gxml/Node.vala"
		_tmp1_ = self->_parent;
#line 96 "../gxml/Node.vala"
		_tmp2_ = _g_object_ref0 (GXML_IS_DOM_ELEMENT (_tmp1_) ? ((GXmlDomElement*) _tmp1_) : NULL);
#line 96 "../gxml/Node.vala"
		result = _tmp2_;
#line 96 "../gxml/Node.vala"
		return result;
#line 410 "Node.c"
	}
#line 97 "../gxml/Node.vala"
	result = NULL;
#line 97 "../gxml/Node.vala"
	return result;
#line 416 "Node.c"
}

static GXmlDomNodeList*
gxml_node_real_get_child_nodes (GXmlDomNode* base)
{
	GXmlDomNodeList* result;
	GXmlNode* self;
	GXmlNodeList* _tmp0_;
	GXmlDomNodeList* _tmp1_;
#line 100 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 100 "../gxml/Node.vala"
	_tmp0_ = self->_child_nodes;
#line 100 "../gxml/Node.vala"
	_tmp1_ = _g_object_ref0 (GXML_IS_DOM_NODE_LIST (_tmp0_) ? ((GXmlDomNodeList*) _tmp0_) : NULL);
#line 100 "../gxml/Node.vala"
	result = _tmp1_;
#line 100 "../gxml/Node.vala"
	return result;
#line 436 "Node.c"
}

static GXmlDomNode*
gxml_node_real_get_first_child (GXmlDomNode* base)
{
	GXmlDomNode* result;
	GXmlNode* self;
	GXmlDomNodeList* _tmp0_;
	GXmlDomNodeList* _tmp1_;
	GXmlDomNodeList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_;
	GXmlDomNodeList* _tmp6_;
	GXmlDomNodeList* _tmp7_;
	GXmlDomNodeList* _tmp8_;
	gpointer _tmp9_;
	GXmlDomNode* _tmp10_;
#line 102 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 103 "../gxml/Node.vala"
	_tmp0_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 103 "../gxml/Node.vala"
	_tmp1_ = _tmp0_;
#line 103 "../gxml/Node.vala"
	_tmp2_ = _tmp1_;
#line 103 "../gxml/Node.vala"
	_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 103 "../gxml/Node.vala"
	_tmp4_ = _tmp3_;
#line 103 "../gxml/Node.vala"
	_tmp5_ = _tmp4_ == 0;
#line 103 "../gxml/Node.vala"
	_g_object_unref0 (_tmp2_);
#line 103 "../gxml/Node.vala"
	if (_tmp5_) {
#line 103 "../gxml/Node.vala"
		result = NULL;
#line 103 "../gxml/Node.vala"
		return result;
#line 477 "Node.c"
	}
#line 104 "../gxml/Node.vala"
	_tmp6_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 104 "../gxml/Node.vala"
	_tmp7_ = _tmp6_;
#line 104 "../gxml/Node.vala"
	_tmp8_ = _tmp7_;
#line 104 "../gxml/Node.vala"
	_tmp9_ = gee_list_get ((GeeList*) _tmp8_, 0);
#line 104 "../gxml/Node.vala"
	_tmp10_ = (GXmlDomNode*) _tmp9_;
#line 104 "../gxml/Node.vala"
	_g_object_unref0 (_tmp8_);
#line 104 "../gxml/Node.vala"
	result = _tmp10_;
#line 104 "../gxml/Node.vala"
	return result;
#line 495 "Node.c"
}

static GXmlDomNode*
gxml_node_real_get_last_child (GXmlDomNode* base)
{
	GXmlDomNode* result;
	GXmlNode* self;
	GXmlDomNodeList* _tmp0_;
	GXmlDomNodeList* _tmp1_;
	GXmlDomNodeList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_;
	GXmlDomNodeList* _tmp6_;
	GXmlDomNodeList* _tmp7_;
	GXmlDomNodeList* _tmp8_;
	GXmlDomNodeList* _tmp9_;
	GXmlDomNodeList* _tmp10_;
	GXmlDomNodeList* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gpointer _tmp14_;
	GXmlDomNode* _tmp15_;
#line 108 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 109 "../gxml/Node.vala"
	_tmp0_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 109 "../gxml/Node.vala"
	_tmp1_ = _tmp0_;
#line 109 "../gxml/Node.vala"
	_tmp2_ = _tmp1_;
#line 109 "../gxml/Node.vala"
	_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 109 "../gxml/Node.vala"
	_tmp4_ = _tmp3_;
#line 109 "../gxml/Node.vala"
	_tmp5_ = _tmp4_ == 0;
#line 109 "../gxml/Node.vala"
	_g_object_unref0 (_tmp2_);
#line 109 "../gxml/Node.vala"
	if (_tmp5_) {
#line 109 "../gxml/Node.vala"
		result = NULL;
#line 109 "../gxml/Node.vala"
		return result;
#line 541 "Node.c"
	}
#line 110 "../gxml/Node.vala"
	_tmp6_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 110 "../gxml/Node.vala"
	_tmp7_ = _tmp6_;
#line 110 "../gxml/Node.vala"
	_tmp8_ = _tmp7_;
#line 110 "../gxml/Node.vala"
	_tmp9_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 110 "../gxml/Node.vala"
	_tmp10_ = _tmp9_;
#line 110 "../gxml/Node.vala"
	_tmp11_ = _tmp10_;
#line 110 "../gxml/Node.vala"
	_tmp12_ = gee_collection_get_size ((GeeCollection*) _tmp11_);
#line 110 "../gxml/Node.vala"
	_tmp13_ = _tmp12_;
#line 110 "../gxml/Node.vala"
	_tmp14_ = gee_list_get ((GeeList*) _tmp8_, _tmp13_ - 1);
#line 110 "../gxml/Node.vala"
	_tmp15_ = (GXmlDomNode*) _tmp14_;
#line 110 "../gxml/Node.vala"
	_g_object_unref0 (_tmp11_);
#line 110 "../gxml/Node.vala"
	_g_object_unref0 (_tmp8_);
#line 110 "../gxml/Node.vala"
	result = _tmp15_;
#line 110 "../gxml/Node.vala"
	return result;
#line 571 "Node.c"
}

static GXmlDomNode*
gxml_node_real_get_previous_sibling (GXmlDomNode* base)
{
	GXmlDomNode* result;
	GXmlNode* self;
	GXmlDomNode* _tmp0_;
	GXmlDomNode* _tmp1_;
	GXmlDomNodeList* _tmp2_;
	GXmlDomNodeList* _tmp3_;
	GXmlDomNodeList* _tmp4_;
	gboolean _tmp5_;
	GXmlDomNode* _tmp6_;
	GXmlDomNodeList* _tmp7_;
	GXmlDomNodeList* _tmp8_;
	GXmlDomNodeList* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gboolean _tmp12_;
	gint pos = 0;
	GXmlDomNode* _tmp13_;
	GXmlDomNodeList* _tmp14_;
	GXmlDomNodeList* _tmp15_;
	GeeArrayList* _tmp16_;
	gint _tmp17_;
	gboolean _tmp18_ = FALSE;
#line 114 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 115 "../gxml/Node.vala"
	_tmp0_ = self->_parent;
#line 115 "../gxml/Node.vala"
	if (_tmp0_ == NULL) {
#line 115 "../gxml/Node.vala"
		result = NULL;
#line 115 "../gxml/Node.vala"
		return result;
#line 609 "Node.c"
	}
#line 116 "../gxml/Node.vala"
	_tmp1_ = self->_parent;
#line 116 "../gxml/Node.vala"
	_tmp2_ = gxml_dom_node_get_child_nodes (_tmp1_);
#line 116 "../gxml/Node.vala"
	_tmp3_ = _tmp2_;
#line 116 "../gxml/Node.vala"
	_tmp4_ = _tmp3_;
#line 116 "../gxml/Node.vala"
	_tmp5_ = _tmp4_ == NULL;
#line 116 "../gxml/Node.vala"
	_g_object_unref0 (_tmp4_);
#line 116 "../gxml/Node.vala"
	if (_tmp5_) {
#line 116 "../gxml/Node.vala"
		result = NULL;
#line 116 "../gxml/Node.vala"
		return result;
#line 629 "Node.c"
	}
#line 117 "../gxml/Node.vala"
	_tmp6_ = self->_parent;
#line 117 "../gxml/Node.vala"
	_tmp7_ = gxml_dom_node_get_child_nodes (_tmp6_);
#line 117 "../gxml/Node.vala"
	_tmp8_ = _tmp7_;
#line 117 "../gxml/Node.vala"
	_tmp9_ = _tmp8_;
#line 117 "../gxml/Node.vala"
	_tmp10_ = gxml_dom_node_list_get_length (_tmp9_);
#line 117 "../gxml/Node.vala"
	_tmp11_ = _tmp10_;
#line 117 "../gxml/Node.vala"
	_tmp12_ = _tmp11_ == 0;
#line 117 "../gxml/Node.vala"
	_g_object_unref0 (_tmp9_);
#line 117 "../gxml/Node.vala"
	if (_tmp12_) {
#line 117 "../gxml/Node.vala"
		result = NULL;
#line 117 "../gxml/Node.vala"
		return result;
#line 653 "Node.c"
	}
#line 118 "../gxml/Node.vala"
	_tmp13_ = self->_parent;
#line 118 "../gxml/Node.vala"
	_tmp14_ = gxml_dom_node_get_child_nodes (_tmp13_);
#line 118 "../gxml/Node.vala"
	_tmp15_ = _tmp14_;
#line 118 "../gxml/Node.vala"
	_tmp16_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ARRAY_LIST, GeeArrayList);
#line 118 "../gxml/Node.vala"
	_tmp17_ = gee_abstract_list_index_of ((GeeAbstractList*) _tmp16_, (GXmlDomNode*) self);
#line 118 "../gxml/Node.vala"
	_g_object_unref0 (_tmp16_);
#line 118 "../gxml/Node.vala"
	pos = _tmp17_;
#line 119 "../gxml/Node.vala"
	if (pos == 0) {
#line 119 "../gxml/Node.vala"
		result = NULL;
#line 119 "../gxml/Node.vala"
		return result;
#line 675 "Node.c"
	}
#line 120 "../gxml/Node.vala"
	if ((pos - 1) > 0) {
#line 679 "Node.c"
		GXmlDomNode* _tmp19_;
		GXmlDomNodeList* _tmp20_;
		GXmlDomNodeList* _tmp21_;
		GXmlDomNodeList* _tmp22_;
		gint _tmp23_;
		gint _tmp24_;
#line 120 "../gxml/Node.vala"
		_tmp19_ = self->_parent;
#line 120 "../gxml/Node.vala"
		_tmp20_ = gxml_dom_node_get_child_nodes (_tmp19_);
#line 120 "../gxml/Node.vala"
		_tmp21_ = _tmp20_;
#line 120 "../gxml/Node.vala"
		_tmp22_ = _tmp21_;
#line 120 "../gxml/Node.vala"
		_tmp23_ = gee_collection_get_size ((GeeCollection*) _tmp22_);
#line 120 "../gxml/Node.vala"
		_tmp24_ = _tmp23_;
#line 120 "../gxml/Node.vala"
		_tmp18_ = (pos - 1) < _tmp24_;
#line 120 "../gxml/Node.vala"
		_g_object_unref0 (_tmp22_);
#line 702 "Node.c"
	} else {
#line 120 "../gxml/Node.vala"
		_tmp18_ = FALSE;
#line 706 "Node.c"
	}
#line 120 "../gxml/Node.vala"
	if (_tmp18_) {
#line 710 "Node.c"
		GXmlDomNode* _tmp25_;
		GXmlDomNodeList* _tmp26_;
		GXmlDomNodeList* _tmp27_;
		GXmlDomNodeList* _tmp28_;
		gpointer _tmp29_;
		GXmlDomNode* _tmp30_;
#line 121 "../gxml/Node.vala"
		_tmp25_ = self->_parent;
#line 121 "../gxml/Node.vala"
		_tmp26_ = gxml_dom_node_get_child_nodes (_tmp25_);
#line 121 "../gxml/Node.vala"
		_tmp27_ = _tmp26_;
#line 121 "../gxml/Node.vala"
		_tmp28_ = _tmp27_;
#line 121 "../gxml/Node.vala"
		_tmp29_ = gee_list_get ((GeeList*) _tmp28_, pos - 1);
#line 121 "../gxml/Node.vala"
		_tmp30_ = (GXmlDomNode*) _tmp29_;
#line 121 "../gxml/Node.vala"
		_g_object_unref0 (_tmp28_);
#line 121 "../gxml/Node.vala"
		result = _tmp30_;
#line 121 "../gxml/Node.vala"
		return result;
#line 735 "Node.c"
	}
#line 122 "../gxml/Node.vala"
	result = NULL;
#line 122 "../gxml/Node.vala"
	return result;
#line 741 "Node.c"
}

static GXmlDomNode*
gxml_node_real_get_next_sibling (GXmlDomNode* base)
{
	GXmlDomNode* result;
	GXmlNode* self;
	GXmlDomNode* _tmp0_;
	GXmlDomNode* _tmp1_;
	GXmlDomNodeList* _tmp2_;
	GXmlDomNodeList* _tmp3_;
	GXmlDomNodeList* _tmp4_;
	gboolean _tmp5_;
	GXmlDomNode* _tmp6_;
	GXmlDomNodeList* _tmp7_;
	GXmlDomNodeList* _tmp8_;
	GXmlDomNodeList* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gboolean _tmp12_;
	gint pos = 0;
	GXmlDomNode* _tmp13_;
	GXmlDomNodeList* _tmp14_;
	GXmlDomNodeList* _tmp15_;
	GeeArrayList* _tmp16_;
	gint _tmp17_;
	gboolean _tmp18_ = FALSE;
#line 126 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 127 "../gxml/Node.vala"
	_tmp0_ = self->_parent;
#line 127 "../gxml/Node.vala"
	if (_tmp0_ == NULL) {
#line 127 "../gxml/Node.vala"
		result = NULL;
#line 127 "../gxml/Node.vala"
		return result;
#line 779 "Node.c"
	}
#line 128 "../gxml/Node.vala"
	_tmp1_ = self->_parent;
#line 128 "../gxml/Node.vala"
	_tmp2_ = gxml_dom_node_get_child_nodes (_tmp1_);
#line 128 "../gxml/Node.vala"
	_tmp3_ = _tmp2_;
#line 128 "../gxml/Node.vala"
	_tmp4_ = _tmp3_;
#line 128 "../gxml/Node.vala"
	_tmp5_ = _tmp4_ == NULL;
#line 128 "../gxml/Node.vala"
	_g_object_unref0 (_tmp4_);
#line 128 "../gxml/Node.vala"
	if (_tmp5_) {
#line 128 "../gxml/Node.vala"
		result = NULL;
#line 128 "../gxml/Node.vala"
		return result;
#line 799 "Node.c"
	}
#line 129 "../gxml/Node.vala"
	_tmp6_ = self->_parent;
#line 129 "../gxml/Node.vala"
	_tmp7_ = gxml_dom_node_get_child_nodes (_tmp6_);
#line 129 "../gxml/Node.vala"
	_tmp8_ = _tmp7_;
#line 129 "../gxml/Node.vala"
	_tmp9_ = _tmp8_;
#line 129 "../gxml/Node.vala"
	_tmp10_ = gxml_dom_node_list_get_length (_tmp9_);
#line 129 "../gxml/Node.vala"
	_tmp11_ = _tmp10_;
#line 129 "../gxml/Node.vala"
	_tmp12_ = _tmp11_ == 0;
#line 129 "../gxml/Node.vala"
	_g_object_unref0 (_tmp9_);
#line 129 "../gxml/Node.vala"
	if (_tmp12_) {
#line 129 "../gxml/Node.vala"
		result = NULL;
#line 129 "../gxml/Node.vala"
		return result;
#line 823 "Node.c"
	}
#line 130 "../gxml/Node.vala"
	_tmp13_ = self->_parent;
#line 130 "../gxml/Node.vala"
	_tmp14_ = gxml_dom_node_get_child_nodes (_tmp13_);
#line 130 "../gxml/Node.vala"
	_tmp15_ = _tmp14_;
#line 130 "../gxml/Node.vala"
	_tmp16_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ARRAY_LIST, GeeArrayList);
#line 130 "../gxml/Node.vala"
	_tmp17_ = gee_abstract_list_index_of ((GeeAbstractList*) _tmp16_, (GXmlDomNode*) self);
#line 130 "../gxml/Node.vala"
	_g_object_unref0 (_tmp16_);
#line 130 "../gxml/Node.vala"
	pos = _tmp17_;
#line 131 "../gxml/Node.vala"
	if (pos == 0) {
#line 131 "../gxml/Node.vala"
		result = NULL;
#line 131 "../gxml/Node.vala"
		return result;
#line 845 "Node.c"
	}
#line 132 "../gxml/Node.vala"
	if ((pos + 1) > 0) {
#line 849 "Node.c"
		GXmlDomNode* _tmp19_;
		GXmlDomNodeList* _tmp20_;
		GXmlDomNodeList* _tmp21_;
		GXmlDomNodeList* _tmp22_;
		gint _tmp23_;
		gint _tmp24_;
#line 132 "../gxml/Node.vala"
		_tmp19_ = self->_parent;
#line 132 "../gxml/Node.vala"
		_tmp20_ = gxml_dom_node_get_child_nodes (_tmp19_);
#line 132 "../gxml/Node.vala"
		_tmp21_ = _tmp20_;
#line 132 "../gxml/Node.vala"
		_tmp22_ = _tmp21_;
#line 132 "../gxml/Node.vala"
		_tmp23_ = gee_collection_get_size ((GeeCollection*) _tmp22_);
#line 132 "../gxml/Node.vala"
		_tmp24_ = _tmp23_;
#line 132 "../gxml/Node.vala"
		_tmp18_ = (pos + 1) < _tmp24_;
#line 132 "../gxml/Node.vala"
		_g_object_unref0 (_tmp22_);
#line 872 "Node.c"
	} else {
#line 132 "../gxml/Node.vala"
		_tmp18_ = FALSE;
#line 876 "Node.c"
	}
#line 132 "../gxml/Node.vala"
	if (_tmp18_) {
#line 880 "Node.c"
		GXmlDomNode* _tmp25_;
		GXmlDomNodeList* _tmp26_;
		GXmlDomNodeList* _tmp27_;
		GXmlDomNodeList* _tmp28_;
		gpointer _tmp29_;
		GXmlDomNode* _tmp30_;
#line 133 "../gxml/Node.vala"
		_tmp25_ = self->_parent;
#line 133 "../gxml/Node.vala"
		_tmp26_ = gxml_dom_node_get_child_nodes (_tmp25_);
#line 133 "../gxml/Node.vala"
		_tmp27_ = _tmp26_;
#line 133 "../gxml/Node.vala"
		_tmp28_ = _tmp27_;
#line 133 "../gxml/Node.vala"
		_tmp29_ = gee_list_get ((GeeList*) _tmp28_, pos + 1);
#line 133 "../gxml/Node.vala"
		_tmp30_ = (GXmlDomNode*) _tmp29_;
#line 133 "../gxml/Node.vala"
		_g_object_unref0 (_tmp28_);
#line 133 "../gxml/Node.vala"
		result = _tmp30_;
#line 133 "../gxml/Node.vala"
		return result;
#line 905 "Node.c"
	}
#line 134 "../gxml/Node.vala"
	result = NULL;
#line 134 "../gxml/Node.vala"
	return result;
#line 911 "Node.c"
}

static gchar*
gxml_node_real_get_node_value (GXmlDomNode* base)
{
	gchar* result;
	GXmlNode* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 138 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 138 "../gxml/Node.vala"
	_tmp0_ = self->_node_value;
#line 138 "../gxml/Node.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 138 "../gxml/Node.vala"
	result = _tmp1_;
#line 138 "../gxml/Node.vala"
	return result;
#line 931 "Node.c"
}

static void
gxml_node_real_set_node_value (GXmlDomNode* base,
                               const gchar* value)
{
	GXmlNode* self;
	gchar* _tmp0_;
#line 138 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 138 "../gxml/Node.vala"
	_tmp0_ = g_strdup (value);
#line 138 "../gxml/Node.vala"
	_g_free0 (self->_node_value);
#line 138 "../gxml/Node.vala"
	self->_node_value = _tmp0_;
#line 138 "../gxml/Node.vala"
	g_object_notify_by_pspec ((GObject *) self, gxml_node_properties[GXML_NODE_NODE_VALUE_PROPERTY]);
#line 950 "Node.c"
}

static gchar*
gxml_node_real_get_text_content (GXmlDomNode* base)
{
	gchar* result;
	GXmlNode* self;
	gchar* t = NULL;
#line 141 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 142 "../gxml/Node.vala"
	t = NULL;
#line 963 "Node.c"
	{
		GXmlDomNodeList* _n_list = NULL;
		GXmlDomNodeList* _tmp0_;
		GXmlDomNodeList* _tmp1_;
		gint _n_size = 0;
		GXmlDomNodeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _n_index = 0;
#line 143 "../gxml/Node.vala"
		_tmp0_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 143 "../gxml/Node.vala"
		_tmp1_ = _tmp0_;
#line 143 "../gxml/Node.vala"
		_n_list = _tmp1_;
#line 143 "../gxml/Node.vala"
		_tmp2_ = _n_list;
#line 143 "../gxml/Node.vala"
		_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 143 "../gxml/Node.vala"
		_tmp4_ = _tmp3_;
#line 143 "../gxml/Node.vala"
		_n_size = _tmp4_;
#line 143 "../gxml/Node.vala"
		_n_index = -1;
#line 143 "../gxml/Node.vala"
		while (TRUE) {
#line 991 "Node.c"
			gint _tmp5_;
			gint _tmp6_;
			GXmlDomNode* n = NULL;
			GXmlDomNodeList* _tmp7_;
			gpointer _tmp8_;
			GXmlDomNode* _tmp9_;
#line 143 "../gxml/Node.vala"
			_n_index = _n_index + 1;
#line 143 "../gxml/Node.vala"
			_tmp5_ = _n_index;
#line 143 "../gxml/Node.vala"
			_tmp6_ = _n_size;
#line 143 "../gxml/Node.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 143 "../gxml/Node.vala"
				break;
#line 1008 "Node.c"
			}
#line 143 "../gxml/Node.vala"
			_tmp7_ = _n_list;
#line 143 "../gxml/Node.vala"
			_tmp8_ = gee_list_get ((GeeList*) _tmp7_, _n_index);
#line 143 "../gxml/Node.vala"
			n = (GXmlDomNode*) _tmp8_;
#line 144 "../gxml/Node.vala"
			_tmp9_ = n;
#line 144 "../gxml/Node.vala"
			if (GXML_IS_DOM_TEXT (_tmp9_)) {
#line 1020 "Node.c"
				const gchar* _tmp10_;
#line 145 "../gxml/Node.vala"
				_tmp10_ = t;
#line 145 "../gxml/Node.vala"
				if (_tmp10_ == NULL) {
#line 1026 "Node.c"
					GXmlDomNode* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
#line 145 "../gxml/Node.vala"
					_tmp11_ = n;
#line 145 "../gxml/Node.vala"
					_tmp12_ = gxml_dom_node_get_node_value (_tmp11_);
#line 145 "../gxml/Node.vala"
					_tmp13_ = _tmp12_;
#line 145 "../gxml/Node.vala"
					_g_free0 (t);
#line 145 "../gxml/Node.vala"
					t = _tmp13_;
#line 1040 "Node.c"
				} else {
					const gchar* _tmp14_;
					GXmlDomNode* _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
#line 146 "../gxml/Node.vala"
					_tmp14_ = t;
#line 146 "../gxml/Node.vala"
					_tmp15_ = n;
#line 146 "../gxml/Node.vala"
					_tmp16_ = gxml_dom_node_get_node_value (_tmp15_);
#line 146 "../gxml/Node.vala"
					_tmp17_ = _tmp16_;
#line 146 "../gxml/Node.vala"
					_tmp18_ = _tmp17_;
#line 146 "../gxml/Node.vala"
					_tmp19_ = g_strconcat (_tmp14_, _tmp18_, NULL);
#line 146 "../gxml/Node.vala"
					_g_free0 (t);
#line 146 "../gxml/Node.vala"
					t = _tmp19_;
#line 146 "../gxml/Node.vala"
					_g_free0 (_tmp18_);
#line 1066 "Node.c"
				}
			}
#line 143 "../gxml/Node.vala"
			_g_object_unref0 (n);
#line 1071 "Node.c"
		}
#line 143 "../gxml/Node.vala"
		_g_object_unref0 (_n_list);
#line 1075 "Node.c"
	}
#line 149 "../gxml/Node.vala"
	result = t;
#line 149 "../gxml/Node.vala"
	return result;
#line 1081 "Node.c"
}

static void
gxml_node_real_set_text_content (GXmlDomNode* base,
                                 const gchar* value)
{
	GXmlNode* self;
	GError* _inner_error0_ = NULL;
#line 151 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 1092 "Node.c"
	{
		GXmlDomText* t = NULL;
		GXmlDomDocument* _tmp0_;
		GXmlDomText* _tmp1_;
		GXmlDomNodeList* _tmp2_;
		GXmlDomNodeList* _tmp3_;
		GXmlDomNodeList* _tmp4_;
#line 153 "../gxml/Node.vala"
		_tmp0_ = self->_document;
#line 153 "../gxml/Node.vala"
		_tmp1_ = gxml_dom_document_create_text_node (_tmp0_, value, &_inner_error0_);
#line 153 "../gxml/Node.vala"
		t = _tmp1_;
#line 153 "../gxml/Node.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1108 "Node.c"
			goto __catch0_g_error;
		}
#line 154 "../gxml/Node.vala"
		_tmp2_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 154 "../gxml/Node.vala"
		_tmp3_ = _tmp2_;
#line 154 "../gxml/Node.vala"
		_tmp4_ = _tmp3_;
#line 154 "../gxml/Node.vala"
		gee_collection_add ((GeeCollection*) _tmp4_, (GXmlDomNode*) t);
#line 154 "../gxml/Node.vala"
		_g_object_unref0 (_tmp4_);
#line 152 "../gxml/Node.vala"
		_g_object_unref0 (t);
#line 1123 "Node.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 152 "../gxml/Node.vala"
		g_clear_error (&_inner_error0_);
#line 156 "../gxml/Node.vala"
		g_warning ("Node.vala:156: %s", _ ("Text content in element can't be created"));
#line 1132 "Node.c"
	}
	__finally0:
#line 152 "../gxml/Node.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 152 "../gxml/Node.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 152 "../gxml/Node.vala"
		g_clear_error (&_inner_error0_);
#line 152 "../gxml/Node.vala"
		return;
#line 1143 "Node.c"
	}
#line 151 "../gxml/Node.vala"
	g_object_notify_by_pspec ((GObject *) self, gxml_node_properties[GXML_NODE_TEXT_CONTENT_PROPERTY]);
#line 1147 "Node.c"
}

static gboolean
gxml_node_real_has_child_nodes (GXmlDomNode* base)
{
	GXmlNode * self;
	GXmlNodeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result = FALSE;
#line 171 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 171 "../gxml/Node.vala"
	_tmp0_ = self->_child_nodes;
#line 171 "../gxml/Node.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 171 "../gxml/Node.vala"
	_tmp2_ = _tmp1_;
#line 171 "../gxml/Node.vala"
	result = _tmp2_ > 0;
#line 171 "../gxml/Node.vala"
	return result;
#line 1170 "Node.c"
}

static void
gxml_node_real_normalize (GXmlDomNode* base)
{
	GXmlNode * self;
#line 172 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 1179 "Node.c"
	{
		gint i = 0;
#line 173 "../gxml/Node.vala"
		i = 0;
#line 1184 "Node.c"
		{
			gboolean _tmp0_ = FALSE;
#line 173 "../gxml/Node.vala"
			_tmp0_ = TRUE;
#line 173 "../gxml/Node.vala"
			while (TRUE) {
#line 1191 "Node.c"
				GXmlDomNodeList* _tmp2_;
				GXmlDomNodeList* _tmp3_;
				GXmlDomNodeList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gboolean _tmp7_;
				GXmlDomNode* n = NULL;
				GXmlDomNodeList* _tmp8_;
				GXmlDomNodeList* _tmp9_;
				GXmlDomNodeList* _tmp10_;
				gpointer _tmp11_;
				GXmlDomNode* _tmp12_;
				GXmlDomNode* _tmp13_;
#line 173 "../gxml/Node.vala"
				if (!_tmp0_) {
#line 1207 "Node.c"
					gint _tmp1_;
#line 173 "../gxml/Node.vala"
					_tmp1_ = i;
#line 173 "../gxml/Node.vala"
					i = _tmp1_ + 1;
#line 1213 "Node.c"
				}
#line 173 "../gxml/Node.vala"
				_tmp0_ = FALSE;
#line 173 "../gxml/Node.vala"
				_tmp2_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 173 "../gxml/Node.vala"
				_tmp3_ = _tmp2_;
#line 173 "../gxml/Node.vala"
				_tmp4_ = _tmp3_;
#line 173 "../gxml/Node.vala"
				_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
#line 173 "../gxml/Node.vala"
				_tmp6_ = _tmp5_;
#line 173 "../gxml/Node.vala"
				_tmp7_ = !(i < _tmp6_);
#line 173 "../gxml/Node.vala"
				_g_object_unref0 (_tmp4_);
#line 173 "../gxml/Node.vala"
				if (_tmp7_) {
#line 173 "../gxml/Node.vala"
					break;
#line 1235 "Node.c"
				}
#line 174 "../gxml/Node.vala"
				_tmp8_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 174 "../gxml/Node.vala"
				_tmp9_ = _tmp8_;
#line 174 "../gxml/Node.vala"
				_tmp10_ = _tmp9_;
#line 174 "../gxml/Node.vala"
				_tmp11_ = gee_list_get ((GeeList*) _tmp10_, i);
#line 174 "../gxml/Node.vala"
				_tmp12_ = (GXmlDomNode*) _tmp11_;
#line 174 "../gxml/Node.vala"
				_g_object_unref0 (_tmp10_);
#line 174 "../gxml/Node.vala"
				n = _tmp12_;
#line 175 "../gxml/Node.vala"
				_tmp13_ = n;
#line 175 "../gxml/Node.vala"
				if (GXML_IS_DOM_TEXT (_tmp13_)) {
#line 1255 "Node.c"
					GXmlDomNodeList* _tmp14_;
					GXmlDomNodeList* _tmp15_;
					GXmlDomNodeList* _tmp16_;
					gpointer _tmp17_;
					GXmlDomNode* _tmp18_;
#line 176 "../gxml/Node.vala"
					_tmp14_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 176 "../gxml/Node.vala"
					_tmp15_ = _tmp14_;
#line 176 "../gxml/Node.vala"
					_tmp16_ = _tmp15_;
#line 176 "../gxml/Node.vala"
					_tmp17_ = gee_list_remove_at ((GeeList*) _tmp16_, i);
#line 176 "../gxml/Node.vala"
					_tmp18_ = (GXmlDomNode*) _tmp17_;
#line 176 "../gxml/Node.vala"
					_g_object_unref0 (_tmp18_);
#line 176 "../gxml/Node.vala"
					_g_object_unref0 (_tmp16_);
#line 1275 "Node.c"
				}
#line 173 "../gxml/Node.vala"
				_g_object_unref0 (n);
#line 1279 "Node.c"
			}
		}
	}
}

static gboolean
gxml_node_real_is_equal_node (GXmlDomNode* base,
                              GXmlDomNode* node)
{
	GXmlNode * self;
	gboolean result = FALSE;
#line 181 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 182 "../gxml/Node.vala"
	if (node == NULL) {
#line 182 "../gxml/Node.vala"
		result = FALSE;
#line 182 "../gxml/Node.vala"
		return result;
#line 1299 "Node.c"
	}
#line 183 "../gxml/Node.vala"
	if (GXML_IS_DOM_CHARACTER_DATA (self)) {
#line 1303 "Node.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gboolean _tmp6_;
#line 184 "../gxml/Node.vala"
		_tmp0_ = gxml_dom_character_data_get_data ((GXmlDomCharacterData*) G_TYPE_CHECK_INSTANCE_CAST (self, GXML_TYPE_DOM_COMMENT, GXmlDomComment));
#line 184 "../gxml/Node.vala"
		_tmp1_ = _tmp0_;
#line 184 "../gxml/Node.vala"
		_tmp2_ = _tmp1_;
#line 184 "../gxml/Node.vala"
		_tmp3_ = gxml_dom_character_data_get_data ((GXmlDomCharacterData*) G_TYPE_CHECK_INSTANCE_CAST (node, GXML_TYPE_DOM_COMMENT, GXmlDomComment));
#line 184 "../gxml/Node.vala"
		_tmp4_ = _tmp3_;
#line 184 "../gxml/Node.vala"
		_tmp5_ = _tmp4_;
#line 184 "../gxml/Node.vala"
		_tmp6_ = g_strcmp0 (_tmp2_, _tmp5_) == 0;
#line 184 "../gxml/Node.vala"
		_g_free0 (_tmp5_);
#line 184 "../gxml/Node.vala"
		_g_free0 (_tmp2_);
#line 184 "../gxml/Node.vala"
		result = _tmp6_;
#line 184 "../gxml/Node.vala"
		return result;
#line 1333 "Node.c"
	}
#line 185 "../gxml/Node.vala"
	result = FALSE;
#line 185 "../gxml/Node.vala"
	return result;
#line 1339 "Node.c"
}

static GXmlDomNodeDocumentPosition
gxml_node_real_compare_document_position (GXmlDomNode* base,
                                          GXmlDomNode* other)
{
	GXmlNode * self;
	gboolean _tmp0_ = FALSE;
	GXmlDomDocument* _tmp1_;
	GXmlDomDocument* _tmp2_;
	GXmlDomDocument* _tmp3_;
	GXmlDomDocument* _tmp4_;
	GXmlDomNode* _tmp8_;
	GXmlDomNode* _tmp9_;
	GXmlDomNode* _tmp10_;
	gboolean _tmp11_;
	GXmlDomNodeDocumentPosition result = 0U;
#line 188 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 188 "../gxml/Node.vala"
	g_return_val_if_fail (other != NULL, 0U);
#line 189 "../gxml/Node.vala"
	if ((GXML_IS_DOM_NODE (self) ? ((GXmlDomNode*) self) : NULL) == other) {
#line 189 "../gxml/Node.vala"
		result = GXML_DOM_NODE_DOCUMENT_POSITION_NONE;
#line 189 "../gxml/Node.vala"
		return result;
#line 1367 "Node.c"
	}
#line 190 "../gxml/Node.vala"
	_tmp1_ = gxml_dom_node_get_owner_document ((GXmlDomNode*) self);
#line 190 "../gxml/Node.vala"
	_tmp2_ = _tmp1_;
#line 190 "../gxml/Node.vala"
	_tmp3_ = gxml_dom_node_get_owner_document (other);
#line 190 "../gxml/Node.vala"
	_tmp4_ = _tmp3_;
#line 190 "../gxml/Node.vala"
	if (_tmp2_ != _tmp4_) {
#line 190 "../gxml/Node.vala"
		_tmp0_ = TRUE;
#line 1381 "Node.c"
	} else {
		GXmlDomNode* _tmp5_;
		GXmlDomNode* _tmp6_;
		GXmlDomNode* _tmp7_;
#line 190 "../gxml/Node.vala"
		_tmp5_ = gxml_dom_node_get_parent_node (other);
#line 190 "../gxml/Node.vala"
		_tmp6_ = _tmp5_;
#line 190 "../gxml/Node.vala"
		_tmp7_ = _tmp6_;
#line 190 "../gxml/Node.vala"
		_tmp0_ = _tmp7_ == NULL;
#line 190 "../gxml/Node.vala"
		_g_object_unref0 (_tmp7_);
#line 1396 "Node.c"
	}
#line 190 "../gxml/Node.vala"
	if (_tmp0_) {
#line 1400 "Node.c"
		GXmlDomNodeDocumentPosition p = 0U;
#line 191 "../gxml/Node.vala"
		p = GXML_DOM_NODE_DOCUMENT_POSITION_DISCONNECTED & GXML_DOM_NODE_DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC;
#line 192 "../gxml/Node.vala"
		if ((&self) > (&other)) {
#line 193 "../gxml/Node.vala"
			p = p & GXML_DOM_NODE_DOCUMENT_POSITION_PRECEDING;
#line 1408 "Node.c"
		} else {
#line 195 "../gxml/Node.vala"
			p = p & GXML_DOM_NODE_DOCUMENT_POSITION_FOLLOWING;
#line 1412 "Node.c"
		}
#line 196 "../gxml/Node.vala"
		result = p;
#line 196 "../gxml/Node.vala"
		return result;
#line 1418 "Node.c"
	}
#line 198 "../gxml/Node.vala"
	if (gxml_dom_node_contains (G_TYPE_CHECK_INSTANCE_CAST (self, GXML_TYPE_DOM_NODE, GXmlDomNode), other)) {
#line 199 "../gxml/Node.vala"
		result = GXML_DOM_NODE_DOCUMENT_POSITION_CONTAINED_BY & GXML_DOM_NODE_DOCUMENT_POSITION_FOLLOWING;
#line 199 "../gxml/Node.vala"
		return result;
#line 1426 "Node.c"
	}
#line 200 "../gxml/Node.vala"
	_tmp8_ = gxml_dom_node_get_parent_node ((GXmlDomNode*) self);
#line 200 "../gxml/Node.vala"
	_tmp9_ = _tmp8_;
#line 200 "../gxml/Node.vala"
	_tmp10_ = _tmp9_;
#line 200 "../gxml/Node.vala"
	_tmp11_ = gxml_dom_node_contains (_tmp10_, other);
#line 200 "../gxml/Node.vala"
	_g_object_unref0 (_tmp10_);
#line 200 "../gxml/Node.vala"
	if (_tmp11_) {
#line 1440 "Node.c"
		GXmlDomNode* par = NULL;
		GXmlDomNode* _tmp12_;
		GXmlDomNode* _tmp13_;
		GXmlDomNode* _tmp14_;
		GXmlDomNodeList* _tmp15_;
		GXmlDomNodeList* _tmp16_;
		GXmlDomNodeList* _tmp17_;
		GXmlDomNode* _tmp18_;
		GXmlDomNodeList* _tmp19_;
		GXmlDomNodeList* _tmp20_;
		GXmlDomNodeList* _tmp21_;
		gboolean _tmp22_;
#line 201 "../gxml/Node.vala"
		_tmp12_ = gxml_dom_node_get_parent_node ((GXmlDomNode*) self);
#line 201 "../gxml/Node.vala"
		_tmp13_ = _tmp12_;
#line 201 "../gxml/Node.vala"
		par = _tmp13_;
#line 202 "../gxml/Node.vala"
		_tmp14_ = par;
#line 202 "../gxml/Node.vala"
		_tmp15_ = gxml_dom_node_get_child_nodes (_tmp14_);
#line 202 "../gxml/Node.vala"
		_tmp16_ = _tmp15_;
#line 202 "../gxml/Node.vala"
		_tmp17_ = _tmp16_;
#line 202 "../gxml/Node.vala"
		_tmp18_ = par;
#line 202 "../gxml/Node.vala"
		_tmp19_ = gxml_dom_node_get_child_nodes (_tmp18_);
#line 202 "../gxml/Node.vala"
		_tmp20_ = _tmp19_;
#line 202 "../gxml/Node.vala"
		_tmp21_ = _tmp20_;
#line 202 "../gxml/Node.vala"
		_tmp22_ = gee_list_index_of ((GeeList*) _tmp17_, (GXmlDomNode*) self) > gee_list_index_of ((GeeList*) _tmp21_, other);
#line 202 "../gxml/Node.vala"
		_g_object_unref0 (_tmp21_);
#line 202 "../gxml/Node.vala"
		_g_object_unref0 (_tmp17_);
#line 202 "../gxml/Node.vala"
		if (_tmp22_) {
#line 203 "../gxml/Node.vala"
			result = GXML_DOM_NODE_DOCUMENT_POSITION_PRECEDING;
#line 203 "../gxml/Node.vala"
			_g_object_unref0 (par);
#line 203 "../gxml/Node.vala"
			return result;
#line 1489 "Node.c"
		} else {
#line 205 "../gxml/Node.vala"
			result = GXML_DOM_NODE_DOCUMENT_POSITION_FOLLOWING;
#line 205 "../gxml/Node.vala"
			_g_object_unref0 (par);
#line 205 "../gxml/Node.vala"
			return result;
#line 1497 "Node.c"
		}
#line 200 "../gxml/Node.vala"
		_g_object_unref0 (par);
#line 1501 "Node.c"
	}
#line 207 "../gxml/Node.vala"
	if (gxml_dom_node_contains (other, (GXmlDomNode*) self)) {
#line 208 "../gxml/Node.vala"
		result = GXML_DOM_NODE_DOCUMENT_POSITION_CONTAINS & GXML_DOM_NODE_DOCUMENT_POSITION_PRECEDING;
#line 208 "../gxml/Node.vala"
		return result;
#line 1509 "Node.c"
	}
#line 209 "../gxml/Node.vala"
	g_warning ("Node.vala:209: %s", _ ("Can't find node position"));
#line 210 "../gxml/Node.vala"
	result = GXML_DOM_NODE_DOCUMENT_POSITION_NONE;
#line 210 "../gxml/Node.vala"
	return result;
#line 1517 "Node.c"
}

static gboolean
gxml_node_real_contains (GXmlDomNode* base,
                         GXmlDomNode* other)
{
	GXmlNode * self;
	GXmlDomNodeList* _tmp0_;
	GXmlDomNodeList* _tmp1_;
	GXmlDomNodeList* _tmp2_;
	gboolean _tmp3_;
	gboolean result = FALSE;
#line 212 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 213 "../gxml/Node.vala"
	if (other == NULL) {
#line 213 "../gxml/Node.vala"
		result = FALSE;
#line 213 "../gxml/Node.vala"
		return result;
#line 1538 "Node.c"
	}
#line 214 "../gxml/Node.vala"
	_tmp0_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 214 "../gxml/Node.vala"
	_tmp1_ = _tmp0_;
#line 214 "../gxml/Node.vala"
	_tmp2_ = _tmp1_;
#line 214 "../gxml/Node.vala"
	_tmp3_ = gee_collection_contains ((GeeCollection*) _tmp2_, other);
#line 214 "../gxml/Node.vala"
	_g_object_unref0 (_tmp2_);
#line 214 "../gxml/Node.vala"
	result = _tmp3_;
#line 214 "../gxml/Node.vala"
	return result;
#line 1554 "Node.c"
}

static gchar*
gxml_node_real_lookup_prefix (GXmlDomNode* base,
                              const gchar* nspace)
{
	GXmlNode * self;
	gboolean _tmp0_ = FALSE;
	gchar* result = NULL;
#line 217 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 218 "../gxml/Node.vala"
	if (GXML_IS_DOM_DOCUMENT_TYPE (self)) {
#line 218 "../gxml/Node.vala"
		_tmp0_ = TRUE;
#line 1570 "Node.c"
	} else {
#line 219 "../gxml/Node.vala"
		_tmp0_ = GXML_IS_DOM_DOCUMENT_FRAGMENT (self);
#line 1574 "Node.c"
	}
#line 218 "../gxml/Node.vala"
	if (_tmp0_) {
#line 219 "../gxml/Node.vala"
		result = NULL;
#line 219 "../gxml/Node.vala"
		return result;
#line 1582 "Node.c"
	}
#line 220 "../gxml/Node.vala"
	if (GXML_IS_DOM_ELEMENT (self)) {
#line 1586 "Node.c"
		gchar* _tmp1_;
#line 221 "../gxml/Node.vala"
		_tmp1_ = gxml_element_lookup_prefix (G_TYPE_CHECK_INSTANCE_CAST (self, GXML_TYPE_ELEMENT, GXmlElement), nspace);
#line 221 "../gxml/Node.vala"
		result = _tmp1_;
#line 221 "../gxml/Node.vala"
		return result;
#line 1594 "Node.c"
	}
#line 223 "../gxml/Node.vala"
	if (GXML_IS_ATTR (self)) {
#line 1598 "Node.c"
		GXmlDomNode* _tmp2_;
		GXmlDomNode* _tmp3_;
		GXmlDomNode* _tmp4_;
		gboolean _tmp5_;
		GXmlDomNode* _tmp6_;
		GXmlDomNode* _tmp7_;
		GXmlDomNode* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 224 "../gxml/Node.vala"
		_tmp2_ = gxml_dom_node_get_parent_node ((GXmlDomNode*) self);
#line 224 "../gxml/Node.vala"
		_tmp3_ = _tmp2_;
#line 224 "../gxml/Node.vala"
		_tmp4_ = _tmp3_;
#line 224 "../gxml/Node.vala"
		_tmp5_ = _tmp4_ == NULL;
#line 224 "../gxml/Node.vala"
		_g_object_unref0 (_tmp4_);
#line 224 "../gxml/Node.vala"
		if (_tmp5_) {
#line 224 "../gxml/Node.vala"
			result = NULL;
#line 224 "../gxml/Node.vala"
			return result;
#line 1624 "Node.c"
		}
#line 225 "../gxml/Node.vala"
		_tmp6_ = gxml_dom_node_get_parent_node ((GXmlDomNode*) self);
#line 225 "../gxml/Node.vala"
		_tmp7_ = _tmp6_;
#line 225 "../gxml/Node.vala"
		_tmp8_ = _tmp7_;
#line 225 "../gxml/Node.vala"
		_tmp9_ = gxml_dom_node_lookup_prefix (_tmp8_, nspace);
#line 225 "../gxml/Node.vala"
		_tmp10_ = _tmp9_;
#line 225 "../gxml/Node.vala"
		_g_object_unref0 (_tmp8_);
#line 225 "../gxml/Node.vala"
		result = _tmp10_;
#line 225 "../gxml/Node.vala"
		return result;
#line 1642 "Node.c"
	}
#line 227 "../gxml/Node.vala"
	result = NULL;
#line 227 "../gxml/Node.vala"
	return result;
#line 1648 "Node.c"
}

static gchar*
gxml_node_real_lookup_namespace_uri (GXmlDomNode* base,
                                     const gchar* prefix)
{
	GXmlNode * self;
	gboolean _tmp0_ = FALSE;
	gchar* result = NULL;
#line 229 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 230 "../gxml/Node.vala"
	if (GXML_IS_DOM_DOCUMENT_TYPE (self)) {
#line 230 "../gxml/Node.vala"
		_tmp0_ = TRUE;
#line 1664 "Node.c"
	} else {
#line 231 "../gxml/Node.vala"
		_tmp0_ = GXML_IS_DOM_DOCUMENT_FRAGMENT (self);
#line 1668 "Node.c"
	}
#line 230 "../gxml/Node.vala"
	if (_tmp0_) {
#line 231 "../gxml/Node.vala"
		result = NULL;
#line 231 "../gxml/Node.vala"
		return result;
#line 1676 "Node.c"
	}
#line 232 "../gxml/Node.vala"
	if (GXML_IS_DOM_ELEMENT (self)) {
#line 1680 "Node.c"
		gchar* _tmp1_;
#line 233 "../gxml/Node.vala"
		_tmp1_ = gxml_element_lookup_namespace_uri (G_TYPE_CHECK_INSTANCE_CAST (self, GXML_TYPE_ELEMENT, GXmlElement), prefix);
#line 233 "../gxml/Node.vala"
		result = _tmp1_;
#line 233 "../gxml/Node.vala"
		return result;
#line 1688 "Node.c"
	}
#line 235 "../gxml/Node.vala"
	if (GXML_IS_ATTR (self)) {
#line 1692 "Node.c"
		GXmlDomNode* _tmp2_;
		GXmlDomNode* _tmp3_;
		GXmlDomNode* _tmp4_;
		gboolean _tmp5_;
		GXmlDomNode* _tmp6_;
		GXmlDomNode* _tmp7_;
		GXmlDomNode* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 236 "../gxml/Node.vala"
		_tmp2_ = gxml_dom_node_get_parent_node ((GXmlDomNode*) self);
#line 236 "../gxml/Node.vala"
		_tmp3_ = _tmp2_;
#line 236 "../gxml/Node.vala"
		_tmp4_ = _tmp3_;
#line 236 "../gxml/Node.vala"
		_tmp5_ = _tmp4_ == NULL;
#line 236 "../gxml/Node.vala"
		_g_object_unref0 (_tmp4_);
#line 236 "../gxml/Node.vala"
		if (_tmp5_) {
#line 236 "../gxml/Node.vala"
			result = NULL;
#line 236 "../gxml/Node.vala"
			return result;
#line 1718 "Node.c"
		}
#line 237 "../gxml/Node.vala"
		_tmp6_ = gxml_dom_node_get_parent_node ((GXmlDomNode*) self);
#line 237 "../gxml/Node.vala"
		_tmp7_ = _tmp6_;
#line 237 "../gxml/Node.vala"
		_tmp8_ = _tmp7_;
#line 237 "../gxml/Node.vala"
		_tmp9_ = gxml_dom_node_lookup_namespace_uri (_tmp8_, prefix);
#line 237 "../gxml/Node.vala"
		_tmp10_ = _tmp9_;
#line 237 "../gxml/Node.vala"
		_g_object_unref0 (_tmp8_);
#line 237 "../gxml/Node.vala"
		result = _tmp10_;
#line 237 "../gxml/Node.vala"
		return result;
#line 1736 "Node.c"
	}
#line 239 "../gxml/Node.vala"
	result = NULL;
#line 239 "../gxml/Node.vala"
	return result;
#line 1742 "Node.c"
}

static gboolean
gxml_node_real_is_default_namespace (GXmlDomNode* base,
                                     const gchar* nspace)
{
	GXmlNode * self;
	gchar* ns = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean result = FALSE;
#line 241 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 242 "../gxml/Node.vala"
	_tmp0_ = gxml_dom_node_lookup_namespace_uri ((GXmlDomNode*) self, NULL);
#line 242 "../gxml/Node.vala"
	ns = _tmp0_;
#line 243 "../gxml/Node.vala"
	_tmp1_ = ns;
#line 243 "../gxml/Node.vala"
	if (g_strcmp0 (_tmp1_, nspace) == 0) {
#line 243 "../gxml/Node.vala"
		result = TRUE;
#line 243 "../gxml/Node.vala"
		_g_free0 (ns);
#line 243 "../gxml/Node.vala"
		return result;
#line 1770 "Node.c"
	}
#line 244 "../gxml/Node.vala"
	result = FALSE;
#line 244 "../gxml/Node.vala"
	_g_free0 (ns);
#line 244 "../gxml/Node.vala"
	return result;
#line 1778 "Node.c"
}

/**
   * Sets node's parent and checks for namespace conflics.
   */
void
gxml_node_set_parent (GXmlNode* self,
                      GXmlDomNode* node,
                      GError** error)
{
	GXmlDomDocument* _tmp0_;
	GXmlDomDocument* _tmp1_;
	GXmlDomDocument* _tmp2_;
	GXmlDomNode* _tmp3_;
#line 249 "../gxml/Node.vala"
	g_return_if_fail (self != NULL);
#line 249 "../gxml/Node.vala"
	g_return_if_fail (node != NULL);
#line 250 "../gxml/Node.vala"
	_tmp0_ = gxml_dom_node_get_owner_document (node);
#line 250 "../gxml/Node.vala"
	_tmp1_ = _tmp0_;
#line 250 "../gxml/Node.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 250 "../gxml/Node.vala"
	_g_object_unref0 (self->_document);
#line 250 "../gxml/Node.vala"
	self->_document = _tmp2_;
#line 251 "../gxml/Node.vala"
	_tmp3_ = _g_object_ref0 (node);
#line 251 "../gxml/Node.vala"
	_g_object_unref0 (self->_parent);
#line 251 "../gxml/Node.vala"
	self->_parent = _tmp3_;
#line 1813 "Node.c"
}

static GXmlDomNode*
gxml_node_real_insert_before (GXmlDomNode* base,
                              GXmlDomNode* node,
                              GXmlDomNode* child,
                              GError** error)
{
	GXmlNode * self;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	GXmlDomNodeList* _tmp20_;
	GXmlDomNodeList* _tmp21_;
	GXmlDomNodeList* _tmp22_;
	GXmlDomNode* _tmp23_;
	GError* _inner_error0_ = NULL;
	GXmlDomNode* result = NULL;
#line 254 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 254 "../gxml/Node.vala"
	g_return_val_if_fail (node != NULL, NULL);
#line 255 "../gxml/Node.vala"
	if (!GXML_IS_NODE (node)) {
#line 1843 "Node.c"
		GError* _tmp0_;
#line 256 "../gxml/Node.vala"
		_tmp0_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Invalid attempt to add invalid node type"));
#line 256 "../gxml/Node.vala"
		_inner_error0_ = _tmp0_;
#line 256 "../gxml/Node.vala"
		g_propagate_error (error, _inner_error0_);
#line 256 "../gxml/Node.vala"
		return NULL;
#line 1853 "Node.c"
	}
#line 258 "../gxml/Node.vala"
	if (child != NULL) {
#line 258 "../gxml/Node.vala"
		_tmp1_ = !gxml_dom_node_contains ((GXmlDomNode*) self, child);
#line 1859 "Node.c"
	} else {
#line 258 "../gxml/Node.vala"
		_tmp1_ = FALSE;
#line 1863 "Node.c"
	}
#line 258 "../gxml/Node.vala"
	if (_tmp1_) {
#line 1867 "Node.c"
		GError* _tmp2_;
#line 259 "../gxml/Node.vala"
		_tmp2_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_NOT_FOUND_ERROR, _ ("Can't find child to insert node before"));
#line 259 "../gxml/Node.vala"
		_inner_error0_ = _tmp2_;
#line 259 "../gxml/Node.vala"
		g_propagate_error (error, _inner_error0_);
#line 259 "../gxml/Node.vala"
		return NULL;
#line 1877 "Node.c"
	}
#line 261 "../gxml/Node.vala"
	if (GXML_IS_DOM_DOCUMENT (self)) {
#line 261 "../gxml/Node.vala"
		_tmp4_ = TRUE;
#line 1883 "Node.c"
	} else {
#line 262 "../gxml/Node.vala"
		_tmp4_ = GXML_IS_DOM_ELEMENT (self);
#line 1887 "Node.c"
	}
#line 261 "../gxml/Node.vala"
	if (_tmp4_) {
#line 261 "../gxml/Node.vala"
		_tmp3_ = TRUE;
#line 1893 "Node.c"
	} else {
#line 263 "../gxml/Node.vala"
		_tmp3_ = GXML_IS_DOM_DOCUMENT_FRAGMENT (self);
#line 1897 "Node.c"
	}
#line 261 "../gxml/Node.vala"
	if (!_tmp3_) {
#line 1901 "Node.c"
		GError* _tmp5_;
#line 264 "../gxml/Node.vala"
		_tmp5_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_HIERARCHY_REQUEST_ERROR, _ ("Invalid attempt to insert a node"));
#line 264 "../gxml/Node.vala"
		_inner_error0_ = _tmp5_;
#line 264 "../gxml/Node.vala"
		g_propagate_error (error, _inner_error0_);
#line 264 "../gxml/Node.vala"
		return NULL;
#line 1911 "Node.c"
	}
#line 266 "../gxml/Node.vala"
	if (GXML_IS_DOM_DOCUMENT_FRAGMENT (node)) {
#line 266 "../gxml/Node.vala"
		_tmp10_ = TRUE;
#line 1917 "Node.c"
	} else {
#line 267 "../gxml/Node.vala"
		_tmp10_ = GXML_IS_DOM_DOCUMENT_TYPE (node);
#line 1921 "Node.c"
	}
#line 266 "../gxml/Node.vala"
	if (_tmp10_) {
#line 266 "../gxml/Node.vala"
		_tmp9_ = TRUE;
#line 1927 "Node.c"
	} else {
#line 268 "../gxml/Node.vala"
		_tmp9_ = GXML_IS_DOM_ELEMENT (node);
#line 1931 "Node.c"
	}
#line 266 "../gxml/Node.vala"
	if (_tmp9_) {
#line 266 "../gxml/Node.vala"
		_tmp8_ = TRUE;
#line 1937 "Node.c"
	} else {
#line 269 "../gxml/Node.vala"
		_tmp8_ = GXML_IS_DOM_TEXT (node);
#line 1941 "Node.c"
	}
#line 266 "../gxml/Node.vala"
	if (_tmp8_) {
#line 266 "../gxml/Node.vala"
		_tmp7_ = TRUE;
#line 1947 "Node.c"
	} else {
#line 270 "../gxml/Node.vala"
		_tmp7_ = GXML_IS_DOM_PROCESSING_INSTRUCTION (node);
#line 1951 "Node.c"
	}
#line 266 "../gxml/Node.vala"
	if (_tmp7_) {
#line 266 "../gxml/Node.vala"
		_tmp6_ = TRUE;
#line 1957 "Node.c"
	} else {
#line 271 "../gxml/Node.vala"
		_tmp6_ = GXML_IS_DOM_COMMENT (node);
#line 1961 "Node.c"
	}
#line 266 "../gxml/Node.vala"
	if (!_tmp6_) {
#line 1965 "Node.c"
		GError* _tmp11_;
#line 272 "../gxml/Node.vala"
		_tmp11_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_HIERARCHY_REQUEST_ERROR, _ ("Invalid attempt to insert an invalid node type"));
#line 272 "../gxml/Node.vala"
		_inner_error0_ = _tmp11_;
#line 272 "../gxml/Node.vala"
		g_propagate_error (error, _inner_error0_);
#line 272 "../gxml/Node.vala"
		return NULL;
#line 1975 "Node.c"
	}
#line 280 "../gxml/Node.vala"
	if (child != NULL) {
#line 1979 "Node.c"
		gint i = 0;
		GXmlDomNodeList* _tmp12_;
		GXmlDomNodeList* _tmp13_;
		GXmlDomNodeList* _tmp14_;
		gint _tmp15_;
		GXmlDomNodeList* _tmp16_;
		GXmlDomNodeList* _tmp17_;
		GXmlDomNodeList* _tmp18_;
		GXmlDomNode* _tmp19_;
#line 281 "../gxml/Node.vala"
		_tmp12_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 281 "../gxml/Node.vala"
		_tmp13_ = _tmp12_;
#line 281 "../gxml/Node.vala"
		_tmp14_ = _tmp13_;
#line 281 "../gxml/Node.vala"
		_tmp15_ = gee_list_index_of ((GeeList*) _tmp14_, GXML_IS_DOM_NODE (child) ? ((GXmlDomNode*) child) : NULL);
#line 281 "../gxml/Node.vala"
		_g_object_unref0 (_tmp14_);
#line 281 "../gxml/Node.vala"
		i = _tmp15_;
#line 282 "../gxml/Node.vala"
		_tmp16_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 282 "../gxml/Node.vala"
		_tmp17_ = _tmp16_;
#line 282 "../gxml/Node.vala"
		_tmp18_ = _tmp17_;
#line 282 "../gxml/Node.vala"
		gee_list_insert ((GeeList*) _tmp18_, i, GXML_IS_DOM_NODE (node) ? ((GXmlDomNode*) node) : NULL);
#line 282 "../gxml/Node.vala"
		_g_object_unref0 (_tmp18_);
#line 283 "../gxml/Node.vala"
		_tmp19_ = _g_object_ref0 (node);
#line 283 "../gxml/Node.vala"
		result = _tmp19_;
#line 283 "../gxml/Node.vala"
		return result;
#line 2017 "Node.c"
	}
#line 285 "../gxml/Node.vala"
	_tmp20_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 285 "../gxml/Node.vala"
	_tmp21_ = _tmp20_;
#line 285 "../gxml/Node.vala"
	_tmp22_ = _tmp21_;
#line 285 "../gxml/Node.vala"
	gee_collection_add ((GeeCollection*) _tmp22_, GXML_IS_DOM_NODE (node) ? ((GXmlDomNode*) node) : NULL);
#line 285 "../gxml/Node.vala"
	_g_object_unref0 (_tmp22_);
#line 286 "../gxml/Node.vala"
	_tmp23_ = _g_object_ref0 (node);
#line 286 "../gxml/Node.vala"
	result = _tmp23_;
#line 286 "../gxml/Node.vala"
	return result;
#line 2035 "Node.c"
}

static GXmlDomNode*
gxml_node_real_append_child (GXmlDomNode* base,
                             GXmlDomNode* node,
                             GError** error)
{
	GXmlNode * self;
	GXmlDomDocument* _tmp1_;
	GXmlDomDocument* _tmp2_;
	GXmlDomDocument* _tmp3_;
	GXmlDomDocument* _tmp4_;
	GXmlDomNode* _tmp6_ = NULL;
	GXmlDomNode* _tmp7_;
	GXmlDomNode* _tmp8_;
	GError* _inner_error0_ = NULL;
	GXmlDomNode* result = NULL;
#line 288 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 288 "../gxml/Node.vala"
	g_return_val_if_fail (node != NULL, NULL);
#line 289 "../gxml/Node.vala"
	if (!GXML_IS_NODE (node)) {
#line 2059 "Node.c"
		GError* _tmp0_;
#line 290 "../gxml/Node.vala"
		_tmp0_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_HIERARCHY_REQUEST_ERROR, _ ("Node type is invalid. Can't append as child"));
#line 290 "../gxml/Node.vala"
		_inner_error0_ = _tmp0_;
#line 290 "../gxml/Node.vala"
		g_propagate_error (error, _inner_error0_);
#line 290 "../gxml/Node.vala"
		return NULL;
#line 2069 "Node.c"
	}
#line 292 "../gxml/Node.vala"
	_tmp1_ = gxml_dom_node_get_owner_document ((GXmlDomNode*) self);
#line 292 "../gxml/Node.vala"
	_tmp2_ = _tmp1_;
#line 292 "../gxml/Node.vala"
	_tmp3_ = gxml_dom_node_get_owner_document (node);
#line 292 "../gxml/Node.vala"
	_tmp4_ = _tmp3_;
#line 292 "../gxml/Node.vala"
	if (_tmp2_ != _tmp4_) {
#line 2081 "Node.c"
		GError* _tmp5_;
#line 293 "../gxml/Node.vala"
		_tmp5_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_HIERARCHY_REQUEST_ERROR, _ ("Invalid attempt to append a child with different parent document"));
#line 293 "../gxml/Node.vala"
		_inner_error0_ = _tmp5_;
#line 293 "../gxml/Node.vala"
		g_propagate_error (error, _inner_error0_);
#line 293 "../gxml/Node.vala"
		return NULL;
#line 2091 "Node.c"
	}
#line 295 "../gxml/Node.vala"
	gxml_node_set_parent (G_TYPE_CHECK_INSTANCE_CAST (node, GXML_TYPE_NODE, GXmlNode), (GXmlDomNode*) self, &_inner_error0_);
#line 295 "../gxml/Node.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 295 "../gxml/Node.vala"
		g_propagate_error (error, _inner_error0_);
#line 295 "../gxml/Node.vala"
		return NULL;
#line 2101 "Node.c"
	}
#line 296 "../gxml/Node.vala"
	_tmp7_ = gxml_dom_node_insert_before ((GXmlDomNode*) self, node, NULL, &_inner_error0_);
#line 296 "../gxml/Node.vala"
	_tmp6_ = _tmp7_;
#line 296 "../gxml/Node.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 296 "../gxml/Node.vala"
		g_propagate_error (error, _inner_error0_);
#line 296 "../gxml/Node.vala"
		return NULL;
#line 2113 "Node.c"
	}
#line 296 "../gxml/Node.vala"
	_tmp8_ = _tmp6_;
#line 296 "../gxml/Node.vala"
	_tmp6_ = NULL;
#line 296 "../gxml/Node.vala"
	result = _tmp8_;
#line 296 "../gxml/Node.vala"
	_g_object_unref0 (_tmp6_);
#line 296 "../gxml/Node.vala"
	return result;
#line 2125 "Node.c"
}

static GXmlDomNode*
gxml_node_real_replace_child (GXmlDomNode* base,
                              GXmlDomNode* node,
                              GXmlDomNode* child,
                              GError** error)
{
	GXmlNode * self;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gint i = 0;
	GXmlDomNodeList* _tmp16_;
	GXmlDomNodeList* _tmp17_;
	GXmlDomNodeList* _tmp18_;
	gint _tmp19_;
	GXmlDomNodeList* _tmp20_;
	GXmlDomNodeList* _tmp21_;
	GXmlDomNodeList* _tmp22_;
	gpointer _tmp23_;
	GXmlDomNode* _tmp24_;
	GXmlDomNodeList* _tmp25_;
	GXmlDomNodeList* _tmp26_;
	GXmlDomNodeList* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	gboolean _tmp30_;
	GXmlDomNodeList* _tmp34_;
	GXmlDomNodeList* _tmp35_;
	GXmlDomNodeList* _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
	gboolean _tmp39_;
	GXmlDomNode* _tmp43_;
	GError* _inner_error0_ = NULL;
	GXmlDomNode* result = NULL;
#line 298 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 298 "../gxml/Node.vala"
	g_return_val_if_fail (node != NULL, NULL);
#line 298 "../gxml/Node.vala"
	g_return_val_if_fail (child != NULL, NULL);
#line 299 "../gxml/Node.vala"
	if (!GXML_IS_NODE (node)) {
#line 2178 "Node.c"
		GError* _tmp0_;
#line 300 "../gxml/Node.vala"
		_tmp0_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Invalid attempt to add invalid node type"));
#line 300 "../gxml/Node.vala"
		_inner_error0_ = _tmp0_;
#line 300 "../gxml/Node.vala"
		g_propagate_error (error, _inner_error0_);
#line 300 "../gxml/Node.vala"
		return NULL;
#line 2188 "Node.c"
	}
#line 301 "../gxml/Node.vala"
	if (child == NULL) {
#line 301 "../gxml/Node.vala"
		_tmp1_ = TRUE;
#line 2194 "Node.c"
	} else {
#line 301 "../gxml/Node.vala"
		_tmp1_ = !gxml_dom_node_contains ((GXmlDomNode*) self, child);
#line 2198 "Node.c"
	}
#line 301 "../gxml/Node.vala"
	if (_tmp1_) {
#line 2202 "Node.c"
		GError* _tmp2_;
#line 302 "../gxml/Node.vala"
		_tmp2_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_NOT_FOUND_ERROR, _ ("Can't find child node to replace or child have a different parent"));
#line 302 "../gxml/Node.vala"
		_inner_error0_ = _tmp2_;
#line 302 "../gxml/Node.vala"
		g_propagate_error (error, _inner_error0_);
#line 302 "../gxml/Node.vala"
		return NULL;
#line 2212 "Node.c"
	}
#line 303 "../gxml/Node.vala"
	if (GXML_IS_DOM_DOCUMENT (self)) {
#line 303 "../gxml/Node.vala"
		_tmp4_ = TRUE;
#line 2218 "Node.c"
	} else {
#line 304 "../gxml/Node.vala"
		_tmp4_ = GXML_IS_DOM_ELEMENT (self);
#line 2222 "Node.c"
	}
#line 303 "../gxml/Node.vala"
	if (_tmp4_) {
#line 303 "../gxml/Node.vala"
		_tmp3_ = TRUE;
#line 2228 "Node.c"
	} else {
#line 305 "../gxml/Node.vala"
		_tmp3_ = GXML_IS_DOM_DOCUMENT_FRAGMENT (self);
#line 2232 "Node.c"
	}
#line 303 "../gxml/Node.vala"
	if (!_tmp3_) {
#line 2236 "Node.c"
		GError* _tmp5_;
#line 306 "../gxml/Node.vala"
		_tmp5_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_HIERARCHY_REQUEST_ERROR, _ ("Invalid attempt to insert a node"));
#line 306 "../gxml/Node.vala"
		_inner_error0_ = _tmp5_;
#line 306 "../gxml/Node.vala"
		g_propagate_error (error, _inner_error0_);
#line 306 "../gxml/Node.vala"
		return NULL;
#line 2246 "Node.c"
	}
#line 307 "../gxml/Node.vala"
	if (GXML_IS_DOM_DOCUMENT_FRAGMENT (node)) {
#line 307 "../gxml/Node.vala"
		_tmp10_ = TRUE;
#line 2252 "Node.c"
	} else {
#line 308 "../gxml/Node.vala"
		_tmp10_ = GXML_IS_DOM_DOCUMENT_TYPE (node);
#line 2256 "Node.c"
	}
#line 307 "../gxml/Node.vala"
	if (_tmp10_) {
#line 307 "../gxml/Node.vala"
		_tmp9_ = TRUE;
#line 2262 "Node.c"
	} else {
#line 309 "../gxml/Node.vala"
		_tmp9_ = GXML_IS_DOM_ELEMENT (node);
#line 2266 "Node.c"
	}
#line 307 "../gxml/Node.vala"
	if (_tmp9_) {
#line 307 "../gxml/Node.vala"
		_tmp8_ = TRUE;
#line 2272 "Node.c"
	} else {
#line 310 "../gxml/Node.vala"
		_tmp8_ = GXML_IS_DOM_TEXT (node);
#line 2276 "Node.c"
	}
#line 307 "../gxml/Node.vala"
	if (_tmp8_) {
#line 307 "../gxml/Node.vala"
		_tmp7_ = TRUE;
#line 2282 "Node.c"
	} else {
#line 311 "../gxml/Node.vala"
		_tmp7_ = GXML_IS_DOM_PROCESSING_INSTRUCTION (node);
#line 2286 "Node.c"
	}
#line 307 "../gxml/Node.vala"
	if (_tmp7_) {
#line 307 "../gxml/Node.vala"
		_tmp6_ = TRUE;
#line 2292 "Node.c"
	} else {
#line 312 "../gxml/Node.vala"
		_tmp6_ = GXML_IS_DOM_COMMENT (node);
#line 2296 "Node.c"
	}
#line 307 "../gxml/Node.vala"
	if (!_tmp6_) {
#line 2300 "Node.c"
		GError* _tmp11_;
#line 313 "../gxml/Node.vala"
		_tmp11_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_HIERARCHY_REQUEST_ERROR, _ ("Invalid attempt to insert an invalid node type"));
#line 313 "../gxml/Node.vala"
		_inner_error0_ = _tmp11_;
#line 313 "../gxml/Node.vala"
		g_propagate_error (error, _inner_error0_);
#line 313 "../gxml/Node.vala"
		return NULL;
#line 2310 "Node.c"
	}
#line 314 "../gxml/Node.vala"
	if (GXML_IS_DOM_TEXT (node)) {
#line 314 "../gxml/Node.vala"
		_tmp13_ = GXML_IS_DOM_DOCUMENT (self);
#line 2316 "Node.c"
	} else {
#line 314 "../gxml/Node.vala"
		_tmp13_ = FALSE;
#line 2320 "Node.c"
	}
#line 314 "../gxml/Node.vala"
	if (_tmp13_) {
#line 314 "../gxml/Node.vala"
		_tmp12_ = TRUE;
#line 2326 "Node.c"
	} else {
		gboolean _tmp14_ = FALSE;
#line 315 "../gxml/Node.vala"
		if (GXML_IS_DOM_DOCUMENT_TYPE (node)) {
#line 315 "../gxml/Node.vala"
			_tmp14_ = !GXML_IS_DOM_DOCUMENT (self);
#line 2333 "Node.c"
		} else {
#line 315 "../gxml/Node.vala"
			_tmp14_ = FALSE;
#line 2337 "Node.c"
		}
#line 315 "../gxml/Node.vala"
		_tmp12_ = _tmp14_;
#line 2341 "Node.c"
	}
#line 314 "../gxml/Node.vala"
	if (_tmp12_) {
#line 2345 "Node.c"
		GError* _tmp15_;
#line 316 "../gxml/Node.vala"
		_tmp15_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_HIERARCHY_REQUEST_ERROR, _ ("Invalid attempt to insert a document's type or text node to an invalid" \
" parent"));
#line 316 "../gxml/Node.vala"
		_inner_error0_ = _tmp15_;
#line 316 "../gxml/Node.vala"
		g_propagate_error (error, _inner_error0_);
#line 316 "../gxml/Node.vala"
		return NULL;
#line 2355 "Node.c"
	}
#line 318 "../gxml/Node.vala"
	_tmp16_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 318 "../gxml/Node.vala"
	_tmp17_ = _tmp16_;
#line 318 "../gxml/Node.vala"
	_tmp18_ = _tmp17_;
#line 318 "../gxml/Node.vala"
	_tmp19_ = gee_list_index_of ((GeeList*) _tmp18_, GXML_IS_DOM_NODE (child) ? ((GXmlDomNode*) child) : NULL);
#line 318 "../gxml/Node.vala"
	_g_object_unref0 (_tmp18_);
#line 318 "../gxml/Node.vala"
	i = _tmp19_;
#line 319 "../gxml/Node.vala"
	_tmp20_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 319 "../gxml/Node.vala"
	_tmp21_ = _tmp20_;
#line 319 "../gxml/Node.vala"
	_tmp22_ = _tmp21_;
#line 319 "../gxml/Node.vala"
	_tmp23_ = gee_list_remove_at ((GeeList*) _tmp22_, i);
#line 319 "../gxml/Node.vala"
	_tmp24_ = (GXmlDomNode*) _tmp23_;
#line 319 "../gxml/Node.vala"
	_g_object_unref0 (_tmp24_);
#line 319 "../gxml/Node.vala"
	_g_object_unref0 (_tmp22_);
#line 320 "../gxml/Node.vala"
	_tmp25_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 320 "../gxml/Node.vala"
	_tmp26_ = _tmp25_;
#line 320 "../gxml/Node.vala"
	_tmp27_ = _tmp26_;
#line 320 "../gxml/Node.vala"
	_tmp28_ = gee_collection_get_size ((GeeCollection*) _tmp27_);
#line 320 "../gxml/Node.vala"
	_tmp29_ = _tmp28_;
#line 320 "../gxml/Node.vala"
	_tmp30_ = i < _tmp29_;
#line 320 "../gxml/Node.vala"
	_g_object_unref0 (_tmp27_);
#line 320 "../gxml/Node.vala"
	if (_tmp30_) {
#line 2399 "Node.c"
		GXmlDomNodeList* _tmp31_;
		GXmlDomNodeList* _tmp32_;
		GXmlDomNodeList* _tmp33_;
#line 321 "../gxml/Node.vala"
		_tmp31_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 321 "../gxml/Node.vala"
		_tmp32_ = _tmp31_;
#line 321 "../gxml/Node.vala"
		_tmp33_ = _tmp32_;
#line 321 "../gxml/Node.vala"
		gee_list_insert ((GeeList*) _tmp33_, i, GXML_IS_DOM_NODE (node) ? ((GXmlDomNode*) node) : NULL);
#line 321 "../gxml/Node.vala"
		_g_object_unref0 (_tmp33_);
#line 2413 "Node.c"
	}
#line 322 "../gxml/Node.vala"
	_tmp34_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 322 "../gxml/Node.vala"
	_tmp35_ = _tmp34_;
#line 322 "../gxml/Node.vala"
	_tmp36_ = _tmp35_;
#line 322 "../gxml/Node.vala"
	_tmp37_ = gee_collection_get_size ((GeeCollection*) _tmp36_);
#line 322 "../gxml/Node.vala"
	_tmp38_ = _tmp37_;
#line 322 "../gxml/Node.vala"
	_tmp39_ = i >= _tmp38_;
#line 322 "../gxml/Node.vala"
	_g_object_unref0 (_tmp36_);
#line 322 "../gxml/Node.vala"
	if (_tmp39_) {
#line 2431 "Node.c"
		GXmlDomNodeList* _tmp40_;
		GXmlDomNodeList* _tmp41_;
		GXmlDomNodeList* _tmp42_;
#line 323 "../gxml/Node.vala"
		_tmp40_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 323 "../gxml/Node.vala"
		_tmp41_ = _tmp40_;
#line 323 "../gxml/Node.vala"
		_tmp42_ = _tmp41_;
#line 323 "../gxml/Node.vala"
		gee_collection_add ((GeeCollection*) _tmp42_, node);
#line 323 "../gxml/Node.vala"
		_g_object_unref0 (_tmp42_);
#line 2445 "Node.c"
	}
#line 324 "../gxml/Node.vala"
	_tmp43_ = _g_object_ref0 (child);
#line 324 "../gxml/Node.vala"
	result = _tmp43_;
#line 324 "../gxml/Node.vala"
	return result;
#line 2453 "Node.c"
}

static GXmlDomNode*
gxml_node_real_remove_child (GXmlDomNode* base,
                             GXmlDomNode* child,
                             GError** error)
{
	GXmlNode * self;
	gint i = 0;
	GXmlDomNodeList* _tmp1_;
	GXmlDomNodeList* _tmp2_;
	GXmlDomNodeList* _tmp3_;
	gint _tmp4_;
	GXmlDomNodeList* _tmp5_;
	GXmlDomNodeList* _tmp6_;
	GXmlDomNodeList* _tmp7_;
	gpointer _tmp8_;
	GXmlDomNode* _tmp9_;
	GError* _inner_error0_ = NULL;
	GXmlDomNode* result = NULL;
#line 326 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 326 "../gxml/Node.vala"
	g_return_val_if_fail (child != NULL, NULL);
#line 327 "../gxml/Node.vala"
	if (!gxml_dom_node_contains ((GXmlDomNode*) self, child)) {
#line 2480 "Node.c"
		GError* _tmp0_;
#line 328 "../gxml/Node.vala"
		_tmp0_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_NOT_FOUND_ERROR, _ ("Can't find child node to remove or child have a different parent"));
#line 328 "../gxml/Node.vala"
		_inner_error0_ = _tmp0_;
#line 328 "../gxml/Node.vala"
		g_propagate_error (error, _inner_error0_);
#line 328 "../gxml/Node.vala"
		return NULL;
#line 2490 "Node.c"
	}
#line 329 "../gxml/Node.vala"
	_tmp1_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 329 "../gxml/Node.vala"
	_tmp2_ = _tmp1_;
#line 329 "../gxml/Node.vala"
	_tmp3_ = _tmp2_;
#line 329 "../gxml/Node.vala"
	_tmp4_ = gee_list_index_of ((GeeList*) _tmp3_, GXML_IS_DOM_NODE (child) ? ((GXmlDomNode*) child) : NULL);
#line 329 "../gxml/Node.vala"
	_g_object_unref0 (_tmp3_);
#line 329 "../gxml/Node.vala"
	i = _tmp4_;
#line 330 "../gxml/Node.vala"
	_tmp5_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 330 "../gxml/Node.vala"
	_tmp6_ = _tmp5_;
#line 330 "../gxml/Node.vala"
	_tmp7_ = _tmp6_;
#line 330 "../gxml/Node.vala"
	_tmp8_ = gee_list_remove_at ((GeeList*) _tmp7_, i);
#line 330 "../gxml/Node.vala"
	_tmp9_ = G_TYPE_CHECK_INSTANCE_CAST ((GXmlDomNode*) _tmp8_, GXML_TYPE_DOM_NODE, GXmlDomNode);
#line 330 "../gxml/Node.vala"
	_g_object_unref0 (_tmp7_);
#line 330 "../gxml/Node.vala"
	result = _tmp9_;
#line 330 "../gxml/Node.vala"
	return result;
#line 2520 "Node.c"
}

static void
gxml_node_real_add_event_listener (GXmlDomEventTarget* base,
                                   const gchar* type,
                                   GXmlDomEventListener* callback,
                                   gboolean capture)
{
	GXmlNode * self;
#line 333 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 333 "../gxml/Node.vala"
	g_return_if_fail (type != NULL);
#line 334 "../gxml/Node.vala"
	return;
#line 2536 "Node.c"
}

static void
gxml_node_real_remove_event_listener (GXmlDomEventTarget* base,
                                      const gchar* type,
                                      GXmlDomEventListener* callback,
                                      gboolean capture)
{
	GXmlNode * self;
#line 335 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 335 "../gxml/Node.vala"
	g_return_if_fail (type != NULL);
#line 336 "../gxml/Node.vala"
	return;
#line 2552 "Node.c"
}

static gboolean
gxml_node_real_dispatch_event (GXmlDomEventTarget* base,
                               GXmlDomEvent* event,
                               GError** error)
{
	GXmlNode * self;
	gboolean result = FALSE;
#line 337 "../gxml/Node.vala"
	self = (GXmlNode*) base;
#line 337 "../gxml/Node.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 338 "../gxml/Node.vala"
	result = FALSE;
#line 338 "../gxml/Node.vala"
	return result;
#line 2570 "Node.c"
}

GXmlNode*
gxml_node_construct (GType object_type)
{
	GXmlNode * self = NULL;
#line 32 "../gxml/Node.vala"
	self = (GXmlNode*) g_object_new (object_type, NULL);
#line 32 "../gxml/Node.vala"
	return self;
#line 2581 "Node.c"
}

GXmlNode*
gxml_node_new (void)
{
#line 32 "../gxml/Node.vala"
	return gxml_node_construct (GXML_TYPE_NODE);
#line 2589 "Node.c"
}

static GObject *
gxml_node_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GXmlNode * self;
	gchar* _tmp0_;
	GXmlNodeList* _tmp1_;
#line 161 "../gxml/Node.vala"
	parent_class = G_OBJECT_CLASS (gxml_node_parent_class);
#line 161 "../gxml/Node.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 161 "../gxml/Node.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GXML_TYPE_NODE, GXmlNode);
#line 162 "../gxml/Node.vala"
	_tmp0_ = g_strdup ("");
#line 162 "../gxml/Node.vala"
	_g_free0 (self->_local_name);
#line 162 "../gxml/Node.vala"
	self->_local_name = _tmp0_;
#line 163 "../gxml/Node.vala"
	_g_free0 (self->_prefix);
#line 163 "../gxml/Node.vala"
	self->_prefix = NULL;
#line 164 "../gxml/Node.vala"
	self->_node_type = GXML_DOM_NODE_NODE_TYPE_INVALID;
#line 165 "../gxml/Node.vala"
	_g_free0 (self->_base_uri);
#line 165 "../gxml/Node.vala"
	self->_base_uri = NULL;
#line 166 "../gxml/Node.vala"
	_g_free0 (self->_node_value);
#line 166 "../gxml/Node.vala"
	self->_node_value = NULL;
#line 167 "../gxml/Node.vala"
	_tmp1_ = gxml_node_list_new ();
#line 167 "../gxml/Node.vala"
	_g_object_unref0 (self->_child_nodes);
#line 167 "../gxml/Node.vala"
	self->_child_nodes = _tmp1_;
#line 168 "../gxml/Node.vala"
	_g_object_unref0 (self->_parent);
#line 168 "../gxml/Node.vala"
	self->_parent = NULL;
#line 161 "../gxml/Node.vala"
	return obj;
#line 2640 "Node.c"
}

static void
gxml_node_class_init (GXmlNodeClass * klass,
                      gpointer klass_data)
{
#line 32 "../gxml/Node.vala"
	gxml_node_parent_class = g_type_class_peek_parent (klass);
#line 32 "../gxml/Node.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gxml_node_get_property;
#line 32 "../gxml/Node.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gxml_node_set_property;
#line 32 "../gxml/Node.vala"
	G_OBJECT_CLASS (klass)->constructor = gxml_node_constructor;
#line 32 "../gxml/Node.vala"
	G_OBJECT_CLASS (klass)->finalize = gxml_node_finalize;
#line 32 "../gxml/Node.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_NODE_NODE_TYPE_PROPERTY, gxml_node_properties[GXML_NODE_NODE_TYPE_PROPERTY] = g_param_spec_enum ("node-type", "node-type", "node-type", GXML_DOM_NODE_TYPE_NODE_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../gxml/Node.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_NODE_NODE_NAME_PROPERTY, gxml_node_properties[GXML_NODE_NODE_NAME_PROPERTY] = g_param_spec_string ("node-name", "node-name", "node-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../gxml/Node.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_NODE_BASE_URI_PROPERTY, gxml_node_properties[GXML_NODE_BASE_URI_PROPERTY] = g_param_spec_string ("base-uri", "base-uri", "base-uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../gxml/Node.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_NODE_OWNER_DOCUMENT_PROPERTY, gxml_node_properties[GXML_NODE_OWNER_DOCUMENT_PROPERTY] = g_param_spec_object ("owner-document", "owner-document", "owner-document", GXML_TYPE_DOM_DOCUMENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 32 "../gxml/Node.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_NODE_PARENT_NODE_PROPERTY, gxml_node_properties[GXML_NODE_PARENT_NODE_PROPERTY] = g_param_spec_object ("parent-node", "parent-node", "parent-node", GXML_TYPE_DOM_NODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../gxml/Node.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_NODE_PARENT_ELEMENT_PROPERTY, gxml_node_properties[GXML_NODE_PARENT_ELEMENT_PROPERTY] = g_param_spec_object ("parent-element", "parent-element", "parent-element", GXML_TYPE_DOM_ELEMENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../gxml/Node.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_NODE_CHILD_NODES_PROPERTY, gxml_node_properties[GXML_NODE_CHILD_NODES_PROPERTY] = g_param_spec_object ("child-nodes", "child-nodes", "child-nodes", GXML_TYPE_DOM_NODE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../gxml/Node.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_NODE_FIRST_CHILD_PROPERTY, gxml_node_properties[GXML_NODE_FIRST_CHILD_PROPERTY] = g_param_spec_object ("first-child", "first-child", "first-child", GXML_TYPE_DOM_NODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../gxml/Node.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_NODE_LAST_CHILD_PROPERTY, gxml_node_properties[GXML_NODE_LAST_CHILD_PROPERTY] = g_param_spec_object ("last-child", "last-child", "last-child", GXML_TYPE_DOM_NODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../gxml/Node.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_NODE_PREVIOUS_SIBLING_PROPERTY, gxml_node_properties[GXML_NODE_PREVIOUS_SIBLING_PROPERTY] = g_param_spec_object ("previous-sibling", "previous-sibling", "previous-sibling", GXML_TYPE_DOM_NODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../gxml/Node.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_NODE_NEXT_SIBLING_PROPERTY, gxml_node_properties[GXML_NODE_NEXT_SIBLING_PROPERTY] = g_param_spec_object ("next-sibling", "next-sibling", "next-sibling", GXML_TYPE_DOM_NODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../gxml/Node.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_NODE_NODE_VALUE_PROPERTY, gxml_node_properties[GXML_NODE_NODE_VALUE_PROPERTY] = g_param_spec_string ("node-value", "node-value", "node-value", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "../gxml/Node.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_NODE_TEXT_CONTENT_PROPERTY, gxml_node_properties[GXML_NODE_TEXT_CONTENT_PROPERTY] = g_param_spec_string ("text-content", "text-content", "text-content", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2683 "Node.c"
}

static void
gxml_node_gxml_dom_event_target_interface_init (GXmlDomEventTargetIface * iface,
                                                gpointer iface_data)
{
#line 32 "../gxml/Node.vala"
	gxml_node_gxml_dom_event_target_parent_iface = g_type_interface_peek_parent (iface);
#line 32 "../gxml/Node.vala"
	iface->add_event_listener = (void (*) (GXmlDomEventTarget*, const gchar*, GXmlDomEventListener*, gboolean)) gxml_node_real_add_event_listener;
#line 32 "../gxml/Node.vala"
	iface->remove_event_listener = (void (*) (GXmlDomEventTarget*, const gchar*, GXmlDomEventListener*, gboolean)) gxml_node_real_remove_event_listener;
#line 32 "../gxml/Node.vala"
	iface->dispatch_event = (gboolean (*) (GXmlDomEventTarget*, GXmlDomEvent*, GError**)) gxml_node_real_dispatch_event;
#line 2698 "Node.c"
}

static void
gxml_node_gxml_dom_node_interface_init (GXmlDomNodeIface * iface,
                                        gpointer iface_data)
{
#line 32 "../gxml/Node.vala"
	gxml_node_gxml_dom_node_parent_iface = g_type_interface_peek_parent (iface);
#line 32 "../gxml/Node.vala"
	iface->has_child_nodes = (gboolean (*) (GXmlDomNode*)) gxml_node_real_has_child_nodes;
#line 32 "../gxml/Node.vala"
	iface->normalize = (void (*) (GXmlDomNode*)) gxml_node_real_normalize;
#line 32 "../gxml/Node.vala"
	iface->is_equal_node = (gboolean (*) (GXmlDomNode*, GXmlDomNode*)) gxml_node_real_is_equal_node;
#line 32 "../gxml/Node.vala"
	iface->compare_document_position = (GXmlDomNodeDocumentPosition (*) (GXmlDomNode*, GXmlDomNode*)) gxml_node_real_compare_document_position;
#line 32 "../gxml/Node.vala"
	iface->contains = (gboolean (*) (GXmlDomNode*, GXmlDomNode*)) gxml_node_real_contains;
#line 32 "../gxml/Node.vala"
	iface->lookup_prefix = (gchar* (*) (GXmlDomNode*, const gchar*)) gxml_node_real_lookup_prefix;
#line 32 "../gxml/Node.vala"
	iface->lookup_namespace_uri = (gchar* (*) (GXmlDomNode*, const gchar*)) gxml_node_real_lookup_namespace_uri;
#line 32 "../gxml/Node.vala"
	iface->is_default_namespace = (gboolean (*) (GXmlDomNode*, const gchar*)) gxml_node_real_is_default_namespace;
#line 32 "../gxml/Node.vala"
	iface->insert_before = (GXmlDomNode* (*) (GXmlDomNode*, GXmlDomNode*, GXmlDomNode*, GError**)) gxml_node_real_insert_before;
#line 32 "../gxml/Node.vala"
	iface->append_child = (GXmlDomNode* (*) (GXmlDomNode*, GXmlDomNode*, GError**)) gxml_node_real_append_child;
#line 32 "../gxml/Node.vala"
	iface->replace_child = (GXmlDomNode* (*) (GXmlDomNode*, GXmlDomNode*, GXmlDomNode*, GError**)) gxml_node_real_replace_child;
#line 32 "../gxml/Node.vala"
	iface->remove_child = (GXmlDomNode* (*) (GXmlDomNode*, GXmlDomNode*, GError**)) gxml_node_real_remove_child;
#line 32 "../gxml/Node.vala"
	iface->get_node_type = gxml_node_real_get_node_type;
#line 32 "../gxml/Node.vala"
	iface->get_node_name = gxml_node_real_get_node_name;
#line 32 "../gxml/Node.vala"
	iface->get_base_uri = gxml_node_real_get_base_uri;
#line 32 "../gxml/Node.vala"
	iface->get_owner_document = gxml_node_real_get_owner_document;
#line 32 "../gxml/Node.vala"
	iface->set_owner_document = gxml_node_real_set_owner_document;
#line 32 "../gxml/Node.vala"
	iface->get_parent_node = gxml_node_real_get_parent_node;
#line 32 "../gxml/Node.vala"
	iface->get_parent_element = gxml_node_real_get_parent_element;
#line 32 "../gxml/Node.vala"
	iface->get_child_nodes = gxml_node_real_get_child_nodes;
#line 32 "../gxml/Node.vala"
	iface->get_first_child = gxml_node_real_get_first_child;
#line 32 "../gxml/Node.vala"
	iface->get_last_child = gxml_node_real_get_last_child;
#line 32 "../gxml/Node.vala"
	iface->get_previous_sibling = gxml_node_real_get_previous_sibling;
#line 32 "../gxml/Node.vala"
	iface->get_next_sibling = gxml_node_real_get_next_sibling;
#line 32 "../gxml/Node.vala"
	iface->get_node_value = gxml_node_real_get_node_value;
#line 32 "../gxml/Node.vala"
	iface->set_node_value = gxml_node_real_set_node_value;
#line 32 "../gxml/Node.vala"
	iface->get_text_content = gxml_node_real_get_text_content;
#line 32 "../gxml/Node.vala"
	iface->set_text_content = gxml_node_real_set_text_content;
#line 2763 "Node.c"
}

static void
gxml_node_instance_init (GXmlNode * self,
                         gpointer klass)
{
}

static void
gxml_node_finalize (GObject * obj)
{
	GXmlNode * self;
#line 32 "../gxml/Node.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GXML_TYPE_NODE, GXmlNode);
#line 39 "../gxml/Node.vala"
	_g_free0 (self->_local_name);
#line 43 "../gxml/Node.vala"
	_g_free0 (self->_prefix);
#line 49 "../gxml/Node.vala"
	_g_free0 (self->_base_uri);
#line 53 "../gxml/Node.vala"
	_g_free0 (self->_node_value);
#line 57 "../gxml/Node.vala"
	_g_object_unref0 (self->_parent);
#line 65 "../gxml/Node.vala"
	_g_object_unref0 (self->_child_nodes);
#line 77 "../gxml/Node.vala"
	_g_object_unref0 (self->_document);
#line 32 "../gxml/Node.vala"
	G_OBJECT_CLASS (gxml_node_parent_class)->finalize (obj);
#line 2794 "Node.c"
}

/**
 * A DOM4 implementation of {@link DomNode}, for one step parsing.
 *
 * This object avoids pre and post XML parsing, by using a one step parsing
 * to translate text XML tree to an GObject based tree.
 */
static GType
gxml_node_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GXmlNodeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_node_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GXmlNode), 0, (GInstanceInitFunc) gxml_node_instance_init, NULL };
	static const GInterfaceInfo gxml_dom_event_target_info = { (GInterfaceInitFunc) gxml_node_gxml_dom_event_target_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gxml_dom_node_info = { (GInterfaceInitFunc) gxml_node_gxml_dom_node_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gxml_node_type_id;
	gxml_node_type_id = g_type_register_static (G_TYPE_OBJECT, "GXmlNode", &g_define_type_info, 0);
	g_type_add_interface_static (gxml_node_type_id, GXML_TYPE_DOM_EVENT_TARGET, &gxml_dom_event_target_info);
	g_type_add_interface_static (gxml_node_type_id, GXML_TYPE_DOM_NODE, &gxml_dom_node_info);
	return gxml_node_type_id;
}

GType
gxml_node_get_type (void)
{
	static volatile gsize gxml_node_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_node_type_id__volatile)) {
		GType gxml_node_type_id;
		gxml_node_type_id = gxml_node_get_type_once ();
		g_once_init_leave (&gxml_node_type_id__volatile, gxml_node_type_id);
	}
	return gxml_node_type_id__volatile;
}

static void
_vala_gxml_node_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	GXmlNode * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_NODE, GXmlNode);
#line 32 "../gxml/Node.vala"
	switch (property_id) {
#line 32 "../gxml/Node.vala"
		case GXML_NODE_NODE_TYPE_PROPERTY:
#line 32 "../gxml/Node.vala"
		g_value_set_enum (value, gxml_dom_node_get_node_type ((GXmlDomNode*) self));
#line 32 "../gxml/Node.vala"
		break;
#line 32 "../gxml/Node.vala"
		case GXML_NODE_NODE_NAME_PROPERTY:
#line 32 "../gxml/Node.vala"
		g_value_take_string (value, gxml_dom_node_get_node_name ((GXmlDomNode*) self));
#line 32 "../gxml/Node.vala"
		break;
#line 32 "../gxml/Node.vala"
		case GXML_NODE_BASE_URI_PROPERTY:
#line 32 "../gxml/Node.vala"
		g_value_set_string (value, gxml_dom_node_get_base_uri ((GXmlDomNode*) self));
#line 32 "../gxml/Node.vala"
		break;
#line 32 "../gxml/Node.vala"
		case GXML_NODE_OWNER_DOCUMENT_PROPERTY:
#line 32 "../gxml/Node.vala"
		g_value_set_object (value, gxml_dom_node_get_owner_document ((GXmlDomNode*) self));
#line 32 "../gxml/Node.vala"
		break;
#line 32 "../gxml/Node.vala"
		case GXML_NODE_PARENT_NODE_PROPERTY:
#line 32 "../gxml/Node.vala"
		g_value_take_object (value, gxml_dom_node_get_parent_node ((GXmlDomNode*) self));
#line 32 "../gxml/Node.vala"
		break;
#line 32 "../gxml/Node.vala"
		case GXML_NODE_PARENT_ELEMENT_PROPERTY:
#line 32 "../gxml/Node.vala"
		g_value_take_object (value, gxml_dom_node_get_parent_element ((GXmlDomNode*) self));
#line 32 "../gxml/Node.vala"
		break;
#line 32 "../gxml/Node.vala"
		case GXML_NODE_CHILD_NODES_PROPERTY:
#line 32 "../gxml/Node.vala"
		g_value_take_object (value, gxml_dom_node_get_child_nodes ((GXmlDomNode*) self));
#line 32 "../gxml/Node.vala"
		break;
#line 32 "../gxml/Node.vala"
		case GXML_NODE_FIRST_CHILD_PROPERTY:
#line 32 "../gxml/Node.vala"
		g_value_take_object (value, gxml_dom_node_get_first_child ((GXmlDomNode*) self));
#line 32 "../gxml/Node.vala"
		break;
#line 32 "../gxml/Node.vala"
		case GXML_NODE_LAST_CHILD_PROPERTY:
#line 32 "../gxml/Node.vala"
		g_value_take_object (value, gxml_dom_node_get_last_child ((GXmlDomNode*) self));
#line 32 "../gxml/Node.vala"
		break;
#line 32 "../gxml/Node.vala"
		case GXML_NODE_PREVIOUS_SIBLING_PROPERTY:
#line 32 "../gxml/Node.vala"
		g_value_take_object (value, gxml_dom_node_get_previous_sibling ((GXmlDomNode*) self));
#line 32 "../gxml/Node.vala"
		break;
#line 32 "../gxml/Node.vala"
		case GXML_NODE_NEXT_SIBLING_PROPERTY:
#line 32 "../gxml/Node.vala"
		g_value_take_object (value, gxml_dom_node_get_next_sibling ((GXmlDomNode*) self));
#line 32 "../gxml/Node.vala"
		break;
#line 32 "../gxml/Node.vala"
		case GXML_NODE_NODE_VALUE_PROPERTY:
#line 32 "../gxml/Node.vala"
		g_value_take_string (value, gxml_dom_node_get_node_value ((GXmlDomNode*) self));
#line 32 "../gxml/Node.vala"
		break;
#line 32 "../gxml/Node.vala"
		case GXML_NODE_TEXT_CONTENT_PROPERTY:
#line 32 "../gxml/Node.vala"
		g_value_take_string (value, gxml_dom_node_get_text_content ((GXmlDomNode*) self));
#line 32 "../gxml/Node.vala"
		break;
#line 2916 "Node.c"
		default:
#line 32 "../gxml/Node.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../gxml/Node.vala"
		break;
#line 2922 "Node.c"
	}
}

static void
_vala_gxml_node_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	GXmlNode * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_NODE, GXmlNode);
#line 32 "../gxml/Node.vala"
	switch (property_id) {
#line 32 "../gxml/Node.vala"
		case GXML_NODE_OWNER_DOCUMENT_PROPERTY:
#line 32 "../gxml/Node.vala"
		gxml_dom_node_set_owner_document ((GXmlDomNode*) self, g_value_get_object (value));
#line 32 "../gxml/Node.vala"
		break;
#line 32 "../gxml/Node.vala"
		case GXML_NODE_NODE_VALUE_PROPERTY:
#line 32 "../gxml/Node.vala"
		gxml_dom_node_set_node_value ((GXmlDomNode*) self, g_value_get_string (value));
#line 32 "../gxml/Node.vala"
		break;
#line 32 "../gxml/Node.vala"
		case GXML_NODE_TEXT_CONTENT_PROPERTY:
#line 32 "../gxml/Node.vala"
		gxml_dom_node_set_text_content ((GXmlDomNode*) self, g_value_get_string (value));
#line 32 "../gxml/Node.vala"
		break;
#line 2954 "Node.c"
		default:
#line 32 "../gxml/Node.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../gxml/Node.vala"
		break;
#line 2960 "Node.c"
	}
}

static GXmlDomNode*
gxml_node_list_real_item (GXmlDomNodeList* base,
                          gint index)
{
	GXmlNodeList * self;
	gpointer _tmp0_;
	GXmlDomNode* result = NULL;
#line 346 "../gxml/Node.vala"
	self = (GXmlNodeList*) base;
#line 346 "../gxml/Node.vala"
	_tmp0_ = GEE_ABSTRACT_LIST_CLASS (gxml_node_list_parent_class)->get ((GeeAbstractList*) G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_ARRAY_LIST, GeeArrayList), index);
#line 346 "../gxml/Node.vala"
	result = (GXmlDomNode*) _tmp0_;
#line 346 "../gxml/Node.vala"
	return result;
#line 2979 "Node.c"
}

static gint
gxml_node_list_real_get_length (GXmlDomNodeList* base)
{
	gint result;
	GXmlNodeList* self;
	gint _tmp0_;
	gint _tmp1_;
#line 347 "../gxml/Node.vala"
	self = (GXmlNodeList*) base;
#line 347 "../gxml/Node.vala"
	_tmp0_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) self);
#line 347 "../gxml/Node.vala"
	_tmp1_ = _tmp0_;
#line 347 "../gxml/Node.vala"
	result = _tmp1_;
#line 347 "../gxml/Node.vala"
	return result;
#line 2999 "Node.c"
}

GXmlNodeList*
gxml_node_list_construct (GType object_type)
{
	GXmlNodeList * self = NULL;
#line 345 "../gxml/Node.vala"
	self = (GXmlNodeList*) gee_array_list_construct (object_type, GXML_TYPE_DOM_NODE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 345 "../gxml/Node.vala"
	return self;
#line 3010 "Node.c"
}

GXmlNodeList*
gxml_node_list_new (void)
{
#line 345 "../gxml/Node.vala"
	return gxml_node_list_construct (GXML_TYPE_NODE_LIST);
#line 3018 "Node.c"
}

static void
gxml_node_list_class_init (GXmlNodeListClass * klass,
                           gpointer klass_data)
{
#line 345 "../gxml/Node.vala"
	gxml_node_list_parent_class = g_type_class_peek_parent (klass);
#line 345 "../gxml/Node.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gxml_node_list_get_property;
#line 345 "../gxml/Node.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_NODE_LIST_LENGTH_PROPERTY, gxml_node_list_properties[GXML_NODE_LIST_LENGTH_PROPERTY] = g_param_spec_int ("length", "length", "length", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3031 "Node.c"
}

static void
gxml_node_list_gxml_dom_node_list_interface_init (GXmlDomNodeListIface * iface,
                                                  gpointer iface_data)
{
#line 345 "../gxml/Node.vala"
	gxml_node_list_gxml_dom_node_list_parent_iface = g_type_interface_peek_parent (iface);
#line 345 "../gxml/Node.vala"
	iface->item = (GXmlDomNode* (*) (GXmlDomNodeList*, gint)) gxml_node_list_real_item;
#line 345 "../gxml/Node.vala"
	iface->get_length = gxml_node_list_real_get_length;
#line 3044 "Node.c"
}

static void
gxml_node_list_instance_init (GXmlNodeList * self,
                              gpointer klass)
{
}

/**
 * List of {@link DomNode} implementing {@link DomNodeList}
 */
static GType
gxml_node_list_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GXmlNodeListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_node_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GXmlNodeList), 0, (GInstanceInitFunc) gxml_node_list_instance_init, NULL };
	static const GInterfaceInfo gxml_dom_node_list_info = { (GInterfaceInitFunc) gxml_node_list_gxml_dom_node_list_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gxml_node_list_type_id;
	gxml_node_list_type_id = g_type_register_static (GEE_TYPE_ARRAY_LIST, "GXmlNodeList", &g_define_type_info, 0);
	g_type_add_interface_static (gxml_node_list_type_id, GXML_TYPE_DOM_NODE_LIST, &gxml_dom_node_list_info);
	return gxml_node_list_type_id;
}

GType
gxml_node_list_get_type (void)
{
	static volatile gsize gxml_node_list_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_node_list_type_id__volatile)) {
		GType gxml_node_list_type_id;
		gxml_node_list_type_id = gxml_node_list_get_type_once ();
		g_once_init_leave (&gxml_node_list_type_id__volatile, gxml_node_list_type_id);
	}
	return gxml_node_list_type_id__volatile;
}

static void
_vala_gxml_node_list_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	GXmlNodeList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_NODE_LIST, GXmlNodeList);
#line 345 "../gxml/Node.vala"
	switch (property_id) {
#line 345 "../gxml/Node.vala"
		case GXML_NODE_LIST_LENGTH_PROPERTY:
#line 345 "../gxml/Node.vala"
		g_value_set_int (value, gxml_dom_node_list_get_length ((GXmlDomNodeList*) self));
#line 345 "../gxml/Node.vala"
		break;
#line 3095 "Node.c"
		default:
#line 345 "../gxml/Node.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 345 "../gxml/Node.vala"
		break;
#line 3101 "Node.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 27 "../gxml/HtmlDocument.vala"
	if (mem && byte_size != 0) {
#line 27 "../gxml/HtmlDocument.vala"
		new_mem = g_malloc (byte_size);
#line 27 "../gxml/HtmlDocument.vala"
		memcpy (new_mem, mem, byte_size);
#line 3116 "Node.c"
	} else {
#line 27 "../gxml/HtmlDocument.vala"
		new_mem = NULL;
#line 3120 "Node.c"
	}
#line 27 "../gxml/HtmlDocument.vala"
	return new_mem;
#line 3124 "Node.c"
}

