/* Object.c generated by valac 0.54.7, the Vala compiler
 * generated from Object.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; c-basic-offset: 2; tab-width: 2 -*- */
/*
 *
 * Copyright (C) 2016-2019  Daniel Espinosa <esodan@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Daniel Espinosa <esodan@gmail.com>
 */

#include "gxml/gxml.h"
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include "gxml.h"

#define _g_param_spec_unref0(var) ((var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

static GList* gxml_object_real_get_properties_list (GXmlObject* self);
static GParamSpec* gxml_object_real_find_property_name (GXmlObject* self,
                                                 const gchar* nick);
static GParamSpec* gxml_object_real_find_object_property_name (GXmlObject* self,
                                                        const gchar* pname);
static GList* gxml_object_real_get_property_element_list (GXmlObject* self);
static gchar* gxml_object_real_get_property_string (GXmlObject* self,
                                             GParamSpec* prop);
static gchar* gxml_object_real_get_attribute (GXmlObject* self,
                                       const gchar* name);
static GXmlProperty* gxml_object_real_find_property (GXmlObject* self,
                                              const gchar* name);
static gboolean gxml_object_real_set_attribute (GXmlObject* self,
                                         const gchar* name,
                                         const gchar* val);
static GXmlDomElement* gxml_object_real_get_child (GXmlObject* self,
                                            const gchar* name);
static GXmlDomElementList* gxml_object_real_find_elements (GXmlObject* self,
                                                    const gchar* name);
static gboolean gxml_object_real_remove_attribute (GXmlObject* self,
                                            const gchar* name);
static gboolean gxml_object_real_set_instance_property (GXmlObject* self,
                                                 const gchar* name);
static void gxml_object_real_clean_property_elements (GXmlObject* self,
                                               const gchar* name,
                                               GError** error);
static GType gxml_object_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

/**
   * Returns a list with all properties' nick with "::" prefix. Nick name,
   * with "::" prefix will be used on serialization to an attribute's name.
   */
static gpointer
_g_param_spec_ref0 (gpointer self)
{
#line 43 "../gxml/Object.vala"
	return self ? g_param_spec_ref (self) : NULL;
#line 83 "Object.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 102 "Object.c"
}

static GList*
gxml_object_real_get_properties_list (GXmlObject* self)
{
	GList* l = NULL;
	GObjectClass* _tmp0_;
	guint _tmp1_ = 0;
	GParamSpec** _tmp2_;
	GList* result = NULL;
#line 42 "../gxml/Object.vala"
	l = NULL;
#line 43 "../gxml/Object.vala"
	_tmp0_ = G_OBJECT_GET_CLASS ((GObject*) self);
#line 43 "../gxml/Object.vala"
	_tmp2_ = g_object_class_list_properties (_tmp0_, &_tmp1_);
#line 119 "Object.c"
	{
		GParamSpec** spec_collection = NULL;
		gint spec_collection_length1 = 0;
		gint _spec_collection_size_ = 0;
		gint spec_it = 0;
#line 43 "../gxml/Object.vala"
		spec_collection = _tmp2_;
#line 43 "../gxml/Object.vala"
		spec_collection_length1 = _tmp1_;
#line 43 "../gxml/Object.vala"
		for (spec_it = 0; spec_it < spec_collection_length1; spec_it = spec_it + 1) {
#line 131 "Object.c"
			GParamSpec* _tmp3_;
			GParamSpec* spec = NULL;
#line 43 "../gxml/Object.vala"
			_tmp3_ = _g_param_spec_ref0 (spec_collection[spec_it]);
#line 43 "../gxml/Object.vala"
			spec = _tmp3_;
#line 138 "Object.c"
			{
				GParamSpec* _tmp4_;
				const gchar* _tmp5_;
#line 44 "../gxml/Object.vala"
				_tmp4_ = spec;
#line 44 "../gxml/Object.vala"
				_tmp5_ = g_param_spec_get_nick (_tmp4_);
#line 44 "../gxml/Object.vala"
				if (string_contains (_tmp5_, "::")) {
#line 148 "Object.c"
					GParamSpec* _tmp6_;
					GParamSpec* _tmp7_;
#line 48 "../gxml/Object.vala"
					_tmp6_ = spec;
#line 48 "../gxml/Object.vala"
					_tmp7_ = _g_param_spec_ref0 (_tmp6_);
#line 48 "../gxml/Object.vala"
					l = g_list_append (l, _tmp7_);
#line 157 "Object.c"
				}
#line 43 "../gxml/Object.vala"
				_g_param_spec_unref0 (spec);
#line 161 "Object.c"
			}
		}
#line 43 "../gxml/Object.vala"
		spec_collection = (g_free (spec_collection), NULL);
#line 166 "Object.c"
	}
#line 51 "../gxml/Object.vala"
	result = l;
#line 51 "../gxml/Object.vala"
	return result;
#line 172 "Object.c"
}

GList*
gxml_object_get_properties_list (GXmlObject* self)
{
	GXmlObjectIface* _iface_;
#line 41 "../gxml/Object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../gxml/Object.vala"
	_iface_ = GXML_OBJECT_GET_INTERFACE (self);
#line 41 "../gxml/Object.vala"
	if (_iface_->get_properties_list) {
#line 41 "../gxml/Object.vala"
		return _iface_->get_properties_list (self);
#line 187 "Object.c"
	}
#line 41 "../gxml/Object.vala"
	return NULL;
#line 191 "Object.c"
}

/**
   * Returns property's {@link GLib.ParamSpec} based on given nick, without '::'
   * This function is case insensitive.
   *
   * By default any property to be serialized, should set its nick with a prefix
   * '::', while this method requires to avoid '::' for property's name to find.
   * '::' will not be present on serialization output, so you can use any convention
   * for your attribute's name, like using camel case.
   */
static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 222 "Object.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 226 "Object.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 232 "Object.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 236 "Object.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 240 "Object.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 248 "Object.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 276 "Object.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 285 "Object.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 299 "Object.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 308 "Object.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 322 "Object.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 331 "Object.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 340 "Object.c"
}

static GParamSpec*
gxml_object_real_find_property_name (GXmlObject* self,
                                     const gchar* nick)
{
	GObjectClass* _tmp0_;
	guint _tmp1_ = 0;
	GParamSpec** _tmp2_;
	GParamSpec* result = NULL;
#line 62 "../gxml/Object.vala"
	g_return_val_if_fail (nick != NULL, NULL);
#line 63 "../gxml/Object.vala"
	_tmp0_ = G_OBJECT_GET_CLASS ((GObject*) self);
#line 63 "../gxml/Object.vala"
	_tmp2_ = g_object_class_list_properties (_tmp0_, &_tmp1_);
#line 357 "Object.c"
	{
		GParamSpec** spec_collection = NULL;
		gint spec_collection_length1 = 0;
		gint _spec_collection_size_ = 0;
		gint spec_it = 0;
#line 63 "../gxml/Object.vala"
		spec_collection = _tmp2_;
#line 63 "../gxml/Object.vala"
		spec_collection_length1 = _tmp1_;
#line 63 "../gxml/Object.vala"
		for (spec_it = 0; spec_it < spec_collection_length1; spec_it = spec_it + 1) {
#line 369 "Object.c"
			GParamSpec* _tmp3_;
			GParamSpec* spec = NULL;
#line 63 "../gxml/Object.vala"
			_tmp3_ = _g_param_spec_ref0 (spec_collection[spec_it]);
#line 63 "../gxml/Object.vala"
			spec = _tmp3_;
#line 376 "Object.c"
			{
				gchar* name = NULL;
				GParamSpec* _tmp4_;
				const gchar* _tmp5_;
				gchar* _tmp6_;
				const gchar* _tmp7_;
#line 64 "../gxml/Object.vala"
				_tmp4_ = spec;
#line 64 "../gxml/Object.vala"
				_tmp5_ = g_param_spec_get_nick (_tmp4_);
#line 64 "../gxml/Object.vala"
				_tmp6_ = g_strdup (_tmp5_);
#line 64 "../gxml/Object.vala"
				name = _tmp6_;
#line 65 "../gxml/Object.vala"
				_tmp7_ = name;
#line 65 "../gxml/Object.vala"
				if (string_contains (_tmp7_, "::")) {
#line 395 "Object.c"
					const gchar* _tmp8_;
					gchar* _tmp9_;
					const gchar* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					gboolean _tmp15_;
#line 66 "../gxml/Object.vala"
					_tmp8_ = name;
#line 66 "../gxml/Object.vala"
					_tmp9_ = string_replace (_tmp8_, "::", "");
#line 66 "../gxml/Object.vala"
					_g_free0 (name);
#line 66 "../gxml/Object.vala"
					name = _tmp9_;
#line 67 "../gxml/Object.vala"
					_tmp10_ = name;
#line 67 "../gxml/Object.vala"
					_tmp11_ = g_utf8_strdown (_tmp10_, (gssize) -1);
#line 67 "../gxml/Object.vala"
					_tmp12_ = _tmp11_;
#line 67 "../gxml/Object.vala"
					_tmp13_ = g_utf8_strdown (nick, (gssize) -1);
#line 67 "../gxml/Object.vala"
					_tmp14_ = _tmp13_;
#line 67 "../gxml/Object.vala"
					_tmp15_ = g_strcmp0 (_tmp12_, _tmp14_) == 0;
#line 67 "../gxml/Object.vala"
					_g_free0 (_tmp14_);
#line 67 "../gxml/Object.vala"
					_g_free0 (_tmp12_);
#line 67 "../gxml/Object.vala"
					if (_tmp15_) {
#line 68 "../gxml/Object.vala"
						result = spec;
#line 68 "../gxml/Object.vala"
						_g_free0 (name);
#line 68 "../gxml/Object.vala"
						spec_collection = (g_free (spec_collection), NULL);
#line 68 "../gxml/Object.vala"
						return result;
#line 438 "Object.c"
					}
				}
#line 63 "../gxml/Object.vala"
				_g_free0 (name);
#line 63 "../gxml/Object.vala"
				_g_param_spec_unref0 (spec);
#line 445 "Object.c"
			}
		}
#line 63 "../gxml/Object.vala"
		spec_collection = (g_free (spec_collection), NULL);
#line 450 "Object.c"
	}
#line 72 "../gxml/Object.vala"
	result = NULL;
#line 72 "../gxml/Object.vala"
	return result;
#line 456 "Object.c"
}

GParamSpec*
gxml_object_find_property_name (GXmlObject* self,
                                const gchar* nick)
{
	GXmlObjectIface* _iface_;
#line 62 "../gxml/Object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "../gxml/Object.vala"
	_iface_ = GXML_OBJECT_GET_INTERFACE (self);
#line 62 "../gxml/Object.vala"
	if (_iface_->find_property_name) {
#line 62 "../gxml/Object.vala"
		return _iface_->find_property_name (self, nick);
#line 472 "Object.c"
	}
#line 62 "../gxml/Object.vala"
	return NULL;
#line 476 "Object.c"
}

/**
   * Returns a {@link GXml.Object} or a {@link Collection} property's
   * {@link GLib.ParamSpec} based on given name. This method is
   * case insensitive.
   *
   * This method will check if nick's name is equal than given name
   * in order to avoid use canonical names like "your-name" if your
   * property is your_name; so you can use nick to "YourName" to find
   * and instantiate it.
   */
static GParamSpec*
gxml_object_real_find_object_property_name (GXmlObject* self,
                                            const gchar* pname)
{
	GObjectClass* _tmp0_;
	guint _tmp1_ = 0;
	GParamSpec** _tmp2_;
	GParamSpec* result = NULL;
#line 84 "../gxml/Object.vala"
	g_return_val_if_fail (pname != NULL, NULL);
#line 85 "../gxml/Object.vala"
	_tmp0_ = G_OBJECT_GET_CLASS ((GObject*) self);
#line 85 "../gxml/Object.vala"
	_tmp2_ = g_object_class_list_properties (_tmp0_, &_tmp1_);
#line 503 "Object.c"
	{
		GParamSpec** spec_collection = NULL;
		gint spec_collection_length1 = 0;
		gint _spec_collection_size_ = 0;
		gint spec_it = 0;
#line 85 "../gxml/Object.vala"
		spec_collection = _tmp2_;
#line 85 "../gxml/Object.vala"
		spec_collection_length1 = _tmp1_;
#line 85 "../gxml/Object.vala"
		for (spec_it = 0; spec_it < spec_collection_length1; spec_it = spec_it + 1) {
#line 515 "Object.c"
			GParamSpec* _tmp3_;
			GParamSpec* spec = NULL;
#line 85 "../gxml/Object.vala"
			_tmp3_ = _g_param_spec_ref0 (spec_collection[spec_it]);
#line 85 "../gxml/Object.vala"
			spec = _tmp3_;
#line 522 "Object.c"
			{
				gchar* name = NULL;
				gchar* _tmp4_;
				const gchar* _tmp5_;
				gchar* nick = NULL;
				GParamSpec* _tmp8_;
				const gchar* _tmp9_;
				gchar* _tmp10_;
				const gchar* _tmp11_;
				gchar* sname = NULL;
				GParamSpec* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
				gboolean _tmp17_ = FALSE;
				const gchar* _tmp18_;
				const gchar* _tmp19_;
#line 86 "../gxml/Object.vala"
				_tmp4_ = g_utf8_strdown (pname, (gssize) -1);
#line 86 "../gxml/Object.vala"
				name = _tmp4_;
#line 87 "../gxml/Object.vala"
				_tmp5_ = name;
#line 87 "../gxml/Object.vala"
				if (string_contains (_tmp5_, "::")) {
#line 547 "Object.c"
					const gchar* _tmp6_;
					gchar* _tmp7_;
#line 87 "../gxml/Object.vala"
					_tmp6_ = name;
#line 87 "../gxml/Object.vala"
					_tmp7_ = string_replace (_tmp6_, "::", "");
#line 87 "../gxml/Object.vala"
					_g_free0 (name);
#line 87 "../gxml/Object.vala"
					name = _tmp7_;
#line 558 "Object.c"
				}
#line 88 "../gxml/Object.vala"
				_tmp8_ = spec;
#line 88 "../gxml/Object.vala"
				_tmp9_ = g_param_spec_get_nick (_tmp8_);
#line 88 "../gxml/Object.vala"
				_tmp10_ = g_utf8_strdown (_tmp9_, (gssize) -1);
#line 88 "../gxml/Object.vala"
				nick = _tmp10_;
#line 89 "../gxml/Object.vala"
				_tmp11_ = nick;
#line 89 "../gxml/Object.vala"
				if (string_contains (_tmp11_, "::")) {
#line 572 "Object.c"
					const gchar* _tmp12_;
					gchar* _tmp13_;
#line 89 "../gxml/Object.vala"
					_tmp12_ = nick;
#line 89 "../gxml/Object.vala"
					_tmp13_ = string_replace (_tmp12_, "::", "");
#line 89 "../gxml/Object.vala"
					_g_free0 (nick);
#line 89 "../gxml/Object.vala"
					nick = _tmp13_;
#line 583 "Object.c"
				}
#line 90 "../gxml/Object.vala"
				_tmp14_ = spec;
#line 90 "../gxml/Object.vala"
				_tmp15_ = _tmp14_->name;
#line 90 "../gxml/Object.vala"
				_tmp16_ = g_utf8_strdown (_tmp15_, (gssize) -1);
#line 90 "../gxml/Object.vala"
				sname = _tmp16_;
#line 91 "../gxml/Object.vala"
				_tmp18_ = sname;
#line 91 "../gxml/Object.vala"
				_tmp19_ = name;
#line 91 "../gxml/Object.vala"
				if (g_strcmp0 (_tmp18_, _tmp19_) == 0) {
#line 91 "../gxml/Object.vala"
					_tmp17_ = TRUE;
#line 601 "Object.c"
				} else {
					const gchar* _tmp20_;
					const gchar* _tmp21_;
#line 91 "../gxml/Object.vala"
					_tmp20_ = nick;
#line 91 "../gxml/Object.vala"
					_tmp21_ = name;
#line 91 "../gxml/Object.vala"
					_tmp17_ = g_strcmp0 (_tmp20_, _tmp21_) == 0;
#line 611 "Object.c"
				}
#line 91 "../gxml/Object.vala"
				if (_tmp17_) {
#line 615 "Object.c"
					gboolean _tmp22_ = FALSE;
					GParamSpec* _tmp23_;
#line 92 "../gxml/Object.vala"
					_tmp23_ = spec;
#line 92 "../gxml/Object.vala"
					if (g_type_is_a (_tmp23_->value_type, GXML_TYPE_OBJECT)) {
#line 92 "../gxml/Object.vala"
						_tmp22_ = TRUE;
#line 624 "Object.c"
					} else {
						GParamSpec* _tmp24_;
#line 93 "../gxml/Object.vala"
						_tmp24_ = spec;
#line 93 "../gxml/Object.vala"
						_tmp22_ = g_type_is_a (_tmp24_->value_type, GXML_TYPE_COLLECTION);
#line 631 "Object.c"
					}
#line 92 "../gxml/Object.vala"
					if (_tmp22_) {
#line 97 "../gxml/Object.vala"
						result = spec;
#line 97 "../gxml/Object.vala"
						_g_free0 (sname);
#line 97 "../gxml/Object.vala"
						_g_free0 (nick);
#line 97 "../gxml/Object.vala"
						_g_free0 (name);
#line 97 "../gxml/Object.vala"
						spec_collection = (g_free (spec_collection), NULL);
#line 97 "../gxml/Object.vala"
						return result;
#line 647 "Object.c"
					}
				}
#line 85 "../gxml/Object.vala"
				_g_free0 (sname);
#line 85 "../gxml/Object.vala"
				_g_free0 (nick);
#line 85 "../gxml/Object.vala"
				_g_free0 (name);
#line 85 "../gxml/Object.vala"
				_g_param_spec_unref0 (spec);
#line 658 "Object.c"
			}
		}
#line 85 "../gxml/Object.vala"
		spec_collection = (g_free (spec_collection), NULL);
#line 663 "Object.c"
	}
#line 101 "../gxml/Object.vala"
	result = NULL;
#line 101 "../gxml/Object.vala"
	return result;
#line 669 "Object.c"
}

GParamSpec*
gxml_object_find_object_property_name (GXmlObject* self,
                                       const gchar* pname)
{
	GXmlObjectIface* _iface_;
#line 84 "../gxml/Object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 84 "../gxml/Object.vala"
	_iface_ = GXML_OBJECT_GET_INTERFACE (self);
#line 84 "../gxml/Object.vala"
	if (_iface_->find_object_property_name) {
#line 84 "../gxml/Object.vala"
		return _iface_->find_object_property_name (self, pname);
#line 685 "Object.c"
	}
#line 84 "../gxml/Object.vala"
	return NULL;
#line 689 "Object.c"
}

/**
   * Returns a list of names for all {@link DomElement}
   * present as object's properties.
   */
static GList*
gxml_object_real_get_property_element_list (GXmlObject* self)
{
	GList* l = NULL;
	GObjectClass* _tmp0_;
	guint _tmp1_ = 0;
	GParamSpec** _tmp2_;
	GList* result = NULL;
#line 108 "../gxml/Object.vala"
	l = NULL;
#line 109 "../gxml/Object.vala"
	_tmp0_ = G_OBJECT_GET_CLASS ((GObject*) self);
#line 109 "../gxml/Object.vala"
	_tmp2_ = g_object_class_list_properties (_tmp0_, &_tmp1_);
#line 710 "Object.c"
	{
		GParamSpec** spec_collection = NULL;
		gint spec_collection_length1 = 0;
		gint _spec_collection_size_ = 0;
		gint spec_it = 0;
#line 109 "../gxml/Object.vala"
		spec_collection = _tmp2_;
#line 109 "../gxml/Object.vala"
		spec_collection_length1 = _tmp1_;
#line 109 "../gxml/Object.vala"
		for (spec_it = 0; spec_it < spec_collection_length1; spec_it = spec_it + 1) {
#line 722 "Object.c"
			GParamSpec* _tmp3_;
			GParamSpec* spec = NULL;
#line 109 "../gxml/Object.vala"
			_tmp3_ = _g_param_spec_ref0 (spec_collection[spec_it]);
#line 109 "../gxml/Object.vala"
			spec = _tmp3_;
#line 729 "Object.c"
			{
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
				GParamSpec* _tmp6_;
#line 110 "../gxml/Object.vala"
				_tmp6_ = spec;
#line 110 "../gxml/Object.vala"
				if (g_type_is_a (_tmp6_->value_type, GXML_TYPE_OBJECT)) {
#line 110 "../gxml/Object.vala"
					_tmp5_ = TRUE;
#line 740 "Object.c"
				} else {
					GParamSpec* _tmp7_;
#line 111 "../gxml/Object.vala"
					_tmp7_ = spec;
#line 111 "../gxml/Object.vala"
					_tmp5_ = g_type_is_a (_tmp7_->value_type, GXML_TYPE_COLLECTION);
#line 747 "Object.c"
				}
#line 110 "../gxml/Object.vala"
				if (_tmp5_) {
#line 751 "Object.c"
					GParamSpec* _tmp8_;
#line 112 "../gxml/Object.vala"
					_tmp8_ = spec;
#line 112 "../gxml/Object.vala"
					_tmp4_ = G_TYPE_IS_INSTANTIATABLE (_tmp8_->value_type);
#line 757 "Object.c"
				} else {
#line 110 "../gxml/Object.vala"
					_tmp4_ = FALSE;
#line 761 "Object.c"
				}
#line 110 "../gxml/Object.vala"
				if (_tmp4_) {
#line 765 "Object.c"
					GParamSpec* _tmp9_;
					GParamSpec* _tmp10_;
#line 116 "../gxml/Object.vala"
					_tmp9_ = spec;
#line 116 "../gxml/Object.vala"
					_tmp10_ = _g_param_spec_ref0 (_tmp9_);
#line 116 "../gxml/Object.vala"
					l = g_list_append (l, _tmp10_);
#line 774 "Object.c"
				}
#line 109 "../gxml/Object.vala"
				_g_param_spec_unref0 (spec);
#line 778 "Object.c"
			}
		}
#line 109 "../gxml/Object.vala"
		spec_collection = (g_free (spec_collection), NULL);
#line 783 "Object.c"
	}
#line 119 "../gxml/Object.vala"
	result = l;
#line 119 "../gxml/Object.vala"
	return result;
#line 789 "Object.c"
}

GList*
gxml_object_get_property_element_list (GXmlObject* self)
{
	GXmlObjectIface* _iface_;
#line 107 "../gxml/Object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 107 "../gxml/Object.vala"
	_iface_ = GXML_OBJECT_GET_INTERFACE (self);
#line 107 "../gxml/Object.vala"
	if (_iface_->get_property_element_list) {
#line 107 "../gxml/Object.vala"
		return _iface_->get_property_element_list (self);
#line 804 "Object.c"
	}
#line 107 "../gxml/Object.vala"
	return NULL;
#line 808 "Object.c"
}

/**
   * Returns an string representation of an Object's property.
   */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 131 "../gxml/Object.vala"
	return self ? g_object_ref (self) : NULL;
#line 819 "Object.c"
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result = NULL;
#line 989 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 989 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 989 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 989 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 989 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 989 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 989 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 989 "glib-2.0.vapi"
	result = _tmp4_;
#line 989 "glib-2.0.vapi"
	return result;
#line 850 "Object.c"
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result = NULL;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 859 "Object.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 867 "Object.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 876 "Object.c"
	}
}

static gchar*
gxml_object_real_get_property_string (GXmlObject* self,
                                      GParamSpec* prop)
{
	GValue v = {0};
	GValue _tmp0_ = {0};
	const gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 124 "../gxml/Object.vala"
	g_return_val_if_fail (prop != NULL, NULL);
#line 125 "../gxml/Object.vala"
	g_value_init (&_tmp0_, prop->value_type);
#line 125 "../gxml/Object.vala"
	v = _tmp0_;
#line 126 "../gxml/Object.vala"
	_tmp1_ = prop->name;
#line 126 "../gxml/Object.vala"
	g_object_get_property ((GObject*) self, _tmp1_, &v);
#line 127 "../gxml/Object.vala"
	if (g_type_is_a (prop->value_type, GXML_TYPE_PROPERTY)) {
#line 901 "Object.c"
		GObject* so = NULL;
		GObject* _tmp2_;
		GObject* _tmp3_;
		GObject* _tmp4_;
		GObject* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 131 "../gxml/Object.vala"
		_tmp2_ = g_value_get_object (&v);
#line 131 "../gxml/Object.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 131 "../gxml/Object.vala"
		so = _tmp3_;
#line 132 "../gxml/Object.vala"
		_tmp4_ = so;
#line 132 "../gxml/Object.vala"
		if (_tmp4_ == NULL) {
#line 136 "../gxml/Object.vala"
			result = NULL;
#line 136 "../gxml/Object.vala"
			_g_object_unref0 (so);
#line 136 "../gxml/Object.vala"
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 136 "../gxml/Object.vala"
			return result;
#line 927 "Object.c"
		}
#line 145 "../gxml/Object.vala"
		_tmp5_ = so;
#line 145 "../gxml/Object.vala"
		_tmp6_ = gxml_property_get_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GXML_TYPE_PROPERTY, GXmlProperty));
#line 145 "../gxml/Object.vala"
		_tmp7_ = _tmp6_;
#line 145 "../gxml/Object.vala"
		result = _tmp7_;
#line 145 "../gxml/Object.vala"
		_g_object_unref0 (so);
#line 145 "../gxml/Object.vala"
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 145 "../gxml/Object.vala"
		return result;
#line 943 "Object.c"
	}
#line 147 "../gxml/Object.vala"
	if (g_type_is_a (prop->value_type, G_TYPE_STRING)) {
#line 947 "Object.c"
		GValue _tmp8_;
		gchar* _tmp9_;
#line 148 "../gxml/Object.vala"
		_tmp8_ = v;
#line 148 "../gxml/Object.vala"
		_tmp9_ = g_strdup (g_value_get_string (&_tmp8_));
#line 148 "../gxml/Object.vala"
		result = _tmp9_;
#line 148 "../gxml/Object.vala"
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 148 "../gxml/Object.vala"
		return result;
#line 960 "Object.c"
	}
#line 150 "../gxml/Object.vala"
	if (g_type_is_a (prop->value_type, G_TYPE_INT)) {
#line 964 "Object.c"
		GValue _tmp10_;
		gchar* _tmp11_;
#line 151 "../gxml/Object.vala"
		_tmp10_ = v;
#line 151 "../gxml/Object.vala"
		_tmp11_ = g_strdup_printf ("%i", g_value_get_int (&_tmp10_));
#line 151 "../gxml/Object.vala"
		result = _tmp11_;
#line 151 "../gxml/Object.vala"
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 151 "../gxml/Object.vala"
		return result;
#line 977 "Object.c"
	}
#line 153 "../gxml/Object.vala"
	if (g_type_is_a (prop->value_type, G_TYPE_UINT)) {
#line 981 "Object.c"
		GValue _tmp12_;
		gchar* _tmp13_;
#line 154 "../gxml/Object.vala"
		_tmp12_ = v;
#line 154 "../gxml/Object.vala"
		_tmp13_ = g_strdup_printf ("%u", g_value_get_uint (&_tmp12_));
#line 154 "../gxml/Object.vala"
		result = _tmp13_;
#line 154 "../gxml/Object.vala"
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 154 "../gxml/Object.vala"
		return result;
#line 994 "Object.c"
	}
#line 156 "../gxml/Object.vala"
	if (g_type_is_a (prop->value_type, G_TYPE_FLOAT)) {
#line 998 "Object.c"
		GValue _tmp14_;
		gchar* _tmp15_;
#line 157 "../gxml/Object.vala"
		_tmp14_ = v;
#line 157 "../gxml/Object.vala"
		_tmp15_ = g_strdup_printf ("%g", g_value_get_float (&_tmp14_));
#line 157 "../gxml/Object.vala"
		result = _tmp15_;
#line 157 "../gxml/Object.vala"
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 157 "../gxml/Object.vala"
		return result;
#line 1011 "Object.c"
	}
#line 159 "../gxml/Object.vala"
	if (g_type_is_a (prop->value_type, G_TYPE_DOUBLE)) {
#line 1015 "Object.c"
		GValue _tmp16_;
		gchar* _tmp17_;
#line 160 "../gxml/Object.vala"
		_tmp16_ = v;
#line 160 "../gxml/Object.vala"
		_tmp17_ = double_to_string (g_value_get_double (&_tmp16_));
#line 160 "../gxml/Object.vala"
		result = _tmp17_;
#line 160 "../gxml/Object.vala"
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 160 "../gxml/Object.vala"
		return result;
#line 1028 "Object.c"
	}
#line 162 "../gxml/Object.vala"
	if (g_type_is_a (prop->value_type, G_TYPE_BOOLEAN)) {
#line 1032 "Object.c"
		GValue _tmp18_;
		gchar* _tmp19_;
#line 163 "../gxml/Object.vala"
		_tmp18_ = v;
#line 163 "../gxml/Object.vala"
		_tmp19_ = bool_to_string (g_value_get_boolean (&_tmp18_));
#line 163 "../gxml/Object.vala"
		result = _tmp19_;
#line 163 "../gxml/Object.vala"
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 163 "../gxml/Object.vala"
		return result;
#line 1045 "Object.c"
	}
#line 165 "../gxml/Object.vala"
	if (g_type_is_a (prop->value_type, G_TYPE_ENUM)) {
#line 1049 "Object.c"
		gint n = 0;
#line 166 "../gxml/Object.vala"
		n = g_value_get_enum (&v);
#line 1053 "Object.c"
		{
			gchar* _tmp20_ = NULL;
			gchar* _tmp21_;
			gchar* _tmp22_;
#line 168 "../gxml/Object.vala"
			_tmp21_ = gxml_enumeration_get_string (prop->value_type, n, TRUE, TRUE, &_inner_error0_);
#line 168 "../gxml/Object.vala"
			_tmp20_ = _tmp21_;
#line 168 "../gxml/Object.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1064 "Object.c"
				goto __catch0_g_error;
			}
#line 168 "../gxml/Object.vala"
			_tmp22_ = _tmp20_;
#line 168 "../gxml/Object.vala"
			_tmp20_ = NULL;
#line 168 "../gxml/Object.vala"
			result = _tmp22_;
#line 168 "../gxml/Object.vala"
			_g_free0 (_tmp20_);
#line 168 "../gxml/Object.vala"
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 168 "../gxml/Object.vala"
			return result;
#line 1079 "Object.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 167 "../gxml/Object.vala"
			g_clear_error (&_inner_error0_);
#line 170 "../gxml/Object.vala"
			g_warning ("Object.vala:170: %s", _ ("Enumeration is out of range"));
#line 1088 "Object.c"
		}
		__finally0:
#line 167 "../gxml/Object.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 167 "../gxml/Object.vala"
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 167 "../gxml/Object.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 167 "../gxml/Object.vala"
			g_clear_error (&_inner_error0_);
#line 167 "../gxml/Object.vala"
			return NULL;
#line 1101 "Object.c"
		}
	}
#line 173 "../gxml/Object.vala"
	result = NULL;
#line 173 "../gxml/Object.vala"
	G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 173 "../gxml/Object.vala"
	return result;
#line 1110 "Object.c"
}

gchar*
gxml_object_get_property_string (GXmlObject* self,
                                 GParamSpec* prop)
{
	GXmlObjectIface* _iface_;
#line 124 "../gxml/Object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 124 "../gxml/Object.vala"
	_iface_ = GXML_OBJECT_GET_INTERFACE (self);
#line 124 "../gxml/Object.vala"
	if (_iface_->get_property_string) {
#line 124 "../gxml/Object.vala"
		return _iface_->get_property_string (self, prop);
#line 1126 "Object.c"
	}
#line 124 "../gxml/Object.vala"
	return NULL;
#line 1130 "Object.c"
}

/**
   * Search for properties in objects, it should be
   * an {@link GLib.Object}'s property. If found a
   * property with given name its value is returned
   * as string representation.
   *
   * If property is a {@link GXml.Property}
   * returned value is a string representation according
   * with object implementation.
   *
   * If given property name is not found, then {@link DomElement.get_attribute}
   * is called.
   *
   * By default all {@link GLib.Object} are children of
   * this object, see {@link get_child}
   */
static gchar*
gxml_object_real_get_attribute (GXmlObject* self,
                                const gchar* name)
{
	GParamSpec* prop = NULL;
	GParamSpec* _tmp0_;
	GParamSpec* _tmp1_;
	GParamSpec* _tmp2_;
	gchar* _tmp3_;
	gchar* result = NULL;
#line 191 "../gxml/Object.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 192 "../gxml/Object.vala"
	_tmp0_ = gxml_object_find_property_name (self, name);
#line 192 "../gxml/Object.vala"
	prop = _tmp0_;
#line 193 "../gxml/Object.vala"
	_tmp1_ = prop;
#line 193 "../gxml/Object.vala"
	if (_tmp1_ == NULL) {
#line 193 "../gxml/Object.vala"
		result = NULL;
#line 193 "../gxml/Object.vala"
		_g_param_spec_unref0 (prop);
#line 193 "../gxml/Object.vala"
		return result;
#line 1175 "Object.c"
	}
#line 194 "../gxml/Object.vala"
	_tmp2_ = prop;
#line 194 "../gxml/Object.vala"
	_tmp3_ = gxml_object_get_property_string (self, _tmp2_);
#line 194 "../gxml/Object.vala"
	result = _tmp3_;
#line 194 "../gxml/Object.vala"
	_g_param_spec_unref0 (prop);
#line 194 "../gxml/Object.vala"
	return result;
#line 1187 "Object.c"
}

gchar*
gxml_object_get_attribute (GXmlObject* self,
                           const gchar* name)
{
	GXmlObjectIface* _iface_;
#line 191 "../gxml/Object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 191 "../gxml/Object.vala"
	_iface_ = GXML_OBJECT_GET_INTERFACE (self);
#line 191 "../gxml/Object.vala"
	if (_iface_->get_attribute) {
#line 191 "../gxml/Object.vala"
		return _iface_->get_attribute (self, name);
#line 1203 "Object.c"
	}
#line 191 "../gxml/Object.vala"
	return NULL;
#line 1207 "Object.c"
}

/**
   * Search for a property of type {@link GXml.Property}
   * and returns it as object
   */
static GXmlProperty*
gxml_object_real_find_property (GXmlObject* self,
                                const gchar* name)
{
	GParamSpec* prop = NULL;
	GParamSpec* _tmp0_;
	GParamSpec* _tmp1_;
	GXmlProperty* result = NULL;
#line 200 "../gxml/Object.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 201 "../gxml/Object.vala"
	_tmp0_ = gxml_object_find_property_name (self, name);
#line 201 "../gxml/Object.vala"
	prop = _tmp0_;
#line 202 "../gxml/Object.vala"
	_tmp1_ = prop;
#line 202 "../gxml/Object.vala"
	if (_tmp1_ != NULL) {
#line 1232 "Object.c"
		GValue v = {0};
		GParamSpec* _tmp2_;
		GValue _tmp3_ = {0};
		gboolean _tmp4_ = FALSE;
		GParamSpec* _tmp5_;
#line 203 "../gxml/Object.vala"
		_tmp2_ = prop;
#line 203 "../gxml/Object.vala"
		g_value_init (&_tmp3_, _tmp2_->value_type);
#line 203 "../gxml/Object.vala"
		v = _tmp3_;
#line 204 "../gxml/Object.vala"
		_tmp5_ = prop;
#line 204 "../gxml/Object.vala"
		if (g_type_is_a (_tmp5_->value_type, GXML_TYPE_PROPERTY)) {
#line 1248 "Object.c"
			GParamSpec* _tmp6_;
#line 205 "../gxml/Object.vala"
			_tmp6_ = prop;
#line 205 "../gxml/Object.vala"
			_tmp4_ = G_TYPE_IS_INSTANTIATABLE (_tmp6_->value_type);
#line 1254 "Object.c"
		} else {
#line 204 "../gxml/Object.vala"
			_tmp4_ = FALSE;
#line 1258 "Object.c"
		}
#line 204 "../gxml/Object.vala"
		if (_tmp4_) {
#line 1262 "Object.c"
			GParamSpec* _tmp7_;
			const gchar* _tmp8_;
			GXmlProperty* so = NULL;
			GValue _tmp9_;
			GXmlObject* _tmp10_;
			GXmlProperty* _tmp11_;
			GXmlProperty* _tmp12_;
#line 206 "../gxml/Object.vala"
			_tmp7_ = prop;
#line 206 "../gxml/Object.vala"
			_tmp8_ = _tmp7_->name;
#line 206 "../gxml/Object.vala"
			g_object_get_property ((GObject*) self, _tmp8_, &v);
#line 207 "../gxml/Object.vala"
			_tmp9_ = v;
#line 207 "../gxml/Object.vala"
			_tmp10_ = g_value_get_object (&_tmp9_);
#line 207 "../gxml/Object.vala"
			_tmp11_ = _g_object_ref0 (GXML_IS_PROPERTY (_tmp10_) ? ((GXmlProperty*) _tmp10_) : NULL);
#line 207 "../gxml/Object.vala"
			so = _tmp11_;
#line 208 "../gxml/Object.vala"
			_tmp12_ = so;
#line 208 "../gxml/Object.vala"
			if (_tmp12_ == NULL) {
#line 1288 "Object.c"
				GObject* obj = NULL;
				GParamSpec* _tmp13_;
				GObject* _tmp14_;
				GObject* _tmp15_;
				GObject* _tmp16_;
				GParamSpec* _tmp17_;
				const gchar* _tmp18_;
				GValue _tmp19_;
				GObject* _tmp20_;
				GXmlProperty* _tmp21_;
#line 209 "../gxml/Object.vala"
				_tmp13_ = prop;
#line 209 "../gxml/Object.vala"
				_tmp14_ = g_object_new (_tmp13_->value_type, NULL);
#line 209 "../gxml/Object.vala"
				_tmp15_ = G_IS_INITIALLY_UNOWNED (_tmp14_) ? g_object_ref_sink (_tmp14_) : _tmp14_;
#line 209 "../gxml/Object.vala"
				obj = _tmp15_;
#line 210 "../gxml/Object.vala"
				_tmp16_ = obj;
#line 210 "../gxml/Object.vala"
				g_value_set_object (&v, _tmp16_);
#line 211 "../gxml/Object.vala"
				_tmp17_ = prop;
#line 211 "../gxml/Object.vala"
				_tmp18_ = _tmp17_->name;
#line 211 "../gxml/Object.vala"
				_tmp19_ = v;
#line 211 "../gxml/Object.vala"
				g_object_set_property ((GObject*) self, _tmp18_, &_tmp19_);
#line 212 "../gxml/Object.vala"
				_tmp20_ = obj;
#line 212 "../gxml/Object.vala"
				_tmp21_ = _g_object_ref0 (GXML_IS_PROPERTY (_tmp20_) ? ((GXmlProperty*) _tmp20_) : NULL);
#line 212 "../gxml/Object.vala"
				_g_object_unref0 (so);
#line 212 "../gxml/Object.vala"
				so = _tmp21_;
#line 209 "../gxml/Object.vala"
				_g_object_unref0 (obj);
#line 1329 "Object.c"
			}
#line 214 "../gxml/Object.vala"
			result = so;
#line 214 "../gxml/Object.vala"
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 214 "../gxml/Object.vala"
			_g_param_spec_unref0 (prop);
#line 214 "../gxml/Object.vala"
			return result;
#line 1339 "Object.c"
		}
#line 204 "../gxml/Object.vala"
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 1343 "Object.c"
	}
#line 217 "../gxml/Object.vala"
	result = NULL;
#line 217 "../gxml/Object.vala"
	_g_param_spec_unref0 (prop);
#line 217 "../gxml/Object.vala"
	return result;
#line 1351 "Object.c"
}

GXmlProperty*
gxml_object_find_property (GXmlObject* self,
                           const gchar* name)
{
	GXmlObjectIface* _iface_;
#line 202 "../gxml/Object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 202 "../gxml/Object.vala"
	_iface_ = GXML_OBJECT_GET_INTERFACE (self);
#line 202 "../gxml/Object.vala"
	if (_iface_->find_property) {
#line 202 "../gxml/Object.vala"
		return _iface_->find_property (self, name);
#line 1367 "Object.c"
	}
#line 202 "../gxml/Object.vala"
	return NULL;
#line 1371 "Object.c"
}

/**
   * Search for a {@link GLib.Object} property with
   * given name, if found, given string representation
   * is used as value to property, using any required
   * transformation from string.
   *
   * By default all {@link GLib.Object} are children of
   * this object.
   */
static gdouble
double_parse (const gchar* str)
{
	gdouble result = 0.0;
#line 995 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 996 "glib-2.0.vapi"
	result = g_ascii_strtod (str, NULL);
#line 996 "glib-2.0.vapi"
	return result;
#line 1393 "Object.c"
}

static gboolean
bool_parse (const gchar* str)
{
	gboolean result = FALSE;
#line 44 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 45 "glib-2.0.vapi"
	if (g_strcmp0 (str, "true") == 0) {
#line 46 "glib-2.0.vapi"
		result = TRUE;
#line 46 "glib-2.0.vapi"
		return result;
#line 1408 "Object.c"
	} else {
#line 48 "glib-2.0.vapi"
		result = FALSE;
#line 48 "glib-2.0.vapi"
		return result;
#line 1414 "Object.c"
	}
}

static gboolean
gxml_object_real_set_attribute (GXmlObject* self,
                                const gchar* name,
                                const gchar* val)
{
	GParamSpec* prop = NULL;
	GParamSpec* _tmp0_;
	GParamSpec* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 228 "../gxml/Object.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 228 "../gxml/Object.vala"
	g_return_val_if_fail (val != NULL, FALSE);
#line 229 "../gxml/Object.vala"
	_tmp0_ = gxml_object_find_property_name (self, name);
#line 229 "../gxml/Object.vala"
	prop = _tmp0_;
#line 230 "../gxml/Object.vala"
	_tmp1_ = prop;
#line 230 "../gxml/Object.vala"
	if (_tmp1_ != NULL) {
#line 1440 "Object.c"
		GValue v = {0};
		GParamSpec* _tmp2_;
		GValue _tmp3_ = {0};
		gboolean _tmp4_ = FALSE;
		GParamSpec* _tmp5_;
		GParamSpec* _tmp23_;
		GParamSpec* _tmp27_;
		GParamSpec* _tmp31_;
		GParamSpec* _tmp35_;
		GParamSpec* _tmp39_;
		GParamSpec* _tmp43_;
		GParamSpec* _tmp47_;
#line 231 "../gxml/Object.vala"
		_tmp2_ = prop;
#line 231 "../gxml/Object.vala"
		g_value_init (&_tmp3_, _tmp2_->value_type);
#line 231 "../gxml/Object.vala"
		v = _tmp3_;
#line 232 "../gxml/Object.vala"
		_tmp5_ = prop;
#line 232 "../gxml/Object.vala"
		if (g_type_is_a (_tmp5_->value_type, GXML_TYPE_PROPERTY)) {
#line 1463 "Object.c"
			GParamSpec* _tmp6_;
#line 233 "../gxml/Object.vala"
			_tmp6_ = prop;
#line 233 "../gxml/Object.vala"
			_tmp4_ = G_TYPE_IS_INSTANTIATABLE (_tmp6_->value_type);
#line 1469 "Object.c"
		} else {
#line 232 "../gxml/Object.vala"
			_tmp4_ = FALSE;
#line 1473 "Object.c"
		}
#line 232 "../gxml/Object.vala"
		if (_tmp4_) {
#line 1477 "Object.c"
			GParamSpec* _tmp7_;
			const gchar* _tmp8_;
			GXmlProperty* so = NULL;
			GValue _tmp9_;
			GXmlObject* _tmp10_;
			GXmlProperty* _tmp11_;
			GXmlProperty* _tmp12_;
			GXmlProperty* _tmp22_;
#line 234 "../gxml/Object.vala"
			_tmp7_ = prop;
#line 234 "../gxml/Object.vala"
			_tmp8_ = _tmp7_->name;
#line 234 "../gxml/Object.vala"
			g_object_get_property ((GObject*) self, _tmp8_, &v);
#line 235 "../gxml/Object.vala"
			_tmp9_ = v;
#line 235 "../gxml/Object.vala"
			_tmp10_ = g_value_get_object (&_tmp9_);
#line 235 "../gxml/Object.vala"
			_tmp11_ = _g_object_ref0 (GXML_IS_PROPERTY (_tmp10_) ? ((GXmlProperty*) _tmp10_) : NULL);
#line 235 "../gxml/Object.vala"
			so = _tmp11_;
#line 236 "../gxml/Object.vala"
			_tmp12_ = so;
#line 236 "../gxml/Object.vala"
			if (_tmp12_ == NULL) {
#line 1504 "Object.c"
				GObject* obj = NULL;
				GParamSpec* _tmp13_;
				GObject* _tmp14_;
				GObject* _tmp15_;
				GObject* _tmp16_;
				GParamSpec* _tmp17_;
				const gchar* _tmp18_;
				GValue _tmp19_;
				GObject* _tmp20_;
				GXmlProperty* _tmp21_;
#line 237 "../gxml/Object.vala"
				_tmp13_ = prop;
#line 237 "../gxml/Object.vala"
				_tmp14_ = g_object_new (_tmp13_->value_type, NULL);
#line 237 "../gxml/Object.vala"
				_tmp15_ = G_IS_INITIALLY_UNOWNED (_tmp14_) ? g_object_ref_sink (_tmp14_) : _tmp14_;
#line 237 "../gxml/Object.vala"
				obj = _tmp15_;
#line 238 "../gxml/Object.vala"
				_tmp16_ = obj;
#line 238 "../gxml/Object.vala"
				g_value_set_object (&v, _tmp16_);
#line 239 "../gxml/Object.vala"
				_tmp17_ = prop;
#line 239 "../gxml/Object.vala"
				_tmp18_ = _tmp17_->name;
#line 239 "../gxml/Object.vala"
				_tmp19_ = v;
#line 239 "../gxml/Object.vala"
				g_object_set_property ((GObject*) self, _tmp18_, &_tmp19_);
#line 240 "../gxml/Object.vala"
				_tmp20_ = obj;
#line 240 "../gxml/Object.vala"
				_tmp21_ = _g_object_ref0 (GXML_IS_PROPERTY (_tmp20_) ? ((GXmlProperty*) _tmp20_) : NULL);
#line 240 "../gxml/Object.vala"
				_g_object_unref0 (so);
#line 240 "../gxml/Object.vala"
				so = _tmp21_;
#line 237 "../gxml/Object.vala"
				_g_object_unref0 (obj);
#line 1545 "Object.c"
			}
#line 242 "../gxml/Object.vala"
			_tmp22_ = so;
#line 242 "../gxml/Object.vala"
			gxml_property_set_value (_tmp22_, val);
#line 243 "../gxml/Object.vala"
			result = TRUE;
#line 243 "../gxml/Object.vala"
			_g_object_unref0 (so);
#line 243 "../gxml/Object.vala"
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 243 "../gxml/Object.vala"
			_g_param_spec_unref0 (prop);
#line 243 "../gxml/Object.vala"
			return result;
#line 1561 "Object.c"
		}
#line 245 "../gxml/Object.vala"
		_tmp23_ = prop;
#line 245 "../gxml/Object.vala"
		if (g_type_is_a (_tmp23_->value_type, G_TYPE_STRING)) {
#line 1567 "Object.c"
			GParamSpec* _tmp24_;
			const gchar* _tmp25_;
			GValue _tmp26_;
#line 246 "../gxml/Object.vala"
			g_value_set_string (&v, val);
#line 247 "../gxml/Object.vala"
			_tmp24_ = prop;
#line 247 "../gxml/Object.vala"
			_tmp25_ = _tmp24_->name;
#line 247 "../gxml/Object.vala"
			_tmp26_ = v;
#line 247 "../gxml/Object.vala"
			g_object_set_property ((GObject*) self, _tmp25_, &_tmp26_);
#line 248 "../gxml/Object.vala"
			result = TRUE;
#line 248 "../gxml/Object.vala"
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 248 "../gxml/Object.vala"
			_g_param_spec_unref0 (prop);
#line 248 "../gxml/Object.vala"
			return result;
#line 1589 "Object.c"
		}
#line 250 "../gxml/Object.vala"
		_tmp27_ = prop;
#line 250 "../gxml/Object.vala"
		if (g_type_is_a (_tmp27_->value_type, G_TYPE_INT)) {
#line 1595 "Object.c"
			gint iv = 0;
			GParamSpec* _tmp28_;
			const gchar* _tmp29_;
			GValue _tmp30_;
#line 251 "../gxml/Object.vala"
			iv = (gint) double_parse (val);
#line 252 "../gxml/Object.vala"
			g_value_set_int (&v, iv);
#line 253 "../gxml/Object.vala"
			_tmp28_ = prop;
#line 253 "../gxml/Object.vala"
			_tmp29_ = _tmp28_->name;
#line 253 "../gxml/Object.vala"
			_tmp30_ = v;
#line 253 "../gxml/Object.vala"
			g_object_set_property ((GObject*) self, _tmp29_, &_tmp30_);
#line 254 "../gxml/Object.vala"
			result = TRUE;
#line 254 "../gxml/Object.vala"
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 254 "../gxml/Object.vala"
			_g_param_spec_unref0 (prop);
#line 254 "../gxml/Object.vala"
			return result;
#line 1620 "Object.c"
		}
#line 256 "../gxml/Object.vala"
		_tmp31_ = prop;
#line 256 "../gxml/Object.vala"
		if (g_type_is_a (_tmp31_->value_type, G_TYPE_UINT)) {
#line 1626 "Object.c"
			guint iv = 0U;
			GParamSpec* _tmp32_;
			const gchar* _tmp33_;
			GValue _tmp34_;
#line 257 "../gxml/Object.vala"
			iv = (guint) double_parse (val);
#line 258 "../gxml/Object.vala"
			g_value_set_uint (&v, (guint) ((gint) iv));
#line 259 "../gxml/Object.vala"
			_tmp32_ = prop;
#line 259 "../gxml/Object.vala"
			_tmp33_ = _tmp32_->name;
#line 259 "../gxml/Object.vala"
			_tmp34_ = v;
#line 259 "../gxml/Object.vala"
			g_object_set_property ((GObject*) self, _tmp33_, &_tmp34_);
#line 260 "../gxml/Object.vala"
			result = TRUE;
#line 260 "../gxml/Object.vala"
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 260 "../gxml/Object.vala"
			_g_param_spec_unref0 (prop);
#line 260 "../gxml/Object.vala"
			return result;
#line 1651 "Object.c"
		}
#line 262 "../gxml/Object.vala"
		_tmp35_ = prop;
#line 262 "../gxml/Object.vala"
		if (g_type_is_a (_tmp35_->value_type, G_TYPE_FLOAT)) {
#line 1657 "Object.c"
			gdouble dv = 0.0;
			GParamSpec* _tmp36_;
			const gchar* _tmp37_;
			GValue _tmp38_;
#line 263 "../gxml/Object.vala"
			dv = double_parse (val);
#line 264 "../gxml/Object.vala"
			g_value_set_float (&v, (gfloat) dv);
#line 265 "../gxml/Object.vala"
			_tmp36_ = prop;
#line 265 "../gxml/Object.vala"
			_tmp37_ = _tmp36_->name;
#line 265 "../gxml/Object.vala"
			_tmp38_ = v;
#line 265 "../gxml/Object.vala"
			g_object_set_property ((GObject*) self, _tmp37_, &_tmp38_);
#line 266 "../gxml/Object.vala"
			result = TRUE;
#line 266 "../gxml/Object.vala"
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 266 "../gxml/Object.vala"
			_g_param_spec_unref0 (prop);
#line 266 "../gxml/Object.vala"
			return result;
#line 1682 "Object.c"
		}
#line 268 "../gxml/Object.vala"
		_tmp39_ = prop;
#line 268 "../gxml/Object.vala"
		if (g_type_is_a (_tmp39_->value_type, G_TYPE_DOUBLE)) {
#line 1688 "Object.c"
			gdouble dv = 0.0;
			GParamSpec* _tmp40_;
			const gchar* _tmp41_;
			GValue _tmp42_;
#line 269 "../gxml/Object.vala"
			dv = double_parse (val);
#line 270 "../gxml/Object.vala"
			g_value_set_double (&v, dv);
#line 271 "../gxml/Object.vala"
			_tmp40_ = prop;
#line 271 "../gxml/Object.vala"
			_tmp41_ = _tmp40_->name;
#line 271 "../gxml/Object.vala"
			_tmp42_ = v;
#line 271 "../gxml/Object.vala"
			g_object_set_property ((GObject*) self, _tmp41_, &_tmp42_);
#line 272 "../gxml/Object.vala"
			result = TRUE;
#line 272 "../gxml/Object.vala"
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 272 "../gxml/Object.vala"
			_g_param_spec_unref0 (prop);
#line 272 "../gxml/Object.vala"
			return result;
#line 1713 "Object.c"
		}
#line 274 "../gxml/Object.vala"
		_tmp43_ = prop;
#line 274 "../gxml/Object.vala"
		if (g_type_is_a (_tmp43_->value_type, G_TYPE_BOOLEAN)) {
#line 1719 "Object.c"
			gboolean bv = FALSE;
			GParamSpec* _tmp44_;
			const gchar* _tmp45_;
			GValue _tmp46_;
#line 275 "../gxml/Object.vala"
			bv = bool_parse (val);
#line 276 "../gxml/Object.vala"
			g_value_set_boolean (&v, bv);
#line 277 "../gxml/Object.vala"
			_tmp44_ = prop;
#line 277 "../gxml/Object.vala"
			_tmp45_ = _tmp44_->name;
#line 277 "../gxml/Object.vala"
			_tmp46_ = v;
#line 277 "../gxml/Object.vala"
			g_object_set_property ((GObject*) self, _tmp45_, &_tmp46_);
#line 278 "../gxml/Object.vala"
			result = TRUE;
#line 278 "../gxml/Object.vala"
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 278 "../gxml/Object.vala"
			_g_param_spec_unref0 (prop);
#line 278 "../gxml/Object.vala"
			return result;
#line 1744 "Object.c"
		}
#line 280 "../gxml/Object.vala"
		_tmp47_ = prop;
#line 280 "../gxml/Object.vala"
		if (g_type_is_a (_tmp47_->value_type, G_TYPE_ENUM)) {
#line 1750 "Object.c"
			{
				GEnumValue* _tmp48_ = NULL;
				GParamSpec* _tmp49_;
				GEnumValue* _tmp50_;
				gint n = 0;
#line 282 "../gxml/Object.vala"
				_tmp49_ = prop;
#line 282 "../gxml/Object.vala"
				_tmp50_ = gxml_enumeration_parse (_tmp49_->value_type, val, &_inner_error0_);
#line 282 "../gxml/Object.vala"
				_tmp48_ = _tmp50_;
#line 282 "../gxml/Object.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1764 "Object.c"
					goto __catch0_g_error;
				}
#line 282 "../gxml/Object.vala"
				n = (gint) (*_tmp48_).value;
#line 283 "../gxml/Object.vala"
				g_value_set_enum (&v, n);
#line 281 "../gxml/Object.vala"
				_g_free0 (_tmp48_);
#line 1773 "Object.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
#line 281 "../gxml/Object.vala"
				g_clear_error (&_inner_error0_);
#line 285 "../gxml/Object.vala"
				g_warning ("Object.vala:285: %s", _ ("Enumeration can't be parsed from string"));
#line 286 "../gxml/Object.vala"
				result = FALSE;
#line 286 "../gxml/Object.vala"
				G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 286 "../gxml/Object.vala"
				_g_param_spec_unref0 (prop);
#line 286 "../gxml/Object.vala"
				return result;
#line 1790 "Object.c"
			}
			__finally0:
#line 281 "../gxml/Object.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1795 "Object.c"
				gboolean _tmp51_ = FALSE;
#line 281 "../gxml/Object.vala"
				G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 281 "../gxml/Object.vala"
				_g_param_spec_unref0 (prop);
#line 281 "../gxml/Object.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 281 "../gxml/Object.vala"
				g_clear_error (&_inner_error0_);
#line 281 "../gxml/Object.vala"
				return _tmp51_;
#line 1807 "Object.c"
			}
#line 288 "../gxml/Object.vala"
			result = TRUE;
#line 288 "../gxml/Object.vala"
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 288 "../gxml/Object.vala"
			_g_param_spec_unref0 (prop);
#line 288 "../gxml/Object.vala"
			return result;
#line 1817 "Object.c"
		}
#line 232 "../gxml/Object.vala"
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 1821 "Object.c"
	}
#line 291 "../gxml/Object.vala"
	result = FALSE;
#line 291 "../gxml/Object.vala"
	_g_param_spec_unref0 (prop);
#line 291 "../gxml/Object.vala"
	return result;
#line 1829 "Object.c"
}

gboolean
gxml_object_set_attribute (GXmlObject* self,
                           const gchar* name,
                           const gchar* val)
{
	GXmlObjectIface* _iface_;
#line 230 "../gxml/Object.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 230 "../gxml/Object.vala"
	_iface_ = GXML_OBJECT_GET_INTERFACE (self);
#line 230 "../gxml/Object.vala"
	if (_iface_->set_attribute) {
#line 230 "../gxml/Object.vala"
		return _iface_->set_attribute (self, name, val);
#line 1846 "Object.c"
	}
#line 230 "../gxml/Object.vala"
	return FALSE;
#line 1850 "Object.c"
}

/**
   * Search a {@link GLib.Object} property with given name
   * and returns it, if it is a {@link DomElement}. If not found,
   * {@link DomElement.get_elements_by_tag_name} is called, returning
   * first node found. Tag name to use, is the given name parameter.
   *
   * @param name a name of this object's property of type {@link DomElement} or
   * first {@link DomNode} with that name in child nodes.
   *
   */
static GXmlDomElement*
gxml_object_real_get_child (GXmlObject* self,
                            const gchar* name)
{
	GParamSpec* prop = NULL;
	GObjectClass* _tmp0_;
	GParamSpec* _tmp1_;
	GParamSpec* _tmp2_;
	GParamSpec* _tmp3_;
	GXmlDomElement* result = NULL;
#line 303 "../gxml/Object.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 304 "../gxml/Object.vala"
	_tmp0_ = G_OBJECT_GET_CLASS ((GObject*) self);
#line 304 "../gxml/Object.vala"
	_tmp1_ = g_object_class_find_property (_tmp0_, name);
#line 304 "../gxml/Object.vala"
	_tmp2_ = _g_param_spec_ref0 (_tmp1_);
#line 304 "../gxml/Object.vala"
	prop = _tmp2_;
#line 305 "../gxml/Object.vala"
	_tmp3_ = prop;
#line 305 "../gxml/Object.vala"
	if (_tmp3_ != NULL) {
#line 1887 "Object.c"
		GParamSpec* _tmp4_;
#line 306 "../gxml/Object.vala"
		_tmp4_ = prop;
#line 306 "../gxml/Object.vala"
		if (g_type_is_a (_tmp4_->value_type, GXML_TYPE_DOM_ELEMENT)) {
#line 1893 "Object.c"
			GValue vo = {0};
			GParamSpec* _tmp5_;
			GValue _tmp6_ = {0};
			GParamSpec* _tmp7_;
			const gchar* _tmp8_;
			GValue _tmp9_;
			GXmlDomElement* _tmp10_;
#line 307 "../gxml/Object.vala"
			_tmp5_ = prop;
#line 307 "../gxml/Object.vala"
			g_value_init (&_tmp6_, _tmp5_->value_type);
#line 307 "../gxml/Object.vala"
			vo = _tmp6_;
#line 308 "../gxml/Object.vala"
			_tmp7_ = prop;
#line 308 "../gxml/Object.vala"
			_tmp8_ = _tmp7_->name;
#line 308 "../gxml/Object.vala"
			g_object_get_property ((GObject*) self, _tmp8_, &vo);
#line 309 "../gxml/Object.vala"
			_tmp9_ = vo;
#line 309 "../gxml/Object.vala"
			_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (g_value_get_object (&_tmp9_), GXML_TYPE_DOM_ELEMENT, GXmlDomElement));
#line 309 "../gxml/Object.vala"
			result = _tmp10_;
#line 309 "../gxml/Object.vala"
			G_IS_VALUE (&vo) ? (g_value_unset (&vo), NULL) : NULL;
#line 309 "../gxml/Object.vala"
			_g_param_spec_unref0 (prop);
#line 309 "../gxml/Object.vala"
			return result;
#line 1925 "Object.c"
		}
	}
#line 312 "../gxml/Object.vala"
	if (gxml_dom_node_has_child_nodes (G_TYPE_CHECK_INSTANCE_CAST (self, GXML_TYPE_DOM_NODE, GXmlDomNode))) {
#line 1930 "Object.c"
		GXmlDomHTMLCollection* els = NULL;
		GXmlDomHTMLCollection* _tmp11_;
		GXmlDomHTMLCollection* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
#line 313 "../gxml/Object.vala"
		_tmp11_ = gxml_dom_element_get_elements_by_tag_name (G_TYPE_CHECK_INSTANCE_CAST (self, GXML_TYPE_DOM_ELEMENT, GXmlDomElement), name);
#line 313 "../gxml/Object.vala"
		els = _tmp11_;
#line 314 "../gxml/Object.vala"
		_tmp12_ = els;
#line 314 "../gxml/Object.vala"
		_tmp13_ = gee_collection_get_size ((GeeCollection*) _tmp12_);
#line 314 "../gxml/Object.vala"
		_tmp14_ = _tmp13_;
#line 314 "../gxml/Object.vala"
		if (_tmp14_ != 0) {
#line 1948 "Object.c"
			GXmlDomHTMLCollection* _tmp15_;
			GXmlDomElement* _tmp16_;
#line 315 "../gxml/Object.vala"
			_tmp15_ = els;
#line 315 "../gxml/Object.vala"
			_tmp16_ = gxml_dom_html_collection_item (_tmp15_, 0);
#line 315 "../gxml/Object.vala"
			result = _tmp16_;
#line 315 "../gxml/Object.vala"
			_g_object_unref0 (els);
#line 315 "../gxml/Object.vala"
			_g_param_spec_unref0 (prop);
#line 315 "../gxml/Object.vala"
			return result;
#line 1963 "Object.c"
		}
#line 312 "../gxml/Object.vala"
		_g_object_unref0 (els);
#line 1967 "Object.c"
	}
#line 317 "../gxml/Object.vala"
	result = NULL;
#line 317 "../gxml/Object.vala"
	_g_param_spec_unref0 (prop);
#line 317 "../gxml/Object.vala"
	return result;
#line 1975 "Object.c"
}

GXmlDomElement*
gxml_object_get_child (GXmlObject* self,
                       const gchar* name)
{
	GXmlObjectIface* _iface_;
#line 303 "../gxml/Object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 303 "../gxml/Object.vala"
	_iface_ = GXML_OBJECT_GET_INTERFACE (self);
#line 303 "../gxml/Object.vala"
	if (_iface_->get_child) {
#line 303 "../gxml/Object.vala"
		return _iface_->get_child (self, name);
#line 1991 "Object.c"
	}
#line 303 "../gxml/Object.vala"
	return NULL;
#line 1995 "Object.c"
}

/**
   * From a given property name of type {@link GXml.Element}, search all
   * child nodes with node's local name equal to property.
   */
static GXmlDomElementList*
gxml_object_real_find_elements (GXmlObject* self,
                                const gchar* name)
{
	GXmlDomElementList* l = NULL;
	GXmlDomElementList* _tmp0_;
	GParamSpec* prop = NULL;
	GObjectClass* _tmp1_;
	GParamSpec* _tmp2_;
	GParamSpec* _tmp3_;
	GParamSpec* _tmp4_;
	GXmlDomElementList* result = NULL;
#line 323 "../gxml/Object.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 324 "../gxml/Object.vala"
	_tmp0_ = gxml_dom_element_list_new ();
#line 324 "../gxml/Object.vala"
	l = _tmp0_;
#line 325 "../gxml/Object.vala"
	_tmp1_ = G_OBJECT_GET_CLASS ((GObject*) self);
#line 325 "../gxml/Object.vala"
	_tmp2_ = g_object_class_find_property (_tmp1_, name);
#line 325 "../gxml/Object.vala"
	_tmp3_ = _g_param_spec_ref0 (_tmp2_);
#line 325 "../gxml/Object.vala"
	prop = _tmp3_;
#line 326 "../gxml/Object.vala"
	_tmp4_ = prop;
#line 326 "../gxml/Object.vala"
	if (_tmp4_ != NULL) {
#line 2032 "Object.c"
		GParamSpec* _tmp5_;
#line 327 "../gxml/Object.vala"
		_tmp5_ = prop;
#line 327 "../gxml/Object.vala"
		if (g_type_is_a (_tmp5_->value_type, GXML_TYPE_DOM_ELEMENT)) {
#line 2038 "Object.c"
			GXmlDomElement* o = NULL;
			GParamSpec* _tmp6_;
			GObject* _tmp7_;
			GObject* _tmp8_;
			GXmlDomElement* _tmp9_;
#line 328 "../gxml/Object.vala"
			_tmp6_ = prop;
#line 328 "../gxml/Object.vala"
			_tmp7_ = g_object_new (_tmp6_->value_type, NULL);
#line 328 "../gxml/Object.vala"
			_tmp8_ = G_IS_INITIALLY_UNOWNED (_tmp7_) ? g_object_ref_sink (_tmp7_) : _tmp7_;
#line 328 "../gxml/Object.vala"
			_tmp9_ = GXML_IS_DOM_ELEMENT (_tmp8_) ? ((GXmlDomElement*) _tmp8_) : NULL;
#line 328 "../gxml/Object.vala"
			if (_tmp9_ == NULL) {
#line 328 "../gxml/Object.vala"
				_g_object_unref0 (_tmp8_);
#line 2056 "Object.c"
			}
#line 328 "../gxml/Object.vala"
			o = _tmp9_;
#line 2060 "Object.c"
			{
				GXmlDomNodeList* _n_list = NULL;
				GXmlDomNodeList* _tmp10_;
				GXmlDomNodeList* _tmp11_;
				gint _n_size = 0;
				GXmlDomNodeList* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
				gint _n_index = 0;
#line 329 "../gxml/Object.vala"
				_tmp10_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 329 "../gxml/Object.vala"
				_tmp11_ = _tmp10_;
#line 329 "../gxml/Object.vala"
				_n_list = _tmp11_;
#line 329 "../gxml/Object.vala"
				_tmp12_ = _n_list;
#line 329 "../gxml/Object.vala"
				_tmp13_ = gee_collection_get_size ((GeeCollection*) _tmp12_);
#line 329 "../gxml/Object.vala"
				_tmp14_ = _tmp13_;
#line 329 "../gxml/Object.vala"
				_n_size = _tmp14_;
#line 329 "../gxml/Object.vala"
				_n_index = -1;
#line 329 "../gxml/Object.vala"
				while (TRUE) {
#line 2088 "Object.c"
					gint _tmp15_;
					gint _tmp16_;
					GXmlDomNode* n = NULL;
					GXmlDomNodeList* _tmp17_;
					gpointer _tmp18_;
					GXmlDomNode* _tmp19_;
					GXmlDomNode* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					gchar* _tmp24_;
					gchar* _tmp25_;
					GXmlDomElement* _tmp26_;
					gchar* _tmp27_;
					gchar* _tmp28_;
					gchar* _tmp29_;
					gchar* _tmp30_;
					gchar* _tmp31_;
					gboolean _tmp32_;
#line 329 "../gxml/Object.vala"
					_n_index = _n_index + 1;
#line 329 "../gxml/Object.vala"
					_tmp15_ = _n_index;
#line 329 "../gxml/Object.vala"
					_tmp16_ = _n_size;
#line 329 "../gxml/Object.vala"
					if (!(_tmp15_ < _tmp16_)) {
#line 329 "../gxml/Object.vala"
						break;
#line 2118 "Object.c"
					}
#line 329 "../gxml/Object.vala"
					_tmp17_ = _n_list;
#line 329 "../gxml/Object.vala"
					_tmp18_ = gee_list_get ((GeeList*) _tmp17_, _n_index);
#line 329 "../gxml/Object.vala"
					n = (GXmlDomNode*) _tmp18_;
#line 330 "../gxml/Object.vala"
					_tmp19_ = n;
#line 330 "../gxml/Object.vala"
					if (!GXML_IS_DOM_ELEMENT (_tmp19_)) {
#line 330 "../gxml/Object.vala"
						_g_object_unref0 (n);
#line 330 "../gxml/Object.vala"
						continue;
#line 2134 "Object.c"
					}
#line 331 "../gxml/Object.vala"
					_tmp20_ = n;
#line 331 "../gxml/Object.vala"
					_tmp21_ = gxml_dom_element_get_local_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GXML_TYPE_DOM_ELEMENT, GXmlDomElement));
#line 331 "../gxml/Object.vala"
					_tmp22_ = _tmp21_;
#line 331 "../gxml/Object.vala"
					_tmp23_ = _tmp22_;
#line 331 "../gxml/Object.vala"
					_tmp24_ = g_utf8_strdown (_tmp23_, (gssize) -1);
#line 331 "../gxml/Object.vala"
					_tmp25_ = _tmp24_;
#line 331 "../gxml/Object.vala"
					_tmp26_ = o;
#line 331 "../gxml/Object.vala"
					_tmp27_ = gxml_dom_element_get_local_name (_tmp26_);
#line 331 "../gxml/Object.vala"
					_tmp28_ = _tmp27_;
#line 331 "../gxml/Object.vala"
					_tmp29_ = _tmp28_;
#line 331 "../gxml/Object.vala"
					_tmp30_ = g_utf8_strdown (_tmp29_, (gssize) -1);
#line 331 "../gxml/Object.vala"
					_tmp31_ = _tmp30_;
#line 331 "../gxml/Object.vala"
					_tmp32_ = g_strcmp0 (_tmp25_, _tmp31_) == 0;
#line 331 "../gxml/Object.vala"
					_g_free0 (_tmp31_);
#line 331 "../gxml/Object.vala"
					_g_free0 (_tmp29_);
#line 331 "../gxml/Object.vala"
					_g_free0 (_tmp25_);
#line 331 "../gxml/Object.vala"
					_g_free0 (_tmp23_);
#line 331 "../gxml/Object.vala"
					if (_tmp32_) {
#line 2172 "Object.c"
						GXmlDomElementList* _tmp33_;
						GXmlDomNode* _tmp34_;
#line 332 "../gxml/Object.vala"
						_tmp33_ = l;
#line 332 "../gxml/Object.vala"
						_tmp34_ = n;
#line 332 "../gxml/Object.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp33_, G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GXML_TYPE_DOM_ELEMENT, GXmlDomElement));
#line 2181 "Object.c"
					}
#line 329 "../gxml/Object.vala"
					_g_object_unref0 (n);
#line 2185 "Object.c"
				}
#line 329 "../gxml/Object.vala"
				_g_object_unref0 (_n_list);
#line 2189 "Object.c"
			}
#line 328 "../gxml/Object.vala"
			_g_object_unref0 (o);
#line 2193 "Object.c"
		}
	}
#line 336 "../gxml/Object.vala"
	result = l;
#line 336 "../gxml/Object.vala"
	_g_param_spec_unref0 (prop);
#line 336 "../gxml/Object.vala"
	return result;
#line 2202 "Object.c"
}

GXmlDomElementList*
gxml_object_find_elements (GXmlObject* self,
                           const gchar* name)
{
	GXmlObjectIface* _iface_;
#line 326 "../gxml/Object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 326 "../gxml/Object.vala"
	_iface_ = GXML_OBJECT_GET_INTERFACE (self);
#line 326 "../gxml/Object.vala"
	if (_iface_->find_elements) {
#line 326 "../gxml/Object.vala"
		return _iface_->find_elements (self, name);
#line 2218 "Object.c"
	}
#line 326 "../gxml/Object.vala"
	return NULL;
#line 2222 "Object.c"
}

/**
   * Search for a property and set it to null if possible returning true,
   * if value can't be removed or located, returns false without change.
   */
static gboolean
gxml_object_real_remove_attribute (GXmlObject* self,
                                   const gchar* name)
{
	GParamSpec* prop = NULL;
	GObjectClass* _tmp0_;
	GParamSpec* _tmp1_;
	GParamSpec* _tmp2_;
	GParamSpec* _tmp3_;
	gboolean result = FALSE;
#line 342 "../gxml/Object.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 343 "../gxml/Object.vala"
	_tmp0_ = G_OBJECT_GET_CLASS ((GObject*) self);
#line 343 "../gxml/Object.vala"
	_tmp1_ = g_object_class_find_property (_tmp0_, name);
#line 343 "../gxml/Object.vala"
	_tmp2_ = _g_param_spec_ref0 (_tmp1_);
#line 343 "../gxml/Object.vala"
	prop = _tmp2_;
#line 344 "../gxml/Object.vala"
	_tmp3_ = prop;
#line 344 "../gxml/Object.vala"
	if (_tmp3_ != NULL) {
#line 2253 "Object.c"
		GParamSpec* _tmp4_;
		GParamSpec* _tmp7_;
#line 345 "../gxml/Object.vala"
		_tmp4_ = prop;
#line 345 "../gxml/Object.vala"
		if (g_type_is_a (_tmp4_->value_type, GXML_TYPE_OBJECT)) {
#line 2260 "Object.c"
			GValue v = {0};
			GValue _tmp5_ = {0};
			GValue _tmp6_;
#line 346 "../gxml/Object.vala"
			g_value_init (&_tmp5_, GXML_TYPE_OBJECT);
#line 346 "../gxml/Object.vala"
			v = _tmp5_;
#line 347 "../gxml/Object.vala"
			_tmp6_ = v;
#line 347 "../gxml/Object.vala"
			g_object_set_property ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, GXML_TYPE_OBJECT, GXmlObject), name, &_tmp6_);
#line 348 "../gxml/Object.vala"
			result = TRUE;
#line 348 "../gxml/Object.vala"
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 348 "../gxml/Object.vala"
			_g_param_spec_unref0 (prop);
#line 348 "../gxml/Object.vala"
			return result;
#line 2280 "Object.c"
		}
#line 350 "../gxml/Object.vala"
		_tmp7_ = prop;
#line 350 "../gxml/Object.vala"
		if (g_type_is_a (_tmp7_->value_type, G_TYPE_STRING)) {
#line 2286 "Object.c"
			GValue v = {0};
			GValue _tmp8_ = {0};
			GParamSpec* _tmp9_;
			const gchar* _tmp10_;
			GValue _tmp11_;
#line 351 "../gxml/Object.vala"
			g_value_init (&_tmp8_, G_TYPE_STRING);
#line 351 "../gxml/Object.vala"
			v = _tmp8_;
#line 352 "../gxml/Object.vala"
			g_value_set_string (&v, NULL);
#line 353 "../gxml/Object.vala"
			_tmp9_ = prop;
#line 353 "../gxml/Object.vala"
			_tmp10_ = _tmp9_->name;
#line 353 "../gxml/Object.vala"
			_tmp11_ = v;
#line 353 "../gxml/Object.vala"
			g_object_set_property ((GObject*) self, _tmp10_, &_tmp11_);
#line 354 "../gxml/Object.vala"
			result = TRUE;
#line 354 "../gxml/Object.vala"
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 354 "../gxml/Object.vala"
			_g_param_spec_unref0 (prop);
#line 354 "../gxml/Object.vala"
			return result;
#line 2314 "Object.c"
		}
	}
#line 357 "../gxml/Object.vala"
	result = FALSE;
#line 357 "../gxml/Object.vala"
	_g_param_spec_unref0 (prop);
#line 357 "../gxml/Object.vala"
	return result;
#line 2323 "Object.c"
}

gboolean
gxml_object_remove_attribute (GXmlObject* self,
                              const gchar* name)
{
	GXmlObjectIface* _iface_;
#line 342 "../gxml/Object.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 342 "../gxml/Object.vala"
	_iface_ = GXML_OBJECT_GET_INTERFACE (self);
#line 342 "../gxml/Object.vala"
	if (_iface_->remove_attribute) {
#line 342 "../gxml/Object.vala"
		return _iface_->remove_attribute (self, name);
#line 2339 "Object.c"
	}
#line 342 "../gxml/Object.vala"
	return FALSE;
#line 2343 "Object.c"
}

/**
   * Convenient method to set an instance of given property's
   * name and initialize according to have same {@link DomNode.owner_document}
   * and set its {@link DomNode.parent_node} to this appending it as a child.
   * If property is a {@link Collection} it is initialize to use
   * this as its {@link Collection.element}.
   *
   * Instance is set to object's property.
   *
   * Property should be a {@link GXml.Element} or {@link Collection}
   *
   * While an object could be created and set to a Object's property, it
   * is not correctly initialized by default. This method helps in the process.
   *
   * If Object's property has been set, this method overwrite it.
   *
   * {{{
   * class NodeA : GXml.Object {
   *   construct { try { initialize ("NodeA"); } catch { warning ("Can't initialize); }
   * }
   * class NodeB : GXml.Object {
   *   public NodeA node { get; set; }
   * }
   *
   * var nb = new NodeB ();
   * nb.create_instance_property ("node");
   * assert (nb.node != null);
   * }}}
   *
   * Property's name can be canonical or its nick name, see {@link find_object_property_name}
   *
   * Returns: true if property has been set and initialized, false otherwise.
   */
static gboolean
gxml_object_real_set_instance_property (GXmlObject* self,
                                        const gchar* name)
{
	GParamSpec* prop = NULL;
	GParamSpec* _tmp0_;
	GParamSpec* _tmp1_;
	GValue v = {0};
	GParamSpec* _tmp2_;
	GValue _tmp3_ = {0};
	GObject* obj = NULL;
	GParamSpec* _tmp4_;
	GParamSpec* _tmp12_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 392 "../gxml/Object.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 393 "../gxml/Object.vala"
	_tmp0_ = gxml_object_find_object_property_name (self, name);
#line 393 "../gxml/Object.vala"
	prop = _tmp0_;
#line 394 "../gxml/Object.vala"
	_tmp1_ = prop;
#line 394 "../gxml/Object.vala"
	if (_tmp1_ == NULL) {
#line 394 "../gxml/Object.vala"
		result = FALSE;
#line 394 "../gxml/Object.vala"
		_g_param_spec_unref0 (prop);
#line 394 "../gxml/Object.vala"
		return result;
#line 2410 "Object.c"
	}
#line 395 "../gxml/Object.vala"
	_tmp2_ = prop;
#line 395 "../gxml/Object.vala"
	g_value_init (&_tmp3_, _tmp2_->value_type);
#line 395 "../gxml/Object.vala"
	v = _tmp3_;
#line 397 "../gxml/Object.vala"
	_tmp4_ = prop;
#line 397 "../gxml/Object.vala"
	if (g_type_is_a (_tmp4_->value_type, GXML_TYPE_COLLECTION)) {
#line 2422 "Object.c"
		GParamSpec* _tmp5_;
		GObject* _tmp6_;
		GObject* _tmp7_;
		GObject* _tmp8_;
		GParamSpec* _tmp9_;
		const gchar* _tmp10_;
		GValue _tmp11_;
#line 398 "../gxml/Object.vala"
		_tmp5_ = prop;
#line 398 "../gxml/Object.vala"
		_tmp6_ = g_object_new (_tmp5_->value_type, "element", self, NULL);
#line 398 "../gxml/Object.vala"
		_tmp7_ = G_IS_INITIALLY_UNOWNED (_tmp6_) ? g_object_ref_sink (_tmp6_) : _tmp6_;
#line 398 "../gxml/Object.vala"
		_g_object_unref0 (obj);
#line 398 "../gxml/Object.vala"
		obj = _tmp7_;
#line 399 "../gxml/Object.vala"
		_tmp8_ = obj;
#line 399 "../gxml/Object.vala"
		g_value_set_object (&v, _tmp8_);
#line 400 "../gxml/Object.vala"
		_tmp9_ = prop;
#line 400 "../gxml/Object.vala"
		_tmp10_ = _tmp9_->name;
#line 400 "../gxml/Object.vala"
		_tmp11_ = v;
#line 400 "../gxml/Object.vala"
		g_object_set_property ((GObject*) self, _tmp10_, &_tmp11_);
#line 401 "../gxml/Object.vala"
		result = TRUE;
#line 401 "../gxml/Object.vala"
		_g_object_unref0 (obj);
#line 401 "../gxml/Object.vala"
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 401 "../gxml/Object.vala"
		_g_param_spec_unref0 (prop);
#line 401 "../gxml/Object.vala"
		return result;
#line 2462 "Object.c"
	}
#line 403 "../gxml/Object.vala"
	_tmp12_ = prop;
#line 403 "../gxml/Object.vala"
	if (g_type_is_a (_tmp12_->value_type, GXML_TYPE_ELEMENT)) {
#line 2468 "Object.c"
		GParamSpec* _tmp13_;
		GXmlDomDocument* _tmp14_;
		GXmlDomDocument* _tmp15_;
		GObject* _tmp16_;
		GObject* _tmp17_;
		GObject* _tmp26_;
		GParamSpec* _tmp27_;
		const gchar* _tmp28_;
		GValue _tmp29_;
#line 404 "../gxml/Object.vala"
		_tmp13_ = prop;
#line 404 "../gxml/Object.vala"
		_tmp14_ = gxml_dom_node_get_owner_document ((GXmlDomNode*) self);
#line 404 "../gxml/Object.vala"
		_tmp15_ = _tmp14_;
#line 404 "../gxml/Object.vala"
		_tmp16_ = g_object_new (_tmp13_->value_type, "owner-document", _tmp15_, NULL);
#line 404 "../gxml/Object.vala"
		_tmp17_ = G_IS_INITIALLY_UNOWNED (_tmp16_) ? g_object_ref_sink (_tmp16_) : _tmp16_;
#line 404 "../gxml/Object.vala"
		_g_object_unref0 (obj);
#line 404 "../gxml/Object.vala"
		obj = _tmp17_;
#line 2492 "Object.c"
		{
			GObject* _tmp18_;
			GXmlDomNode* _tmp19_;
			GXmlDomNode* _tmp20_;
#line 405 "../gxml/Object.vala"
			_tmp18_ = obj;
#line 405 "../gxml/Object.vala"
			_tmp19_ = gxml_dom_node_append_child ((GXmlDomNode*) self, (GXmlDomNode*) (GXML_IS_ELEMENT (_tmp18_) ? ((GXmlElement*) _tmp18_) : NULL), &_inner_error0_);
#line 405 "../gxml/Object.vala"
			_tmp20_ = _tmp19_;
#line 405 "../gxml/Object.vala"
			_g_object_unref0 (_tmp20_);
#line 405 "../gxml/Object.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2507 "Object.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
#line 405 "../gxml/Object.vala"
			e = _inner_error0_;
#line 405 "../gxml/Object.vala"
			_inner_error0_ = NULL;
#line 407 "../gxml/Object.vala"
			_tmp21_ = e;
#line 407 "../gxml/Object.vala"
			_tmp22_ = _tmp21_->message;
#line 407 "../gxml/Object.vala"
			_tmp23_ = g_strdup_printf (_ ("Error while attempting to instantiate property object: %s"), _tmp22_);
#line 407 "../gxml/Object.vala"
			_tmp24_ = _tmp23_;
#line 407 "../gxml/Object.vala"
			g_warning ("Object.vala:407: %s", _tmp24_);
#line 407 "../gxml/Object.vala"
			_g_free0 (_tmp24_);
#line 408 "../gxml/Object.vala"
			result = FALSE;
#line 408 "../gxml/Object.vala"
			_g_error_free0 (e);
#line 408 "../gxml/Object.vala"
			_g_object_unref0 (obj);
#line 408 "../gxml/Object.vala"
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 408 "../gxml/Object.vala"
			_g_param_spec_unref0 (prop);
#line 408 "../gxml/Object.vala"
			return result;
#line 2547 "Object.c"
		}
		__finally0:
#line 405 "../gxml/Object.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2552 "Object.c"
			gboolean _tmp25_ = FALSE;
#line 405 "../gxml/Object.vala"
			_g_object_unref0 (obj);
#line 405 "../gxml/Object.vala"
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 405 "../gxml/Object.vala"
			_g_param_spec_unref0 (prop);
#line 405 "../gxml/Object.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 405 "../gxml/Object.vala"
			g_clear_error (&_inner_error0_);
#line 405 "../gxml/Object.vala"
			return _tmp25_;
#line 2566 "Object.c"
		}
#line 410 "../gxml/Object.vala"
		_tmp26_ = obj;
#line 410 "../gxml/Object.vala"
		g_value_set_object (&v, _tmp26_);
#line 411 "../gxml/Object.vala"
		_tmp27_ = prop;
#line 411 "../gxml/Object.vala"
		_tmp28_ = _tmp27_->name;
#line 411 "../gxml/Object.vala"
		_tmp29_ = v;
#line 411 "../gxml/Object.vala"
		g_object_set_property ((GObject*) self, _tmp28_, &_tmp29_);
#line 412 "../gxml/Object.vala"
		result = TRUE;
#line 412 "../gxml/Object.vala"
		_g_object_unref0 (obj);
#line 412 "../gxml/Object.vala"
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 412 "../gxml/Object.vala"
		_g_param_spec_unref0 (prop);
#line 412 "../gxml/Object.vala"
		return result;
#line 2590 "Object.c"
	}
#line 414 "../gxml/Object.vala"
	result = FALSE;
#line 414 "../gxml/Object.vala"
	_g_object_unref0 (obj);
#line 414 "../gxml/Object.vala"
	G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 414 "../gxml/Object.vala"
	_g_param_spec_unref0 (prop);
#line 414 "../gxml/Object.vala"
	return result;
#line 2602 "Object.c"
}

gboolean
gxml_object_set_instance_property (GXmlObject* self,
                                   const gchar* name)
{
	GXmlObjectIface* _iface_;
#line 403 "../gxml/Object.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 403 "../gxml/Object.vala"
	_iface_ = GXML_OBJECT_GET_INTERFACE (self);
#line 403 "../gxml/Object.vala"
	if (_iface_->set_instance_property) {
#line 403 "../gxml/Object.vala"
		return _iface_->set_instance_property (self, name);
#line 2618 "Object.c"
	}
#line 403 "../gxml/Object.vala"
	return FALSE;
#line 2622 "Object.c"
}

/**
   * Utility method to remove all instances of a property being child elements
   * of object. Is useful if you have a {@link GXml.Element} property, it should be
   * just one child of this type and you want to overwrite it.
   *
   * In this example you have defined an element MyClass to be child of
   * MyParentClass, but it should have just one element, once you set child_elements
   * it calls {@link clean_property_elements} using property's canonicals name.
   *
   * {{{
   *  public class MyClass : GXml.Element {
   *    public string name { get; set; }
   *  }
   *  public class MyParentClass : GXml.Element {
   *    private Myclass _child_elements = null;
   *    public MyClass child_elements {
   *      get { return _child_elements; }
   *      set {
   *        try {
   *          clean_property_elements ("child-elements");
   *          _child_elements = value;
   *          append_child (_child_elements);
   *        } catch (GLib.Error e) {
   *          warning (e.message);
   *        }
   *      }
   *    }
   *  }
   * }}}
   *
   * @param name property name to search value type, use canonical names.
   *
   * @throws DomError if property is not a {@link GXml.Element}.
   */
static void
gxml_object_real_clean_property_elements (GXmlObject* self,
                                          const gchar* name,
                                          GError** error)
{
	GParamSpec* prop = NULL;
	GObjectClass* _tmp0_;
	GParamSpec* _tmp1_;
	GParamSpec* _tmp2_;
	GParamSpec* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 450 "../gxml/Object.vala"
	g_return_if_fail (name != NULL);
#line 453 "../gxml/Object.vala"
	_tmp0_ = G_OBJECT_GET_CLASS ((GObject*) self);
#line 453 "../gxml/Object.vala"
	_tmp1_ = g_object_class_find_property (_tmp0_, name);
#line 453 "../gxml/Object.vala"
	_tmp2_ = _g_param_spec_ref0 (_tmp1_);
#line 453 "../gxml/Object.vala"
	prop = _tmp2_;
#line 454 "../gxml/Object.vala"
	_tmp3_ = prop;
#line 454 "../gxml/Object.vala"
	if (_tmp3_ != NULL) {
#line 2684 "Object.c"
		GParamSpec* _tmp4_;
		GXmlDomElementList* l = NULL;
		GXmlDomElementList* _tmp6_;
		GXmlDomElementList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
#line 455 "../gxml/Object.vala"
		_tmp4_ = prop;
#line 455 "../gxml/Object.vala"
		if (!g_type_is_a (_tmp4_->value_type, GXML_TYPE_ELEMENT)) {
#line 2695 "Object.c"
			GError* _tmp5_;
#line 456 "../gxml/Object.vala"
			_tmp5_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_TYPE_MISMATCH_ERROR, _ ("Can't set value. It is not a GXmlGXml.Element type"));
#line 456 "../gxml/Object.vala"
			_inner_error0_ = _tmp5_;
#line 456 "../gxml/Object.vala"
			g_propagate_error (error, _inner_error0_);
#line 456 "../gxml/Object.vala"
			_g_param_spec_unref0 (prop);
#line 456 "../gxml/Object.vala"
			return;
#line 2707 "Object.c"
		}
#line 457 "../gxml/Object.vala"
		_tmp6_ = gxml_object_find_elements (self, name);
#line 457 "../gxml/Object.vala"
		l = _tmp6_;
#line 458 "../gxml/Object.vala"
		_tmp7_ = l;
#line 458 "../gxml/Object.vala"
		_tmp8_ = gxml_dom_html_collection_get_length ((GXmlDomHTMLCollection*) _tmp7_);
#line 458 "../gxml/Object.vala"
		_tmp9_ = _tmp8_;
#line 458 "../gxml/Object.vala"
		if (_tmp9_ != 0) {
#line 2721 "Object.c"
			{
				GXmlDomElementList* _e_list = NULL;
				GXmlDomElementList* _tmp10_;
				gint _e_size = 0;
				GXmlDomElementList* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				gint _e_index = 0;
#line 459 "../gxml/Object.vala"
				_tmp10_ = l;
#line 459 "../gxml/Object.vala"
				_e_list = _tmp10_;
#line 459 "../gxml/Object.vala"
				_tmp11_ = _e_list;
#line 459 "../gxml/Object.vala"
				_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 459 "../gxml/Object.vala"
				_tmp13_ = _tmp12_;
#line 459 "../gxml/Object.vala"
				_e_size = _tmp13_;
#line 459 "../gxml/Object.vala"
				_e_index = -1;
#line 459 "../gxml/Object.vala"
				while (TRUE) {
#line 2746 "Object.c"
					gint _tmp14_;
					gint _tmp15_;
					GXmlDomElement* e = NULL;
					GXmlDomElementList* _tmp16_;
					gpointer _tmp17_;
					GXmlDomElement* _tmp18_;
#line 459 "../gxml/Object.vala"
					_e_index = _e_index + 1;
#line 459 "../gxml/Object.vala"
					_tmp14_ = _e_index;
#line 459 "../gxml/Object.vala"
					_tmp15_ = _e_size;
#line 459 "../gxml/Object.vala"
					if (!(_tmp14_ < _tmp15_)) {
#line 459 "../gxml/Object.vala"
						break;
#line 2763 "Object.c"
					}
#line 459 "../gxml/Object.vala"
					_tmp16_ = _e_list;
#line 459 "../gxml/Object.vala"
					_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp16_, _e_index);
#line 459 "../gxml/Object.vala"
					e = (GXmlDomElement*) _tmp17_;
#line 460 "../gxml/Object.vala"
					_tmp18_ = e;
#line 460 "../gxml/Object.vala"
					gxml_dom_child_node_remove ((GXmlDomChildNode*) _tmp18_);
#line 459 "../gxml/Object.vala"
					_g_object_unref0 (e);
#line 2777 "Object.c"
				}
			}
		}
#line 454 "../gxml/Object.vala"
		_g_object_unref0 (l);
#line 2783 "Object.c"
	}
#line 450 "../gxml/Object.vala"
	_g_param_spec_unref0 (prop);
#line 2787 "Object.c"
}

void
gxml_object_clean_property_elements (GXmlObject* self,
                                     const gchar* name,
                                     GError** error)
{
	GXmlObjectIface* _iface_;
#line 450 "../gxml/Object.vala"
	g_return_if_fail (self != NULL);
#line 450 "../gxml/Object.vala"
	_iface_ = GXML_OBJECT_GET_INTERFACE (self);
#line 450 "../gxml/Object.vala"
	if (_iface_->clean_property_elements) {
#line 450 "../gxml/Object.vala"
		_iface_->clean_property_elements (self, name, error);
#line 2804 "Object.c"
	}
}

static void
gxml_object_default_init (GXmlObjectIface * iface,
                          gpointer iface_data)
{
#line 397 "../gxml/Object.vala"
	iface->get_properties_list = gxml_object_real_get_properties_list;
#line 397 "../gxml/Object.vala"
	iface->find_property_name = gxml_object_real_find_property_name;
#line 397 "../gxml/Object.vala"
	iface->find_object_property_name = gxml_object_real_find_object_property_name;
#line 397 "../gxml/Object.vala"
	iface->get_property_element_list = gxml_object_real_get_property_element_list;
#line 397 "../gxml/Object.vala"
	iface->get_property_string = gxml_object_real_get_property_string;
#line 397 "../gxml/Object.vala"
	iface->get_attribute = gxml_object_real_get_attribute;
#line 397 "../gxml/Object.vala"
	iface->find_property = gxml_object_real_find_property;
#line 397 "../gxml/Object.vala"
	iface->set_attribute = gxml_object_real_set_attribute;
#line 397 "../gxml/Object.vala"
	iface->get_child = gxml_object_real_get_child;
#line 397 "../gxml/Object.vala"
	iface->find_elements = gxml_object_real_find_elements;
#line 397 "../gxml/Object.vala"
	iface->remove_attribute = gxml_object_real_remove_attribute;
#line 397 "../gxml/Object.vala"
	iface->set_instance_property = gxml_object_real_set_instance_property;
#line 397 "../gxml/Object.vala"
	iface->clean_property_elements = gxml_object_real_clean_property_elements;
#line 2838 "Object.c"
}

/**
 * A GXml Object Model represents a {@link DomElement}. It has attributes
 * and children. All object's properties are handled as attributes if they are
 * basic types like integers, strings, enums and others; {@link Property}
 * objects are handled as attributes too. If object's attribute is a {@link GLib.Object}
 * it is handled as node's child, but only if it is a {@link GXml.Element} object,
 * other wise it is ignored when this object is used as {@link DomNode} in XML
 * documents.
 */
static GType
gxml_object_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GXmlObjectIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_object_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType gxml_object_type_id;
	gxml_object_type_id = g_type_register_static (G_TYPE_INTERFACE, "GXmlObject", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (gxml_object_type_id, G_TYPE_OBJECT);
	g_type_interface_add_prerequisite (gxml_object_type_id, GXML_TYPE_DOM_NODE);
	g_type_interface_add_prerequisite (gxml_object_type_id, GXML_TYPE_DOM_ELEMENT);
	return gxml_object_type_id;
}

GType
gxml_object_get_type (void)
{
	static volatile gsize gxml_object_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_object_type_id__volatile)) {
		GType gxml_object_type_id;
		gxml_object_type_id = gxml_object_get_type_once ();
		g_once_init_leave (&gxml_object_type_id__volatile, gxml_object_type_id);
	}
	return gxml_object_type_id__volatile;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 392 "../gxml/Object.vala"
	if (mem && byte_size != 0) {
#line 392 "../gxml/Object.vala"
		new_mem = g_malloc (byte_size);
#line 392 "../gxml/Object.vala"
		memcpy (new_mem, mem, byte_size);
#line 2885 "Object.c"
	} else {
#line 392 "../gxml/Object.vala"
		new_mem = NULL;
#line 2889 "Object.c"
	}
#line 392 "../gxml/Object.vala"
	return new_mem;
#line 2893 "Object.c"
}

