/* Parser.c generated by valac 0.54.7, the Vala compiler
 * generated from Parser.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; c-basic-offset: 2; tab-width: 2 -*- */
/* Parser.vala
 *
 * Copyright (C) 2016-2019  Daniel Espinosa <esodan@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Daniel Espinosa <esodan@gmail.com>
 */

#include "gxml/gxml.h"
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include "gxml.h"

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _GxmlParserWriteFileAsyncData GxmlParserWriteFileAsyncData;
typedef struct _GxmlParserReadFileAsyncData GxmlParserReadFileAsyncData;
typedef struct _GxmlParserReadChildNodesAsyncData GxmlParserReadChildNodesAsyncData;
#define _g_param_spec_unref0(var) ((var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

/**
 * Parser Error codes for {@link DomNode} parsing objects
 */
struct _GxmlParserWriteFileAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GXmlParser* self;
	GFile* file;
	GFileOutputStream* ostream;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GCancellable* _tmp2_;
	GCancellable* _tmp3_;
	GFileOutputStream* _tmp4_;
	GFileOutputStream* _tmp5_;
	GError* _inner_error0_;
};

struct _GxmlParserReadFileAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GXmlParser* self;
	GFile* file;
	GError* _tmp0_;
	GFileInputStream* _tmp1_;
	GFileInputStream* _tmp2_;
	GError* _inner_error0_;
};

struct _GxmlParserReadChildNodesAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GXmlParser* self;
	GXmlDomNode* parent;
	gboolean cont;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GError* _inner_error0_;
};

static void gxml_parser_real_write_file (GXmlParser* self,
                                  GFile* file,
                                  GError** error);
static void gxml_parser_real_write_file_async_data_free (gpointer _data);
static void gxml_parser_real_write_file_async (GXmlParser* self,
                                        GFile* file,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
static gboolean gxml_parser_real_write_file_async_co (GxmlParserWriteFileAsyncData* _data_);
static void gxml_parser_write_file_async_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_);
static void gxml_parser_real_read_file (GXmlParser* self,
                                 GFile* file,
                                 GError** error);
static void gxml_parser_real_read_file_async_data_free (gpointer _data);
static void gxml_parser_real_read_file_async (GXmlParser* self,
                                       GFile* file,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
static gboolean gxml_parser_real_read_file_async_co (GxmlParserReadFileAsyncData* _data_);
static gboolean _gxml_parser_real_read_file_async_co_gsource_func (gpointer self);
static void gxml_parser_read_file_async_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_);
static void gxml_parser_real_read_child_nodes (GXmlParser* self,
                                        GXmlDomNode* parent,
                                        GError** error);
static void gxml_parser_real_read_child_nodes_async_data_free (gpointer _data);
static void gxml_parser_real_read_child_nodes_async (GXmlParser* self,
                                              GXmlDomNode* parent,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
static gboolean gxml_parser_real_read_child_nodes_async_co (GxmlParserReadChildNodesAsyncData* _data_);
static gboolean _gxml_parser_real_read_child_nodes_async_co_gsource_func (gpointer self);
static gboolean gxml_parser_real_read_child_element (GXmlParser* self,
                                              GXmlDomNode* parent,
                                              GError** error);
static gboolean gxml_parser_real_read_element_property (GXmlParser* self,
                                                 GXmlDomNode* parent,
                                                 GXmlDomNode** element,
                                                 GError** error);
static void _g_param_spec_unref0_ (gpointer var);
static inline void _g_list_free__g_param_spec_unref0_ (GList* self);
static gboolean gxml_parser_real_add_element_collection (GXmlParser* self,
                                                  GXmlDomNode* parent,
                                                  GXmlDomNode** element,
                                                  GError** error);
static void gxml_parser_real_read_child_nodes_string (GXmlParser* self,
                                               const gchar* str,
                                               GError** error);
static guint8* _vala_array_dup3 (guint8* self,
                          gssize length);
static GType gxml_parser_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

GQuark
gxml_parser_error_quark (void)
{
#line 392 "../gxml/Object.vala"
	return g_quark_from_static_string ("gxml-parser-error-quark");
#line 153 "Parser.c"
}

gboolean
gxml_parser_get_backup (GXmlParser* self)
{
	GXmlParserIface* _iface_;
#line 41 "../gxml/Parser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 41 "../gxml/Parser.vala"
	if (_iface_->get_backup) {
#line 41 "../gxml/Parser.vala"
		return _iface_->get_backup (self);
#line 168 "Parser.c"
	}
#line 41 "../gxml/Parser.vala"
	return FALSE;
#line 172 "Parser.c"
}

void
gxml_parser_set_backup (GXmlParser* self,
                        gboolean value)
{
	GXmlParserIface* _iface_;
#line 41 "../gxml/Parser.vala"
	g_return_if_fail (self != NULL);
#line 41 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 41 "../gxml/Parser.vala"
	if (_iface_->set_backup) {
#line 41 "../gxml/Parser.vala"
		_iface_->set_backup (self, value);
#line 188 "Parser.c"
	}
}

gboolean
gxml_parser_get_indent (GXmlParser* self)
{
	GXmlParserIface* _iface_;
#line 45 "../gxml/Parser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 45 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 45 "../gxml/Parser.vala"
	if (_iface_->get_indent) {
#line 45 "../gxml/Parser.vala"
		return _iface_->get_indent (self);
#line 204 "Parser.c"
	}
#line 45 "../gxml/Parser.vala"
	return FALSE;
#line 208 "Parser.c"
}

void
gxml_parser_set_indent (GXmlParser* self,
                        gboolean value)
{
	GXmlParserIface* _iface_;
#line 45 "../gxml/Parser.vala"
	g_return_if_fail (self != NULL);
#line 45 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 45 "../gxml/Parser.vala"
	if (_iface_->set_indent) {
#line 45 "../gxml/Parser.vala"
		_iface_->set_indent (self, value);
#line 224 "Parser.c"
	}
}

GCancellable*
gxml_parser_get_cancellable (GXmlParser* self)
{
	GXmlParserIface* _iface_;
#line 49 "../gxml/Parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 49 "../gxml/Parser.vala"
	if (_iface_->get_cancellable) {
#line 49 "../gxml/Parser.vala"
		return _iface_->get_cancellable (self);
#line 240 "Parser.c"
	}
#line 49 "../gxml/Parser.vala"
	return NULL;
#line 244 "Parser.c"
}

void
gxml_parser_set_cancellable (GXmlParser* self,
                             GCancellable* value)
{
	GXmlParserIface* _iface_;
#line 49 "../gxml/Parser.vala"
	g_return_if_fail (self != NULL);
#line 49 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 49 "../gxml/Parser.vala"
	if (_iface_->set_cancellable) {
#line 49 "../gxml/Parser.vala"
		_iface_->set_cancellable (self, value);
#line 260 "Parser.c"
	}
}

GXmlDomNode*
gxml_parser_get_node (GXmlParser* self)
{
	GXmlParserIface* _iface_;
#line 53 "../gxml/Parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 53 "../gxml/Parser.vala"
	if (_iface_->get_node) {
#line 53 "../gxml/Parser.vala"
		return _iface_->get_node (self);
#line 276 "Parser.c"
	}
#line 53 "../gxml/Parser.vala"
	return NULL;
#line 280 "Parser.c"
}

GHashTable*
gxml_parser_get_types (GXmlParser* self)
{
	GXmlParserIface* _iface_;
#line 65 "../gxml/Parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 65 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 65 "../gxml/Parser.vala"
	if (_iface_->get_types) {
#line 65 "../gxml/Parser.vala"
		return _iface_->get_types (self);
#line 295 "Parser.c"
	}
#line 65 "../gxml/Parser.vala"
	return NULL;
#line 299 "Parser.c"
}

/**
   * Writes a {@link GXml.DomDocument} to a {@link GLib.File}
   */
static void
gxml_parser_real_write_file (GXmlParser* self,
                             GFile* file,
                             GError** error)
{
	GFileOutputStream* ostream = NULL;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GCancellable* _tmp2_;
	GCancellable* _tmp3_;
	GFileOutputStream* _tmp4_;
	GFileOutputStream* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 69 "../gxml/Parser.vala"
	g_return_if_fail (file != NULL);
#line 70 "../gxml/Parser.vala"
	_tmp0_ = gxml_parser_get_backup (self);
#line 70 "../gxml/Parser.vala"
	_tmp1_ = _tmp0_;
#line 70 "../gxml/Parser.vala"
	_tmp2_ = gxml_parser_get_cancellable (self);
#line 70 "../gxml/Parser.vala"
	_tmp3_ = _tmp2_;
#line 70 "../gxml/Parser.vala"
	_tmp4_ = g_file_replace (file, NULL, _tmp1_, G_FILE_CREATE_NONE, _tmp3_, &_inner_error0_);
#line 70 "../gxml/Parser.vala"
	ostream = _tmp4_;
#line 70 "../gxml/Parser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 70 "../gxml/Parser.vala"
		g_propagate_error (error, _inner_error0_);
#line 70 "../gxml/Parser.vala"
		return;
#line 338 "Parser.c"
	}
#line 72 "../gxml/Parser.vala"
	_tmp5_ = ostream;
#line 72 "../gxml/Parser.vala"
	gxml_parser_write_stream (self, (GOutputStream*) _tmp5_, &_inner_error0_);
#line 72 "../gxml/Parser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 72 "../gxml/Parser.vala"
		g_propagate_error (error, _inner_error0_);
#line 72 "../gxml/Parser.vala"
		_g_object_unref0 (ostream);
#line 72 "../gxml/Parser.vala"
		return;
#line 352 "Parser.c"
	}
#line 69 "../gxml/Parser.vala"
	_g_object_unref0 (ostream);
#line 356 "Parser.c"
}

void
gxml_parser_write_file (GXmlParser* self,
                        GFile* file,
                        GError** error)
{
	GXmlParserIface* _iface_;
#line 69 "../gxml/Parser.vala"
	g_return_if_fail (self != NULL);
#line 69 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 69 "../gxml/Parser.vala"
	if (_iface_->write_file) {
#line 69 "../gxml/Parser.vala"
		_iface_->write_file (self, file, error);
#line 373 "Parser.c"
	}
}

static void
gxml_parser_real_write_file_async_data_free (gpointer _data)
{
	GxmlParserWriteFileAsyncData* _data_;
	_data_ = _data;
#line 36 "../gxml/Parser.vala"
	_g_object_unref0 (_data_->file);
#line 36 "../gxml/Parser.vala"
	_g_object_unref0 (_data_->self);
#line 36 "../gxml/Parser.vala"
	g_slice_free (GxmlParserWriteFileAsyncData, _data_);
#line 388 "Parser.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 36 "../gxml/Parser.vala"
	return self ? g_object_ref (self) : NULL;
#line 396 "Parser.c"
}

static void
gxml_parser_real_write_file_async (GXmlParser* self,
                                   GFile* file,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	GxmlParserWriteFileAsyncData* _data_;
	GXmlParser* _tmp0_;
	GFile* _tmp1_;
#line 36 "../gxml/Parser.vala"
	g_return_if_fail (file != NULL);
#line 36 "../gxml/Parser.vala"
	_data_ = g_slice_new0 (GxmlParserWriteFileAsyncData);
#line 36 "../gxml/Parser.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 36 "../gxml/Parser.vala"
	g_task_set_task_data (_data_->_async_result, _data_, gxml_parser_real_write_file_async_data_free);
#line 36 "../gxml/Parser.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 36 "../gxml/Parser.vala"
	_data_->self = _tmp0_;
#line 36 "../gxml/Parser.vala"
	_tmp1_ = _g_object_ref0 (file);
#line 36 "../gxml/Parser.vala"
	_g_object_unref0 (_data_->file);
#line 36 "../gxml/Parser.vala"
	_data_->file = _tmp1_;
#line 36 "../gxml/Parser.vala"
	gxml_parser_real_write_file_async_co (_data_);
#line 428 "Parser.c"
}

static void
gxml_parser_real_write_file_finish (GXmlParser* self,
                                    GAsyncResult* _res_,
                                    GError** error)
{
	GxmlParserWriteFileAsyncData* _data_;
#line 36 "../gxml/Parser.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 36 "../gxml/Parser.vala"
	if (NULL == _data_) {
#line 36 "../gxml/Parser.vala"
		return;
#line 443 "Parser.c"
	}
}

/**
   * Writes a {@link GXml.DomDocument} to a {@link GLib.File}
   */
static void
gxml_parser_write_file_async_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_)
{
	GxmlParserWriteFileAsyncData* _data_;
#line 78 "../gxml/Parser.vala"
	_data_ = _user_data_;
#line 78 "../gxml/Parser.vala"
	_data_->_source_object_ = source_object;
#line 78 "../gxml/Parser.vala"
	_data_->_res_ = _res_;
#line 78 "../gxml/Parser.vala"
	gxml_parser_real_write_file_async_co (_data_);
#line 464 "Parser.c"
}

static gboolean
gxml_parser_real_write_file_async_co (GxmlParserWriteFileAsyncData* _data_)
{
#line 77 "../gxml/Parser.vala"
	switch (_data_->_state_) {
#line 77 "../gxml/Parser.vala"
		case 0:
#line 474 "Parser.c"
		goto _state_0;
#line 77 "../gxml/Parser.vala"
		case 1:
#line 478 "Parser.c"
		goto _state_1;
#line 77 "../gxml/Parser.vala"
		case 2:
#line 482 "Parser.c"
		goto _state_2;
		default:
#line 77 "../gxml/Parser.vala"
		g_assert_not_reached ();
#line 487 "Parser.c"
	}
	_state_0:
#line 78 "../gxml/Parser.vala"
	_data_->_tmp0_ = gxml_parser_get_backup (_data_->self);
#line 78 "../gxml/Parser.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 78 "../gxml/Parser.vala"
	_data_->_tmp2_ = gxml_parser_get_cancellable (_data_->self);
#line 78 "../gxml/Parser.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 78 "../gxml/Parser.vala"
	_data_->_state_ = 1;
#line 78 "../gxml/Parser.vala"
	g_file_replace_async (_data_->file, NULL, _data_->_tmp1_, G_FILE_CREATE_NONE, 0, _data_->_tmp3_, gxml_parser_write_file_async_ready, _data_);
#line 78 "../gxml/Parser.vala"
	return FALSE;
#line 504 "Parser.c"
	_state_1:
#line 78 "../gxml/Parser.vala"
	_data_->_tmp4_ = g_file_replace_finish (_data_->file, _data_->_res_, &_data_->_inner_error0_);
#line 78 "../gxml/Parser.vala"
	_data_->ostream = _data_->_tmp4_;
#line 78 "../gxml/Parser.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 78 "../gxml/Parser.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 78 "../gxml/Parser.vala"
		g_object_unref (_data_->_async_result);
#line 78 "../gxml/Parser.vala"
		return FALSE;
#line 518 "Parser.c"
	}
#line 80 "../gxml/Parser.vala"
	_data_->_tmp5_ = _data_->ostream;
#line 80 "../gxml/Parser.vala"
	_data_->_state_ = 2;
#line 80 "../gxml/Parser.vala"
	gxml_parser_write_stream_async (_data_->self, (GOutputStream*) _data_->_tmp5_, gxml_parser_write_file_async_ready, _data_);
#line 80 "../gxml/Parser.vala"
	return FALSE;
#line 528 "Parser.c"
	_state_2:
#line 80 "../gxml/Parser.vala"
	gxml_parser_write_stream_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 80 "../gxml/Parser.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 80 "../gxml/Parser.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 80 "../gxml/Parser.vala"
		_g_object_unref0 (_data_->ostream);
#line 80 "../gxml/Parser.vala"
		g_object_unref (_data_->_async_result);
#line 80 "../gxml/Parser.vala"
		return FALSE;
#line 542 "Parser.c"
	}
#line 77 "../gxml/Parser.vala"
	_g_object_unref0 (_data_->ostream);
#line 77 "../gxml/Parser.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 77 "../gxml/Parser.vala"
	if (_data_->_state_ != 0) {
#line 77 "../gxml/Parser.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 77 "../gxml/Parser.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 554 "Parser.c"
		}
	}
#line 77 "../gxml/Parser.vala"
	g_object_unref (_data_->_async_result);
#line 77 "../gxml/Parser.vala"
	return FALSE;
#line 561 "Parser.c"
}

void
gxml_parser_write_file_async (GXmlParser* self,
                              GFile* file,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	GXmlParserIface* _iface_;
#line 36 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 36 "../gxml/Parser.vala"
	if (_iface_->write_file_async) {
#line 36 "../gxml/Parser.vala"
		_iface_->write_file_async (self, file, _callback_, _user_data_);
#line 577 "Parser.c"
	}
}

void
gxml_parser_write_file_finish (GXmlParser* self,
                               GAsyncResult* _res_,
                               GError** error)
{
	GXmlParserIface* _iface_;
#line 36 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 36 "../gxml/Parser.vala"
	if (_iface_->write_file_finish) {
#line 36 "../gxml/Parser.vala"
		_iface_->write_file_finish (self, _res_, error);
#line 593 "Parser.c"
	}
}

/**
   * Writes a {@link node} to a string
   */
gchar*
gxml_parser_write_string (GXmlParser* self,
                          GError** error)
{
	GXmlParserIface* _iface_;
#line 85 "../gxml/Parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 85 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 85 "../gxml/Parser.vala"
	if (_iface_->write_string) {
#line 85 "../gxml/Parser.vala"
		return _iface_->write_string (self, error);
#line 613 "Parser.c"
	}
#line 85 "../gxml/Parser.vala"
	return NULL;
#line 617 "Parser.c"
}

void
gxml_parser_write_string_async (GXmlParser* self,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	GXmlParserIface* _iface_;
#line 36 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 36 "../gxml/Parser.vala"
	if (_iface_->write_string_async) {
#line 36 "../gxml/Parser.vala"
		_iface_->write_string_async (self, _callback_, _user_data_);
#line 632 "Parser.c"
	}
}

gchar*
gxml_parser_write_string_finish (GXmlParser* self,
                                 GAsyncResult* _res_,
                                 GError** error)
{
	GXmlParserIface* _iface_;
#line 36 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 36 "../gxml/Parser.vala"
	if (_iface_->write_string_finish) {
#line 36 "../gxml/Parser.vala"
		return _iface_->write_string_finish (self, _res_, error);
#line 648 "Parser.c"
	}
#line 36 "../gxml/Parser.vala"
	return NULL;
#line 652 "Parser.c"
}

/**
   * Writes a {@link GXml.DomDocument} to a {@link GLib.OutputStream}
   */
void
gxml_parser_write_stream (GXmlParser* self,
                          GOutputStream* stream,
                          GError** error)
{
	GXmlParserIface* _iface_;
#line 93 "../gxml/Parser.vala"
	g_return_if_fail (self != NULL);
#line 93 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 93 "../gxml/Parser.vala"
	if (_iface_->write_stream) {
#line 93 "../gxml/Parser.vala"
		_iface_->write_stream (self, stream, error);
#line 672 "Parser.c"
	}
}

void
gxml_parser_write_stream_async (GXmlParser* self,
                                GOutputStream* stream,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	GXmlParserIface* _iface_;
#line 36 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 36 "../gxml/Parser.vala"
	if (_iface_->write_stream_async) {
#line 36 "../gxml/Parser.vala"
		_iface_->write_stream_async (self, stream, _callback_, _user_data_);
#line 689 "Parser.c"
	}
}

void
gxml_parser_write_stream_finish (GXmlParser* self,
                                 GAsyncResult* _res_,
                                 GError** error)
{
	GXmlParserIface* _iface_;
#line 36 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 36 "../gxml/Parser.vala"
	if (_iface_->write_stream_finish) {
#line 36 "../gxml/Parser.vala"
		_iface_->write_stream_finish (self, _res_, error);
#line 705 "Parser.c"
	}
}

/**
   * Reads a {@link node} from a {@link GLib.File}
   */
static void
gxml_parser_real_read_file (GXmlParser* self,
                            GFile* file,
                            GError** error)
{
	GFileInputStream* _tmp1_ = NULL;
	GFileInputStream* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 101 "../gxml/Parser.vala"
	g_return_if_fail (file != NULL);
#line 103 "../gxml/Parser.vala"
	if (!g_file_query_exists (file, NULL)) {
#line 724 "Parser.c"
		GError* _tmp0_;
#line 104 "../gxml/Parser.vala"
		_tmp0_ = g_error_new_literal (GXML_PARSER_ERROR, GXML_PARSER_ERROR_INVALID_FILE_ERROR, _ ("File doesn't exist"));
#line 104 "../gxml/Parser.vala"
		_inner_error0_ = _tmp0_;
#line 104 "../gxml/Parser.vala"
		g_propagate_error (error, _inner_error0_);
#line 104 "../gxml/Parser.vala"
		return;
#line 734 "Parser.c"
	}
#line 105 "../gxml/Parser.vala"
	_tmp2_ = g_file_read (file, NULL, &_inner_error0_);
#line 105 "../gxml/Parser.vala"
	_tmp1_ = _tmp2_;
#line 105 "../gxml/Parser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 105 "../gxml/Parser.vala"
		g_propagate_error (error, _inner_error0_);
#line 105 "../gxml/Parser.vala"
		return;
#line 746 "Parser.c"
	}
#line 105 "../gxml/Parser.vala"
	gxml_parser_read_stream (self, (GInputStream*) _tmp1_, &_inner_error0_);
#line 105 "../gxml/Parser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 105 "../gxml/Parser.vala"
		g_propagate_error (error, _inner_error0_);
#line 105 "../gxml/Parser.vala"
		_g_object_unref0 (_tmp1_);
#line 105 "../gxml/Parser.vala"
		return;
#line 758 "Parser.c"
	}
#line 101 "../gxml/Parser.vala"
	_g_object_unref0 (_tmp1_);
#line 762 "Parser.c"
}

void
gxml_parser_read_file (GXmlParser* self,
                       GFile* file,
                       GError** error)
{
	GXmlParserIface* _iface_;
#line 101 "../gxml/Parser.vala"
	g_return_if_fail (self != NULL);
#line 101 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 101 "../gxml/Parser.vala"
	if (_iface_->read_file) {
#line 101 "../gxml/Parser.vala"
		_iface_->read_file (self, file, error);
#line 779 "Parser.c"
	}
}

static void
gxml_parser_real_read_file_async_data_free (gpointer _data)
{
	GxmlParserReadFileAsyncData* _data_;
	_data_ = _data;
#line 36 "../gxml/Parser.vala"
	_g_object_unref0 (_data_->file);
#line 36 "../gxml/Parser.vala"
	_g_object_unref0 (_data_->self);
#line 36 "../gxml/Parser.vala"
	g_slice_free (GxmlParserReadFileAsyncData, _data_);
#line 794 "Parser.c"
}

static void
gxml_parser_real_read_file_async (GXmlParser* self,
                                  GFile* file,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	GxmlParserReadFileAsyncData* _data_;
	GXmlParser* _tmp0_;
	GFile* _tmp1_;
#line 36 "../gxml/Parser.vala"
	g_return_if_fail (file != NULL);
#line 36 "../gxml/Parser.vala"
	_data_ = g_slice_new0 (GxmlParserReadFileAsyncData);
#line 36 "../gxml/Parser.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 36 "../gxml/Parser.vala"
	g_task_set_task_data (_data_->_async_result, _data_, gxml_parser_real_read_file_async_data_free);
#line 36 "../gxml/Parser.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 36 "../gxml/Parser.vala"
	_data_->self = _tmp0_;
#line 36 "../gxml/Parser.vala"
	_tmp1_ = _g_object_ref0 (file);
#line 36 "../gxml/Parser.vala"
	_g_object_unref0 (_data_->file);
#line 36 "../gxml/Parser.vala"
	_data_->file = _tmp1_;
#line 36 "../gxml/Parser.vala"
	gxml_parser_real_read_file_async_co (_data_);
#line 826 "Parser.c"
}

static void
gxml_parser_real_read_file_finish (GXmlParser* self,
                                   GAsyncResult* _res_,
                                   GError** error)
{
	GxmlParserReadFileAsyncData* _data_;
#line 36 "../gxml/Parser.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 36 "../gxml/Parser.vala"
	if (NULL == _data_) {
#line 36 "../gxml/Parser.vala"
		return;
#line 841 "Parser.c"
	}
}

/**
   * Reads a {@link GXml.DomDocument} from a {@link GLib.File}
   */
static gboolean
_gxml_parser_real_read_file_async_co_gsource_func (gpointer self)
{
	gboolean result;
	result = gxml_parser_real_read_file_async_co (self);
#line 113 "../gxml/Parser.vala"
	return result;
#line 855 "Parser.c"
}

static void
gxml_parser_read_file_async_ready (GObject* source_object,
                                   GAsyncResult* _res_,
                                   gpointer _user_data_)
{
	GxmlParserReadFileAsyncData* _data_;
#line 115 "../gxml/Parser.vala"
	_data_ = _user_data_;
#line 115 "../gxml/Parser.vala"
	_data_->_source_object_ = source_object;
#line 115 "../gxml/Parser.vala"
	_data_->_res_ = _res_;
#line 115 "../gxml/Parser.vala"
	gxml_parser_real_read_file_async_co (_data_);
#line 872 "Parser.c"
}

static gboolean
gxml_parser_real_read_file_async_co (GxmlParserReadFileAsyncData* _data_)
{
#line 110 "../gxml/Parser.vala"
	switch (_data_->_state_) {
#line 110 "../gxml/Parser.vala"
		case 0:
#line 882 "Parser.c"
		goto _state_0;
#line 110 "../gxml/Parser.vala"
		case 1:
#line 886 "Parser.c"
		goto _state_1;
#line 110 "../gxml/Parser.vala"
		case 2:
#line 890 "Parser.c"
		goto _state_2;
		default:
#line 110 "../gxml/Parser.vala"
		g_assert_not_reached ();
#line 895 "Parser.c"
	}
	_state_0:
#line 111 "../gxml/Parser.vala"
	if (!g_file_query_exists (_data_->file, NULL)) {
#line 112 "../gxml/Parser.vala"
		_data_->_tmp0_ = g_error_new_literal (GXML_PARSER_ERROR, GXML_PARSER_ERROR_INVALID_FILE_ERROR, _ ("File doesn't exist"));
#line 112 "../gxml/Parser.vala"
		_data_->_inner_error0_ = _data_->_tmp0_;
#line 112 "../gxml/Parser.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 112 "../gxml/Parser.vala"
		g_object_unref (_data_->_async_result);
#line 112 "../gxml/Parser.vala"
		return FALSE;
#line 910 "Parser.c"
	}
#line 113 "../gxml/Parser.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _gxml_parser_real_read_file_async_co_gsource_func, _data_, NULL);
#line 114 "../gxml/Parser.vala"
	_data_->_state_ = 1;
#line 114 "../gxml/Parser.vala"
	return FALSE;
#line 918 "Parser.c"
	_state_1:
	;
#line 115 "../gxml/Parser.vala"
	_data_->_tmp2_ = g_file_read (_data_->file, NULL, &_data_->_inner_error0_);
#line 115 "../gxml/Parser.vala"
	_data_->_tmp1_ = _data_->_tmp2_;
#line 115 "../gxml/Parser.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 115 "../gxml/Parser.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 115 "../gxml/Parser.vala"
		g_object_unref (_data_->_async_result);
#line 115 "../gxml/Parser.vala"
		return FALSE;
#line 933 "Parser.c"
	}
#line 115 "../gxml/Parser.vala"
	_data_->_state_ = 2;
#line 115 "../gxml/Parser.vala"
	gxml_parser_read_stream_async (_data_->self, (GInputStream*) _data_->_tmp1_, gxml_parser_read_file_async_ready, _data_);
#line 115 "../gxml/Parser.vala"
	return FALSE;
#line 941 "Parser.c"
	_state_2:
#line 115 "../gxml/Parser.vala"
	gxml_parser_read_stream_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 115 "../gxml/Parser.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 115 "../gxml/Parser.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 115 "../gxml/Parser.vala"
		_g_object_unref0 (_data_->_tmp1_);
#line 115 "../gxml/Parser.vala"
		g_object_unref (_data_->_async_result);
#line 115 "../gxml/Parser.vala"
		return FALSE;
#line 955 "Parser.c"
	}
#line 110 "../gxml/Parser.vala"
	_g_object_unref0 (_data_->_tmp1_);
#line 110 "../gxml/Parser.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 110 "../gxml/Parser.vala"
	if (_data_->_state_ != 0) {
#line 110 "../gxml/Parser.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 110 "../gxml/Parser.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 967 "Parser.c"
		}
	}
#line 110 "../gxml/Parser.vala"
	g_object_unref (_data_->_async_result);
#line 110 "../gxml/Parser.vala"
	return FALSE;
#line 974 "Parser.c"
}

void
gxml_parser_read_file_async (GXmlParser* self,
                             GFile* file,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_)
{
	GXmlParserIface* _iface_;
#line 36 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 36 "../gxml/Parser.vala"
	if (_iface_->read_file_async) {
#line 36 "../gxml/Parser.vala"
		_iface_->read_file_async (self, file, _callback_, _user_data_);
#line 990 "Parser.c"
	}
}

void
gxml_parser_read_file_finish (GXmlParser* self,
                              GAsyncResult* _res_,
                              GError** error)
{
	GXmlParserIface* _iface_;
#line 36 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 36 "../gxml/Parser.vala"
	if (_iface_->read_file_finish) {
#line 36 "../gxml/Parser.vala"
		_iface_->read_file_finish (self, _res_, error);
#line 1006 "Parser.c"
	}
}

/**
   * Read a {@link GXml.DomDocument} from a {@link GLib.InputStream}
   */
void
gxml_parser_read_stream (GXmlParser* self,
                         GInputStream* stream,
                         GError** error)
{
	GXmlParserIface* _iface_;
#line 121 "../gxml/Parser.vala"
	g_return_if_fail (self != NULL);
#line 121 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 121 "../gxml/Parser.vala"
	if (_iface_->read_stream) {
#line 121 "../gxml/Parser.vala"
		_iface_->read_stream (self, stream, error);
#line 1027 "Parser.c"
	}
}

void
gxml_parser_read_stream_async (GXmlParser* self,
                               GInputStream* stream,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	GXmlParserIface* _iface_;
#line 36 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 36 "../gxml/Parser.vala"
	if (_iface_->read_stream_async) {
#line 36 "../gxml/Parser.vala"
		_iface_->read_stream_async (self, stream, _callback_, _user_data_);
#line 1044 "Parser.c"
	}
}

void
gxml_parser_read_stream_finish (GXmlParser* self,
                                GAsyncResult* _res_,
                                GError** error)
{
	GXmlParserIface* _iface_;
#line 36 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 36 "../gxml/Parser.vala"
	if (_iface_->read_stream_finish) {
#line 36 "../gxml/Parser.vala"
		_iface_->read_stream_finish (self, _res_, error);
#line 1060 "Parser.c"
	}
}

/**
   * Reads a {@link node} from a string
   */
void
gxml_parser_read_string (GXmlParser* self,
                         const gchar* str,
                         GError** error)
{
	GXmlParserIface* _iface_;
#line 130 "../gxml/Parser.vala"
	g_return_if_fail (self != NULL);
#line 130 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 130 "../gxml/Parser.vala"
	if (_iface_->read_string) {
#line 130 "../gxml/Parser.vala"
		_iface_->read_string (self, str, error);
#line 1081 "Parser.c"
	}
}

void
gxml_parser_read_string_async (GXmlParser* self,
                               const gchar* str,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	GXmlParserIface* _iface_;
#line 36 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 36 "../gxml/Parser.vala"
	if (_iface_->read_string_async) {
#line 36 "../gxml/Parser.vala"
		_iface_->read_string_async (self, str, _callback_, _user_data_);
#line 1098 "Parser.c"
	}
}

void
gxml_parser_read_string_finish (GXmlParser* self,
                                GAsyncResult* _res_,
                                GError** error)
{
	GXmlParserIface* _iface_;
#line 36 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 36 "../gxml/Parser.vala"
	if (_iface_->read_string_finish) {
#line 36 "../gxml/Parser.vala"
		_iface_->read_string_finish (self, _res_, error);
#line 1114 "Parser.c"
	}
}

/**
   * Creates an {@link GLib.InputStream} to write a string representation
   * in XML
   */
GInputStream*
gxml_parser_create_stream (GXmlParser* self,
                           GError** error)
{
	GXmlParserIface* _iface_;
#line 140 "../gxml/Parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 140 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 140 "../gxml/Parser.vala"
	if (_iface_->create_stream) {
#line 140 "../gxml/Parser.vala"
		return _iface_->create_stream (self, error);
#line 1135 "Parser.c"
	}
#line 140 "../gxml/Parser.vala"
	return NULL;
#line 1139 "Parser.c"
}

void
gxml_parser_create_stream_async (GXmlParser* self,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	GXmlParserIface* _iface_;
#line 36 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 36 "../gxml/Parser.vala"
	if (_iface_->create_stream_async) {
#line 36 "../gxml/Parser.vala"
		_iface_->create_stream_async (self, _callback_, _user_data_);
#line 1154 "Parser.c"
	}
}

GInputStream*
gxml_parser_create_stream_finish (GXmlParser* self,
                                  GAsyncResult* _res_,
                                  GError** error)
{
	GXmlParserIface* _iface_;
#line 36 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 36 "../gxml/Parser.vala"
	if (_iface_->create_stream_finish) {
#line 36 "../gxml/Parser.vala"
		return _iface_->create_stream_finish (self, _res_, error);
#line 1170 "Parser.c"
	}
#line 36 "../gxml/Parser.vala"
	return NULL;
#line 1174 "Parser.c"
}

/**
   * Iterates in all child nodes and append them to node.
   */
static void
gxml_parser_real_read_child_nodes (GXmlParser* self,
                                   GXmlDomNode* parent,
                                   GError** error)
{
	gboolean cont = FALSE;
	GError* _inner_error0_ = NULL;
#line 149 "../gxml/Parser.vala"
	g_return_if_fail (parent != NULL);
#line 150 "../gxml/Parser.vala"
	cont = TRUE;
#line 151 "../gxml/Parser.vala"
	while (TRUE) {
#line 1193 "Parser.c"
		gboolean _tmp1_ = FALSE;
#line 151 "../gxml/Parser.vala"
		if (!cont) {
#line 151 "../gxml/Parser.vala"
			break;
#line 1199 "Parser.c"
		}
#line 152 "../gxml/Parser.vala"
		if (GXML_IS_DOM_DOCUMENT (parent)) {
#line 1203 "Parser.c"
			gboolean _tmp0_ = FALSE;
#line 153 "../gxml/Parser.vala"
			_tmp0_ = gxml_parser_read_child_node (self, parent, &_inner_error0_);
#line 153 "../gxml/Parser.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 153 "../gxml/Parser.vala"
				g_propagate_error (error, _inner_error0_);
#line 153 "../gxml/Parser.vala"
				return;
#line 1213 "Parser.c"
			}
#line 153 "../gxml/Parser.vala"
			cont = _tmp0_;
#line 1217 "Parser.c"
		}
#line 155 "../gxml/Parser.vala"
		_tmp1_ = gxml_parser_move_next_node (self, &_inner_error0_);
#line 155 "../gxml/Parser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 155 "../gxml/Parser.vala"
			g_propagate_error (error, _inner_error0_);
#line 155 "../gxml/Parser.vala"
			return;
#line 1227 "Parser.c"
		}
#line 155 "../gxml/Parser.vala"
		if (!_tmp1_) {
#line 155 "../gxml/Parser.vala"
			return;
#line 1233 "Parser.c"
		}
#line 156 "../gxml/Parser.vala"
		if (gxml_parser_current_is_element (self)) {
#line 1237 "Parser.c"
			gboolean _tmp2_ = FALSE;
#line 157 "../gxml/Parser.vala"
			_tmp2_ = gxml_parser_read_child_element (self, parent, &_inner_error0_);
#line 157 "../gxml/Parser.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 157 "../gxml/Parser.vala"
				g_propagate_error (error, _inner_error0_);
#line 157 "../gxml/Parser.vala"
				return;
#line 1247 "Parser.c"
			}
#line 157 "../gxml/Parser.vala"
			cont = _tmp2_;
#line 1251 "Parser.c"
		} else {
			gboolean _tmp3_ = FALSE;
#line 159 "../gxml/Parser.vala"
			_tmp3_ = gxml_parser_read_child_node (self, parent, &_inner_error0_);
#line 159 "../gxml/Parser.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 159 "../gxml/Parser.vala"
				g_propagate_error (error, _inner_error0_);
#line 159 "../gxml/Parser.vala"
				return;
#line 1262 "Parser.c"
			}
#line 159 "../gxml/Parser.vala"
			cont = _tmp3_;
#line 1266 "Parser.c"
		}
	}
}

void
gxml_parser_read_child_nodes (GXmlParser* self,
                              GXmlDomNode* parent,
                              GError** error)
{
	GXmlParserIface* _iface_;
#line 149 "../gxml/Parser.vala"
	g_return_if_fail (self != NULL);
#line 149 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 149 "../gxml/Parser.vala"
	if (_iface_->read_child_nodes) {
#line 149 "../gxml/Parser.vala"
		_iface_->read_child_nodes (self, parent, error);
#line 1285 "Parser.c"
	}
}

static void
gxml_parser_real_read_child_nodes_async_data_free (gpointer _data)
{
	GxmlParserReadChildNodesAsyncData* _data_;
	_data_ = _data;
#line 36 "../gxml/Parser.vala"
	_g_object_unref0 (_data_->parent);
#line 36 "../gxml/Parser.vala"
	_g_object_unref0 (_data_->self);
#line 36 "../gxml/Parser.vala"
	g_slice_free (GxmlParserReadChildNodesAsyncData, _data_);
#line 1300 "Parser.c"
}

static void
gxml_parser_real_read_child_nodes_async (GXmlParser* self,
                                         GXmlDomNode* parent,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	GxmlParserReadChildNodesAsyncData* _data_;
	GXmlParser* _tmp0_;
	GXmlDomNode* _tmp1_;
#line 36 "../gxml/Parser.vala"
	g_return_if_fail (parent != NULL);
#line 36 "../gxml/Parser.vala"
	_data_ = g_slice_new0 (GxmlParserReadChildNodesAsyncData);
#line 36 "../gxml/Parser.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 36 "../gxml/Parser.vala"
	g_task_set_task_data (_data_->_async_result, _data_, gxml_parser_real_read_child_nodes_async_data_free);
#line 36 "../gxml/Parser.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 36 "../gxml/Parser.vala"
	_data_->self = _tmp0_;
#line 36 "../gxml/Parser.vala"
	_tmp1_ = _g_object_ref0 (parent);
#line 36 "../gxml/Parser.vala"
	_g_object_unref0 (_data_->parent);
#line 36 "../gxml/Parser.vala"
	_data_->parent = _tmp1_;
#line 36 "../gxml/Parser.vala"
	gxml_parser_real_read_child_nodes_async_co (_data_);
#line 1332 "Parser.c"
}

static void
gxml_parser_real_read_child_nodes_finish (GXmlParser* self,
                                          GAsyncResult* _res_,
                                          GError** error)
{
	GxmlParserReadChildNodesAsyncData* _data_;
#line 36 "../gxml/Parser.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 36 "../gxml/Parser.vala"
	if (NULL == _data_) {
#line 36 "../gxml/Parser.vala"
		return;
#line 1347 "Parser.c"
	}
}

/**
   * Iterates in all child nodes and append them to node.
   */
static gboolean
_gxml_parser_real_read_child_nodes_async_co_gsource_func (gpointer self)
{
	gboolean result;
	result = gxml_parser_real_read_child_nodes_async_co (self);
#line 168 "../gxml/Parser.vala"
	return result;
#line 1361 "Parser.c"
}

static gboolean
gxml_parser_real_read_child_nodes_async_co (GxmlParserReadChildNodesAsyncData* _data_)
{
#line 165 "../gxml/Parser.vala"
	switch (_data_->_state_) {
#line 165 "../gxml/Parser.vala"
		case 0:
#line 1371 "Parser.c"
		goto _state_0;
#line 165 "../gxml/Parser.vala"
		case 1:
#line 1375 "Parser.c"
		goto _state_1;
		default:
#line 165 "../gxml/Parser.vala"
		g_assert_not_reached ();
#line 1380 "Parser.c"
	}
	_state_0:
#line 166 "../gxml/Parser.vala"
	_data_->cont = TRUE;
#line 167 "../gxml/Parser.vala"
	while (TRUE) {
#line 167 "../gxml/Parser.vala"
		if (!_data_->cont) {
#line 167 "../gxml/Parser.vala"
			break;
#line 1391 "Parser.c"
		}
#line 168 "../gxml/Parser.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _gxml_parser_real_read_child_nodes_async_co_gsource_func, _data_, NULL);
#line 169 "../gxml/Parser.vala"
		_data_->_state_ = 1;
#line 169 "../gxml/Parser.vala"
		return FALSE;
#line 1399 "Parser.c"
		_state_1:
		;
#line 170 "../gxml/Parser.vala"
		_data_->_tmp0_ = gxml_parser_move_next_node (_data_->self, &_data_->_inner_error0_);
#line 170 "../gxml/Parser.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 170 "../gxml/Parser.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 170 "../gxml/Parser.vala"
			g_object_unref (_data_->_async_result);
#line 170 "../gxml/Parser.vala"
			return FALSE;
#line 1412 "Parser.c"
		}
#line 170 "../gxml/Parser.vala"
		if (!_data_->_tmp0_) {
#line 170 "../gxml/Parser.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 170 "../gxml/Parser.vala"
			if (_data_->_state_ != 0) {
#line 170 "../gxml/Parser.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 170 "../gxml/Parser.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1424 "Parser.c"
				}
			}
#line 170 "../gxml/Parser.vala"
			g_object_unref (_data_->_async_result);
#line 170 "../gxml/Parser.vala"
			return FALSE;
#line 1431 "Parser.c"
		}
#line 171 "../gxml/Parser.vala"
		if (gxml_parser_current_is_element (_data_->self)) {
#line 172 "../gxml/Parser.vala"
			_data_->_tmp1_ = gxml_parser_read_child_element (_data_->self, _data_->parent, &_data_->_inner_error0_);
#line 172 "../gxml/Parser.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 172 "../gxml/Parser.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 172 "../gxml/Parser.vala"
				g_object_unref (_data_->_async_result);
#line 172 "../gxml/Parser.vala"
				return FALSE;
#line 1445 "Parser.c"
			}
#line 172 "../gxml/Parser.vala"
			_data_->cont = _data_->_tmp1_;
#line 1449 "Parser.c"
		} else {
#line 174 "../gxml/Parser.vala"
			_data_->_tmp2_ = gxml_parser_read_child_node (_data_->self, _data_->parent, &_data_->_inner_error0_);
#line 174 "../gxml/Parser.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 174 "../gxml/Parser.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 174 "../gxml/Parser.vala"
				g_object_unref (_data_->_async_result);
#line 174 "../gxml/Parser.vala"
				return FALSE;
#line 1461 "Parser.c"
			}
#line 174 "../gxml/Parser.vala"
			_data_->cont = _data_->_tmp2_;
#line 1465 "Parser.c"
		}
	}
#line 165 "../gxml/Parser.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 165 "../gxml/Parser.vala"
	if (_data_->_state_ != 0) {
#line 165 "../gxml/Parser.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 165 "../gxml/Parser.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1476 "Parser.c"
		}
	}
#line 165 "../gxml/Parser.vala"
	g_object_unref (_data_->_async_result);
#line 165 "../gxml/Parser.vala"
	return FALSE;
#line 1483 "Parser.c"
}

void
gxml_parser_read_child_nodes_async (GXmlParser* self,
                                    GXmlDomNode* parent,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	GXmlParserIface* _iface_;
#line 36 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 36 "../gxml/Parser.vala"
	if (_iface_->read_child_nodes_async) {
#line 36 "../gxml/Parser.vala"
		_iface_->read_child_nodes_async (self, parent, _callback_, _user_data_);
#line 1499 "Parser.c"
	}
}

void
gxml_parser_read_child_nodes_finish (GXmlParser* self,
                                     GAsyncResult* _res_,
                                     GError** error)
{
	GXmlParserIface* _iface_;
#line 36 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 36 "../gxml/Parser.vala"
	if (_iface_->read_child_nodes_finish) {
#line 36 "../gxml/Parser.vala"
		_iface_->read_child_nodes_finish (self, _res_, error);
#line 1515 "Parser.c"
	}
}

/**
   * Creates a new {@link DomNode} and append it to
   * parent: depending on current node's type found by parser.
   *
   * If current found node is a {@link DomElement}, it is not parsed.
   * If you want to parse it use {@link read_element} method.
   *
   * Returns: true if node has been created and appended to parent.
   */
gboolean
gxml_parser_read_child_node (GXmlParser* self,
                             GXmlDomNode* parent,
                             GError** error)
{
	GXmlParserIface* _iface_;
#line 186 "../gxml/Parser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 186 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 186 "../gxml/Parser.vala"
	if (_iface_->read_child_node) {
#line 186 "../gxml/Parser.vala"
		return _iface_->read_child_node (self, parent, error);
#line 1542 "Parser.c"
	}
#line 186 "../gxml/Parser.vala"
	return FALSE;
#line 1546 "Parser.c"
}

/**
   * Reads current found element
   */
static gboolean
gxml_parser_real_read_child_element (GXmlParser* self,
                                     GXmlDomNode* parent,
                                     GError** error)
{
	gboolean isempty = FALSE;
	GXmlDomNode* n = NULL;
	gboolean _tmp2_ = FALSE;
	GXmlDomNode* _tmp3_ = NULL;
	gboolean _tmp4_;
	GXmlDomNode* _tmp16_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 190 "../gxml/Parser.vala"
	g_return_val_if_fail (parent != NULL, FALSE);
#line 191 "../gxml/Parser.vala"
	if (!gxml_parser_current_is_element (self)) {
#line 1569 "Parser.c"
		GError* _tmp0_;
		gboolean _tmp1_ = FALSE;
#line 192 "../gxml/Parser.vala"
		_tmp0_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Invalid attempt to parse an element node, when current found node is n" \
"ot"));
#line 192 "../gxml/Parser.vala"
		_inner_error0_ = _tmp0_;
#line 192 "../gxml/Parser.vala"
		g_propagate_error (error, _inner_error0_);
#line 192 "../gxml/Parser.vala"
		return _tmp1_;
#line 1580 "Parser.c"
	}
#line 194 "../gxml/Parser.vala"
	isempty = gxml_parser_current_is_empty_element (self);
#line 195 "../gxml/Parser.vala"
	n = NULL;
#line 196 "../gxml/Parser.vala"
	_tmp4_ = gxml_parser_read_element_property (self, parent, &_tmp3_, &_inner_error0_);
#line 196 "../gxml/Parser.vala"
	_g_object_unref0 (n);
#line 196 "../gxml/Parser.vala"
	n = _tmp3_;
#line 196 "../gxml/Parser.vala"
	_tmp2_ = _tmp4_;
#line 196 "../gxml/Parser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1596 "Parser.c"
		gboolean _tmp5_ = FALSE;
#line 196 "../gxml/Parser.vala"
		g_propagate_error (error, _inner_error0_);
#line 196 "../gxml/Parser.vala"
		_g_object_unref0 (n);
#line 196 "../gxml/Parser.vala"
		return _tmp5_;
#line 1604 "Parser.c"
	}
#line 196 "../gxml/Parser.vala"
	if (!_tmp2_) {
#line 1608 "Parser.c"
		gboolean _tmp6_ = FALSE;
		GXmlDomNode* _tmp7_ = NULL;
		gboolean _tmp8_;
#line 197 "../gxml/Parser.vala"
		_tmp8_ = gxml_parser_add_element_collection (self, parent, &_tmp7_, &_inner_error0_);
#line 197 "../gxml/Parser.vala"
		_g_object_unref0 (n);
#line 197 "../gxml/Parser.vala"
		n = _tmp7_;
#line 197 "../gxml/Parser.vala"
		_tmp6_ = _tmp8_;
#line 197 "../gxml/Parser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1622 "Parser.c"
			gboolean _tmp9_ = FALSE;
#line 197 "../gxml/Parser.vala"
			g_propagate_error (error, _inner_error0_);
#line 197 "../gxml/Parser.vala"
			_g_object_unref0 (n);
#line 197 "../gxml/Parser.vala"
			return _tmp9_;
#line 1630 "Parser.c"
		}
#line 197 "../gxml/Parser.vala"
		if (!_tmp6_) {
#line 1634 "Parser.c"
			GXmlDomElement* _tmp10_ = NULL;
			GXmlDomElement* _tmp11_;
			GXmlDomElement* _tmp13_;
			GXmlDomNode* _tmp14_;
#line 198 "../gxml/Parser.vala"
			_tmp11_ = gxml_parser_create_element (self, parent, &_inner_error0_);
#line 198 "../gxml/Parser.vala"
			_tmp10_ = _tmp11_;
#line 198 "../gxml/Parser.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1645 "Parser.c"
				gboolean _tmp12_ = FALSE;
#line 198 "../gxml/Parser.vala"
				g_propagate_error (error, _inner_error0_);
#line 198 "../gxml/Parser.vala"
				_g_object_unref0 (n);
#line 198 "../gxml/Parser.vala"
				return _tmp12_;
#line 1653 "Parser.c"
			}
#line 198 "../gxml/Parser.vala"
			_tmp13_ = _tmp10_;
#line 198 "../gxml/Parser.vala"
			_tmp10_ = NULL;
#line 198 "../gxml/Parser.vala"
			_g_object_unref0 (n);
#line 198 "../gxml/Parser.vala"
			n = (GXmlDomNode*) _tmp13_;
#line 199 "../gxml/Parser.vala"
			_tmp14_ = n;
#line 199 "../gxml/Parser.vala"
			gxml_parser_read_element (self, GXML_IS_DOM_ELEMENT (_tmp14_) ? ((GXmlDomElement*) _tmp14_) : NULL, &_inner_error0_);
#line 199 "../gxml/Parser.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1669 "Parser.c"
				gboolean _tmp15_ = FALSE;
#line 199 "../gxml/Parser.vala"
				g_propagate_error (error, _inner_error0_);
#line 199 "../gxml/Parser.vala"
				_g_object_unref0 (_tmp10_);
#line 199 "../gxml/Parser.vala"
				_g_object_unref0 (n);
#line 199 "../gxml/Parser.vala"
				return _tmp15_;
#line 1679 "Parser.c"
			}
#line 197 "../gxml/Parser.vala"
			_g_object_unref0 (_tmp10_);
#line 1683 "Parser.c"
		}
	}
#line 201 "../gxml/Parser.vala"
	_tmp16_ = n;
#line 201 "../gxml/Parser.vala"
	if (_tmp16_ == NULL) {
#line 201 "../gxml/Parser.vala"
		result = FALSE;
#line 201 "../gxml/Parser.vala"
		_g_object_unref0 (n);
#line 201 "../gxml/Parser.vala"
		return result;
#line 1696 "Parser.c"
	}
#line 202 "../gxml/Parser.vala"
	if (!isempty) {
#line 1700 "Parser.c"
		GXmlDomNode* _tmp17_;
#line 203 "../gxml/Parser.vala"
		_tmp17_ = n;
#line 203 "../gxml/Parser.vala"
		gxml_parser_read_child_nodes (self, _tmp17_, &_inner_error0_);
#line 203 "../gxml/Parser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1708 "Parser.c"
			gboolean _tmp18_ = FALSE;
#line 203 "../gxml/Parser.vala"
			g_propagate_error (error, _inner_error0_);
#line 203 "../gxml/Parser.vala"
			_g_object_unref0 (n);
#line 203 "../gxml/Parser.vala"
			return _tmp18_;
#line 1716 "Parser.c"
		}
	}
#line 204 "../gxml/Parser.vala"
	result = TRUE;
#line 204 "../gxml/Parser.vala"
	_g_object_unref0 (n);
#line 204 "../gxml/Parser.vala"
	return result;
#line 1725 "Parser.c"
}

gboolean
gxml_parser_read_child_element (GXmlParser* self,
                                GXmlDomNode* parent,
                                GError** error)
{
	GXmlParserIface* _iface_;
#line 190 "../gxml/Parser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 190 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 190 "../gxml/Parser.vala"
	if (_iface_->read_child_element) {
#line 190 "../gxml/Parser.vala"
		return _iface_->read_child_element (self, parent, error);
#line 1742 "Parser.c"
	}
#line 190 "../gxml/Parser.vala"
	return FALSE;
#line 1746 "Parser.c"
}

/**
   * Creates a new {@link DomElement} and append it as a child of parent: for current
   * read node, only if parent: have a property as {@link DomElement} type and current
   * node have same local name as property element.
   *
   * Returns: true if element is set to a new object and it is set as a child of parent:
   * as a property.
   */
static gpointer
_g_param_spec_ref0 (gpointer self)
{
#line 218 "../gxml/Parser.vala"
	return self ? g_param_spec_ref (self) : NULL;
#line 1762 "Parser.c"
}

static void
_g_param_spec_unref0_ (gpointer var)
{
#line 227 "../gxml/Parser.vala"
	(var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL));
#line 1770 "Parser.c"
}

static inline void
_g_list_free__g_param_spec_unref0_ (GList* self)
{
#line 227 "../gxml/Parser.vala"
	g_list_free_full (self, (GDestroyNotify) _g_param_spec_unref0_);
#line 1778 "Parser.c"
}

static gboolean
gxml_parser_real_read_element_property (GXmlParser* self,
                                        GXmlDomNode* parent,
                                        GXmlDomNode** element,
                                        GError** error)
{
	GXmlDomNode* _vala_element = NULL;
	GList* _tmp0_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 214 "../gxml/Parser.vala"
	g_return_val_if_fail (parent != NULL, FALSE);
#line 216 "../gxml/Parser.vala"
	_g_object_unref0 (_vala_element);
#line 216 "../gxml/Parser.vala"
	_vala_element = NULL;
#line 217 "../gxml/Parser.vala"
	if (!GXML_IS_OBJECT (parent)) {
#line 217 "../gxml/Parser.vala"
		result = FALSE;
#line 217 "../gxml/Parser.vala"
		if (element) {
#line 217 "../gxml/Parser.vala"
			*element = _vala_element;
#line 1805 "Parser.c"
		} else {
#line 217 "../gxml/Parser.vala"
			_g_object_unref0 (_vala_element);
#line 1809 "Parser.c"
		}
#line 217 "../gxml/Parser.vala"
		return result;
#line 1813 "Parser.c"
	}
#line 218 "../gxml/Parser.vala"
	_tmp0_ = gxml_object_get_property_element_list (G_TYPE_CHECK_INSTANCE_CAST (parent, GXML_TYPE_OBJECT, GXmlObject));
#line 1817 "Parser.c"
	{
		GList* pspec_collection = NULL;
		GList* pspec_it = NULL;
#line 218 "../gxml/Parser.vala"
		pspec_collection = _tmp0_;
#line 218 "../gxml/Parser.vala"
		for (pspec_it = pspec_collection; pspec_it != NULL; pspec_it = pspec_it->next) {
#line 1825 "Parser.c"
			GParamSpec* _tmp1_;
			GParamSpec* pspec = NULL;
#line 218 "../gxml/Parser.vala"
			_tmp1_ = _g_param_spec_ref0 ((GParamSpec*) pspec_it->data);
#line 218 "../gxml/Parser.vala"
			pspec = _tmp1_;
#line 1832 "Parser.c"
			{
				GParamSpec* _tmp2_;
				GXmlDomElement* obj = NULL;
				GParamSpec* _tmp3_;
				GXmlDomNode* _tmp4_;
				GXmlDomNode* _tmp5_;
				GXmlDomDocument* _tmp6_;
				GXmlDomDocument* _tmp7_;
				GObject* _tmp8_;
				GObject* _tmp9_;
				GXmlDomElement* _tmp10_;
				GXmlDomElement* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				gboolean _tmp21_;
#line 220 "../gxml/Parser.vala"
				_tmp2_ = pspec;
#line 220 "../gxml/Parser.vala"
				if (g_type_is_a (_tmp2_->value_type, GXML_TYPE_COLLECTION)) {
#line 220 "../gxml/Parser.vala"
					_g_param_spec_unref0 (pspec);
#line 220 "../gxml/Parser.vala"
					continue;
#line 1863 "Parser.c"
				}
#line 222 "../gxml/Parser.vala"
				_tmp3_ = pspec;
#line 222 "../gxml/Parser.vala"
				_tmp4_ = gxml_parser_get_node (self);
#line 222 "../gxml/Parser.vala"
				_tmp5_ = _tmp4_;
#line 222 "../gxml/Parser.vala"
				_tmp6_ = gxml_dom_node_get_owner_document (_tmp5_);
#line 222 "../gxml/Parser.vala"
				_tmp7_ = _tmp6_;
#line 222 "../gxml/Parser.vala"
				_tmp8_ = g_object_new (_tmp3_->value_type, "owner-document", _tmp7_, NULL);
#line 222 "../gxml/Parser.vala"
				_tmp9_ = G_IS_INITIALLY_UNOWNED (_tmp8_) ? g_object_ref_sink (_tmp8_) : _tmp8_;
#line 222 "../gxml/Parser.vala"
				_tmp10_ = GXML_IS_DOM_ELEMENT (_tmp9_) ? ((GXmlDomElement*) _tmp9_) : NULL;
#line 222 "../gxml/Parser.vala"
				if (_tmp10_ == NULL) {
#line 222 "../gxml/Parser.vala"
					_g_object_unref0 (_tmp9_);
#line 1885 "Parser.c"
				}
#line 222 "../gxml/Parser.vala"
				obj = _tmp10_;
#line 224 "../gxml/Parser.vala"
				_tmp11_ = obj;
#line 224 "../gxml/Parser.vala"
				_tmp12_ = gxml_dom_element_get_local_name (_tmp11_);
#line 224 "../gxml/Parser.vala"
				_tmp13_ = _tmp12_;
#line 224 "../gxml/Parser.vala"
				_tmp14_ = _tmp13_;
#line 224 "../gxml/Parser.vala"
				_tmp15_ = g_utf8_strdown (_tmp14_, (gssize) -1);
#line 224 "../gxml/Parser.vala"
				_tmp16_ = _tmp15_;
#line 224 "../gxml/Parser.vala"
				_tmp17_ = gxml_parser_current_node_name (self);
#line 224 "../gxml/Parser.vala"
				_tmp18_ = _tmp17_;
#line 224 "../gxml/Parser.vala"
				_tmp19_ = g_utf8_strdown (_tmp18_, (gssize) -1);
#line 224 "../gxml/Parser.vala"
				_tmp20_ = _tmp19_;
#line 224 "../gxml/Parser.vala"
				_tmp21_ = g_strcmp0 (_tmp16_, _tmp20_) == 0;
#line 224 "../gxml/Parser.vala"
				_g_free0 (_tmp20_);
#line 224 "../gxml/Parser.vala"
				_g_free0 (_tmp18_);
#line 224 "../gxml/Parser.vala"
				_g_free0 (_tmp16_);
#line 224 "../gxml/Parser.vala"
				_g_free0 (_tmp14_);
#line 224 "../gxml/Parser.vala"
				if (_tmp21_) {
#line 1921 "Parser.c"
					GValue v = {0};
					GParamSpec* _tmp22_;
					GValue _tmp23_ = {0};
					GXmlDomElement* _tmp24_;
					GXmlDomNode* _tmp25_;
					GXmlDomNode* _tmp26_;
					GXmlDomElement* _tmp28_;
					GParamSpec* _tmp29_;
					const gchar* _tmp30_;
					GValue _tmp31_;
					GXmlDomElement* _tmp32_;
					GXmlDomElement* _tmp34_;
					GXmlDomNode* _tmp35_;
#line 226 "../gxml/Parser.vala"
					_tmp22_ = pspec;
#line 226 "../gxml/Parser.vala"
					g_value_init (&_tmp23_, _tmp22_->value_type);
#line 226 "../gxml/Parser.vala"
					v = _tmp23_;
#line 227 "../gxml/Parser.vala"
					_tmp24_ = obj;
#line 227 "../gxml/Parser.vala"
					_tmp25_ = gxml_dom_node_append_child (parent, GXML_IS_DOM_NODE (_tmp24_) ? ((GXmlDomNode*) _tmp24_) : NULL, &_inner_error0_);
#line 227 "../gxml/Parser.vala"
					_tmp26_ = _tmp25_;
#line 227 "../gxml/Parser.vala"
					_g_object_unref0 (_tmp26_);
#line 227 "../gxml/Parser.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1951 "Parser.c"
						gboolean _tmp27_ = FALSE;
#line 227 "../gxml/Parser.vala"
						g_propagate_error (error, _inner_error0_);
#line 227 "../gxml/Parser.vala"
						G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 227 "../gxml/Parser.vala"
						_g_object_unref0 (obj);
#line 227 "../gxml/Parser.vala"
						_g_param_spec_unref0 (pspec);
#line 227 "../gxml/Parser.vala"
						(pspec_collection == NULL) ? NULL : (pspec_collection = (_g_list_free__g_param_spec_unref0_ (pspec_collection), NULL));
#line 227 "../gxml/Parser.vala"
						_g_object_unref0 (_vala_element);
#line 227 "../gxml/Parser.vala"
						return _tmp27_;
#line 1967 "Parser.c"
					}
#line 228 "../gxml/Parser.vala"
					_tmp28_ = obj;
#line 228 "../gxml/Parser.vala"
					g_value_set_object (&v, (GObject*) _tmp28_);
#line 229 "../gxml/Parser.vala"
					_tmp29_ = pspec;
#line 229 "../gxml/Parser.vala"
					_tmp30_ = _tmp29_->name;
#line 229 "../gxml/Parser.vala"
					_tmp31_ = v;
#line 229 "../gxml/Parser.vala"
					g_object_set_property ((GObject*) parent, _tmp30_, &_tmp31_);
#line 230 "../gxml/Parser.vala"
					_tmp32_ = obj;
#line 230 "../gxml/Parser.vala"
					gxml_parser_read_element (self, GXML_IS_DOM_ELEMENT (_tmp32_) ? ((GXmlDomElement*) _tmp32_) : NULL, &_inner_error0_);
#line 230 "../gxml/Parser.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1987 "Parser.c"
						gboolean _tmp33_ = FALSE;
#line 230 "../gxml/Parser.vala"
						g_propagate_error (error, _inner_error0_);
#line 230 "../gxml/Parser.vala"
						G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 230 "../gxml/Parser.vala"
						_g_object_unref0 (obj);
#line 230 "../gxml/Parser.vala"
						_g_param_spec_unref0 (pspec);
#line 230 "../gxml/Parser.vala"
						(pspec_collection == NULL) ? NULL : (pspec_collection = (_g_list_free__g_param_spec_unref0_ (pspec_collection), NULL));
#line 230 "../gxml/Parser.vala"
						_g_object_unref0 (_vala_element);
#line 230 "../gxml/Parser.vala"
						return _tmp33_;
#line 2003 "Parser.c"
					}
#line 231 "../gxml/Parser.vala"
					_tmp34_ = obj;
#line 231 "../gxml/Parser.vala"
					_tmp35_ = _g_object_ref0 (GXML_IS_DOM_NODE (_tmp34_) ? ((GXmlDomNode*) _tmp34_) : NULL);
#line 231 "../gxml/Parser.vala"
					_g_object_unref0 (_vala_element);
#line 231 "../gxml/Parser.vala"
					_vala_element = _tmp35_;
#line 232 "../gxml/Parser.vala"
					result = TRUE;
#line 232 "../gxml/Parser.vala"
					G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 232 "../gxml/Parser.vala"
					_g_object_unref0 (obj);
#line 232 "../gxml/Parser.vala"
					_g_param_spec_unref0 (pspec);
#line 232 "../gxml/Parser.vala"
					(pspec_collection == NULL) ? NULL : (pspec_collection = (_g_list_free__g_param_spec_unref0_ (pspec_collection), NULL));
#line 232 "../gxml/Parser.vala"
					if (element) {
#line 232 "../gxml/Parser.vala"
						*element = _vala_element;
#line 2027 "Parser.c"
					} else {
#line 232 "../gxml/Parser.vala"
						_g_object_unref0 (_vala_element);
#line 2031 "Parser.c"
					}
#line 232 "../gxml/Parser.vala"
					return result;
#line 2035 "Parser.c"
				}
#line 222 "../gxml/Parser.vala"
				_g_object_unref0 (obj);
#line 222 "../gxml/Parser.vala"
				_g_param_spec_unref0 (pspec);
#line 2041 "Parser.c"
			}
		}
#line 222 "../gxml/Parser.vala"
		(pspec_collection == NULL) ? NULL : (pspec_collection = (_g_list_free__g_param_spec_unref0_ (pspec_collection), NULL));
#line 2046 "Parser.c"
	}
#line 235 "../gxml/Parser.vala"
	result = FALSE;
#line 235 "../gxml/Parser.vala"
	if (element) {
#line 235 "../gxml/Parser.vala"
		*element = _vala_element;
#line 2054 "Parser.c"
	} else {
#line 235 "../gxml/Parser.vala"
		_g_object_unref0 (_vala_element);
#line 2058 "Parser.c"
	}
#line 235 "../gxml/Parser.vala"
	return result;
#line 2062 "Parser.c"
}

gboolean
gxml_parser_read_element_property (GXmlParser* self,
                                   GXmlDomNode* parent,
                                   GXmlDomNode** element,
                                   GError** error)
{
	GXmlParserIface* _iface_;
#line 218 "../gxml/Parser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 218 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 218 "../gxml/Parser.vala"
	if (_iface_->read_element_property) {
#line 218 "../gxml/Parser.vala"
		return _iface_->read_element_property (self, parent, element, error);
#line 2080 "Parser.c"
	}
#line 218 "../gxml/Parser.vala"
	return FALSE;
#line 2084 "Parser.c"
}

/**
   * Creates a new {@link DomElement} and append it as a child of parent: for current
   * read node, only if parent: have a property as {@link Collection} type and current
   * node have same local name as collection {@link Collection.items_name}
   *
   * Returns: true if element is set to a new object, it is set as a child of parent:
   * and has been added to a parent:'s collection property.
   */
static gpointer
_g_hash_table_ref0 (gpointer self)
{
#line 272 "../gxml/Parser.vala"
	return self ? g_hash_table_ref (self) : NULL;
#line 2100 "Parser.c"
}

static gboolean
gxml_parser_real_add_element_collection (GXmlParser* self,
                                         GXmlDomNode* parent,
                                         GXmlDomNode** element,
                                         GError** error)
{
	GXmlDomNode* _vala_element = NULL;
	GList* _tmp0_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 245 "../gxml/Parser.vala"
	g_return_val_if_fail (parent != NULL, FALSE);
#line 247 "../gxml/Parser.vala"
	_g_object_unref0 (_vala_element);
#line 247 "../gxml/Parser.vala"
	_vala_element = NULL;
#line 248 "../gxml/Parser.vala"
	if (!GXML_IS_OBJECT (parent)) {
#line 248 "../gxml/Parser.vala"
		result = FALSE;
#line 248 "../gxml/Parser.vala"
		if (element) {
#line 248 "../gxml/Parser.vala"
			*element = _vala_element;
#line 2127 "Parser.c"
		} else {
#line 248 "../gxml/Parser.vala"
			_g_object_unref0 (_vala_element);
#line 2131 "Parser.c"
		}
#line 248 "../gxml/Parser.vala"
		return result;
#line 2135 "Parser.c"
	}
#line 249 "../gxml/Parser.vala"
	_tmp0_ = gxml_object_get_property_element_list (G_TYPE_CHECK_INSTANCE_CAST (parent, GXML_TYPE_OBJECT, GXmlObject));
#line 2139 "Parser.c"
	{
		GList* pspec_collection = NULL;
		GList* pspec_it = NULL;
#line 249 "../gxml/Parser.vala"
		pspec_collection = _tmp0_;
#line 249 "../gxml/Parser.vala"
		for (pspec_it = pspec_collection; pspec_it != NULL; pspec_it = pspec_it->next) {
#line 2147 "Parser.c"
			GParamSpec* _tmp1_;
			GParamSpec* pspec = NULL;
#line 249 "../gxml/Parser.vala"
			_tmp1_ = _g_param_spec_ref0 ((GParamSpec*) pspec_it->data);
#line 249 "../gxml/Parser.vala"
			pspec = _tmp1_;
#line 2154 "Parser.c"
			{
				GParamSpec* _tmp2_;
				GXmlCollection* col = NULL;
				GValue vc = {0};
				GParamSpec* _tmp3_;
				GValue _tmp4_ = {0};
				GParamSpec* _tmp5_;
				const gchar* _tmp6_;
				GObject* _tmp7_;
				GXmlCollection* _tmp8_;
				GXmlCollection* _tmp9_;
				gboolean _tmp18_ = FALSE;
				GXmlCollection* _tmp19_;
				GType _tmp20_;
				GType _tmp21_;
				GType obj_type = 0UL;
				GXmlCollection* _tmp29_;
#line 251 "../gxml/Parser.vala"
				_tmp2_ = pspec;
#line 251 "../gxml/Parser.vala"
				if (!g_type_is_a (_tmp2_->value_type, GXML_TYPE_COLLECTION)) {
#line 251 "../gxml/Parser.vala"
					_g_param_spec_unref0 (pspec);
#line 251 "../gxml/Parser.vala"
					continue;
#line 2180 "Parser.c"
				}
#line 253 "../gxml/Parser.vala"
				_tmp3_ = pspec;
#line 253 "../gxml/Parser.vala"
				g_value_init (&_tmp4_, _tmp3_->value_type);
#line 253 "../gxml/Parser.vala"
				vc = _tmp4_;
#line 254 "../gxml/Parser.vala"
				_tmp5_ = pspec;
#line 254 "../gxml/Parser.vala"
				_tmp6_ = _tmp5_->name;
#line 254 "../gxml/Parser.vala"
				g_object_get_property ((GObject*) parent, _tmp6_, &vc);
#line 255 "../gxml/Parser.vala"
				_tmp7_ = g_value_get_object (&vc);
#line 255 "../gxml/Parser.vala"
				_tmp8_ = _g_object_ref0 (GXML_IS_COLLECTION (_tmp7_) ? ((GXmlCollection*) _tmp7_) : NULL);
#line 255 "../gxml/Parser.vala"
				_g_object_unref0 (col);
#line 255 "../gxml/Parser.vala"
				col = _tmp8_;
#line 256 "../gxml/Parser.vala"
				_tmp9_ = col;
#line 256 "../gxml/Parser.vala"
				if (_tmp9_ == NULL) {
#line 2206 "Parser.c"
					GParamSpec* _tmp10_;
					GObject* _tmp11_;
					GObject* _tmp12_;
					GXmlCollection* _tmp13_;
					GXmlCollection* _tmp14_;
					GParamSpec* _tmp15_;
					const gchar* _tmp16_;
					GValue _tmp17_;
#line 257 "../gxml/Parser.vala"
					_tmp10_ = pspec;
#line 257 "../gxml/Parser.vala"
					_tmp11_ = g_object_new (_tmp10_->value_type, "element", parent, NULL);
#line 257 "../gxml/Parser.vala"
					_tmp12_ = G_IS_INITIALLY_UNOWNED (_tmp11_) ? g_object_ref_sink (_tmp11_) : _tmp11_;
#line 257 "../gxml/Parser.vala"
					_tmp13_ = GXML_IS_COLLECTION (_tmp12_) ? ((GXmlCollection*) _tmp12_) : NULL;
#line 257 "../gxml/Parser.vala"
					if (_tmp13_ == NULL) {
#line 257 "../gxml/Parser.vala"
						_g_object_unref0 (_tmp12_);
#line 2227 "Parser.c"
					}
#line 257 "../gxml/Parser.vala"
					_g_object_unref0 (col);
#line 257 "../gxml/Parser.vala"
					col = _tmp13_;
#line 259 "../gxml/Parser.vala"
					_tmp14_ = col;
#line 259 "../gxml/Parser.vala"
					g_value_set_object (&vc, (GObject*) _tmp14_);
#line 260 "../gxml/Parser.vala"
					_tmp15_ = pspec;
#line 260 "../gxml/Parser.vala"
					_tmp16_ = _tmp15_->name;
#line 260 "../gxml/Parser.vala"
					_tmp17_ = vc;
#line 260 "../gxml/Parser.vala"
					g_object_set_property ((GObject*) parent, _tmp16_, &_tmp17_);
#line 2245 "Parser.c"
				}
#line 262 "../gxml/Parser.vala"
				_tmp19_ = col;
#line 262 "../gxml/Parser.vala"
				_tmp20_ = gxml_collection_get_items_type (_tmp19_);
#line 262 "../gxml/Parser.vala"
				_tmp21_ = _tmp20_;
#line 262 "../gxml/Parser.vala"
				if (_tmp21_ == G_TYPE_INVALID) {
#line 262 "../gxml/Parser.vala"
					_tmp18_ = TRUE;
#line 2257 "Parser.c"
				} else {
					GXmlCollection* _tmp22_;
					GType _tmp23_;
					GType _tmp24_;
#line 263 "../gxml/Parser.vala"
					_tmp22_ = col;
#line 263 "../gxml/Parser.vala"
					_tmp23_ = gxml_collection_get_items_type (_tmp22_);
#line 263 "../gxml/Parser.vala"
					_tmp24_ = _tmp23_;
#line 263 "../gxml/Parser.vala"
					_tmp18_ = !g_type_is_a (_tmp24_, GXML_TYPE_OBJECT);
#line 2270 "Parser.c"
				}
#line 262 "../gxml/Parser.vala"
				if (_tmp18_) {
#line 2274 "Parser.c"
					GXmlCollection* _tmp25_;
					const gchar* _tmp26_;
					GError* _tmp27_;
					gboolean _tmp28_ = FALSE;
#line 264 "../gxml/Parser.vala"
					_tmp25_ = col;
#line 264 "../gxml/Parser.vala"
					_tmp26_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) _tmp25_));
#line 264 "../gxml/Parser.vala"
					_tmp27_ = g_error_new (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Collection '%s' hasn't been constructed properly: items' type property" \
" was not set at construction time or set to invalid type"), _tmp26_);
#line 264 "../gxml/Parser.vala"
					_inner_error0_ = _tmp27_;
#line 264 "../gxml/Parser.vala"
					g_propagate_error (error, _inner_error0_);
#line 264 "../gxml/Parser.vala"
					G_IS_VALUE (&vc) ? (g_value_unset (&vc), NULL) : NULL;
#line 264 "../gxml/Parser.vala"
					_g_object_unref0 (col);
#line 264 "../gxml/Parser.vala"
					_g_param_spec_unref0 (pspec);
#line 264 "../gxml/Parser.vala"
					(pspec_collection == NULL) ? NULL : (pspec_collection = (_g_list_free__g_param_spec_unref0_ (pspec_collection), NULL));
#line 264 "../gxml/Parser.vala"
					_g_object_unref0 (_vala_element);
#line 264 "../gxml/Parser.vala"
					return _tmp28_;
#line 2301 "Parser.c"
				}
#line 267 "../gxml/Parser.vala"
				obj_type = G_TYPE_INVALID;
#line 268 "../gxml/Parser.vala"
				_tmp29_ = col;
#line 268 "../gxml/Parser.vala"
				if (GXML_IS_COLLECTION_PARENT (_tmp29_)) {
#line 2309 "Parser.c"
					GHashTable* obj_types = NULL;
					GHashTable* _tmp30_;
					GHashTable* _tmp31_;
					GXmlCollection* _tmp32_;
					GHashTable* _tmp46_;
#line 269 "../gxml/Parser.vala"
					obj_types = NULL;
#line 270 "../gxml/Parser.vala"
					_tmp30_ = gxml_parser_get_types (self);
#line 270 "../gxml/Parser.vala"
					_tmp31_ = _tmp30_;
#line 270 "../gxml/Parser.vala"
					_tmp32_ = col;
#line 270 "../gxml/Parser.vala"
					if (!g_hash_table_contains (_tmp31_, (gpointer) ((gintptr) G_TYPE_FROM_INSTANCE ((GObject*) _tmp32_)))) {
#line 2325 "Parser.c"
						GXmlCollection* _tmp33_;
						GHashTable* _tmp34_;
						GHashTable* _tmp35_;
						GHashTable* _tmp36_;
						GHashTable* _tmp37_;
						GXmlCollection* _tmp38_;
						GHashTable* _tmp39_;
						GHashTable* _tmp40_;
#line 271 "../gxml/Parser.vala"
						_tmp33_ = col;
#line 271 "../gxml/Parser.vala"
						_tmp34_ = gxml_collection_parent_get_types (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, GXML_TYPE_COLLECTION_PARENT, GXmlCollectionParent));
#line 271 "../gxml/Parser.vala"
						_tmp35_ = _tmp34_;
#line 271 "../gxml/Parser.vala"
						_g_hash_table_unref0 (obj_types);
#line 271 "../gxml/Parser.vala"
						obj_types = _tmp35_;
#line 272 "../gxml/Parser.vala"
						_tmp36_ = gxml_parser_get_types (self);
#line 272 "../gxml/Parser.vala"
						_tmp37_ = _tmp36_;
#line 272 "../gxml/Parser.vala"
						_tmp38_ = col;
#line 272 "../gxml/Parser.vala"
						_tmp39_ = obj_types;
#line 272 "../gxml/Parser.vala"
						_tmp40_ = _g_hash_table_ref0 (_tmp39_);
#line 272 "../gxml/Parser.vala"
						g_hash_table_insert (_tmp37_, (gpointer) ((gintptr) G_TYPE_FROM_INSTANCE ((GObject*) _tmp38_)), _tmp40_);
#line 2356 "Parser.c"
					} else {
						GHashTable* _tmp41_;
						GHashTable* _tmp42_;
						GXmlCollection* _tmp43_;
						gconstpointer _tmp44_;
						GHashTable* _tmp45_;
#line 274 "../gxml/Parser.vala"
						_tmp41_ = gxml_parser_get_types (self);
#line 274 "../gxml/Parser.vala"
						_tmp42_ = _tmp41_;
#line 274 "../gxml/Parser.vala"
						_tmp43_ = col;
#line 274 "../gxml/Parser.vala"
						_tmp44_ = g_hash_table_lookup (_tmp42_, (gpointer) ((gintptr) G_TYPE_FROM_INSTANCE ((GObject*) _tmp43_)));
#line 274 "../gxml/Parser.vala"
						_tmp45_ = _g_hash_table_ref0 ((GHashTable*) _tmp44_);
#line 274 "../gxml/Parser.vala"
						_g_hash_table_unref0 (obj_types);
#line 274 "../gxml/Parser.vala"
						obj_types = _tmp45_;
#line 2377 "Parser.c"
					}
#line 276 "../gxml/Parser.vala"
					_tmp46_ = obj_types;
#line 276 "../gxml/Parser.vala"
					if (_tmp46_ != NULL) {
#line 2383 "Parser.c"
						gchar* n = NULL;
						gchar* _tmp47_;
						gchar* _tmp48_;
						gchar* _tmp49_;
						gchar* _tmp50_;
						GHashTable* _tmp51_;
						const gchar* _tmp52_;
#line 277 "../gxml/Parser.vala"
						_tmp47_ = gxml_parser_current_node_name (self);
#line 277 "../gxml/Parser.vala"
						_tmp48_ = _tmp47_;
#line 277 "../gxml/Parser.vala"
						_tmp49_ = g_utf8_strdown (_tmp48_, (gssize) -1);
#line 277 "../gxml/Parser.vala"
						_tmp50_ = _tmp49_;
#line 277 "../gxml/Parser.vala"
						_g_free0 (_tmp48_);
#line 277 "../gxml/Parser.vala"
						n = _tmp50_;
#line 278 "../gxml/Parser.vala"
						_tmp51_ = obj_types;
#line 278 "../gxml/Parser.vala"
						_tmp52_ = n;
#line 278 "../gxml/Parser.vala"
						if (g_hash_table_contains (_tmp51_, _tmp52_)) {
#line 2409 "Parser.c"
							GHashTable* _tmp53_;
							const gchar* _tmp54_;
							gconstpointer _tmp55_;
#line 279 "../gxml/Parser.vala"
							_tmp53_ = obj_types;
#line 279 "../gxml/Parser.vala"
							_tmp54_ = n;
#line 279 "../gxml/Parser.vala"
							_tmp55_ = g_hash_table_lookup (_tmp53_, _tmp54_);
#line 279 "../gxml/Parser.vala"
							obj_type = (GType) ((gintptr) _tmp55_);
#line 2421 "Parser.c"
						}
#line 276 "../gxml/Parser.vala"
						_g_free0 (n);
#line 2425 "Parser.c"
					}
#line 268 "../gxml/Parser.vala"
					_g_hash_table_unref0 (obj_types);
#line 2429 "Parser.c"
				} else {
					gboolean _tmp56_ = FALSE;
					GXmlCollection* _tmp57_;
					const gchar* _tmp58_;
					const gchar* _tmp59_;
					gboolean _tmp67_ = FALSE;
					GXmlCollection* _tmp68_;
					GXmlDomElement* _tmp69_;
					GXmlDomElement* _tmp70_;
					GXmlCollection* _tmp78_;
					GXmlDomElement* _tmp79_;
					GXmlDomElement* _tmp80_;
					GXmlCollection* _tmp87_;
					const gchar* _tmp88_;
					const gchar* _tmp89_;
					gchar* _tmp90_;
					gchar* _tmp91_;
					gchar* _tmp92_;
					gchar* _tmp93_;
					gchar* _tmp94_;
					gchar* _tmp95_;
					gboolean _tmp96_;
#line 283 "../gxml/Parser.vala"
					_tmp57_ = col;
#line 283 "../gxml/Parser.vala"
					_tmp58_ = gxml_collection_get_items_name (_tmp57_);
#line 283 "../gxml/Parser.vala"
					_tmp59_ = _tmp58_;
#line 283 "../gxml/Parser.vala"
					if (g_strcmp0 (_tmp59_, "") == 0) {
#line 283 "../gxml/Parser.vala"
						_tmp56_ = TRUE;
#line 2462 "Parser.c"
					} else {
						GXmlCollection* _tmp60_;
						const gchar* _tmp61_;
						const gchar* _tmp62_;
#line 283 "../gxml/Parser.vala"
						_tmp60_ = col;
#line 283 "../gxml/Parser.vala"
						_tmp61_ = gxml_collection_get_items_name (_tmp60_);
#line 283 "../gxml/Parser.vala"
						_tmp62_ = _tmp61_;
#line 283 "../gxml/Parser.vala"
						_tmp56_ = _tmp62_ == NULL;
#line 2475 "Parser.c"
					}
#line 283 "../gxml/Parser.vala"
					if (_tmp56_) {
#line 2479 "Parser.c"
						GXmlCollection* _tmp63_;
						const gchar* _tmp64_;
						GError* _tmp65_;
						gboolean _tmp66_ = FALSE;
#line 284 "../gxml/Parser.vala"
						_tmp63_ = col;
#line 284 "../gxml/Parser.vala"
						_tmp64_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) _tmp63_));
#line 284 "../gxml/Parser.vala"
						_tmp65_ = g_error_new (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Collection '%s' hasn't been constructed properly: items' name property" \
" was not set at construction time"), _tmp64_);
#line 284 "../gxml/Parser.vala"
						_inner_error0_ = _tmp65_;
#line 284 "../gxml/Parser.vala"
						g_propagate_error (error, _inner_error0_);
#line 284 "../gxml/Parser.vala"
						G_IS_VALUE (&vc) ? (g_value_unset (&vc), NULL) : NULL;
#line 284 "../gxml/Parser.vala"
						_g_object_unref0 (col);
#line 284 "../gxml/Parser.vala"
						_g_param_spec_unref0 (pspec);
#line 284 "../gxml/Parser.vala"
						(pspec_collection == NULL) ? NULL : (pspec_collection = (_g_list_free__g_param_spec_unref0_ (pspec_collection), NULL));
#line 284 "../gxml/Parser.vala"
						_g_object_unref0 (_vala_element);
#line 284 "../gxml/Parser.vala"
						return _tmp66_;
#line 2506 "Parser.c"
					}
#line 287 "../gxml/Parser.vala"
					_tmp68_ = col;
#line 287 "../gxml/Parser.vala"
					_tmp69_ = gxml_collection_get_element (_tmp68_);
#line 287 "../gxml/Parser.vala"
					_tmp70_ = _tmp69_;
#line 287 "../gxml/Parser.vala"
					if (_tmp70_ == NULL) {
#line 287 "../gxml/Parser.vala"
						_tmp67_ = TRUE;
#line 2518 "Parser.c"
					} else {
						GXmlCollection* _tmp71_;
						GXmlDomElement* _tmp72_;
						GXmlDomElement* _tmp73_;
#line 287 "../gxml/Parser.vala"
						_tmp71_ = col;
#line 287 "../gxml/Parser.vala"
						_tmp72_ = gxml_collection_get_element (_tmp71_);
#line 287 "../gxml/Parser.vala"
						_tmp73_ = _tmp72_;
#line 287 "../gxml/Parser.vala"
						_tmp67_ = !GXML_IS_OBJECT (_tmp73_);
#line 2531 "Parser.c"
					}
#line 287 "../gxml/Parser.vala"
					if (_tmp67_) {
#line 2535 "Parser.c"
						GXmlCollection* _tmp74_;
						const gchar* _tmp75_;
						GError* _tmp76_;
						gboolean _tmp77_ = FALSE;
#line 288 "../gxml/Parser.vala"
						_tmp74_ = col;
#line 288 "../gxml/Parser.vala"
						_tmp75_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) _tmp74_));
#line 288 "../gxml/Parser.vala"
						_tmp76_ = g_error_new (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Collection '%s' hasn't been constructed properly: element property was" \
" not set at construction time"), _tmp75_);
#line 288 "../gxml/Parser.vala"
						_inner_error0_ = _tmp76_;
#line 288 "../gxml/Parser.vala"
						g_propagate_error (error, _inner_error0_);
#line 288 "../gxml/Parser.vala"
						G_IS_VALUE (&vc) ? (g_value_unset (&vc), NULL) : NULL;
#line 288 "../gxml/Parser.vala"
						_g_object_unref0 (col);
#line 288 "../gxml/Parser.vala"
						_g_param_spec_unref0 (pspec);
#line 288 "../gxml/Parser.vala"
						(pspec_collection == NULL) ? NULL : (pspec_collection = (_g_list_free__g_param_spec_unref0_ (pspec_collection), NULL));
#line 288 "../gxml/Parser.vala"
						_g_object_unref0 (_vala_element);
#line 288 "../gxml/Parser.vala"
						return _tmp77_;
#line 2562 "Parser.c"
					}
#line 291 "../gxml/Parser.vala"
					_tmp78_ = col;
#line 291 "../gxml/Parser.vala"
					_tmp79_ = gxml_collection_get_element (_tmp78_);
#line 291 "../gxml/Parser.vala"
					_tmp80_ = _tmp79_;
#line 291 "../gxml/Parser.vala"
					if (!GXML_IS_OBJECT (_tmp80_)) {
#line 2572 "Parser.c"
						GXmlCollection* _tmp81_;
						GXmlDomElement* _tmp82_;
						GXmlDomElement* _tmp83_;
						const gchar* _tmp84_;
						GError* _tmp85_;
						gboolean _tmp86_ = FALSE;
#line 292 "../gxml/Parser.vala"
						_tmp81_ = col;
#line 292 "../gxml/Parser.vala"
						_tmp82_ = gxml_collection_get_element (_tmp81_);
#line 292 "../gxml/Parser.vala"
						_tmp83_ = _tmp82_;
#line 292 "../gxml/Parser.vala"
						_tmp84_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) _tmp83_));
#line 292 "../gxml/Parser.vala"
						_tmp85_ = g_error_new (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Invalid object of type '%s' doesn't implement GXml.Object interface: c" \
"an't be handled by the collection"), _tmp84_);
#line 292 "../gxml/Parser.vala"
						_inner_error0_ = _tmp85_;
#line 292 "../gxml/Parser.vala"
						g_propagate_error (error, _inner_error0_);
#line 292 "../gxml/Parser.vala"
						G_IS_VALUE (&vc) ? (g_value_unset (&vc), NULL) : NULL;
#line 292 "../gxml/Parser.vala"
						_g_object_unref0 (col);
#line 292 "../gxml/Parser.vala"
						_g_param_spec_unref0 (pspec);
#line 292 "../gxml/Parser.vala"
						(pspec_collection == NULL) ? NULL : (pspec_collection = (_g_list_free__g_param_spec_unref0_ (pspec_collection), NULL));
#line 292 "../gxml/Parser.vala"
						_g_object_unref0 (_vala_element);
#line 292 "../gxml/Parser.vala"
						return _tmp86_;
#line 2605 "Parser.c"
					}
#line 295 "../gxml/Parser.vala"
					_tmp87_ = col;
#line 295 "../gxml/Parser.vala"
					_tmp88_ = gxml_collection_get_items_name (_tmp87_);
#line 295 "../gxml/Parser.vala"
					_tmp89_ = _tmp88_;
#line 295 "../gxml/Parser.vala"
					_tmp90_ = g_utf8_strdown (_tmp89_, (gssize) -1);
#line 295 "../gxml/Parser.vala"
					_tmp91_ = _tmp90_;
#line 295 "../gxml/Parser.vala"
					_tmp92_ = gxml_parser_current_node_name (self);
#line 295 "../gxml/Parser.vala"
					_tmp93_ = _tmp92_;
#line 295 "../gxml/Parser.vala"
					_tmp94_ = g_utf8_strdown (_tmp93_, (gssize) -1);
#line 295 "../gxml/Parser.vala"
					_tmp95_ = _tmp94_;
#line 295 "../gxml/Parser.vala"
					_tmp96_ = g_strcmp0 (_tmp91_, _tmp95_) == 0;
#line 295 "../gxml/Parser.vala"
					_g_free0 (_tmp95_);
#line 295 "../gxml/Parser.vala"
					_g_free0 (_tmp93_);
#line 295 "../gxml/Parser.vala"
					_g_free0 (_tmp91_);
#line 295 "../gxml/Parser.vala"
					if (_tmp96_) {
#line 2635 "Parser.c"
						GXmlDomDocument* _tmp97_;
						GXmlDomDocument* _tmp98_;
						GXmlCollection* _tmp101_;
						GType _tmp102_;
						GType _tmp103_;
#line 296 "../gxml/Parser.vala"
						_tmp97_ = gxml_dom_node_get_owner_document (parent);
#line 296 "../gxml/Parser.vala"
						_tmp98_ = _tmp97_;
#line 296 "../gxml/Parser.vala"
						if (_tmp98_ == NULL) {
#line 2647 "Parser.c"
							GError* _tmp99_;
							gboolean _tmp100_ = FALSE;
#line 297 "../gxml/Parser.vala"
							_tmp99_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_HIERARCHY_REQUEST_ERROR, _ ("No document is set to node"));
#line 297 "../gxml/Parser.vala"
							_inner_error0_ = _tmp99_;
#line 297 "../gxml/Parser.vala"
							g_propagate_error (error, _inner_error0_);
#line 297 "../gxml/Parser.vala"
							G_IS_VALUE (&vc) ? (g_value_unset (&vc), NULL) : NULL;
#line 297 "../gxml/Parser.vala"
							_g_object_unref0 (col);
#line 297 "../gxml/Parser.vala"
							_g_param_spec_unref0 (pspec);
#line 297 "../gxml/Parser.vala"
							(pspec_collection == NULL) ? NULL : (pspec_collection = (_g_list_free__g_param_spec_unref0_ (pspec_collection), NULL));
#line 297 "../gxml/Parser.vala"
							_g_object_unref0 (_vala_element);
#line 297 "../gxml/Parser.vala"
							return _tmp100_;
#line 2668 "Parser.c"
						}
#line 299 "../gxml/Parser.vala"
						_tmp101_ = col;
#line 299 "../gxml/Parser.vala"
						_tmp102_ = gxml_collection_get_items_type (_tmp101_);
#line 299 "../gxml/Parser.vala"
						_tmp103_ = _tmp102_;
#line 299 "../gxml/Parser.vala"
						obj_type = _tmp103_;
#line 2678 "Parser.c"
					}
				}
#line 302 "../gxml/Parser.vala"
				if (obj_type != G_TYPE_INVALID) {
#line 2683 "Parser.c"
					GXmlDomElement* obj = NULL;
					GXmlDomNode* _tmp104_;
					GXmlDomNode* _tmp105_;
					GXmlDomDocument* _tmp106_;
					GXmlDomDocument* _tmp107_;
					GObject* _tmp108_;
					GObject* _tmp109_;
					GXmlDomElement* _tmp110_;
					GXmlDomElement* _tmp111_;
					GXmlDomNode* _tmp112_;
					GXmlDomNode* _tmp113_;
					GXmlDomElement* _tmp115_;
					GXmlCollection* _tmp117_;
					GXmlDomElement* _tmp118_;
					GXmlDomElement* _tmp120_;
					GXmlDomNode* _tmp121_;
#line 303 "../gxml/Parser.vala"
					_tmp104_ = gxml_parser_get_node (self);
#line 303 "../gxml/Parser.vala"
					_tmp105_ = _tmp104_;
#line 303 "../gxml/Parser.vala"
					_tmp106_ = gxml_dom_node_get_owner_document (_tmp105_);
#line 303 "../gxml/Parser.vala"
					_tmp107_ = _tmp106_;
#line 303 "../gxml/Parser.vala"
					_tmp108_ = g_object_new (obj_type, "owner-document", _tmp107_, NULL);
#line 303 "../gxml/Parser.vala"
					_tmp109_ = G_IS_INITIALLY_UNOWNED (_tmp108_) ? g_object_ref_sink (_tmp108_) : _tmp108_;
#line 303 "../gxml/Parser.vala"
					_tmp110_ = GXML_IS_DOM_ELEMENT (_tmp109_) ? ((GXmlDomElement*) _tmp109_) : NULL;
#line 303 "../gxml/Parser.vala"
					if (_tmp110_ == NULL) {
#line 303 "../gxml/Parser.vala"
						_g_object_unref0 (_tmp109_);
#line 2718 "Parser.c"
					}
#line 303 "../gxml/Parser.vala"
					obj = _tmp110_;
#line 305 "../gxml/Parser.vala"
					_tmp111_ = obj;
#line 305 "../gxml/Parser.vala"
					_tmp112_ = gxml_dom_node_append_child (parent, (GXmlDomNode*) _tmp111_, &_inner_error0_);
#line 305 "../gxml/Parser.vala"
					_tmp113_ = _tmp112_;
#line 305 "../gxml/Parser.vala"
					_g_object_unref0 (_tmp113_);
#line 305 "../gxml/Parser.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2732 "Parser.c"
						gboolean _tmp114_ = FALSE;
#line 305 "../gxml/Parser.vala"
						g_propagate_error (error, _inner_error0_);
#line 305 "../gxml/Parser.vala"
						_g_object_unref0 (obj);
#line 305 "../gxml/Parser.vala"
						G_IS_VALUE (&vc) ? (g_value_unset (&vc), NULL) : NULL;
#line 305 "../gxml/Parser.vala"
						_g_object_unref0 (col);
#line 305 "../gxml/Parser.vala"
						_g_param_spec_unref0 (pspec);
#line 305 "../gxml/Parser.vala"
						(pspec_collection == NULL) ? NULL : (pspec_collection = (_g_list_free__g_param_spec_unref0_ (pspec_collection), NULL));
#line 305 "../gxml/Parser.vala"
						_g_object_unref0 (_vala_element);
#line 305 "../gxml/Parser.vala"
						return _tmp114_;
#line 2750 "Parser.c"
					}
#line 306 "../gxml/Parser.vala"
					_tmp115_ = obj;
#line 306 "../gxml/Parser.vala"
					gxml_parser_read_element (self, GXML_IS_DOM_ELEMENT (_tmp115_) ? ((GXmlDomElement*) _tmp115_) : NULL, &_inner_error0_);
#line 306 "../gxml/Parser.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2758 "Parser.c"
						gboolean _tmp116_ = FALSE;
#line 306 "../gxml/Parser.vala"
						g_propagate_error (error, _inner_error0_);
#line 306 "../gxml/Parser.vala"
						_g_object_unref0 (obj);
#line 306 "../gxml/Parser.vala"
						G_IS_VALUE (&vc) ? (g_value_unset (&vc), NULL) : NULL;
#line 306 "../gxml/Parser.vala"
						_g_object_unref0 (col);
#line 306 "../gxml/Parser.vala"
						_g_param_spec_unref0 (pspec);
#line 306 "../gxml/Parser.vala"
						(pspec_collection == NULL) ? NULL : (pspec_collection = (_g_list_free__g_param_spec_unref0_ (pspec_collection), NULL));
#line 306 "../gxml/Parser.vala"
						_g_object_unref0 (_vala_element);
#line 306 "../gxml/Parser.vala"
						return _tmp116_;
#line 2776 "Parser.c"
					}
#line 307 "../gxml/Parser.vala"
					_tmp117_ = col;
#line 307 "../gxml/Parser.vala"
					_tmp118_ = obj;
#line 307 "../gxml/Parser.vala"
					gxml_collection_append (_tmp117_, _tmp118_, &_inner_error0_);
#line 307 "../gxml/Parser.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2786 "Parser.c"
						gboolean _tmp119_ = FALSE;
#line 307 "../gxml/Parser.vala"
						g_propagate_error (error, _inner_error0_);
#line 307 "../gxml/Parser.vala"
						_g_object_unref0 (obj);
#line 307 "../gxml/Parser.vala"
						G_IS_VALUE (&vc) ? (g_value_unset (&vc), NULL) : NULL;
#line 307 "../gxml/Parser.vala"
						_g_object_unref0 (col);
#line 307 "../gxml/Parser.vala"
						_g_param_spec_unref0 (pspec);
#line 307 "../gxml/Parser.vala"
						(pspec_collection == NULL) ? NULL : (pspec_collection = (_g_list_free__g_param_spec_unref0_ (pspec_collection), NULL));
#line 307 "../gxml/Parser.vala"
						_g_object_unref0 (_vala_element);
#line 307 "../gxml/Parser.vala"
						return _tmp119_;
#line 2804 "Parser.c"
					}
#line 308 "../gxml/Parser.vala"
					_tmp120_ = obj;
#line 308 "../gxml/Parser.vala"
					_tmp121_ = _g_object_ref0 ((GXmlDomNode*) _tmp120_);
#line 308 "../gxml/Parser.vala"
					_g_object_unref0 (_vala_element);
#line 308 "../gxml/Parser.vala"
					_vala_element = _tmp121_;
#line 309 "../gxml/Parser.vala"
					result = TRUE;
#line 309 "../gxml/Parser.vala"
					_g_object_unref0 (obj);
#line 309 "../gxml/Parser.vala"
					G_IS_VALUE (&vc) ? (g_value_unset (&vc), NULL) : NULL;
#line 309 "../gxml/Parser.vala"
					_g_object_unref0 (col);
#line 309 "../gxml/Parser.vala"
					_g_param_spec_unref0 (pspec);
#line 309 "../gxml/Parser.vala"
					(pspec_collection == NULL) ? NULL : (pspec_collection = (_g_list_free__g_param_spec_unref0_ (pspec_collection), NULL));
#line 309 "../gxml/Parser.vala"
					if (element) {
#line 309 "../gxml/Parser.vala"
						*element = _vala_element;
#line 2830 "Parser.c"
					} else {
#line 309 "../gxml/Parser.vala"
						_g_object_unref0 (_vala_element);
#line 2834 "Parser.c"
					}
#line 309 "../gxml/Parser.vala"
					return result;
#line 2838 "Parser.c"
				}
#line 302 "../gxml/Parser.vala"
				G_IS_VALUE (&vc) ? (g_value_unset (&vc), NULL) : NULL;
#line 302 "../gxml/Parser.vala"
				_g_object_unref0 (col);
#line 302 "../gxml/Parser.vala"
				_g_param_spec_unref0 (pspec);
#line 2846 "Parser.c"
			}
		}
#line 302 "../gxml/Parser.vala"
		(pspec_collection == NULL) ? NULL : (pspec_collection = (_g_list_free__g_param_spec_unref0_ (pspec_collection), NULL));
#line 2851 "Parser.c"
	}
#line 312 "../gxml/Parser.vala"
	result = FALSE;
#line 312 "../gxml/Parser.vala"
	if (element) {
#line 312 "../gxml/Parser.vala"
		*element = _vala_element;
#line 2859 "Parser.c"
	} else {
#line 312 "../gxml/Parser.vala"
		_g_object_unref0 (_vala_element);
#line 2863 "Parser.c"
	}
#line 312 "../gxml/Parser.vala"
	return result;
#line 2867 "Parser.c"
}

gboolean
gxml_parser_add_element_collection (GXmlParser* self,
                                    GXmlDomNode* parent,
                                    GXmlDomNode** element,
                                    GError** error)
{
	GXmlParserIface* _iface_;
#line 256 "../gxml/Parser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 256 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 256 "../gxml/Parser.vala"
	if (_iface_->add_element_collection) {
#line 256 "../gxml/Parser.vala"
		return _iface_->add_element_collection (self, parent, element, error);
#line 2885 "Parser.c"
	}
#line 256 "../gxml/Parser.vala"
	return FALSE;
#line 2889 "Parser.c"
}

/**
   * Read all children node feed by stream.
   */
void
gxml_parser_read_child_nodes_stream (GXmlParser* self,
                                     GInputStream* istream,
                                     GError** error)
{
	GXmlParserIface* _iface_;
#line 317 "../gxml/Parser.vala"
	g_return_if_fail (self != NULL);
#line 317 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 317 "../gxml/Parser.vala"
	if (_iface_->read_child_nodes_stream) {
#line 317 "../gxml/Parser.vala"
		_iface_->read_child_nodes_stream (self, istream, error);
#line 2909 "Parser.c"
	}
}

/**
   * Read children nodes from string
   */
static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1555 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1556 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1556 "glib-2.0.vapi"
	res_length1 = -1;
#line 1556 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1557 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1557 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1557 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1558 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1558 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1558 "glib-2.0.vapi"
	if (result_length1) {
#line 1558 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 2950 "Parser.c"
	}
#line 1558 "glib-2.0.vapi"
	result = _tmp2_;
#line 1558 "glib-2.0.vapi"
	return result;
#line 2956 "Parser.c"
}

static guint8*
_vala_array_dup3 (guint8* self,
                  gssize length)
{
#line 324 "../gxml/Parser.vala"
	if (length > 0) {
#line 324 "../gxml/Parser.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 2967 "Parser.c"
	}
#line 324 "../gxml/Parser.vala"
	return NULL;
#line 2971 "Parser.c"
}

static void
gxml_parser_real_read_child_nodes_string (GXmlParser* self,
                                          const gchar* str,
                                          GError** error)
{
	GMemoryInputStream* stream = NULL;
	guint8* _tmp1_;
	gint _tmp1__length1;
	gint _tmp2_ = 0;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
	GDestroyNotify _tmp5_;
	GMemoryInputStream* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 321 "../gxml/Parser.vala"
	g_return_if_fail (str != NULL);
#line 322 "../gxml/Parser.vala"
	if (g_strcmp0 (str, "") == 0) {
#line 2994 "Parser.c"
		GError* _tmp0_;
#line 323 "../gxml/Parser.vala"
		_tmp0_ = g_error_new_literal (GXML_PARSER_ERROR, GXML_PARSER_ERROR_INVALID_DATA_ERROR, _ ("Invalid document string, it is empty or is not allowed"));
#line 323 "../gxml/Parser.vala"
		_inner_error0_ = _tmp0_;
#line 323 "../gxml/Parser.vala"
		g_propagate_error (error, _inner_error0_);
#line 323 "../gxml/Parser.vala"
		return;
#line 3004 "Parser.c"
	}
#line 324 "../gxml/Parser.vala"
	_tmp1_ = string_get_data (str, &_tmp2_);
#line 324 "../gxml/Parser.vala"
	_tmp1__length1 = _tmp2_;
#line 324 "../gxml/Parser.vala"
	_tmp3_ = _tmp1_;
#line 324 "../gxml/Parser.vala"
	_tmp3__length1 = _tmp1__length1;
#line 324 "../gxml/Parser.vala"
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup3 (_tmp3_, _tmp3__length1) : _tmp3_;
#line 324 "../gxml/Parser.vala"
	_tmp4__length1 = _tmp3__length1;
#line 324 "../gxml/Parser.vala"
	_tmp5_ = g_free;
#line 324 "../gxml/Parser.vala"
	_tmp6_ = (GMemoryInputStream*) g_memory_input_stream_new_from_data (_tmp4_, _tmp4__length1, _tmp5_);
#line 324 "../gxml/Parser.vala"
	stream = _tmp6_;
#line 325 "../gxml/Parser.vala"
	gxml_parser_read_child_nodes_stream (self, (GInputStream*) stream, &_inner_error0_);
#line 325 "../gxml/Parser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 325 "../gxml/Parser.vala"
		g_propagate_error (error, _inner_error0_);
#line 325 "../gxml/Parser.vala"
		_g_object_unref0 (stream);
#line 325 "../gxml/Parser.vala"
		return;
#line 3034 "Parser.c"
	}
#line 321 "../gxml/Parser.vala"
	_g_object_unref0 (stream);
#line 3038 "Parser.c"
}

void
gxml_parser_read_child_nodes_string (GXmlParser* self,
                                     const gchar* str,
                                     GError** error)
{
	GXmlParserIface* _iface_;
#line 321 "../gxml/Parser.vala"
	g_return_if_fail (self != NULL);
#line 321 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 321 "../gxml/Parser.vala"
	if (_iface_->read_child_nodes_string) {
#line 321 "../gxml/Parser.vala"
		_iface_->read_child_nodes_string (self, str, error);
#line 3055 "Parser.c"
	}
}

/**
   * Reads all child nodes as string
   */
gchar*
gxml_parser_read_unparsed (GXmlParser* self,
                           GError** error)
{
	GXmlParserIface* _iface_;
#line 330 "../gxml/Parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 330 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 330 "../gxml/Parser.vala"
	if (_iface_->read_unparsed) {
#line 330 "../gxml/Parser.vala"
		return _iface_->read_unparsed (self, error);
#line 3075 "Parser.c"
	}
#line 330 "../gxml/Parser.vala"
	return NULL;
#line 3079 "Parser.c"
}

/**
   * Use parser to go to next parsed node.
   */
gboolean
gxml_parser_move_next_node (GXmlParser* self,
                            GError** error)
{
	GXmlParserIface* _iface_;
#line 334 "../gxml/Parser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 334 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 334 "../gxml/Parser.vala"
	if (_iface_->move_next_node) {
#line 334 "../gxml/Parser.vala"
		return _iface_->move_next_node (self, error);
#line 3098 "Parser.c"
	}
#line 334 "../gxml/Parser.vala"
	return FALSE;
#line 3102 "Parser.c"
}

/**
   * Check if current node has children.
   */
gboolean
gxml_parser_current_is_empty_element (GXmlParser* self)
{
	GXmlParserIface* _iface_;
#line 338 "../gxml/Parser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 338 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 338 "../gxml/Parser.vala"
	if (_iface_->current_is_empty_element) {
#line 338 "../gxml/Parser.vala"
		return _iface_->current_is_empty_element (self);
#line 3120 "Parser.c"
	}
#line 338 "../gxml/Parser.vala"
	return FALSE;
#line 3124 "Parser.c"
}

/**
   * Check if current node found by parser, is a {@link DomElement}
   */
gboolean
gxml_parser_current_is_element (GXmlParser* self)
{
	GXmlParserIface* _iface_;
#line 342 "../gxml/Parser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 342 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 342 "../gxml/Parser.vala"
	if (_iface_->current_is_element) {
#line 342 "../gxml/Parser.vala"
		return _iface_->current_is_element (self);
#line 3142 "Parser.c"
	}
#line 342 "../gxml/Parser.vala"
	return FALSE;
#line 3146 "Parser.c"
}

/**
   * Check if current node found by parser, is a {@link DomDocument}
   */
gboolean
gxml_parser_current_is_document (GXmlParser* self)
{
	GXmlParserIface* _iface_;
#line 346 "../gxml/Parser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 346 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 346 "../gxml/Parser.vala"
	if (_iface_->current_is_document) {
#line 346 "../gxml/Parser.vala"
		return _iface_->current_is_document (self);
#line 3164 "Parser.c"
	}
#line 346 "../gxml/Parser.vala"
	return FALSE;
#line 3168 "Parser.c"
}

/**
   * Returns current node's local name, found by parser.
   */
gchar*
gxml_parser_current_node_name (GXmlParser* self)
{
	GXmlParserIface* _iface_;
#line 350 "../gxml/Parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 350 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 350 "../gxml/Parser.vala"
	if (_iface_->current_node_name) {
#line 350 "../gxml/Parser.vala"
		return _iface_->current_node_name (self);
#line 3186 "Parser.c"
	}
#line 350 "../gxml/Parser.vala"
	return NULL;
#line 3190 "Parser.c"
}

/**
   * Creates a new {@link DomElement} and append it as a child of parent.
   */
GXmlDomElement*
gxml_parser_create_element (GXmlParser* self,
                            GXmlDomNode* parent,
                            GError** error)
{
	GXmlParserIface* _iface_;
#line 354 "../gxml/Parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 354 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 354 "../gxml/Parser.vala"
	if (_iface_->create_element) {
#line 354 "../gxml/Parser.vala"
		return _iface_->create_element (self, parent, error);
#line 3210 "Parser.c"
	}
#line 354 "../gxml/Parser.vala"
	return NULL;
#line 3214 "Parser.c"
}

/**
   * Reads an element's attributes, setting its values and taking care about their
   * namespaces.
   */
void
gxml_parser_read_element (GXmlParser* self,
                          GXmlDomElement* element,
                          GError** error)
{
	GXmlParserIface* _iface_;
#line 359 "../gxml/Parser.vala"
	g_return_if_fail (self != NULL);
#line 359 "../gxml/Parser.vala"
	_iface_ = GXML_PARSER_GET_INTERFACE (self);
#line 359 "../gxml/Parser.vala"
	if (_iface_->read_element) {
#line 359 "../gxml/Parser.vala"
		_iface_->read_element (self, element, error);
#line 3235 "Parser.c"
	}
}

static void
gxml_parser_default_init (GXmlParserIface * iface,
                          gpointer iface_data)
{
	/**
	   * Controls if, when writing to a file, a backup should
	   * be created.
	   */
#line 249 "../gxml/Parser.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("backup", "backup", "backup", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3249 "Parser.c"
	/**
	   * Controls if, when writing, indentation should be used.
	   */
#line 249 "../gxml/Parser.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("indent", "indent", "indent", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3255 "Parser.c"
	/**
	   * Controls if, when writing, indentation should be used.
	   */
#line 249 "../gxml/Parser.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("cancellable", "cancellable", "cancellable", g_cancellable_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3261 "Parser.c"
	/**
	   * A {@link GXml.DomDocument} to read to or write from
	   */
#line 249 "../gxml/Parser.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("node", "node", "node", GXML_TYPE_DOM_NODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3267 "Parser.c"
	/**
	   * A collection of child types of found {@link GXml.CollectionParent}
	   * objects, used to instantiate the correct class based on the
	   * node's name.
	   *
	   * The map use the {@link GLib.Type} of the object implementing
	   * {@link GXml.CollectionParent} as the key, to get a {@link GLib.HashTable}
	   * holding a set of instantiable child classes, with the key as the
	   * lowercase of the node's local name to get the {@link GLib.Type}
	   * of the instantiable class to create and add to the collection.
	   */
#line 249 "../gxml/Parser.vala"
	g_object_interface_install_property (iface, g_param_spec_boxed ("types", "types", "types", G_TYPE_HASH_TABLE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 249 "../gxml/Parser.vala"
	iface->write_file = gxml_parser_real_write_file;
#line 249 "../gxml/Parser.vala"
	iface->write_file_async = gxml_parser_real_write_file_async;
#line 249 "../gxml/Parser.vala"
	iface->write_file_finish = gxml_parser_real_write_file_finish;
#line 249 "../gxml/Parser.vala"
	iface->read_file = gxml_parser_real_read_file;
#line 249 "../gxml/Parser.vala"
	iface->read_file_async = gxml_parser_real_read_file_async;
#line 249 "../gxml/Parser.vala"
	iface->read_file_finish = gxml_parser_real_read_file_finish;
#line 249 "../gxml/Parser.vala"
	iface->read_child_nodes = gxml_parser_real_read_child_nodes;
#line 249 "../gxml/Parser.vala"
	iface->read_child_nodes_async = gxml_parser_real_read_child_nodes_async;
#line 249 "../gxml/Parser.vala"
	iface->read_child_nodes_finish = gxml_parser_real_read_child_nodes_finish;
#line 249 "../gxml/Parser.vala"
	iface->read_child_element = gxml_parser_real_read_child_element;
#line 249 "../gxml/Parser.vala"
	iface->read_element_property = gxml_parser_real_read_element_property;
#line 249 "../gxml/Parser.vala"
	iface->add_element_collection = gxml_parser_real_add_element_collection;
#line 249 "../gxml/Parser.vala"
	iface->read_child_nodes_string = gxml_parser_real_read_child_nodes_string;
#line 3307 "Parser.c"
}

/**
 * XML parser engine for {@link DomDocument} implementations.
 */
static GType
gxml_parser_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GXmlParserIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_parser_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType gxml_parser_type_id;
	gxml_parser_type_id = g_type_register_static (G_TYPE_INTERFACE, "GXmlParser", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (gxml_parser_type_id, G_TYPE_OBJECT);
	return gxml_parser_type_id;
}

GType
gxml_parser_get_type (void)
{
	static volatile gsize gxml_parser_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_parser_type_id__volatile)) {
		GType gxml_parser_type_id;
		gxml_parser_type_id = gxml_parser_get_type_once ();
		g_once_init_leave (&gxml_parser_type_id__volatile, gxml_parser_type_id);
	}
	return gxml_parser_type_id__volatile;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 245 "../gxml/Parser.vala"
	if (mem && byte_size != 0) {
#line 245 "../gxml/Parser.vala"
		new_mem = g_malloc (byte_size);
#line 245 "../gxml/Parser.vala"
		memcpy (new_mem, mem, byte_size);
#line 3346 "Parser.c"
	} else {
#line 245 "../gxml/Parser.vala"
		new_mem = NULL;
#line 3350 "Parser.c"
	}
#line 245 "../gxml/Parser.vala"
	return new_mem;
#line 3354 "Parser.c"
}

