/* Range.c generated by valac 0.54.7, the Vala compiler
 * generated from Range.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: t; c-basic-offset: 2; tab-width: 2 -*- */
/*
 *
 * Copyright (C) 2016  Daniel Espinosa <esodan@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Daniel Espinosa <esodan@gmail.com>
 */
/* FIXME Range could be a set of nodes or a set of character data*/

#include "gxml/gxml.h"
#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include "gxml.h"

enum  {
	GXML_RANGE_0_PROPERTY,
	GXML_RANGE_START_CONTAINER_PROPERTY,
	GXML_RANGE_START_OFFSET_PROPERTY,
	GXML_RANGE_END_CONTAINER_PROPERTY,
	GXML_RANGE_END_OFFSET_PROPERTY,
	GXML_RANGE_COLLAPSED_PROPERTY,
	GXML_RANGE_COMMON_ANCESTOR_CONTAINER_PROPERTY,
	GXML_RANGE_NUM_PROPERTIES
};
static GParamSpec* gxml_range_properties[GXML_RANGE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

static gpointer gxml_range_parent_class = NULL;
static GXmlDomRangeIface * gxml_range_gxml_dom_range_parent_iface = NULL;

static void gxml_range_real_set_start (GXmlDomRange* base,
                                GXmlDomNode* node,
                                gint offset,
                                GError** error);
static void gxml_range_real_set_end (GXmlDomRange* base,
                              GXmlDomNode* node,
                              gint offset,
                              GError** error);
static void gxml_range_real_set_start_before (GXmlDomRange* base,
                                       GXmlDomNode* node,
                                       GError** error);
static void gxml_range_real_set_start_after (GXmlDomRange* base,
                                      GXmlDomNode* node,
                                      GError** error);
static void gxml_range_real_set_end_before (GXmlDomRange* base,
                                     GXmlDomNode* node,
                                     GError** error);
static void gxml_range_real_set_end_after (GXmlDomRange* base,
                                    GXmlDomNode* node,
                                    GError** error);
static void gxml_range_real_collapse (GXmlDomRange* base,
                               gboolean to_start,
                               GError** error);
static void gxml_range_real_select_node (GXmlDomRange* base,
                                  GXmlDomNode* node,
                                  GError** error);
static void gxml_range_real_select_node_contents (GXmlDomRange* base,
                                           GXmlDomNode* node,
                                           GError** error);
static gint gxml_range_real_compare_boundary_points (GXmlDomRange* base,
                                              GXmlDomRangeBoundaryPoints how,
                                              GXmlDomRange* source_range,
                                              GError** error);
static void gxml_range_real_delete_contents (GXmlDomRange* base,
                                      GError** error);
static GXmlDomDocumentFragment* gxml_range_real_extract_contents (GXmlDomRange* base,
                                                           GError** error);
static GXmlDomDocumentFragment* gxml_range_real_clone_contents (GXmlDomRange* base,
                                                         GError** error);
static void gxml_range_real_insert_node (GXmlDomRange* base,
                                  GXmlDomNode* node);
static void gxml_range_real_surround_contents (GXmlDomRange* base,
                                        GXmlDomNode* newParent);
static GXmlDomRange* gxml_range_real_clone_range (GXmlDomRange* base);
static void gxml_range_real_detach (GXmlDomRange* base);
static gboolean gxml_range_real_is_point_in_range (GXmlDomRange* base,
                                            GXmlDomNode* node,
                                            gint offset);
static gshort gxml_range_real_compare_point (GXmlDomRange* base,
                                      GXmlDomNode* node,
                                      gint offset);
static gboolean gxml_range_real_intersects_node (GXmlDomRange* base,
                                          GXmlDomNode* node);
static gchar* gxml_range_real_to_string (GXmlDomRange* base);
static void gxml_range_finalize (GObject * obj);
static GType gxml_range_get_type_once (void);
static void _vala_gxml_range_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GXmlDomNode*
gxml_range_real_get_start_container (GXmlDomRange* base)
{
	GXmlDomNode* result;
	GXmlRange* self;
	GXmlDomNode* _tmp0_;
#line 35 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 35 "../gxml/Range.vala"
	_tmp0_ = self->_start_container;
#line 35 "../gxml/Range.vala"
	result = _tmp0_;
#line 35 "../gxml/Range.vala"
	return result;
#line 130 "Range.c"
}

static gint
gxml_range_real_get_start_offset (GXmlDomRange* base)
{
	gint result;
	GXmlRange* self;
#line 36 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 36 "../gxml/Range.vala"
	result = self->_start_offset;
#line 36 "../gxml/Range.vala"
	return result;
#line 144 "Range.c"
}

static GXmlDomNode*
gxml_range_real_get_end_container (GXmlDomRange* base)
{
	GXmlDomNode* result;
	GXmlRange* self;
	GXmlDomNode* _tmp0_;
#line 37 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 37 "../gxml/Range.vala"
	_tmp0_ = self->_end_container;
#line 37 "../gxml/Range.vala"
	result = _tmp0_;
#line 37 "../gxml/Range.vala"
	return result;
#line 161 "Range.c"
}

static gint
gxml_range_real_get_end_offset (GXmlDomRange* base)
{
	gint result;
	GXmlRange* self;
#line 38 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 38 "../gxml/Range.vala"
	result = self->_end_offset;
#line 38 "../gxml/Range.vala"
	return result;
#line 175 "Range.c"
}

static gboolean
gxml_range_real_get_collapsed (GXmlDomRange* base)
{
	gboolean result;
	GXmlRange* self;
#line 39 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 39 "../gxml/Range.vala"
	result = self->_collapse;
#line 39 "../gxml/Range.vala"
	return result;
#line 189 "Range.c"
}

static GXmlDomNode*
gxml_range_real_get_common_ancestor_container (GXmlDomRange* base)
{
	GXmlDomNode* result;
	GXmlRange* self;
	GXmlDomNode* _tmp0_;
#line 40 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 40 "../gxml/Range.vala"
	_tmp0_ = self->_common_ancestor_container;
#line 40 "../gxml/Range.vala"
	result = _tmp0_;
#line 40 "../gxml/Range.vala"
	return result;
#line 206 "Range.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 43 "../gxml/Range.vala"
	return self ? g_object_ref (self) : NULL;
#line 214 "Range.c"
}

GXmlRange*
gxml_range_construct (GType object_type,
                      GXmlDomDocument* doc)
{
	GXmlRange * self = NULL;
	GXmlDomDocument* _tmp0_;
	GXmlDomNode* _tmp1_;
	GXmlDomNode* _tmp2_;
	GXmlDomNode* _tmp3_;
#line 42 "../gxml/Range.vala"
	g_return_val_if_fail (doc != NULL, NULL);
#line 42 "../gxml/Range.vala"
	self = (GXmlRange*) g_object_new (object_type, NULL);
#line 43 "../gxml/Range.vala"
	_tmp0_ = _g_object_ref0 (doc);
#line 43 "../gxml/Range.vala"
	_g_object_unref0 (self->_document);
#line 43 "../gxml/Range.vala"
	self->_document = _tmp0_;
#line 44 "../gxml/Range.vala"
	_tmp1_ = _g_object_ref0 ((GXmlDomNode*) doc);
#line 44 "../gxml/Range.vala"
	_g_object_unref0 (self->_start_container);
#line 44 "../gxml/Range.vala"
	self->_start_container = _tmp1_;
#line 45 "../gxml/Range.vala"
	_tmp2_ = _g_object_ref0 ((GXmlDomNode*) doc);
#line 45 "../gxml/Range.vala"
	_g_object_unref0 (self->_end_container);
#line 45 "../gxml/Range.vala"
	self->_end_container = _tmp2_;
#line 46 "../gxml/Range.vala"
	self->_start_offset = 0;
#line 47 "../gxml/Range.vala"
	self->_end_offset = 0;
#line 48 "../gxml/Range.vala"
	_tmp3_ = _g_object_ref0 ((GXmlDomNode*) doc);
#line 48 "../gxml/Range.vala"
	_g_object_unref0 (self->_common_ancestor_container);
#line 48 "../gxml/Range.vala"
	self->_common_ancestor_container = _tmp3_;
#line 42 "../gxml/Range.vala"
	return self;
#line 260 "Range.c"
}

GXmlRange*
gxml_range_new (GXmlDomDocument* doc)
{
#line 42 "../gxml/Range.vala"
	return gxml_range_construct (GXML_TYPE_RANGE, doc);
#line 268 "Range.c"
}

static void
gxml_range_real_set_start (GXmlDomRange* base,
                           GXmlDomNode* node,
                           gint offset,
                           GError** error)
{
	GXmlRange * self;
	GXmlDomNode* _tmp12_;
	GXmlDomNode* _tmp32_;
	GError* _inner_error0_ = NULL;
#line 51 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 51 "../gxml/Range.vala"
	g_return_if_fail (node != NULL);
#line 52 "../gxml/Range.vala"
	if (GXML_IS_DOM_DOCUMENT_TYPE (node)) {
#line 287 "Range.c"
		GError* _tmp0_;
#line 53 "../gxml/Range.vala"
		_tmp0_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Invalid node type to start"));
#line 53 "../gxml/Range.vala"
		_inner_error0_ = _tmp0_;
#line 53 "../gxml/Range.vala"
		g_propagate_error (error, _inner_error0_);
#line 53 "../gxml/Range.vala"
		return;
#line 297 "Range.c"
	}
#line 54 "../gxml/Range.vala"
	if (GXML_IS_DOM_DOCUMENT_TYPE (node)) {
#line 55 "../gxml/Range.vala"
		if (offset > 0) {
#line 303 "Range.c"
			GError* _tmp1_;
#line 56 "../gxml/Range.vala"
			_tmp1_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_INDEX_SIZE_ERROR, _ ("Invalid offset for node to start: for document type"));
#line 56 "../gxml/Range.vala"
			_inner_error0_ = _tmp1_;
#line 56 "../gxml/Range.vala"
			g_propagate_error (error, _inner_error0_);
#line 56 "../gxml/Range.vala"
			return;
#line 313 "Range.c"
		} else {
#line 58 "../gxml/Range.vala"
			if (GXML_IS_DOM_CHARACTER_DATA (node)) {
#line 317 "Range.c"
				gint _tmp2_;
				gint _tmp3_;
#line 59 "../gxml/Range.vala"
				_tmp2_ = gxml_dom_character_data_get_length (G_TYPE_CHECK_INSTANCE_CAST (node, GXML_TYPE_DOM_CHARACTER_DATA, GXmlDomCharacterData));
#line 59 "../gxml/Range.vala"
				_tmp3_ = _tmp2_;
#line 59 "../gxml/Range.vala"
				if (offset > _tmp3_) {
#line 326 "Range.c"
					GError* _tmp4_;
#line 60 "../gxml/Range.vala"
					_tmp4_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_INDEX_SIZE_ERROR, _ ("Invalid offset for node to start: for character data"));
#line 60 "../gxml/Range.vala"
					_inner_error0_ = _tmp4_;
#line 60 "../gxml/Range.vala"
					g_propagate_error (error, _inner_error0_);
#line 60 "../gxml/Range.vala"
					return;
#line 336 "Range.c"
				} else {
					GXmlDomNodeList* _tmp5_;
					GXmlDomNodeList* _tmp6_;
					GXmlDomNodeList* _tmp7_;
					gint _tmp8_;
					gint _tmp9_;
					gboolean _tmp10_;
#line 62 "../gxml/Range.vala"
					_tmp5_ = gxml_dom_node_get_child_nodes (node);
#line 62 "../gxml/Range.vala"
					_tmp6_ = _tmp5_;
#line 62 "../gxml/Range.vala"
					_tmp7_ = _tmp6_;
#line 62 "../gxml/Range.vala"
					_tmp8_ = gxml_dom_node_list_get_length (_tmp7_);
#line 62 "../gxml/Range.vala"
					_tmp9_ = _tmp8_;
#line 62 "../gxml/Range.vala"
					_tmp10_ = offset > _tmp9_;
#line 62 "../gxml/Range.vala"
					_g_object_unref0 (_tmp7_);
#line 62 "../gxml/Range.vala"
					if (_tmp10_) {
#line 360 "Range.c"
						GError* _tmp11_;
#line 63 "../gxml/Range.vala"
						_tmp11_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_INDEX_SIZE_ERROR, _ ("Invalid offset for node to start: for children number"));
#line 63 "../gxml/Range.vala"
						_inner_error0_ = _tmp11_;
#line 63 "../gxml/Range.vala"
						g_propagate_error (error, _inner_error0_);
#line 63 "../gxml/Range.vala"
						return;
#line 370 "Range.c"
					}
				}
			}
		}
	}
#line 64 "../gxml/Range.vala"
	_tmp12_ = self->_end_container;
#line 64 "../gxml/Range.vala"
	if (_tmp12_ != NULL) {
#line 380 "Range.c"
		GXmlDomNode* _tmp13_;
		GXmlDomNode* _tmp14_;
		GXmlDomNode* _tmp15_;
		GXmlDomNode* _tmp16_;
		GXmlDomNode* _tmp17_;
		GXmlDomNode* _tmp18_;
		GXmlDomNode* _tmp19_;
		gboolean _tmp20_;
#line 65 "../gxml/Range.vala"
		_tmp13_ = gxml_dom_node_get_parent_node (node);
#line 65 "../gxml/Range.vala"
		_tmp14_ = _tmp13_;
#line 65 "../gxml/Range.vala"
		_tmp15_ = _tmp14_;
#line 65 "../gxml/Range.vala"
		_tmp16_ = self->_end_container;
#line 65 "../gxml/Range.vala"
		_tmp17_ = gxml_dom_node_get_parent_node (_tmp16_);
#line 65 "../gxml/Range.vala"
		_tmp18_ = _tmp17_;
#line 65 "../gxml/Range.vala"
		_tmp19_ = _tmp18_;
#line 65 "../gxml/Range.vala"
		_tmp20_ = _tmp15_ != _tmp19_;
#line 65 "../gxml/Range.vala"
		_g_object_unref0 (_tmp19_);
#line 65 "../gxml/Range.vala"
		_g_object_unref0 (_tmp15_);
#line 65 "../gxml/Range.vala"
		if (_tmp20_) {
#line 411 "Range.c"
			GXmlDomNode* _tmp21_;
			GXmlDomNode* _tmp22_;
#line 66 "../gxml/Range.vala"
			_tmp21_ = self->_end_container;
#line 66 "../gxml/Range.vala"
			_tmp22_ = _g_object_ref0 (_tmp21_);
#line 66 "../gxml/Range.vala"
			_g_object_unref0 (self->_start_container);
#line 66 "../gxml/Range.vala"
			self->_start_container = _tmp22_;
#line 67 "../gxml/Range.vala"
			self->_start_offset = self->_end_offset;
#line 424 "Range.c"
		} else {
			gint ni = 0;
			GXmlDomNode* _tmp23_;
			GXmlDomNode* _tmp24_;
			GXmlDomNode* _tmp25_;
			GXmlDomNodeList* _tmp26_;
			GXmlDomNodeList* _tmp27_;
			GXmlDomNodeList* _tmp28_;
			gint _tmp29_;
			GXmlDomNode* _tmp31_;
#line 69 "../gxml/Range.vala"
			_tmp23_ = gxml_dom_node_get_parent_node (node);
#line 69 "../gxml/Range.vala"
			_tmp24_ = _tmp23_;
#line 69 "../gxml/Range.vala"
			_tmp25_ = _tmp24_;
#line 69 "../gxml/Range.vala"
			_tmp26_ = gxml_dom_node_get_child_nodes (_tmp25_);
#line 69 "../gxml/Range.vala"
			_tmp27_ = _tmp26_;
#line 69 "../gxml/Range.vala"
			_tmp28_ = _tmp27_;
#line 69 "../gxml/Range.vala"
			_tmp29_ = gee_list_index_of ((GeeList*) _tmp28_, node);
#line 69 "../gxml/Range.vala"
			_g_object_unref0 (_tmp28_);
#line 69 "../gxml/Range.vala"
			_g_object_unref0 (_tmp25_);
#line 69 "../gxml/Range.vala"
			ni = _tmp29_;
#line 70 "../gxml/Range.vala"
			if (ni > offset) {
#line 457 "Range.c"
				GXmlDomNode* _tmp30_;
#line 71 "../gxml/Range.vala"
				_tmp30_ = _g_object_ref0 (node);
#line 71 "../gxml/Range.vala"
				_g_object_unref0 (self->_end_container);
#line 71 "../gxml/Range.vala"
				self->_end_container = _tmp30_;
#line 465 "Range.c"
			}
#line 72 "../gxml/Range.vala"
			_tmp31_ = _g_object_ref0 (node);
#line 72 "../gxml/Range.vala"
			_g_object_unref0 (self->_start_container);
#line 72 "../gxml/Range.vala"
			self->_start_container = _tmp31_;
#line 73 "../gxml/Range.vala"
			self->_start_offset = offset;
#line 475 "Range.c"
		}
	}
#line 76 "../gxml/Range.vala"
	_tmp32_ = _g_object_ref0 (node);
#line 76 "../gxml/Range.vala"
	_g_object_unref0 (self->_start_container);
#line 76 "../gxml/Range.vala"
	self->_start_container = _tmp32_;
#line 77 "../gxml/Range.vala"
	self->_start_offset = offset;
#line 486 "Range.c"
}

static void
gxml_range_real_set_end (GXmlDomRange* base,
                         GXmlDomNode* node,
                         gint offset,
                         GError** error)
{
	GXmlRange * self;
	GXmlDomNode* _tmp12_;
	GXmlDomNode* _tmp31_;
	GError* _inner_error0_ = NULL;
#line 79 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 79 "../gxml/Range.vala"
	g_return_if_fail (node != NULL);
#line 80 "../gxml/Range.vala"
	if (GXML_IS_DOM_DOCUMENT_TYPE (node)) {
#line 505 "Range.c"
		GError* _tmp0_;
#line 81 "../gxml/Range.vala"
		_tmp0_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Invalid node type to start"));
#line 81 "../gxml/Range.vala"
		_inner_error0_ = _tmp0_;
#line 81 "../gxml/Range.vala"
		g_propagate_error (error, _inner_error0_);
#line 81 "../gxml/Range.vala"
		return;
#line 515 "Range.c"
	}
#line 82 "../gxml/Range.vala"
	if (GXML_IS_DOM_DOCUMENT_TYPE (node)) {
#line 83 "../gxml/Range.vala"
		if (offset > 0) {
#line 521 "Range.c"
			GError* _tmp1_;
#line 84 "../gxml/Range.vala"
			_tmp1_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_INDEX_SIZE_ERROR, _ ("Invalid offset for node to start: for document type"));
#line 84 "../gxml/Range.vala"
			_inner_error0_ = _tmp1_;
#line 84 "../gxml/Range.vala"
			g_propagate_error (error, _inner_error0_);
#line 84 "../gxml/Range.vala"
			return;
#line 531 "Range.c"
		} else {
#line 86 "../gxml/Range.vala"
			if (GXML_IS_DOM_CHARACTER_DATA (node)) {
#line 535 "Range.c"
				gint _tmp2_;
				gint _tmp3_;
#line 87 "../gxml/Range.vala"
				_tmp2_ = gxml_dom_character_data_get_length (G_TYPE_CHECK_INSTANCE_CAST (node, GXML_TYPE_DOM_CHARACTER_DATA, GXmlDomCharacterData));
#line 87 "../gxml/Range.vala"
				_tmp3_ = _tmp2_;
#line 87 "../gxml/Range.vala"
				if (offset > _tmp3_) {
#line 544 "Range.c"
					GError* _tmp4_;
#line 88 "../gxml/Range.vala"
					_tmp4_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_INDEX_SIZE_ERROR, _ ("Invalid offset for node to start: for character data"));
#line 88 "../gxml/Range.vala"
					_inner_error0_ = _tmp4_;
#line 88 "../gxml/Range.vala"
					g_propagate_error (error, _inner_error0_);
#line 88 "../gxml/Range.vala"
					return;
#line 554 "Range.c"
				} else {
					GXmlDomNodeList* _tmp5_;
					GXmlDomNodeList* _tmp6_;
					GXmlDomNodeList* _tmp7_;
					gint _tmp8_;
					gint _tmp9_;
					gboolean _tmp10_;
#line 90 "../gxml/Range.vala"
					_tmp5_ = gxml_dom_node_get_child_nodes (node);
#line 90 "../gxml/Range.vala"
					_tmp6_ = _tmp5_;
#line 90 "../gxml/Range.vala"
					_tmp7_ = _tmp6_;
#line 90 "../gxml/Range.vala"
					_tmp8_ = gxml_dom_node_list_get_length (_tmp7_);
#line 90 "../gxml/Range.vala"
					_tmp9_ = _tmp8_;
#line 90 "../gxml/Range.vala"
					_tmp10_ = offset > _tmp9_;
#line 90 "../gxml/Range.vala"
					_g_object_unref0 (_tmp7_);
#line 90 "../gxml/Range.vala"
					if (_tmp10_) {
#line 578 "Range.c"
						GError* _tmp11_;
#line 91 "../gxml/Range.vala"
						_tmp11_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_INDEX_SIZE_ERROR, _ ("Invalid offset for node to start: for children number"));
#line 91 "../gxml/Range.vala"
						_inner_error0_ = _tmp11_;
#line 91 "../gxml/Range.vala"
						g_propagate_error (error, _inner_error0_);
#line 91 "../gxml/Range.vala"
						return;
#line 588 "Range.c"
					}
				}
			}
		}
	}
#line 92 "../gxml/Range.vala"
	_tmp12_ = self->_start_container;
#line 92 "../gxml/Range.vala"
	if (_tmp12_ != NULL) {
#line 598 "Range.c"
		GXmlDomNode* _tmp13_;
		GXmlDomNode* _tmp14_;
		GXmlDomNode* _tmp15_;
		GXmlDomNode* _tmp16_;
		GXmlDomNode* _tmp17_;
		GXmlDomNode* _tmp18_;
		GXmlDomNode* _tmp19_;
		gboolean _tmp20_;
#line 93 "../gxml/Range.vala"
		_tmp13_ = gxml_dom_node_get_parent_node (node);
#line 93 "../gxml/Range.vala"
		_tmp14_ = _tmp13_;
#line 93 "../gxml/Range.vala"
		_tmp15_ = _tmp14_;
#line 93 "../gxml/Range.vala"
		_tmp16_ = self->_start_container;
#line 93 "../gxml/Range.vala"
		_tmp17_ = gxml_dom_node_get_parent_node (_tmp16_);
#line 93 "../gxml/Range.vala"
		_tmp18_ = _tmp17_;
#line 93 "../gxml/Range.vala"
		_tmp19_ = _tmp18_;
#line 93 "../gxml/Range.vala"
		_tmp20_ = _tmp15_ != _tmp19_;
#line 93 "../gxml/Range.vala"
		_g_object_unref0 (_tmp19_);
#line 93 "../gxml/Range.vala"
		_g_object_unref0 (_tmp15_);
#line 93 "../gxml/Range.vala"
		if (_tmp20_) {
#line 629 "Range.c"
			GXmlDomNode* _tmp21_;
			GXmlDomNode* _tmp22_;
#line 94 "../gxml/Range.vala"
			_tmp21_ = self->_start_container;
#line 94 "../gxml/Range.vala"
			_tmp22_ = _g_object_ref0 (_tmp21_);
#line 94 "../gxml/Range.vala"
			_g_object_unref0 (self->_end_container);
#line 94 "../gxml/Range.vala"
			self->_end_container = _tmp22_;
#line 95 "../gxml/Range.vala"
			self->_end_offset = self->_start_offset;
#line 642 "Range.c"
		} else {
			gint ni = 0;
			GXmlDomNode* _tmp23_;
			GXmlDomNode* _tmp24_;
			GXmlDomNode* _tmp25_;
			GXmlDomNodeList* _tmp26_;
			GXmlDomNodeList* _tmp27_;
			GXmlDomNodeList* _tmp28_;
			gint _tmp29_;
#line 97 "../gxml/Range.vala"
			_tmp23_ = gxml_dom_node_get_parent_node (node);
#line 97 "../gxml/Range.vala"
			_tmp24_ = _tmp23_;
#line 97 "../gxml/Range.vala"
			_tmp25_ = _tmp24_;
#line 97 "../gxml/Range.vala"
			_tmp26_ = gxml_dom_node_get_child_nodes (_tmp25_);
#line 97 "../gxml/Range.vala"
			_tmp27_ = _tmp26_;
#line 97 "../gxml/Range.vala"
			_tmp28_ = _tmp27_;
#line 97 "../gxml/Range.vala"
			_tmp29_ = gee_list_index_of ((GeeList*) _tmp28_, node);
#line 97 "../gxml/Range.vala"
			_g_object_unref0 (_tmp28_);
#line 97 "../gxml/Range.vala"
			_g_object_unref0 (_tmp25_);
#line 97 "../gxml/Range.vala"
			ni = _tmp29_;
#line 98 "../gxml/Range.vala"
			if (ni > offset) {
#line 674 "Range.c"
				GXmlDomNode* _tmp30_;
#line 99 "../gxml/Range.vala"
				_tmp30_ = _g_object_ref0 (node);
#line 99 "../gxml/Range.vala"
				_g_object_unref0 (self->_start_container);
#line 99 "../gxml/Range.vala"
				self->_start_container = _tmp30_;
#line 682 "Range.c"
			}
		}
	}
#line 102 "../gxml/Range.vala"
	_tmp31_ = _g_object_ref0 (node);
#line 102 "../gxml/Range.vala"
	_g_object_unref0 (self->_end_container);
#line 102 "../gxml/Range.vala"
	self->_end_container = _tmp31_;
#line 103 "../gxml/Range.vala"
	self->_end_offset = offset;
#line 694 "Range.c"
}

static void
gxml_range_real_set_start_before (GXmlDomRange* base,
                                  GXmlDomNode* node,
                                  GError** error)
{
	GXmlRange * self;
	GXmlDomNode* _tmp0_;
	GXmlDomNode* _tmp1_;
	GXmlDomNode* _tmp2_;
	gboolean _tmp3_;
	GXmlDomNode* _tmp5_;
	GXmlDomNode* _tmp6_;
	GXmlDomNode* _tmp7_;
	GXmlDomNode* _tmp8_;
	GXmlDomNode* _tmp9_;
	GXmlDomNode* _tmp10_;
	GXmlDomNodeList* _tmp11_;
	GXmlDomNodeList* _tmp12_;
	GXmlDomNodeList* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 105 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 105 "../gxml/Range.vala"
	g_return_if_fail (node != NULL);
#line 106 "../gxml/Range.vala"
	_tmp0_ = gxml_dom_node_get_parent_node (node);
#line 106 "../gxml/Range.vala"
	_tmp1_ = _tmp0_;
#line 106 "../gxml/Range.vala"
	_tmp2_ = _tmp1_;
#line 106 "../gxml/Range.vala"
	_tmp3_ = _tmp2_ == NULL;
#line 106 "../gxml/Range.vala"
	_g_object_unref0 (_tmp2_);
#line 106 "../gxml/Range.vala"
	if (_tmp3_) {
#line 733 "Range.c"
		GError* _tmp4_;
#line 107 "../gxml/Range.vala"
		_tmp4_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Invalid node type to start before"));
#line 107 "../gxml/Range.vala"
		_inner_error0_ = _tmp4_;
#line 107 "../gxml/Range.vala"
		g_propagate_error (error, _inner_error0_);
#line 107 "../gxml/Range.vala"
		return;
#line 743 "Range.c"
	}
#line 108 "../gxml/Range.vala"
	_tmp5_ = gxml_dom_node_get_parent_node (node);
#line 108 "../gxml/Range.vala"
	_tmp6_ = _tmp5_;
#line 108 "../gxml/Range.vala"
	_tmp7_ = _tmp6_;
#line 108 "../gxml/Range.vala"
	_tmp8_ = gxml_dom_node_get_parent_node (node);
#line 108 "../gxml/Range.vala"
	_tmp9_ = _tmp8_;
#line 108 "../gxml/Range.vala"
	_tmp10_ = _tmp9_;
#line 108 "../gxml/Range.vala"
	_tmp11_ = gxml_dom_node_get_child_nodes (_tmp10_);
#line 108 "../gxml/Range.vala"
	_tmp12_ = _tmp11_;
#line 108 "../gxml/Range.vala"
	_tmp13_ = _tmp12_;
#line 108 "../gxml/Range.vala"
	gxml_dom_range_set_start ((GXmlDomRange*) self, _tmp7_, gee_list_index_of ((GeeList*) _tmp13_, node), &_inner_error0_);
#line 108 "../gxml/Range.vala"
	_g_object_unref0 (_tmp13_);
#line 108 "../gxml/Range.vala"
	_g_object_unref0 (_tmp10_);
#line 108 "../gxml/Range.vala"
	_g_object_unref0 (_tmp7_);
#line 108 "../gxml/Range.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 108 "../gxml/Range.vala"
		g_propagate_error (error, _inner_error0_);
#line 108 "../gxml/Range.vala"
		return;
#line 777 "Range.c"
	}
}

static void
gxml_range_real_set_start_after (GXmlDomRange* base,
                                 GXmlDomNode* node,
                                 GError** error)
{
	GXmlRange * self;
	GXmlDomNode* _tmp0_;
	GXmlDomNode* _tmp1_;
	GXmlDomNode* _tmp2_;
	gboolean _tmp3_;
	gint i = 0;
	GXmlDomNode* _tmp5_;
	GXmlDomNode* _tmp6_;
	GXmlDomNode* _tmp7_;
	GXmlDomNodeList* _tmp8_;
	GXmlDomNodeList* _tmp9_;
	GXmlDomNodeList* _tmp10_;
	gint _tmp11_;
	GXmlDomNode* _tmp12_;
	GXmlDomNode* _tmp13_;
	GXmlDomNode* _tmp14_;
	GXmlDomNodeList* _tmp15_;
	GXmlDomNodeList* _tmp16_;
	GXmlDomNodeList* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gboolean _tmp20_;
	GError* _inner_error0_ = NULL;
#line 110 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 110 "../gxml/Range.vala"
	g_return_if_fail (node != NULL);
#line 111 "../gxml/Range.vala"
	_tmp0_ = gxml_dom_node_get_parent_node (node);
#line 111 "../gxml/Range.vala"
	_tmp1_ = _tmp0_;
#line 111 "../gxml/Range.vala"
	_tmp2_ = _tmp1_;
#line 111 "../gxml/Range.vala"
	_tmp3_ = _tmp2_ == NULL;
#line 111 "../gxml/Range.vala"
	_g_object_unref0 (_tmp2_);
#line 111 "../gxml/Range.vala"
	if (_tmp3_) {
#line 825 "Range.c"
		GError* _tmp4_;
#line 112 "../gxml/Range.vala"
		_tmp4_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Invalid node type to start after"));
#line 112 "../gxml/Range.vala"
		_inner_error0_ = _tmp4_;
#line 112 "../gxml/Range.vala"
		g_propagate_error (error, _inner_error0_);
#line 112 "../gxml/Range.vala"
		return;
#line 835 "Range.c"
	}
#line 113 "../gxml/Range.vala"
	_tmp5_ = gxml_dom_node_get_parent_node (node);
#line 113 "../gxml/Range.vala"
	_tmp6_ = _tmp5_;
#line 113 "../gxml/Range.vala"
	_tmp7_ = _tmp6_;
#line 113 "../gxml/Range.vala"
	_tmp8_ = gxml_dom_node_get_child_nodes (_tmp7_);
#line 113 "../gxml/Range.vala"
	_tmp9_ = _tmp8_;
#line 113 "../gxml/Range.vala"
	_tmp10_ = _tmp9_;
#line 113 "../gxml/Range.vala"
	_tmp11_ = gee_list_index_of ((GeeList*) _tmp10_, node);
#line 113 "../gxml/Range.vala"
	_g_object_unref0 (_tmp10_);
#line 113 "../gxml/Range.vala"
	_g_object_unref0 (_tmp7_);
#line 113 "../gxml/Range.vala"
	i = _tmp11_;
#line 114 "../gxml/Range.vala"
	_tmp12_ = gxml_dom_node_get_parent_node (node);
#line 114 "../gxml/Range.vala"
	_tmp13_ = _tmp12_;
#line 114 "../gxml/Range.vala"
	_tmp14_ = _tmp13_;
#line 114 "../gxml/Range.vala"
	_tmp15_ = gxml_dom_node_get_child_nodes (_tmp14_);
#line 114 "../gxml/Range.vala"
	_tmp16_ = _tmp15_;
#line 114 "../gxml/Range.vala"
	_tmp17_ = _tmp16_;
#line 114 "../gxml/Range.vala"
	_tmp18_ = gee_collection_get_size ((GeeCollection*) _tmp17_);
#line 114 "../gxml/Range.vala"
	_tmp19_ = _tmp18_;
#line 114 "../gxml/Range.vala"
	_tmp20_ = (i + 1) < _tmp19_;
#line 114 "../gxml/Range.vala"
	_g_object_unref0 (_tmp17_);
#line 114 "../gxml/Range.vala"
	_g_object_unref0 (_tmp14_);
#line 114 "../gxml/Range.vala"
	if (_tmp20_) {
#line 881 "Range.c"
		GXmlDomNode* _tmp21_;
		GXmlDomNode* _tmp22_;
		GXmlDomNode* _tmp23_;
		GXmlDomNode* _tmp24_;
		GXmlDomNode* _tmp25_;
		GXmlDomNode* _tmp26_;
		GXmlDomNodeList* _tmp27_;
		GXmlDomNodeList* _tmp28_;
		GXmlDomNodeList* _tmp29_;
#line 115 "../gxml/Range.vala"
		_tmp21_ = gxml_dom_node_get_parent_node (node);
#line 115 "../gxml/Range.vala"
		_tmp22_ = _tmp21_;
#line 115 "../gxml/Range.vala"
		_tmp23_ = _tmp22_;
#line 115 "../gxml/Range.vala"
		_tmp24_ = gxml_dom_node_get_parent_node (node);
#line 115 "../gxml/Range.vala"
		_tmp25_ = _tmp24_;
#line 115 "../gxml/Range.vala"
		_tmp26_ = _tmp25_;
#line 115 "../gxml/Range.vala"
		_tmp27_ = gxml_dom_node_get_child_nodes (_tmp26_);
#line 115 "../gxml/Range.vala"
		_tmp28_ = _tmp27_;
#line 115 "../gxml/Range.vala"
		_tmp29_ = _tmp28_;
#line 115 "../gxml/Range.vala"
		gxml_dom_range_set_start ((GXmlDomRange*) self, _tmp23_, gee_list_index_of ((GeeList*) _tmp29_, node) + 1, &_inner_error0_);
#line 115 "../gxml/Range.vala"
		_g_object_unref0 (_tmp29_);
#line 115 "../gxml/Range.vala"
		_g_object_unref0 (_tmp26_);
#line 115 "../gxml/Range.vala"
		_g_object_unref0 (_tmp23_);
#line 115 "../gxml/Range.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 115 "../gxml/Range.vala"
			g_propagate_error (error, _inner_error0_);
#line 115 "../gxml/Range.vala"
			return;
#line 923 "Range.c"
		}
	} else {
		GXmlDomNode* _tmp30_;
		GXmlDomNode* _tmp31_;
		GXmlDomNode* _tmp32_;
		GXmlDomNode* _tmp33_;
		GXmlDomNode* _tmp34_;
		GXmlDomNode* _tmp35_;
		GXmlDomNodeList* _tmp36_;
		GXmlDomNodeList* _tmp37_;
		GXmlDomNodeList* _tmp38_;
#line 117 "../gxml/Range.vala"
		_tmp30_ = gxml_dom_node_get_parent_node (node);
#line 117 "../gxml/Range.vala"
		_tmp31_ = _tmp30_;
#line 117 "../gxml/Range.vala"
		_tmp32_ = _tmp31_;
#line 117 "../gxml/Range.vala"
		_tmp33_ = gxml_dom_node_get_parent_node (node);
#line 117 "../gxml/Range.vala"
		_tmp34_ = _tmp33_;
#line 117 "../gxml/Range.vala"
		_tmp35_ = _tmp34_;
#line 117 "../gxml/Range.vala"
		_tmp36_ = gxml_dom_node_get_child_nodes (_tmp35_);
#line 117 "../gxml/Range.vala"
		_tmp37_ = _tmp36_;
#line 117 "../gxml/Range.vala"
		_tmp38_ = _tmp37_;
#line 117 "../gxml/Range.vala"
		gxml_dom_range_set_start ((GXmlDomRange*) self, _tmp32_, gee_list_index_of ((GeeList*) _tmp38_, node), &_inner_error0_);
#line 117 "../gxml/Range.vala"
		_g_object_unref0 (_tmp38_);
#line 117 "../gxml/Range.vala"
		_g_object_unref0 (_tmp35_);
#line 117 "../gxml/Range.vala"
		_g_object_unref0 (_tmp32_);
#line 117 "../gxml/Range.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 117 "../gxml/Range.vala"
			g_propagate_error (error, _inner_error0_);
#line 117 "../gxml/Range.vala"
			return;
#line 967 "Range.c"
		}
	}
}

static void
gxml_range_real_set_end_before (GXmlDomRange* base,
                                GXmlDomNode* node,
                                GError** error)
{
	GXmlRange * self;
	GXmlDomNode* _tmp0_;
	GXmlDomNode* _tmp1_;
	GXmlDomNode* _tmp2_;
	gboolean _tmp3_;
	GXmlDomNode* _tmp5_;
	GXmlDomNode* _tmp6_;
	GXmlDomNode* _tmp7_;
	GXmlDomNode* _tmp8_;
	GXmlDomNode* _tmp9_;
	GXmlDomNode* _tmp10_;
	GXmlDomNodeList* _tmp11_;
	GXmlDomNodeList* _tmp12_;
	GXmlDomNodeList* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 119 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 119 "../gxml/Range.vala"
	g_return_if_fail (node != NULL);
#line 120 "../gxml/Range.vala"
	_tmp0_ = gxml_dom_node_get_parent_node (node);
#line 120 "../gxml/Range.vala"
	_tmp1_ = _tmp0_;
#line 120 "../gxml/Range.vala"
	_tmp2_ = _tmp1_;
#line 120 "../gxml/Range.vala"
	_tmp3_ = _tmp2_ == NULL;
#line 120 "../gxml/Range.vala"
	_g_object_unref0 (_tmp2_);
#line 120 "../gxml/Range.vala"
	if (_tmp3_) {
#line 1008 "Range.c"
		GError* _tmp4_;
#line 121 "../gxml/Range.vala"
		_tmp4_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Invalid node type to start before"));
#line 121 "../gxml/Range.vala"
		_inner_error0_ = _tmp4_;
#line 121 "../gxml/Range.vala"
		g_propagate_error (error, _inner_error0_);
#line 121 "../gxml/Range.vala"
		return;
#line 1018 "Range.c"
	}
#line 122 "../gxml/Range.vala"
	_tmp5_ = gxml_dom_node_get_parent_node (node);
#line 122 "../gxml/Range.vala"
	_tmp6_ = _tmp5_;
#line 122 "../gxml/Range.vala"
	_tmp7_ = _tmp6_;
#line 122 "../gxml/Range.vala"
	_tmp8_ = gxml_dom_node_get_parent_node (node);
#line 122 "../gxml/Range.vala"
	_tmp9_ = _tmp8_;
#line 122 "../gxml/Range.vala"
	_tmp10_ = _tmp9_;
#line 122 "../gxml/Range.vala"
	_tmp11_ = gxml_dom_node_get_child_nodes (_tmp10_);
#line 122 "../gxml/Range.vala"
	_tmp12_ = _tmp11_;
#line 122 "../gxml/Range.vala"
	_tmp13_ = _tmp12_;
#line 122 "../gxml/Range.vala"
	gxml_dom_range_set_end ((GXmlDomRange*) self, _tmp7_, gee_list_index_of ((GeeList*) _tmp13_, node), &_inner_error0_);
#line 122 "../gxml/Range.vala"
	_g_object_unref0 (_tmp13_);
#line 122 "../gxml/Range.vala"
	_g_object_unref0 (_tmp10_);
#line 122 "../gxml/Range.vala"
	_g_object_unref0 (_tmp7_);
#line 122 "../gxml/Range.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 122 "../gxml/Range.vala"
		g_propagate_error (error, _inner_error0_);
#line 122 "../gxml/Range.vala"
		return;
#line 1052 "Range.c"
	}
}

static void
gxml_range_real_set_end_after (GXmlDomRange* base,
                               GXmlDomNode* node,
                               GError** error)
{
	GXmlRange * self;
	GXmlDomNode* _tmp0_;
	GXmlDomNode* _tmp1_;
	GXmlDomNode* _tmp2_;
	gboolean _tmp3_;
	gint i = 0;
	GXmlDomNode* _tmp5_;
	GXmlDomNode* _tmp6_;
	GXmlDomNode* _tmp7_;
	GXmlDomNodeList* _tmp8_;
	GXmlDomNodeList* _tmp9_;
	GXmlDomNodeList* _tmp10_;
	gint _tmp11_;
	GXmlDomNode* _tmp12_;
	GXmlDomNode* _tmp13_;
	GXmlDomNode* _tmp14_;
	GXmlDomNodeList* _tmp15_;
	GXmlDomNodeList* _tmp16_;
	GXmlDomNodeList* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gboolean _tmp20_;
	GError* _inner_error0_ = NULL;
#line 124 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 124 "../gxml/Range.vala"
	g_return_if_fail (node != NULL);
#line 125 "../gxml/Range.vala"
	_tmp0_ = gxml_dom_node_get_parent_node (node);
#line 125 "../gxml/Range.vala"
	_tmp1_ = _tmp0_;
#line 125 "../gxml/Range.vala"
	_tmp2_ = _tmp1_;
#line 125 "../gxml/Range.vala"
	_tmp3_ = _tmp2_ == NULL;
#line 125 "../gxml/Range.vala"
	_g_object_unref0 (_tmp2_);
#line 125 "../gxml/Range.vala"
	if (_tmp3_) {
#line 1100 "Range.c"
		GError* _tmp4_;
#line 126 "../gxml/Range.vala"
		_tmp4_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Invalid node type to start after"));
#line 126 "../gxml/Range.vala"
		_inner_error0_ = _tmp4_;
#line 126 "../gxml/Range.vala"
		g_propagate_error (error, _inner_error0_);
#line 126 "../gxml/Range.vala"
		return;
#line 1110 "Range.c"
	}
#line 127 "../gxml/Range.vala"
	_tmp5_ = gxml_dom_node_get_parent_node (node);
#line 127 "../gxml/Range.vala"
	_tmp6_ = _tmp5_;
#line 127 "../gxml/Range.vala"
	_tmp7_ = _tmp6_;
#line 127 "../gxml/Range.vala"
	_tmp8_ = gxml_dom_node_get_child_nodes (_tmp7_);
#line 127 "../gxml/Range.vala"
	_tmp9_ = _tmp8_;
#line 127 "../gxml/Range.vala"
	_tmp10_ = _tmp9_;
#line 127 "../gxml/Range.vala"
	_tmp11_ = gee_list_index_of ((GeeList*) _tmp10_, node);
#line 127 "../gxml/Range.vala"
	_g_object_unref0 (_tmp10_);
#line 127 "../gxml/Range.vala"
	_g_object_unref0 (_tmp7_);
#line 127 "../gxml/Range.vala"
	i = _tmp11_;
#line 128 "../gxml/Range.vala"
	_tmp12_ = gxml_dom_node_get_parent_node (node);
#line 128 "../gxml/Range.vala"
	_tmp13_ = _tmp12_;
#line 128 "../gxml/Range.vala"
	_tmp14_ = _tmp13_;
#line 128 "../gxml/Range.vala"
	_tmp15_ = gxml_dom_node_get_child_nodes (_tmp14_);
#line 128 "../gxml/Range.vala"
	_tmp16_ = _tmp15_;
#line 128 "../gxml/Range.vala"
	_tmp17_ = _tmp16_;
#line 128 "../gxml/Range.vala"
	_tmp18_ = gee_collection_get_size ((GeeCollection*) _tmp17_);
#line 128 "../gxml/Range.vala"
	_tmp19_ = _tmp18_;
#line 128 "../gxml/Range.vala"
	_tmp20_ = (i + 1) < _tmp19_;
#line 128 "../gxml/Range.vala"
	_g_object_unref0 (_tmp17_);
#line 128 "../gxml/Range.vala"
	_g_object_unref0 (_tmp14_);
#line 128 "../gxml/Range.vala"
	if (_tmp20_) {
#line 1156 "Range.c"
		GXmlDomNode* _tmp21_;
		GXmlDomNode* _tmp22_;
		GXmlDomNode* _tmp23_;
		GXmlDomNode* _tmp24_;
		GXmlDomNode* _tmp25_;
		GXmlDomNode* _tmp26_;
		GXmlDomNodeList* _tmp27_;
		GXmlDomNodeList* _tmp28_;
		GXmlDomNodeList* _tmp29_;
#line 129 "../gxml/Range.vala"
		_tmp21_ = gxml_dom_node_get_parent_node (node);
#line 129 "../gxml/Range.vala"
		_tmp22_ = _tmp21_;
#line 129 "../gxml/Range.vala"
		_tmp23_ = _tmp22_;
#line 129 "../gxml/Range.vala"
		_tmp24_ = gxml_dom_node_get_parent_node (node);
#line 129 "../gxml/Range.vala"
		_tmp25_ = _tmp24_;
#line 129 "../gxml/Range.vala"
		_tmp26_ = _tmp25_;
#line 129 "../gxml/Range.vala"
		_tmp27_ = gxml_dom_node_get_child_nodes (_tmp26_);
#line 129 "../gxml/Range.vala"
		_tmp28_ = _tmp27_;
#line 129 "../gxml/Range.vala"
		_tmp29_ = _tmp28_;
#line 129 "../gxml/Range.vala"
		gxml_dom_range_set_end ((GXmlDomRange*) self, _tmp23_, gee_list_index_of ((GeeList*) _tmp29_, node) + 1, &_inner_error0_);
#line 129 "../gxml/Range.vala"
		_g_object_unref0 (_tmp29_);
#line 129 "../gxml/Range.vala"
		_g_object_unref0 (_tmp26_);
#line 129 "../gxml/Range.vala"
		_g_object_unref0 (_tmp23_);
#line 129 "../gxml/Range.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 129 "../gxml/Range.vala"
			g_propagate_error (error, _inner_error0_);
#line 129 "../gxml/Range.vala"
			return;
#line 1198 "Range.c"
		}
	} else {
		GXmlDomNode* _tmp30_;
		GXmlDomNode* _tmp31_;
		GXmlDomNode* _tmp32_;
		GXmlDomNode* _tmp33_;
		GXmlDomNode* _tmp34_;
		GXmlDomNode* _tmp35_;
		GXmlDomNodeList* _tmp36_;
		GXmlDomNodeList* _tmp37_;
		GXmlDomNodeList* _tmp38_;
#line 131 "../gxml/Range.vala"
		_tmp30_ = gxml_dom_node_get_parent_node (node);
#line 131 "../gxml/Range.vala"
		_tmp31_ = _tmp30_;
#line 131 "../gxml/Range.vala"
		_tmp32_ = _tmp31_;
#line 131 "../gxml/Range.vala"
		_tmp33_ = gxml_dom_node_get_parent_node (node);
#line 131 "../gxml/Range.vala"
		_tmp34_ = _tmp33_;
#line 131 "../gxml/Range.vala"
		_tmp35_ = _tmp34_;
#line 131 "../gxml/Range.vala"
		_tmp36_ = gxml_dom_node_get_child_nodes (_tmp35_);
#line 131 "../gxml/Range.vala"
		_tmp37_ = _tmp36_;
#line 131 "../gxml/Range.vala"
		_tmp38_ = _tmp37_;
#line 131 "../gxml/Range.vala"
		gxml_dom_range_set_end ((GXmlDomRange*) self, _tmp32_, gee_list_index_of ((GeeList*) _tmp38_, node), &_inner_error0_);
#line 131 "../gxml/Range.vala"
		_g_object_unref0 (_tmp38_);
#line 131 "../gxml/Range.vala"
		_g_object_unref0 (_tmp35_);
#line 131 "../gxml/Range.vala"
		_g_object_unref0 (_tmp32_);
#line 131 "../gxml/Range.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 131 "../gxml/Range.vala"
			g_propagate_error (error, _inner_error0_);
#line 131 "../gxml/Range.vala"
			return;
#line 1242 "Range.c"
		}
	}
}

static void
gxml_range_real_collapse (GXmlDomRange* base,
                          gboolean to_start,
                          GError** error)
{
	GXmlRange * self;
#line 133 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 134 "../gxml/Range.vala"
	if (to_start) {
#line 1257 "Range.c"
		GXmlDomNode* _tmp0_;
		GXmlDomNode* _tmp1_;
#line 135 "../gxml/Range.vala"
		_tmp0_ = self->_start_container;
#line 135 "../gxml/Range.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 135 "../gxml/Range.vala"
		_g_object_unref0 (self->_end_container);
#line 135 "../gxml/Range.vala"
		self->_end_container = _tmp1_;
#line 136 "../gxml/Range.vala"
		self->_end_offset = self->_start_offset;
#line 1270 "Range.c"
	} else {
		GXmlDomNode* _tmp2_;
		GXmlDomNode* _tmp3_;
#line 138 "../gxml/Range.vala"
		_tmp2_ = self->_end_container;
#line 138 "../gxml/Range.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 138 "../gxml/Range.vala"
		_g_object_unref0 (self->_start_container);
#line 138 "../gxml/Range.vala"
		self->_start_container = _tmp3_;
#line 139 "../gxml/Range.vala"
		self->_start_offset = self->_end_offset;
#line 1284 "Range.c"
	}
}

static void
gxml_range_real_select_node (GXmlDomRange* base,
                             GXmlDomNode* node,
                             GError** error)
{
	GXmlRange * self;
	GXmlDomNode* _tmp0_;
	GXmlDomNode* _tmp1_;
	GXmlDomNode* _tmp2_;
	gboolean _tmp3_;
	gint i = 0;
	GXmlDomNode* _tmp5_;
	GXmlDomNode* _tmp6_;
	GXmlDomNode* _tmp7_;
	GXmlDomNodeList* _tmp8_;
	GXmlDomNodeList* _tmp9_;
	GXmlDomNodeList* _tmp10_;
	gint _tmp11_;
	GXmlDomNode* _tmp12_;
	GXmlDomNode* _tmp13_;
	GXmlDomNode* _tmp14_;
	GXmlDomNode* _tmp15_;
	GXmlDomNode* _tmp16_;
	GXmlDomNode* _tmp17_;
	GXmlDomNodeList* _tmp18_;
	GXmlDomNodeList* _tmp19_;
	GXmlDomNodeList* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	gboolean _tmp23_;
	GError* _inner_error0_ = NULL;
#line 142 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 142 "../gxml/Range.vala"
	g_return_if_fail (node != NULL);
#line 143 "../gxml/Range.vala"
	_tmp0_ = gxml_dom_node_get_parent_node (node);
#line 143 "../gxml/Range.vala"
	_tmp1_ = _tmp0_;
#line 143 "../gxml/Range.vala"
	_tmp2_ = _tmp1_;
#line 143 "../gxml/Range.vala"
	_tmp3_ = _tmp2_ == NULL;
#line 143 "../gxml/Range.vala"
	_g_object_unref0 (_tmp2_);
#line 143 "../gxml/Range.vala"
	if (_tmp3_) {
#line 1335 "Range.c"
		GError* _tmp4_;
#line 144 "../gxml/Range.vala"
		_tmp4_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Invalid node type to start after"));
#line 144 "../gxml/Range.vala"
		_inner_error0_ = _tmp4_;
#line 144 "../gxml/Range.vala"
		g_propagate_error (error, _inner_error0_);
#line 144 "../gxml/Range.vala"
		return;
#line 1345 "Range.c"
	}
#line 145 "../gxml/Range.vala"
	_tmp5_ = gxml_dom_node_get_parent_node (node);
#line 145 "../gxml/Range.vala"
	_tmp6_ = _tmp5_;
#line 145 "../gxml/Range.vala"
	_tmp7_ = _tmp6_;
#line 145 "../gxml/Range.vala"
	_tmp8_ = gxml_dom_node_get_child_nodes (_tmp7_);
#line 145 "../gxml/Range.vala"
	_tmp9_ = _tmp8_;
#line 145 "../gxml/Range.vala"
	_tmp10_ = _tmp9_;
#line 145 "../gxml/Range.vala"
	_tmp11_ = gee_list_index_of ((GeeList*) _tmp10_, node);
#line 145 "../gxml/Range.vala"
	_g_object_unref0 (_tmp10_);
#line 145 "../gxml/Range.vala"
	_g_object_unref0 (_tmp7_);
#line 145 "../gxml/Range.vala"
	i = _tmp11_;
#line 146 "../gxml/Range.vala"
	_tmp12_ = gxml_dom_node_get_parent_node (node);
#line 146 "../gxml/Range.vala"
	_tmp13_ = _tmp12_;
#line 146 "../gxml/Range.vala"
	_tmp14_ = _tmp13_;
#line 146 "../gxml/Range.vala"
	gxml_dom_range_set_start ((GXmlDomRange*) self, _tmp14_, i, &_inner_error0_);
#line 146 "../gxml/Range.vala"
	_g_object_unref0 (_tmp14_);
#line 146 "../gxml/Range.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 146 "../gxml/Range.vala"
		g_propagate_error (error, _inner_error0_);
#line 146 "../gxml/Range.vala"
		return;
#line 1383 "Range.c"
	}
#line 147 "../gxml/Range.vala"
	_tmp15_ = gxml_dom_node_get_parent_node (node);
#line 147 "../gxml/Range.vala"
	_tmp16_ = _tmp15_;
#line 147 "../gxml/Range.vala"
	_tmp17_ = _tmp16_;
#line 147 "../gxml/Range.vala"
	_tmp18_ = gxml_dom_node_get_child_nodes (_tmp17_);
#line 147 "../gxml/Range.vala"
	_tmp19_ = _tmp18_;
#line 147 "../gxml/Range.vala"
	_tmp20_ = _tmp19_;
#line 147 "../gxml/Range.vala"
	_tmp21_ = gee_collection_get_size ((GeeCollection*) _tmp20_);
#line 147 "../gxml/Range.vala"
	_tmp22_ = _tmp21_;
#line 147 "../gxml/Range.vala"
	_tmp23_ = (i + 1) < _tmp22_;
#line 147 "../gxml/Range.vala"
	_g_object_unref0 (_tmp20_);
#line 147 "../gxml/Range.vala"
	_g_object_unref0 (_tmp17_);
#line 147 "../gxml/Range.vala"
	if (_tmp23_) {
#line 1409 "Range.c"
		GXmlDomNode* _tmp24_;
		GXmlDomNode* _tmp25_;
		GXmlDomNode* _tmp26_;
#line 148 "../gxml/Range.vala"
		_tmp24_ = gxml_dom_node_get_parent_node (node);
#line 148 "../gxml/Range.vala"
		_tmp25_ = _tmp24_;
#line 148 "../gxml/Range.vala"
		_tmp26_ = _tmp25_;
#line 148 "../gxml/Range.vala"
		gxml_dom_range_set_end ((GXmlDomRange*) self, _tmp26_, i + 1, &_inner_error0_);
#line 148 "../gxml/Range.vala"
		_g_object_unref0 (_tmp26_);
#line 148 "../gxml/Range.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 148 "../gxml/Range.vala"
			g_propagate_error (error, _inner_error0_);
#line 148 "../gxml/Range.vala"
			return;
#line 1429 "Range.c"
		}
	} else {
		GXmlDomNode* _tmp27_;
		GXmlDomNode* _tmp28_;
		GXmlDomNode* _tmp29_;
#line 150 "../gxml/Range.vala"
		_tmp27_ = gxml_dom_node_get_parent_node (node);
#line 150 "../gxml/Range.vala"
		_tmp28_ = _tmp27_;
#line 150 "../gxml/Range.vala"
		_tmp29_ = _tmp28_;
#line 150 "../gxml/Range.vala"
		gxml_dom_range_set_end ((GXmlDomRange*) self, _tmp29_, i, &_inner_error0_);
#line 150 "../gxml/Range.vala"
		_g_object_unref0 (_tmp29_);
#line 150 "../gxml/Range.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 150 "../gxml/Range.vala"
			g_propagate_error (error, _inner_error0_);
#line 150 "../gxml/Range.vala"
			return;
#line 1451 "Range.c"
		}
	}
}

static void
gxml_range_real_select_node_contents (GXmlDomRange* base,
                                      GXmlDomNode* node,
                                      GError** error)
{
	GXmlRange * self;
	gint length = 0;
	GError* _inner_error0_ = NULL;
#line 152 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 152 "../gxml/Range.vala"
	g_return_if_fail (node != NULL);
#line 153 "../gxml/Range.vala"
	if (GXML_IS_DOM_DOCUMENT_TYPE (node)) {
#line 1470 "Range.c"
		GError* _tmp0_;
#line 154 "../gxml/Range.vala"
		_tmp0_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Invalid node type to start"));
#line 154 "../gxml/Range.vala"
		_inner_error0_ = _tmp0_;
#line 154 "../gxml/Range.vala"
		g_propagate_error (error, _inner_error0_);
#line 154 "../gxml/Range.vala"
		return;
#line 1480 "Range.c"
	}
#line 155 "../gxml/Range.vala"
	gxml_dom_range_set_start ((GXmlDomRange*) self, node, 0, &_inner_error0_);
#line 155 "../gxml/Range.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 155 "../gxml/Range.vala"
		g_propagate_error (error, _inner_error0_);
#line 155 "../gxml/Range.vala"
		return;
#line 1490 "Range.c"
	}
#line 156 "../gxml/Range.vala"
	length = 0;
#line 157 "../gxml/Range.vala"
	if (GXML_IS_DOM_DOCUMENT_TYPE (node)) {
#line 157 "../gxml/Range.vala"
		length = 0;
#line 1498 "Range.c"
	} else {
#line 159 "../gxml/Range.vala"
		if (GXML_IS_DOM_CHARACTER_DATA (node)) {
#line 1502 "Range.c"
			gint _tmp1_;
			gint _tmp2_;
#line 159 "../gxml/Range.vala"
			_tmp1_ = gxml_dom_character_data_get_length (G_TYPE_CHECK_INSTANCE_CAST (node, GXML_TYPE_DOM_CHARACTER_DATA, GXmlDomCharacterData));
#line 159 "../gxml/Range.vala"
			_tmp2_ = _tmp1_;
#line 159 "../gxml/Range.vala"
			length = _tmp2_;
#line 1511 "Range.c"
		} else {
			GXmlDomNodeList* _tmp3_;
			GXmlDomNodeList* _tmp4_;
			GXmlDomNodeList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
#line 161 "../gxml/Range.vala"
			_tmp3_ = gxml_dom_node_get_child_nodes (node);
#line 161 "../gxml/Range.vala"
			_tmp4_ = _tmp3_;
#line 161 "../gxml/Range.vala"
			_tmp5_ = _tmp4_;
#line 161 "../gxml/Range.vala"
			_tmp6_ = gxml_dom_node_list_get_length (_tmp5_);
#line 161 "../gxml/Range.vala"
			_tmp7_ = _tmp6_;
#line 161 "../gxml/Range.vala"
			length = _tmp7_;
#line 161 "../gxml/Range.vala"
			_g_object_unref0 (_tmp5_);
#line 1532 "Range.c"
		}
	}
#line 162 "../gxml/Range.vala"
	gxml_dom_range_set_end ((GXmlDomRange*) self, node, length, &_inner_error0_);
#line 162 "../gxml/Range.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 162 "../gxml/Range.vala"
		g_propagate_error (error, _inner_error0_);
#line 162 "../gxml/Range.vala"
		return;
#line 1543 "Range.c"
	}
}

static gint
gxml_range_real_compare_boundary_points (GXmlDomRange* base,
                                         GXmlDomRangeBoundaryPoints how,
                                         GXmlDomRange* source_range,
                                         GError** error)
{
	GXmlRange * self;
	GXmlDomNode* _tmp0_;
	GXmlDomNode* _tmp1_;
	GXmlDomNode* _tmp2_;
	GXmlDomNode* _tmp3_;
	GXmlDomNode* _tmp4_;
	GXmlDomNode* _tmp5_;
	GXmlDomNode* _tmp6_;
	GXmlDomNode* _tmp7_;
	GXmlDomNode* _tmp8_;
	gboolean _tmp9_;
	GError* _inner_error0_ = NULL;
	gint result = 0;
#line 165 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 165 "../gxml/Range.vala"
	g_return_val_if_fail (source_range != NULL, 0);
#line 168 "../gxml/Range.vala"
	_tmp0_ = self->_start_container;
#line 168 "../gxml/Range.vala"
	_tmp1_ = gxml_dom_node_get_parent_node (_tmp0_);
#line 168 "../gxml/Range.vala"
	_tmp2_ = _tmp1_;
#line 168 "../gxml/Range.vala"
	_tmp3_ = _tmp2_;
#line 168 "../gxml/Range.vala"
	_tmp4_ = gxml_dom_range_get_start_container (source_range);
#line 168 "../gxml/Range.vala"
	_tmp5_ = _tmp4_;
#line 168 "../gxml/Range.vala"
	_tmp6_ = gxml_dom_node_get_parent_node (_tmp5_);
#line 168 "../gxml/Range.vala"
	_tmp7_ = _tmp6_;
#line 168 "../gxml/Range.vala"
	_tmp8_ = _tmp7_;
#line 168 "../gxml/Range.vala"
	_tmp9_ = _tmp3_ != _tmp8_;
#line 168 "../gxml/Range.vala"
	_g_object_unref0 (_tmp8_);
#line 168 "../gxml/Range.vala"
	_g_object_unref0 (_tmp3_);
#line 168 "../gxml/Range.vala"
	if (_tmp9_) {
#line 1596 "Range.c"
		GError* _tmp10_;
		gint _tmp11_ = -1;
#line 169 "../gxml/Range.vala"
		_tmp10_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_WRONG_DOCUMENT_ERROR, _ ("Invalid root in the source range"));
#line 169 "../gxml/Range.vala"
		_inner_error0_ = _tmp10_;
#line 169 "../gxml/Range.vala"
		g_propagate_error (error, _inner_error0_);
#line 169 "../gxml/Range.vala"
		return _tmp11_;
#line 1607 "Range.c"
	}
#line 170 "../gxml/Range.vala"
	switch (how) {
#line 170 "../gxml/Range.vala"
		case GXML_DOM_RANGE_BOUNDARY_POINTS_START_TO_START:
#line 1613 "Range.c"
		{
			GXmlDomNode* _tmp12_;
			GXmlDomNode* _tmp14_;
			GXmlDomNode* _tmp15_;
#line 172 "../gxml/Range.vala"
			_tmp12_ = self->_start_container;
#line 172 "../gxml/Range.vala"
			gxml_dom_range_set_start ((GXmlDomRange*) self, _tmp12_, 0, &_inner_error0_);
#line 172 "../gxml/Range.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1624 "Range.c"
				gint _tmp13_ = -1;
#line 172 "../gxml/Range.vala"
				g_propagate_error (error, _inner_error0_);
#line 172 "../gxml/Range.vala"
				return _tmp13_;
#line 1630 "Range.c"
			}
#line 173 "../gxml/Range.vala"
			_tmp14_ = gxml_dom_range_get_start_container (source_range);
#line 173 "../gxml/Range.vala"
			_tmp15_ = _tmp14_;
#line 173 "../gxml/Range.vala"
			gxml_dom_range_set_end ((GXmlDomRange*) self, _tmp15_, 0, &_inner_error0_);
#line 173 "../gxml/Range.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1640 "Range.c"
				gint _tmp16_ = -1;
#line 173 "../gxml/Range.vala"
				g_propagate_error (error, _inner_error0_);
#line 173 "../gxml/Range.vala"
				return _tmp16_;
#line 1646 "Range.c"
			}
#line 174 "../gxml/Range.vala"
			result = 0;
#line 174 "../gxml/Range.vala"
			return result;
#line 1652 "Range.c"
		}
#line 170 "../gxml/Range.vala"
		case GXML_DOM_RANGE_BOUNDARY_POINTS_START_TO_END:
#line 1656 "Range.c"
		{
			GXmlDomNode* _tmp17_;
			GXmlDomNode* _tmp18_;
			GXmlDomNodeList* _tmp19_;
			GXmlDomNodeList* _tmp20_;
			GXmlDomNodeList* _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
			GXmlDomNode* _tmp25_;
			GXmlDomNode* _tmp26_;
#line 176 "../gxml/Range.vala"
			_tmp17_ = self->_start_container;
#line 176 "../gxml/Range.vala"
			_tmp18_ = self->_start_container;
#line 176 "../gxml/Range.vala"
			_tmp19_ = gxml_dom_node_get_child_nodes (_tmp18_);
#line 176 "../gxml/Range.vala"
			_tmp20_ = _tmp19_;
#line 176 "../gxml/Range.vala"
			_tmp21_ = _tmp20_;
#line 176 "../gxml/Range.vala"
			_tmp22_ = gee_collection_get_size ((GeeCollection*) _tmp21_);
#line 176 "../gxml/Range.vala"
			_tmp23_ = _tmp22_;
#line 176 "../gxml/Range.vala"
			gxml_dom_range_set_start ((GXmlDomRange*) self, _tmp17_, _tmp23_, &_inner_error0_);
#line 176 "../gxml/Range.vala"
			_g_object_unref0 (_tmp21_);
#line 176 "../gxml/Range.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1687 "Range.c"
				gint _tmp24_ = -1;
#line 176 "../gxml/Range.vala"
				g_propagate_error (error, _inner_error0_);
#line 176 "../gxml/Range.vala"
				return _tmp24_;
#line 1693 "Range.c"
			}
#line 177 "../gxml/Range.vala"
			_tmp25_ = gxml_dom_range_get_end_container (source_range);
#line 177 "../gxml/Range.vala"
			_tmp26_ = _tmp25_;
#line 177 "../gxml/Range.vala"
			gxml_dom_range_set_end ((GXmlDomRange*) self, _tmp26_, 0, &_inner_error0_);
#line 177 "../gxml/Range.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1703 "Range.c"
				gint _tmp27_ = -1;
#line 177 "../gxml/Range.vala"
				g_propagate_error (error, _inner_error0_);
#line 177 "../gxml/Range.vala"
				return _tmp27_;
#line 1709 "Range.c"
			}
#line 178 "../gxml/Range.vala"
			result = -1;
#line 178 "../gxml/Range.vala"
			return result;
#line 1715 "Range.c"
		}
#line 170 "../gxml/Range.vala"
		case GXML_DOM_RANGE_BOUNDARY_POINTS_END_TO_END:
#line 1719 "Range.c"
		{
			GXmlDomNode* _tmp28_;
			GXmlDomNode* _tmp30_;
			GXmlDomNode* _tmp31_;
#line 180 "../gxml/Range.vala"
			_tmp28_ = self->_end_container;
#line 180 "../gxml/Range.vala"
			gxml_dom_range_set_start ((GXmlDomRange*) self, _tmp28_, 0, &_inner_error0_);
#line 180 "../gxml/Range.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1730 "Range.c"
				gint _tmp29_ = -1;
#line 180 "../gxml/Range.vala"
				g_propagate_error (error, _inner_error0_);
#line 180 "../gxml/Range.vala"
				return _tmp29_;
#line 1736 "Range.c"
			}
#line 181 "../gxml/Range.vala"
			_tmp30_ = gxml_dom_range_get_end_container (source_range);
#line 181 "../gxml/Range.vala"
			_tmp31_ = _tmp30_;
#line 181 "../gxml/Range.vala"
			gxml_dom_range_set_end ((GXmlDomRange*) self, _tmp31_, 0, &_inner_error0_);
#line 181 "../gxml/Range.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1746 "Range.c"
				gint _tmp32_ = -1;
#line 181 "../gxml/Range.vala"
				g_propagate_error (error, _inner_error0_);
#line 181 "../gxml/Range.vala"
				return _tmp32_;
#line 1752 "Range.c"
			}
#line 182 "../gxml/Range.vala"
			result = 0;
#line 182 "../gxml/Range.vala"
			return result;
#line 1758 "Range.c"
		}
#line 170 "../gxml/Range.vala"
		case GXML_DOM_RANGE_BOUNDARY_POINTS_END_TO_START:
#line 1762 "Range.c"
		{
			GXmlDomNode* _tmp33_;
			GXmlDomNode* _tmp35_;
			GXmlDomNode* _tmp36_;
#line 184 "../gxml/Range.vala"
			_tmp33_ = self->_start_container;
#line 184 "../gxml/Range.vala"
			gxml_dom_range_set_start ((GXmlDomRange*) self, _tmp33_, 0, &_inner_error0_);
#line 184 "../gxml/Range.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1773 "Range.c"
				gint _tmp34_ = -1;
#line 184 "../gxml/Range.vala"
				g_propagate_error (error, _inner_error0_);
#line 184 "../gxml/Range.vala"
				return _tmp34_;
#line 1779 "Range.c"
			}
#line 185 "../gxml/Range.vala"
			_tmp35_ = gxml_dom_range_get_end_container (source_range);
#line 185 "../gxml/Range.vala"
			_tmp36_ = _tmp35_;
#line 185 "../gxml/Range.vala"
			gxml_dom_range_set_end ((GXmlDomRange*) self, _tmp36_, 0, &_inner_error0_);
#line 185 "../gxml/Range.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1789 "Range.c"
				gint _tmp37_ = -1;
#line 185 "../gxml/Range.vala"
				g_propagate_error (error, _inner_error0_);
#line 185 "../gxml/Range.vala"
				return _tmp37_;
#line 1795 "Range.c"
			}
#line 186 "../gxml/Range.vala"
			result = 1;
#line 186 "../gxml/Range.vala"
			return result;
#line 1801 "Range.c"
		}
		default:
#line 170 "../gxml/Range.vala"
		break;
#line 1806 "Range.c"
	}
#line 188 "../gxml/Range.vala"
	result = 0;
#line 188 "../gxml/Range.vala"
	return result;
#line 1812 "Range.c"
}

static void
gxml_range_real_delete_contents (GXmlDomRange* base,
                                 GError** error)
{
	GXmlRange * self;
#line 191 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 191 "../gxml/Range.vala"
	return;
#line 1824 "Range.c"
}

static GXmlDomDocumentFragment*
gxml_range_real_extract_contents (GXmlDomRange* base,
                                  GError** error)
{
	GXmlRange * self;
	GXmlDomDocumentFragment* result = NULL;
#line 192 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 192 "../gxml/Range.vala"
	result = NULL;
#line 192 "../gxml/Range.vala"
	return result;
#line 1839 "Range.c"
}

static GXmlDomDocumentFragment*
gxml_range_real_clone_contents (GXmlDomRange* base,
                                GError** error)
{
	GXmlRange * self;
	GXmlDomDocumentFragment* result = NULL;
#line 193 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 193 "../gxml/Range.vala"
	result = NULL;
#line 193 "../gxml/Range.vala"
	return result;
#line 1854 "Range.c"
}

static void
gxml_range_real_insert_node (GXmlDomRange* base,
                             GXmlDomNode* node)
{
	GXmlRange * self;
#line 194 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 194 "../gxml/Range.vala"
	g_return_if_fail (node != NULL);
#line 194 "../gxml/Range.vala"
	return;
#line 1868 "Range.c"
}

static void
gxml_range_real_surround_contents (GXmlDomRange* base,
                                   GXmlDomNode* newParent)
{
	GXmlRange * self;
#line 195 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 195 "../gxml/Range.vala"
	g_return_if_fail (newParent != NULL);
#line 195 "../gxml/Range.vala"
	return;
#line 1882 "Range.c"
}

static GXmlDomRange*
gxml_range_real_clone_range (GXmlDomRange* base)
{
	GXmlRange * self;
	GObject* _tmp0_;
	GXmlDomRange* _tmp1_;
	GXmlDomRange* result = NULL;
#line 197 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 197 "../gxml/Range.vala"
	_tmp0_ = g_object_ref ((GObject*) self);
#line 197 "../gxml/Range.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GXML_TYPE_DOM_RANGE, GXmlDomRange));
#line 197 "../gxml/Range.vala"
	result = _tmp1_;
#line 197 "../gxml/Range.vala"
	return result;
#line 1902 "Range.c"
}

static void
gxml_range_real_detach (GXmlDomRange* base)
{
	GXmlRange * self;
#line 198 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 198 "../gxml/Range.vala"
	return;
#line 1913 "Range.c"
}

static gboolean
gxml_range_real_is_point_in_range (GXmlDomRange* base,
                                   GXmlDomNode* node,
                                   gint offset)
{
	GXmlRange * self;
	gboolean result = FALSE;
#line 200 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 200 "../gxml/Range.vala"
	g_return_val_if_fail (node != NULL, FALSE);
#line 200 "../gxml/Range.vala"
	result = FALSE;
#line 200 "../gxml/Range.vala"
	return result;
#line 1931 "Range.c"
}

static gshort
gxml_range_real_compare_point (GXmlDomRange* base,
                               GXmlDomNode* node,
                               gint offset)
{
	GXmlRange * self;
	gshort result = 0;
#line 201 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 201 "../gxml/Range.vala"
	g_return_val_if_fail (node != NULL, 0);
#line 201 "../gxml/Range.vala"
	result = (gshort) 0;
#line 201 "../gxml/Range.vala"
	return result;
#line 1949 "Range.c"
}

static gboolean
gxml_range_real_intersects_node (GXmlDomRange* base,
                                 GXmlDomNode* node)
{
	GXmlRange * self;
	gboolean result = FALSE;
#line 203 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 203 "../gxml/Range.vala"
	g_return_val_if_fail (node != NULL, FALSE);
#line 203 "../gxml/Range.vala"
	result = FALSE;
#line 203 "../gxml/Range.vala"
	return result;
#line 1966 "Range.c"
}

static gchar*
gxml_range_real_to_string (GXmlDomRange* base)
{
	GXmlRange * self;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 205 "../gxml/Range.vala"
	self = (GXmlRange*) base;
#line 205 "../gxml/Range.vala"
	_tmp0_ = g_strdup ("DomRange");
#line 205 "../gxml/Range.vala"
	result = _tmp0_;
#line 205 "../gxml/Range.vala"
	return result;
#line 1983 "Range.c"
}

static void
gxml_range_class_init (GXmlRangeClass * klass,
                       gpointer klass_data)
{
#line 27 "../gxml/Range.vala"
	gxml_range_parent_class = g_type_class_peek_parent (klass);
#line 27 "../gxml/Range.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gxml_range_get_property;
#line 27 "../gxml/Range.vala"
	G_OBJECT_CLASS (klass)->finalize = gxml_range_finalize;
#line 27 "../gxml/Range.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_RANGE_START_CONTAINER_PROPERTY, gxml_range_properties[GXML_RANGE_START_CONTAINER_PROPERTY] = g_param_spec_object ("start-container", "start-container", "start-container", GXML_TYPE_DOM_NODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 27 "../gxml/Range.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_RANGE_START_OFFSET_PROPERTY, gxml_range_properties[GXML_RANGE_START_OFFSET_PROPERTY] = g_param_spec_int ("start-offset", "start-offset", "start-offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 27 "../gxml/Range.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_RANGE_END_CONTAINER_PROPERTY, gxml_range_properties[GXML_RANGE_END_CONTAINER_PROPERTY] = g_param_spec_object ("end-container", "end-container", "end-container", GXML_TYPE_DOM_NODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 27 "../gxml/Range.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_RANGE_END_OFFSET_PROPERTY, gxml_range_properties[GXML_RANGE_END_OFFSET_PROPERTY] = g_param_spec_int ("end-offset", "end-offset", "end-offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 27 "../gxml/Range.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_RANGE_COLLAPSED_PROPERTY, gxml_range_properties[GXML_RANGE_COLLAPSED_PROPERTY] = g_param_spec_boolean ("collapsed", "collapsed", "collapsed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 27 "../gxml/Range.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_RANGE_COMMON_ANCESTOR_CONTAINER_PROPERTY, gxml_range_properties[GXML_RANGE_COMMON_ANCESTOR_CONTAINER_PROPERTY] = g_param_spec_object ("common-ancestor-container", "common-ancestor-container", "common-ancestor-container", GXML_TYPE_DOM_NODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2008 "Range.c"
}

static void
gxml_range_gxml_dom_range_interface_init (GXmlDomRangeIface * iface,
                                          gpointer iface_data)
{
#line 27 "../gxml/Range.vala"
	gxml_range_gxml_dom_range_parent_iface = g_type_interface_peek_parent (iface);
#line 27 "../gxml/Range.vala"
	iface->set_start = (void (*) (GXmlDomRange*, GXmlDomNode*, gint, GError**)) gxml_range_real_set_start;
#line 27 "../gxml/Range.vala"
	iface->set_end = (void (*) (GXmlDomRange*, GXmlDomNode*, gint, GError**)) gxml_range_real_set_end;
#line 27 "../gxml/Range.vala"
	iface->set_start_before = (void (*) (GXmlDomRange*, GXmlDomNode*, GError**)) gxml_range_real_set_start_before;
#line 27 "../gxml/Range.vala"
	iface->set_start_after = (void (*) (GXmlDomRange*, GXmlDomNode*, GError**)) gxml_range_real_set_start_after;
#line 27 "../gxml/Range.vala"
	iface->set_end_before = (void (*) (GXmlDomRange*, GXmlDomNode*, GError**)) gxml_range_real_set_end_before;
#line 27 "../gxml/Range.vala"
	iface->set_end_after = (void (*) (GXmlDomRange*, GXmlDomNode*, GError**)) gxml_range_real_set_end_after;
#line 27 "../gxml/Range.vala"
	iface->collapse = (void (*) (GXmlDomRange*, gboolean, GError**)) gxml_range_real_collapse;
#line 27 "../gxml/Range.vala"
	iface->select_node = (void (*) (GXmlDomRange*, GXmlDomNode*, GError**)) gxml_range_real_select_node;
#line 27 "../gxml/Range.vala"
	iface->select_node_contents = (void (*) (GXmlDomRange*, GXmlDomNode*, GError**)) gxml_range_real_select_node_contents;
#line 27 "../gxml/Range.vala"
	iface->compare_boundary_points = (gint (*) (GXmlDomRange*, GXmlDomRangeBoundaryPoints, GXmlDomRange*, GError**)) gxml_range_real_compare_boundary_points;
#line 27 "../gxml/Range.vala"
	iface->delete_contents = (void (*) (GXmlDomRange*, GError**)) gxml_range_real_delete_contents;
#line 27 "../gxml/Range.vala"
	iface->extract_contents = (GXmlDomDocumentFragment* (*) (GXmlDomRange*, GError**)) gxml_range_real_extract_contents;
#line 27 "../gxml/Range.vala"
	iface->clone_contents = (GXmlDomDocumentFragment* (*) (GXmlDomRange*, GError**)) gxml_range_real_clone_contents;
#line 27 "../gxml/Range.vala"
	iface->insert_node = (void (*) (GXmlDomRange*, GXmlDomNode*)) gxml_range_real_insert_node;
#line 27 "../gxml/Range.vala"
	iface->surround_contents = (void (*) (GXmlDomRange*, GXmlDomNode*)) gxml_range_real_surround_contents;
#line 27 "../gxml/Range.vala"
	iface->clone_range = (GXmlDomRange* (*) (GXmlDomRange*)) gxml_range_real_clone_range;
#line 27 "../gxml/Range.vala"
	iface->detach = (void (*) (GXmlDomRange*)) gxml_range_real_detach;
#line 27 "../gxml/Range.vala"
	iface->is_point_in_range = (gboolean (*) (GXmlDomRange*, GXmlDomNode*, gint)) gxml_range_real_is_point_in_range;
#line 27 "../gxml/Range.vala"
	iface->compare_point = (gshort (*) (GXmlDomRange*, GXmlDomNode*, gint)) gxml_range_real_compare_point;
#line 27 "../gxml/Range.vala"
	iface->intersects_node = (gboolean (*) (GXmlDomRange*, GXmlDomNode*)) gxml_range_real_intersects_node;
#line 27 "../gxml/Range.vala"
	iface->to_string = (gchar* (*) (GXmlDomRange*)) gxml_range_real_to_string;
#line 27 "../gxml/Range.vala"
	iface->get_start_container = gxml_range_real_get_start_container;
#line 27 "../gxml/Range.vala"
	iface->get_start_offset = gxml_range_real_get_start_offset;
#line 27 "../gxml/Range.vala"
	iface->get_end_container = gxml_range_real_get_end_container;
#line 27 "../gxml/Range.vala"
	iface->get_end_offset = gxml_range_real_get_end_offset;
#line 27 "../gxml/Range.vala"
	iface->get_collapsed = gxml_range_real_get_collapsed;
#line 27 "../gxml/Range.vala"
	iface->get_common_ancestor_container = gxml_range_real_get_common_ancestor_container;
#line 2071 "Range.c"
}

static void
gxml_range_instance_init (GXmlRange * self,
                          gpointer klass)
{
}

static void
gxml_range_finalize (GObject * obj)
{
	GXmlRange * self;
#line 27 "../gxml/Range.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GXML_TYPE_RANGE, GXmlRange);
#line 28 "../gxml/Range.vala"
	_g_object_unref0 (self->_document);
#line 29 "../gxml/Range.vala"
	_g_object_unref0 (self->_start_container);
#line 31 "../gxml/Range.vala"
	_g_object_unref0 (self->_end_container);
#line 34 "../gxml/Range.vala"
	_g_object_unref0 (self->_common_ancestor_container);
#line 27 "../gxml/Range.vala"
	G_OBJECT_CLASS (gxml_range_parent_class)->finalize (obj);
#line 2096 "Range.c"
}

/**
 * DOM4 Range implementation, powered by libxml2 library.
 */
static GType
gxml_range_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GXmlRangeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_range_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GXmlRange), 0, (GInstanceInitFunc) gxml_range_instance_init, NULL };
	static const GInterfaceInfo gxml_dom_range_info = { (GInterfaceInitFunc) gxml_range_gxml_dom_range_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gxml_range_type_id;
	gxml_range_type_id = g_type_register_static (G_TYPE_OBJECT, "GXmlRange", &g_define_type_info, 0);
	g_type_add_interface_static (gxml_range_type_id, GXML_TYPE_DOM_RANGE, &gxml_dom_range_info);
	return gxml_range_type_id;
}

GType
gxml_range_get_type (void)
{
	static volatile gsize gxml_range_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_range_type_id__volatile)) {
		GType gxml_range_type_id;
		gxml_range_type_id = gxml_range_get_type_once ();
		g_once_init_leave (&gxml_range_type_id__volatile, gxml_range_type_id);
	}
	return gxml_range_type_id__volatile;
}

static void
_vala_gxml_range_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	GXmlRange * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_RANGE, GXmlRange);
#line 27 "../gxml/Range.vala"
	switch (property_id) {
#line 27 "../gxml/Range.vala"
		case GXML_RANGE_START_CONTAINER_PROPERTY:
#line 27 "../gxml/Range.vala"
		g_value_set_object (value, gxml_dom_range_get_start_container ((GXmlDomRange*) self));
#line 27 "../gxml/Range.vala"
		break;
#line 27 "../gxml/Range.vala"
		case GXML_RANGE_START_OFFSET_PROPERTY:
#line 27 "../gxml/Range.vala"
		g_value_set_int (value, gxml_dom_range_get_start_offset ((GXmlDomRange*) self));
#line 27 "../gxml/Range.vala"
		break;
#line 27 "../gxml/Range.vala"
		case GXML_RANGE_END_CONTAINER_PROPERTY:
#line 27 "../gxml/Range.vala"
		g_value_set_object (value, gxml_dom_range_get_end_container ((GXmlDomRange*) self));
#line 27 "../gxml/Range.vala"
		break;
#line 27 "../gxml/Range.vala"
		case GXML_RANGE_END_OFFSET_PROPERTY:
#line 27 "../gxml/Range.vala"
		g_value_set_int (value, gxml_dom_range_get_end_offset ((GXmlDomRange*) self));
#line 27 "../gxml/Range.vala"
		break;
#line 27 "../gxml/Range.vala"
		case GXML_RANGE_COLLAPSED_PROPERTY:
#line 27 "../gxml/Range.vala"
		g_value_set_boolean (value, gxml_dom_range_get_collapsed ((GXmlDomRange*) self));
#line 27 "../gxml/Range.vala"
		break;
#line 27 "../gxml/Range.vala"
		case GXML_RANGE_COMMON_ANCESTOR_CONTAINER_PROPERTY:
#line 27 "../gxml/Range.vala"
		g_value_set_object (value, gxml_dom_range_get_common_ancestor_container ((GXmlDomRange*) self));
#line 27 "../gxml/Range.vala"
		break;
#line 2171 "Range.c"
		default:
#line 27 "../gxml/Range.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../gxml/Range.vala"
		break;
#line 2177 "Range.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 245 "../gxml/Parser.vala"
	if (mem && byte_size != 0) {
#line 245 "../gxml/Parser.vala"
		new_mem = g_malloc (byte_size);
#line 245 "../gxml/Parser.vala"
		memcpy (new_mem, mem, byte_size);
#line 2192 "Range.c"
	} else {
#line 245 "../gxml/Parser.vala"
		new_mem = NULL;
#line 2196 "Range.c"
	}
#line 245 "../gxml/Parser.vala"
	return new_mem;
#line 2200 "Range.c"
}

