/* XPath.c generated by valac 0.54.7, the Vala compiler
 * generated from XPath.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; c-basic-offset: 2; tab-width: 2 -*- */
/*
 *
 * Copyright (C) 2016  Yannick Inizan <inizan.yannick@gmail.com>
 * Copyright (C) 2016  Daniel Espinosa <esodan@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Yannick Inizan <inizan.yannick@gmail.com>
 *      Daniel Espinosa <esodan@gmail.com>
 */

#include "gxml/gxml.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include "gxml.h"

/**
 * Parser Error codes for {@link XPathObject} objects
 */

static GType gxml_xpath_context_get_type_once (void);
static GType gxml_xpath_object_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

/**
 * Object type codes for  {@link XPathObject} objects
 */
static GType
gxml_xpath_object_type_get_type_once (void)
{
	static const GEnumValue values[] = {{GXML_XPATH_OBJECT_TYPE_UNDEFINED, "GXML_XPATH_OBJECT_TYPE_UNDEFINED", "undefined"}, {GXML_XPATH_OBJECT_TYPE_NODESET, "GXML_XPATH_OBJECT_TYPE_NODESET", "nodeset"}, {GXML_XPATH_OBJECT_TYPE_BOOLEAN, "GXML_XPATH_OBJECT_TYPE_BOOLEAN", "boolean"}, {GXML_XPATH_OBJECT_TYPE_NUMBER, "GXML_XPATH_OBJECT_TYPE_NUMBER", "number"}, {GXML_XPATH_OBJECT_TYPE_STRING, "GXML_XPATH_OBJECT_TYPE_STRING", "string"}, {GXML_XPATH_OBJECT_TYPE_POINT, "GXML_XPATH_OBJECT_TYPE_POINT", "point"}, {GXML_XPATH_OBJECT_TYPE_RANGE, "GXML_XPATH_OBJECT_TYPE_RANGE", "range"}, {GXML_XPATH_OBJECT_TYPE_LOCATIONSET, "GXML_XPATH_OBJECT_TYPE_LOCATIONSET", "locationset"}, {GXML_XPATH_OBJECT_TYPE_USERS, "GXML_XPATH_OBJECT_TYPE_USERS", "users"}, {GXML_XPATH_OBJECT_TYPE_XSLT_TREE, "GXML_XPATH_OBJECT_TYPE_XSLT_TREE", "xslt-tree"}, {0, NULL, NULL}};
	GType gxml_xpath_object_type_type_id;
	gxml_xpath_object_type_type_id = g_enum_register_static ("GXmlXPathObjectType", values);
	return gxml_xpath_object_type_type_id;
}

GType
gxml_xpath_object_type_get_type (void)
{
	static volatile gsize gxml_xpath_object_type_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_xpath_object_type_type_id__volatile)) {
		GType gxml_xpath_object_type_type_id;
		gxml_xpath_object_type_type_id = gxml_xpath_object_type_get_type_once ();
		g_once_init_leave (&gxml_xpath_object_type_type_id__volatile, gxml_xpath_object_type_type_id);
	}
	return gxml_xpath_object_type_type_id__volatile;
}

GQuark
gxml_xpath_error_quark (void)
{
#line 245 "../gxml/Parser.vala"
	return g_quark_from_static_string ("gxml-xpath-error-quark");
#line 75 "XPath.c"
}

/**
   * Evaluate XPath expression.
   *
   * This method evaluates provided expression, registers provided namespaces
   * in resolver and returns an {@link GXml.XPathObject}.
   *
   * Resolver is a map where its key is the namespace's prefix and
   * its value is the namespace's URI
   *
   * Throw {@link GXml.XPathError} if one of provided namespaces is invalid.
   */
GXmlXPathObject*
gxml_xpath_context_evaluate (GXmlXPathContext* self,
                             const gchar* expression,
                             GeeMap* resolver,
                             GError** error)
{
	GXmlXPathContextIface* _iface_;
#line 82 "../gxml/XPath.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 82 "../gxml/XPath.vala"
	_iface_ = GXML_XPATH_CONTEXT_GET_INTERFACE (self);
#line 82 "../gxml/XPath.vala"
	if (_iface_->evaluate) {
#line 82 "../gxml/XPath.vala"
		return _iface_->evaluate (self, expression, resolver, error);
#line 104 "XPath.c"
	}
#line 82 "../gxml/XPath.vala"
	return NULL;
#line 108 "XPath.c"
}

static void
gxml_xpath_context_default_init (GXmlXPathContextIface * iface,
                                 gpointer iface_data)
{
}

static GType
gxml_xpath_context_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GXmlXPathContextIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_xpath_context_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType gxml_xpath_context_type_id;
	gxml_xpath_context_type_id = g_type_register_static (G_TYPE_INTERFACE, "GXmlXPathContext", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (gxml_xpath_context_type_id, G_TYPE_OBJECT);
	return gxml_xpath_context_type_id;
}

GType
gxml_xpath_context_get_type (void)
{
	static volatile gsize gxml_xpath_context_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_xpath_context_type_id__volatile)) {
		GType gxml_xpath_context_type_id;
		gxml_xpath_context_type_id = gxml_xpath_context_get_type_once ();
		g_once_init_leave (&gxml_xpath_context_type_id__volatile, gxml_xpath_context_type_id);
	}
	return gxml_xpath_context_type_id__volatile;
}

GQuark
gxml_xpath_object_error_quark (void)
{
#line 245 "../gxml/Parser.vala"
	return g_quark_from_static_string ("gxml-xpath-object-error-quark");
#line 144 "XPath.c"
}

GXmlXPathObjectType
gxml_xpath_object_get_object_type (GXmlXPathObject* self)
{
	GXmlXPathObjectIface* _iface_;
#line 96 "../gxml/XPath.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 96 "../gxml/XPath.vala"
	_iface_ = GXML_XPATH_OBJECT_GET_INTERFACE (self);
#line 96 "../gxml/XPath.vala"
	if (_iface_->get_object_type) {
#line 96 "../gxml/XPath.vala"
		return _iface_->get_object_type (self);
#line 159 "XPath.c"
	}
#line 96 "../gxml/XPath.vala"
	return 0;
#line 163 "XPath.c"
}

gboolean
gxml_xpath_object_get_boolean_value (GXmlXPathObject* self)
{
	GXmlXPathObjectIface* _iface_;
#line 100 "../gxml/XPath.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 100 "../gxml/XPath.vala"
	_iface_ = GXML_XPATH_OBJECT_GET_INTERFACE (self);
#line 100 "../gxml/XPath.vala"
	if (_iface_->get_boolean_value) {
#line 100 "../gxml/XPath.vala"
		return _iface_->get_boolean_value (self);
#line 178 "XPath.c"
	}
#line 100 "../gxml/XPath.vala"
	return FALSE;
#line 182 "XPath.c"
}

const gchar*
gxml_xpath_object_get_string_value (GXmlXPathObject* self)
{
	GXmlXPathObjectIface* _iface_;
#line 104 "../gxml/XPath.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 104 "../gxml/XPath.vala"
	_iface_ = GXML_XPATH_OBJECT_GET_INTERFACE (self);
#line 104 "../gxml/XPath.vala"
	if (_iface_->get_string_value) {
#line 104 "../gxml/XPath.vala"
		return _iface_->get_string_value (self);
#line 197 "XPath.c"
	}
#line 104 "../gxml/XPath.vala"
	return NULL;
#line 201 "XPath.c"
}

gdouble
gxml_xpath_object_get_number_value (GXmlXPathObject* self)
{
	GXmlXPathObjectIface* _iface_;
#line 108 "../gxml/XPath.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 108 "../gxml/XPath.vala"
	_iface_ = GXML_XPATH_OBJECT_GET_INTERFACE (self);
#line 108 "../gxml/XPath.vala"
	if (_iface_->get_number_value) {
#line 108 "../gxml/XPath.vala"
		return _iface_->get_number_value (self);
#line 216 "XPath.c"
	}
#line 108 "../gxml/XPath.vala"
	return -1.0;
#line 220 "XPath.c"
}

GXmlDomHTMLCollection*
gxml_xpath_object_get_nodeset (GXmlXPathObject* self)
{
	GXmlXPathObjectIface* _iface_;
#line 112 "../gxml/XPath.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 112 "../gxml/XPath.vala"
	_iface_ = GXML_XPATH_OBJECT_GET_INTERFACE (self);
#line 112 "../gxml/XPath.vala"
	if (_iface_->get_nodeset) {
#line 112 "../gxml/XPath.vala"
		return _iface_->get_nodeset (self);
#line 235 "XPath.c"
	}
#line 112 "../gxml/XPath.vala"
	return NULL;
#line 239 "XPath.c"
}

static void
gxml_xpath_object_default_init (GXmlXPathObjectIface * iface,
                                gpointer iface_data)
{
	/**
	   *
	   */
#line 92 "../gxml/XPath.vala"
	g_object_interface_install_property (iface, g_param_spec_enum ("object-type", "object-type", "object-type", GXML_TYPE_XPATH_OBJECT_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 251 "XPath.c"
	/**
	   *
	   */
#line 92 "../gxml/XPath.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("boolean-value", "boolean-value", "boolean-value", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 257 "XPath.c"
	/**
	   *
	   */
#line 92 "../gxml/XPath.vala"
	g_object_interface_install_property (iface, g_param_spec_string ("string-value", "string-value", "string-value", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 263 "XPath.c"
	/**
	   *
	   */
#line 92 "../gxml/XPath.vala"
	g_object_interface_install_property (iface, g_param_spec_double ("number-value", "number-value", "number-value", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 269 "XPath.c"
	/**
	   *
	   */
#line 92 "../gxml/XPath.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("nodeset", "nodeset", "nodeset", GXML_TYPE_DOM_HTML_COLLECTION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 275 "XPath.c"
}

static GType
gxml_xpath_object_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GXmlXPathObjectIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_xpath_object_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType gxml_xpath_object_type_id;
	gxml_xpath_object_type_id = g_type_register_static (G_TYPE_INTERFACE, "GXmlXPathObject", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (gxml_xpath_object_type_id, G_TYPE_OBJECT);
	return gxml_xpath_object_type_id;
}

GType
gxml_xpath_object_get_type (void)
{
	static volatile gsize gxml_xpath_object_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_xpath_object_type_id__volatile)) {
		GType gxml_xpath_object_type_id;
		gxml_xpath_object_type_id = gxml_xpath_object_get_type_once ();
		g_once_init_leave (&gxml_xpath_object_type_id__volatile, gxml_xpath_object_type_id);
	}
	return gxml_xpath_object_type_id__volatile;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 245 "../gxml/Parser.vala"
	if (mem && byte_size != 0) {
#line 245 "../gxml/Parser.vala"
		new_mem = g_malloc (byte_size);
#line 245 "../gxml/Parser.vala"
		memcpy (new_mem, mem, byte_size);
#line 311 "XPath.c"
	} else {
#line 245 "../gxml/Parser.vala"
		new_mem = NULL;
#line 315 "XPath.c"
	}
#line 245 "../gxml/Parser.vala"
	return new_mem;
#line 319 "XPath.c"
}

