/* CssSelectorParser.c generated by valac 0.54.7, the Vala compiler
 * generated from CssSelectorParser.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: tab; c-basic-offset: 0; tab-width: 2 -*- */
/*
 *
 * Copyright (C) 2017-2019  Yannick Inizan <inizan.yannick@gmail.com>
 * Copyright (C) 2017  Daniel Espinosa <esodan@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Yannick Inizan <inizan.yannick@gmail.com>
 *      Daniel Espinosa <esodan@gmail.com>
 */

#include "gxml/gxml.h"
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <errno.h>
#include "gxml.h"

#define GXML_TYPE_CSS_STRING (gxml_css_string_get_type ())
#define GXML_CSS_STRING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GXML_TYPE_CSS_STRING, GXmlCssString))
#define GXML_CSS_STRING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GXML_TYPE_CSS_STRING, GXmlCssStringClass))
#define GXML_IS_CSS_STRING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GXML_TYPE_CSS_STRING))
#define GXML_IS_CSS_STRING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GXML_TYPE_CSS_STRING))
#define GXML_CSS_STRING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GXML_TYPE_CSS_STRING, GXmlCssStringClass))

typedef struct _GXmlCssString GXmlCssString;
typedef struct _GXmlCssStringClass GXmlCssStringClass;
typedef struct _GXmlCssStringPrivate GXmlCssStringPrivate;
enum  {
	GXML_CSS_STRING_0_PROPERTY,
	GXML_CSS_STRING_EOF_PROPERTY,
	GXML_CSS_STRING_TEXT_PROPERTY,
	GXML_CSS_STRING_NUM_PROPERTIES
};
static GParamSpec* gxml_css_string_properties[GXML_CSS_STRING_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
typedef gboolean (*GXmlCssStringFunc) (GXmlCssString* str, gpointer user_data);
enum  {
	GXML_CSS_SELECTOR_0_PROPERTY,
	GXML_CSS_SELECTOR_SELECTOR_TYPE_PROPERTY,
	GXML_CSS_SELECTOR_NAME_PROPERTY,
	GXML_CSS_SELECTOR_VALUE_PROPERTY,
	GXML_CSS_SELECTOR_COMBINER_PROPERTY,
	GXML_CSS_SELECTOR_NUM_PROPERTIES
};
static GParamSpec* gxml_css_selector_properties[GXML_CSS_SELECTOR_NUM_PROPERTIES];
enum  {
	GXML_CSS_ELEMENT_SELECTOR_0_PROPERTY,
	GXML_CSS_ELEMENT_SELECTOR_PREFIXED_PROPERTY,
	GXML_CSS_ELEMENT_SELECTOR_PREFIX_PROPERTY,
	GXML_CSS_ELEMENT_SELECTOR_LOCAL_NAME_PROPERTY,
	GXML_CSS_ELEMENT_SELECTOR_NUM_PROPERTIES
};
static GParamSpec* gxml_css_element_selector_properties[GXML_CSS_ELEMENT_SELECTOR_NUM_PROPERTIES];
enum  {
	GXML_CSS_ATTRIBUTE_SELECTOR_0_PROPERTY,
	GXML_CSS_ATTRIBUTE_SELECTOR_PREFIX_PROPERTY,
	GXML_CSS_ATTRIBUTE_SELECTOR_LOCAL_NAME_PROPERTY,
	GXML_CSS_ATTRIBUTE_SELECTOR_NUM_PROPERTIES
};
static GParamSpec* gxml_css_attribute_selector_properties[GXML_CSS_ATTRIBUTE_SELECTOR_NUM_PROPERTIES];
enum  {
	GXML_CSS_NOT_SELECTOR_0_PROPERTY,
	GXML_CSS_NOT_SELECTOR_SELECTORS_PROPERTY,
	GXML_CSS_NOT_SELECTOR_NUM_PROPERTIES
};
static GParamSpec* gxml_css_not_selector_properties[GXML_CSS_NOT_SELECTOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	GXML_CSS_SELECTOR_PARSER_0_PROPERTY,
	GXML_CSS_SELECTOR_PARSER_SELECTORS_PROPERTY,
	GXML_CSS_SELECTOR_PARSER_NUM_PROPERTIES
};
static GParamSpec* gxml_css_selector_parser_properties[GXML_CSS_SELECTOR_PARSER_NUM_PROPERTIES];
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _Block1Data Block1Data;

/**
 * Error throwed during parsing 
 */
struct _GXmlCssString {
	GObject parent_instance;
	GXmlCssStringPrivate * priv;
};

struct _GXmlCssStringClass {
	GObjectClass parent_class;
};

struct _GXmlCssStringPrivate {
	gint position;
	gchar* _text;
};

struct _GXmlCssSelectorPrivate {
	GXmlCssSelectorType _selector_type;
	gchar* _name;
	gchar* _value;
	GXmlCssCombiner _combiner;
};

struct _GXmlCssAttributeSelectorPrivate {
	gchar* _prefix;
	gchar* _local_name;
};

struct _GXmlCssNotSelectorPrivate {
	GeeArrayList* list;
};

struct _GXmlCssSelectorParserPrivate {
	GeeArrayList* list;
};

struct _Block1Data {
	int _ref_count_;
	gunichar quote;
};

static gint GXmlCssString_private_offset;
static gpointer gxml_css_string_parent_class = NULL;
static gint GXmlCssSelector_private_offset;
static gpointer gxml_css_selector_parent_class = NULL;
static gpointer gxml_css_element_selector_parent_class = NULL;
static gint GXmlCssAttributeSelector_private_offset;
static gpointer gxml_css_attribute_selector_parent_class = NULL;
static gint GXmlCssNotSelector_private_offset;
static gpointer gxml_css_not_selector_parent_class = NULL;
static gint GXmlCssSelectorParser_private_offset;
static gpointer gxml_css_selector_parser_parent_class = NULL;

VALA_EXTERN GType gxml_css_string_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GXmlCssString* gxml_css_string_new (const gchar* text);
VALA_EXTERN GXmlCssString* gxml_css_string_construct (GType object_type,
                                          const gchar* text);
VALA_EXTERN gunichar gxml_css_string_peek (GXmlCssString* self);
VALA_EXTERN const gchar* gxml_css_string_get_text (GXmlCssString* self);
VALA_EXTERN gunichar gxml_css_string_read (GXmlCssString* self);
VALA_EXTERN gunichar gxml_css_string_read_r (GXmlCssString* self);
VALA_EXTERN gboolean gxml_css_string_get_eof (GXmlCssString* self);
static void gxml_css_string_set_text (GXmlCssString* self,
                               const gchar* value);
static void gxml_css_string_finalize (GObject * obj);
static GType gxml_css_string_get_type_once (void);
static void _vala_gxml_css_string_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_gxml_css_string_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void gxml_css_selector_finalize (GObject * obj);
static GType gxml_css_selector_get_type_once (void);
static void _vala_gxml_css_selector_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_gxml_css_selector_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static GType gxml_css_element_selector_get_type_once (void);
static void _vala_gxml_css_element_selector_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_gxml_css_element_selector_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
static void gxml_css_attribute_selector_finalize (GObject * obj);
static GType gxml_css_attribute_selector_get_type_once (void);
static void _vala_gxml_css_attribute_selector_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_gxml_css_attribute_selector_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);
static GObject * gxml_css_not_selector_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void gxml_css_not_selector_finalize (GObject * obj);
static GType gxml_css_not_selector_get_type_once (void);
static void _vala_gxml_css_not_selector_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static gboolean gxml_css_selector_parser_is_valid_char (gunichar u);
static gboolean _vala_unichar_array_contains (gunichar * stack,
                                       gssize stack_length,
                                       const gunichar needle);
static gchar* gxml_css_selector_parser_parse_identifier (GXmlCssString* str,
                                                  GXmlCssStringFunc func,
                                                  gpointer func_target);
static GXmlCssSelector* gxml_css_selector_parser_parse_element (GXmlCssString* str,
                                                         GError** error);
static GXmlCssNotSelector* gxml_css_selector_parser_parse_not_selector (GXmlCssString* str,
                                                                 GError** error);
static void gxml_css_selector_parser_parse_selectors (GXmlCssString* str,
                                               GeeList* list,
                                               gunichar stop_char,
                                               GError** error);
static GXmlCssSelector* gxml_css_selector_parser_parse_pseudo (GXmlCssString* str,
                                                        GError** error);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static GXmlCssSelector* gxml_css_selector_parser_parse_class (GXmlCssString* str,
                                                       GError** error);
static GXmlCssSelector* gxml_css_selector_parser_parse_id (GXmlCssString* str,
                                                    GError** error);
static GXmlCssSelector* gxml_css_selector_parser_parse_attribute (GXmlCssString* str,
                                                           GError** error);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda4_ (Block1Data* _data1_,
                     GXmlCssString* s);
static gboolean ___lambda4__gxml_css_string_func (GXmlCssString* str,
                                           gpointer self);
static gboolean gxml_css_selector_parser_match_pseudo (GXmlDomElement* element,
                                                GXmlCssSelector* selector,
                                                GError** error);
static gboolean gxml_css_selector_parser_match_attribute (GXmlDomElement* element,
                                                   GXmlCssAttributeSelector* selector,
                                                   GError** error);
static gboolean gxml_css_selector_parser_match_node (GXmlDomElement* element,
                                              GXmlCssSelector* selector,
                                              GError** error);
static gboolean gxml_css_selector_parser_match_element (GXmlDomElement* root,
                                                 GXmlDomElement* element,
                                                 GeeCollection* selectors,
                                                 GError** error);
static GObject * gxml_css_selector_parser_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void gxml_css_selector_parser_finalize (GObject * obj);
static GType gxml_css_selector_parser_get_type_once (void);
static void _vala_gxml_css_selector_parser_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

/**
 * Enumeration of identifiers, to combine selectors 
 */
static GType
gxml_css_combiner_get_type_once (void)
{
	static const GEnumValue values[] = {{GXML_CSS_COMBINER_NULL, "GXML_CSS_COMBINER_NULL", "null"}, {GXML_CSS_COMBINER_NONE, "GXML_CSS_COMBINER_NONE", "none"}, {GXML_CSS_COMBINER_INSIDE, "GXML_CSS_COMBINER_INSIDE", "inside"}, {GXML_CSS_COMBINER_AND, "GXML_CSS_COMBINER_AND", "and"}, {GXML_CSS_COMBINER_PARENT, "GXML_CSS_COMBINER_PARENT", "parent"}, {GXML_CSS_COMBINER_AFTER, "GXML_CSS_COMBINER_AFTER", "after"}, {GXML_CSS_COMBINER_PRECEDED, "GXML_CSS_COMBINER_PRECEDED", "preceded"}, {0, NULL, NULL}};
	GType gxml_css_combiner_type_id;
	gxml_css_combiner_type_id = g_enum_register_static ("GXmlCssCombiner", values);
	return gxml_css_combiner_type_id;
}

GType
gxml_css_combiner_get_type (void)
{
	static volatile gsize gxml_css_combiner_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_css_combiner_type_id__volatile)) {
		GType gxml_css_combiner_type_id;
		gxml_css_combiner_type_id = gxml_css_combiner_get_type_once ();
		g_once_init_leave (&gxml_css_combiner_type_id__volatile, gxml_css_combiner_type_id);
	}
	return gxml_css_combiner_type_id__volatile;
}

/**
 * Enumeration of types for {@link GXml.CssSelector}
 */
static GType
gxml_css_selector_type_get_type_once (void)
{
	static const GEnumValue values[] = {{GXML_CSS_SELECTOR_TYPE_CLASS, "GXML_CSS_SELECTOR_TYPE_CLASS", "class"}, {GXML_CSS_SELECTOR_TYPE_ID, "GXML_CSS_SELECTOR_TYPE_ID", "id"}, {GXML_CSS_SELECTOR_TYPE_ALL, "GXML_CSS_SELECTOR_TYPE_ALL", "all"}, {GXML_CSS_SELECTOR_TYPE_ELEMENT, "GXML_CSS_SELECTOR_TYPE_ELEMENT", "element"}, {GXML_CSS_SELECTOR_TYPE_ATTRIBUTE, "GXML_CSS_SELECTOR_TYPE_ATTRIBUTE", "attribute"}, {GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_EQUAL, "GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_EQUAL", "attribute-equal"}, {GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_CONTAINS, "GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_CONTAINS", "attribute-contains"}, {GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_SUBSTRING, "GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_SUBSTRING", "attribute-substring"}, {GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_STARTS_WITH, "GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_STARTS_WITH", "attribute-starts-with"}, {GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_STARTS_WITH_WORD, "GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_STARTS_WITH_WORD", "attribute-starts-with-word"}, {GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_ENDS_WITH, "GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_ENDS_WITH", "attribute-ends-with"}, {GXML_CSS_SELECTOR_TYPE_PSEUDO_CLASS, "GXML_CSS_SELECTOR_TYPE_PSEUDO_CLASS", "pseudo-class"}, {0, NULL, NULL}};
	GType gxml_css_selector_type_type_id;
	gxml_css_selector_type_type_id = g_enum_register_static ("GXmlCssSelectorType", values);
	return gxml_css_selector_type_type_id;
}

GType
gxml_css_selector_type_get_type (void)
{
	static volatile gsize gxml_css_selector_type_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_css_selector_type_type_id__volatile)) {
		GType gxml_css_selector_type_type_id;
		gxml_css_selector_type_type_id = gxml_css_selector_type_get_type_once ();
		g_once_init_leave (&gxml_css_selector_type_type_id__volatile, gxml_css_selector_type_type_id);
	}
	return gxml_css_selector_type_type_id__volatile;
}

GQuark
gxml_css_selector_error_quark (void)
{
#line 371 "../gxml/Collections.vala"
	return g_quark_from_static_string ("gxml-css-selector-error-quark");
#line 326 "CssSelectorParser.c"
}

static inline gpointer
gxml_css_string_get_instance_private (GXmlCssString* self)
{
	return G_STRUCT_MEMBER_P (self, GXmlCssString_private_offset);
}

GXmlCssString*
gxml_css_string_construct (GType object_type,
                           const gchar* text)
{
	GXmlCssString * self = NULL;
#line 71 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 72 "../gxml/CssSelectorParser.vala"
	self = (GXmlCssString*) g_object_new (object_type, "text", text, NULL);
#line 71 "../gxml/CssSelectorParser.vala"
	return self;
#line 346 "CssSelectorParser.c"
}

GXmlCssString*
gxml_css_string_new (const gchar* text)
{
#line 71 "../gxml/CssSelectorParser.vala"
	return gxml_css_string_construct (GXML_TYPE_CSS_STRING, text);
#line 354 "CssSelectorParser.c"
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
#line 1251 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1252 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1253 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 370 "CssSelectorParser.c"
		gchar* _tmp0_;
#line 1254 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1254 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1255 "glib-2.0.vapi"
		result = TRUE;
#line 1255 "glib-2.0.vapi"
		if (c) {
#line 1255 "glib-2.0.vapi"
			*c = _vala_c;
#line 382 "CssSelectorParser.c"
		}
#line 1255 "glib-2.0.vapi"
		return result;
#line 386 "CssSelectorParser.c"
	} else {
#line 1257 "glib-2.0.vapi"
		result = FALSE;
#line 1257 "glib-2.0.vapi"
		if (c) {
#line 1257 "glib-2.0.vapi"
			*c = _vala_c;
#line 394 "CssSelectorParser.c"
		}
#line 1257 "glib-2.0.vapi"
		return result;
#line 398 "CssSelectorParser.c"
	}
}

gunichar
gxml_css_string_peek (GXmlCssString* self)
{
	gint pos = 0;
	gunichar u = 0U;
	const gchar* _tmp0_;
	gunichar _tmp1_ = 0U;
	gboolean _tmp2_;
	gunichar result = 0U;
#line 77 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 78 "../gxml/CssSelectorParser.vala"
	pos = self->priv->position;
#line 79 "../gxml/CssSelectorParser.vala"
	u = (gunichar) 0;
#line 80 "../gxml/CssSelectorParser.vala"
	_tmp0_ = self->priv->_text;
#line 80 "../gxml/CssSelectorParser.vala"
	_tmp2_ = string_get_next_char (_tmp0_, &pos, &_tmp1_);
#line 80 "../gxml/CssSelectorParser.vala"
	u = _tmp1_;
#line 80 "../gxml/CssSelectorParser.vala"
	if (!_tmp2_) {
#line 81 "../gxml/CssSelectorParser.vala"
		result = (gunichar) 0;
#line 81 "../gxml/CssSelectorParser.vala"
		return result;
#line 429 "CssSelectorParser.c"
	}
#line 82 "../gxml/CssSelectorParser.vala"
	result = u;
#line 82 "../gxml/CssSelectorParser.vala"
	return result;
#line 435 "CssSelectorParser.c"
}

gunichar
gxml_css_string_read (GXmlCssString* self)
{
	gunichar u = 0U;
	const gchar* _tmp0_;
	gunichar _tmp1_ = 0U;
	gboolean _tmp2_;
	gunichar result = 0U;
#line 85 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 86 "../gxml/CssSelectorParser.vala"
	u = (gunichar) 0;
#line 87 "../gxml/CssSelectorParser.vala"
	_tmp0_ = self->priv->_text;
#line 87 "../gxml/CssSelectorParser.vala"
	_tmp2_ = string_get_next_char (_tmp0_, &self->priv->position, &_tmp1_);
#line 87 "../gxml/CssSelectorParser.vala"
	u = _tmp1_;
#line 87 "../gxml/CssSelectorParser.vala"
	if (!_tmp2_) {
#line 88 "../gxml/CssSelectorParser.vala"
		result = (gunichar) 0;
#line 88 "../gxml/CssSelectorParser.vala"
		return result;
#line 462 "CssSelectorParser.c"
	}
#line 89 "../gxml/CssSelectorParser.vala"
	result = u;
#line 89 "../gxml/CssSelectorParser.vala"
	return result;
#line 468 "CssSelectorParser.c"
}

static gboolean
string_get_prev_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
#line 1290 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1291 "glib-2.0.vapi"
	if (0 < (*index)) {
#line 482 "CssSelectorParser.c"
		gchar* _tmp0_;
#line 1292 "glib-2.0.vapi"
		_tmp0_ = g_utf8_prev_char (((gchar*) self) + (*index));
#line 1292 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1293 "glib-2.0.vapi"
		_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1294 "glib-2.0.vapi"
		result = TRUE;
#line 1294 "glib-2.0.vapi"
		if (c) {
#line 1294 "glib-2.0.vapi"
			*c = _vala_c;
#line 496 "CssSelectorParser.c"
		}
#line 1294 "glib-2.0.vapi"
		return result;
#line 500 "CssSelectorParser.c"
	} else {
#line 1296 "glib-2.0.vapi"
		_vala_c = (gunichar) 0;
#line 1297 "glib-2.0.vapi"
		result = FALSE;
#line 1297 "glib-2.0.vapi"
		if (c) {
#line 1297 "glib-2.0.vapi"
			*c = _vala_c;
#line 510 "CssSelectorParser.c"
		}
#line 1297 "glib-2.0.vapi"
		return result;
#line 514 "CssSelectorParser.c"
	}
}

gunichar
gxml_css_string_read_r (GXmlCssString* self)
{
	gunichar u = 0U;
	const gchar* _tmp0_;
	gunichar _tmp1_ = 0U;
	gboolean _tmp2_;
	gunichar result = 0U;
#line 92 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 93 "../gxml/CssSelectorParser.vala"
	u = (gunichar) 0;
#line 94 "../gxml/CssSelectorParser.vala"
	_tmp0_ = self->priv->_text;
#line 94 "../gxml/CssSelectorParser.vala"
	_tmp2_ = string_get_prev_char (_tmp0_, &self->priv->position, &_tmp1_);
#line 94 "../gxml/CssSelectorParser.vala"
	u = _tmp1_;
#line 94 "../gxml/CssSelectorParser.vala"
	if (!_tmp2_) {
#line 95 "../gxml/CssSelectorParser.vala"
		result = (gunichar) 0;
#line 95 "../gxml/CssSelectorParser.vala"
		return result;
#line 542 "CssSelectorParser.c"
	}
#line 96 "../gxml/CssSelectorParser.vala"
	result = u;
#line 96 "../gxml/CssSelectorParser.vala"
	return result;
#line 548 "CssSelectorParser.c"
}

gboolean
gxml_css_string_get_eof (GXmlCssString* self)
{
	gboolean result;
#line 100 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 101 "../gxml/CssSelectorParser.vala"
	result = gxml_css_string_peek (self) == ((gunichar) 0);
#line 101 "../gxml/CssSelectorParser.vala"
	return result;
#line 561 "CssSelectorParser.c"
}

const gchar*
gxml_css_string_get_text (GXmlCssString* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 105 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 105 "../gxml/CssSelectorParser.vala"
	_tmp0_ = self->priv->_text;
#line 105 "../gxml/CssSelectorParser.vala"
	result = _tmp0_;
#line 105 "../gxml/CssSelectorParser.vala"
	return result;
#line 577 "CssSelectorParser.c"
}

static void
gxml_css_string_set_text (GXmlCssString* self,
                          const gchar* value)
{
	gchar* old_value;
#line 105 "../gxml/CssSelectorParser.vala"
	g_return_if_fail (self != NULL);
#line 105 "../gxml/CssSelectorParser.vala"
	old_value = gxml_css_string_get_text (self);
#line 105 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 591 "CssSelectorParser.c"
		gchar* _tmp0_;
#line 105 "../gxml/CssSelectorParser.vala"
		_tmp0_ = g_strdup (value);
#line 105 "../gxml/CssSelectorParser.vala"
		_g_free0 (self->priv->_text);
#line 105 "../gxml/CssSelectorParser.vala"
		self->priv->_text = _tmp0_;
#line 105 "../gxml/CssSelectorParser.vala"
		g_object_notify_by_pspec ((GObject *) self, gxml_css_string_properties[GXML_CSS_STRING_TEXT_PROPERTY]);
#line 601 "CssSelectorParser.c"
	}
}

static void
gxml_css_string_class_init (GXmlCssStringClass * klass,
                            gpointer klass_data)
{
#line 70 "../gxml/CssSelectorParser.vala"
	gxml_css_string_parent_class = g_type_class_peek_parent (klass);
#line 70 "../gxml/CssSelectorParser.vala"
	g_type_class_adjust_private_offset (klass, &GXmlCssString_private_offset);
#line 70 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gxml_css_string_get_property;
#line 70 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gxml_css_string_set_property;
#line 70 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (klass)->finalize = gxml_css_string_finalize;
#line 70 "../gxml/CssSelectorParser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_CSS_STRING_EOF_PROPERTY, gxml_css_string_properties[GXML_CSS_STRING_EOF_PROPERTY] = g_param_spec_boolean ("eof", "eof", "eof", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 70 "../gxml/CssSelectorParser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_CSS_STRING_TEXT_PROPERTY, gxml_css_string_properties[GXML_CSS_STRING_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 623 "CssSelectorParser.c"
}

static void
gxml_css_string_instance_init (GXmlCssString * self,
                               gpointer klass)
{
#line 70 "../gxml/CssSelectorParser.vala"
	self->priv = gxml_css_string_get_instance_private (self);
#line 632 "CssSelectorParser.c"
}

static void
gxml_css_string_finalize (GObject * obj)
{
	GXmlCssString * self;
#line 70 "../gxml/CssSelectorParser.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GXML_TYPE_CSS_STRING, GXmlCssString);
#line 105 "../gxml/CssSelectorParser.vala"
	_g_free0 (self->priv->_text);
#line 70 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (gxml_css_string_parent_class)->finalize (obj);
#line 645 "CssSelectorParser.c"
}

/**
 * String container for parsing 
 */
static GType
gxml_css_string_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GXmlCssStringClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_css_string_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GXmlCssString), 0, (GInstanceInitFunc) gxml_css_string_instance_init, NULL };
	GType gxml_css_string_type_id;
	gxml_css_string_type_id = g_type_register_static (G_TYPE_OBJECT, "GXmlCssString", &g_define_type_info, 0);
	GXmlCssString_private_offset = g_type_add_instance_private (gxml_css_string_type_id, sizeof (GXmlCssStringPrivate));
	return gxml_css_string_type_id;
}

GType
gxml_css_string_get_type (void)
{
	static volatile gsize gxml_css_string_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_css_string_type_id__volatile)) {
		GType gxml_css_string_type_id;
		gxml_css_string_type_id = gxml_css_string_get_type_once ();
		g_once_init_leave (&gxml_css_string_type_id__volatile, gxml_css_string_type_id);
	}
	return gxml_css_string_type_id__volatile;
}

static void
_vala_gxml_css_string_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	GXmlCssString * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_CSS_STRING, GXmlCssString);
#line 70 "../gxml/CssSelectorParser.vala"
	switch (property_id) {
#line 70 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_STRING_EOF_PROPERTY:
#line 70 "../gxml/CssSelectorParser.vala"
		g_value_set_boolean (value, gxml_css_string_get_eof (self));
#line 70 "../gxml/CssSelectorParser.vala"
		break;
#line 70 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_STRING_TEXT_PROPERTY:
#line 70 "../gxml/CssSelectorParser.vala"
		g_value_set_string (value, gxml_css_string_get_text (self));
#line 70 "../gxml/CssSelectorParser.vala"
		break;
#line 695 "CssSelectorParser.c"
		default:
#line 70 "../gxml/CssSelectorParser.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 70 "../gxml/CssSelectorParser.vala"
		break;
#line 701 "CssSelectorParser.c"
	}
}

static void
_vala_gxml_css_string_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	GXmlCssString * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_CSS_STRING, GXmlCssString);
#line 70 "../gxml/CssSelectorParser.vala"
	switch (property_id) {
#line 70 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_STRING_TEXT_PROPERTY:
#line 70 "../gxml/CssSelectorParser.vala"
		gxml_css_string_set_text (self, g_value_get_string (value));
#line 70 "../gxml/CssSelectorParser.vala"
		break;
#line 721 "CssSelectorParser.c"
		default:
#line 70 "../gxml/CssSelectorParser.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 70 "../gxml/CssSelectorParser.vala"
		break;
#line 727 "CssSelectorParser.c"
	}
}

static inline gpointer
gxml_css_selector_get_instance_private (GXmlCssSelector* self)
{
	return G_STRUCT_MEMBER_P (self, GXmlCssSelector_private_offset);
}

GXmlCssSelector*
gxml_css_selector_construct (GType object_type,
                             GXmlCssSelectorType t,
                             const gchar* name)
{
	GXmlCssSelector * self = NULL;
#line 115 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 116 "../gxml/CssSelectorParser.vala"
	self = (GXmlCssSelector*) g_object_new (object_type, "selector-type", t, "name", name, "value", "", NULL);
#line 115 "../gxml/CssSelectorParser.vala"
	return self;
#line 749 "CssSelectorParser.c"
}

GXmlCssSelector*
gxml_css_selector_new (GXmlCssSelectorType t,
                       const gchar* name)
{
#line 115 "../gxml/CssSelectorParser.vala"
	return gxml_css_selector_construct (GXML_TYPE_CSS_SELECTOR, t, name);
#line 758 "CssSelectorParser.c"
}

GXmlCssSelector*
gxml_css_selector_construct_with_value (GType object_type,
                                        GXmlCssSelectorType t,
                                        const gchar* name,
                                        const gchar* value)
{
	GXmlCssSelector * self = NULL;
#line 119 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 119 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 120 "../gxml/CssSelectorParser.vala"
	self = (GXmlCssSelector*) g_object_new (object_type, "selector-type", t, "name", name, "value", value, NULL);
#line 119 "../gxml/CssSelectorParser.vala"
	return self;
#line 776 "CssSelectorParser.c"
}

GXmlCssSelector*
gxml_css_selector_new_with_value (GXmlCssSelectorType t,
                                  const gchar* name,
                                  const gchar* value)
{
#line 119 "../gxml/CssSelectorParser.vala"
	return gxml_css_selector_construct_with_value (GXML_TYPE_CSS_SELECTOR, t, name, value);
#line 786 "CssSelectorParser.c"
}

GXmlCssSelectorType
gxml_css_selector_get_selector_type (GXmlCssSelector* self)
{
	GXmlCssSelectorType result;
#line 123 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 123 "../gxml/CssSelectorParser.vala"
	result = self->priv->_selector_type;
#line 123 "../gxml/CssSelectorParser.vala"
	return result;
#line 799 "CssSelectorParser.c"
}

void
gxml_css_selector_set_selector_type (GXmlCssSelector* self,
                                     GXmlCssSelectorType value)
{
	GXmlCssSelectorType old_value;
#line 123 "../gxml/CssSelectorParser.vala"
	g_return_if_fail (self != NULL);
#line 123 "../gxml/CssSelectorParser.vala"
	old_value = gxml_css_selector_get_selector_type (self);
#line 123 "../gxml/CssSelectorParser.vala"
	if (old_value != value) {
#line 123 "../gxml/CssSelectorParser.vala"
		self->priv->_selector_type = value;
#line 123 "../gxml/CssSelectorParser.vala"
		g_object_notify_by_pspec ((GObject *) self, gxml_css_selector_properties[GXML_CSS_SELECTOR_SELECTOR_TYPE_PROPERTY]);
#line 817 "CssSelectorParser.c"
	}
}

const gchar*
gxml_css_selector_get_name (GXmlCssSelector* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 125 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 125 "../gxml/CssSelectorParser.vala"
	_tmp0_ = self->priv->_name;
#line 125 "../gxml/CssSelectorParser.vala"
	result = _tmp0_;
#line 125 "../gxml/CssSelectorParser.vala"
	return result;
#line 834 "CssSelectorParser.c"
}

void
gxml_css_selector_set_name (GXmlCssSelector* self,
                            const gchar* value)
{
	gchar* old_value;
#line 125 "../gxml/CssSelectorParser.vala"
	g_return_if_fail (self != NULL);
#line 125 "../gxml/CssSelectorParser.vala"
	old_value = gxml_css_selector_get_name (self);
#line 125 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 848 "CssSelectorParser.c"
		gchar* _tmp0_;
#line 125 "../gxml/CssSelectorParser.vala"
		_tmp0_ = g_strdup (value);
#line 125 "../gxml/CssSelectorParser.vala"
		_g_free0 (self->priv->_name);
#line 125 "../gxml/CssSelectorParser.vala"
		self->priv->_name = _tmp0_;
#line 125 "../gxml/CssSelectorParser.vala"
		g_object_notify_by_pspec ((GObject *) self, gxml_css_selector_properties[GXML_CSS_SELECTOR_NAME_PROPERTY]);
#line 858 "CssSelectorParser.c"
	}
}

const gchar*
gxml_css_selector_get_value (GXmlCssSelector* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 127 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 127 "../gxml/CssSelectorParser.vala"
	_tmp0_ = self->priv->_value;
#line 127 "../gxml/CssSelectorParser.vala"
	result = _tmp0_;
#line 127 "../gxml/CssSelectorParser.vala"
	return result;
#line 875 "CssSelectorParser.c"
}

void
gxml_css_selector_set_value (GXmlCssSelector* self,
                             const gchar* value)
{
	gchar* old_value;
#line 127 "../gxml/CssSelectorParser.vala"
	g_return_if_fail (self != NULL);
#line 127 "../gxml/CssSelectorParser.vala"
	old_value = gxml_css_selector_get_value (self);
#line 127 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 889 "CssSelectorParser.c"
		gchar* _tmp0_;
#line 127 "../gxml/CssSelectorParser.vala"
		_tmp0_ = g_strdup (value);
#line 127 "../gxml/CssSelectorParser.vala"
		_g_free0 (self->priv->_value);
#line 127 "../gxml/CssSelectorParser.vala"
		self->priv->_value = _tmp0_;
#line 127 "../gxml/CssSelectorParser.vala"
		g_object_notify_by_pspec ((GObject *) self, gxml_css_selector_properties[GXML_CSS_SELECTOR_VALUE_PROPERTY]);
#line 899 "CssSelectorParser.c"
	}
}

GXmlCssCombiner
gxml_css_selector_get_combiner (GXmlCssSelector* self)
{
	GXmlCssCombiner result;
#line 129 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 129 "../gxml/CssSelectorParser.vala"
	result = self->priv->_combiner;
#line 129 "../gxml/CssSelectorParser.vala"
	return result;
#line 913 "CssSelectorParser.c"
}

void
gxml_css_selector_set_combiner (GXmlCssSelector* self,
                                GXmlCssCombiner value)
{
	GXmlCssCombiner old_value;
#line 129 "../gxml/CssSelectorParser.vala"
	g_return_if_fail (self != NULL);
#line 129 "../gxml/CssSelectorParser.vala"
	old_value = gxml_css_selector_get_combiner (self);
#line 129 "../gxml/CssSelectorParser.vala"
	if (old_value != value) {
#line 129 "../gxml/CssSelectorParser.vala"
		self->priv->_combiner = value;
#line 129 "../gxml/CssSelectorParser.vala"
		g_object_notify_by_pspec ((GObject *) self, gxml_css_selector_properties[GXML_CSS_SELECTOR_COMBINER_PROPERTY]);
#line 931 "CssSelectorParser.c"
	}
}

static void
gxml_css_selector_class_init (GXmlCssSelectorClass * klass,
                              gpointer klass_data)
{
#line 114 "../gxml/CssSelectorParser.vala"
	gxml_css_selector_parent_class = g_type_class_peek_parent (klass);
#line 114 "../gxml/CssSelectorParser.vala"
	g_type_class_adjust_private_offset (klass, &GXmlCssSelector_private_offset);
#line 114 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gxml_css_selector_get_property;
#line 114 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gxml_css_selector_set_property;
#line 114 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (klass)->finalize = gxml_css_selector_finalize;
#line 114 "../gxml/CssSelectorParser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_CSS_SELECTOR_SELECTOR_TYPE_PROPERTY, gxml_css_selector_properties[GXML_CSS_SELECTOR_SELECTOR_TYPE_PROPERTY] = g_param_spec_enum ("selector-type", "selector-type", "selector-type", GXML_TYPE_CSS_SELECTOR_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 114 "../gxml/CssSelectorParser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_CSS_SELECTOR_NAME_PROPERTY, gxml_css_selector_properties[GXML_CSS_SELECTOR_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 114 "../gxml/CssSelectorParser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_CSS_SELECTOR_VALUE_PROPERTY, gxml_css_selector_properties[GXML_CSS_SELECTOR_VALUE_PROPERTY] = g_param_spec_string ("value", "value", "value", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 114 "../gxml/CssSelectorParser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_CSS_SELECTOR_COMBINER_PROPERTY, gxml_css_selector_properties[GXML_CSS_SELECTOR_COMBINER_PROPERTY] = g_param_spec_enum ("combiner", "combiner", "combiner", GXML_TYPE_CSS_COMBINER, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 957 "CssSelectorParser.c"
}

static void
gxml_css_selector_instance_init (GXmlCssSelector * self,
                                 gpointer klass)
{
#line 114 "../gxml/CssSelectorParser.vala"
	self->priv = gxml_css_selector_get_instance_private (self);
#line 966 "CssSelectorParser.c"
}

static void
gxml_css_selector_finalize (GObject * obj)
{
	GXmlCssSelector * self;
#line 114 "../gxml/CssSelectorParser.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GXML_TYPE_CSS_SELECTOR, GXmlCssSelector);
#line 125 "../gxml/CssSelectorParser.vala"
	_g_free0 (self->priv->_name);
#line 127 "../gxml/CssSelectorParser.vala"
	_g_free0 (self->priv->_value);
#line 114 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (gxml_css_selector_parent_class)->finalize (obj);
#line 981 "CssSelectorParser.c"
}

/**
 * generic CSS selector, used by {@link GXml.CssSelectorParser}
 */
static GType
gxml_css_selector_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GXmlCssSelectorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_css_selector_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GXmlCssSelector), 0, (GInstanceInitFunc) gxml_css_selector_instance_init, NULL };
	GType gxml_css_selector_type_id;
	gxml_css_selector_type_id = g_type_register_static (G_TYPE_OBJECT, "GXmlCssSelector", &g_define_type_info, 0);
	GXmlCssSelector_private_offset = g_type_add_instance_private (gxml_css_selector_type_id, sizeof (GXmlCssSelectorPrivate));
	return gxml_css_selector_type_id;
}

GType
gxml_css_selector_get_type (void)
{
	static volatile gsize gxml_css_selector_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_css_selector_type_id__volatile)) {
		GType gxml_css_selector_type_id;
		gxml_css_selector_type_id = gxml_css_selector_get_type_once ();
		g_once_init_leave (&gxml_css_selector_type_id__volatile, gxml_css_selector_type_id);
	}
	return gxml_css_selector_type_id__volatile;
}

static void
_vala_gxml_css_selector_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	GXmlCssSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_CSS_SELECTOR, GXmlCssSelector);
#line 114 "../gxml/CssSelectorParser.vala"
	switch (property_id) {
#line 114 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_SELECTOR_SELECTOR_TYPE_PROPERTY:
#line 114 "../gxml/CssSelectorParser.vala"
		g_value_set_enum (value, gxml_css_selector_get_selector_type (self));
#line 114 "../gxml/CssSelectorParser.vala"
		break;
#line 114 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_SELECTOR_NAME_PROPERTY:
#line 114 "../gxml/CssSelectorParser.vala"
		g_value_set_string (value, gxml_css_selector_get_name (self));
#line 114 "../gxml/CssSelectorParser.vala"
		break;
#line 114 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_SELECTOR_VALUE_PROPERTY:
#line 114 "../gxml/CssSelectorParser.vala"
		g_value_set_string (value, gxml_css_selector_get_value (self));
#line 114 "../gxml/CssSelectorParser.vala"
		break;
#line 114 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_SELECTOR_COMBINER_PROPERTY:
#line 114 "../gxml/CssSelectorParser.vala"
		g_value_set_enum (value, gxml_css_selector_get_combiner (self));
#line 114 "../gxml/CssSelectorParser.vala"
		break;
#line 1043 "CssSelectorParser.c"
		default:
#line 114 "../gxml/CssSelectorParser.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 114 "../gxml/CssSelectorParser.vala"
		break;
#line 1049 "CssSelectorParser.c"
	}
}

static void
_vala_gxml_css_selector_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	GXmlCssSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_CSS_SELECTOR, GXmlCssSelector);
#line 114 "../gxml/CssSelectorParser.vala"
	switch (property_id) {
#line 114 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_SELECTOR_SELECTOR_TYPE_PROPERTY:
#line 114 "../gxml/CssSelectorParser.vala"
		gxml_css_selector_set_selector_type (self, g_value_get_enum (value));
#line 114 "../gxml/CssSelectorParser.vala"
		break;
#line 114 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_SELECTOR_NAME_PROPERTY:
#line 114 "../gxml/CssSelectorParser.vala"
		gxml_css_selector_set_name (self, g_value_get_string (value));
#line 114 "../gxml/CssSelectorParser.vala"
		break;
#line 114 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_SELECTOR_VALUE_PROPERTY:
#line 114 "../gxml/CssSelectorParser.vala"
		gxml_css_selector_set_value (self, g_value_get_string (value));
#line 114 "../gxml/CssSelectorParser.vala"
		break;
#line 114 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_SELECTOR_COMBINER_PROPERTY:
#line 114 "../gxml/CssSelectorParser.vala"
		gxml_css_selector_set_combiner (self, g_value_get_enum (value));
#line 114 "../gxml/CssSelectorParser.vala"
		break;
#line 1087 "CssSelectorParser.c"
		default:
#line 114 "../gxml/CssSelectorParser.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 114 "../gxml/CssSelectorParser.vala"
		break;
#line 1093 "CssSelectorParser.c"
	}
}

GXmlCssElementSelector*
gxml_css_element_selector_construct (GType object_type,
                                     const gchar* prefix,
                                     const gchar* local_name)
{
	GXmlCssElementSelector * self = NULL;
#line 135 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (local_name != NULL, NULL);
#line 136 "../gxml/CssSelectorParser.vala"
	self = (GXmlCssElementSelector*) gxml_css_selector_construct (object_type, GXML_CSS_SELECTOR_TYPE_ELEMENT, "");
#line 137 "../gxml/CssSelectorParser.vala"
	gxml_css_selector_set_name ((GXmlCssSelector*) self, prefix);
#line 138 "../gxml/CssSelectorParser.vala"
	gxml_css_selector_set_value ((GXmlCssSelector*) self, local_name);
#line 135 "../gxml/CssSelectorParser.vala"
	return self;
#line 1113 "CssSelectorParser.c"
}

GXmlCssElementSelector*
gxml_css_element_selector_new (const gchar* prefix,
                               const gchar* local_name)
{
#line 135 "../gxml/CssSelectorParser.vala"
	return gxml_css_element_selector_construct (GXML_TYPE_CSS_ELEMENT_SELECTOR, prefix, local_name);
#line 1122 "CssSelectorParser.c"
}

gboolean
gxml_css_element_selector_get_prefixed (GXmlCssElementSelector* self)
{
	gboolean result;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
#line 142 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 143 "../gxml/CssSelectorParser.vala"
	_tmp0_ = gxml_css_element_selector_get_prefix (self);
#line 143 "../gxml/CssSelectorParser.vala"
	_tmp1_ = _tmp0_;
#line 143 "../gxml/CssSelectorParser.vala"
	_tmp2_ = _tmp1_;
#line 143 "../gxml/CssSelectorParser.vala"
	_tmp3_ = _tmp2_ != NULL;
#line 143 "../gxml/CssSelectorParser.vala"
	_g_free0 (_tmp2_);
#line 143 "../gxml/CssSelectorParser.vala"
	result = _tmp3_;
#line 143 "../gxml/CssSelectorParser.vala"
	return result;
#line 1149 "CssSelectorParser.c"
}

gchar*
gxml_css_element_selector_get_prefix (GXmlCssElementSelector* self)
{
	gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
#line 148 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 149 "../gxml/CssSelectorParser.vala"
	_tmp0_ = gxml_css_selector_get_name ((GXmlCssSelector*) self);
#line 149 "../gxml/CssSelectorParser.vala"
	_tmp1_ = _tmp0_;
#line 149 "../gxml/CssSelectorParser.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 149 "../gxml/CssSelectorParser.vala"
	result = _tmp2_;
#line 149 "../gxml/CssSelectorParser.vala"
	return result;
#line 1171 "CssSelectorParser.c"
}

void
gxml_css_element_selector_set_prefix (GXmlCssElementSelector* self,
                                      const gchar* value)
{
#line 151 "../gxml/CssSelectorParser.vala"
	g_return_if_fail (self != NULL);
#line 152 "../gxml/CssSelectorParser.vala"
	gxml_css_selector_set_name ((GXmlCssSelector*) self, value);
#line 151 "../gxml/CssSelectorParser.vala"
	g_object_notify_by_pspec ((GObject *) self, gxml_css_element_selector_properties[GXML_CSS_ELEMENT_SELECTOR_PREFIX_PROPERTY]);
#line 1184 "CssSelectorParser.c"
}

gchar*
gxml_css_element_selector_get_local_name (GXmlCssElementSelector* self)
{
	gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
#line 157 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 158 "../gxml/CssSelectorParser.vala"
	_tmp0_ = gxml_css_selector_get_value ((GXmlCssSelector*) self);
#line 158 "../gxml/CssSelectorParser.vala"
	_tmp1_ = _tmp0_;
#line 158 "../gxml/CssSelectorParser.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 158 "../gxml/CssSelectorParser.vala"
	result = _tmp2_;
#line 158 "../gxml/CssSelectorParser.vala"
	return result;
#line 1206 "CssSelectorParser.c"
}

void
gxml_css_element_selector_set_local_name (GXmlCssElementSelector* self,
                                          const gchar* value)
{
#line 160 "../gxml/CssSelectorParser.vala"
	g_return_if_fail (self != NULL);
#line 161 "../gxml/CssSelectorParser.vala"
	gxml_css_selector_set_value ((GXmlCssSelector*) self, value);
#line 160 "../gxml/CssSelectorParser.vala"
	g_object_notify_by_pspec ((GObject *) self, gxml_css_element_selector_properties[GXML_CSS_ELEMENT_SELECTOR_LOCAL_NAME_PROPERTY]);
#line 1219 "CssSelectorParser.c"
}

static void
gxml_css_element_selector_class_init (GXmlCssElementSelectorClass * klass,
                                      gpointer klass_data)
{
#line 134 "../gxml/CssSelectorParser.vala"
	gxml_css_element_selector_parent_class = g_type_class_peek_parent (klass);
#line 134 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gxml_css_element_selector_get_property;
#line 134 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gxml_css_element_selector_set_property;
#line 134 "../gxml/CssSelectorParser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_CSS_ELEMENT_SELECTOR_PREFIXED_PROPERTY, gxml_css_element_selector_properties[GXML_CSS_ELEMENT_SELECTOR_PREFIXED_PROPERTY] = g_param_spec_boolean ("prefixed", "prefixed", "prefixed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 134 "../gxml/CssSelectorParser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_CSS_ELEMENT_SELECTOR_PREFIX_PROPERTY, gxml_css_element_selector_properties[GXML_CSS_ELEMENT_SELECTOR_PREFIX_PROPERTY] = g_param_spec_string ("prefix", "prefix", "prefix", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 134 "../gxml/CssSelectorParser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_CSS_ELEMENT_SELECTOR_LOCAL_NAME_PROPERTY, gxml_css_element_selector_properties[GXML_CSS_ELEMENT_SELECTOR_LOCAL_NAME_PROPERTY] = g_param_spec_string ("local-name", "local-name", "local-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1238 "CssSelectorParser.c"
}

static void
gxml_css_element_selector_instance_init (GXmlCssElementSelector * self,
                                         gpointer klass)
{
}

/**
 * CssSelector for elements
 */
static GType
gxml_css_element_selector_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GXmlCssElementSelectorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_css_element_selector_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GXmlCssElementSelector), 0, (GInstanceInitFunc) gxml_css_element_selector_instance_init, NULL };
	GType gxml_css_element_selector_type_id;
	gxml_css_element_selector_type_id = g_type_register_static (GXML_TYPE_CSS_SELECTOR, "GXmlCssElementSelector", &g_define_type_info, 0);
	return gxml_css_element_selector_type_id;
}

GType
gxml_css_element_selector_get_type (void)
{
	static volatile gsize gxml_css_element_selector_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_css_element_selector_type_id__volatile)) {
		GType gxml_css_element_selector_type_id;
		gxml_css_element_selector_type_id = gxml_css_element_selector_get_type_once ();
		g_once_init_leave (&gxml_css_element_selector_type_id__volatile, gxml_css_element_selector_type_id);
	}
	return gxml_css_element_selector_type_id__volatile;
}

static void
_vala_gxml_css_element_selector_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	GXmlCssElementSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_CSS_ELEMENT_SELECTOR, GXmlCssElementSelector);
#line 134 "../gxml/CssSelectorParser.vala"
	switch (property_id) {
#line 134 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_ELEMENT_SELECTOR_PREFIXED_PROPERTY:
#line 134 "../gxml/CssSelectorParser.vala"
		g_value_set_boolean (value, gxml_css_element_selector_get_prefixed (self));
#line 134 "../gxml/CssSelectorParser.vala"
		break;
#line 134 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_ELEMENT_SELECTOR_PREFIX_PROPERTY:
#line 134 "../gxml/CssSelectorParser.vala"
		g_value_take_string (value, gxml_css_element_selector_get_prefix (self));
#line 134 "../gxml/CssSelectorParser.vala"
		break;
#line 134 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_ELEMENT_SELECTOR_LOCAL_NAME_PROPERTY:
#line 134 "../gxml/CssSelectorParser.vala"
		g_value_take_string (value, gxml_css_element_selector_get_local_name (self));
#line 134 "../gxml/CssSelectorParser.vala"
		break;
#line 1299 "CssSelectorParser.c"
		default:
#line 134 "../gxml/CssSelectorParser.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 134 "../gxml/CssSelectorParser.vala"
		break;
#line 1305 "CssSelectorParser.c"
	}
}

static void
_vala_gxml_css_element_selector_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	GXmlCssElementSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_CSS_ELEMENT_SELECTOR, GXmlCssElementSelector);
#line 134 "../gxml/CssSelectorParser.vala"
	switch (property_id) {
#line 134 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_ELEMENT_SELECTOR_PREFIX_PROPERTY:
#line 134 "../gxml/CssSelectorParser.vala"
		gxml_css_element_selector_set_prefix (self, g_value_get_string (value));
#line 134 "../gxml/CssSelectorParser.vala"
		break;
#line 134 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_ELEMENT_SELECTOR_LOCAL_NAME_PROPERTY:
#line 134 "../gxml/CssSelectorParser.vala"
		gxml_css_element_selector_set_local_name (self, g_value_get_string (value));
#line 134 "../gxml/CssSelectorParser.vala"
		break;
#line 1331 "CssSelectorParser.c"
		default:
#line 134 "../gxml/CssSelectorParser.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 134 "../gxml/CssSelectorParser.vala"
		break;
#line 1337 "CssSelectorParser.c"
	}
}

static inline gpointer
gxml_css_attribute_selector_get_instance_private (GXmlCssAttributeSelector* self)
{
	return G_STRUCT_MEMBER_P (self, GXmlCssAttributeSelector_private_offset);
}

GXmlCssAttributeSelector*
gxml_css_attribute_selector_construct (GType object_type,
                                       const gchar* prefix,
                                       const gchar* local_name)
{
	GXmlCssAttributeSelector * self = NULL;
	gchar* _tmp0_ = NULL;
#line 169 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (local_name != NULL, NULL);
#line 170 "../gxml/CssSelectorParser.vala"
	self = (GXmlCssAttributeSelector*) gxml_css_selector_construct (object_type, GXML_CSS_SELECTOR_TYPE_ATTRIBUTE, "");
#line 171 "../gxml/CssSelectorParser.vala"
	gxml_css_attribute_selector_set_prefix (self, prefix);
#line 172 "../gxml/CssSelectorParser.vala"
	gxml_css_attribute_selector_set_local_name (self, local_name);
#line 173 "../gxml/CssSelectorParser.vala"
	if (prefix == NULL) {
#line 1364 "CssSelectorParser.c"
		gchar* _tmp1_;
#line 173 "../gxml/CssSelectorParser.vala"
		_tmp1_ = g_strdup (local_name);
#line 173 "../gxml/CssSelectorParser.vala"
		_g_free0 (_tmp0_);
#line 173 "../gxml/CssSelectorParser.vala"
		_tmp0_ = _tmp1_;
#line 1372 "CssSelectorParser.c"
	} else {
		gchar* _tmp2_;
#line 173 "../gxml/CssSelectorParser.vala"
		_tmp2_ = g_strdup_printf ("%s|%s", prefix, local_name);
#line 173 "../gxml/CssSelectorParser.vala"
		_g_free0 (_tmp0_);
#line 173 "../gxml/CssSelectorParser.vala"
		_tmp0_ = _tmp2_;
#line 1381 "CssSelectorParser.c"
	}
#line 173 "../gxml/CssSelectorParser.vala"
	gxml_css_selector_set_name ((GXmlCssSelector*) self, _tmp0_);
#line 169 "../gxml/CssSelectorParser.vala"
	_g_free0 (_tmp0_);
#line 169 "../gxml/CssSelectorParser.vala"
	return self;
#line 1389 "CssSelectorParser.c"
}

GXmlCssAttributeSelector*
gxml_css_attribute_selector_new (const gchar* prefix,
                                 const gchar* local_name)
{
#line 169 "../gxml/CssSelectorParser.vala"
	return gxml_css_attribute_selector_construct (GXML_TYPE_CSS_ATTRIBUTE_SELECTOR, prefix, local_name);
#line 1398 "CssSelectorParser.c"
}

const gchar*
gxml_css_attribute_selector_get_prefix (GXmlCssAttributeSelector* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 176 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 176 "../gxml/CssSelectorParser.vala"
	_tmp0_ = self->priv->_prefix;
#line 176 "../gxml/CssSelectorParser.vala"
	result = _tmp0_;
#line 176 "../gxml/CssSelectorParser.vala"
	return result;
#line 1414 "CssSelectorParser.c"
}

void
gxml_css_attribute_selector_set_prefix (GXmlCssAttributeSelector* self,
                                        const gchar* value)
{
	gchar* old_value;
#line 176 "../gxml/CssSelectorParser.vala"
	g_return_if_fail (self != NULL);
#line 176 "../gxml/CssSelectorParser.vala"
	old_value = gxml_css_attribute_selector_get_prefix (self);
#line 176 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1428 "CssSelectorParser.c"
		gchar* _tmp0_;
#line 176 "../gxml/CssSelectorParser.vala"
		_tmp0_ = g_strdup (value);
#line 176 "../gxml/CssSelectorParser.vala"
		_g_free0 (self->priv->_prefix);
#line 176 "../gxml/CssSelectorParser.vala"
		self->priv->_prefix = _tmp0_;
#line 176 "../gxml/CssSelectorParser.vala"
		g_object_notify_by_pspec ((GObject *) self, gxml_css_attribute_selector_properties[GXML_CSS_ATTRIBUTE_SELECTOR_PREFIX_PROPERTY]);
#line 1438 "CssSelectorParser.c"
	}
}

const gchar*
gxml_css_attribute_selector_get_local_name (GXmlCssAttributeSelector* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 178 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 178 "../gxml/CssSelectorParser.vala"
	_tmp0_ = self->priv->_local_name;
#line 178 "../gxml/CssSelectorParser.vala"
	result = _tmp0_;
#line 178 "../gxml/CssSelectorParser.vala"
	return result;
#line 1455 "CssSelectorParser.c"
}

void
gxml_css_attribute_selector_set_local_name (GXmlCssAttributeSelector* self,
                                            const gchar* value)
{
	gchar* old_value;
#line 178 "../gxml/CssSelectorParser.vala"
	g_return_if_fail (self != NULL);
#line 178 "../gxml/CssSelectorParser.vala"
	old_value = gxml_css_attribute_selector_get_local_name (self);
#line 178 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1469 "CssSelectorParser.c"
		gchar* _tmp0_;
#line 178 "../gxml/CssSelectorParser.vala"
		_tmp0_ = g_strdup (value);
#line 178 "../gxml/CssSelectorParser.vala"
		_g_free0 (self->priv->_local_name);
#line 178 "../gxml/CssSelectorParser.vala"
		self->priv->_local_name = _tmp0_;
#line 178 "../gxml/CssSelectorParser.vala"
		g_object_notify_by_pspec ((GObject *) self, gxml_css_attribute_selector_properties[GXML_CSS_ATTRIBUTE_SELECTOR_LOCAL_NAME_PROPERTY]);
#line 1479 "CssSelectorParser.c"
	}
}

static void
gxml_css_attribute_selector_class_init (GXmlCssAttributeSelectorClass * klass,
                                        gpointer klass_data)
{
#line 168 "../gxml/CssSelectorParser.vala"
	gxml_css_attribute_selector_parent_class = g_type_class_peek_parent (klass);
#line 168 "../gxml/CssSelectorParser.vala"
	g_type_class_adjust_private_offset (klass, &GXmlCssAttributeSelector_private_offset);
#line 168 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gxml_css_attribute_selector_get_property;
#line 168 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gxml_css_attribute_selector_set_property;
#line 168 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (klass)->finalize = gxml_css_attribute_selector_finalize;
#line 168 "../gxml/CssSelectorParser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_CSS_ATTRIBUTE_SELECTOR_PREFIX_PROPERTY, gxml_css_attribute_selector_properties[GXML_CSS_ATTRIBUTE_SELECTOR_PREFIX_PROPERTY] = g_param_spec_string ("prefix", "prefix", "prefix", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 168 "../gxml/CssSelectorParser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_CSS_ATTRIBUTE_SELECTOR_LOCAL_NAME_PROPERTY, gxml_css_attribute_selector_properties[GXML_CSS_ATTRIBUTE_SELECTOR_LOCAL_NAME_PROPERTY] = g_param_spec_string ("local-name", "local-name", "local-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1501 "CssSelectorParser.c"
}

static void
gxml_css_attribute_selector_instance_init (GXmlCssAttributeSelector * self,
                                           gpointer klass)
{
#line 168 "../gxml/CssSelectorParser.vala"
	self->priv = gxml_css_attribute_selector_get_instance_private (self);
#line 1510 "CssSelectorParser.c"
}

static void
gxml_css_attribute_selector_finalize (GObject * obj)
{
	GXmlCssAttributeSelector * self;
#line 168 "../gxml/CssSelectorParser.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GXML_TYPE_CSS_ATTRIBUTE_SELECTOR, GXmlCssAttributeSelector);
#line 176 "../gxml/CssSelectorParser.vala"
	_g_free0 (self->priv->_prefix);
#line 178 "../gxml/CssSelectorParser.vala"
	_g_free0 (self->priv->_local_name);
#line 168 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (gxml_css_attribute_selector_parent_class)->finalize (obj);
#line 1525 "CssSelectorParser.c"
}

/**
 * CssSelector for attributes
 */
static GType
gxml_css_attribute_selector_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GXmlCssAttributeSelectorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_css_attribute_selector_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GXmlCssAttributeSelector), 0, (GInstanceInitFunc) gxml_css_attribute_selector_instance_init, NULL };
	GType gxml_css_attribute_selector_type_id;
	gxml_css_attribute_selector_type_id = g_type_register_static (GXML_TYPE_CSS_SELECTOR, "GXmlCssAttributeSelector", &g_define_type_info, 0);
	GXmlCssAttributeSelector_private_offset = g_type_add_instance_private (gxml_css_attribute_selector_type_id, sizeof (GXmlCssAttributeSelectorPrivate));
	return gxml_css_attribute_selector_type_id;
}

GType
gxml_css_attribute_selector_get_type (void)
{
	static volatile gsize gxml_css_attribute_selector_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_css_attribute_selector_type_id__volatile)) {
		GType gxml_css_attribute_selector_type_id;
		gxml_css_attribute_selector_type_id = gxml_css_attribute_selector_get_type_once ();
		g_once_init_leave (&gxml_css_attribute_selector_type_id__volatile, gxml_css_attribute_selector_type_id);
	}
	return gxml_css_attribute_selector_type_id__volatile;
}

static void
_vala_gxml_css_attribute_selector_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	GXmlCssAttributeSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_CSS_ATTRIBUTE_SELECTOR, GXmlCssAttributeSelector);
#line 168 "../gxml/CssSelectorParser.vala"
	switch (property_id) {
#line 168 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_ATTRIBUTE_SELECTOR_PREFIX_PROPERTY:
#line 168 "../gxml/CssSelectorParser.vala"
		g_value_set_string (value, gxml_css_attribute_selector_get_prefix (self));
#line 168 "../gxml/CssSelectorParser.vala"
		break;
#line 168 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_ATTRIBUTE_SELECTOR_LOCAL_NAME_PROPERTY:
#line 168 "../gxml/CssSelectorParser.vala"
		g_value_set_string (value, gxml_css_attribute_selector_get_local_name (self));
#line 168 "../gxml/CssSelectorParser.vala"
		break;
#line 1575 "CssSelectorParser.c"
		default:
#line 168 "../gxml/CssSelectorParser.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 168 "../gxml/CssSelectorParser.vala"
		break;
#line 1581 "CssSelectorParser.c"
	}
}

static void
_vala_gxml_css_attribute_selector_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	GXmlCssAttributeSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_CSS_ATTRIBUTE_SELECTOR, GXmlCssAttributeSelector);
#line 168 "../gxml/CssSelectorParser.vala"
	switch (property_id) {
#line 168 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_ATTRIBUTE_SELECTOR_PREFIX_PROPERTY:
#line 168 "../gxml/CssSelectorParser.vala"
		gxml_css_attribute_selector_set_prefix (self, g_value_get_string (value));
#line 168 "../gxml/CssSelectorParser.vala"
		break;
#line 168 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_ATTRIBUTE_SELECTOR_LOCAL_NAME_PROPERTY:
#line 168 "../gxml/CssSelectorParser.vala"
		gxml_css_attribute_selector_set_local_name (self, g_value_get_string (value));
#line 168 "../gxml/CssSelectorParser.vala"
		break;
#line 1607 "CssSelectorParser.c"
		default:
#line 168 "../gxml/CssSelectorParser.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 168 "../gxml/CssSelectorParser.vala"
		break;
#line 1613 "CssSelectorParser.c"
	}
}

static inline gpointer
gxml_css_not_selector_get_instance_private (GXmlCssNotSelector* self)
{
	return G_STRUCT_MEMBER_P (self, GXmlCssNotSelector_private_offset);
}

GXmlCssNotSelector*
gxml_css_not_selector_construct (GType object_type)
{
	GXmlCssNotSelector * self = NULL;
#line 185 "../gxml/CssSelectorParser.vala"
	self = (GXmlCssNotSelector*) g_object_new (object_type, "selector-type", GXML_CSS_SELECTOR_TYPE_PSEUDO_CLASS, "name", "not", NULL);
#line 184 "../gxml/CssSelectorParser.vala"
	return self;
#line 1631 "CssSelectorParser.c"
}

GXmlCssNotSelector*
gxml_css_not_selector_new (void)
{
#line 184 "../gxml/CssSelectorParser.vala"
	return gxml_css_not_selector_construct (GXML_TYPE_CSS_NOT_SELECTOR);
#line 1639 "CssSelectorParser.c"
}

GeeList*
gxml_css_not_selector_get_selectors (GXmlCssNotSelector* self)
{
	GeeList* result;
	GeeArrayList* _tmp0_;
#line 199 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 200 "../gxml/CssSelectorParser.vala"
	_tmp0_ = self->priv->list;
#line 200 "../gxml/CssSelectorParser.vala"
	result = (GeeList*) _tmp0_;
#line 200 "../gxml/CssSelectorParser.vala"
	return result;
#line 1655 "CssSelectorParser.c"
}

static GObject *
gxml_css_not_selector_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GXmlCssNotSelector * self;
	GeeArrayList* _tmp0_;
#line 190 "../gxml/CssSelectorParser.vala"
	parent_class = G_OBJECT_CLASS (gxml_css_not_selector_parent_class);
#line 190 "../gxml/CssSelectorParser.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 190 "../gxml/CssSelectorParser.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GXML_TYPE_CSS_NOT_SELECTOR, GXmlCssNotSelector);
#line 191 "../gxml/CssSelectorParser.vala"
	_tmp0_ = gee_array_list_new (GXML_TYPE_CSS_SELECTOR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 191 "../gxml/CssSelectorParser.vala"
	_g_object_unref0 (self->priv->list);
#line 191 "../gxml/CssSelectorParser.vala"
	self->priv->list = _tmp0_;
#line 190 "../gxml/CssSelectorParser.vala"
	return obj;
#line 1681 "CssSelectorParser.c"
}

static void
gxml_css_not_selector_class_init (GXmlCssNotSelectorClass * klass,
                                  gpointer klass_data)
{
#line 183 "../gxml/CssSelectorParser.vala"
	gxml_css_not_selector_parent_class = g_type_class_peek_parent (klass);
#line 183 "../gxml/CssSelectorParser.vala"
	g_type_class_adjust_private_offset (klass, &GXmlCssNotSelector_private_offset);
#line 183 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gxml_css_not_selector_get_property;
#line 183 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (klass)->constructor = gxml_css_not_selector_constructor;
#line 183 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (klass)->finalize = gxml_css_not_selector_finalize;
#line 1698 "CssSelectorParser.c"
	/**
	 * a list of {@link GXml.CssSelector} that shouldn't match as a
	 * {@link Gee.List} of {@link GXml.CssSelector}
	 */
#line 183 "../gxml/CssSelectorParser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_CSS_NOT_SELECTOR_SELECTORS_PROPERTY, gxml_css_not_selector_properties[GXML_CSS_NOT_SELECTOR_SELECTORS_PROPERTY] = g_param_spec_object ("selectors", "selectors", "selectors", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1705 "CssSelectorParser.c"
}

static void
gxml_css_not_selector_instance_init (GXmlCssNotSelector * self,
                                     gpointer klass)
{
#line 183 "../gxml/CssSelectorParser.vala"
	self->priv = gxml_css_not_selector_get_instance_private (self);
#line 1714 "CssSelectorParser.c"
}

static void
gxml_css_not_selector_finalize (GObject * obj)
{
	GXmlCssNotSelector * self;
#line 183 "../gxml/CssSelectorParser.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GXML_TYPE_CSS_NOT_SELECTOR, GXmlCssNotSelector);
#line 188 "../gxml/CssSelectorParser.vala"
	_g_object_unref0 (self->priv->list);
#line 183 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (gxml_css_not_selector_parent_class)->finalize (obj);
#line 1727 "CssSelectorParser.c"
}

/**
 * CssSelector for 'not' pseudo class 
 */
static GType
gxml_css_not_selector_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GXmlCssNotSelectorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_css_not_selector_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GXmlCssNotSelector), 0, (GInstanceInitFunc) gxml_css_not_selector_instance_init, NULL };
	GType gxml_css_not_selector_type_id;
	gxml_css_not_selector_type_id = g_type_register_static (GXML_TYPE_CSS_SELECTOR, "GXmlCssNotSelector", &g_define_type_info, 0);
	GXmlCssNotSelector_private_offset = g_type_add_instance_private (gxml_css_not_selector_type_id, sizeof (GXmlCssNotSelectorPrivate));
	return gxml_css_not_selector_type_id;
}

GType
gxml_css_not_selector_get_type (void)
{
	static volatile gsize gxml_css_not_selector_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_css_not_selector_type_id__volatile)) {
		GType gxml_css_not_selector_type_id;
		gxml_css_not_selector_type_id = gxml_css_not_selector_get_type_once ();
		g_once_init_leave (&gxml_css_not_selector_type_id__volatile, gxml_css_not_selector_type_id);
	}
	return gxml_css_not_selector_type_id__volatile;
}

static void
_vala_gxml_css_not_selector_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	GXmlCssNotSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_CSS_NOT_SELECTOR, GXmlCssNotSelector);
#line 183 "../gxml/CssSelectorParser.vala"
	switch (property_id) {
#line 183 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_NOT_SELECTOR_SELECTORS_PROPERTY:
#line 183 "../gxml/CssSelectorParser.vala"
		g_value_set_object (value, gxml_css_not_selector_get_selectors (self));
#line 183 "../gxml/CssSelectorParser.vala"
		break;
#line 1771 "CssSelectorParser.c"
		default:
#line 183 "../gxml/CssSelectorParser.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 183 "../gxml/CssSelectorParser.vala"
		break;
#line 1777 "CssSelectorParser.c"
	}
}

static inline gpointer
gxml_css_selector_parser_get_instance_private (GXmlCssSelectorParser* self)
{
	return G_STRUCT_MEMBER_P (self, GXmlCssSelectorParser_private_offset);
}

static gboolean
_vala_unichar_array_contains (gunichar * stack,
                              gssize stack_length,
                              const gunichar needle)
{
	gssize i;
#line 216 "../gxml/CssSelectorParser.vala"
	for (i = 0; i < stack_length; i++) {
#line 216 "../gxml/CssSelectorParser.vala"
		if (needle == stack[i]) {
#line 216 "../gxml/CssSelectorParser.vala"
			return TRUE;
#line 1799 "CssSelectorParser.c"
		}
	}
#line 216 "../gxml/CssSelectorParser.vala"
	return FALSE;
#line 1804 "CssSelectorParser.c"
}

static gboolean
gxml_css_selector_parser_is_valid_char (gunichar u)
{
	gunichar* array = NULL;
	gunichar* _tmp0_;
	gint array_length1;
	gint _array_size_;
	gboolean result = FALSE;
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_ = g_new0 (gunichar, 25);
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[0] = (gunichar) '=';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[1] = (gunichar) '[';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[2] = (gunichar) ']';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[3] = (gunichar) '{';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[4] = (gunichar) '}';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[5] = (gunichar) '$';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[6] = (gunichar) '&';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[7] = (gunichar) '#';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[8] = (gunichar) '|';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[9] = (gunichar) '`';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[10] = (gunichar) '^';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[11] = (gunichar) '@';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[12] = (gunichar) '+';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[13] = (gunichar) '~';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[14] = (gunichar) '*';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[15] = (gunichar) '%';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[16] = (gunichar) '!';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[17] = (gunichar) '?';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[18] = (gunichar) '<';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[19] = (gunichar) '>';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[20] = (gunichar) ':';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[21] = (gunichar) '.';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[22] = (gunichar) '"';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[23] = (gunichar) '\'';
#line 209 "../gxml/CssSelectorParser.vala"
	_tmp0_[24] = (gunichar) ',';
#line 209 "../gxml/CssSelectorParser.vala"
	array = _tmp0_;
#line 209 "../gxml/CssSelectorParser.vala"
	array_length1 = 25;
#line 209 "../gxml/CssSelectorParser.vala"
	_array_size_ = array_length1;
#line 216 "../gxml/CssSelectorParser.vala"
	result = !_vala_unichar_array_contains (array, array_length1, u);
#line 216 "../gxml/CssSelectorParser.vala"
	array = (g_free (array), NULL);
#line 216 "../gxml/CssSelectorParser.vala"
	return result;
#line 1879 "CssSelectorParser.c"
}

static gchar*
gxml_css_selector_parser_parse_identifier (GXmlCssString* str,
                                           GXmlCssStringFunc func,
                                           gpointer func_target)
{
	GString* builder = NULL;
	GString* _tmp0_;
	GString* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result = NULL;
#line 219 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 220 "../gxml/CssSelectorParser.vala"
	_tmp0_ = g_string_new ("");
#line 220 "../gxml/CssSelectorParser.vala"
	builder = _tmp0_;
#line 221 "../gxml/CssSelectorParser.vala"
	while (TRUE) {
#line 1901 "CssSelectorParser.c"
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_;
		gboolean _tmp3_;
		GString* _tmp4_;
#line 221 "../gxml/CssSelectorParser.vala"
		_tmp2_ = gxml_css_string_get_eof (str);
#line 221 "../gxml/CssSelectorParser.vala"
		_tmp3_ = _tmp2_;
#line 221 "../gxml/CssSelectorParser.vala"
		if (!_tmp3_) {
#line 221 "../gxml/CssSelectorParser.vala"
			_tmp1_ = func (str, func_target);
#line 1914 "CssSelectorParser.c"
		} else {
#line 221 "../gxml/CssSelectorParser.vala"
			_tmp1_ = FALSE;
#line 1918 "CssSelectorParser.c"
		}
#line 221 "../gxml/CssSelectorParser.vala"
		if (!_tmp1_) {
#line 221 "../gxml/CssSelectorParser.vala"
			break;
#line 1924 "CssSelectorParser.c"
		}
#line 222 "../gxml/CssSelectorParser.vala"
		_tmp4_ = builder;
#line 222 "../gxml/CssSelectorParser.vala"
		g_string_append_unichar (_tmp4_, gxml_css_string_read (str));
#line 1930 "CssSelectorParser.c"
	}
#line 223 "../gxml/CssSelectorParser.vala"
	_tmp5_ = builder;
#line 223 "../gxml/CssSelectorParser.vala"
	_tmp6_ = _tmp5_->str;
#line 223 "../gxml/CssSelectorParser.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 223 "../gxml/CssSelectorParser.vala"
	result = _tmp7_;
#line 223 "../gxml/CssSelectorParser.vala"
	_g_string_free0 (builder);
#line 223 "../gxml/CssSelectorParser.vala"
	return result;
#line 1944 "CssSelectorParser.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 1963 "CssSelectorParser.c"
}

static GXmlCssSelector*
gxml_css_selector_parser_parse_element (GXmlCssString* str,
                                        GError** error)
{
	GString* builder = NULL;
	GString* _tmp0_;
	GString* extra_builder = NULL;
	GString* _tmp1_;
	gboolean _tmp8_ = FALSE;
	GString* _tmp9_;
	const gchar* _tmp10_;
	GString* _tmp31_;
	GString* _tmp33_;
	const gchar* _tmp34_;
	GXmlCssElementSelector* _tmp35_;
	GError* _inner_error0_ = NULL;
	GXmlCssSelector* result = NULL;
#line 226 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 227 "../gxml/CssSelectorParser.vala"
	_tmp0_ = g_string_new ("");
#line 227 "../gxml/CssSelectorParser.vala"
	builder = _tmp0_;
#line 228 "../gxml/CssSelectorParser.vala"
	_tmp1_ = g_string_new ("");
#line 228 "../gxml/CssSelectorParser.vala"
	extra_builder = _tmp1_;
#line 229 "../gxml/CssSelectorParser.vala"
	while (TRUE) {
#line 1995 "CssSelectorParser.c"
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_;
		gboolean _tmp5_;
		GString* _tmp7_;
#line 229 "../gxml/CssSelectorParser.vala"
		_tmp4_ = gxml_css_string_get_eof (str);
#line 229 "../gxml/CssSelectorParser.vala"
		_tmp5_ = _tmp4_;
#line 229 "../gxml/CssSelectorParser.vala"
		if (!_tmp5_) {
#line 2007 "CssSelectorParser.c"
			gboolean _tmp6_ = FALSE;
#line 229 "../gxml/CssSelectorParser.vala"
			if (gxml_css_string_peek (str) == ((gunichar) '*')) {
#line 229 "../gxml/CssSelectorParser.vala"
				_tmp6_ = TRUE;
#line 2013 "CssSelectorParser.c"
			} else {
#line 229 "../gxml/CssSelectorParser.vala"
				_tmp6_ = gxml_css_selector_parser_is_valid_char (gxml_css_string_peek (str));
#line 2017 "CssSelectorParser.c"
			}
#line 229 "../gxml/CssSelectorParser.vala"
			_tmp3_ = _tmp6_;
#line 2021 "CssSelectorParser.c"
		} else {
#line 229 "../gxml/CssSelectorParser.vala"
			_tmp3_ = FALSE;
#line 2025 "CssSelectorParser.c"
		}
#line 229 "../gxml/CssSelectorParser.vala"
		if (_tmp3_) {
#line 229 "../gxml/CssSelectorParser.vala"
			_tmp2_ = !g_unichar_isspace (gxml_css_string_peek (str));
#line 2031 "CssSelectorParser.c"
		} else {
#line 229 "../gxml/CssSelectorParser.vala"
			_tmp2_ = FALSE;
#line 2035 "CssSelectorParser.c"
		}
#line 229 "../gxml/CssSelectorParser.vala"
		if (!_tmp2_) {
#line 229 "../gxml/CssSelectorParser.vala"
			break;
#line 2041 "CssSelectorParser.c"
		}
#line 230 "../gxml/CssSelectorParser.vala"
		_tmp7_ = builder;
#line 230 "../gxml/CssSelectorParser.vala"
		g_string_append_unichar (_tmp7_, gxml_css_string_read (str));
#line 2047 "CssSelectorParser.c"
	}
#line 231 "../gxml/CssSelectorParser.vala"
	_tmp9_ = builder;
#line 231 "../gxml/CssSelectorParser.vala"
	_tmp10_ = _tmp9_->str;
#line 231 "../gxml/CssSelectorParser.vala"
	if (string_contains (_tmp10_, "*")) {
#line 2055 "CssSelectorParser.c"
		GString* _tmp11_;
#line 231 "../gxml/CssSelectorParser.vala"
		_tmp11_ = builder;
#line 231 "../gxml/CssSelectorParser.vala"
		_tmp8_ = _tmp11_->len > ((gssize) 1);
#line 2061 "CssSelectorParser.c"
	} else {
#line 231 "../gxml/CssSelectorParser.vala"
		_tmp8_ = FALSE;
#line 2065 "CssSelectorParser.c"
	}
#line 231 "../gxml/CssSelectorParser.vala"
	if (_tmp8_) {
#line 2069 "CssSelectorParser.c"
		GError* _tmp12_;
#line 232 "../gxml/CssSelectorParser.vala"
		_tmp12_ = g_error_new_literal (GXML_CSS_SELECTOR_ERROR, GXML_CSS_SELECTOR_ERROR_IDENTIFIER, _ ("Invalid identifier"));
#line 232 "../gxml/CssSelectorParser.vala"
		_inner_error0_ = _tmp12_;
#line 232 "../gxml/CssSelectorParser.vala"
		g_propagate_error (error, _inner_error0_);
#line 232 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (extra_builder);
#line 232 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (builder);
#line 232 "../gxml/CssSelectorParser.vala"
		return NULL;
#line 2083 "CssSelectorParser.c"
	}
#line 233 "../gxml/CssSelectorParser.vala"
	if (gxml_css_string_peek (str) == ((gunichar) '|')) {
#line 2087 "CssSelectorParser.c"
		GString* _tmp19_;
		gboolean _tmp21_ = FALSE;
		GString* _tmp22_;
		const gchar* _tmp23_;
		GString* _tmp26_;
		const gchar* _tmp27_;
		GString* _tmp28_;
		const gchar* _tmp29_;
		GXmlCssElementSelector* _tmp30_;
#line 234 "../gxml/CssSelectorParser.vala"
		gxml_css_string_read (str);
#line 235 "../gxml/CssSelectorParser.vala"
		while (TRUE) {
#line 2101 "CssSelectorParser.c"
			gboolean _tmp13_ = FALSE;
			gboolean _tmp14_ = FALSE;
			gboolean _tmp15_;
			gboolean _tmp16_;
			GString* _tmp18_;
#line 235 "../gxml/CssSelectorParser.vala"
			_tmp15_ = gxml_css_string_get_eof (str);
#line 235 "../gxml/CssSelectorParser.vala"
			_tmp16_ = _tmp15_;
#line 235 "../gxml/CssSelectorParser.vala"
			if (!_tmp16_) {
#line 2113 "CssSelectorParser.c"
				gboolean _tmp17_ = FALSE;
#line 235 "../gxml/CssSelectorParser.vala"
				if (gxml_css_string_peek (str) == ((gunichar) '*')) {
#line 235 "../gxml/CssSelectorParser.vala"
					_tmp17_ = TRUE;
#line 2119 "CssSelectorParser.c"
				} else {
#line 235 "../gxml/CssSelectorParser.vala"
					_tmp17_ = gxml_css_selector_parser_is_valid_char (gxml_css_string_peek (str));
#line 2123 "CssSelectorParser.c"
				}
#line 235 "../gxml/CssSelectorParser.vala"
				_tmp14_ = _tmp17_;
#line 2127 "CssSelectorParser.c"
			} else {
#line 235 "../gxml/CssSelectorParser.vala"
				_tmp14_ = FALSE;
#line 2131 "CssSelectorParser.c"
			}
#line 235 "../gxml/CssSelectorParser.vala"
			if (_tmp14_) {
#line 235 "../gxml/CssSelectorParser.vala"
				_tmp13_ = !g_unichar_isspace (gxml_css_string_peek (str));
#line 2137 "CssSelectorParser.c"
			} else {
#line 235 "../gxml/CssSelectorParser.vala"
				_tmp13_ = FALSE;
#line 2141 "CssSelectorParser.c"
			}
#line 235 "../gxml/CssSelectorParser.vala"
			if (!_tmp13_) {
#line 235 "../gxml/CssSelectorParser.vala"
				break;
#line 2147 "CssSelectorParser.c"
			}
#line 236 "../gxml/CssSelectorParser.vala"
			_tmp18_ = extra_builder;
#line 236 "../gxml/CssSelectorParser.vala"
			g_string_append_unichar (_tmp18_, gxml_css_string_read (str));
#line 2153 "CssSelectorParser.c"
		}
#line 237 "../gxml/CssSelectorParser.vala"
		_tmp19_ = extra_builder;
#line 237 "../gxml/CssSelectorParser.vala"
		if (_tmp19_->len == ((gssize) 0)) {
#line 2159 "CssSelectorParser.c"
			GError* _tmp20_;
#line 238 "../gxml/CssSelectorParser.vala"
			_tmp20_ = g_error_new_literal (GXML_CSS_SELECTOR_ERROR, GXML_CSS_SELECTOR_ERROR_IDENTIFIER, _ ("string value is empty"));
#line 238 "../gxml/CssSelectorParser.vala"
			_inner_error0_ = _tmp20_;
#line 238 "../gxml/CssSelectorParser.vala"
			g_propagate_error (error, _inner_error0_);
#line 238 "../gxml/CssSelectorParser.vala"
			_g_string_free0 (extra_builder);
#line 238 "../gxml/CssSelectorParser.vala"
			_g_string_free0 (builder);
#line 238 "../gxml/CssSelectorParser.vala"
			return NULL;
#line 2173 "CssSelectorParser.c"
		}
#line 239 "../gxml/CssSelectorParser.vala"
		_tmp22_ = extra_builder;
#line 239 "../gxml/CssSelectorParser.vala"
		_tmp23_ = _tmp22_->str;
#line 239 "../gxml/CssSelectorParser.vala"
		if (string_contains (_tmp23_, "*")) {
#line 2181 "CssSelectorParser.c"
			GString* _tmp24_;
#line 239 "../gxml/CssSelectorParser.vala"
			_tmp24_ = extra_builder;
#line 239 "../gxml/CssSelectorParser.vala"
			_tmp21_ = _tmp24_->len > ((gssize) 1);
#line 2187 "CssSelectorParser.c"
		} else {
#line 239 "../gxml/CssSelectorParser.vala"
			_tmp21_ = FALSE;
#line 2191 "CssSelectorParser.c"
		}
#line 239 "../gxml/CssSelectorParser.vala"
		if (_tmp21_) {
#line 2195 "CssSelectorParser.c"
			GError* _tmp25_;
#line 240 "../gxml/CssSelectorParser.vala"
			_tmp25_ = g_error_new_literal (GXML_CSS_SELECTOR_ERROR, GXML_CSS_SELECTOR_ERROR_IDENTIFIER, _ ("Invalid identifier"));
#line 240 "../gxml/CssSelectorParser.vala"
			_inner_error0_ = _tmp25_;
#line 240 "../gxml/CssSelectorParser.vala"
			g_propagate_error (error, _inner_error0_);
#line 240 "../gxml/CssSelectorParser.vala"
			_g_string_free0 (extra_builder);
#line 240 "../gxml/CssSelectorParser.vala"
			_g_string_free0 (builder);
#line 240 "../gxml/CssSelectorParser.vala"
			return NULL;
#line 2209 "CssSelectorParser.c"
		}
#line 241 "../gxml/CssSelectorParser.vala"
		_tmp26_ = builder;
#line 241 "../gxml/CssSelectorParser.vala"
		_tmp27_ = _tmp26_->str;
#line 241 "../gxml/CssSelectorParser.vala"
		_tmp28_ = extra_builder;
#line 241 "../gxml/CssSelectorParser.vala"
		_tmp29_ = _tmp28_->str;
#line 241 "../gxml/CssSelectorParser.vala"
		_tmp30_ = gxml_css_element_selector_new (_tmp27_, _tmp29_);
#line 241 "../gxml/CssSelectorParser.vala"
		result = (GXmlCssSelector*) _tmp30_;
#line 241 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (extra_builder);
#line 241 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (builder);
#line 241 "../gxml/CssSelectorParser.vala"
		return result;
#line 2229 "CssSelectorParser.c"
	}
#line 243 "../gxml/CssSelectorParser.vala"
	_tmp31_ = builder;
#line 243 "../gxml/CssSelectorParser.vala"
	if (_tmp31_->len == ((gssize) 0)) {
#line 2235 "CssSelectorParser.c"
		GError* _tmp32_;
#line 244 "../gxml/CssSelectorParser.vala"
		_tmp32_ = g_error_new_literal (GXML_CSS_SELECTOR_ERROR, GXML_CSS_SELECTOR_ERROR_IDENTIFIER, _ ("string value is empty"));
#line 244 "../gxml/CssSelectorParser.vala"
		_inner_error0_ = _tmp32_;
#line 244 "../gxml/CssSelectorParser.vala"
		g_propagate_error (error, _inner_error0_);
#line 244 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (extra_builder);
#line 244 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (builder);
#line 244 "../gxml/CssSelectorParser.vala"
		return NULL;
#line 2249 "CssSelectorParser.c"
	}
#line 245 "../gxml/CssSelectorParser.vala"
	_tmp33_ = builder;
#line 245 "../gxml/CssSelectorParser.vala"
	_tmp34_ = _tmp33_->str;
#line 245 "../gxml/CssSelectorParser.vala"
	_tmp35_ = gxml_css_element_selector_new (NULL, _tmp34_);
#line 245 "../gxml/CssSelectorParser.vala"
	result = (GXmlCssSelector*) _tmp35_;
#line 245 "../gxml/CssSelectorParser.vala"
	_g_string_free0 (extra_builder);
#line 245 "../gxml/CssSelectorParser.vala"
	_g_string_free0 (builder);
#line 245 "../gxml/CssSelectorParser.vala"
	return result;
#line 2265 "CssSelectorParser.c"
}

static GXmlCssNotSelector*
gxml_css_selector_parser_parse_not_selector (GXmlCssString* str,
                                             GError** error)
{
	GXmlCssNotSelector* selector = NULL;
	GXmlCssNotSelector* _tmp1_;
	GXmlCssNotSelector* _tmp2_;
	GeeList* _tmp3_;
	GeeList* _tmp4_;
	GError* _inner_error0_ = NULL;
	GXmlCssNotSelector* result = NULL;
#line 248 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 249 "../gxml/CssSelectorParser.vala"
	if (gxml_css_string_read (str) != ((gunichar) '(')) {
#line 2283 "CssSelectorParser.c"
		GError* _tmp0_;
#line 250 "../gxml/CssSelectorParser.vala"
		_tmp0_ = g_error_new_literal (GXML_CSS_SELECTOR_ERROR, GXML_CSS_SELECTOR_ERROR_NOT, _ ("Cannot find start of 'not selector' value"));
#line 250 "../gxml/CssSelectorParser.vala"
		_inner_error0_ = _tmp0_;
#line 250 "../gxml/CssSelectorParser.vala"
		g_propagate_error (error, _inner_error0_);
#line 250 "../gxml/CssSelectorParser.vala"
		return NULL;
#line 2293 "CssSelectorParser.c"
	}
#line 251 "../gxml/CssSelectorParser.vala"
	_tmp1_ = gxml_css_not_selector_new ();
#line 251 "../gxml/CssSelectorParser.vala"
	selector = _tmp1_;
#line 252 "../gxml/CssSelectorParser.vala"
	while (TRUE) {
#line 252 "../gxml/CssSelectorParser.vala"
		if (!g_unichar_isspace (gxml_css_string_peek (str))) {
#line 252 "../gxml/CssSelectorParser.vala"
			break;
#line 2305 "CssSelectorParser.c"
		}
#line 253 "../gxml/CssSelectorParser.vala"
		gxml_css_string_read (str);
#line 2309 "CssSelectorParser.c"
	}
#line 254 "../gxml/CssSelectorParser.vala"
	_tmp2_ = selector;
#line 254 "../gxml/CssSelectorParser.vala"
	_tmp3_ = gxml_css_not_selector_get_selectors (_tmp2_);
#line 254 "../gxml/CssSelectorParser.vala"
	_tmp4_ = _tmp3_;
#line 254 "../gxml/CssSelectorParser.vala"
	gxml_css_selector_parser_parse_selectors (str, _tmp4_, (gunichar) ')', &_inner_error0_);
#line 254 "../gxml/CssSelectorParser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 254 "../gxml/CssSelectorParser.vala"
		g_propagate_error (error, _inner_error0_);
#line 254 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (selector);
#line 254 "../gxml/CssSelectorParser.vala"
		return NULL;
#line 2327 "CssSelectorParser.c"
	}
#line 255 "../gxml/CssSelectorParser.vala"
	if (gxml_css_string_read (str) != ((gunichar) ')')) {
#line 2331 "CssSelectorParser.c"
		GError* _tmp5_;
#line 256 "../gxml/CssSelectorParser.vala"
		_tmp5_ = g_error_new_literal (GXML_CSS_SELECTOR_ERROR, GXML_CSS_SELECTOR_ERROR_NOT, _ ("Cannot find end of 'not selector' value"));
#line 256 "../gxml/CssSelectorParser.vala"
		_inner_error0_ = _tmp5_;
#line 256 "../gxml/CssSelectorParser.vala"
		g_propagate_error (error, _inner_error0_);
#line 256 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (selector);
#line 256 "../gxml/CssSelectorParser.vala"
		return NULL;
#line 2343 "CssSelectorParser.c"
	}
#line 257 "../gxml/CssSelectorParser.vala"
	result = selector;
#line 257 "../gxml/CssSelectorParser.vala"
	return result;
#line 2349 "CssSelectorParser.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 270 "../gxml/CssSelectorParser.vala"
	for (i = 0; i < stack_length; i++) {
#line 270 "../gxml/CssSelectorParser.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 270 "../gxml/CssSelectorParser.vala"
			return TRUE;
#line 2364 "CssSelectorParser.c"
		}
	}
#line 270 "../gxml/CssSelectorParser.vala"
	return FALSE;
#line 2369 "CssSelectorParser.c"
}

static gboolean
uint64_try_parse (const gchar* str,
                  guint64* _result_,
                  const gchar** unparsed,
                  guint _base)
{
	guint64 _vala__result_ = 0ULL;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	guint64 _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result = FALSE;
#line 835 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 837 "glib-2.0.vapi"
	errno = 0;
#line 838 "glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoull (str, &_tmp0_, _base);
#line 838 "glib-2.0.vapi"
	endptr = _tmp0_;
#line 838 "glib-2.0.vapi"
	_vala__result_ = _tmp1_;
#line 839 "glib-2.0.vapi"
	_tmp2_ = endptr;
#line 839 "glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 839 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 839 "glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 2405 "CssSelectorParser.c"
		gboolean _tmp5_ = FALSE;
#line 840 "glib-2.0.vapi"
		_vala_unparsed = "";
#line 841 "glib-2.0.vapi"
		if (errno != ERANGE) {
#line 841 "glib-2.0.vapi"
			_tmp5_ = errno != EINVAL;
#line 2413 "CssSelectorParser.c"
		} else {
#line 841 "glib-2.0.vapi"
			_tmp5_ = FALSE;
#line 2417 "CssSelectorParser.c"
		}
#line 841 "glib-2.0.vapi"
		result = _tmp5_;
#line 841 "glib-2.0.vapi"
		if (_result_) {
#line 841 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 2425 "CssSelectorParser.c"
		}
#line 841 "glib-2.0.vapi"
		if (unparsed) {
#line 841 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 2431 "CssSelectorParser.c"
		}
#line 841 "glib-2.0.vapi"
		return result;
#line 2435 "CssSelectorParser.c"
	} else {
		gchar* _tmp6_;
#line 843 "glib-2.0.vapi"
		_tmp6_ = endptr;
#line 843 "glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp6_;
#line 844 "glib-2.0.vapi"
		result = FALSE;
#line 844 "glib-2.0.vapi"
		if (_result_) {
#line 844 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 2448 "CssSelectorParser.c"
		}
#line 844 "glib-2.0.vapi"
		if (unparsed) {
#line 844 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 2454 "CssSelectorParser.c"
		}
#line 844 "glib-2.0.vapi"
		return result;
#line 2458 "CssSelectorParser.c"
	}
}

static GXmlCssSelector*
gxml_css_selector_parser_parse_pseudo (GXmlCssString* str,
                                       GError** error)
{
	gchar** pseudo_strv = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar** _tmp11_;
	gint pseudo_strv_length1;
	gint _pseudo_strv_size_;
	gchar** pseudo_value_strv = NULL;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar** _tmp16_;
	gint pseudo_value_strv_length1;
	gint _pseudo_value_strv_size_;
	GString* builder = NULL;
	GString* _tmp17_;
	GString* _tmp20_;
	const gchar* _tmp21_;
	gboolean _tmp25_ = FALSE;
	GString* _tmp26_;
	const gchar* _tmp27_;
	gchar** _tmp28_;
	gint _tmp28__length1;
	GString* _tmp38_;
	const gchar* _tmp39_;
	gchar** _tmp40_;
	gint _tmp40__length1;
	gboolean _tmp44_ = FALSE;
	GString* _tmp45_;
	const gchar* _tmp46_;
	gchar** _tmp47_;
	gint _tmp47__length1;
	GString* vbuilder = NULL;
	GString* _tmp54_;
	GString* _tmp58_;
	const gchar* _tmp59_;
	guint64 val = 0ULL;
	gboolean _tmp63_ = FALSE;
	gboolean _tmp64_ = FALSE;
	GString* _tmp65_;
	const gchar* _tmp66_;
	GString* _tmp75_;
	const gchar* _tmp76_;
	GString* _tmp77_;
	const gchar* _tmp78_;
	GXmlCssSelector* _tmp79_;
	GError* _inner_error0_ = NULL;
	GXmlCssSelector* result = NULL;
#line 260 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp0_ = g_strdup ("checked");
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp1_ = g_strdup ("enabled");
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp2_ = g_strdup ("disabled");
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp3_ = g_strdup ("root");
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp4_ = g_strdup ("empty");
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp5_ = g_strdup ("first-child");
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp6_ = g_strdup ("last-child");
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp7_ = g_strdup ("only-child");
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp8_ = g_strdup ("first-of-type");
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp9_ = g_strdup ("last-of-type");
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp10_ = g_strdup ("only-of-type");
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp11_ = g_new0 (gchar*, 11 + 1);
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp11_[0] = _tmp0_;
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp11_[1] = _tmp1_;
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp11_[2] = _tmp2_;
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp11_[3] = _tmp3_;
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp11_[4] = _tmp4_;
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp11_[5] = _tmp5_;
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp11_[6] = _tmp6_;
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp11_[7] = _tmp7_;
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp11_[8] = _tmp8_;
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp11_[9] = _tmp9_;
#line 261 "../gxml/CssSelectorParser.vala"
	_tmp11_[10] = _tmp10_;
#line 261 "../gxml/CssSelectorParser.vala"
	pseudo_strv = _tmp11_;
#line 261 "../gxml/CssSelectorParser.vala"
	pseudo_strv_length1 = 11;
#line 261 "../gxml/CssSelectorParser.vala"
	_pseudo_strv_size_ = pseudo_strv_length1;
#line 262 "../gxml/CssSelectorParser.vala"
	_tmp12_ = g_strdup ("nth-child");
#line 262 "../gxml/CssSelectorParser.vala"
	_tmp13_ = g_strdup ("nth-last-child");
#line 262 "../gxml/CssSelectorParser.vala"
	_tmp14_ = g_strdup ("nth-of-type");
#line 262 "../gxml/CssSelectorParser.vala"
	_tmp15_ = g_strdup ("nth-last-of-type");
#line 262 "../gxml/CssSelectorParser.vala"
	_tmp16_ = g_new0 (gchar*, 4 + 1);
#line 262 "../gxml/CssSelectorParser.vala"
	_tmp16_[0] = _tmp12_;
#line 262 "../gxml/CssSelectorParser.vala"
	_tmp16_[1] = _tmp13_;
#line 262 "../gxml/CssSelectorParser.vala"
	_tmp16_[2] = _tmp14_;
#line 262 "../gxml/CssSelectorParser.vala"
	_tmp16_[3] = _tmp15_;
#line 262 "../gxml/CssSelectorParser.vala"
	pseudo_value_strv = _tmp16_;
#line 262 "../gxml/CssSelectorParser.vala"
	pseudo_value_strv_length1 = 4;
#line 262 "../gxml/CssSelectorParser.vala"
	_pseudo_value_strv_size_ = pseudo_value_strv_length1;
#line 264 "../gxml/CssSelectorParser.vala"
	gxml_css_string_read (str);
#line 265 "../gxml/CssSelectorParser.vala"
	_tmp17_ = g_string_new ("");
#line 265 "../gxml/CssSelectorParser.vala"
	builder = _tmp17_;
#line 266 "../gxml/CssSelectorParser.vala"
	while (TRUE) {
#line 2609 "CssSelectorParser.c"
		gboolean _tmp18_ = FALSE;
		GString* _tmp19_;
#line 266 "../gxml/CssSelectorParser.vala"
		if (g_unichar_isalpha (gxml_css_string_peek (str))) {
#line 266 "../gxml/CssSelectorParser.vala"
			_tmp18_ = TRUE;
#line 2616 "CssSelectorParser.c"
		} else {
#line 266 "../gxml/CssSelectorParser.vala"
			_tmp18_ = gxml_css_string_peek (str) == ((gunichar) '-');
#line 2620 "CssSelectorParser.c"
		}
#line 266 "../gxml/CssSelectorParser.vala"
		if (!_tmp18_) {
#line 266 "../gxml/CssSelectorParser.vala"
			break;
#line 2626 "CssSelectorParser.c"
		}
#line 267 "../gxml/CssSelectorParser.vala"
		_tmp19_ = builder;
#line 267 "../gxml/CssSelectorParser.vala"
		g_string_append_unichar (_tmp19_, gxml_css_string_read (str));
#line 2632 "CssSelectorParser.c"
	}
#line 268 "../gxml/CssSelectorParser.vala"
	_tmp20_ = builder;
#line 268 "../gxml/CssSelectorParser.vala"
	_tmp21_ = _tmp20_->str;
#line 268 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (_tmp21_, "not") == 0) {
#line 2640 "CssSelectorParser.c"
		GXmlCssNotSelector* _tmp22_ = NULL;
		GXmlCssNotSelector* _tmp23_;
		GXmlCssNotSelector* _tmp24_;
#line 269 "../gxml/CssSelectorParser.vala"
		_tmp23_ = gxml_css_selector_parser_parse_not_selector (str, &_inner_error0_);
#line 269 "../gxml/CssSelectorParser.vala"
		_tmp22_ = _tmp23_;
#line 269 "../gxml/CssSelectorParser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 269 "../gxml/CssSelectorParser.vala"
			g_propagate_error (error, _inner_error0_);
#line 269 "../gxml/CssSelectorParser.vala"
			_g_string_free0 (builder);
#line 269 "../gxml/CssSelectorParser.vala"
			pseudo_value_strv = (_vala_array_free (pseudo_value_strv, pseudo_value_strv_length1, (GDestroyNotify) g_free), NULL);
#line 269 "../gxml/CssSelectorParser.vala"
			pseudo_strv = (_vala_array_free (pseudo_strv, pseudo_strv_length1, (GDestroyNotify) g_free), NULL);
#line 269 "../gxml/CssSelectorParser.vala"
			return NULL;
#line 2660 "CssSelectorParser.c"
		}
#line 269 "../gxml/CssSelectorParser.vala"
		_tmp24_ = _tmp22_;
#line 269 "../gxml/CssSelectorParser.vala"
		_tmp22_ = NULL;
#line 269 "../gxml/CssSelectorParser.vala"
		result = (GXmlCssSelector*) _tmp24_;
#line 269 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp22_);
#line 269 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (builder);
#line 269 "../gxml/CssSelectorParser.vala"
		pseudo_value_strv = (_vala_array_free (pseudo_value_strv, pseudo_value_strv_length1, (GDestroyNotify) g_free), NULL);
#line 269 "../gxml/CssSelectorParser.vala"
		pseudo_strv = (_vala_array_free (pseudo_strv, pseudo_strv_length1, (GDestroyNotify) g_free), NULL);
#line 269 "../gxml/CssSelectorParser.vala"
		return result;
#line 2678 "CssSelectorParser.c"
	}
#line 270 "../gxml/CssSelectorParser.vala"
	_tmp26_ = builder;
#line 270 "../gxml/CssSelectorParser.vala"
	_tmp27_ = _tmp26_->str;
#line 270 "../gxml/CssSelectorParser.vala"
	_tmp28_ = pseudo_strv;
#line 270 "../gxml/CssSelectorParser.vala"
	_tmp28__length1 = pseudo_strv_length1;
#line 270 "../gxml/CssSelectorParser.vala"
	if (!_vala_string_array_contains (_tmp28_, _tmp28__length1, _tmp27_)) {
#line 2690 "CssSelectorParser.c"
		GString* _tmp29_;
		const gchar* _tmp30_;
		gchar** _tmp31_;
		gint _tmp31__length1;
#line 270 "../gxml/CssSelectorParser.vala"
		_tmp29_ = builder;
#line 270 "../gxml/CssSelectorParser.vala"
		_tmp30_ = _tmp29_->str;
#line 270 "../gxml/CssSelectorParser.vala"
		_tmp31_ = pseudo_value_strv;
#line 270 "../gxml/CssSelectorParser.vala"
		_tmp31__length1 = pseudo_value_strv_length1;
#line 270 "../gxml/CssSelectorParser.vala"
		_tmp25_ = !_vala_string_array_contains (_tmp31_, _tmp31__length1, _tmp30_);
#line 2705 "CssSelectorParser.c"
	} else {
#line 270 "../gxml/CssSelectorParser.vala"
		_tmp25_ = FALSE;
#line 2709 "CssSelectorParser.c"
	}
#line 270 "../gxml/CssSelectorParser.vala"
	if (_tmp25_) {
#line 2713 "CssSelectorParser.c"
		GString* _tmp32_;
		const gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		GError* _tmp36_;
		GError* _tmp37_;
#line 271 "../gxml/CssSelectorParser.vala"
		_tmp32_ = builder;
#line 271 "../gxml/CssSelectorParser.vala"
		_tmp33_ = _tmp32_->str;
#line 271 "../gxml/CssSelectorParser.vala"
		_tmp34_ = g_strdup_printf (_ ("Invalid '%s' pseudo class"), _tmp33_);
#line 271 "../gxml/CssSelectorParser.vala"
		_tmp35_ = _tmp34_;
#line 271 "../gxml/CssSelectorParser.vala"
		_tmp36_ = g_error_new_literal (GXML_CSS_SELECTOR_ERROR, GXML_CSS_SELECTOR_ERROR_PSEUDO, _tmp35_);
#line 271 "../gxml/CssSelectorParser.vala"
		_tmp37_ = _tmp36_;
#line 271 "../gxml/CssSelectorParser.vala"
		_g_free0 (_tmp35_);
#line 271 "../gxml/CssSelectorParser.vala"
		_inner_error0_ = _tmp37_;
#line 271 "../gxml/CssSelectorParser.vala"
		g_propagate_error (error, _inner_error0_);
#line 271 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (builder);
#line 271 "../gxml/CssSelectorParser.vala"
		pseudo_value_strv = (_vala_array_free (pseudo_value_strv, pseudo_value_strv_length1, (GDestroyNotify) g_free), NULL);
#line 271 "../gxml/CssSelectorParser.vala"
		pseudo_strv = (_vala_array_free (pseudo_strv, pseudo_strv_length1, (GDestroyNotify) g_free), NULL);
#line 271 "../gxml/CssSelectorParser.vala"
		return NULL;
#line 2746 "CssSelectorParser.c"
	}
#line 272 "../gxml/CssSelectorParser.vala"
	_tmp38_ = builder;
#line 272 "../gxml/CssSelectorParser.vala"
	_tmp39_ = _tmp38_->str;
#line 272 "../gxml/CssSelectorParser.vala"
	_tmp40_ = pseudo_strv;
#line 272 "../gxml/CssSelectorParser.vala"
	_tmp40__length1 = pseudo_strv_length1;
#line 272 "../gxml/CssSelectorParser.vala"
	if (_vala_string_array_contains (_tmp40_, _tmp40__length1, _tmp39_)) {
#line 2758 "CssSelectorParser.c"
		GString* _tmp41_;
		const gchar* _tmp42_;
		GXmlCssSelector* _tmp43_;
#line 273 "../gxml/CssSelectorParser.vala"
		_tmp41_ = builder;
#line 273 "../gxml/CssSelectorParser.vala"
		_tmp42_ = _tmp41_->str;
#line 273 "../gxml/CssSelectorParser.vala"
		_tmp43_ = gxml_css_selector_new (GXML_CSS_SELECTOR_TYPE_PSEUDO_CLASS, _tmp42_);
#line 273 "../gxml/CssSelectorParser.vala"
		result = _tmp43_;
#line 273 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (builder);
#line 273 "../gxml/CssSelectorParser.vala"
		pseudo_value_strv = (_vala_array_free (pseudo_value_strv, pseudo_value_strv_length1, (GDestroyNotify) g_free), NULL);
#line 273 "../gxml/CssSelectorParser.vala"
		pseudo_strv = (_vala_array_free (pseudo_strv, pseudo_strv_length1, (GDestroyNotify) g_free), NULL);
#line 273 "../gxml/CssSelectorParser.vala"
		return result;
#line 2778 "CssSelectorParser.c"
	}
#line 274 "../gxml/CssSelectorParser.vala"
	_tmp45_ = builder;
#line 274 "../gxml/CssSelectorParser.vala"
	_tmp46_ = _tmp45_->str;
#line 274 "../gxml/CssSelectorParser.vala"
	_tmp47_ = pseudo_value_strv;
#line 274 "../gxml/CssSelectorParser.vala"
	_tmp47__length1 = pseudo_value_strv_length1;
#line 274 "../gxml/CssSelectorParser.vala"
	if (_vala_string_array_contains (_tmp47_, _tmp47__length1, _tmp46_)) {
#line 274 "../gxml/CssSelectorParser.vala"
		_tmp44_ = gxml_css_string_read (str) != ((gunichar) '(');
#line 2792 "CssSelectorParser.c"
	} else {
#line 274 "../gxml/CssSelectorParser.vala"
		_tmp44_ = FALSE;
#line 2796 "CssSelectorParser.c"
	}
#line 274 "../gxml/CssSelectorParser.vala"
	if (_tmp44_) {
#line 2800 "CssSelectorParser.c"
		GString* _tmp48_;
		const gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		GError* _tmp52_;
		GError* _tmp53_;
#line 275 "../gxml/CssSelectorParser.vala"
		_tmp48_ = builder;
#line 275 "../gxml/CssSelectorParser.vala"
		_tmp49_ = _tmp48_->str;
#line 275 "../gxml/CssSelectorParser.vala"
		_tmp50_ = g_strdup_printf (_ ("Invalid '%s' pseudo class : cannot find value"), _tmp49_);
#line 275 "../gxml/CssSelectorParser.vala"
		_tmp51_ = _tmp50_;
#line 275 "../gxml/CssSelectorParser.vala"
		_tmp52_ = g_error_new_literal (GXML_CSS_SELECTOR_ERROR, GXML_CSS_SELECTOR_ERROR_PSEUDO, _tmp51_);
#line 275 "../gxml/CssSelectorParser.vala"
		_tmp53_ = _tmp52_;
#line 275 "../gxml/CssSelectorParser.vala"
		_g_free0 (_tmp51_);
#line 275 "../gxml/CssSelectorParser.vala"
		_inner_error0_ = _tmp53_;
#line 275 "../gxml/CssSelectorParser.vala"
		g_propagate_error (error, _inner_error0_);
#line 275 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (builder);
#line 275 "../gxml/CssSelectorParser.vala"
		pseudo_value_strv = (_vala_array_free (pseudo_value_strv, pseudo_value_strv_length1, (GDestroyNotify) g_free), NULL);
#line 275 "../gxml/CssSelectorParser.vala"
		pseudo_strv = (_vala_array_free (pseudo_strv, pseudo_strv_length1, (GDestroyNotify) g_free), NULL);
#line 275 "../gxml/CssSelectorParser.vala"
		return NULL;
#line 2833 "CssSelectorParser.c"
	}
#line 276 "../gxml/CssSelectorParser.vala"
	_tmp54_ = g_string_new ("");
#line 276 "../gxml/CssSelectorParser.vala"
	vbuilder = _tmp54_;
#line 277 "../gxml/CssSelectorParser.vala"
	while (TRUE) {
#line 2841 "CssSelectorParser.c"
		gboolean _tmp55_ = FALSE;
		GString* _tmp56_;
#line 277 "../gxml/CssSelectorParser.vala"
		if (g_unichar_isalnum (gxml_css_string_peek (str))) {
#line 277 "../gxml/CssSelectorParser.vala"
			_tmp55_ = TRUE;
#line 2848 "CssSelectorParser.c"
		} else {
#line 277 "../gxml/CssSelectorParser.vala"
			_tmp55_ = gxml_css_string_peek (str) == ((gunichar) '-');
#line 2852 "CssSelectorParser.c"
		}
#line 277 "../gxml/CssSelectorParser.vala"
		if (!_tmp55_) {
#line 277 "../gxml/CssSelectorParser.vala"
			break;
#line 2858 "CssSelectorParser.c"
		}
#line 278 "../gxml/CssSelectorParser.vala"
		_tmp56_ = vbuilder;
#line 278 "../gxml/CssSelectorParser.vala"
		g_string_append_unichar (_tmp56_, gxml_css_string_read (str));
#line 2864 "CssSelectorParser.c"
	}
#line 279 "../gxml/CssSelectorParser.vala"
	if (gxml_css_string_read (str) != ((gunichar) ')')) {
#line 2868 "CssSelectorParser.c"
		GError* _tmp57_;
#line 280 "../gxml/CssSelectorParser.vala"
		_tmp57_ = g_error_new_literal (GXML_CSS_SELECTOR_ERROR, GXML_CSS_SELECTOR_ERROR_PSEUDO, _ ("Cannot find end of pseudo class value"));
#line 280 "../gxml/CssSelectorParser.vala"
		_inner_error0_ = _tmp57_;
#line 280 "../gxml/CssSelectorParser.vala"
		g_propagate_error (error, _inner_error0_);
#line 280 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (vbuilder);
#line 280 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (builder);
#line 280 "../gxml/CssSelectorParser.vala"
		pseudo_value_strv = (_vala_array_free (pseudo_value_strv, pseudo_value_strv_length1, (GDestroyNotify) g_free), NULL);
#line 280 "../gxml/CssSelectorParser.vala"
		pseudo_strv = (_vala_array_free (pseudo_strv, pseudo_strv_length1, (GDestroyNotify) g_free), NULL);
#line 280 "../gxml/CssSelectorParser.vala"
		return NULL;
#line 2886 "CssSelectorParser.c"
	}
#line 281 "../gxml/CssSelectorParser.vala"
	_tmp58_ = builder;
#line 281 "../gxml/CssSelectorParser.vala"
	_tmp59_ = _tmp58_->str;
#line 281 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (_tmp59_, "lang") == 0) {
#line 2894 "CssSelectorParser.c"
		GString* _tmp60_;
		const gchar* _tmp61_;
		GXmlCssSelector* _tmp62_;
#line 282 "../gxml/CssSelectorParser.vala"
		_tmp60_ = vbuilder;
#line 282 "../gxml/CssSelectorParser.vala"
		_tmp61_ = _tmp60_->str;
#line 282 "../gxml/CssSelectorParser.vala"
		_tmp62_ = gxml_css_selector_new_with_value (GXML_CSS_SELECTOR_TYPE_PSEUDO_CLASS, "lang", _tmp61_);
#line 282 "../gxml/CssSelectorParser.vala"
		result = _tmp62_;
#line 282 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (vbuilder);
#line 282 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (builder);
#line 282 "../gxml/CssSelectorParser.vala"
		pseudo_value_strv = (_vala_array_free (pseudo_value_strv, pseudo_value_strv_length1, (GDestroyNotify) g_free), NULL);
#line 282 "../gxml/CssSelectorParser.vala"
		pseudo_strv = (_vala_array_free (pseudo_strv, pseudo_strv_length1, (GDestroyNotify) g_free), NULL);
#line 282 "../gxml/CssSelectorParser.vala"
		return result;
#line 2916 "CssSelectorParser.c"
	}
#line 283 "../gxml/CssSelectorParser.vala"
	val = (guint64) 0;
#line 284 "../gxml/CssSelectorParser.vala"
	_tmp65_ = vbuilder;
#line 284 "../gxml/CssSelectorParser.vala"
	_tmp66_ = _tmp65_->str;
#line 284 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (_tmp66_, "odd") != 0) {
#line 2926 "CssSelectorParser.c"
		GString* _tmp67_;
		const gchar* _tmp68_;
#line 284 "../gxml/CssSelectorParser.vala"
		_tmp67_ = vbuilder;
#line 284 "../gxml/CssSelectorParser.vala"
		_tmp68_ = _tmp67_->str;
#line 284 "../gxml/CssSelectorParser.vala"
		_tmp64_ = g_strcmp0 (_tmp68_, "even") != 0;
#line 2935 "CssSelectorParser.c"
	} else {
#line 284 "../gxml/CssSelectorParser.vala"
		_tmp64_ = FALSE;
#line 2939 "CssSelectorParser.c"
	}
#line 284 "../gxml/CssSelectorParser.vala"
	if (_tmp64_) {
#line 2943 "CssSelectorParser.c"
		gboolean _tmp69_ = FALSE;
		GString* _tmp70_;
		const gchar* _tmp71_;
		guint64 _tmp72_ = 0ULL;
		gboolean _tmp73_;
#line 284 "../gxml/CssSelectorParser.vala"
		_tmp70_ = vbuilder;
#line 284 "../gxml/CssSelectorParser.vala"
		_tmp71_ = _tmp70_->str;
#line 284 "../gxml/CssSelectorParser.vala"
		_tmp73_ = uint64_try_parse (_tmp71_, &_tmp72_, NULL, (guint) 0);
#line 284 "../gxml/CssSelectorParser.vala"
		val = _tmp72_;
#line 284 "../gxml/CssSelectorParser.vala"
		if (!_tmp73_) {
#line 284 "../gxml/CssSelectorParser.vala"
			_tmp69_ = TRUE;
#line 2961 "CssSelectorParser.c"
		} else {
#line 284 "../gxml/CssSelectorParser.vala"
			_tmp69_ = val == ((guint64) 0);
#line 2965 "CssSelectorParser.c"
		}
#line 284 "../gxml/CssSelectorParser.vala"
		_tmp63_ = _tmp69_;
#line 2969 "CssSelectorParser.c"
	} else {
#line 284 "../gxml/CssSelectorParser.vala"
		_tmp63_ = FALSE;
#line 2973 "CssSelectorParser.c"
	}
#line 284 "../gxml/CssSelectorParser.vala"
	if (_tmp63_) {
#line 2977 "CssSelectorParser.c"
		GError* _tmp74_;
#line 285 "../gxml/CssSelectorParser.vala"
		_tmp74_ = g_error_new_literal (GXML_CSS_SELECTOR_ERROR, GXML_CSS_SELECTOR_ERROR_PSEUDO, _ ("Pseudo class value isn't a valid number"));
#line 285 "../gxml/CssSelectorParser.vala"
		_inner_error0_ = _tmp74_;
#line 285 "../gxml/CssSelectorParser.vala"
		g_propagate_error (error, _inner_error0_);
#line 285 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (vbuilder);
#line 285 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (builder);
#line 285 "../gxml/CssSelectorParser.vala"
		pseudo_value_strv = (_vala_array_free (pseudo_value_strv, pseudo_value_strv_length1, (GDestroyNotify) g_free), NULL);
#line 285 "../gxml/CssSelectorParser.vala"
		pseudo_strv = (_vala_array_free (pseudo_strv, pseudo_strv_length1, (GDestroyNotify) g_free), NULL);
#line 285 "../gxml/CssSelectorParser.vala"
		return NULL;
#line 2995 "CssSelectorParser.c"
	}
#line 286 "../gxml/CssSelectorParser.vala"
	_tmp75_ = builder;
#line 286 "../gxml/CssSelectorParser.vala"
	_tmp76_ = _tmp75_->str;
#line 286 "../gxml/CssSelectorParser.vala"
	_tmp77_ = vbuilder;
#line 286 "../gxml/CssSelectorParser.vala"
	_tmp78_ = _tmp77_->str;
#line 286 "../gxml/CssSelectorParser.vala"
	_tmp79_ = gxml_css_selector_new_with_value (GXML_CSS_SELECTOR_TYPE_PSEUDO_CLASS, _tmp76_, _tmp78_);
#line 286 "../gxml/CssSelectorParser.vala"
	result = _tmp79_;
#line 286 "../gxml/CssSelectorParser.vala"
	_g_string_free0 (vbuilder);
#line 286 "../gxml/CssSelectorParser.vala"
	_g_string_free0 (builder);
#line 286 "../gxml/CssSelectorParser.vala"
	pseudo_value_strv = (_vala_array_free (pseudo_value_strv, pseudo_value_strv_length1, (GDestroyNotify) g_free), NULL);
#line 286 "../gxml/CssSelectorParser.vala"
	pseudo_strv = (_vala_array_free (pseudo_strv, pseudo_strv_length1, (GDestroyNotify) g_free), NULL);
#line 286 "../gxml/CssSelectorParser.vala"
	return result;
#line 3019 "CssSelectorParser.c"
}

static GXmlCssSelector*
gxml_css_selector_parser_parse_class (GXmlCssString* str,
                                      GError** error)
{
	GString* builder = NULL;
	GString* _tmp0_;
	GString* _tmp7_;
	const gchar* _tmp8_;
	GXmlCssSelector* _tmp9_;
	GError* _inner_error0_ = NULL;
	GXmlCssSelector* result = NULL;
#line 289 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 290 "../gxml/CssSelectorParser.vala"
	gxml_css_string_read (str);
#line 291 "../gxml/CssSelectorParser.vala"
	_tmp0_ = g_string_new ("");
#line 291 "../gxml/CssSelectorParser.vala"
	builder = _tmp0_;
#line 292 "../gxml/CssSelectorParser.vala"
	if (!g_unichar_isalpha (gxml_css_string_peek (str))) {
#line 3043 "CssSelectorParser.c"
		GError* _tmp1_;
#line 293 "../gxml/CssSelectorParser.vala"
		_tmp1_ = g_error_new_literal (GXML_CSS_SELECTOR_ERROR, GXML_CSS_SELECTOR_ERROR_ATTRIBUTE, _ ("current class doesn't start with letter"));
#line 293 "../gxml/CssSelectorParser.vala"
		_inner_error0_ = _tmp1_;
#line 293 "../gxml/CssSelectorParser.vala"
		g_propagate_error (error, _inner_error0_);
#line 293 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (builder);
#line 293 "../gxml/CssSelectorParser.vala"
		return NULL;
#line 3055 "CssSelectorParser.c"
	}
#line 294 "../gxml/CssSelectorParser.vala"
	while (TRUE) {
#line 3059 "CssSelectorParser.c"
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_;
		gboolean _tmp5_;
		GString* _tmp6_;
#line 294 "../gxml/CssSelectorParser.vala"
		_tmp4_ = gxml_css_string_get_eof (str);
#line 294 "../gxml/CssSelectorParser.vala"
		_tmp5_ = _tmp4_;
#line 294 "../gxml/CssSelectorParser.vala"
		if (!_tmp5_) {
#line 294 "../gxml/CssSelectorParser.vala"
			_tmp3_ = gxml_css_selector_parser_is_valid_char (gxml_css_string_peek (str));
#line 3073 "CssSelectorParser.c"
		} else {
#line 294 "../gxml/CssSelectorParser.vala"
			_tmp3_ = FALSE;
#line 3077 "CssSelectorParser.c"
		}
#line 294 "../gxml/CssSelectorParser.vala"
		if (_tmp3_) {
#line 294 "../gxml/CssSelectorParser.vala"
			_tmp2_ = !g_unichar_isspace (gxml_css_string_peek (str));
#line 3083 "CssSelectorParser.c"
		} else {
#line 294 "../gxml/CssSelectorParser.vala"
			_tmp2_ = FALSE;
#line 3087 "CssSelectorParser.c"
		}
#line 294 "../gxml/CssSelectorParser.vala"
		if (!_tmp2_) {
#line 294 "../gxml/CssSelectorParser.vala"
			break;
#line 3093 "CssSelectorParser.c"
		}
#line 295 "../gxml/CssSelectorParser.vala"
		_tmp6_ = builder;
#line 295 "../gxml/CssSelectorParser.vala"
		g_string_append_unichar (_tmp6_, gxml_css_string_read (str));
#line 3099 "CssSelectorParser.c"
	}
#line 296 "../gxml/CssSelectorParser.vala"
	_tmp7_ = builder;
#line 296 "../gxml/CssSelectorParser.vala"
	_tmp8_ = _tmp7_->str;
#line 296 "../gxml/CssSelectorParser.vala"
	_tmp9_ = gxml_css_selector_new (GXML_CSS_SELECTOR_TYPE_CLASS, _tmp8_);
#line 296 "../gxml/CssSelectorParser.vala"
	result = _tmp9_;
#line 296 "../gxml/CssSelectorParser.vala"
	_g_string_free0 (builder);
#line 296 "../gxml/CssSelectorParser.vala"
	return result;
#line 3113 "CssSelectorParser.c"
}

static GXmlCssSelector*
gxml_css_selector_parser_parse_id (GXmlCssString* str,
                                   GError** error)
{
	GString* builder = NULL;
	GString* _tmp0_;
	GString* _tmp7_;
	const gchar* _tmp8_;
	GXmlCssSelector* _tmp9_;
	GError* _inner_error0_ = NULL;
	GXmlCssSelector* result = NULL;
#line 299 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 300 "../gxml/CssSelectorParser.vala"
	gxml_css_string_read (str);
#line 301 "../gxml/CssSelectorParser.vala"
	_tmp0_ = g_string_new ("");
#line 301 "../gxml/CssSelectorParser.vala"
	builder = _tmp0_;
#line 302 "../gxml/CssSelectorParser.vala"
	if (!g_unichar_isalpha (gxml_css_string_peek (str))) {
#line 3137 "CssSelectorParser.c"
		GError* _tmp1_;
#line 303 "../gxml/CssSelectorParser.vala"
		_tmp1_ = g_error_new_literal (GXML_CSS_SELECTOR_ERROR, GXML_CSS_SELECTOR_ERROR_ATTRIBUTE, _ ("current id doesn't start with letter"));
#line 303 "../gxml/CssSelectorParser.vala"
		_inner_error0_ = _tmp1_;
#line 303 "../gxml/CssSelectorParser.vala"
		g_propagate_error (error, _inner_error0_);
#line 303 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (builder);
#line 303 "../gxml/CssSelectorParser.vala"
		return NULL;
#line 3149 "CssSelectorParser.c"
	}
#line 304 "../gxml/CssSelectorParser.vala"
	while (TRUE) {
#line 3153 "CssSelectorParser.c"
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_;
		gboolean _tmp5_;
		GString* _tmp6_;
#line 304 "../gxml/CssSelectorParser.vala"
		_tmp4_ = gxml_css_string_get_eof (str);
#line 304 "../gxml/CssSelectorParser.vala"
		_tmp5_ = _tmp4_;
#line 304 "../gxml/CssSelectorParser.vala"
		if (!_tmp5_) {
#line 304 "../gxml/CssSelectorParser.vala"
			_tmp3_ = gxml_css_selector_parser_is_valid_char (gxml_css_string_peek (str));
#line 3167 "CssSelectorParser.c"
		} else {
#line 304 "../gxml/CssSelectorParser.vala"
			_tmp3_ = FALSE;
#line 3171 "CssSelectorParser.c"
		}
#line 304 "../gxml/CssSelectorParser.vala"
		if (_tmp3_) {
#line 304 "../gxml/CssSelectorParser.vala"
			_tmp2_ = !g_unichar_isspace (gxml_css_string_peek (str));
#line 3177 "CssSelectorParser.c"
		} else {
#line 304 "../gxml/CssSelectorParser.vala"
			_tmp2_ = FALSE;
#line 3181 "CssSelectorParser.c"
		}
#line 304 "../gxml/CssSelectorParser.vala"
		if (!_tmp2_) {
#line 304 "../gxml/CssSelectorParser.vala"
			break;
#line 3187 "CssSelectorParser.c"
		}
#line 305 "../gxml/CssSelectorParser.vala"
		_tmp6_ = builder;
#line 305 "../gxml/CssSelectorParser.vala"
		g_string_append_unichar (_tmp6_, gxml_css_string_read (str));
#line 3193 "CssSelectorParser.c"
	}
#line 306 "../gxml/CssSelectorParser.vala"
	_tmp7_ = builder;
#line 306 "../gxml/CssSelectorParser.vala"
	_tmp8_ = _tmp7_->str;
#line 306 "../gxml/CssSelectorParser.vala"
	_tmp9_ = gxml_css_selector_new (GXML_CSS_SELECTOR_TYPE_ID, _tmp8_);
#line 306 "../gxml/CssSelectorParser.vala"
	result = _tmp9_;
#line 306 "../gxml/CssSelectorParser.vala"
	_g_string_free0 (builder);
#line 306 "../gxml/CssSelectorParser.vala"
	return result;
#line 3207 "CssSelectorParser.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 309 "../gxml/CssSelectorParser.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 309 "../gxml/CssSelectorParser.vala"
	return _data1_;
#line 3217 "CssSelectorParser.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 309 "../gxml/CssSelectorParser.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 309 "../gxml/CssSelectorParser.vala"
		g_slice_free (Block1Data, _data1_);
#line 3229 "CssSelectorParser.c"
	}
}

static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1071 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 7);
#line 1071 "glib-2.0.vapi"
	str = (gchar*) _tmp0_;
#line 1072 "glib-2.0.vapi"
	g_unichar_to_utf8 (self, str);
#line 1073 "glib-2.0.vapi"
	result = str;
#line 1073 "glib-2.0.vapi"
	return result;
#line 3249 "CssSelectorParser.c"
}

static gboolean
__lambda4_ (Block1Data* _data1_,
            GXmlCssString* s)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result = FALSE;
#line 369 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (s != NULL, FALSE);
#line 370 "../gxml/CssSelectorParser.vala"
	if (_data1_->quote == ((gunichar) 0)) {
#line 370 "../gxml/CssSelectorParser.vala"
		_tmp2_ = !g_unichar_isspace (gxml_css_string_peek (s));
#line 3266 "CssSelectorParser.c"
	} else {
#line 370 "../gxml/CssSelectorParser.vala"
		_tmp2_ = FALSE;
#line 3270 "CssSelectorParser.c"
	}
#line 370 "../gxml/CssSelectorParser.vala"
	if (_tmp2_) {
#line 370 "../gxml/CssSelectorParser.vala"
		_tmp1_ = gxml_css_selector_parser_is_valid_char (gxml_css_string_peek (s));
#line 3276 "CssSelectorParser.c"
	} else {
#line 370 "../gxml/CssSelectorParser.vala"
		_tmp1_ = FALSE;
#line 3280 "CssSelectorParser.c"
	}
#line 370 "../gxml/CssSelectorParser.vala"
	if (_tmp1_) {
#line 370 "../gxml/CssSelectorParser.vala"
		_tmp0_ = TRUE;
#line 3286 "CssSelectorParser.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 370 "../gxml/CssSelectorParser.vala"
		if (_data1_->quote > ((gunichar) 0)) {
#line 370 "../gxml/CssSelectorParser.vala"
			_tmp3_ = gxml_css_string_peek (s) != _data1_->quote;
#line 3293 "CssSelectorParser.c"
		} else {
#line 370 "../gxml/CssSelectorParser.vala"
			_tmp3_ = FALSE;
#line 3297 "CssSelectorParser.c"
		}
#line 370 "../gxml/CssSelectorParser.vala"
		_tmp0_ = _tmp3_;
#line 3301 "CssSelectorParser.c"
	}
#line 370 "../gxml/CssSelectorParser.vala"
	result = _tmp0_;
#line 370 "../gxml/CssSelectorParser.vala"
	return result;
#line 3307 "CssSelectorParser.c"
}

static gboolean
___lambda4__gxml_css_string_func (GXmlCssString* str,
                                  gpointer self)
{
	gboolean result;
	result = __lambda4_ (self, str);
#line 369 "../gxml/CssSelectorParser.vala"
	return result;
#line 3318 "CssSelectorParser.c"
}

static GXmlCssSelector*
gxml_css_selector_parser_parse_attribute (GXmlCssString* str,
                                          GError** error)
{
	Block1Data* _data1_;
	GString* builder = NULL;
	GString* _tmp0_;
	GString* extra_builder = NULL;
	GString* _tmp1_;
	gboolean prefixed = FALSE;
	gboolean _tmp8_ = FALSE;
	GString* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp26_ = NULL;
	gchar* prefix = NULL;
	gchar* _tmp29_;
	const gchar* _tmp30_ = NULL;
	gchar* local_name = NULL;
	gchar* _tmp35_;
	GXmlCssAttributeSelector* selector = NULL;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	GXmlCssAttributeSelector* _tmp38_;
	GXmlCssSelectorType ct = 0;
	GXmlCssAttributeSelector* _tmp40_;
	gboolean _tmp47_ = FALSE;
	gchar* attr_value = NULL;
	gchar* _tmp48_;
	GXmlCssAttributeSelector* _tmp49_;
	const gchar* _tmp50_;
	gboolean _tmp51_ = FALSE;
	GError* _inner_error0_ = NULL;
	GXmlCssSelector* result = NULL;
#line 309 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 309 "../gxml/CssSelectorParser.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 309 "../gxml/CssSelectorParser.vala"
	_data1_->_ref_count_ = 1;
#line 310 "../gxml/CssSelectorParser.vala"
	gxml_css_string_read (str);
#line 311 "../gxml/CssSelectorParser.vala"
	while (TRUE) {
#line 311 "../gxml/CssSelectorParser.vala"
		if (!g_unichar_isspace (gxml_css_string_peek (str))) {
#line 311 "../gxml/CssSelectorParser.vala"
			break;
#line 3368 "CssSelectorParser.c"
		}
#line 312 "../gxml/CssSelectorParser.vala"
		gxml_css_string_read (str);
#line 3372 "CssSelectorParser.c"
	}
#line 313 "../gxml/CssSelectorParser.vala"
	_tmp0_ = g_string_new ("");
#line 313 "../gxml/CssSelectorParser.vala"
	builder = _tmp0_;
#line 314 "../gxml/CssSelectorParser.vala"
	_tmp1_ = g_string_new ("");
#line 314 "../gxml/CssSelectorParser.vala"
	extra_builder = _tmp1_;
#line 315 "../gxml/CssSelectorParser.vala"
	prefixed = FALSE;
#line 316 "../gxml/CssSelectorParser.vala"
	while (TRUE) {
#line 3386 "CssSelectorParser.c"
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_;
		gboolean _tmp5_;
		GString* _tmp7_;
#line 316 "../gxml/CssSelectorParser.vala"
		_tmp4_ = gxml_css_string_get_eof (str);
#line 316 "../gxml/CssSelectorParser.vala"
		_tmp5_ = _tmp4_;
#line 316 "../gxml/CssSelectorParser.vala"
		if (!_tmp5_) {
#line 3398 "CssSelectorParser.c"
			gboolean _tmp6_ = FALSE;
#line 316 "../gxml/CssSelectorParser.vala"
			if (gxml_css_string_peek (str) == ((gunichar) '*')) {
#line 316 "../gxml/CssSelectorParser.vala"
				_tmp6_ = TRUE;
#line 3404 "CssSelectorParser.c"
			} else {
#line 316 "../gxml/CssSelectorParser.vala"
				_tmp6_ = gxml_css_selector_parser_is_valid_char (gxml_css_string_peek (str));
#line 3408 "CssSelectorParser.c"
			}
#line 316 "../gxml/CssSelectorParser.vala"
			_tmp3_ = _tmp6_;
#line 3412 "CssSelectorParser.c"
		} else {
#line 316 "../gxml/CssSelectorParser.vala"
			_tmp3_ = FALSE;
#line 3416 "CssSelectorParser.c"
		}
#line 316 "../gxml/CssSelectorParser.vala"
		if (_tmp3_) {
#line 316 "../gxml/CssSelectorParser.vala"
			_tmp2_ = !g_unichar_isspace (gxml_css_string_peek (str));
#line 3422 "CssSelectorParser.c"
		} else {
#line 316 "../gxml/CssSelectorParser.vala"
			_tmp2_ = FALSE;
#line 3426 "CssSelectorParser.c"
		}
#line 316 "../gxml/CssSelectorParser.vala"
		if (!_tmp2_) {
#line 316 "../gxml/CssSelectorParser.vala"
			break;
#line 3432 "CssSelectorParser.c"
		}
#line 317 "../gxml/CssSelectorParser.vala"
		_tmp7_ = builder;
#line 317 "../gxml/CssSelectorParser.vala"
		g_string_append_unichar (_tmp7_, gxml_css_string_read (str));
#line 3438 "CssSelectorParser.c"
	}
#line 318 "../gxml/CssSelectorParser.vala"
	_tmp9_ = builder;
#line 318 "../gxml/CssSelectorParser.vala"
	_tmp10_ = _tmp9_->str;
#line 318 "../gxml/CssSelectorParser.vala"
	if (string_contains (_tmp10_, "*")) {
#line 3446 "CssSelectorParser.c"
		GString* _tmp11_;
#line 318 "../gxml/CssSelectorParser.vala"
		_tmp11_ = builder;
#line 318 "../gxml/CssSelectorParser.vala"
		_tmp8_ = _tmp11_->len > ((gssize) 1);
#line 3452 "CssSelectorParser.c"
	} else {
#line 318 "../gxml/CssSelectorParser.vala"
		_tmp8_ = FALSE;
#line 3456 "CssSelectorParser.c"
	}
#line 318 "../gxml/CssSelectorParser.vala"
	if (_tmp8_) {
#line 3460 "CssSelectorParser.c"
		GError* _tmp12_;
#line 319 "../gxml/CssSelectorParser.vala"
		_tmp12_ = g_error_new_literal (GXML_CSS_SELECTOR_ERROR, GXML_CSS_SELECTOR_ERROR_ATTRIBUTE, _ ("Invalid attribute"));
#line 319 "../gxml/CssSelectorParser.vala"
		_inner_error0_ = _tmp12_;
#line 319 "../gxml/CssSelectorParser.vala"
		g_propagate_error (error, _inner_error0_);
#line 319 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (extra_builder);
#line 319 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (builder);
#line 319 "../gxml/CssSelectorParser.vala"
		block1_data_unref (_data1_);
#line 319 "../gxml/CssSelectorParser.vala"
		_data1_ = NULL;
#line 319 "../gxml/CssSelectorParser.vala"
		return NULL;
#line 3478 "CssSelectorParser.c"
	}
#line 320 "../gxml/CssSelectorParser.vala"
	if (gxml_css_string_peek (str) == ((gunichar) '|')) {
#line 321 "../gxml/CssSelectorParser.vala"
		gxml_css_string_read (str);
#line 322 "../gxml/CssSelectorParser.vala"
		if (gxml_css_string_peek (str) == ((gunichar) '=')) {
#line 323 "../gxml/CssSelectorParser.vala"
			gxml_css_string_read_r (str);
#line 3488 "CssSelectorParser.c"
		} else {
			GString* _tmp19_;
			gboolean _tmp21_ = FALSE;
			GString* _tmp22_;
			const gchar* _tmp23_;
#line 325 "../gxml/CssSelectorParser.vala"
			prefixed = TRUE;
#line 326 "../gxml/CssSelectorParser.vala"
			while (TRUE) {
#line 3498 "CssSelectorParser.c"
				gboolean _tmp13_ = FALSE;
				gboolean _tmp14_ = FALSE;
				gboolean _tmp15_;
				gboolean _tmp16_;
				GString* _tmp18_;
#line 326 "../gxml/CssSelectorParser.vala"
				_tmp15_ = gxml_css_string_get_eof (str);
#line 326 "../gxml/CssSelectorParser.vala"
				_tmp16_ = _tmp15_;
#line 326 "../gxml/CssSelectorParser.vala"
				if (!_tmp16_) {
#line 3510 "CssSelectorParser.c"
					gboolean _tmp17_ = FALSE;
#line 326 "../gxml/CssSelectorParser.vala"
					if (gxml_css_string_peek (str) == ((gunichar) '*')) {
#line 326 "../gxml/CssSelectorParser.vala"
						_tmp17_ = TRUE;
#line 3516 "CssSelectorParser.c"
					} else {
#line 326 "../gxml/CssSelectorParser.vala"
						_tmp17_ = gxml_css_selector_parser_is_valid_char (gxml_css_string_peek (str));
#line 3520 "CssSelectorParser.c"
					}
#line 326 "../gxml/CssSelectorParser.vala"
					_tmp14_ = _tmp17_;
#line 3524 "CssSelectorParser.c"
				} else {
#line 326 "../gxml/CssSelectorParser.vala"
					_tmp14_ = FALSE;
#line 3528 "CssSelectorParser.c"
				}
#line 326 "../gxml/CssSelectorParser.vala"
				if (_tmp14_) {
#line 326 "../gxml/CssSelectorParser.vala"
					_tmp13_ = !g_unichar_isspace (gxml_css_string_peek (str));
#line 3534 "CssSelectorParser.c"
				} else {
#line 326 "../gxml/CssSelectorParser.vala"
					_tmp13_ = FALSE;
#line 3538 "CssSelectorParser.c"
				}
#line 326 "../gxml/CssSelectorParser.vala"
				if (!_tmp13_) {
#line 326 "../gxml/CssSelectorParser.vala"
					break;
#line 3544 "CssSelectorParser.c"
				}
#line 327 "../gxml/CssSelectorParser.vala"
				_tmp18_ = extra_builder;
#line 327 "../gxml/CssSelectorParser.vala"
				g_string_append_unichar (_tmp18_, gxml_css_string_read (str));
#line 3550 "CssSelectorParser.c"
			}
#line 328 "../gxml/CssSelectorParser.vala"
			_tmp19_ = extra_builder;
#line 328 "../gxml/CssSelectorParser.vala"
			if (_tmp19_->len == ((gssize) 0)) {
#line 3556 "CssSelectorParser.c"
				GError* _tmp20_;
#line 329 "../gxml/CssSelectorParser.vala"
				_tmp20_ = g_error_new_literal (GXML_CSS_SELECTOR_ERROR, GXML_CSS_SELECTOR_ERROR_ATTRIBUTE, _ ("string value is empty"));
#line 329 "../gxml/CssSelectorParser.vala"
				_inner_error0_ = _tmp20_;
#line 329 "../gxml/CssSelectorParser.vala"
				g_propagate_error (error, _inner_error0_);
#line 329 "../gxml/CssSelectorParser.vala"
				_g_string_free0 (extra_builder);
#line 329 "../gxml/CssSelectorParser.vala"
				_g_string_free0 (builder);
#line 329 "../gxml/CssSelectorParser.vala"
				block1_data_unref (_data1_);
#line 329 "../gxml/CssSelectorParser.vala"
				_data1_ = NULL;
#line 329 "../gxml/CssSelectorParser.vala"
				return NULL;
#line 3574 "CssSelectorParser.c"
			}
#line 330 "../gxml/CssSelectorParser.vala"
			_tmp22_ = extra_builder;
#line 330 "../gxml/CssSelectorParser.vala"
			_tmp23_ = _tmp22_->str;
#line 330 "../gxml/CssSelectorParser.vala"
			if (string_contains (_tmp23_, "*")) {
#line 3582 "CssSelectorParser.c"
				GString* _tmp24_;
#line 330 "../gxml/CssSelectorParser.vala"
				_tmp24_ = extra_builder;
#line 330 "../gxml/CssSelectorParser.vala"
				_tmp21_ = _tmp24_->len > ((gssize) 1);
#line 3588 "CssSelectorParser.c"
			} else {
#line 330 "../gxml/CssSelectorParser.vala"
				_tmp21_ = FALSE;
#line 3592 "CssSelectorParser.c"
			}
#line 330 "../gxml/CssSelectorParser.vala"
			if (_tmp21_) {
#line 3596 "CssSelectorParser.c"
				GError* _tmp25_;
#line 331 "../gxml/CssSelectorParser.vala"
				_tmp25_ = g_error_new_literal (GXML_CSS_SELECTOR_ERROR, GXML_CSS_SELECTOR_ERROR_ATTRIBUTE, _ ("Invalid attribute"));
#line 331 "../gxml/CssSelectorParser.vala"
				_inner_error0_ = _tmp25_;
#line 331 "../gxml/CssSelectorParser.vala"
				g_propagate_error (error, _inner_error0_);
#line 331 "../gxml/CssSelectorParser.vala"
				_g_string_free0 (extra_builder);
#line 331 "../gxml/CssSelectorParser.vala"
				_g_string_free0 (builder);
#line 331 "../gxml/CssSelectorParser.vala"
				block1_data_unref (_data1_);
#line 331 "../gxml/CssSelectorParser.vala"
				_data1_ = NULL;
#line 331 "../gxml/CssSelectorParser.vala"
				return NULL;
#line 3614 "CssSelectorParser.c"
			}
		}
	}
#line 334 "../gxml/CssSelectorParser.vala"
	if (prefixed) {
#line 3620 "CssSelectorParser.c"
		GString* _tmp27_;
		const gchar* _tmp28_;
#line 334 "../gxml/CssSelectorParser.vala"
		_tmp27_ = builder;
#line 334 "../gxml/CssSelectorParser.vala"
		_tmp28_ = _tmp27_->str;
#line 334 "../gxml/CssSelectorParser.vala"
		_tmp26_ = _tmp28_;
#line 3629 "CssSelectorParser.c"
	} else {
#line 334 "../gxml/CssSelectorParser.vala"
		_tmp26_ = NULL;
#line 3633 "CssSelectorParser.c"
	}
#line 334 "../gxml/CssSelectorParser.vala"
	_tmp29_ = g_strdup (_tmp26_);
#line 334 "../gxml/CssSelectorParser.vala"
	prefix = _tmp29_;
#line 335 "../gxml/CssSelectorParser.vala"
	if (prefixed) {
#line 3641 "CssSelectorParser.c"
		GString* _tmp31_;
		const gchar* _tmp32_;
#line 335 "../gxml/CssSelectorParser.vala"
		_tmp31_ = extra_builder;
#line 335 "../gxml/CssSelectorParser.vala"
		_tmp32_ = _tmp31_->str;
#line 335 "../gxml/CssSelectorParser.vala"
		_tmp30_ = _tmp32_;
#line 3650 "CssSelectorParser.c"
	} else {
		GString* _tmp33_;
		const gchar* _tmp34_;
#line 335 "../gxml/CssSelectorParser.vala"
		_tmp33_ = builder;
#line 335 "../gxml/CssSelectorParser.vala"
		_tmp34_ = _tmp33_->str;
#line 335 "../gxml/CssSelectorParser.vala"
		_tmp30_ = _tmp34_;
#line 3660 "CssSelectorParser.c"
	}
#line 335 "../gxml/CssSelectorParser.vala"
	_tmp35_ = g_strdup (_tmp30_);
#line 335 "../gxml/CssSelectorParser.vala"
	local_name = _tmp35_;
#line 336 "../gxml/CssSelectorParser.vala"
	_tmp36_ = prefix;
#line 336 "../gxml/CssSelectorParser.vala"
	_tmp37_ = local_name;
#line 336 "../gxml/CssSelectorParser.vala"
	_tmp38_ = gxml_css_attribute_selector_new (_tmp36_, _tmp37_);
#line 336 "../gxml/CssSelectorParser.vala"
	selector = _tmp38_;
#line 337 "../gxml/CssSelectorParser.vala"
	while (TRUE) {
#line 337 "../gxml/CssSelectorParser.vala"
		if (!g_unichar_isspace (gxml_css_string_peek (str))) {
#line 337 "../gxml/CssSelectorParser.vala"
			break;
#line 3680 "CssSelectorParser.c"
		}
#line 338 "../gxml/CssSelectorParser.vala"
		gxml_css_string_read (str);
#line 3684 "CssSelectorParser.c"
	}
#line 339 "../gxml/CssSelectorParser.vala"
	if (gxml_css_string_peek (str) == ((gunichar) ']')) {
#line 340 "../gxml/CssSelectorParser.vala"
		gxml_css_string_read (str);
#line 341 "../gxml/CssSelectorParser.vala"
		result = (GXmlCssSelector*) selector;
#line 341 "../gxml/CssSelectorParser.vala"
		_g_free0 (local_name);
#line 341 "../gxml/CssSelectorParser.vala"
		_g_free0 (prefix);
#line 341 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (extra_builder);
#line 341 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (builder);
#line 341 "../gxml/CssSelectorParser.vala"
		block1_data_unref (_data1_);
#line 341 "../gxml/CssSelectorParser.vala"
		_data1_ = NULL;
#line 341 "../gxml/CssSelectorParser.vala"
		return result;
#line 3706 "CssSelectorParser.c"
	}
#line 343 "../gxml/CssSelectorParser.vala"
	ct = GXML_CSS_SELECTOR_TYPE_CLASS;
#line 344 "../gxml/CssSelectorParser.vala"
	if (gxml_css_string_peek (str) == ((gunichar) '=')) {
#line 345 "../gxml/CssSelectorParser.vala"
		ct = GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_EQUAL;
#line 3714 "CssSelectorParser.c"
	} else {
#line 346 "../gxml/CssSelectorParser.vala"
		if (gxml_css_string_peek (str) == ((gunichar) '|')) {
#line 347 "../gxml/CssSelectorParser.vala"
			ct = GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_STARTS_WITH_WORD;
#line 3720 "CssSelectorParser.c"
		} else {
#line 348 "../gxml/CssSelectorParser.vala"
			if (gxml_css_string_peek (str) == ((gunichar) '^')) {
#line 349 "../gxml/CssSelectorParser.vala"
				ct = GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_STARTS_WITH;
#line 3726 "CssSelectorParser.c"
			} else {
#line 350 "../gxml/CssSelectorParser.vala"
				if (gxml_css_string_peek (str) == ((gunichar) '$')) {
#line 351 "../gxml/CssSelectorParser.vala"
					ct = GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_ENDS_WITH;
#line 3732 "CssSelectorParser.c"
				} else {
#line 352 "../gxml/CssSelectorParser.vala"
					if (gxml_css_string_peek (str) == ((gunichar) '~')) {
#line 353 "../gxml/CssSelectorParser.vala"
						ct = GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_CONTAINS;
#line 3738 "CssSelectorParser.c"
					} else {
#line 354 "../gxml/CssSelectorParser.vala"
						if (gxml_css_string_peek (str) == ((gunichar) '*')) {
#line 355 "../gxml/CssSelectorParser.vala"
							ct = GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_SUBSTRING;
#line 3744 "CssSelectorParser.c"
						}
					}
				}
			}
		}
	}
#line 356 "../gxml/CssSelectorParser.vala"
	if (ct == GXML_CSS_SELECTOR_TYPE_CLASS) {
#line 3753 "CssSelectorParser.c"
		GError* _tmp39_;
#line 357 "../gxml/CssSelectorParser.vala"
		_tmp39_ = g_error_new_literal (GXML_CSS_SELECTOR_ERROR, GXML_CSS_SELECTOR_ERROR_ATTRIBUTE, _ ("Invalid attribute selector"));
#line 357 "../gxml/CssSelectorParser.vala"
		_inner_error0_ = _tmp39_;
#line 357 "../gxml/CssSelectorParser.vala"
		g_propagate_error (error, _inner_error0_);
#line 357 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (selector);
#line 357 "../gxml/CssSelectorParser.vala"
		_g_free0 (local_name);
#line 357 "../gxml/CssSelectorParser.vala"
		_g_free0 (prefix);
#line 357 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (extra_builder);
#line 357 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (builder);
#line 357 "../gxml/CssSelectorParser.vala"
		block1_data_unref (_data1_);
#line 357 "../gxml/CssSelectorParser.vala"
		_data1_ = NULL;
#line 357 "../gxml/CssSelectorParser.vala"
		return NULL;
#line 3777 "CssSelectorParser.c"
	}
#line 358 "../gxml/CssSelectorParser.vala"
	_tmp40_ = selector;
#line 358 "../gxml/CssSelectorParser.vala"
	gxml_css_selector_set_selector_type ((GXmlCssSelector*) _tmp40_, ct);
#line 359 "../gxml/CssSelectorParser.vala"
	if (ct != GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_EQUAL) {
#line 360 "../gxml/CssSelectorParser.vala"
		gxml_css_string_read (str);
#line 3787 "CssSelectorParser.c"
	}
#line 361 "../gxml/CssSelectorParser.vala"
	if (gxml_css_string_peek (str) != ((gunichar) '=')) {
#line 3791 "CssSelectorParser.c"
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		GError* _tmp45_;
		GError* _tmp46_;
#line 362 "../gxml/CssSelectorParser.vala"
		_tmp41_ = g_unichar_to_string (gxml_css_string_peek (str));
#line 362 "../gxml/CssSelectorParser.vala"
		_tmp42_ = _tmp41_;
#line 362 "../gxml/CssSelectorParser.vala"
		_tmp43_ = g_strdup_printf (_ ("Invalid attribute selector. '=' expected but '%s' was found"), _tmp42_);
#line 362 "../gxml/CssSelectorParser.vala"
		_tmp44_ = _tmp43_;
#line 362 "../gxml/CssSelectorParser.vala"
		_tmp45_ = g_error_new_literal (GXML_CSS_SELECTOR_ERROR, GXML_CSS_SELECTOR_ERROR_ATTRIBUTE, _tmp44_);
#line 362 "../gxml/CssSelectorParser.vala"
		_tmp46_ = _tmp45_;
#line 362 "../gxml/CssSelectorParser.vala"
		_g_free0 (_tmp44_);
#line 362 "../gxml/CssSelectorParser.vala"
		_g_free0 (_tmp42_);
#line 362 "../gxml/CssSelectorParser.vala"
		_inner_error0_ = _tmp46_;
#line 362 "../gxml/CssSelectorParser.vala"
		g_propagate_error (error, _inner_error0_);
#line 362 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (selector);
#line 362 "../gxml/CssSelectorParser.vala"
		_g_free0 (local_name);
#line 362 "../gxml/CssSelectorParser.vala"
		_g_free0 (prefix);
#line 362 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (extra_builder);
#line 362 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (builder);
#line 362 "../gxml/CssSelectorParser.vala"
		block1_data_unref (_data1_);
#line 362 "../gxml/CssSelectorParser.vala"
		_data1_ = NULL;
#line 362 "../gxml/CssSelectorParser.vala"
		return NULL;
#line 3834 "CssSelectorParser.c"
	}
#line 363 "../gxml/CssSelectorParser.vala"
	gxml_css_string_read (str);
#line 364 "../gxml/CssSelectorParser.vala"
	while (TRUE) {
#line 364 "../gxml/CssSelectorParser.vala"
		if (!g_unichar_isspace (gxml_css_string_peek (str))) {
#line 364 "../gxml/CssSelectorParser.vala"
			break;
#line 3844 "CssSelectorParser.c"
		}
#line 365 "../gxml/CssSelectorParser.vala"
		gxml_css_string_read (str);
#line 3848 "CssSelectorParser.c"
	}
#line 366 "../gxml/CssSelectorParser.vala"
	_data1_->quote = (gunichar) 0;
#line 367 "../gxml/CssSelectorParser.vala"
	if (gxml_css_string_peek (str) == ((gunichar) '"')) {
#line 367 "../gxml/CssSelectorParser.vala"
		_tmp47_ = TRUE;
#line 3856 "CssSelectorParser.c"
	} else {
#line 367 "../gxml/CssSelectorParser.vala"
		_tmp47_ = gxml_css_string_peek (str) == ((gunichar) '\'');
#line 3860 "CssSelectorParser.c"
	}
#line 367 "../gxml/CssSelectorParser.vala"
	if (_tmp47_) {
#line 368 "../gxml/CssSelectorParser.vala"
		_data1_->quote = gxml_css_string_read (str);
#line 3866 "CssSelectorParser.c"
	}
#line 369 "../gxml/CssSelectorParser.vala"
	_tmp48_ = gxml_css_selector_parser_parse_identifier (str, ___lambda4__gxml_css_string_func, _data1_);
#line 369 "../gxml/CssSelectorParser.vala"
	attr_value = _tmp48_;
#line 372 "../gxml/CssSelectorParser.vala"
	_tmp49_ = selector;
#line 372 "../gxml/CssSelectorParser.vala"
	_tmp50_ = attr_value;
#line 372 "../gxml/CssSelectorParser.vala"
	gxml_css_selector_set_value ((GXmlCssSelector*) _tmp49_, _tmp50_);
#line 373 "../gxml/CssSelectorParser.vala"
	if (_data1_->quote > ((gunichar) 0)) {
#line 373 "../gxml/CssSelectorParser.vala"
		_tmp51_ = _data1_->quote != gxml_css_string_read (str);
#line 3882 "CssSelectorParser.c"
	} else {
#line 373 "../gxml/CssSelectorParser.vala"
		_tmp51_ = FALSE;
#line 3886 "CssSelectorParser.c"
	}
#line 373 "../gxml/CssSelectorParser.vala"
	if (_tmp51_) {
#line 3890 "CssSelectorParser.c"
		GError* _tmp52_;
#line 374 "../gxml/CssSelectorParser.vala"
		_tmp52_ = g_error_new_literal (GXML_CSS_SELECTOR_ERROR, GXML_CSS_SELECTOR_ERROR_ATTRIBUTE, _ ("Cannot find end of attribute value"));
#line 374 "../gxml/CssSelectorParser.vala"
		_inner_error0_ = _tmp52_;
#line 374 "../gxml/CssSelectorParser.vala"
		g_propagate_error (error, _inner_error0_);
#line 374 "../gxml/CssSelectorParser.vala"
		_g_free0 (attr_value);
#line 374 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (selector);
#line 374 "../gxml/CssSelectorParser.vala"
		_g_free0 (local_name);
#line 374 "../gxml/CssSelectorParser.vala"
		_g_free0 (prefix);
#line 374 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (extra_builder);
#line 374 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (builder);
#line 374 "../gxml/CssSelectorParser.vala"
		block1_data_unref (_data1_);
#line 374 "../gxml/CssSelectorParser.vala"
		_data1_ = NULL;
#line 374 "../gxml/CssSelectorParser.vala"
		return NULL;
#line 3916 "CssSelectorParser.c"
	}
#line 375 "../gxml/CssSelectorParser.vala"
	while (TRUE) {
#line 375 "../gxml/CssSelectorParser.vala"
		if (!g_unichar_isspace (gxml_css_string_peek (str))) {
#line 375 "../gxml/CssSelectorParser.vala"
			break;
#line 3924 "CssSelectorParser.c"
		}
#line 376 "../gxml/CssSelectorParser.vala"
		gxml_css_string_read (str);
#line 3928 "CssSelectorParser.c"
	}
#line 377 "../gxml/CssSelectorParser.vala"
	if (gxml_css_string_read (str) != ((gunichar) ']')) {
#line 3932 "CssSelectorParser.c"
		GError* _tmp53_;
#line 378 "../gxml/CssSelectorParser.vala"
		_tmp53_ = g_error_new_literal (GXML_CSS_SELECTOR_ERROR, GXML_CSS_SELECTOR_ERROR_ATTRIBUTE, _ ("Cannot find end of attribute selector"));
#line 378 "../gxml/CssSelectorParser.vala"
		_inner_error0_ = _tmp53_;
#line 378 "../gxml/CssSelectorParser.vala"
		g_propagate_error (error, _inner_error0_);
#line 378 "../gxml/CssSelectorParser.vala"
		_g_free0 (attr_value);
#line 378 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (selector);
#line 378 "../gxml/CssSelectorParser.vala"
		_g_free0 (local_name);
#line 378 "../gxml/CssSelectorParser.vala"
		_g_free0 (prefix);
#line 378 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (extra_builder);
#line 378 "../gxml/CssSelectorParser.vala"
		_g_string_free0 (builder);
#line 378 "../gxml/CssSelectorParser.vala"
		block1_data_unref (_data1_);
#line 378 "../gxml/CssSelectorParser.vala"
		_data1_ = NULL;
#line 378 "../gxml/CssSelectorParser.vala"
		return NULL;
#line 3958 "CssSelectorParser.c"
	}
#line 382 "../gxml/CssSelectorParser.vala"
	result = (GXmlCssSelector*) selector;
#line 382 "../gxml/CssSelectorParser.vala"
	_g_free0 (attr_value);
#line 382 "../gxml/CssSelectorParser.vala"
	_g_free0 (local_name);
#line 382 "../gxml/CssSelectorParser.vala"
	_g_free0 (prefix);
#line 382 "../gxml/CssSelectorParser.vala"
	_g_string_free0 (extra_builder);
#line 382 "../gxml/CssSelectorParser.vala"
	_g_string_free0 (builder);
#line 382 "../gxml/CssSelectorParser.vala"
	block1_data_unref (_data1_);
#line 382 "../gxml/CssSelectorParser.vala"
	_data1_ = NULL;
#line 382 "../gxml/CssSelectorParser.vala"
	return result;
#line 3978 "CssSelectorParser.c"
}

static void
gxml_css_selector_parser_parse_selectors (GXmlCssString* str,
                                          GeeList* list,
                                          gunichar stop_char,
                                          GError** error)
{
	gint _tmp42_;
	gint _tmp43_;
	gint _tmp45_;
	gint _tmp46_;
	gpointer _tmp47_;
	GXmlCssSelector* _tmp48_;
	GXmlCssCombiner _tmp49_;
	GXmlCssCombiner _tmp50_;
	gboolean _tmp51_;
	gint _tmp56_;
	gint _tmp57_;
	gpointer _tmp58_;
	GXmlCssSelector* _tmp59_;
	GXmlCssCombiner _tmp60_;
	GXmlCssCombiner _tmp61_;
	gboolean _tmp62_;
	GError* _inner_error0_ = NULL;
#line 385 "../gxml/CssSelectorParser.vala"
	g_return_if_fail (str != NULL);
#line 385 "../gxml/CssSelectorParser.vala"
	g_return_if_fail (list != NULL);
#line 386 "../gxml/CssSelectorParser.vala"
	while (TRUE) {
#line 4010 "CssSelectorParser.c"
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		gint _tmp15_;
		gint _tmp16_;
		gpointer _tmp17_;
		GXmlCssSelector* _tmp18_;
		gboolean _tmp19_;
		GXmlCssCombiner combiner = 0;
		gboolean _tmp37_ = FALSE;
		gint _tmp38_;
		gint _tmp39_;
		gpointer _tmp40_;
		GXmlCssSelector* _tmp41_;
#line 386 "../gxml/CssSelectorParser.vala"
		_tmp1_ = gxml_css_string_get_eof (str);
#line 386 "../gxml/CssSelectorParser.vala"
		_tmp2_ = _tmp1_;
#line 386 "../gxml/CssSelectorParser.vala"
		if (!_tmp2_) {
#line 386 "../gxml/CssSelectorParser.vala"
			_tmp0_ = gxml_css_string_peek (str) != stop_char;
#line 4035 "CssSelectorParser.c"
		} else {
#line 386 "../gxml/CssSelectorParser.vala"
			_tmp0_ = FALSE;
#line 4039 "CssSelectorParser.c"
		}
#line 386 "../gxml/CssSelectorParser.vala"
		if (!_tmp0_) {
#line 386 "../gxml/CssSelectorParser.vala"
			break;
#line 4045 "CssSelectorParser.c"
		}
#line 387 "../gxml/CssSelectorParser.vala"
		if (g_unichar_isalpha (gxml_css_string_peek (str))) {
#line 387 "../gxml/CssSelectorParser.vala"
			_tmp4_ = TRUE;
#line 4051 "CssSelectorParser.c"
		} else {
#line 387 "../gxml/CssSelectorParser.vala"
			_tmp4_ = gxml_css_string_peek (str) == ((gunichar) '*');
#line 4055 "CssSelectorParser.c"
		}
#line 387 "../gxml/CssSelectorParser.vala"
		if (_tmp4_) {
#line 387 "../gxml/CssSelectorParser.vala"
			_tmp3_ = TRUE;
#line 4061 "CssSelectorParser.c"
		} else {
#line 387 "../gxml/CssSelectorParser.vala"
			_tmp3_ = gxml_css_string_peek (str) == ((gunichar) '|');
#line 4065 "CssSelectorParser.c"
		}
#line 387 "../gxml/CssSelectorParser.vala"
		if (_tmp3_) {
#line 4069 "CssSelectorParser.c"
			GXmlCssSelector* _tmp5_ = NULL;
			GXmlCssSelector* _tmp6_;
#line 388 "../gxml/CssSelectorParser.vala"
			_tmp6_ = gxml_css_selector_parser_parse_element (str, &_inner_error0_);
#line 388 "../gxml/CssSelectorParser.vala"
			_tmp5_ = _tmp6_;
#line 388 "../gxml/CssSelectorParser.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 388 "../gxml/CssSelectorParser.vala"
				g_propagate_error (error, _inner_error0_);
#line 388 "../gxml/CssSelectorParser.vala"
				return;
#line 4082 "CssSelectorParser.c"
			}
#line 388 "../gxml/CssSelectorParser.vala"
			gee_collection_add ((GeeCollection*) list, _tmp5_);
#line 387 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (_tmp5_);
#line 4088 "CssSelectorParser.c"
		} else {
#line 389 "../gxml/CssSelectorParser.vala"
			if (gxml_css_string_peek (str) == ((gunichar) '.')) {
#line 4092 "CssSelectorParser.c"
				GXmlCssSelector* _tmp7_ = NULL;
				GXmlCssSelector* _tmp8_;
#line 390 "../gxml/CssSelectorParser.vala"
				_tmp8_ = gxml_css_selector_parser_parse_class (str, &_inner_error0_);
#line 390 "../gxml/CssSelectorParser.vala"
				_tmp7_ = _tmp8_;
#line 390 "../gxml/CssSelectorParser.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 390 "../gxml/CssSelectorParser.vala"
					g_propagate_error (error, _inner_error0_);
#line 390 "../gxml/CssSelectorParser.vala"
					return;
#line 4105 "CssSelectorParser.c"
				}
#line 390 "../gxml/CssSelectorParser.vala"
				gee_collection_add ((GeeCollection*) list, _tmp7_);
#line 389 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (_tmp7_);
#line 4111 "CssSelectorParser.c"
			} else {
#line 391 "../gxml/CssSelectorParser.vala"
				if (gxml_css_string_peek (str) == ((gunichar) '#')) {
#line 4115 "CssSelectorParser.c"
					GXmlCssSelector* _tmp9_ = NULL;
					GXmlCssSelector* _tmp10_;
#line 392 "../gxml/CssSelectorParser.vala"
					_tmp10_ = gxml_css_selector_parser_parse_id (str, &_inner_error0_);
#line 392 "../gxml/CssSelectorParser.vala"
					_tmp9_ = _tmp10_;
#line 392 "../gxml/CssSelectorParser.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 392 "../gxml/CssSelectorParser.vala"
						g_propagate_error (error, _inner_error0_);
#line 392 "../gxml/CssSelectorParser.vala"
						return;
#line 4128 "CssSelectorParser.c"
					}
#line 392 "../gxml/CssSelectorParser.vala"
					gee_collection_add ((GeeCollection*) list, _tmp9_);
#line 391 "../gxml/CssSelectorParser.vala"
					_g_object_unref0 (_tmp9_);
#line 4134 "CssSelectorParser.c"
				} else {
#line 393 "../gxml/CssSelectorParser.vala"
					if (gxml_css_string_peek (str) == ((gunichar) ':')) {
#line 4138 "CssSelectorParser.c"
						GXmlCssSelector* _tmp11_ = NULL;
						GXmlCssSelector* _tmp12_;
#line 394 "../gxml/CssSelectorParser.vala"
						_tmp12_ = gxml_css_selector_parser_parse_pseudo (str, &_inner_error0_);
#line 394 "../gxml/CssSelectorParser.vala"
						_tmp11_ = _tmp12_;
#line 394 "../gxml/CssSelectorParser.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 394 "../gxml/CssSelectorParser.vala"
							g_propagate_error (error, _inner_error0_);
#line 394 "../gxml/CssSelectorParser.vala"
							return;
#line 4151 "CssSelectorParser.c"
						}
#line 394 "../gxml/CssSelectorParser.vala"
						gee_collection_add ((GeeCollection*) list, _tmp11_);
#line 393 "../gxml/CssSelectorParser.vala"
						_g_object_unref0 (_tmp11_);
#line 4157 "CssSelectorParser.c"
					} else {
#line 395 "../gxml/CssSelectorParser.vala"
						if (gxml_css_string_peek (str) == ((gunichar) '[')) {
#line 4161 "CssSelectorParser.c"
							GXmlCssSelector* _tmp13_ = NULL;
							GXmlCssSelector* _tmp14_;
#line 396 "../gxml/CssSelectorParser.vala"
							_tmp14_ = gxml_css_selector_parser_parse_attribute (str, &_inner_error0_);
#line 396 "../gxml/CssSelectorParser.vala"
							_tmp13_ = _tmp14_;
#line 396 "../gxml/CssSelectorParser.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 396 "../gxml/CssSelectorParser.vala"
								g_propagate_error (error, _inner_error0_);
#line 396 "../gxml/CssSelectorParser.vala"
								return;
#line 4174 "CssSelectorParser.c"
							}
#line 396 "../gxml/CssSelectorParser.vala"
							gee_collection_add ((GeeCollection*) list, _tmp13_);
#line 395 "../gxml/CssSelectorParser.vala"
							_g_object_unref0 (_tmp13_);
#line 4180 "CssSelectorParser.c"
						}
					}
				}
			}
		}
#line 397 "../gxml/CssSelectorParser.vala"
		_tmp15_ = gee_collection_get_size ((GeeCollection*) list);
#line 397 "../gxml/CssSelectorParser.vala"
		_tmp16_ = _tmp15_;
#line 397 "../gxml/CssSelectorParser.vala"
		_tmp17_ = gee_list_get (list, _tmp16_ - 1);
#line 397 "../gxml/CssSelectorParser.vala"
		_tmp18_ = (GXmlCssSelector*) _tmp17_;
#line 397 "../gxml/CssSelectorParser.vala"
		_tmp19_ = GXML_IS_CSS_ELEMENT_SELECTOR (_tmp18_);
#line 397 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp18_);
#line 397 "../gxml/CssSelectorParser.vala"
		if (_tmp19_) {
#line 4200 "CssSelectorParser.c"
			GXmlCssElementSelector* sel = NULL;
			gint _tmp20_;
			gint _tmp21_;
			gpointer _tmp22_;
			GXmlCssSelector* _tmp23_;
			GXmlCssElementSelector* _tmp24_;
			gboolean _tmp25_ = FALSE;
			GXmlCssElementSelector* _tmp26_;
			gboolean _tmp27_;
			gboolean _tmp28_;
#line 398 "../gxml/CssSelectorParser.vala"
			_tmp20_ = gee_collection_get_size ((GeeCollection*) list);
#line 398 "../gxml/CssSelectorParser.vala"
			_tmp21_ = _tmp20_;
#line 398 "../gxml/CssSelectorParser.vala"
			_tmp22_ = gee_list_get (list, _tmp21_ - 1);
#line 398 "../gxml/CssSelectorParser.vala"
			_tmp23_ = (GXmlCssSelector*) _tmp22_;
#line 398 "../gxml/CssSelectorParser.vala"
			_tmp24_ = GXML_IS_CSS_ELEMENT_SELECTOR (_tmp23_) ? ((GXmlCssElementSelector*) _tmp23_) : NULL;
#line 398 "../gxml/CssSelectorParser.vala"
			if (_tmp24_ == NULL) {
#line 398 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (_tmp23_);
#line 4225 "CssSelectorParser.c"
			}
#line 398 "../gxml/CssSelectorParser.vala"
			sel = _tmp24_;
#line 399 "../gxml/CssSelectorParser.vala"
			_tmp26_ = sel;
#line 399 "../gxml/CssSelectorParser.vala"
			_tmp27_ = gxml_css_element_selector_get_prefixed (_tmp26_);
#line 399 "../gxml/CssSelectorParser.vala"
			_tmp28_ = _tmp27_;
#line 399 "../gxml/CssSelectorParser.vala"
			if (!_tmp28_) {
#line 4237 "CssSelectorParser.c"
				GXmlCssElementSelector* _tmp29_;
				gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
#line 399 "../gxml/CssSelectorParser.vala"
				_tmp29_ = sel;
#line 399 "../gxml/CssSelectorParser.vala"
				_tmp30_ = gxml_css_element_selector_get_local_name (_tmp29_);
#line 399 "../gxml/CssSelectorParser.vala"
				_tmp31_ = _tmp30_;
#line 399 "../gxml/CssSelectorParser.vala"
				_tmp32_ = _tmp31_;
#line 399 "../gxml/CssSelectorParser.vala"
				_tmp25_ = g_strcmp0 (_tmp32_, "*") == 0;
#line 399 "../gxml/CssSelectorParser.vala"
				_g_free0 (_tmp32_);
#line 4254 "CssSelectorParser.c"
			} else {
#line 399 "../gxml/CssSelectorParser.vala"
				_tmp25_ = FALSE;
#line 4258 "CssSelectorParser.c"
			}
#line 399 "../gxml/CssSelectorParser.vala"
			if (_tmp25_) {
#line 4262 "CssSelectorParser.c"
				gint _tmp33_;
				gint _tmp34_;
				GXmlCssSelector* _tmp35_;
				GXmlCssSelector* _tmp36_;
#line 400 "../gxml/CssSelectorParser.vala"
				_tmp33_ = gee_collection_get_size ((GeeCollection*) list);
#line 400 "../gxml/CssSelectorParser.vala"
				_tmp34_ = _tmp33_;
#line 400 "../gxml/CssSelectorParser.vala"
				_tmp35_ = gxml_css_selector_new (GXML_CSS_SELECTOR_TYPE_ALL, "");
#line 400 "../gxml/CssSelectorParser.vala"
				_tmp36_ = _tmp35_;
#line 400 "../gxml/CssSelectorParser.vala"
				gee_list_set (list, _tmp34_ - 1, _tmp36_);
#line 400 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (_tmp36_);
#line 4279 "CssSelectorParser.c"
			}
#line 397 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (sel);
#line 4283 "CssSelectorParser.c"
		}
#line 403 "../gxml/CssSelectorParser.vala"
		combiner = 0;
#line 404 "../gxml/CssSelectorParser.vala"
		if (g_unichar_isspace (gxml_css_string_peek (str))) {
#line 405 "../gxml/CssSelectorParser.vala"
			combiner = GXML_CSS_COMBINER_INSIDE;
#line 4291 "CssSelectorParser.c"
		}
#line 406 "../gxml/CssSelectorParser.vala"
		while (TRUE) {
#line 406 "../gxml/CssSelectorParser.vala"
			if (!g_unichar_isspace (gxml_css_string_peek (str))) {
#line 406 "../gxml/CssSelectorParser.vala"
				break;
#line 4299 "CssSelectorParser.c"
			}
#line 407 "../gxml/CssSelectorParser.vala"
			gxml_css_string_read (str);
#line 4303 "CssSelectorParser.c"
		}
#line 408 "../gxml/CssSelectorParser.vala"
		if (gxml_css_string_peek (str) == ((gunichar) ',')) {
#line 409 "../gxml/CssSelectorParser.vala"
			combiner = GXML_CSS_COMBINER_AND;
#line 4309 "CssSelectorParser.c"
		} else {
#line 410 "../gxml/CssSelectorParser.vala"
			if (gxml_css_string_peek (str) == ((gunichar) '>')) {
#line 411 "../gxml/CssSelectorParser.vala"
				combiner = GXML_CSS_COMBINER_PARENT;
#line 4315 "CssSelectorParser.c"
			} else {
#line 412 "../gxml/CssSelectorParser.vala"
				if (gxml_css_string_peek (str) == ((gunichar) '+')) {
#line 413 "../gxml/CssSelectorParser.vala"
					combiner = GXML_CSS_COMBINER_AFTER;
#line 4321 "CssSelectorParser.c"
				} else {
#line 414 "../gxml/CssSelectorParser.vala"
					if (gxml_css_string_peek (str) == ((gunichar) '~')) {
#line 415 "../gxml/CssSelectorParser.vala"
						combiner = GXML_CSS_COMBINER_PRECEDED;
#line 4327 "CssSelectorParser.c"
					} else {
#line 416 "../gxml/CssSelectorParser.vala"
						if (combiner == 0) {
#line 417 "../gxml/CssSelectorParser.vala"
							combiner = GXML_CSS_COMBINER_NONE;
#line 4333 "CssSelectorParser.c"
						}
					}
				}
			}
		}
#line 418 "../gxml/CssSelectorParser.vala"
		if (combiner != GXML_CSS_COMBINER_NONE) {
#line 418 "../gxml/CssSelectorParser.vala"
			_tmp37_ = combiner != GXML_CSS_COMBINER_INSIDE;
#line 4343 "CssSelectorParser.c"
		} else {
#line 418 "../gxml/CssSelectorParser.vala"
			_tmp37_ = FALSE;
#line 4347 "CssSelectorParser.c"
		}
#line 418 "../gxml/CssSelectorParser.vala"
		if (_tmp37_) {
#line 419 "../gxml/CssSelectorParser.vala"
			gxml_css_string_read (str);
#line 4353 "CssSelectorParser.c"
		}
#line 420 "../gxml/CssSelectorParser.vala"
		_tmp38_ = gee_collection_get_size ((GeeCollection*) list);
#line 420 "../gxml/CssSelectorParser.vala"
		_tmp39_ = _tmp38_;
#line 420 "../gxml/CssSelectorParser.vala"
		_tmp40_ = gee_list_get (list, _tmp39_ - 1);
#line 420 "../gxml/CssSelectorParser.vala"
		_tmp41_ = (GXmlCssSelector*) _tmp40_;
#line 420 "../gxml/CssSelectorParser.vala"
		gxml_css_selector_set_combiner (_tmp41_, combiner);
#line 420 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp41_);
#line 421 "../gxml/CssSelectorParser.vala"
		while (TRUE) {
#line 421 "../gxml/CssSelectorParser.vala"
			if (!g_unichar_isspace (gxml_css_string_peek (str))) {
#line 421 "../gxml/CssSelectorParser.vala"
				break;
#line 4373 "CssSelectorParser.c"
			}
#line 422 "../gxml/CssSelectorParser.vala"
			gxml_css_string_read (str);
#line 4377 "CssSelectorParser.c"
		}
	}
#line 424 "../gxml/CssSelectorParser.vala"
	_tmp42_ = gee_collection_get_size ((GeeCollection*) list);
#line 424 "../gxml/CssSelectorParser.vala"
	_tmp43_ = _tmp42_;
#line 424 "../gxml/CssSelectorParser.vala"
	if (_tmp43_ == 0) {
#line 4386 "CssSelectorParser.c"
		GError* _tmp44_;
#line 425 "../gxml/CssSelectorParser.vala"
		_tmp44_ = g_error_new_literal (GXML_CSS_SELECTOR_ERROR, GXML_CSS_SELECTOR_ERROR_NULL, _ ("No selectors found"));
#line 425 "../gxml/CssSelectorParser.vala"
		_inner_error0_ = _tmp44_;
#line 425 "../gxml/CssSelectorParser.vala"
		g_propagate_error (error, _inner_error0_);
#line 425 "../gxml/CssSelectorParser.vala"
		return;
#line 4396 "CssSelectorParser.c"
	}
#line 426 "../gxml/CssSelectorParser.vala"
	_tmp45_ = gee_collection_get_size ((GeeCollection*) list);
#line 426 "../gxml/CssSelectorParser.vala"
	_tmp46_ = _tmp45_;
#line 426 "../gxml/CssSelectorParser.vala"
	_tmp47_ = gee_list_get (list, _tmp46_ - 1);
#line 426 "../gxml/CssSelectorParser.vala"
	_tmp48_ = (GXmlCssSelector*) _tmp47_;
#line 426 "../gxml/CssSelectorParser.vala"
	_tmp49_ = gxml_css_selector_get_combiner (_tmp48_);
#line 426 "../gxml/CssSelectorParser.vala"
	_tmp50_ = _tmp49_;
#line 426 "../gxml/CssSelectorParser.vala"
	_tmp51_ = _tmp50_ == GXML_CSS_COMBINER_NONE;
#line 426 "../gxml/CssSelectorParser.vala"
	_g_object_unref0 (_tmp48_);
#line 426 "../gxml/CssSelectorParser.vala"
	if (_tmp51_) {
#line 4416 "CssSelectorParser.c"
		gint _tmp52_;
		gint _tmp53_;
		gpointer _tmp54_;
		GXmlCssSelector* _tmp55_;
#line 427 "../gxml/CssSelectorParser.vala"
		_tmp52_ = gee_collection_get_size ((GeeCollection*) list);
#line 427 "../gxml/CssSelectorParser.vala"
		_tmp53_ = _tmp52_;
#line 427 "../gxml/CssSelectorParser.vala"
		_tmp54_ = gee_list_get (list, _tmp53_ - 1);
#line 427 "../gxml/CssSelectorParser.vala"
		_tmp55_ = (GXmlCssSelector*) _tmp54_;
#line 427 "../gxml/CssSelectorParser.vala"
		gxml_css_selector_set_combiner (_tmp55_, GXML_CSS_COMBINER_NULL);
#line 427 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp55_);
#line 4433 "CssSelectorParser.c"
	}
#line 428 "../gxml/CssSelectorParser.vala"
	_tmp56_ = gee_collection_get_size ((GeeCollection*) list);
#line 428 "../gxml/CssSelectorParser.vala"
	_tmp57_ = _tmp56_;
#line 428 "../gxml/CssSelectorParser.vala"
	_tmp58_ = gee_list_get (list, _tmp57_ - 1);
#line 428 "../gxml/CssSelectorParser.vala"
	_tmp59_ = (GXmlCssSelector*) _tmp58_;
#line 428 "../gxml/CssSelectorParser.vala"
	_tmp60_ = gxml_css_selector_get_combiner (_tmp59_);
#line 428 "../gxml/CssSelectorParser.vala"
	_tmp61_ = _tmp60_;
#line 428 "../gxml/CssSelectorParser.vala"
	_tmp62_ = _tmp61_ != GXML_CSS_COMBINER_NULL;
#line 428 "../gxml/CssSelectorParser.vala"
	_g_object_unref0 (_tmp59_);
#line 428 "../gxml/CssSelectorParser.vala"
	if (_tmp62_) {
#line 4453 "CssSelectorParser.c"
		gint _tmp63_;
		gint _tmp64_;
		gpointer _tmp65_;
		GXmlCssSelector* _tmp66_;
		GXmlCssCombiner _tmp67_;
		GXmlCssCombiner _tmp68_;
		GEnumValue* _tmp69_;
		gchar* _tmp70_;
		gchar* _tmp71_;
		GError* _tmp72_;
		GError* _tmp73_;
#line 429 "../gxml/CssSelectorParser.vala"
		_tmp63_ = gee_collection_get_size ((GeeCollection*) list);
#line 429 "../gxml/CssSelectorParser.vala"
		_tmp64_ = _tmp63_;
#line 429 "../gxml/CssSelectorParser.vala"
		_tmp65_ = gee_list_get (list, _tmp64_ - 1);
#line 429 "../gxml/CssSelectorParser.vala"
		_tmp66_ = (GXmlCssSelector*) _tmp65_;
#line 429 "../gxml/CssSelectorParser.vala"
		_tmp67_ = gxml_css_selector_get_combiner (_tmp66_);
#line 429 "../gxml/CssSelectorParser.vala"
		_tmp68_ = _tmp67_;
#line 429 "../gxml/CssSelectorParser.vala"
		_tmp69_ = g_enum_get_value (g_type_class_ref (GXML_TYPE_CSS_COMBINER), _tmp68_);
#line 429 "../gxml/CssSelectorParser.vala"
		_tmp70_ = g_strdup_printf (_ ("Last selector has combiner assigned (%s)"), (_tmp69_ != NULL) ? _tmp69_->value_name : NULL);
#line 429 "../gxml/CssSelectorParser.vala"
		_tmp71_ = _tmp70_;
#line 429 "../gxml/CssSelectorParser.vala"
		_tmp72_ = g_error_new_literal (GXML_CSS_SELECTOR_ERROR, GXML_CSS_SELECTOR_ERROR_COMBINER, _tmp71_);
#line 429 "../gxml/CssSelectorParser.vala"
		_tmp73_ = _tmp72_;
#line 429 "../gxml/CssSelectorParser.vala"
		_g_free0 (_tmp71_);
#line 429 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp66_);
#line 429 "../gxml/CssSelectorParser.vala"
		_inner_error0_ = _tmp73_;
#line 429 "../gxml/CssSelectorParser.vala"
		g_propagate_error (error, _inner_error0_);
#line 429 "../gxml/CssSelectorParser.vala"
		return;
#line 4497 "CssSelectorParser.c"
	}
}

/**
 * parse selectors string. If data isn't valid, error is throwed
 * 
 * @param selectors CSS selectors Level 3 string 
 */
void
gxml_css_selector_parser_parse (GXmlCssSelectorParser* self,
                                const gchar* selectors,
                                GError** error)
{
	GeeArrayList* _tmp0_;
	GXmlCssString* str = NULL;
	GXmlCssString* _tmp1_;
	GeeArrayList* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 436 "../gxml/CssSelectorParser.vala"
	g_return_if_fail (self != NULL);
#line 436 "../gxml/CssSelectorParser.vala"
	g_return_if_fail (selectors != NULL);
#line 437 "../gxml/CssSelectorParser.vala"
	_tmp0_ = self->priv->list;
#line 437 "../gxml/CssSelectorParser.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 438 "../gxml/CssSelectorParser.vala"
	_tmp1_ = gxml_css_string_new (selectors);
#line 438 "../gxml/CssSelectorParser.vala"
	str = _tmp1_;
#line 439 "../gxml/CssSelectorParser.vala"
	_tmp2_ = self->priv->list;
#line 439 "../gxml/CssSelectorParser.vala"
	gxml_css_selector_parser_parse_selectors (str, (GeeList*) _tmp2_, (gunichar) 0, &_inner_error0_);
#line 439 "../gxml/CssSelectorParser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 439 "../gxml/CssSelectorParser.vala"
		g_propagate_error (error, _inner_error0_);
#line 439 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (str);
#line 439 "../gxml/CssSelectorParser.vala"
		return;
#line 4540 "CssSelectorParser.c"
	}
#line 436 "../gxml/CssSelectorParser.vala"
	_g_object_unref0 (str);
#line 4544 "CssSelectorParser.c"
}

GeeList*
gxml_css_selector_parser_get_selectors (GXmlCssSelectorParser* self)
{
	GeeList* result;
	GeeArrayList* _tmp0_;
#line 452 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 453 "../gxml/CssSelectorParser.vala"
	_tmp0_ = self->priv->list;
#line 453 "../gxml/CssSelectorParser.vala"
	result = (GeeList*) _tmp0_;
#line 453 "../gxml/CssSelectorParser.vala"
	return result;
#line 4560 "CssSelectorParser.c"
}

static gboolean
gxml_css_selector_parser_match_pseudo (GXmlDomElement* element,
                                       GXmlCssSelector* selector,
                                       GError** error)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gboolean _tmp28_ = FALSE;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	const gchar* _tmp57_;
	const gchar* _tmp58_;
	const gchar* _tmp63_;
	const gchar* _tmp64_;
	const gchar* _tmp73_;
	const gchar* _tmp74_;
	const gchar* _tmp89_;
	const gchar* _tmp90_;
	const gchar* _tmp105_;
	const gchar* _tmp106_;
	const gchar* _tmp136_;
	const gchar* _tmp137_;
	const gchar* _tmp189_;
	const gchar* _tmp190_;
	const gchar* _tmp258_;
	const gchar* _tmp259_;
	const gchar* _tmp312_;
	const gchar* _tmp313_;
	gboolean result = FALSE;
#line 457 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (element != NULL, FALSE);
#line 457 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (selector != NULL, FALSE);
#line 458 "../gxml/CssSelectorParser.vala"
	_tmp0_ = gxml_css_selector_get_name (selector);
#line 458 "../gxml/CssSelectorParser.vala"
	_tmp1_ = _tmp0_;
#line 458 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (_tmp1_, "root") == 0) {
#line 4608 "CssSelectorParser.c"
		GXmlDomDocument* _tmp2_;
		GXmlDomDocument* _tmp3_;
		GXmlDomElement* _tmp4_;
		GXmlDomElement* _tmp5_;
		GXmlDomElement* _tmp6_;
		gboolean _tmp7_;
#line 459 "../gxml/CssSelectorParser.vala"
		_tmp2_ = gxml_dom_node_get_owner_document ((GXmlDomNode*) element);
#line 459 "../gxml/CssSelectorParser.vala"
		_tmp3_ = _tmp2_;
#line 459 "../gxml/CssSelectorParser.vala"
		_tmp4_ = gxml_dom_document_get_document_element (_tmp3_);
#line 459 "../gxml/CssSelectorParser.vala"
		_tmp5_ = _tmp4_;
#line 459 "../gxml/CssSelectorParser.vala"
		_tmp6_ = _tmp5_;
#line 459 "../gxml/CssSelectorParser.vala"
		_tmp7_ = element == _tmp6_;
#line 459 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp6_);
#line 459 "../gxml/CssSelectorParser.vala"
		result = _tmp7_;
#line 459 "../gxml/CssSelectorParser.vala"
		return result;
#line 4633 "CssSelectorParser.c"
	}
#line 460 "../gxml/CssSelectorParser.vala"
	_tmp8_ = gxml_css_selector_get_name (selector);
#line 460 "../gxml/CssSelectorParser.vala"
	_tmp9_ = _tmp8_;
#line 460 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (_tmp9_, "empty") == 0) {
#line 4641 "CssSelectorParser.c"
		GXmlDomHTMLCollection* _tmp10_;
		GXmlDomHTMLCollection* _tmp11_;
		GXmlDomHTMLCollection* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		gboolean _tmp15_;
#line 461 "../gxml/CssSelectorParser.vala"
		_tmp10_ = gxml_dom_parent_node_get_children ((GXmlDomParentNode*) element);
#line 461 "../gxml/CssSelectorParser.vala"
		_tmp11_ = _tmp10_;
#line 461 "../gxml/CssSelectorParser.vala"
		_tmp12_ = _tmp11_;
#line 461 "../gxml/CssSelectorParser.vala"
		_tmp13_ = gxml_dom_html_collection_get_length (_tmp12_);
#line 461 "../gxml/CssSelectorParser.vala"
		_tmp14_ = _tmp13_;
#line 461 "../gxml/CssSelectorParser.vala"
		_tmp15_ = _tmp14_ == 0;
#line 461 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp12_);
#line 461 "../gxml/CssSelectorParser.vala"
		result = _tmp15_;
#line 461 "../gxml/CssSelectorParser.vala"
		return result;
#line 4666 "CssSelectorParser.c"
	}
#line 462 "../gxml/CssSelectorParser.vala"
	_tmp16_ = gxml_css_selector_get_name (selector);
#line 462 "../gxml/CssSelectorParser.vala"
	_tmp17_ = _tmp16_;
#line 462 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (_tmp17_, "checked") == 0) {
#line 4674 "CssSelectorParser.c"
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gboolean _tmp21_;
		GXmlDomNamedNodeMap* _tmp22_;
		GXmlDomNamedNodeMap* _tmp23_;
		GXmlDomNamedNodeMap* _tmp24_;
		GXmlDomNode* _tmp25_;
		GXmlDomNode* _tmp26_;
		gboolean _tmp27_;
#line 463 "../gxml/CssSelectorParser.vala"
		_tmp18_ = gxml_dom_element_get_local_name (element);
#line 463 "../gxml/CssSelectorParser.vala"
		_tmp19_ = _tmp18_;
#line 463 "../gxml/CssSelectorParser.vala"
		_tmp20_ = _tmp19_;
#line 463 "../gxml/CssSelectorParser.vala"
		_tmp21_ = g_strcmp0 (_tmp20_, "input") != 0;
#line 463 "../gxml/CssSelectorParser.vala"
		_g_free0 (_tmp20_);
#line 463 "../gxml/CssSelectorParser.vala"
		if (_tmp21_) {
#line 464 "../gxml/CssSelectorParser.vala"
			result = FALSE;
#line 464 "../gxml/CssSelectorParser.vala"
			return result;
#line 4701 "CssSelectorParser.c"
		}
#line 465 "../gxml/CssSelectorParser.vala"
		_tmp22_ = gxml_dom_element_get_attributes (element);
#line 465 "../gxml/CssSelectorParser.vala"
		_tmp23_ = _tmp22_;
#line 465 "../gxml/CssSelectorParser.vala"
		_tmp24_ = _tmp23_;
#line 465 "../gxml/CssSelectorParser.vala"
		_tmp25_ = gxml_dom_named_node_map_get_named_item (_tmp24_, "checked");
#line 465 "../gxml/CssSelectorParser.vala"
		_tmp26_ = _tmp25_;
#line 465 "../gxml/CssSelectorParser.vala"
		_tmp27_ = _tmp26_ != NULL;
#line 465 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp26_);
#line 465 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp24_);
#line 465 "../gxml/CssSelectorParser.vala"
		result = _tmp27_;
#line 465 "../gxml/CssSelectorParser.vala"
		return result;
#line 4723 "CssSelectorParser.c"
	}
#line 467 "../gxml/CssSelectorParser.vala"
	_tmp29_ = gxml_css_selector_get_name (selector);
#line 467 "../gxml/CssSelectorParser.vala"
	_tmp30_ = _tmp29_;
#line 467 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (_tmp30_, "enabled") == 0) {
#line 467 "../gxml/CssSelectorParser.vala"
		_tmp28_ = TRUE;
#line 4733 "CssSelectorParser.c"
	} else {
		const gchar* _tmp31_;
		const gchar* _tmp32_;
#line 467 "../gxml/CssSelectorParser.vala"
		_tmp31_ = gxml_css_selector_get_name (selector);
#line 467 "../gxml/CssSelectorParser.vala"
		_tmp32_ = _tmp31_;
#line 467 "../gxml/CssSelectorParser.vala"
		_tmp28_ = g_strcmp0 (_tmp32_, "disabled") == 0;
#line 4743 "CssSelectorParser.c"
	}
#line 467 "../gxml/CssSelectorParser.vala"
	if (_tmp28_) {
#line 4747 "CssSelectorParser.c"
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gboolean _tmp36_;
		const gchar* _tmp37_;
		const gchar* _tmp38_;
		GXmlDomNamedNodeMap* _tmp45_;
		GXmlDomNamedNodeMap* _tmp46_;
		GXmlDomNamedNodeMap* _tmp47_;
		GXmlDomNode* _tmp48_;
		GXmlDomNode* _tmp49_;
		gboolean _tmp50_;
#line 468 "../gxml/CssSelectorParser.vala"
		_tmp33_ = gxml_dom_element_get_local_name (element);
#line 468 "../gxml/CssSelectorParser.vala"
		_tmp34_ = _tmp33_;
#line 468 "../gxml/CssSelectorParser.vala"
		_tmp35_ = _tmp34_;
#line 468 "../gxml/CssSelectorParser.vala"
		_tmp36_ = g_strcmp0 (_tmp35_, "input") != 0;
#line 468 "../gxml/CssSelectorParser.vala"
		_g_free0 (_tmp35_);
#line 468 "../gxml/CssSelectorParser.vala"
		if (_tmp36_) {
#line 469 "../gxml/CssSelectorParser.vala"
			result = FALSE;
#line 469 "../gxml/CssSelectorParser.vala"
			return result;
#line 4776 "CssSelectorParser.c"
		}
#line 470 "../gxml/CssSelectorParser.vala"
		_tmp37_ = gxml_css_selector_get_name (selector);
#line 470 "../gxml/CssSelectorParser.vala"
		_tmp38_ = _tmp37_;
#line 470 "../gxml/CssSelectorParser.vala"
		if (g_strcmp0 (_tmp38_, "disabled") == 0) {
#line 4784 "CssSelectorParser.c"
			GXmlDomNamedNodeMap* _tmp39_;
			GXmlDomNamedNodeMap* _tmp40_;
			GXmlDomNamedNodeMap* _tmp41_;
			GXmlDomNode* _tmp42_;
			GXmlDomNode* _tmp43_;
			gboolean _tmp44_;
#line 471 "../gxml/CssSelectorParser.vala"
			_tmp39_ = gxml_dom_element_get_attributes (element);
#line 471 "../gxml/CssSelectorParser.vala"
			_tmp40_ = _tmp39_;
#line 471 "../gxml/CssSelectorParser.vala"
			_tmp41_ = _tmp40_;
#line 471 "../gxml/CssSelectorParser.vala"
			_tmp42_ = gxml_dom_named_node_map_get_named_item (_tmp41_, "disabled");
#line 471 "../gxml/CssSelectorParser.vala"
			_tmp43_ = _tmp42_;
#line 471 "../gxml/CssSelectorParser.vala"
			_tmp44_ = _tmp43_ != NULL;
#line 471 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (_tmp43_);
#line 471 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (_tmp41_);
#line 471 "../gxml/CssSelectorParser.vala"
			result = _tmp44_;
#line 471 "../gxml/CssSelectorParser.vala"
			return result;
#line 4811 "CssSelectorParser.c"
		}
#line 472 "../gxml/CssSelectorParser.vala"
		_tmp45_ = gxml_dom_element_get_attributes (element);
#line 472 "../gxml/CssSelectorParser.vala"
		_tmp46_ = _tmp45_;
#line 472 "../gxml/CssSelectorParser.vala"
		_tmp47_ = _tmp46_;
#line 472 "../gxml/CssSelectorParser.vala"
		_tmp48_ = gxml_dom_named_node_map_get_named_item (_tmp47_, "disabled");
#line 472 "../gxml/CssSelectorParser.vala"
		_tmp49_ = _tmp48_;
#line 472 "../gxml/CssSelectorParser.vala"
		_tmp50_ = _tmp49_ == NULL;
#line 472 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp49_);
#line 472 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp47_);
#line 472 "../gxml/CssSelectorParser.vala"
		result = _tmp50_;
#line 472 "../gxml/CssSelectorParser.vala"
		return result;
#line 4833 "CssSelectorParser.c"
	}
#line 474 "../gxml/CssSelectorParser.vala"
	_tmp51_ = gxml_css_selector_get_name (selector);
#line 474 "../gxml/CssSelectorParser.vala"
	_tmp52_ = _tmp51_;
#line 474 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (_tmp52_, "first-child") == 0) {
#line 4841 "CssSelectorParser.c"
		GXmlDomElement* _tmp53_;
		GXmlDomElement* _tmp54_;
		GXmlDomElement* _tmp55_;
		gboolean _tmp56_;
#line 475 "../gxml/CssSelectorParser.vala"
		_tmp53_ = gxml_dom_non_document_type_child_node_get_previous_element_sibling ((GXmlDomNonDocumentTypeChildNode*) element);
#line 475 "../gxml/CssSelectorParser.vala"
		_tmp54_ = _tmp53_;
#line 475 "../gxml/CssSelectorParser.vala"
		_tmp55_ = _tmp54_;
#line 475 "../gxml/CssSelectorParser.vala"
		_tmp56_ = _tmp55_ == NULL;
#line 475 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp55_);
#line 475 "../gxml/CssSelectorParser.vala"
		result = _tmp56_;
#line 475 "../gxml/CssSelectorParser.vala"
		return result;
#line 4860 "CssSelectorParser.c"
	}
#line 476 "../gxml/CssSelectorParser.vala"
	_tmp57_ = gxml_css_selector_get_name (selector);
#line 476 "../gxml/CssSelectorParser.vala"
	_tmp58_ = _tmp57_;
#line 476 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (_tmp58_, "last-child") == 0) {
#line 4868 "CssSelectorParser.c"
		GXmlDomElement* _tmp59_;
		GXmlDomElement* _tmp60_;
		GXmlDomElement* _tmp61_;
		gboolean _tmp62_;
#line 477 "../gxml/CssSelectorParser.vala"
		_tmp59_ = gxml_dom_non_document_type_child_node_get_next_element_sibling ((GXmlDomNonDocumentTypeChildNode*) element);
#line 477 "../gxml/CssSelectorParser.vala"
		_tmp60_ = _tmp59_;
#line 477 "../gxml/CssSelectorParser.vala"
		_tmp61_ = _tmp60_;
#line 477 "../gxml/CssSelectorParser.vala"
		_tmp62_ = _tmp61_ == NULL;
#line 477 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp61_);
#line 477 "../gxml/CssSelectorParser.vala"
		result = _tmp62_;
#line 477 "../gxml/CssSelectorParser.vala"
		return result;
#line 4887 "CssSelectorParser.c"
	}
#line 478 "../gxml/CssSelectorParser.vala"
	_tmp63_ = gxml_css_selector_get_name (selector);
#line 478 "../gxml/CssSelectorParser.vala"
	_tmp64_ = _tmp63_;
#line 478 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (_tmp64_, "only-child") == 0) {
#line 4895 "CssSelectorParser.c"
		gboolean _tmp65_ = FALSE;
		GXmlDomElement* _tmp66_;
		GXmlDomElement* _tmp67_;
		GXmlDomElement* _tmp68_;
		gboolean _tmp69_;
#line 479 "../gxml/CssSelectorParser.vala"
		_tmp66_ = gxml_dom_non_document_type_child_node_get_previous_element_sibling ((GXmlDomNonDocumentTypeChildNode*) element);
#line 479 "../gxml/CssSelectorParser.vala"
		_tmp67_ = _tmp66_;
#line 479 "../gxml/CssSelectorParser.vala"
		_tmp68_ = _tmp67_;
#line 479 "../gxml/CssSelectorParser.vala"
		_tmp69_ = _tmp68_ == NULL;
#line 479 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp68_);
#line 479 "../gxml/CssSelectorParser.vala"
		if (_tmp69_) {
#line 4913 "CssSelectorParser.c"
			GXmlDomElement* _tmp70_;
			GXmlDomElement* _tmp71_;
			GXmlDomElement* _tmp72_;
#line 479 "../gxml/CssSelectorParser.vala"
			_tmp70_ = gxml_dom_non_document_type_child_node_get_next_element_sibling ((GXmlDomNonDocumentTypeChildNode*) element);
#line 479 "../gxml/CssSelectorParser.vala"
			_tmp71_ = _tmp70_;
#line 479 "../gxml/CssSelectorParser.vala"
			_tmp72_ = _tmp71_;
#line 479 "../gxml/CssSelectorParser.vala"
			_tmp65_ = _tmp72_ == NULL;
#line 479 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (_tmp72_);
#line 4927 "CssSelectorParser.c"
		} else {
#line 479 "../gxml/CssSelectorParser.vala"
			_tmp65_ = FALSE;
#line 4931 "CssSelectorParser.c"
		}
#line 479 "../gxml/CssSelectorParser.vala"
		result = _tmp65_;
#line 479 "../gxml/CssSelectorParser.vala"
		return result;
#line 4937 "CssSelectorParser.c"
	}
#line 480 "../gxml/CssSelectorParser.vala"
	_tmp73_ = gxml_css_selector_get_name (selector);
#line 480 "../gxml/CssSelectorParser.vala"
	_tmp74_ = _tmp73_;
#line 480 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (_tmp74_, "first-of-type") == 0) {
#line 4945 "CssSelectorParser.c"
		GXmlDomElement* e = NULL;
		GXmlDomElement* _tmp75_;
		GXmlDomElement* _tmp76_;
		gboolean res = FALSE;
#line 481 "../gxml/CssSelectorParser.vala"
		_tmp75_ = gxml_dom_non_document_type_child_node_get_previous_element_sibling ((GXmlDomNonDocumentTypeChildNode*) element);
#line 481 "../gxml/CssSelectorParser.vala"
		_tmp76_ = _tmp75_;
#line 481 "../gxml/CssSelectorParser.vala"
		e = _tmp76_;
#line 482 "../gxml/CssSelectorParser.vala"
		res = TRUE;
#line 483 "../gxml/CssSelectorParser.vala"
		while (TRUE) {
#line 4960 "CssSelectorParser.c"
			GXmlDomElement* _tmp77_;
			GXmlDomElement* _tmp78_;
			gchar* _tmp79_;
			gchar* _tmp80_;
			gchar* _tmp81_;
			gchar* _tmp82_;
			gchar* _tmp83_;
			gchar* _tmp84_;
			gboolean _tmp85_;
			GXmlDomElement* _tmp86_;
			GXmlDomElement* _tmp87_;
			GXmlDomElement* _tmp88_;
#line 483 "../gxml/CssSelectorParser.vala"
			_tmp77_ = e;
#line 483 "../gxml/CssSelectorParser.vala"
			if (!(_tmp77_ != NULL)) {
#line 483 "../gxml/CssSelectorParser.vala"
				break;
#line 4979 "CssSelectorParser.c"
			}
#line 484 "../gxml/CssSelectorParser.vala"
			_tmp78_ = e;
#line 484 "../gxml/CssSelectorParser.vala"
			_tmp79_ = gxml_dom_element_get_local_name (_tmp78_);
#line 484 "../gxml/CssSelectorParser.vala"
			_tmp80_ = _tmp79_;
#line 484 "../gxml/CssSelectorParser.vala"
			_tmp81_ = _tmp80_;
#line 484 "../gxml/CssSelectorParser.vala"
			_tmp82_ = gxml_dom_element_get_local_name (element);
#line 484 "../gxml/CssSelectorParser.vala"
			_tmp83_ = _tmp82_;
#line 484 "../gxml/CssSelectorParser.vala"
			_tmp84_ = _tmp83_;
#line 484 "../gxml/CssSelectorParser.vala"
			_tmp85_ = g_strcmp0 (_tmp81_, _tmp84_) == 0;
#line 484 "../gxml/CssSelectorParser.vala"
			_g_free0 (_tmp84_);
#line 484 "../gxml/CssSelectorParser.vala"
			_g_free0 (_tmp81_);
#line 484 "../gxml/CssSelectorParser.vala"
			if (_tmp85_) {
#line 485 "../gxml/CssSelectorParser.vala"
				res = FALSE;
#line 5005 "CssSelectorParser.c"
			}
#line 486 "../gxml/CssSelectorParser.vala"
			_tmp86_ = e;
#line 486 "../gxml/CssSelectorParser.vala"
			_tmp87_ = gxml_dom_non_document_type_child_node_get_previous_element_sibling ((GXmlDomNonDocumentTypeChildNode*) _tmp86_);
#line 486 "../gxml/CssSelectorParser.vala"
			_tmp88_ = _tmp87_;
#line 486 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (e);
#line 486 "../gxml/CssSelectorParser.vala"
			e = _tmp88_;
#line 5017 "CssSelectorParser.c"
		}
#line 488 "../gxml/CssSelectorParser.vala"
		result = res;
#line 488 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (e);
#line 488 "../gxml/CssSelectorParser.vala"
		return result;
#line 5025 "CssSelectorParser.c"
	}
#line 490 "../gxml/CssSelectorParser.vala"
	_tmp89_ = gxml_css_selector_get_name (selector);
#line 490 "../gxml/CssSelectorParser.vala"
	_tmp90_ = _tmp89_;
#line 490 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (_tmp90_, "last-of-type") == 0) {
#line 5033 "CssSelectorParser.c"
		GXmlDomElement* e = NULL;
		GXmlDomElement* _tmp91_;
		GXmlDomElement* _tmp92_;
		gboolean res = FALSE;
#line 491 "../gxml/CssSelectorParser.vala"
		_tmp91_ = gxml_dom_non_document_type_child_node_get_next_element_sibling ((GXmlDomNonDocumentTypeChildNode*) element);
#line 491 "../gxml/CssSelectorParser.vala"
		_tmp92_ = _tmp91_;
#line 491 "../gxml/CssSelectorParser.vala"
		e = _tmp92_;
#line 492 "../gxml/CssSelectorParser.vala"
		res = TRUE;
#line 493 "../gxml/CssSelectorParser.vala"
		while (TRUE) {
#line 5048 "CssSelectorParser.c"
			GXmlDomElement* _tmp93_;
			GXmlDomElement* _tmp94_;
			gchar* _tmp95_;
			gchar* _tmp96_;
			gchar* _tmp97_;
			gchar* _tmp98_;
			gchar* _tmp99_;
			gchar* _tmp100_;
			gboolean _tmp101_;
			GXmlDomElement* _tmp102_;
			GXmlDomElement* _tmp103_;
			GXmlDomElement* _tmp104_;
#line 493 "../gxml/CssSelectorParser.vala"
			_tmp93_ = e;
#line 493 "../gxml/CssSelectorParser.vala"
			if (!(_tmp93_ != NULL)) {
#line 493 "../gxml/CssSelectorParser.vala"
				break;
#line 5067 "CssSelectorParser.c"
			}
#line 494 "../gxml/CssSelectorParser.vala"
			_tmp94_ = e;
#line 494 "../gxml/CssSelectorParser.vala"
			_tmp95_ = gxml_dom_element_get_local_name (_tmp94_);
#line 494 "../gxml/CssSelectorParser.vala"
			_tmp96_ = _tmp95_;
#line 494 "../gxml/CssSelectorParser.vala"
			_tmp97_ = _tmp96_;
#line 494 "../gxml/CssSelectorParser.vala"
			_tmp98_ = gxml_dom_element_get_local_name (element);
#line 494 "../gxml/CssSelectorParser.vala"
			_tmp99_ = _tmp98_;
#line 494 "../gxml/CssSelectorParser.vala"
			_tmp100_ = _tmp99_;
#line 494 "../gxml/CssSelectorParser.vala"
			_tmp101_ = g_strcmp0 (_tmp97_, _tmp100_) == 0;
#line 494 "../gxml/CssSelectorParser.vala"
			_g_free0 (_tmp100_);
#line 494 "../gxml/CssSelectorParser.vala"
			_g_free0 (_tmp97_);
#line 494 "../gxml/CssSelectorParser.vala"
			if (_tmp101_) {
#line 495 "../gxml/CssSelectorParser.vala"
				res = FALSE;
#line 5093 "CssSelectorParser.c"
			}
#line 496 "../gxml/CssSelectorParser.vala"
			_tmp102_ = e;
#line 496 "../gxml/CssSelectorParser.vala"
			_tmp103_ = gxml_dom_non_document_type_child_node_get_next_element_sibling ((GXmlDomNonDocumentTypeChildNode*) _tmp102_);
#line 496 "../gxml/CssSelectorParser.vala"
			_tmp104_ = _tmp103_;
#line 496 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (e);
#line 496 "../gxml/CssSelectorParser.vala"
			e = _tmp104_;
#line 5105 "CssSelectorParser.c"
		}
#line 498 "../gxml/CssSelectorParser.vala"
		result = res;
#line 498 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (e);
#line 498 "../gxml/CssSelectorParser.vala"
		return result;
#line 5113 "CssSelectorParser.c"
	}
#line 500 "../gxml/CssSelectorParser.vala"
	_tmp105_ = gxml_css_selector_get_name (selector);
#line 500 "../gxml/CssSelectorParser.vala"
	_tmp106_ = _tmp105_;
#line 500 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (_tmp106_, "only-of-type") == 0) {
#line 5121 "CssSelectorParser.c"
		GXmlDomElement* e = NULL;
		GXmlDomElement* _tmp107_;
		GXmlDomElement* _tmp108_;
		GXmlDomElement* f = NULL;
		GXmlDomElement* _tmp109_;
		GXmlDomElement* _tmp110_;
		gboolean eres = FALSE;
		gboolean fres = FALSE;
		gboolean _tmp135_ = FALSE;
#line 501 "../gxml/CssSelectorParser.vala"
		_tmp107_ = gxml_dom_non_document_type_child_node_get_previous_element_sibling ((GXmlDomNonDocumentTypeChildNode*) element);
#line 501 "../gxml/CssSelectorParser.vala"
		_tmp108_ = _tmp107_;
#line 501 "../gxml/CssSelectorParser.vala"
		e = _tmp108_;
#line 502 "../gxml/CssSelectorParser.vala"
		_tmp109_ = gxml_dom_non_document_type_child_node_get_next_element_sibling ((GXmlDomNonDocumentTypeChildNode*) element);
#line 502 "../gxml/CssSelectorParser.vala"
		_tmp110_ = _tmp109_;
#line 502 "../gxml/CssSelectorParser.vala"
		f = _tmp110_;
#line 503 "../gxml/CssSelectorParser.vala"
		eres = TRUE;
#line 504 "../gxml/CssSelectorParser.vala"
		fres = TRUE;
#line 505 "../gxml/CssSelectorParser.vala"
		while (TRUE) {
#line 5149 "CssSelectorParser.c"
			GXmlDomElement* _tmp111_;
			GXmlDomElement* _tmp112_;
			gchar* _tmp113_;
			gchar* _tmp114_;
			gchar* _tmp115_;
			gchar* _tmp116_;
			gchar* _tmp117_;
			gchar* _tmp118_;
			gboolean _tmp119_;
			GXmlDomElement* _tmp120_;
			GXmlDomElement* _tmp121_;
			GXmlDomElement* _tmp122_;
#line 505 "../gxml/CssSelectorParser.vala"
			_tmp111_ = e;
#line 505 "../gxml/CssSelectorParser.vala"
			if (!(_tmp111_ != NULL)) {
#line 505 "../gxml/CssSelectorParser.vala"
				break;
#line 5168 "CssSelectorParser.c"
			}
#line 506 "../gxml/CssSelectorParser.vala"
			_tmp112_ = e;
#line 506 "../gxml/CssSelectorParser.vala"
			_tmp113_ = gxml_dom_element_get_local_name (_tmp112_);
#line 506 "../gxml/CssSelectorParser.vala"
			_tmp114_ = _tmp113_;
#line 506 "../gxml/CssSelectorParser.vala"
			_tmp115_ = _tmp114_;
#line 506 "../gxml/CssSelectorParser.vala"
			_tmp116_ = gxml_dom_element_get_local_name (element);
#line 506 "../gxml/CssSelectorParser.vala"
			_tmp117_ = _tmp116_;
#line 506 "../gxml/CssSelectorParser.vala"
			_tmp118_ = _tmp117_;
#line 506 "../gxml/CssSelectorParser.vala"
			_tmp119_ = g_strcmp0 (_tmp115_, _tmp118_) == 0;
#line 506 "../gxml/CssSelectorParser.vala"
			_g_free0 (_tmp118_);
#line 506 "../gxml/CssSelectorParser.vala"
			_g_free0 (_tmp115_);
#line 506 "../gxml/CssSelectorParser.vala"
			if (_tmp119_) {
#line 507 "../gxml/CssSelectorParser.vala"
				eres = FALSE;
#line 5194 "CssSelectorParser.c"
			}
#line 508 "../gxml/CssSelectorParser.vala"
			_tmp120_ = e;
#line 508 "../gxml/CssSelectorParser.vala"
			_tmp121_ = gxml_dom_non_document_type_child_node_get_previous_element_sibling ((GXmlDomNonDocumentTypeChildNode*) _tmp120_);
#line 508 "../gxml/CssSelectorParser.vala"
			_tmp122_ = _tmp121_;
#line 508 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (e);
#line 508 "../gxml/CssSelectorParser.vala"
			e = _tmp122_;
#line 5206 "CssSelectorParser.c"
		}
#line 510 "../gxml/CssSelectorParser.vala"
		while (TRUE) {
#line 5210 "CssSelectorParser.c"
			GXmlDomElement* _tmp123_;
			GXmlDomElement* _tmp124_;
			gchar* _tmp125_;
			gchar* _tmp126_;
			gchar* _tmp127_;
			gchar* _tmp128_;
			gchar* _tmp129_;
			gchar* _tmp130_;
			gboolean _tmp131_;
			GXmlDomElement* _tmp132_;
			GXmlDomElement* _tmp133_;
			GXmlDomElement* _tmp134_;
#line 510 "../gxml/CssSelectorParser.vala"
			_tmp123_ = f;
#line 510 "../gxml/CssSelectorParser.vala"
			if (!(_tmp123_ != NULL)) {
#line 510 "../gxml/CssSelectorParser.vala"
				break;
#line 5229 "CssSelectorParser.c"
			}
#line 511 "../gxml/CssSelectorParser.vala"
			_tmp124_ = f;
#line 511 "../gxml/CssSelectorParser.vala"
			_tmp125_ = gxml_dom_element_get_local_name (_tmp124_);
#line 511 "../gxml/CssSelectorParser.vala"
			_tmp126_ = _tmp125_;
#line 511 "../gxml/CssSelectorParser.vala"
			_tmp127_ = _tmp126_;
#line 511 "../gxml/CssSelectorParser.vala"
			_tmp128_ = gxml_dom_element_get_local_name (element);
#line 511 "../gxml/CssSelectorParser.vala"
			_tmp129_ = _tmp128_;
#line 511 "../gxml/CssSelectorParser.vala"
			_tmp130_ = _tmp129_;
#line 511 "../gxml/CssSelectorParser.vala"
			_tmp131_ = g_strcmp0 (_tmp127_, _tmp130_) == 0;
#line 511 "../gxml/CssSelectorParser.vala"
			_g_free0 (_tmp130_);
#line 511 "../gxml/CssSelectorParser.vala"
			_g_free0 (_tmp127_);
#line 511 "../gxml/CssSelectorParser.vala"
			if (_tmp131_) {
#line 512 "../gxml/CssSelectorParser.vala"
				fres = FALSE;
#line 5255 "CssSelectorParser.c"
			}
#line 513 "../gxml/CssSelectorParser.vala"
			_tmp132_ = f;
#line 513 "../gxml/CssSelectorParser.vala"
			_tmp133_ = gxml_dom_non_document_type_child_node_get_next_element_sibling ((GXmlDomNonDocumentTypeChildNode*) _tmp132_);
#line 513 "../gxml/CssSelectorParser.vala"
			_tmp134_ = _tmp133_;
#line 513 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (f);
#line 513 "../gxml/CssSelectorParser.vala"
			f = _tmp134_;
#line 5267 "CssSelectorParser.c"
		}
#line 515 "../gxml/CssSelectorParser.vala"
		if (eres) {
#line 515 "../gxml/CssSelectorParser.vala"
			_tmp135_ = fres;
#line 5273 "CssSelectorParser.c"
		} else {
#line 515 "../gxml/CssSelectorParser.vala"
			_tmp135_ = FALSE;
#line 5277 "CssSelectorParser.c"
		}
#line 515 "../gxml/CssSelectorParser.vala"
		result = _tmp135_;
#line 515 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (f);
#line 515 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (e);
#line 515 "../gxml/CssSelectorParser.vala"
		return result;
#line 5287 "CssSelectorParser.c"
	}
#line 517 "../gxml/CssSelectorParser.vala"
	_tmp136_ = gxml_css_selector_get_name (selector);
#line 517 "../gxml/CssSelectorParser.vala"
	_tmp137_ = _tmp136_;
#line 517 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (_tmp137_, "nth-child") == 0) {
#line 5295 "CssSelectorParser.c"
		GXmlDomElement* _tmp138_;
		GXmlDomElement* _tmp139_;
		GXmlDomElement* _tmp140_;
		gboolean _tmp141_;
		gboolean _tmp142_ = FALSE;
		const gchar* _tmp143_;
		const gchar* _tmp144_;
		gint index = 0;
		const gchar* _tmp169_;
		const gchar* _tmp170_;
		GXmlDomElement* _tmp171_;
		GXmlDomElement* _tmp172_;
		GXmlDomElement* _tmp173_;
		GXmlDomHTMLCollection* _tmp174_;
		GXmlDomHTMLCollection* _tmp175_;
		GXmlDomHTMLCollection* _tmp176_;
		gint _tmp177_;
		gint _tmp178_;
		gboolean _tmp179_;
		GXmlDomElement* _tmp180_;
		GXmlDomElement* _tmp181_;
		GXmlDomElement* _tmp182_;
		GXmlDomHTMLCollection* _tmp183_;
		GXmlDomHTMLCollection* _tmp184_;
		GXmlDomHTMLCollection* _tmp185_;
		GXmlDomElement* _tmp186_;
		GXmlDomElement* _tmp187_;
		gboolean _tmp188_;
#line 518 "../gxml/CssSelectorParser.vala"
		_tmp138_ = gxml_dom_node_get_parent_element ((GXmlDomNode*) element);
#line 518 "../gxml/CssSelectorParser.vala"
		_tmp139_ = _tmp138_;
#line 518 "../gxml/CssSelectorParser.vala"
		_tmp140_ = _tmp139_;
#line 518 "../gxml/CssSelectorParser.vala"
		_tmp141_ = _tmp140_ == NULL;
#line 518 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp140_);
#line 518 "../gxml/CssSelectorParser.vala"
		if (_tmp141_) {
#line 519 "../gxml/CssSelectorParser.vala"
			result = FALSE;
#line 519 "../gxml/CssSelectorParser.vala"
			return result;
#line 5340 "CssSelectorParser.c"
		}
#line 520 "../gxml/CssSelectorParser.vala"
		_tmp143_ = gxml_css_selector_get_value (selector);
#line 520 "../gxml/CssSelectorParser.vala"
		_tmp144_ = _tmp143_;
#line 520 "../gxml/CssSelectorParser.vala"
		if (g_strcmp0 (_tmp144_, "even") == 0) {
#line 520 "../gxml/CssSelectorParser.vala"
			_tmp142_ = TRUE;
#line 5350 "CssSelectorParser.c"
		} else {
			const gchar* _tmp145_;
			const gchar* _tmp146_;
#line 520 "../gxml/CssSelectorParser.vala"
			_tmp145_ = gxml_css_selector_get_value (selector);
#line 520 "../gxml/CssSelectorParser.vala"
			_tmp146_ = _tmp145_;
#line 520 "../gxml/CssSelectorParser.vala"
			_tmp142_ = g_strcmp0 (_tmp146_, "odd") == 0;
#line 5360 "CssSelectorParser.c"
		}
#line 520 "../gxml/CssSelectorParser.vala"
		if (_tmp142_) {
#line 5364 "CssSelectorParser.c"
			{
				gint _tmp147_ = 0;
				const gchar* _tmp148_;
				const gchar* _tmp149_;
				gint i = 0;
#line 521 "../gxml/CssSelectorParser.vala"
				_tmp148_ = gxml_css_selector_get_value (selector);
#line 521 "../gxml/CssSelectorParser.vala"
				_tmp149_ = _tmp148_;
#line 521 "../gxml/CssSelectorParser.vala"
				if (g_strcmp0 (_tmp149_, "even") == 0) {
#line 521 "../gxml/CssSelectorParser.vala"
					_tmp147_ = 1;
#line 5378 "CssSelectorParser.c"
				} else {
#line 521 "../gxml/CssSelectorParser.vala"
					_tmp147_ = 0;
#line 5382 "CssSelectorParser.c"
				}
#line 521 "../gxml/CssSelectorParser.vala"
				i = _tmp147_;
#line 5386 "CssSelectorParser.c"
				{
					gboolean _tmp150_ = FALSE;
#line 521 "../gxml/CssSelectorParser.vala"
					_tmp150_ = TRUE;
#line 521 "../gxml/CssSelectorParser.vala"
					while (TRUE) {
#line 5393 "CssSelectorParser.c"
						GXmlDomElement* _tmp151_;
						GXmlDomElement* _tmp152_;
						GXmlDomElement* _tmp153_;
						GXmlDomHTMLCollection* _tmp154_;
						GXmlDomHTMLCollection* _tmp155_;
						GXmlDomHTMLCollection* _tmp156_;
						gint _tmp157_;
						gint _tmp158_;
						gboolean _tmp159_;
						GXmlDomElement* child = NULL;
						GXmlDomElement* _tmp160_;
						GXmlDomElement* _tmp161_;
						GXmlDomElement* _tmp162_;
						GXmlDomHTMLCollection* _tmp163_;
						GXmlDomHTMLCollection* _tmp164_;
						GXmlDomHTMLCollection* _tmp165_;
						GXmlDomElement* _tmp166_;
						GXmlDomElement* _tmp167_;
						GXmlDomElement* _tmp168_;
#line 521 "../gxml/CssSelectorParser.vala"
						if (!_tmp150_) {
#line 521 "../gxml/CssSelectorParser.vala"
							i += 2;
#line 5417 "CssSelectorParser.c"
						}
#line 521 "../gxml/CssSelectorParser.vala"
						_tmp150_ = FALSE;
#line 521 "../gxml/CssSelectorParser.vala"
						_tmp151_ = gxml_dom_node_get_parent_element ((GXmlDomNode*) element);
#line 521 "../gxml/CssSelectorParser.vala"
						_tmp152_ = _tmp151_;
#line 521 "../gxml/CssSelectorParser.vala"
						_tmp153_ = _tmp152_;
#line 521 "../gxml/CssSelectorParser.vala"
						_tmp154_ = gxml_dom_parent_node_get_children ((GXmlDomParentNode*) _tmp153_);
#line 521 "../gxml/CssSelectorParser.vala"
						_tmp155_ = _tmp154_;
#line 521 "../gxml/CssSelectorParser.vala"
						_tmp156_ = _tmp155_;
#line 521 "../gxml/CssSelectorParser.vala"
						_tmp157_ = gxml_dom_html_collection_get_length (_tmp156_);
#line 521 "../gxml/CssSelectorParser.vala"
						_tmp158_ = _tmp157_;
#line 521 "../gxml/CssSelectorParser.vala"
						_tmp159_ = !(i < _tmp158_);
#line 521 "../gxml/CssSelectorParser.vala"
						_g_object_unref0 (_tmp156_);
#line 521 "../gxml/CssSelectorParser.vala"
						_g_object_unref0 (_tmp153_);
#line 521 "../gxml/CssSelectorParser.vala"
						if (_tmp159_) {
#line 521 "../gxml/CssSelectorParser.vala"
							break;
#line 5447 "CssSelectorParser.c"
						}
#line 522 "../gxml/CssSelectorParser.vala"
						_tmp160_ = gxml_dom_node_get_parent_element ((GXmlDomNode*) element);
#line 522 "../gxml/CssSelectorParser.vala"
						_tmp161_ = _tmp160_;
#line 522 "../gxml/CssSelectorParser.vala"
						_tmp162_ = _tmp161_;
#line 522 "../gxml/CssSelectorParser.vala"
						_tmp163_ = gxml_dom_parent_node_get_children ((GXmlDomParentNode*) _tmp162_);
#line 522 "../gxml/CssSelectorParser.vala"
						_tmp164_ = _tmp163_;
#line 522 "../gxml/CssSelectorParser.vala"
						_tmp165_ = _tmp164_;
#line 522 "../gxml/CssSelectorParser.vala"
						_tmp166_ = gxml_dom_html_collection_item (_tmp165_, i);
#line 522 "../gxml/CssSelectorParser.vala"
						_tmp167_ = _tmp166_;
#line 522 "../gxml/CssSelectorParser.vala"
						_g_object_unref0 (_tmp165_);
#line 522 "../gxml/CssSelectorParser.vala"
						_g_object_unref0 (_tmp162_);
#line 522 "../gxml/CssSelectorParser.vala"
						child = _tmp167_;
#line 523 "../gxml/CssSelectorParser.vala"
						_tmp168_ = child;
#line 523 "../gxml/CssSelectorParser.vala"
						if (_tmp168_ == element) {
#line 524 "../gxml/CssSelectorParser.vala"
							result = TRUE;
#line 524 "../gxml/CssSelectorParser.vala"
							_g_object_unref0 (child);
#line 524 "../gxml/CssSelectorParser.vala"
							return result;
#line 5481 "CssSelectorParser.c"
						}
#line 521 "../gxml/CssSelectorParser.vala"
						_g_object_unref0 (child);
#line 5485 "CssSelectorParser.c"
					}
				}
			}
#line 526 "../gxml/CssSelectorParser.vala"
			result = FALSE;
#line 526 "../gxml/CssSelectorParser.vala"
			return result;
#line 5493 "CssSelectorParser.c"
		}
#line 528 "../gxml/CssSelectorParser.vala"
		_tmp169_ = gxml_css_selector_get_value (selector);
#line 528 "../gxml/CssSelectorParser.vala"
		_tmp170_ = _tmp169_;
#line 528 "../gxml/CssSelectorParser.vala"
		index = atoi (_tmp170_) - 1;
#line 529 "../gxml/CssSelectorParser.vala"
		_tmp171_ = gxml_dom_node_get_parent_element ((GXmlDomNode*) element);
#line 529 "../gxml/CssSelectorParser.vala"
		_tmp172_ = _tmp171_;
#line 529 "../gxml/CssSelectorParser.vala"
		_tmp173_ = _tmp172_;
#line 529 "../gxml/CssSelectorParser.vala"
		_tmp174_ = gxml_dom_parent_node_get_children ((GXmlDomParentNode*) _tmp173_);
#line 529 "../gxml/CssSelectorParser.vala"
		_tmp175_ = _tmp174_;
#line 529 "../gxml/CssSelectorParser.vala"
		_tmp176_ = _tmp175_;
#line 529 "../gxml/CssSelectorParser.vala"
		_tmp177_ = gxml_dom_html_collection_get_length (_tmp176_);
#line 529 "../gxml/CssSelectorParser.vala"
		_tmp178_ = _tmp177_;
#line 529 "../gxml/CssSelectorParser.vala"
		_tmp179_ = index >= _tmp178_;
#line 529 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp176_);
#line 529 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp173_);
#line 529 "../gxml/CssSelectorParser.vala"
		if (_tmp179_) {
#line 530 "../gxml/CssSelectorParser.vala"
			result = FALSE;
#line 530 "../gxml/CssSelectorParser.vala"
			return result;
#line 5529 "CssSelectorParser.c"
		}
#line 531 "../gxml/CssSelectorParser.vala"
		_tmp180_ = gxml_dom_node_get_parent_element ((GXmlDomNode*) element);
#line 531 "../gxml/CssSelectorParser.vala"
		_tmp181_ = _tmp180_;
#line 531 "../gxml/CssSelectorParser.vala"
		_tmp182_ = _tmp181_;
#line 531 "../gxml/CssSelectorParser.vala"
		_tmp183_ = gxml_dom_parent_node_get_children ((GXmlDomParentNode*) _tmp182_);
#line 531 "../gxml/CssSelectorParser.vala"
		_tmp184_ = _tmp183_;
#line 531 "../gxml/CssSelectorParser.vala"
		_tmp185_ = _tmp184_;
#line 531 "../gxml/CssSelectorParser.vala"
		_tmp186_ = gxml_dom_html_collection_item (_tmp185_, index);
#line 531 "../gxml/CssSelectorParser.vala"
		_tmp187_ = _tmp186_;
#line 531 "../gxml/CssSelectorParser.vala"
		_tmp188_ = element == _tmp187_;
#line 531 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp187_);
#line 531 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp185_);
#line 531 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp182_);
#line 531 "../gxml/CssSelectorParser.vala"
		result = _tmp188_;
#line 531 "../gxml/CssSelectorParser.vala"
		return result;
#line 5559 "CssSelectorParser.c"
	}
#line 533 "../gxml/CssSelectorParser.vala"
	_tmp189_ = gxml_css_selector_get_name (selector);
#line 533 "../gxml/CssSelectorParser.vala"
	_tmp190_ = _tmp189_;
#line 533 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (_tmp190_, "nth-last-child") == 0) {
#line 5567 "CssSelectorParser.c"
		GXmlDomElement* _tmp191_;
		GXmlDomElement* _tmp192_;
		GXmlDomElement* _tmp193_;
		gboolean _tmp194_;
		gboolean _tmp195_ = FALSE;
		const gchar* _tmp196_;
		const gchar* _tmp197_;
		gint index = 0;
		const gchar* _tmp230_;
		const gchar* _tmp231_;
		GXmlDomElement* _tmp232_;
		GXmlDomElement* _tmp233_;
		GXmlDomElement* _tmp234_;
		GXmlDomHTMLCollection* _tmp235_;
		GXmlDomHTMLCollection* _tmp236_;
		GXmlDomHTMLCollection* _tmp237_;
		gint _tmp238_;
		gint _tmp239_;
		gboolean _tmp240_;
		GXmlDomElement* _tmp241_;
		GXmlDomElement* _tmp242_;
		GXmlDomElement* _tmp243_;
		GXmlDomHTMLCollection* _tmp244_;
		GXmlDomHTMLCollection* _tmp245_;
		GXmlDomHTMLCollection* _tmp246_;
		GXmlDomElement* _tmp247_;
		GXmlDomElement* _tmp248_;
		GXmlDomElement* _tmp249_;
		GXmlDomHTMLCollection* _tmp250_;
		GXmlDomHTMLCollection* _tmp251_;
		GXmlDomHTMLCollection* _tmp252_;
		gint _tmp253_;
		gint _tmp254_;
		GXmlDomElement* _tmp255_;
		GXmlDomElement* _tmp256_;
		gboolean _tmp257_;
#line 534 "../gxml/CssSelectorParser.vala"
		_tmp191_ = gxml_dom_node_get_parent_element ((GXmlDomNode*) element);
#line 534 "../gxml/CssSelectorParser.vala"
		_tmp192_ = _tmp191_;
#line 534 "../gxml/CssSelectorParser.vala"
		_tmp193_ = _tmp192_;
#line 534 "../gxml/CssSelectorParser.vala"
		_tmp194_ = _tmp193_ == NULL;
#line 534 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp193_);
#line 534 "../gxml/CssSelectorParser.vala"
		if (_tmp194_) {
#line 535 "../gxml/CssSelectorParser.vala"
			result = FALSE;
#line 535 "../gxml/CssSelectorParser.vala"
			return result;
#line 5620 "CssSelectorParser.c"
		}
#line 536 "../gxml/CssSelectorParser.vala"
		_tmp196_ = gxml_css_selector_get_value (selector);
#line 536 "../gxml/CssSelectorParser.vala"
		_tmp197_ = _tmp196_;
#line 536 "../gxml/CssSelectorParser.vala"
		if (g_strcmp0 (_tmp197_, "even") == 0) {
#line 536 "../gxml/CssSelectorParser.vala"
			_tmp195_ = TRUE;
#line 5630 "CssSelectorParser.c"
		} else {
			const gchar* _tmp198_;
			const gchar* _tmp199_;
#line 536 "../gxml/CssSelectorParser.vala"
			_tmp198_ = gxml_css_selector_get_value (selector);
#line 536 "../gxml/CssSelectorParser.vala"
			_tmp199_ = _tmp198_;
#line 536 "../gxml/CssSelectorParser.vala"
			_tmp195_ = g_strcmp0 (_tmp199_, "odd") == 0;
#line 5640 "CssSelectorParser.c"
		}
#line 536 "../gxml/CssSelectorParser.vala"
		if (_tmp195_) {
#line 5644 "CssSelectorParser.c"
			{
				gint _tmp200_ = 0;
				const gchar* _tmp201_;
				const gchar* _tmp202_;
				gint i = 0;
#line 537 "../gxml/CssSelectorParser.vala"
				_tmp201_ = gxml_css_selector_get_value (selector);
#line 537 "../gxml/CssSelectorParser.vala"
				_tmp202_ = _tmp201_;
#line 537 "../gxml/CssSelectorParser.vala"
				if (g_strcmp0 (_tmp202_, "even") == 0) {
#line 537 "../gxml/CssSelectorParser.vala"
					_tmp200_ = 1;
#line 5658 "CssSelectorParser.c"
				} else {
#line 537 "../gxml/CssSelectorParser.vala"
					_tmp200_ = 0;
#line 5662 "CssSelectorParser.c"
				}
#line 537 "../gxml/CssSelectorParser.vala"
				i = _tmp200_;
#line 5666 "CssSelectorParser.c"
				{
					gboolean _tmp203_ = FALSE;
#line 537 "../gxml/CssSelectorParser.vala"
					_tmp203_ = TRUE;
#line 537 "../gxml/CssSelectorParser.vala"
					while (TRUE) {
#line 5673 "CssSelectorParser.c"
						GXmlDomElement* _tmp204_;
						GXmlDomElement* _tmp205_;
						GXmlDomElement* _tmp206_;
						GXmlDomHTMLCollection* _tmp207_;
						GXmlDomHTMLCollection* _tmp208_;
						GXmlDomHTMLCollection* _tmp209_;
						gint _tmp210_;
						gint _tmp211_;
						gboolean _tmp212_;
						GXmlDomElement* child = NULL;
						GXmlDomElement* _tmp213_;
						GXmlDomElement* _tmp214_;
						GXmlDomElement* _tmp215_;
						GXmlDomHTMLCollection* _tmp216_;
						GXmlDomHTMLCollection* _tmp217_;
						GXmlDomHTMLCollection* _tmp218_;
						GXmlDomElement* _tmp219_;
						GXmlDomElement* _tmp220_;
						GXmlDomElement* _tmp221_;
						GXmlDomHTMLCollection* _tmp222_;
						GXmlDomHTMLCollection* _tmp223_;
						GXmlDomHTMLCollection* _tmp224_;
						gint _tmp225_;
						gint _tmp226_;
						GXmlDomElement* _tmp227_;
						GXmlDomElement* _tmp228_;
						GXmlDomElement* _tmp229_;
#line 537 "../gxml/CssSelectorParser.vala"
						if (!_tmp203_) {
#line 537 "../gxml/CssSelectorParser.vala"
							i += 2;
#line 5705 "CssSelectorParser.c"
						}
#line 537 "../gxml/CssSelectorParser.vala"
						_tmp203_ = FALSE;
#line 537 "../gxml/CssSelectorParser.vala"
						_tmp204_ = gxml_dom_node_get_parent_element ((GXmlDomNode*) element);
#line 537 "../gxml/CssSelectorParser.vala"
						_tmp205_ = _tmp204_;
#line 537 "../gxml/CssSelectorParser.vala"
						_tmp206_ = _tmp205_;
#line 537 "../gxml/CssSelectorParser.vala"
						_tmp207_ = gxml_dom_parent_node_get_children ((GXmlDomParentNode*) _tmp206_);
#line 537 "../gxml/CssSelectorParser.vala"
						_tmp208_ = _tmp207_;
#line 537 "../gxml/CssSelectorParser.vala"
						_tmp209_ = _tmp208_;
#line 537 "../gxml/CssSelectorParser.vala"
						_tmp210_ = gxml_dom_html_collection_get_length (_tmp209_);
#line 537 "../gxml/CssSelectorParser.vala"
						_tmp211_ = _tmp210_;
#line 537 "../gxml/CssSelectorParser.vala"
						_tmp212_ = !(i < _tmp211_);
#line 537 "../gxml/CssSelectorParser.vala"
						_g_object_unref0 (_tmp209_);
#line 537 "../gxml/CssSelectorParser.vala"
						_g_object_unref0 (_tmp206_);
#line 537 "../gxml/CssSelectorParser.vala"
						if (_tmp212_) {
#line 537 "../gxml/CssSelectorParser.vala"
							break;
#line 5735 "CssSelectorParser.c"
						}
#line 538 "../gxml/CssSelectorParser.vala"
						_tmp213_ = gxml_dom_node_get_parent_element ((GXmlDomNode*) element);
#line 538 "../gxml/CssSelectorParser.vala"
						_tmp214_ = _tmp213_;
#line 538 "../gxml/CssSelectorParser.vala"
						_tmp215_ = _tmp214_;
#line 538 "../gxml/CssSelectorParser.vala"
						_tmp216_ = gxml_dom_parent_node_get_children ((GXmlDomParentNode*) _tmp215_);
#line 538 "../gxml/CssSelectorParser.vala"
						_tmp217_ = _tmp216_;
#line 538 "../gxml/CssSelectorParser.vala"
						_tmp218_ = _tmp217_;
#line 538 "../gxml/CssSelectorParser.vala"
						_tmp219_ = gxml_dom_node_get_parent_element ((GXmlDomNode*) element);
#line 538 "../gxml/CssSelectorParser.vala"
						_tmp220_ = _tmp219_;
#line 538 "../gxml/CssSelectorParser.vala"
						_tmp221_ = _tmp220_;
#line 538 "../gxml/CssSelectorParser.vala"
						_tmp222_ = gxml_dom_parent_node_get_children ((GXmlDomParentNode*) _tmp221_);
#line 538 "../gxml/CssSelectorParser.vala"
						_tmp223_ = _tmp222_;
#line 538 "../gxml/CssSelectorParser.vala"
						_tmp224_ = _tmp223_;
#line 538 "../gxml/CssSelectorParser.vala"
						_tmp225_ = gxml_dom_html_collection_get_length (_tmp224_);
#line 538 "../gxml/CssSelectorParser.vala"
						_tmp226_ = _tmp225_;
#line 538 "../gxml/CssSelectorParser.vala"
						_tmp227_ = gxml_dom_html_collection_item (_tmp218_, (_tmp226_ - 1) - i);
#line 538 "../gxml/CssSelectorParser.vala"
						_tmp228_ = _tmp227_;
#line 538 "../gxml/CssSelectorParser.vala"
						_g_object_unref0 (_tmp224_);
#line 538 "../gxml/CssSelectorParser.vala"
						_g_object_unref0 (_tmp221_);
#line 538 "../gxml/CssSelectorParser.vala"
						_g_object_unref0 (_tmp218_);
#line 538 "../gxml/CssSelectorParser.vala"
						_g_object_unref0 (_tmp215_);
#line 538 "../gxml/CssSelectorParser.vala"
						child = _tmp228_;
#line 539 "../gxml/CssSelectorParser.vala"
						_tmp229_ = child;
#line 539 "../gxml/CssSelectorParser.vala"
						if (_tmp229_ == element) {
#line 540 "../gxml/CssSelectorParser.vala"
							result = TRUE;
#line 540 "../gxml/CssSelectorParser.vala"
							_g_object_unref0 (child);
#line 540 "../gxml/CssSelectorParser.vala"
							return result;
#line 5789 "CssSelectorParser.c"
						}
#line 537 "../gxml/CssSelectorParser.vala"
						_g_object_unref0 (child);
#line 5793 "CssSelectorParser.c"
					}
				}
			}
#line 542 "../gxml/CssSelectorParser.vala"
			result = FALSE;
#line 542 "../gxml/CssSelectorParser.vala"
			return result;
#line 5801 "CssSelectorParser.c"
		}
#line 544 "../gxml/CssSelectorParser.vala"
		_tmp230_ = gxml_css_selector_get_value (selector);
#line 544 "../gxml/CssSelectorParser.vala"
		_tmp231_ = _tmp230_;
#line 544 "../gxml/CssSelectorParser.vala"
		index = atoi (_tmp231_) - 1;
#line 545 "../gxml/CssSelectorParser.vala"
		_tmp232_ = gxml_dom_node_get_parent_element ((GXmlDomNode*) element);
#line 545 "../gxml/CssSelectorParser.vala"
		_tmp233_ = _tmp232_;
#line 545 "../gxml/CssSelectorParser.vala"
		_tmp234_ = _tmp233_;
#line 545 "../gxml/CssSelectorParser.vala"
		_tmp235_ = gxml_dom_parent_node_get_children ((GXmlDomParentNode*) _tmp234_);
#line 545 "../gxml/CssSelectorParser.vala"
		_tmp236_ = _tmp235_;
#line 545 "../gxml/CssSelectorParser.vala"
		_tmp237_ = _tmp236_;
#line 545 "../gxml/CssSelectorParser.vala"
		_tmp238_ = gxml_dom_html_collection_get_length (_tmp237_);
#line 545 "../gxml/CssSelectorParser.vala"
		_tmp239_ = _tmp238_;
#line 545 "../gxml/CssSelectorParser.vala"
		_tmp240_ = index >= _tmp239_;
#line 545 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp237_);
#line 545 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp234_);
#line 545 "../gxml/CssSelectorParser.vala"
		if (_tmp240_) {
#line 546 "../gxml/CssSelectorParser.vala"
			result = FALSE;
#line 546 "../gxml/CssSelectorParser.vala"
			return result;
#line 5837 "CssSelectorParser.c"
		}
#line 547 "../gxml/CssSelectorParser.vala"
		_tmp241_ = gxml_dom_node_get_parent_element ((GXmlDomNode*) element);
#line 547 "../gxml/CssSelectorParser.vala"
		_tmp242_ = _tmp241_;
#line 547 "../gxml/CssSelectorParser.vala"
		_tmp243_ = _tmp242_;
#line 547 "../gxml/CssSelectorParser.vala"
		_tmp244_ = gxml_dom_parent_node_get_children ((GXmlDomParentNode*) _tmp243_);
#line 547 "../gxml/CssSelectorParser.vala"
		_tmp245_ = _tmp244_;
#line 547 "../gxml/CssSelectorParser.vala"
		_tmp246_ = _tmp245_;
#line 547 "../gxml/CssSelectorParser.vala"
		_tmp247_ = gxml_dom_node_get_parent_element ((GXmlDomNode*) element);
#line 547 "../gxml/CssSelectorParser.vala"
		_tmp248_ = _tmp247_;
#line 547 "../gxml/CssSelectorParser.vala"
		_tmp249_ = _tmp248_;
#line 547 "../gxml/CssSelectorParser.vala"
		_tmp250_ = gxml_dom_parent_node_get_children ((GXmlDomParentNode*) _tmp249_);
#line 547 "../gxml/CssSelectorParser.vala"
		_tmp251_ = _tmp250_;
#line 547 "../gxml/CssSelectorParser.vala"
		_tmp252_ = _tmp251_;
#line 547 "../gxml/CssSelectorParser.vala"
		_tmp253_ = gxml_dom_html_collection_get_length (_tmp252_);
#line 547 "../gxml/CssSelectorParser.vala"
		_tmp254_ = _tmp253_;
#line 547 "../gxml/CssSelectorParser.vala"
		_tmp255_ = gxml_dom_html_collection_item (_tmp246_, (_tmp254_ - 1) - index);
#line 547 "../gxml/CssSelectorParser.vala"
		_tmp256_ = _tmp255_;
#line 547 "../gxml/CssSelectorParser.vala"
		_tmp257_ = element == _tmp256_;
#line 547 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp256_);
#line 547 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp252_);
#line 547 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp249_);
#line 547 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp246_);
#line 547 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp243_);
#line 547 "../gxml/CssSelectorParser.vala"
		result = _tmp257_;
#line 547 "../gxml/CssSelectorParser.vala"
		return result;
#line 5887 "CssSelectorParser.c"
	}
#line 549 "../gxml/CssSelectorParser.vala"
	_tmp258_ = gxml_css_selector_get_name (selector);
#line 549 "../gxml/CssSelectorParser.vala"
	_tmp259_ = _tmp258_;
#line 549 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (_tmp259_, "nth-of-type") == 0) {
#line 5895 "CssSelectorParser.c"
		GXmlDomElement* _tmp260_;
		GXmlDomElement* _tmp261_;
		GXmlDomElement* _tmp262_;
		gboolean _tmp263_;
		GeeArrayList* list = NULL;
		GeeArrayList* _tmp264_;
		gboolean _tmp288_ = FALSE;
		const gchar* _tmp289_;
		const gchar* _tmp290_;
		gint index = 0;
		const gchar* _tmp303_;
		const gchar* _tmp304_;
		GeeArrayList* _tmp305_;
		gint _tmp306_;
		gint _tmp307_;
		GeeArrayList* _tmp308_;
		gpointer _tmp309_;
		GXmlDomElement* _tmp310_;
		gboolean _tmp311_;
#line 550 "../gxml/CssSelectorParser.vala"
		_tmp260_ = gxml_dom_node_get_parent_element ((GXmlDomNode*) element);
#line 550 "../gxml/CssSelectorParser.vala"
		_tmp261_ = _tmp260_;
#line 550 "../gxml/CssSelectorParser.vala"
		_tmp262_ = _tmp261_;
#line 550 "../gxml/CssSelectorParser.vala"
		_tmp263_ = _tmp262_ == NULL;
#line 550 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp262_);
#line 550 "../gxml/CssSelectorParser.vala"
		if (_tmp263_) {
#line 551 "../gxml/CssSelectorParser.vala"
			result = FALSE;
#line 551 "../gxml/CssSelectorParser.vala"
			return result;
#line 5931 "CssSelectorParser.c"
		}
#line 552 "../gxml/CssSelectorParser.vala"
		_tmp264_ = gee_array_list_new (GXML_TYPE_DOM_ELEMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 552 "../gxml/CssSelectorParser.vala"
		list = _tmp264_;
#line 5937 "CssSelectorParser.c"
		{
			GXmlDomHTMLCollection* _child_list = NULL;
			GXmlDomElement* _tmp265_;
			GXmlDomElement* _tmp266_;
			GXmlDomElement* _tmp267_;
			GXmlDomHTMLCollection* _tmp268_;
			GXmlDomHTMLCollection* _tmp269_;
			GXmlDomHTMLCollection* _tmp270_;
			gint _child_size = 0;
			GXmlDomHTMLCollection* _tmp271_;
			gint _tmp272_;
			gint _tmp273_;
			gint _child_index = 0;
#line 553 "../gxml/CssSelectorParser.vala"
			_tmp265_ = gxml_dom_node_get_parent_element ((GXmlDomNode*) element);
#line 553 "../gxml/CssSelectorParser.vala"
			_tmp266_ = _tmp265_;
#line 553 "../gxml/CssSelectorParser.vala"
			_tmp267_ = _tmp266_;
#line 553 "../gxml/CssSelectorParser.vala"
			_tmp268_ = gxml_dom_parent_node_get_children ((GXmlDomParentNode*) _tmp267_);
#line 553 "../gxml/CssSelectorParser.vala"
			_tmp269_ = _tmp268_;
#line 553 "../gxml/CssSelectorParser.vala"
			_tmp270_ = _tmp269_;
#line 553 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (_tmp267_);
#line 553 "../gxml/CssSelectorParser.vala"
			_child_list = _tmp270_;
#line 553 "../gxml/CssSelectorParser.vala"
			_tmp271_ = _child_list;
#line 553 "../gxml/CssSelectorParser.vala"
			_tmp272_ = gee_collection_get_size ((GeeCollection*) _tmp271_);
#line 553 "../gxml/CssSelectorParser.vala"
			_tmp273_ = _tmp272_;
#line 553 "../gxml/CssSelectorParser.vala"
			_child_size = _tmp273_;
#line 553 "../gxml/CssSelectorParser.vala"
			_child_index = -1;
#line 553 "../gxml/CssSelectorParser.vala"
			while (TRUE) {
#line 5979 "CssSelectorParser.c"
				gint _tmp274_;
				gint _tmp275_;
				GXmlDomElement* child = NULL;
				GXmlDomHTMLCollection* _tmp276_;
				gpointer _tmp277_;
				GXmlDomElement* _tmp278_;
				gchar* _tmp279_;
				gchar* _tmp280_;
				gchar* _tmp281_;
				gchar* _tmp282_;
				gchar* _tmp283_;
				gchar* _tmp284_;
				gboolean _tmp285_;
#line 553 "../gxml/CssSelectorParser.vala"
				_child_index = _child_index + 1;
#line 553 "../gxml/CssSelectorParser.vala"
				_tmp274_ = _child_index;
#line 553 "../gxml/CssSelectorParser.vala"
				_tmp275_ = _child_size;
#line 553 "../gxml/CssSelectorParser.vala"
				if (!(_tmp274_ < _tmp275_)) {
#line 553 "../gxml/CssSelectorParser.vala"
					break;
#line 6003 "CssSelectorParser.c"
				}
#line 553 "../gxml/CssSelectorParser.vala"
				_tmp276_ = _child_list;
#line 553 "../gxml/CssSelectorParser.vala"
				_tmp277_ = gee_list_get ((GeeList*) _tmp276_, _child_index);
#line 553 "../gxml/CssSelectorParser.vala"
				child = (GXmlDomElement*) _tmp277_;
#line 554 "../gxml/CssSelectorParser.vala"
				_tmp278_ = child;
#line 554 "../gxml/CssSelectorParser.vala"
				_tmp279_ = gxml_dom_element_get_local_name (_tmp278_);
#line 554 "../gxml/CssSelectorParser.vala"
				_tmp280_ = _tmp279_;
#line 554 "../gxml/CssSelectorParser.vala"
				_tmp281_ = _tmp280_;
#line 554 "../gxml/CssSelectorParser.vala"
				_tmp282_ = gxml_dom_element_get_local_name (element);
#line 554 "../gxml/CssSelectorParser.vala"
				_tmp283_ = _tmp282_;
#line 554 "../gxml/CssSelectorParser.vala"
				_tmp284_ = _tmp283_;
#line 554 "../gxml/CssSelectorParser.vala"
				_tmp285_ = g_strcmp0 (_tmp281_, _tmp284_) == 0;
#line 554 "../gxml/CssSelectorParser.vala"
				_g_free0 (_tmp284_);
#line 554 "../gxml/CssSelectorParser.vala"
				_g_free0 (_tmp281_);
#line 554 "../gxml/CssSelectorParser.vala"
				if (_tmp285_) {
#line 6033 "CssSelectorParser.c"
					GeeArrayList* _tmp286_;
					GXmlDomElement* _tmp287_;
#line 555 "../gxml/CssSelectorParser.vala"
					_tmp286_ = list;
#line 555 "../gxml/CssSelectorParser.vala"
					_tmp287_ = child;
#line 555 "../gxml/CssSelectorParser.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp286_, _tmp287_);
#line 6042 "CssSelectorParser.c"
				}
#line 553 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (child);
#line 6046 "CssSelectorParser.c"
			}
#line 553 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (_child_list);
#line 6050 "CssSelectorParser.c"
		}
#line 556 "../gxml/CssSelectorParser.vala"
		_tmp289_ = gxml_css_selector_get_value (selector);
#line 556 "../gxml/CssSelectorParser.vala"
		_tmp290_ = _tmp289_;
#line 556 "../gxml/CssSelectorParser.vala"
		if (g_strcmp0 (_tmp290_, "even") == 0) {
#line 556 "../gxml/CssSelectorParser.vala"
			_tmp288_ = TRUE;
#line 6060 "CssSelectorParser.c"
		} else {
			const gchar* _tmp291_;
			const gchar* _tmp292_;
#line 556 "../gxml/CssSelectorParser.vala"
			_tmp291_ = gxml_css_selector_get_value (selector);
#line 556 "../gxml/CssSelectorParser.vala"
			_tmp292_ = _tmp291_;
#line 556 "../gxml/CssSelectorParser.vala"
			_tmp288_ = g_strcmp0 (_tmp292_, "odd") == 0;
#line 6070 "CssSelectorParser.c"
		}
#line 556 "../gxml/CssSelectorParser.vala"
		if (_tmp288_) {
#line 6074 "CssSelectorParser.c"
			{
				gint _tmp293_ = 0;
				const gchar* _tmp294_;
				const gchar* _tmp295_;
				gint i = 0;
#line 557 "../gxml/CssSelectorParser.vala"
				_tmp294_ = gxml_css_selector_get_value (selector);
#line 557 "../gxml/CssSelectorParser.vala"
				_tmp295_ = _tmp294_;
#line 557 "../gxml/CssSelectorParser.vala"
				if (g_strcmp0 (_tmp295_, "even") == 0) {
#line 557 "../gxml/CssSelectorParser.vala"
					_tmp293_ = 1;
#line 6088 "CssSelectorParser.c"
				} else {
#line 557 "../gxml/CssSelectorParser.vala"
					_tmp293_ = 0;
#line 6092 "CssSelectorParser.c"
				}
#line 557 "../gxml/CssSelectorParser.vala"
				i = _tmp293_;
#line 6096 "CssSelectorParser.c"
				{
					gboolean _tmp296_ = FALSE;
#line 557 "../gxml/CssSelectorParser.vala"
					_tmp296_ = TRUE;
#line 557 "../gxml/CssSelectorParser.vala"
					while (TRUE) {
#line 6103 "CssSelectorParser.c"
						GeeArrayList* _tmp297_;
						gint _tmp298_;
						gint _tmp299_;
						GXmlDomElement* child = NULL;
						GeeArrayList* _tmp300_;
						gpointer _tmp301_;
						GXmlDomElement* _tmp302_;
#line 557 "../gxml/CssSelectorParser.vala"
						if (!_tmp296_) {
#line 557 "../gxml/CssSelectorParser.vala"
							i += 2;
#line 6115 "CssSelectorParser.c"
						}
#line 557 "../gxml/CssSelectorParser.vala"
						_tmp296_ = FALSE;
#line 557 "../gxml/CssSelectorParser.vala"
						_tmp297_ = list;
#line 557 "../gxml/CssSelectorParser.vala"
						_tmp298_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp297_);
#line 557 "../gxml/CssSelectorParser.vala"
						_tmp299_ = _tmp298_;
#line 557 "../gxml/CssSelectorParser.vala"
						if (!(i < _tmp299_)) {
#line 557 "../gxml/CssSelectorParser.vala"
							break;
#line 6129 "CssSelectorParser.c"
						}
#line 558 "../gxml/CssSelectorParser.vala"
						_tmp300_ = list;
#line 558 "../gxml/CssSelectorParser.vala"
						_tmp301_ = gee_abstract_list_get ((GeeAbstractList*) _tmp300_, i);
#line 558 "../gxml/CssSelectorParser.vala"
						child = (GXmlDomElement*) _tmp301_;
#line 559 "../gxml/CssSelectorParser.vala"
						_tmp302_ = child;
#line 559 "../gxml/CssSelectorParser.vala"
						if (_tmp302_ == element) {
#line 560 "../gxml/CssSelectorParser.vala"
							result = TRUE;
#line 560 "../gxml/CssSelectorParser.vala"
							_g_object_unref0 (child);
#line 560 "../gxml/CssSelectorParser.vala"
							_g_object_unref0 (list);
#line 560 "../gxml/CssSelectorParser.vala"
							return result;
#line 6149 "CssSelectorParser.c"
						}
#line 557 "../gxml/CssSelectorParser.vala"
						_g_object_unref0 (child);
#line 6153 "CssSelectorParser.c"
					}
				}
			}
#line 562 "../gxml/CssSelectorParser.vala"
			result = FALSE;
#line 562 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (list);
#line 562 "../gxml/CssSelectorParser.vala"
			return result;
#line 6163 "CssSelectorParser.c"
		}
#line 564 "../gxml/CssSelectorParser.vala"
		_tmp303_ = gxml_css_selector_get_value (selector);
#line 564 "../gxml/CssSelectorParser.vala"
		_tmp304_ = _tmp303_;
#line 564 "../gxml/CssSelectorParser.vala"
		index = atoi (_tmp304_) - 1;
#line 565 "../gxml/CssSelectorParser.vala"
		_tmp305_ = list;
#line 565 "../gxml/CssSelectorParser.vala"
		_tmp306_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp305_);
#line 565 "../gxml/CssSelectorParser.vala"
		_tmp307_ = _tmp306_;
#line 565 "../gxml/CssSelectorParser.vala"
		if (index >= _tmp307_) {
#line 566 "../gxml/CssSelectorParser.vala"
			result = FALSE;
#line 566 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (list);
#line 566 "../gxml/CssSelectorParser.vala"
			return result;
#line 6185 "CssSelectorParser.c"
		}
#line 567 "../gxml/CssSelectorParser.vala"
		_tmp308_ = list;
#line 567 "../gxml/CssSelectorParser.vala"
		_tmp309_ = gee_abstract_list_get ((GeeAbstractList*) _tmp308_, index);
#line 567 "../gxml/CssSelectorParser.vala"
		_tmp310_ = (GXmlDomElement*) _tmp309_;
#line 567 "../gxml/CssSelectorParser.vala"
		_tmp311_ = _tmp310_ == element;
#line 567 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp310_);
#line 567 "../gxml/CssSelectorParser.vala"
		result = _tmp311_;
#line 567 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (list);
#line 567 "../gxml/CssSelectorParser.vala"
		return result;
#line 6203 "CssSelectorParser.c"
	}
#line 569 "../gxml/CssSelectorParser.vala"
	_tmp312_ = gxml_css_selector_get_name (selector);
#line 569 "../gxml/CssSelectorParser.vala"
	_tmp313_ = _tmp312_;
#line 569 "../gxml/CssSelectorParser.vala"
	if (g_strcmp0 (_tmp313_, "nth-last-of-type") == 0) {
#line 6211 "CssSelectorParser.c"
		GXmlDomElement* _tmp314_;
		GXmlDomElement* _tmp315_;
		GXmlDomElement* _tmp316_;
		gboolean _tmp317_;
		GeeArrayList* list = NULL;
		GeeArrayList* _tmp318_;
		gboolean _tmp342_ = FALSE;
		const gchar* _tmp343_;
		const gchar* _tmp344_;
		gint index = 0;
		const gchar* _tmp360_;
		const gchar* _tmp361_;
		GeeArrayList* _tmp362_;
		gint _tmp363_;
		gint _tmp364_;
		GeeArrayList* _tmp365_;
		GeeArrayList* _tmp366_;
		gint _tmp367_;
		gint _tmp368_;
		gpointer _tmp369_;
		GXmlDomElement* _tmp370_;
		gboolean _tmp371_;
#line 570 "../gxml/CssSelectorParser.vala"
		_tmp314_ = gxml_dom_node_get_parent_element ((GXmlDomNode*) element);
#line 570 "../gxml/CssSelectorParser.vala"
		_tmp315_ = _tmp314_;
#line 570 "../gxml/CssSelectorParser.vala"
		_tmp316_ = _tmp315_;
#line 570 "../gxml/CssSelectorParser.vala"
		_tmp317_ = _tmp316_ == NULL;
#line 570 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp316_);
#line 570 "../gxml/CssSelectorParser.vala"
		if (_tmp317_) {
#line 571 "../gxml/CssSelectorParser.vala"
			result = FALSE;
#line 571 "../gxml/CssSelectorParser.vala"
			return result;
#line 6250 "CssSelectorParser.c"
		}
#line 572 "../gxml/CssSelectorParser.vala"
		_tmp318_ = gee_array_list_new (GXML_TYPE_DOM_ELEMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 572 "../gxml/CssSelectorParser.vala"
		list = _tmp318_;
#line 6256 "CssSelectorParser.c"
		{
			GXmlDomHTMLCollection* _child_list = NULL;
			GXmlDomElement* _tmp319_;
			GXmlDomElement* _tmp320_;
			GXmlDomElement* _tmp321_;
			GXmlDomHTMLCollection* _tmp322_;
			GXmlDomHTMLCollection* _tmp323_;
			GXmlDomHTMLCollection* _tmp324_;
			gint _child_size = 0;
			GXmlDomHTMLCollection* _tmp325_;
			gint _tmp326_;
			gint _tmp327_;
			gint _child_index = 0;
#line 573 "../gxml/CssSelectorParser.vala"
			_tmp319_ = gxml_dom_node_get_parent_element ((GXmlDomNode*) element);
#line 573 "../gxml/CssSelectorParser.vala"
			_tmp320_ = _tmp319_;
#line 573 "../gxml/CssSelectorParser.vala"
			_tmp321_ = _tmp320_;
#line 573 "../gxml/CssSelectorParser.vala"
			_tmp322_ = gxml_dom_parent_node_get_children ((GXmlDomParentNode*) _tmp321_);
#line 573 "../gxml/CssSelectorParser.vala"
			_tmp323_ = _tmp322_;
#line 573 "../gxml/CssSelectorParser.vala"
			_tmp324_ = _tmp323_;
#line 573 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (_tmp321_);
#line 573 "../gxml/CssSelectorParser.vala"
			_child_list = _tmp324_;
#line 573 "../gxml/CssSelectorParser.vala"
			_tmp325_ = _child_list;
#line 573 "../gxml/CssSelectorParser.vala"
			_tmp326_ = gee_collection_get_size ((GeeCollection*) _tmp325_);
#line 573 "../gxml/CssSelectorParser.vala"
			_tmp327_ = _tmp326_;
#line 573 "../gxml/CssSelectorParser.vala"
			_child_size = _tmp327_;
#line 573 "../gxml/CssSelectorParser.vala"
			_child_index = -1;
#line 573 "../gxml/CssSelectorParser.vala"
			while (TRUE) {
#line 6298 "CssSelectorParser.c"
				gint _tmp328_;
				gint _tmp329_;
				GXmlDomElement* child = NULL;
				GXmlDomHTMLCollection* _tmp330_;
				gpointer _tmp331_;
				GXmlDomElement* _tmp332_;
				gchar* _tmp333_;
				gchar* _tmp334_;
				gchar* _tmp335_;
				gchar* _tmp336_;
				gchar* _tmp337_;
				gchar* _tmp338_;
				gboolean _tmp339_;
#line 573 "../gxml/CssSelectorParser.vala"
				_child_index = _child_index + 1;
#line 573 "../gxml/CssSelectorParser.vala"
				_tmp328_ = _child_index;
#line 573 "../gxml/CssSelectorParser.vala"
				_tmp329_ = _child_size;
#line 573 "../gxml/CssSelectorParser.vala"
				if (!(_tmp328_ < _tmp329_)) {
#line 573 "../gxml/CssSelectorParser.vala"
					break;
#line 6322 "CssSelectorParser.c"
				}
#line 573 "../gxml/CssSelectorParser.vala"
				_tmp330_ = _child_list;
#line 573 "../gxml/CssSelectorParser.vala"
				_tmp331_ = gee_list_get ((GeeList*) _tmp330_, _child_index);
#line 573 "../gxml/CssSelectorParser.vala"
				child = (GXmlDomElement*) _tmp331_;
#line 574 "../gxml/CssSelectorParser.vala"
				_tmp332_ = child;
#line 574 "../gxml/CssSelectorParser.vala"
				_tmp333_ = gxml_dom_element_get_local_name (_tmp332_);
#line 574 "../gxml/CssSelectorParser.vala"
				_tmp334_ = _tmp333_;
#line 574 "../gxml/CssSelectorParser.vala"
				_tmp335_ = _tmp334_;
#line 574 "../gxml/CssSelectorParser.vala"
				_tmp336_ = gxml_dom_element_get_local_name (element);
#line 574 "../gxml/CssSelectorParser.vala"
				_tmp337_ = _tmp336_;
#line 574 "../gxml/CssSelectorParser.vala"
				_tmp338_ = _tmp337_;
#line 574 "../gxml/CssSelectorParser.vala"
				_tmp339_ = g_strcmp0 (_tmp335_, _tmp338_) == 0;
#line 574 "../gxml/CssSelectorParser.vala"
				_g_free0 (_tmp338_);
#line 574 "../gxml/CssSelectorParser.vala"
				_g_free0 (_tmp335_);
#line 574 "../gxml/CssSelectorParser.vala"
				if (_tmp339_) {
#line 6352 "CssSelectorParser.c"
					GeeArrayList* _tmp340_;
					GXmlDomElement* _tmp341_;
#line 575 "../gxml/CssSelectorParser.vala"
					_tmp340_ = list;
#line 575 "../gxml/CssSelectorParser.vala"
					_tmp341_ = child;
#line 575 "../gxml/CssSelectorParser.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp340_, _tmp341_);
#line 6361 "CssSelectorParser.c"
				}
#line 573 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (child);
#line 6365 "CssSelectorParser.c"
			}
#line 573 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (_child_list);
#line 6369 "CssSelectorParser.c"
		}
#line 576 "../gxml/CssSelectorParser.vala"
		_tmp343_ = gxml_css_selector_get_value (selector);
#line 576 "../gxml/CssSelectorParser.vala"
		_tmp344_ = _tmp343_;
#line 576 "../gxml/CssSelectorParser.vala"
		if (g_strcmp0 (_tmp344_, "even") == 0) {
#line 576 "../gxml/CssSelectorParser.vala"
			_tmp342_ = TRUE;
#line 6379 "CssSelectorParser.c"
		} else {
			const gchar* _tmp345_;
			const gchar* _tmp346_;
#line 576 "../gxml/CssSelectorParser.vala"
			_tmp345_ = gxml_css_selector_get_value (selector);
#line 576 "../gxml/CssSelectorParser.vala"
			_tmp346_ = _tmp345_;
#line 576 "../gxml/CssSelectorParser.vala"
			_tmp342_ = g_strcmp0 (_tmp346_, "odd") == 0;
#line 6389 "CssSelectorParser.c"
		}
#line 576 "../gxml/CssSelectorParser.vala"
		if (_tmp342_) {
#line 6393 "CssSelectorParser.c"
			{
				gint _tmp347_ = 0;
				const gchar* _tmp348_;
				const gchar* _tmp349_;
				gint i = 0;
#line 577 "../gxml/CssSelectorParser.vala"
				_tmp348_ = gxml_css_selector_get_value (selector);
#line 577 "../gxml/CssSelectorParser.vala"
				_tmp349_ = _tmp348_;
#line 577 "../gxml/CssSelectorParser.vala"
				if (g_strcmp0 (_tmp349_, "even") == 0) {
#line 577 "../gxml/CssSelectorParser.vala"
					_tmp347_ = 1;
#line 6407 "CssSelectorParser.c"
				} else {
#line 577 "../gxml/CssSelectorParser.vala"
					_tmp347_ = 0;
#line 6411 "CssSelectorParser.c"
				}
#line 577 "../gxml/CssSelectorParser.vala"
				i = _tmp347_;
#line 6415 "CssSelectorParser.c"
				{
					gboolean _tmp350_ = FALSE;
#line 577 "../gxml/CssSelectorParser.vala"
					_tmp350_ = TRUE;
#line 577 "../gxml/CssSelectorParser.vala"
					while (TRUE) {
#line 6422 "CssSelectorParser.c"
						GeeArrayList* _tmp351_;
						gint _tmp352_;
						gint _tmp353_;
						GXmlDomElement* child = NULL;
						GeeArrayList* _tmp354_;
						GeeArrayList* _tmp355_;
						gint _tmp356_;
						gint _tmp357_;
						gpointer _tmp358_;
						GXmlDomElement* _tmp359_;
#line 577 "../gxml/CssSelectorParser.vala"
						if (!_tmp350_) {
#line 577 "../gxml/CssSelectorParser.vala"
							i += 2;
#line 6437 "CssSelectorParser.c"
						}
#line 577 "../gxml/CssSelectorParser.vala"
						_tmp350_ = FALSE;
#line 577 "../gxml/CssSelectorParser.vala"
						_tmp351_ = list;
#line 577 "../gxml/CssSelectorParser.vala"
						_tmp352_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp351_);
#line 577 "../gxml/CssSelectorParser.vala"
						_tmp353_ = _tmp352_;
#line 577 "../gxml/CssSelectorParser.vala"
						if (!(i < _tmp353_)) {
#line 577 "../gxml/CssSelectorParser.vala"
							break;
#line 6451 "CssSelectorParser.c"
						}
#line 578 "../gxml/CssSelectorParser.vala"
						_tmp354_ = list;
#line 578 "../gxml/CssSelectorParser.vala"
						_tmp355_ = list;
#line 578 "../gxml/CssSelectorParser.vala"
						_tmp356_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp355_);
#line 578 "../gxml/CssSelectorParser.vala"
						_tmp357_ = _tmp356_;
#line 578 "../gxml/CssSelectorParser.vala"
						_tmp358_ = gee_abstract_list_get ((GeeAbstractList*) _tmp354_, (_tmp357_ - 1) - i);
#line 578 "../gxml/CssSelectorParser.vala"
						child = (GXmlDomElement*) _tmp358_;
#line 579 "../gxml/CssSelectorParser.vala"
						_tmp359_ = child;
#line 579 "../gxml/CssSelectorParser.vala"
						if (_tmp359_ == element) {
#line 580 "../gxml/CssSelectorParser.vala"
							result = TRUE;
#line 580 "../gxml/CssSelectorParser.vala"
							_g_object_unref0 (child);
#line 580 "../gxml/CssSelectorParser.vala"
							_g_object_unref0 (list);
#line 580 "../gxml/CssSelectorParser.vala"
							return result;
#line 6477 "CssSelectorParser.c"
						}
#line 577 "../gxml/CssSelectorParser.vala"
						_g_object_unref0 (child);
#line 6481 "CssSelectorParser.c"
					}
				}
			}
#line 582 "../gxml/CssSelectorParser.vala"
			result = FALSE;
#line 582 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (list);
#line 582 "../gxml/CssSelectorParser.vala"
			return result;
#line 6491 "CssSelectorParser.c"
		}
#line 584 "../gxml/CssSelectorParser.vala"
		_tmp360_ = gxml_css_selector_get_value (selector);
#line 584 "../gxml/CssSelectorParser.vala"
		_tmp361_ = _tmp360_;
#line 584 "../gxml/CssSelectorParser.vala"
		index = atoi (_tmp361_) - 1;
#line 585 "../gxml/CssSelectorParser.vala"
		_tmp362_ = list;
#line 585 "../gxml/CssSelectorParser.vala"
		_tmp363_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp362_);
#line 585 "../gxml/CssSelectorParser.vala"
		_tmp364_ = _tmp363_;
#line 585 "../gxml/CssSelectorParser.vala"
		if (index >= _tmp364_) {
#line 586 "../gxml/CssSelectorParser.vala"
			result = FALSE;
#line 586 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (list);
#line 586 "../gxml/CssSelectorParser.vala"
			return result;
#line 6513 "CssSelectorParser.c"
		}
#line 587 "../gxml/CssSelectorParser.vala"
		_tmp365_ = list;
#line 587 "../gxml/CssSelectorParser.vala"
		_tmp366_ = list;
#line 587 "../gxml/CssSelectorParser.vala"
		_tmp367_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp366_);
#line 587 "../gxml/CssSelectorParser.vala"
		_tmp368_ = _tmp367_;
#line 587 "../gxml/CssSelectorParser.vala"
		_tmp369_ = gee_abstract_list_get ((GeeAbstractList*) _tmp365_, (_tmp368_ - 1) - index);
#line 587 "../gxml/CssSelectorParser.vala"
		_tmp370_ = (GXmlDomElement*) _tmp369_;
#line 587 "../gxml/CssSelectorParser.vala"
		_tmp371_ = _tmp370_ == element;
#line 587 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp370_);
#line 587 "../gxml/CssSelectorParser.vala"
		if (_tmp371_) {
#line 588 "../gxml/CssSelectorParser.vala"
			result = TRUE;
#line 588 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (list);
#line 588 "../gxml/CssSelectorParser.vala"
			return result;
#line 6539 "CssSelectorParser.c"
		}
#line 569 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (list);
#line 6543 "CssSelectorParser.c"
	}
#line 590 "../gxml/CssSelectorParser.vala"
	result = FALSE;
#line 590 "../gxml/CssSelectorParser.vala"
	return result;
#line 6549 "CssSelectorParser.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result = 0;
#line 1133 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1133 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1134 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1134 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1136 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1136 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 6573 "CssSelectorParser.c"
		gchar* _tmp2_;
#line 1137 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1137 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1137 "glib-2.0.vapi"
		return result;
#line 6581 "CssSelectorParser.c"
	} else {
#line 1139 "glib-2.0.vapi"
		result = -1;
#line 1139 "glib-2.0.vapi"
		return result;
#line 6587 "CssSelectorParser.c"
	}
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result = 0;
#line 1143 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1143 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1144 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1144 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1146 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1146 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 6612 "CssSelectorParser.c"
		gchar* _tmp2_;
#line 1147 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1147 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1147 "glib-2.0.vapi"
		return result;
#line 6620 "CssSelectorParser.c"
	} else {
#line 1149 "glib-2.0.vapi"
		result = -1;
#line 1149 "glib-2.0.vapi"
		return result;
#line 6626 "CssSelectorParser.c"
	}
}

static gboolean
gxml_css_selector_parser_match_attribute (GXmlDomElement* element,
                                          GXmlCssAttributeSelector* selector,
                                          GError** error)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GeeArrayList* _tmp149_;
	gint _tmp150_;
	gint _tmp151_;
	gboolean result = FALSE;
#line 593 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (element != NULL, FALSE);
#line 593 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (selector != NULL, FALSE);
#line 594 "../gxml/CssSelectorParser.vala"
	_tmp0_ = gee_array_list_new (GXML_TYPE_DOM_NODE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 594 "../gxml/CssSelectorParser.vala"
	list = _tmp0_;
#line 595 "../gxml/CssSelectorParser.vala"
	_tmp1_ = gxml_css_attribute_selector_get_prefix (selector);
#line 595 "../gxml/CssSelectorParser.vala"
	_tmp2_ = _tmp1_;
#line 595 "../gxml/CssSelectorParser.vala"
	if (_tmp2_ != NULL) {
#line 6657 "CssSelectorParser.c"
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 596 "../gxml/CssSelectorParser.vala"
		_tmp3_ = gxml_css_attribute_selector_get_prefix (selector);
#line 596 "../gxml/CssSelectorParser.vala"
		_tmp4_ = _tmp3_;
#line 596 "../gxml/CssSelectorParser.vala"
		if (g_strcmp0 (_tmp4_, "") == 0) {
#line 6666 "CssSelectorParser.c"
			{
				gint i = 0;
#line 597 "../gxml/CssSelectorParser.vala"
				i = 0;
#line 6671 "CssSelectorParser.c"
				{
					gboolean _tmp5_ = FALSE;
#line 597 "../gxml/CssSelectorParser.vala"
					_tmp5_ = TRUE;
#line 597 "../gxml/CssSelectorParser.vala"
					while (TRUE) {
#line 6678 "CssSelectorParser.c"
						GXmlDomNamedNodeMap* _tmp7_;
						GXmlDomNamedNodeMap* _tmp8_;
						GXmlDomNamedNodeMap* _tmp9_;
						gint _tmp10_;
						gint _tmp11_;
						gboolean _tmp12_;
						GXmlDomNamedNodeMap* _tmp13_;
						GXmlDomNamedNodeMap* _tmp14_;
						GXmlDomNamedNodeMap* _tmp15_;
						GXmlDomNode* _tmp16_;
						GXmlDomNode* _tmp17_;
						gboolean _tmp18_;
						gboolean _tmp19_ = FALSE;
						GXmlDomNamedNodeMap* _tmp20_;
						GXmlDomNamedNodeMap* _tmp21_;
						GXmlDomNamedNodeMap* _tmp22_;
						GXmlDomNode* _tmp23_;
						GXmlDomNode* _tmp24_;
						gchar* _tmp25_;
						gchar* _tmp26_;
						gchar* _tmp27_;
						const gchar* _tmp28_;
						const gchar* _tmp29_;
						gboolean _tmp30_;
#line 597 "../gxml/CssSelectorParser.vala"
						if (!_tmp5_) {
#line 6705 "CssSelectorParser.c"
							gint _tmp6_;
#line 597 "../gxml/CssSelectorParser.vala"
							_tmp6_ = i;
#line 597 "../gxml/CssSelectorParser.vala"
							i = _tmp6_ + 1;
#line 6711 "CssSelectorParser.c"
						}
#line 597 "../gxml/CssSelectorParser.vala"
						_tmp5_ = FALSE;
#line 597 "../gxml/CssSelectorParser.vala"
						_tmp7_ = gxml_dom_element_get_attributes (element);
#line 597 "../gxml/CssSelectorParser.vala"
						_tmp8_ = _tmp7_;
#line 597 "../gxml/CssSelectorParser.vala"
						_tmp9_ = _tmp8_;
#line 597 "../gxml/CssSelectorParser.vala"
						_tmp10_ = gxml_dom_named_node_map_get_length (_tmp9_);
#line 597 "../gxml/CssSelectorParser.vala"
						_tmp11_ = _tmp10_;
#line 597 "../gxml/CssSelectorParser.vala"
						_tmp12_ = !(i < _tmp11_);
#line 597 "../gxml/CssSelectorParser.vala"
						_g_object_unref0 (_tmp9_);
#line 597 "../gxml/CssSelectorParser.vala"
						if (_tmp12_) {
#line 597 "../gxml/CssSelectorParser.vala"
							break;
#line 6733 "CssSelectorParser.c"
						}
#line 598 "../gxml/CssSelectorParser.vala"
						_tmp13_ = gxml_dom_element_get_attributes (element);
#line 598 "../gxml/CssSelectorParser.vala"
						_tmp14_ = _tmp13_;
#line 598 "../gxml/CssSelectorParser.vala"
						_tmp15_ = _tmp14_;
#line 598 "../gxml/CssSelectorParser.vala"
						_tmp16_ = gxml_dom_named_node_map_item (_tmp15_, i);
#line 598 "../gxml/CssSelectorParser.vala"
						_tmp17_ = _tmp16_;
#line 598 "../gxml/CssSelectorParser.vala"
						_tmp18_ = _tmp17_ == NULL;
#line 598 "../gxml/CssSelectorParser.vala"
						_g_object_unref0 (_tmp17_);
#line 598 "../gxml/CssSelectorParser.vala"
						_g_object_unref0 (_tmp15_);
#line 598 "../gxml/CssSelectorParser.vala"
						if (_tmp18_) {
#line 599 "../gxml/CssSelectorParser.vala"
							continue;
#line 6755 "CssSelectorParser.c"
						}
#line 600 "../gxml/CssSelectorParser.vala"
						_tmp20_ = gxml_dom_element_get_attributes (element);
#line 600 "../gxml/CssSelectorParser.vala"
						_tmp21_ = _tmp20_;
#line 600 "../gxml/CssSelectorParser.vala"
						_tmp22_ = _tmp21_;
#line 600 "../gxml/CssSelectorParser.vala"
						_tmp23_ = gxml_dom_named_node_map_item (_tmp22_, i);
#line 600 "../gxml/CssSelectorParser.vala"
						_tmp24_ = _tmp23_;
#line 600 "../gxml/CssSelectorParser.vala"
						_tmp25_ = gxml_dom_node_get_node_name (_tmp24_);
#line 600 "../gxml/CssSelectorParser.vala"
						_tmp26_ = _tmp25_;
#line 600 "../gxml/CssSelectorParser.vala"
						_tmp27_ = _tmp26_;
#line 600 "../gxml/CssSelectorParser.vala"
						_tmp28_ = gxml_css_attribute_selector_get_local_name (selector);
#line 600 "../gxml/CssSelectorParser.vala"
						_tmp29_ = _tmp28_;
#line 600 "../gxml/CssSelectorParser.vala"
						_tmp30_ = g_strcmp0 (_tmp27_, _tmp29_) == 0;
#line 600 "../gxml/CssSelectorParser.vala"
						_g_free0 (_tmp27_);
#line 600 "../gxml/CssSelectorParser.vala"
						_g_object_unref0 (_tmp24_);
#line 600 "../gxml/CssSelectorParser.vala"
						_g_object_unref0 (_tmp22_);
#line 600 "../gxml/CssSelectorParser.vala"
						if (_tmp30_) {
#line 600 "../gxml/CssSelectorParser.vala"
							_tmp19_ = TRUE;
#line 6789 "CssSelectorParser.c"
						} else {
							const gchar* _tmp31_;
							const gchar* _tmp32_;
#line 600 "../gxml/CssSelectorParser.vala"
							_tmp31_ = gxml_css_attribute_selector_get_local_name (selector);
#line 600 "../gxml/CssSelectorParser.vala"
							_tmp32_ = _tmp31_;
#line 600 "../gxml/CssSelectorParser.vala"
							_tmp19_ = g_strcmp0 (_tmp32_, "*") == 0;
#line 6799 "CssSelectorParser.c"
						}
#line 600 "../gxml/CssSelectorParser.vala"
						if (_tmp19_) {
#line 6803 "CssSelectorParser.c"
							GeeArrayList* _tmp33_;
							GXmlDomNamedNodeMap* _tmp34_;
							GXmlDomNamedNodeMap* _tmp35_;
							GXmlDomNamedNodeMap* _tmp36_;
							GXmlDomNode* _tmp37_;
							GXmlDomNode* _tmp38_;
#line 601 "../gxml/CssSelectorParser.vala"
							_tmp33_ = list;
#line 601 "../gxml/CssSelectorParser.vala"
							_tmp34_ = gxml_dom_element_get_attributes (element);
#line 601 "../gxml/CssSelectorParser.vala"
							_tmp35_ = _tmp34_;
#line 601 "../gxml/CssSelectorParser.vala"
							_tmp36_ = _tmp35_;
#line 601 "../gxml/CssSelectorParser.vala"
							_tmp37_ = gxml_dom_named_node_map_item (_tmp36_, i);
#line 601 "../gxml/CssSelectorParser.vala"
							_tmp38_ = _tmp37_;
#line 601 "../gxml/CssSelectorParser.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp33_, _tmp38_);
#line 601 "../gxml/CssSelectorParser.vala"
							_g_object_unref0 (_tmp38_);
#line 601 "../gxml/CssSelectorParser.vala"
							_g_object_unref0 (_tmp36_);
#line 6828 "CssSelectorParser.c"
						}
					}
				}
			}
		} else {
			const gchar* _tmp39_;
			const gchar* _tmp40_;
#line 604 "../gxml/CssSelectorParser.vala"
			_tmp39_ = gxml_css_attribute_selector_get_prefix (selector);
#line 604 "../gxml/CssSelectorParser.vala"
			_tmp40_ = _tmp39_;
#line 604 "../gxml/CssSelectorParser.vala"
			if (g_strcmp0 (_tmp40_, "*") == 0) {
#line 6842 "CssSelectorParser.c"
				{
					gint i = 0;
#line 605 "../gxml/CssSelectorParser.vala"
					i = 0;
#line 6847 "CssSelectorParser.c"
					{
						gboolean _tmp41_ = FALSE;
#line 605 "../gxml/CssSelectorParser.vala"
						_tmp41_ = TRUE;
#line 605 "../gxml/CssSelectorParser.vala"
						while (TRUE) {
#line 6854 "CssSelectorParser.c"
							GXmlDomNamedNodeMap* _tmp43_;
							GXmlDomNamedNodeMap* _tmp44_;
							GXmlDomNamedNodeMap* _tmp45_;
							gint _tmp46_;
							gint _tmp47_;
							gboolean _tmp48_;
							GXmlDomNamedNodeMap* _tmp49_;
							GXmlDomNamedNodeMap* _tmp50_;
							GXmlDomNamedNodeMap* _tmp51_;
							GXmlDomNode* _tmp52_;
							GXmlDomNode* _tmp53_;
							gboolean _tmp54_;
							gchar* attr_name = NULL;
							GXmlDomNamedNodeMap* _tmp55_;
							GXmlDomNamedNodeMap* _tmp56_;
							GXmlDomNamedNodeMap* _tmp57_;
							GXmlDomNode* _tmp58_;
							GXmlDomNode* _tmp59_;
							gchar* _tmp60_;
							gchar* _tmp61_;
							gchar* _tmp62_;
							gboolean _tmp63_ = FALSE;
							const gchar* _tmp64_;
							gchar** _tmp65_;
							gchar** _tmp66_;
							gchar** _tmp67_;
							gint _tmp67__length1;
							gboolean _tmp68_;
#line 605 "../gxml/CssSelectorParser.vala"
							if (!_tmp41_) {
#line 6885 "CssSelectorParser.c"
								gint _tmp42_;
#line 605 "../gxml/CssSelectorParser.vala"
								_tmp42_ = i;
#line 605 "../gxml/CssSelectorParser.vala"
								i = _tmp42_ + 1;
#line 6891 "CssSelectorParser.c"
							}
#line 605 "../gxml/CssSelectorParser.vala"
							_tmp41_ = FALSE;
#line 605 "../gxml/CssSelectorParser.vala"
							_tmp43_ = gxml_dom_element_get_attributes (element);
#line 605 "../gxml/CssSelectorParser.vala"
							_tmp44_ = _tmp43_;
#line 605 "../gxml/CssSelectorParser.vala"
							_tmp45_ = _tmp44_;
#line 605 "../gxml/CssSelectorParser.vala"
							_tmp46_ = gxml_dom_named_node_map_get_length (_tmp45_);
#line 605 "../gxml/CssSelectorParser.vala"
							_tmp47_ = _tmp46_;
#line 605 "../gxml/CssSelectorParser.vala"
							_tmp48_ = !(i < _tmp47_);
#line 605 "../gxml/CssSelectorParser.vala"
							_g_object_unref0 (_tmp45_);
#line 605 "../gxml/CssSelectorParser.vala"
							if (_tmp48_) {
#line 605 "../gxml/CssSelectorParser.vala"
								break;
#line 6913 "CssSelectorParser.c"
							}
#line 606 "../gxml/CssSelectorParser.vala"
							_tmp49_ = gxml_dom_element_get_attributes (element);
#line 606 "../gxml/CssSelectorParser.vala"
							_tmp50_ = _tmp49_;
#line 606 "../gxml/CssSelectorParser.vala"
							_tmp51_ = _tmp50_;
#line 606 "../gxml/CssSelectorParser.vala"
							_tmp52_ = gxml_dom_named_node_map_item (_tmp51_, i);
#line 606 "../gxml/CssSelectorParser.vala"
							_tmp53_ = _tmp52_;
#line 606 "../gxml/CssSelectorParser.vala"
							_tmp54_ = _tmp53_ == NULL;
#line 606 "../gxml/CssSelectorParser.vala"
							_g_object_unref0 (_tmp53_);
#line 606 "../gxml/CssSelectorParser.vala"
							_g_object_unref0 (_tmp51_);
#line 606 "../gxml/CssSelectorParser.vala"
							if (_tmp54_) {
#line 607 "../gxml/CssSelectorParser.vala"
								continue;
#line 6935 "CssSelectorParser.c"
							}
#line 608 "../gxml/CssSelectorParser.vala"
							_tmp55_ = gxml_dom_element_get_attributes (element);
#line 608 "../gxml/CssSelectorParser.vala"
							_tmp56_ = _tmp55_;
#line 608 "../gxml/CssSelectorParser.vala"
							_tmp57_ = _tmp56_;
#line 608 "../gxml/CssSelectorParser.vala"
							_tmp58_ = gxml_dom_named_node_map_item (_tmp57_, i);
#line 608 "../gxml/CssSelectorParser.vala"
							_tmp59_ = _tmp58_;
#line 608 "../gxml/CssSelectorParser.vala"
							_tmp60_ = gxml_dom_node_get_node_name (_tmp59_);
#line 608 "../gxml/CssSelectorParser.vala"
							_tmp61_ = _tmp60_;
#line 608 "../gxml/CssSelectorParser.vala"
							_tmp62_ = _tmp61_;
#line 608 "../gxml/CssSelectorParser.vala"
							_g_object_unref0 (_tmp59_);
#line 608 "../gxml/CssSelectorParser.vala"
							_g_object_unref0 (_tmp57_);
#line 608 "../gxml/CssSelectorParser.vala"
							attr_name = _tmp62_;
#line 609 "../gxml/CssSelectorParser.vala"
							_tmp64_ = attr_name;
#line 609 "../gxml/CssSelectorParser.vala"
							_tmp66_ = _tmp65_ = g_strsplit (_tmp64_, ":", 0);
#line 609 "../gxml/CssSelectorParser.vala"
							_tmp67_ = _tmp66_;
#line 609 "../gxml/CssSelectorParser.vala"
							_tmp67__length1 = _vala_array_length (_tmp65_);
#line 609 "../gxml/CssSelectorParser.vala"
							_tmp68_ = _vala_array_length (_tmp65_) == 2;
#line 609 "../gxml/CssSelectorParser.vala"
							_tmp67_ = (_vala_array_free (_tmp67_, _tmp67__length1, (GDestroyNotify) g_free), NULL);
#line 609 "../gxml/CssSelectorParser.vala"
							if (_tmp68_) {
#line 6973 "CssSelectorParser.c"
								gboolean _tmp69_ = FALSE;
								const gchar* _tmp70_;
								gchar** _tmp71_;
								gchar** _tmp72_;
								gchar** _tmp73_;
								gint _tmp73__length1;
								const gchar* _tmp74_;
								const gchar* _tmp75_;
								const gchar* _tmp76_;
								gboolean _tmp77_;
#line 609 "../gxml/CssSelectorParser.vala"
								_tmp70_ = attr_name;
#line 609 "../gxml/CssSelectorParser.vala"
								_tmp72_ = _tmp71_ = g_strsplit (_tmp70_, ":", 0);
#line 609 "../gxml/CssSelectorParser.vala"
								_tmp73_ = _tmp72_;
#line 609 "../gxml/CssSelectorParser.vala"
								_tmp73__length1 = _vala_array_length (_tmp71_);
#line 609 "../gxml/CssSelectorParser.vala"
								_tmp74_ = _tmp73_[1];
#line 609 "../gxml/CssSelectorParser.vala"
								_tmp75_ = gxml_css_attribute_selector_get_local_name (selector);
#line 609 "../gxml/CssSelectorParser.vala"
								_tmp76_ = _tmp75_;
#line 609 "../gxml/CssSelectorParser.vala"
								_tmp77_ = g_strcmp0 (_tmp74_, _tmp76_) == 0;
#line 609 "../gxml/CssSelectorParser.vala"
								_tmp73_ = (_vala_array_free (_tmp73_, _tmp73__length1, (GDestroyNotify) g_free), NULL);
#line 609 "../gxml/CssSelectorParser.vala"
								if (_tmp77_) {
#line 609 "../gxml/CssSelectorParser.vala"
									_tmp69_ = TRUE;
#line 7006 "CssSelectorParser.c"
								} else {
									const gchar* _tmp78_;
									const gchar* _tmp79_;
#line 609 "../gxml/CssSelectorParser.vala"
									_tmp78_ = gxml_css_attribute_selector_get_local_name (selector);
#line 609 "../gxml/CssSelectorParser.vala"
									_tmp79_ = _tmp78_;
#line 609 "../gxml/CssSelectorParser.vala"
									_tmp69_ = g_strcmp0 (_tmp79_, "*") == 0;
#line 7016 "CssSelectorParser.c"
								}
#line 609 "../gxml/CssSelectorParser.vala"
								_tmp63_ = _tmp69_;
#line 7020 "CssSelectorParser.c"
							} else {
#line 609 "../gxml/CssSelectorParser.vala"
								_tmp63_ = FALSE;
#line 7024 "CssSelectorParser.c"
							}
#line 609 "../gxml/CssSelectorParser.vala"
							if (_tmp63_) {
#line 7028 "CssSelectorParser.c"
								GeeArrayList* _tmp80_;
								GXmlDomNamedNodeMap* _tmp81_;
								GXmlDomNamedNodeMap* _tmp82_;
								GXmlDomNamedNodeMap* _tmp83_;
								GXmlDomNode* _tmp84_;
								GXmlDomNode* _tmp85_;
#line 610 "../gxml/CssSelectorParser.vala"
								_tmp80_ = list;
#line 610 "../gxml/CssSelectorParser.vala"
								_tmp81_ = gxml_dom_element_get_attributes (element);
#line 610 "../gxml/CssSelectorParser.vala"
								_tmp82_ = _tmp81_;
#line 610 "../gxml/CssSelectorParser.vala"
								_tmp83_ = _tmp82_;
#line 610 "../gxml/CssSelectorParser.vala"
								_tmp84_ = gxml_dom_named_node_map_item (_tmp83_, i);
#line 610 "../gxml/CssSelectorParser.vala"
								_tmp85_ = _tmp84_;
#line 610 "../gxml/CssSelectorParser.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp80_, _tmp85_);
#line 610 "../gxml/CssSelectorParser.vala"
								_g_object_unref0 (_tmp85_);
#line 610 "../gxml/CssSelectorParser.vala"
								_g_object_unref0 (_tmp83_);
#line 7053 "CssSelectorParser.c"
							}
#line 605 "../gxml/CssSelectorParser.vala"
							_g_free0 (attr_name);
#line 7057 "CssSelectorParser.c"
						}
					}
				}
			} else {
				{
					gint i = 0;
#line 614 "../gxml/CssSelectorParser.vala"
					i = 0;
#line 7066 "CssSelectorParser.c"
					{
						gboolean _tmp86_ = FALSE;
#line 614 "../gxml/CssSelectorParser.vala"
						_tmp86_ = TRUE;
#line 614 "../gxml/CssSelectorParser.vala"
						while (TRUE) {
#line 7073 "CssSelectorParser.c"
							GXmlDomNamedNodeMap* _tmp88_;
							GXmlDomNamedNodeMap* _tmp89_;
							GXmlDomNamedNodeMap* _tmp90_;
							gint _tmp91_;
							gint _tmp92_;
							gboolean _tmp93_;
							GXmlDomNamedNodeMap* _tmp94_;
							GXmlDomNamedNodeMap* _tmp95_;
							GXmlDomNamedNodeMap* _tmp96_;
							GXmlDomNode* _tmp97_;
							GXmlDomNode* _tmp98_;
							gboolean _tmp99_;
							gchar* attr_name = NULL;
							GXmlDomNamedNodeMap* _tmp100_;
							GXmlDomNamedNodeMap* _tmp101_;
							GXmlDomNamedNodeMap* _tmp102_;
							GXmlDomNode* _tmp103_;
							GXmlDomNode* _tmp104_;
							gchar* _tmp105_;
							gchar* _tmp106_;
							gchar* _tmp107_;
							gboolean _tmp108_ = FALSE;
							gboolean _tmp109_ = FALSE;
							const gchar* _tmp110_;
							gchar** _tmp111_;
							gchar** _tmp112_;
							gchar** _tmp113_;
							gint _tmp113__length1;
							gboolean _tmp114_;
#line 614 "../gxml/CssSelectorParser.vala"
							if (!_tmp86_) {
#line 7105 "CssSelectorParser.c"
								gint _tmp87_;
#line 614 "../gxml/CssSelectorParser.vala"
								_tmp87_ = i;
#line 614 "../gxml/CssSelectorParser.vala"
								i = _tmp87_ + 1;
#line 7111 "CssSelectorParser.c"
							}
#line 614 "../gxml/CssSelectorParser.vala"
							_tmp86_ = FALSE;
#line 614 "../gxml/CssSelectorParser.vala"
							_tmp88_ = gxml_dom_element_get_attributes (element);
#line 614 "../gxml/CssSelectorParser.vala"
							_tmp89_ = _tmp88_;
#line 614 "../gxml/CssSelectorParser.vala"
							_tmp90_ = _tmp89_;
#line 614 "../gxml/CssSelectorParser.vala"
							_tmp91_ = gxml_dom_named_node_map_get_length (_tmp90_);
#line 614 "../gxml/CssSelectorParser.vala"
							_tmp92_ = _tmp91_;
#line 614 "../gxml/CssSelectorParser.vala"
							_tmp93_ = !(i < _tmp92_);
#line 614 "../gxml/CssSelectorParser.vala"
							_g_object_unref0 (_tmp90_);
#line 614 "../gxml/CssSelectorParser.vala"
							if (_tmp93_) {
#line 614 "../gxml/CssSelectorParser.vala"
								break;
#line 7133 "CssSelectorParser.c"
							}
#line 615 "../gxml/CssSelectorParser.vala"
							_tmp94_ = gxml_dom_element_get_attributes (element);
#line 615 "../gxml/CssSelectorParser.vala"
							_tmp95_ = _tmp94_;
#line 615 "../gxml/CssSelectorParser.vala"
							_tmp96_ = _tmp95_;
#line 615 "../gxml/CssSelectorParser.vala"
							_tmp97_ = gxml_dom_named_node_map_item (_tmp96_, i);
#line 615 "../gxml/CssSelectorParser.vala"
							_tmp98_ = _tmp97_;
#line 615 "../gxml/CssSelectorParser.vala"
							_tmp99_ = _tmp98_ == NULL;
#line 615 "../gxml/CssSelectorParser.vala"
							_g_object_unref0 (_tmp98_);
#line 615 "../gxml/CssSelectorParser.vala"
							_g_object_unref0 (_tmp96_);
#line 615 "../gxml/CssSelectorParser.vala"
							if (_tmp99_) {
#line 616 "../gxml/CssSelectorParser.vala"
								continue;
#line 7155 "CssSelectorParser.c"
							}
#line 617 "../gxml/CssSelectorParser.vala"
							_tmp100_ = gxml_dom_element_get_attributes (element);
#line 617 "../gxml/CssSelectorParser.vala"
							_tmp101_ = _tmp100_;
#line 617 "../gxml/CssSelectorParser.vala"
							_tmp102_ = _tmp101_;
#line 617 "../gxml/CssSelectorParser.vala"
							_tmp103_ = gxml_dom_named_node_map_item (_tmp102_, i);
#line 617 "../gxml/CssSelectorParser.vala"
							_tmp104_ = _tmp103_;
#line 617 "../gxml/CssSelectorParser.vala"
							_tmp105_ = gxml_dom_node_get_node_name (_tmp104_);
#line 617 "../gxml/CssSelectorParser.vala"
							_tmp106_ = _tmp105_;
#line 617 "../gxml/CssSelectorParser.vala"
							_tmp107_ = _tmp106_;
#line 617 "../gxml/CssSelectorParser.vala"
							_g_object_unref0 (_tmp104_);
#line 617 "../gxml/CssSelectorParser.vala"
							_g_object_unref0 (_tmp102_);
#line 617 "../gxml/CssSelectorParser.vala"
							attr_name = _tmp107_;
#line 618 "../gxml/CssSelectorParser.vala"
							_tmp110_ = attr_name;
#line 618 "../gxml/CssSelectorParser.vala"
							_tmp112_ = _tmp111_ = g_strsplit (_tmp110_, ":", 0);
#line 618 "../gxml/CssSelectorParser.vala"
							_tmp113_ = _tmp112_;
#line 618 "../gxml/CssSelectorParser.vala"
							_tmp113__length1 = _vala_array_length (_tmp111_);
#line 618 "../gxml/CssSelectorParser.vala"
							_tmp114_ = _vala_array_length (_tmp111_) == 2;
#line 618 "../gxml/CssSelectorParser.vala"
							_tmp113_ = (_vala_array_free (_tmp113_, _tmp113__length1, (GDestroyNotify) g_free), NULL);
#line 618 "../gxml/CssSelectorParser.vala"
							if (_tmp114_) {
#line 7193 "CssSelectorParser.c"
								const gchar* _tmp115_;
								gchar** _tmp116_;
								gchar** _tmp117_;
								gchar** _tmp118_;
								gint _tmp118__length1;
								const gchar* _tmp119_;
								const gchar* _tmp120_;
								const gchar* _tmp121_;
#line 618 "../gxml/CssSelectorParser.vala"
								_tmp115_ = attr_name;
#line 618 "../gxml/CssSelectorParser.vala"
								_tmp117_ = _tmp116_ = g_strsplit (_tmp115_, ":", 0);
#line 618 "../gxml/CssSelectorParser.vala"
								_tmp118_ = _tmp117_;
#line 618 "../gxml/CssSelectorParser.vala"
								_tmp118__length1 = _vala_array_length (_tmp116_);
#line 618 "../gxml/CssSelectorParser.vala"
								_tmp119_ = _tmp118_[0];
#line 618 "../gxml/CssSelectorParser.vala"
								_tmp120_ = gxml_css_attribute_selector_get_prefix (selector);
#line 618 "../gxml/CssSelectorParser.vala"
								_tmp121_ = _tmp120_;
#line 618 "../gxml/CssSelectorParser.vala"
								_tmp109_ = g_strcmp0 (_tmp119_, _tmp121_) == 0;
#line 618 "../gxml/CssSelectorParser.vala"
								_tmp118_ = (_vala_array_free (_tmp118_, _tmp118__length1, (GDestroyNotify) g_free), NULL);
#line 7220 "CssSelectorParser.c"
							} else {
#line 618 "../gxml/CssSelectorParser.vala"
								_tmp109_ = FALSE;
#line 7224 "CssSelectorParser.c"
							}
#line 618 "../gxml/CssSelectorParser.vala"
							if (_tmp109_) {
#line 7228 "CssSelectorParser.c"
								gboolean _tmp122_ = FALSE;
								const gchar* _tmp123_;
								gchar** _tmp124_;
								gchar** _tmp125_;
								gchar** _tmp126_;
								gint _tmp126__length1;
								const gchar* _tmp127_;
								const gchar* _tmp128_;
								const gchar* _tmp129_;
								gboolean _tmp130_;
#line 618 "../gxml/CssSelectorParser.vala"
								_tmp123_ = attr_name;
#line 618 "../gxml/CssSelectorParser.vala"
								_tmp125_ = _tmp124_ = g_strsplit (_tmp123_, ":", 0);
#line 618 "../gxml/CssSelectorParser.vala"
								_tmp126_ = _tmp125_;
#line 618 "../gxml/CssSelectorParser.vala"
								_tmp126__length1 = _vala_array_length (_tmp124_);
#line 618 "../gxml/CssSelectorParser.vala"
								_tmp127_ = _tmp126_[1];
#line 618 "../gxml/CssSelectorParser.vala"
								_tmp128_ = gxml_css_attribute_selector_get_local_name (selector);
#line 618 "../gxml/CssSelectorParser.vala"
								_tmp129_ = _tmp128_;
#line 618 "../gxml/CssSelectorParser.vala"
								_tmp130_ = g_strcmp0 (_tmp127_, _tmp129_) == 0;
#line 618 "../gxml/CssSelectorParser.vala"
								_tmp126_ = (_vala_array_free (_tmp126_, _tmp126__length1, (GDestroyNotify) g_free), NULL);
#line 618 "../gxml/CssSelectorParser.vala"
								if (_tmp130_) {
#line 618 "../gxml/CssSelectorParser.vala"
									_tmp122_ = TRUE;
#line 7261 "CssSelectorParser.c"
								} else {
									const gchar* _tmp131_;
									const gchar* _tmp132_;
#line 618 "../gxml/CssSelectorParser.vala"
									_tmp131_ = gxml_css_attribute_selector_get_local_name (selector);
#line 618 "../gxml/CssSelectorParser.vala"
									_tmp132_ = _tmp131_;
#line 618 "../gxml/CssSelectorParser.vala"
									_tmp122_ = g_strcmp0 (_tmp132_, "*") == 0;
#line 7271 "CssSelectorParser.c"
								}
#line 618 "../gxml/CssSelectorParser.vala"
								_tmp108_ = _tmp122_;
#line 7275 "CssSelectorParser.c"
							} else {
#line 618 "../gxml/CssSelectorParser.vala"
								_tmp108_ = FALSE;
#line 7279 "CssSelectorParser.c"
							}
#line 618 "../gxml/CssSelectorParser.vala"
							if (_tmp108_) {
#line 7283 "CssSelectorParser.c"
								GeeArrayList* _tmp133_;
								GXmlDomNamedNodeMap* _tmp134_;
								GXmlDomNamedNodeMap* _tmp135_;
								GXmlDomNamedNodeMap* _tmp136_;
								GXmlDomNode* _tmp137_;
								GXmlDomNode* _tmp138_;
#line 619 "../gxml/CssSelectorParser.vala"
								_tmp133_ = list;
#line 619 "../gxml/CssSelectorParser.vala"
								_tmp134_ = gxml_dom_element_get_attributes (element);
#line 619 "../gxml/CssSelectorParser.vala"
								_tmp135_ = _tmp134_;
#line 619 "../gxml/CssSelectorParser.vala"
								_tmp136_ = _tmp135_;
#line 619 "../gxml/CssSelectorParser.vala"
								_tmp137_ = gxml_dom_named_node_map_item (_tmp136_, i);
#line 619 "../gxml/CssSelectorParser.vala"
								_tmp138_ = _tmp137_;
#line 619 "../gxml/CssSelectorParser.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp133_, _tmp138_);
#line 619 "../gxml/CssSelectorParser.vala"
								_g_object_unref0 (_tmp138_);
#line 619 "../gxml/CssSelectorParser.vala"
								_g_object_unref0 (_tmp136_);
#line 7308 "CssSelectorParser.c"
							}
#line 614 "../gxml/CssSelectorParser.vala"
							_g_free0 (attr_name);
#line 7312 "CssSelectorParser.c"
						}
					}
				}
			}
		}
	} else {
		GXmlDomNode* attr = NULL;
		GXmlDomNamedNodeMap* _tmp139_;
		GXmlDomNamedNodeMap* _tmp140_;
		GXmlDomNamedNodeMap* _tmp141_;
		const gchar* _tmp142_;
		const gchar* _tmp143_;
		GXmlDomNode* _tmp144_;
		GXmlDomNode* _tmp145_;
		GXmlDomNode* _tmp146_;
#line 624 "../gxml/CssSelectorParser.vala"
		_tmp139_ = gxml_dom_element_get_attributes (element);
#line 624 "../gxml/CssSelectorParser.vala"
		_tmp140_ = _tmp139_;
#line 624 "../gxml/CssSelectorParser.vala"
		_tmp141_ = _tmp140_;
#line 624 "../gxml/CssSelectorParser.vala"
		_tmp142_ = gxml_css_attribute_selector_get_local_name (selector);
#line 624 "../gxml/CssSelectorParser.vala"
		_tmp143_ = _tmp142_;
#line 624 "../gxml/CssSelectorParser.vala"
		_tmp144_ = gxml_dom_named_node_map_get_named_item (_tmp141_, _tmp143_);
#line 624 "../gxml/CssSelectorParser.vala"
		_tmp145_ = _tmp144_;
#line 624 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp141_);
#line 624 "../gxml/CssSelectorParser.vala"
		attr = _tmp145_;
#line 625 "../gxml/CssSelectorParser.vala"
		_tmp146_ = attr;
#line 625 "../gxml/CssSelectorParser.vala"
		if (_tmp146_ != NULL) {
#line 7350 "CssSelectorParser.c"
			GeeArrayList* _tmp147_;
			GXmlDomNode* _tmp148_;
#line 626 "../gxml/CssSelectorParser.vala"
			_tmp147_ = list;
#line 626 "../gxml/CssSelectorParser.vala"
			_tmp148_ = attr;
#line 626 "../gxml/CssSelectorParser.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp147_, _tmp148_);
#line 7359 "CssSelectorParser.c"
		}
#line 595 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (attr);
#line 7363 "CssSelectorParser.c"
	}
#line 628 "../gxml/CssSelectorParser.vala"
	_tmp149_ = list;
#line 628 "../gxml/CssSelectorParser.vala"
	_tmp150_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp149_);
#line 628 "../gxml/CssSelectorParser.vala"
	_tmp151_ = _tmp150_;
#line 628 "../gxml/CssSelectorParser.vala"
	if (_tmp151_ == 0) {
#line 629 "../gxml/CssSelectorParser.vala"
		result = FALSE;
#line 629 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (list);
#line 629 "../gxml/CssSelectorParser.vala"
		return result;
#line 7379 "CssSelectorParser.c"
	}
	{
		GeeArrayList* _attr_list = NULL;
		GeeArrayList* _tmp152_;
		gint _attr_size = 0;
		GeeArrayList* _tmp153_;
		gint _tmp154_;
		gint _tmp155_;
		gint _attr_index = 0;
#line 630 "../gxml/CssSelectorParser.vala"
		_tmp152_ = list;
#line 630 "../gxml/CssSelectorParser.vala"
		_attr_list = _tmp152_;
#line 630 "../gxml/CssSelectorParser.vala"
		_tmp153_ = _attr_list;
#line 630 "../gxml/CssSelectorParser.vala"
		_tmp154_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp153_);
#line 630 "../gxml/CssSelectorParser.vala"
		_tmp155_ = _tmp154_;
#line 630 "../gxml/CssSelectorParser.vala"
		_attr_size = _tmp155_;
#line 630 "../gxml/CssSelectorParser.vala"
		_attr_index = -1;
#line 630 "../gxml/CssSelectorParser.vala"
		while (TRUE) {
#line 7405 "CssSelectorParser.c"
			gint _tmp156_;
			gint _tmp157_;
			GXmlDomNode* attr = NULL;
			GeeArrayList* _tmp158_;
			gpointer _tmp159_;
			GXmlCssSelectorType _tmp160_;
			GXmlCssSelectorType _tmp161_;
			gboolean _tmp162_ = FALSE;
			GXmlCssSelectorType _tmp163_;
			GXmlCssSelectorType _tmp164_;
			gboolean _tmp171_ = FALSE;
			gboolean _tmp172_ = FALSE;
			GXmlCssSelectorType _tmp173_;
			GXmlCssSelectorType _tmp174_;
			gboolean _tmp188_ = FALSE;
			gboolean _tmp189_ = FALSE;
			GXmlCssSelectorType _tmp190_;
			GXmlCssSelectorType _tmp191_;
			gboolean _tmp202_ = FALSE;
			gboolean _tmp203_ = FALSE;
			GXmlCssSelectorType _tmp204_;
			GXmlCssSelectorType _tmp205_;
			gboolean _tmp220_ = FALSE;
			gboolean _tmp221_ = FALSE;
			GXmlCssSelectorType _tmp222_;
			GXmlCssSelectorType _tmp223_;
			gboolean _tmp234_ = FALSE;
			gboolean _tmp235_ = FALSE;
			GXmlCssSelectorType _tmp236_;
			GXmlCssSelectorType _tmp237_;
#line 630 "../gxml/CssSelectorParser.vala"
			_attr_index = _attr_index + 1;
#line 630 "../gxml/CssSelectorParser.vala"
			_tmp156_ = _attr_index;
#line 630 "../gxml/CssSelectorParser.vala"
			_tmp157_ = _attr_size;
#line 630 "../gxml/CssSelectorParser.vala"
			if (!(_tmp156_ < _tmp157_)) {
#line 630 "../gxml/CssSelectorParser.vala"
				break;
#line 7446 "CssSelectorParser.c"
			}
#line 630 "../gxml/CssSelectorParser.vala"
			_tmp158_ = _attr_list;
#line 630 "../gxml/CssSelectorParser.vala"
			_tmp159_ = gee_abstract_list_get ((GeeAbstractList*) _tmp158_, _attr_index);
#line 630 "../gxml/CssSelectorParser.vala"
			attr = (GXmlDomNode*) _tmp159_;
#line 631 "../gxml/CssSelectorParser.vala"
			_tmp160_ = gxml_css_selector_get_selector_type ((GXmlCssSelector*) selector);
#line 631 "../gxml/CssSelectorParser.vala"
			_tmp161_ = _tmp160_;
#line 631 "../gxml/CssSelectorParser.vala"
			if (_tmp161_ == GXML_CSS_SELECTOR_TYPE_ATTRIBUTE) {
#line 632 "../gxml/CssSelectorParser.vala"
				result = TRUE;
#line 632 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (attr);
#line 632 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (list);
#line 632 "../gxml/CssSelectorParser.vala"
				return result;
#line 7468 "CssSelectorParser.c"
			}
#line 633 "../gxml/CssSelectorParser.vala"
			_tmp163_ = gxml_css_selector_get_selector_type ((GXmlCssSelector*) selector);
#line 633 "../gxml/CssSelectorParser.vala"
			_tmp164_ = _tmp163_;
#line 633 "../gxml/CssSelectorParser.vala"
			if (_tmp164_ == GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_EQUAL) {
#line 7476 "CssSelectorParser.c"
				GXmlDomNode* _tmp165_;
				gchar* _tmp166_;
				gchar* _tmp167_;
				gchar* _tmp168_;
				const gchar* _tmp169_;
				const gchar* _tmp170_;
#line 633 "../gxml/CssSelectorParser.vala"
				_tmp165_ = attr;
#line 633 "../gxml/CssSelectorParser.vala"
				_tmp166_ = gxml_dom_node_get_node_value (_tmp165_);
#line 633 "../gxml/CssSelectorParser.vala"
				_tmp167_ = _tmp166_;
#line 633 "../gxml/CssSelectorParser.vala"
				_tmp168_ = _tmp167_;
#line 633 "../gxml/CssSelectorParser.vala"
				_tmp169_ = gxml_css_selector_get_value ((GXmlCssSelector*) selector);
#line 633 "../gxml/CssSelectorParser.vala"
				_tmp170_ = _tmp169_;
#line 633 "../gxml/CssSelectorParser.vala"
				_tmp162_ = g_strcmp0 (_tmp168_, _tmp170_) == 0;
#line 633 "../gxml/CssSelectorParser.vala"
				_g_free0 (_tmp168_);
#line 7499 "CssSelectorParser.c"
			} else {
#line 633 "../gxml/CssSelectorParser.vala"
				_tmp162_ = FALSE;
#line 7503 "CssSelectorParser.c"
			}
#line 633 "../gxml/CssSelectorParser.vala"
			if (_tmp162_) {
#line 634 "../gxml/CssSelectorParser.vala"
				result = TRUE;
#line 634 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (attr);
#line 634 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (list);
#line 634 "../gxml/CssSelectorParser.vala"
				return result;
#line 7515 "CssSelectorParser.c"
			}
#line 635 "../gxml/CssSelectorParser.vala"
			_tmp173_ = gxml_css_selector_get_selector_type ((GXmlCssSelector*) selector);
#line 635 "../gxml/CssSelectorParser.vala"
			_tmp174_ = _tmp173_;
#line 635 "../gxml/CssSelectorParser.vala"
			if (_tmp174_ == GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_CONTAINS) {
#line 7523 "CssSelectorParser.c"
				GXmlDomNode* _tmp175_;
				gchar* _tmp176_;
				gchar* _tmp177_;
				gchar* _tmp178_;
#line 635 "../gxml/CssSelectorParser.vala"
				_tmp175_ = attr;
#line 635 "../gxml/CssSelectorParser.vala"
				_tmp176_ = gxml_dom_node_get_node_value (_tmp175_);
#line 635 "../gxml/CssSelectorParser.vala"
				_tmp177_ = _tmp176_;
#line 635 "../gxml/CssSelectorParser.vala"
				_tmp178_ = _tmp177_;
#line 635 "../gxml/CssSelectorParser.vala"
				_tmp172_ = _tmp178_ != NULL;
#line 635 "../gxml/CssSelectorParser.vala"
				_g_free0 (_tmp178_);
#line 7540 "CssSelectorParser.c"
			} else {
#line 635 "../gxml/CssSelectorParser.vala"
				_tmp172_ = FALSE;
#line 7544 "CssSelectorParser.c"
			}
#line 635 "../gxml/CssSelectorParser.vala"
			if (_tmp172_) {
#line 7548 "CssSelectorParser.c"
				const gchar* _tmp179_;
				const gchar* _tmp180_;
				GXmlDomNode* _tmp181_;
				gchar* _tmp182_;
				gchar* _tmp183_;
				gchar* _tmp184_;
				gchar** _tmp185_;
				gchar** _tmp186_;
				gchar** _tmp187_;
				gint _tmp187__length1;
#line 635 "../gxml/CssSelectorParser.vala"
				_tmp179_ = gxml_css_selector_get_value ((GXmlCssSelector*) selector);
#line 635 "../gxml/CssSelectorParser.vala"
				_tmp180_ = _tmp179_;
#line 635 "../gxml/CssSelectorParser.vala"
				_tmp181_ = attr;
#line 635 "../gxml/CssSelectorParser.vala"
				_tmp182_ = gxml_dom_node_get_node_value (_tmp181_);
#line 635 "../gxml/CssSelectorParser.vala"
				_tmp183_ = _tmp182_;
#line 635 "../gxml/CssSelectorParser.vala"
				_tmp184_ = _tmp183_;
#line 635 "../gxml/CssSelectorParser.vala"
				_tmp186_ = _tmp185_ = g_strsplit (_tmp184_, " ", 0);
#line 635 "../gxml/CssSelectorParser.vala"
				_tmp187_ = _tmp186_;
#line 635 "../gxml/CssSelectorParser.vala"
				_tmp187__length1 = _vala_array_length (_tmp185_);
#line 635 "../gxml/CssSelectorParser.vala"
				_tmp171_ = _vala_string_array_contains (_tmp187_, _vala_array_length (_tmp185_), _tmp180_);
#line 635 "../gxml/CssSelectorParser.vala"
				_tmp187_ = (_vala_array_free (_tmp187_, _tmp187__length1, (GDestroyNotify) g_free), NULL);
#line 635 "../gxml/CssSelectorParser.vala"
				_g_free0 (_tmp184_);
#line 7583 "CssSelectorParser.c"
			} else {
#line 635 "../gxml/CssSelectorParser.vala"
				_tmp171_ = FALSE;
#line 7587 "CssSelectorParser.c"
			}
#line 635 "../gxml/CssSelectorParser.vala"
			if (_tmp171_) {
#line 636 "../gxml/CssSelectorParser.vala"
				result = TRUE;
#line 636 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (attr);
#line 636 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (list);
#line 636 "../gxml/CssSelectorParser.vala"
				return result;
#line 7599 "CssSelectorParser.c"
			}
#line 637 "../gxml/CssSelectorParser.vala"
			_tmp190_ = gxml_css_selector_get_selector_type ((GXmlCssSelector*) selector);
#line 637 "../gxml/CssSelectorParser.vala"
			_tmp191_ = _tmp190_;
#line 637 "../gxml/CssSelectorParser.vala"
			if (_tmp191_ == GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_SUBSTRING) {
#line 7607 "CssSelectorParser.c"
				GXmlDomNode* _tmp192_;
				gchar* _tmp193_;
				gchar* _tmp194_;
				gchar* _tmp195_;
#line 637 "../gxml/CssSelectorParser.vala"
				_tmp192_ = attr;
#line 637 "../gxml/CssSelectorParser.vala"
				_tmp193_ = gxml_dom_node_get_node_value (_tmp192_);
#line 637 "../gxml/CssSelectorParser.vala"
				_tmp194_ = _tmp193_;
#line 637 "../gxml/CssSelectorParser.vala"
				_tmp195_ = _tmp194_;
#line 637 "../gxml/CssSelectorParser.vala"
				_tmp189_ = _tmp195_ != NULL;
#line 637 "../gxml/CssSelectorParser.vala"
				_g_free0 (_tmp195_);
#line 7624 "CssSelectorParser.c"
			} else {
#line 637 "../gxml/CssSelectorParser.vala"
				_tmp189_ = FALSE;
#line 7628 "CssSelectorParser.c"
			}
#line 637 "../gxml/CssSelectorParser.vala"
			if (_tmp189_) {
#line 7632 "CssSelectorParser.c"
				GXmlDomNode* _tmp196_;
				gchar* _tmp197_;
				gchar* _tmp198_;
				gchar* _tmp199_;
				const gchar* _tmp200_;
				const gchar* _tmp201_;
#line 637 "../gxml/CssSelectorParser.vala"
				_tmp196_ = attr;
#line 637 "../gxml/CssSelectorParser.vala"
				_tmp197_ = gxml_dom_node_get_node_value (_tmp196_);
#line 637 "../gxml/CssSelectorParser.vala"
				_tmp198_ = _tmp197_;
#line 637 "../gxml/CssSelectorParser.vala"
				_tmp199_ = _tmp198_;
#line 637 "../gxml/CssSelectorParser.vala"
				_tmp200_ = gxml_css_selector_get_value ((GXmlCssSelector*) selector);
#line 637 "../gxml/CssSelectorParser.vala"
				_tmp201_ = _tmp200_;
#line 637 "../gxml/CssSelectorParser.vala"
				_tmp188_ = string_contains (_tmp199_, _tmp201_);
#line 637 "../gxml/CssSelectorParser.vala"
				_g_free0 (_tmp199_);
#line 7655 "CssSelectorParser.c"
			} else {
#line 637 "../gxml/CssSelectorParser.vala"
				_tmp188_ = FALSE;
#line 7659 "CssSelectorParser.c"
			}
#line 637 "../gxml/CssSelectorParser.vala"
			if (_tmp188_) {
#line 638 "../gxml/CssSelectorParser.vala"
				result = TRUE;
#line 638 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (attr);
#line 638 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (list);
#line 638 "../gxml/CssSelectorParser.vala"
				return result;
#line 7671 "CssSelectorParser.c"
			}
#line 639 "../gxml/CssSelectorParser.vala"
			_tmp204_ = gxml_css_selector_get_selector_type ((GXmlCssSelector*) selector);
#line 639 "../gxml/CssSelectorParser.vala"
			_tmp205_ = _tmp204_;
#line 639 "../gxml/CssSelectorParser.vala"
			if (_tmp205_ == GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_STARTS_WITH_WORD) {
#line 7679 "CssSelectorParser.c"
				GXmlDomNode* _tmp206_;
				gchar* _tmp207_;
				gchar* _tmp208_;
				gchar* _tmp209_;
#line 639 "../gxml/CssSelectorParser.vala"
				_tmp206_ = attr;
#line 639 "../gxml/CssSelectorParser.vala"
				_tmp207_ = gxml_dom_node_get_node_value (_tmp206_);
#line 639 "../gxml/CssSelectorParser.vala"
				_tmp208_ = _tmp207_;
#line 639 "../gxml/CssSelectorParser.vala"
				_tmp209_ = _tmp208_;
#line 639 "../gxml/CssSelectorParser.vala"
				_tmp203_ = _tmp209_ != NULL;
#line 639 "../gxml/CssSelectorParser.vala"
				_g_free0 (_tmp209_);
#line 7696 "CssSelectorParser.c"
			} else {
#line 639 "../gxml/CssSelectorParser.vala"
				_tmp203_ = FALSE;
#line 7700 "CssSelectorParser.c"
			}
#line 639 "../gxml/CssSelectorParser.vala"
			if (_tmp203_) {
#line 7704 "CssSelectorParser.c"
				GXmlDomNode* _tmp210_;
				gchar* _tmp211_;
				gchar* _tmp212_;
				gchar* _tmp213_;
				gchar** _tmp214_;
				gchar** _tmp215_;
				gchar** _tmp216_;
				gint _tmp216__length1;
				const gchar* _tmp217_;
				const gchar* _tmp218_;
				const gchar* _tmp219_;
#line 639 "../gxml/CssSelectorParser.vala"
				_tmp210_ = attr;
#line 639 "../gxml/CssSelectorParser.vala"
				_tmp211_ = gxml_dom_node_get_node_value (_tmp210_);
#line 639 "../gxml/CssSelectorParser.vala"
				_tmp212_ = _tmp211_;
#line 639 "../gxml/CssSelectorParser.vala"
				_tmp213_ = _tmp212_;
#line 639 "../gxml/CssSelectorParser.vala"
				_tmp215_ = _tmp214_ = g_strsplit (_tmp213_, "-", 0);
#line 639 "../gxml/CssSelectorParser.vala"
				_tmp216_ = _tmp215_;
#line 639 "../gxml/CssSelectorParser.vala"
				_tmp216__length1 = _vala_array_length (_tmp214_);
#line 639 "../gxml/CssSelectorParser.vala"
				_tmp217_ = _tmp216_[0];
#line 639 "../gxml/CssSelectorParser.vala"
				_tmp218_ = gxml_css_selector_get_value ((GXmlCssSelector*) selector);
#line 639 "../gxml/CssSelectorParser.vala"
				_tmp219_ = _tmp218_;
#line 639 "../gxml/CssSelectorParser.vala"
				_tmp202_ = g_strcmp0 (_tmp217_, _tmp219_) == 0;
#line 639 "../gxml/CssSelectorParser.vala"
				_tmp216_ = (_vala_array_free (_tmp216_, _tmp216__length1, (GDestroyNotify) g_free), NULL);
#line 639 "../gxml/CssSelectorParser.vala"
				_g_free0 (_tmp213_);
#line 7742 "CssSelectorParser.c"
			} else {
#line 639 "../gxml/CssSelectorParser.vala"
				_tmp202_ = FALSE;
#line 7746 "CssSelectorParser.c"
			}
#line 639 "../gxml/CssSelectorParser.vala"
			if (_tmp202_) {
#line 640 "../gxml/CssSelectorParser.vala"
				result = TRUE;
#line 640 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (attr);
#line 640 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (list);
#line 640 "../gxml/CssSelectorParser.vala"
				return result;
#line 7758 "CssSelectorParser.c"
			}
#line 641 "../gxml/CssSelectorParser.vala"
			_tmp222_ = gxml_css_selector_get_selector_type ((GXmlCssSelector*) selector);
#line 641 "../gxml/CssSelectorParser.vala"
			_tmp223_ = _tmp222_;
#line 641 "../gxml/CssSelectorParser.vala"
			if (_tmp223_ == GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_STARTS_WITH) {
#line 7766 "CssSelectorParser.c"
				GXmlDomNode* _tmp224_;
				gchar* _tmp225_;
				gchar* _tmp226_;
				gchar* _tmp227_;
#line 641 "../gxml/CssSelectorParser.vala"
				_tmp224_ = attr;
#line 641 "../gxml/CssSelectorParser.vala"
				_tmp225_ = gxml_dom_node_get_node_value (_tmp224_);
#line 641 "../gxml/CssSelectorParser.vala"
				_tmp226_ = _tmp225_;
#line 641 "../gxml/CssSelectorParser.vala"
				_tmp227_ = _tmp226_;
#line 641 "../gxml/CssSelectorParser.vala"
				_tmp221_ = _tmp227_ != NULL;
#line 641 "../gxml/CssSelectorParser.vala"
				_g_free0 (_tmp227_);
#line 7783 "CssSelectorParser.c"
			} else {
#line 641 "../gxml/CssSelectorParser.vala"
				_tmp221_ = FALSE;
#line 7787 "CssSelectorParser.c"
			}
#line 641 "../gxml/CssSelectorParser.vala"
			if (_tmp221_) {
#line 7791 "CssSelectorParser.c"
				GXmlDomNode* _tmp228_;
				gchar* _tmp229_;
				gchar* _tmp230_;
				gchar* _tmp231_;
				const gchar* _tmp232_;
				const gchar* _tmp233_;
#line 641 "../gxml/CssSelectorParser.vala"
				_tmp228_ = attr;
#line 641 "../gxml/CssSelectorParser.vala"
				_tmp229_ = gxml_dom_node_get_node_value (_tmp228_);
#line 641 "../gxml/CssSelectorParser.vala"
				_tmp230_ = _tmp229_;
#line 641 "../gxml/CssSelectorParser.vala"
				_tmp231_ = _tmp230_;
#line 641 "../gxml/CssSelectorParser.vala"
				_tmp232_ = gxml_css_selector_get_value ((GXmlCssSelector*) selector);
#line 641 "../gxml/CssSelectorParser.vala"
				_tmp233_ = _tmp232_;
#line 641 "../gxml/CssSelectorParser.vala"
				_tmp220_ = string_index_of (_tmp231_, _tmp233_, 0) == 0;
#line 641 "../gxml/CssSelectorParser.vala"
				_g_free0 (_tmp231_);
#line 7814 "CssSelectorParser.c"
			} else {
#line 641 "../gxml/CssSelectorParser.vala"
				_tmp220_ = FALSE;
#line 7818 "CssSelectorParser.c"
			}
#line 641 "../gxml/CssSelectorParser.vala"
			if (_tmp220_) {
#line 642 "../gxml/CssSelectorParser.vala"
				result = TRUE;
#line 642 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (attr);
#line 642 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (list);
#line 642 "../gxml/CssSelectorParser.vala"
				return result;
#line 7830 "CssSelectorParser.c"
			}
#line 643 "../gxml/CssSelectorParser.vala"
			_tmp236_ = gxml_css_selector_get_selector_type ((GXmlCssSelector*) selector);
#line 643 "../gxml/CssSelectorParser.vala"
			_tmp237_ = _tmp236_;
#line 643 "../gxml/CssSelectorParser.vala"
			if (_tmp237_ == GXML_CSS_SELECTOR_TYPE_ATTRIBUTE_ENDS_WITH) {
#line 7838 "CssSelectorParser.c"
				GXmlDomNode* _tmp238_;
				gchar* _tmp239_;
				gchar* _tmp240_;
				gchar* _tmp241_;
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp238_ = attr;
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp239_ = gxml_dom_node_get_node_value (_tmp238_);
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp240_ = _tmp239_;
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp241_ = _tmp240_;
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp235_ = _tmp241_ != NULL;
#line 643 "../gxml/CssSelectorParser.vala"
				_g_free0 (_tmp241_);
#line 7855 "CssSelectorParser.c"
			} else {
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp235_ = FALSE;
#line 7859 "CssSelectorParser.c"
			}
#line 643 "../gxml/CssSelectorParser.vala"
			if (_tmp235_) {
#line 7863 "CssSelectorParser.c"
				GXmlDomNode* _tmp242_;
				gchar* _tmp243_;
				gchar* _tmp244_;
				gchar* _tmp245_;
				const gchar* _tmp246_;
				const gchar* _tmp247_;
				GXmlDomNode* _tmp248_;
				gchar* _tmp249_;
				gchar* _tmp250_;
				gchar* _tmp251_;
				gint _tmp252_;
				gint _tmp253_;
				const gchar* _tmp254_;
				const gchar* _tmp255_;
				gint _tmp256_;
				gint _tmp257_;
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp242_ = attr;
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp243_ = gxml_dom_node_get_node_value (_tmp242_);
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp244_ = _tmp243_;
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp245_ = _tmp244_;
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp246_ = gxml_css_selector_get_value ((GXmlCssSelector*) selector);
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp247_ = _tmp246_;
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp248_ = attr;
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp249_ = gxml_dom_node_get_node_value (_tmp248_);
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp250_ = _tmp249_;
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp251_ = _tmp250_;
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp252_ = strlen (_tmp251_);
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp253_ = _tmp252_;
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp254_ = gxml_css_selector_get_value ((GXmlCssSelector*) selector);
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp255_ = _tmp254_;
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp256_ = strlen (_tmp255_);
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp257_ = _tmp256_;
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp234_ = string_last_index_of (_tmp245_, _tmp247_, 0) == (_tmp253_ - _tmp257_);
#line 643 "../gxml/CssSelectorParser.vala"
				_g_free0 (_tmp251_);
#line 643 "../gxml/CssSelectorParser.vala"
				_g_free0 (_tmp245_);
#line 7918 "CssSelectorParser.c"
			} else {
#line 643 "../gxml/CssSelectorParser.vala"
				_tmp234_ = FALSE;
#line 7922 "CssSelectorParser.c"
			}
#line 643 "../gxml/CssSelectorParser.vala"
			if (_tmp234_) {
#line 644 "../gxml/CssSelectorParser.vala"
				result = TRUE;
#line 644 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (attr);
#line 644 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (list);
#line 644 "../gxml/CssSelectorParser.vala"
				return result;
#line 7934 "CssSelectorParser.c"
			}
#line 630 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (attr);
#line 7938 "CssSelectorParser.c"
		}
	}
#line 646 "../gxml/CssSelectorParser.vala"
	result = FALSE;
#line 646 "../gxml/CssSelectorParser.vala"
	_g_object_unref0 (list);
#line 646 "../gxml/CssSelectorParser.vala"
	return result;
#line 7947 "CssSelectorParser.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 659 "../gxml/CssSelectorParser.vala"
	return self ? g_object_ref (self) : NULL;
#line 7955 "CssSelectorParser.c"
}

static gboolean
gxml_css_selector_parser_match_node (GXmlDomElement* element,
                                     GXmlCssSelector* selector,
                                     GError** error)
{
	GXmlCssSelectorType _tmp0_;
	GXmlCssSelectorType _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GXmlCssSelectorType _tmp4_;
	GXmlCssSelectorType _tmp5_;
	gboolean _tmp16_ = FALSE;
	GXmlCssSelectorType _tmp17_;
	GXmlCssSelectorType _tmp18_;
	GXmlCssSelectorType _tmp105_;
	GXmlCssSelectorType _tmp106_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 649 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (element != NULL, FALSE);
#line 649 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (selector != NULL, FALSE);
#line 650 "../gxml/CssSelectorParser.vala"
	_tmp0_ = gxml_css_selector_get_selector_type (selector);
#line 650 "../gxml/CssSelectorParser.vala"
	_tmp1_ = _tmp0_;
#line 650 "../gxml/CssSelectorParser.vala"
	if (_tmp1_ == GXML_CSS_SELECTOR_TYPE_ALL) {
#line 651 "../gxml/CssSelectorParser.vala"
		result = TRUE;
#line 651 "../gxml/CssSelectorParser.vala"
		return result;
#line 7990 "CssSelectorParser.c"
	}
#line 652 "../gxml/CssSelectorParser.vala"
	_tmp4_ = gxml_css_selector_get_selector_type (selector);
#line 652 "../gxml/CssSelectorParser.vala"
	_tmp5_ = _tmp4_;
#line 652 "../gxml/CssSelectorParser.vala"
	if (_tmp5_ == GXML_CSS_SELECTOR_TYPE_CLASS) {
#line 7998 "CssSelectorParser.c"
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 652 "../gxml/CssSelectorParser.vala"
		_tmp6_ = gxml_dom_element_get_attribute (element, "class");
#line 652 "../gxml/CssSelectorParser.vala"
		_tmp7_ = _tmp6_;
#line 652 "../gxml/CssSelectorParser.vala"
		_tmp3_ = _tmp7_ != NULL;
#line 652 "../gxml/CssSelectorParser.vala"
		_g_free0 (_tmp7_);
#line 8009 "CssSelectorParser.c"
	} else {
#line 652 "../gxml/CssSelectorParser.vala"
		_tmp3_ = FALSE;
#line 8013 "CssSelectorParser.c"
	}
#line 652 "../gxml/CssSelectorParser.vala"
	if (_tmp3_) {
#line 8017 "CssSelectorParser.c"
		gboolean _tmp8_ = FALSE;
		GXmlDomTokenList* _tmp9_;
		GXmlDomTokenList* _tmp10_;
		GXmlDomTokenList* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gboolean _tmp14_;
#line 652 "../gxml/CssSelectorParser.vala"
		_tmp9_ = gxml_dom_element_get_class_list (element);
#line 652 "../gxml/CssSelectorParser.vala"
		_tmp10_ = _tmp9_;
#line 652 "../gxml/CssSelectorParser.vala"
		_tmp11_ = _tmp10_;
#line 652 "../gxml/CssSelectorParser.vala"
		_tmp12_ = gxml_css_selector_get_name (selector);
#line 652 "../gxml/CssSelectorParser.vala"
		_tmp13_ = _tmp12_;
#line 652 "../gxml/CssSelectorParser.vala"
		_tmp14_ = gxml_dom_token_list_contains (_tmp11_, _tmp13_, &_inner_error0_);
#line 652 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp11_);
#line 652 "../gxml/CssSelectorParser.vala"
		_tmp8_ = _tmp14_;
#line 652 "../gxml/CssSelectorParser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8043 "CssSelectorParser.c"
			gboolean _tmp15_ = FALSE;
#line 652 "../gxml/CssSelectorParser.vala"
			g_propagate_error (error, _inner_error0_);
#line 652 "../gxml/CssSelectorParser.vala"
			return _tmp15_;
#line 8049 "CssSelectorParser.c"
		}
#line 652 "../gxml/CssSelectorParser.vala"
		_tmp2_ = _tmp8_;
#line 8053 "CssSelectorParser.c"
	} else {
#line 652 "../gxml/CssSelectorParser.vala"
		_tmp2_ = FALSE;
#line 8057 "CssSelectorParser.c"
	}
#line 652 "../gxml/CssSelectorParser.vala"
	if (_tmp2_) {
#line 653 "../gxml/CssSelectorParser.vala"
		result = TRUE;
#line 653 "../gxml/CssSelectorParser.vala"
		return result;
#line 8065 "CssSelectorParser.c"
	}
#line 654 "../gxml/CssSelectorParser.vala"
	_tmp17_ = gxml_css_selector_get_selector_type (selector);
#line 654 "../gxml/CssSelectorParser.vala"
	_tmp18_ = _tmp17_;
#line 654 "../gxml/CssSelectorParser.vala"
	if (_tmp18_ == GXML_CSS_SELECTOR_TYPE_ID) {
#line 8073 "CssSelectorParser.c"
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
#line 654 "../gxml/CssSelectorParser.vala"
		_tmp19_ = gxml_dom_element_get_id (element);
#line 654 "../gxml/CssSelectorParser.vala"
		_tmp20_ = _tmp19_;
#line 654 "../gxml/CssSelectorParser.vala"
		_tmp21_ = _tmp20_;
#line 654 "../gxml/CssSelectorParser.vala"
		_tmp22_ = gxml_css_selector_get_name (selector);
#line 654 "../gxml/CssSelectorParser.vala"
		_tmp23_ = _tmp22_;
#line 654 "../gxml/CssSelectorParser.vala"
		_tmp16_ = g_strcmp0 (_tmp21_, _tmp23_) == 0;
#line 654 "../gxml/CssSelectorParser.vala"
		_g_free0 (_tmp21_);
#line 8093 "CssSelectorParser.c"
	} else {
#line 654 "../gxml/CssSelectorParser.vala"
		_tmp16_ = FALSE;
#line 8097 "CssSelectorParser.c"
	}
#line 654 "../gxml/CssSelectorParser.vala"
	if (_tmp16_) {
#line 655 "../gxml/CssSelectorParser.vala"
		result = TRUE;
#line 655 "../gxml/CssSelectorParser.vala"
		return result;
#line 8105 "CssSelectorParser.c"
	}
#line 656 "../gxml/CssSelectorParser.vala"
	if (GXML_IS_CSS_ATTRIBUTE_SELECTOR (selector)) {
#line 8109 "CssSelectorParser.c"
		gboolean _tmp24_ = FALSE;
#line 657 "../gxml/CssSelectorParser.vala"
		_tmp24_ = gxml_css_selector_parser_match_attribute (element, GXML_IS_CSS_ATTRIBUTE_SELECTOR (selector) ? ((GXmlCssAttributeSelector*) selector) : NULL, &_inner_error0_);
#line 657 "../gxml/CssSelectorParser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8115 "CssSelectorParser.c"
			gboolean _tmp25_ = FALSE;
#line 657 "../gxml/CssSelectorParser.vala"
			g_propagate_error (error, _inner_error0_);
#line 657 "../gxml/CssSelectorParser.vala"
			return _tmp25_;
#line 8121 "CssSelectorParser.c"
		}
#line 657 "../gxml/CssSelectorParser.vala"
		result = _tmp24_;
#line 657 "../gxml/CssSelectorParser.vala"
		return result;
#line 8127 "CssSelectorParser.c"
	}
#line 658 "../gxml/CssSelectorParser.vala"
	if (GXML_IS_CSS_ELEMENT_SELECTOR (selector)) {
#line 8131 "CssSelectorParser.c"
		GXmlCssElementSelector* sel = NULL;
		GXmlCssElementSelector* _tmp26_;
		gboolean _tmp27_ = FALSE;
		GXmlCssElementSelector* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gboolean _tmp32_;
		gboolean _tmp41_ = FALSE;
		GXmlCssElementSelector* _tmp42_;
		gboolean _tmp43_;
		gboolean _tmp44_;
		GXmlCssElementSelector* _tmp72_;
		gchar* _tmp73_;
		gchar* _tmp74_;
		gchar* _tmp75_;
		gboolean _tmp76_;
		gboolean _tmp85_ = FALSE;
		GXmlCssElementSelector* _tmp86_;
		gchar* _tmp87_;
		gchar* _tmp88_;
		gchar* _tmp89_;
		gchar* _tmp90_;
		gchar* _tmp91_;
		gchar* _tmp92_;
		gboolean _tmp93_;
#line 659 "../gxml/CssSelectorParser.vala"
		_tmp26_ = _g_object_ref0 (GXML_IS_CSS_ELEMENT_SELECTOR (selector) ? ((GXmlCssElementSelector*) selector) : NULL);
#line 659 "../gxml/CssSelectorParser.vala"
		sel = _tmp26_;
#line 660 "../gxml/CssSelectorParser.vala"
		_tmp28_ = sel;
#line 660 "../gxml/CssSelectorParser.vala"
		_tmp29_ = gxml_css_element_selector_get_local_name (_tmp28_);
#line 660 "../gxml/CssSelectorParser.vala"
		_tmp30_ = _tmp29_;
#line 660 "../gxml/CssSelectorParser.vala"
		_tmp31_ = _tmp30_;
#line 660 "../gxml/CssSelectorParser.vala"
		_tmp32_ = g_strcmp0 (_tmp31_, "*") == 0;
#line 660 "../gxml/CssSelectorParser.vala"
		_g_free0 (_tmp31_);
#line 660 "../gxml/CssSelectorParser.vala"
		if (_tmp32_) {
#line 8176 "CssSelectorParser.c"
			gboolean _tmp33_ = FALSE;
			GXmlCssElementSelector* _tmp34_;
			gboolean _tmp35_;
			gboolean _tmp36_;
#line 660 "../gxml/CssSelectorParser.vala"
			_tmp34_ = sel;
#line 660 "../gxml/CssSelectorParser.vala"
			_tmp35_ = gxml_css_element_selector_get_prefixed (_tmp34_);
#line 660 "../gxml/CssSelectorParser.vala"
			_tmp36_ = _tmp35_;
#line 660 "../gxml/CssSelectorParser.vala"
			if (!_tmp36_) {
#line 660 "../gxml/CssSelectorParser.vala"
				_tmp33_ = TRUE;
#line 8191 "CssSelectorParser.c"
			} else {
				GXmlCssElementSelector* _tmp37_;
				gchar* _tmp38_;
				gchar* _tmp39_;
				gchar* _tmp40_;
#line 660 "../gxml/CssSelectorParser.vala"
				_tmp37_ = sel;
#line 660 "../gxml/CssSelectorParser.vala"
				_tmp38_ = gxml_css_element_selector_get_prefix (_tmp37_);
#line 660 "../gxml/CssSelectorParser.vala"
				_tmp39_ = _tmp38_;
#line 660 "../gxml/CssSelectorParser.vala"
				_tmp40_ = _tmp39_;
#line 660 "../gxml/CssSelectorParser.vala"
				_tmp33_ = g_strcmp0 (_tmp40_, "*") == 0;
#line 660 "../gxml/CssSelectorParser.vala"
				_g_free0 (_tmp40_);
#line 8209 "CssSelectorParser.c"
			}
#line 660 "../gxml/CssSelectorParser.vala"
			_tmp27_ = _tmp33_;
#line 8213 "CssSelectorParser.c"
		} else {
#line 660 "../gxml/CssSelectorParser.vala"
			_tmp27_ = FALSE;
#line 8217 "CssSelectorParser.c"
		}
#line 660 "../gxml/CssSelectorParser.vala"
		if (_tmp27_) {
#line 661 "../gxml/CssSelectorParser.vala"
			result = TRUE;
#line 661 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (sel);
#line 661 "../gxml/CssSelectorParser.vala"
			return result;
#line 8227 "CssSelectorParser.c"
		}
#line 662 "../gxml/CssSelectorParser.vala"
		_tmp42_ = sel;
#line 662 "../gxml/CssSelectorParser.vala"
		_tmp43_ = gxml_css_element_selector_get_prefixed (_tmp42_);
#line 662 "../gxml/CssSelectorParser.vala"
		_tmp44_ = _tmp43_;
#line 662 "../gxml/CssSelectorParser.vala"
		if (_tmp44_) {
#line 8237 "CssSelectorParser.c"
			GXmlCssElementSelector* _tmp45_;
			gchar* _tmp46_;
			gchar* _tmp47_;
			gchar* _tmp48_;
#line 662 "../gxml/CssSelectorParser.vala"
			_tmp45_ = sel;
#line 662 "../gxml/CssSelectorParser.vala"
			_tmp46_ = gxml_css_element_selector_get_prefix (_tmp45_);
#line 662 "../gxml/CssSelectorParser.vala"
			_tmp47_ = _tmp46_;
#line 662 "../gxml/CssSelectorParser.vala"
			_tmp48_ = _tmp47_;
#line 662 "../gxml/CssSelectorParser.vala"
			_tmp41_ = g_strcmp0 (_tmp48_, "") == 0;
#line 662 "../gxml/CssSelectorParser.vala"
			_g_free0 (_tmp48_);
#line 8254 "CssSelectorParser.c"
		} else {
#line 662 "../gxml/CssSelectorParser.vala"
			_tmp41_ = FALSE;
#line 8258 "CssSelectorParser.c"
		}
#line 662 "../gxml/CssSelectorParser.vala"
		if (_tmp41_) {
#line 8262 "CssSelectorParser.c"
			gboolean _tmp49_ = FALSE;
			gchar* _tmp50_;
			gchar* _tmp51_;
			gchar* _tmp52_;
			gboolean _tmp53_;
			gboolean _tmp59_ = FALSE;
			GXmlCssElementSelector* _tmp60_;
			gchar* _tmp61_;
			gchar* _tmp62_;
			gchar* _tmp63_;
			gboolean _tmp64_;
#line 663 "../gxml/CssSelectorParser.vala"
			_tmp50_ = gxml_dom_element_get_prefix (element);
#line 663 "../gxml/CssSelectorParser.vala"
			_tmp51_ = _tmp50_;
#line 663 "../gxml/CssSelectorParser.vala"
			_tmp52_ = _tmp51_;
#line 663 "../gxml/CssSelectorParser.vala"
			_tmp53_ = _tmp52_ != NULL;
#line 663 "../gxml/CssSelectorParser.vala"
			_g_free0 (_tmp52_);
#line 663 "../gxml/CssSelectorParser.vala"
			if (_tmp53_) {
#line 8286 "CssSelectorParser.c"
				gchar* _tmp54_;
				gchar* _tmp55_;
				gchar* _tmp56_;
				gint _tmp57_;
				gint _tmp58_;
#line 663 "../gxml/CssSelectorParser.vala"
				_tmp54_ = gxml_dom_element_get_prefix (element);
#line 663 "../gxml/CssSelectorParser.vala"
				_tmp55_ = _tmp54_;
#line 663 "../gxml/CssSelectorParser.vala"
				_tmp56_ = _tmp55_;
#line 663 "../gxml/CssSelectorParser.vala"
				_tmp57_ = strlen (_tmp56_);
#line 663 "../gxml/CssSelectorParser.vala"
				_tmp58_ = _tmp57_;
#line 663 "../gxml/CssSelectorParser.vala"
				_tmp49_ = _tmp58_ > 0;
#line 663 "../gxml/CssSelectorParser.vala"
				_g_free0 (_tmp56_);
#line 8306 "CssSelectorParser.c"
			} else {
#line 663 "../gxml/CssSelectorParser.vala"
				_tmp49_ = FALSE;
#line 8310 "CssSelectorParser.c"
			}
#line 663 "../gxml/CssSelectorParser.vala"
			if (_tmp49_) {
#line 664 "../gxml/CssSelectorParser.vala"
				result = FALSE;
#line 664 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (sel);
#line 664 "../gxml/CssSelectorParser.vala"
				return result;
#line 8320 "CssSelectorParser.c"
			}
#line 665 "../gxml/CssSelectorParser.vala"
			_tmp60_ = sel;
#line 665 "../gxml/CssSelectorParser.vala"
			_tmp61_ = gxml_css_element_selector_get_local_name (_tmp60_);
#line 665 "../gxml/CssSelectorParser.vala"
			_tmp62_ = _tmp61_;
#line 665 "../gxml/CssSelectorParser.vala"
			_tmp63_ = _tmp62_;
#line 665 "../gxml/CssSelectorParser.vala"
			_tmp64_ = g_strcmp0 (_tmp63_, "*") == 0;
#line 665 "../gxml/CssSelectorParser.vala"
			_g_free0 (_tmp63_);
#line 665 "../gxml/CssSelectorParser.vala"
			if (_tmp64_) {
#line 665 "../gxml/CssSelectorParser.vala"
				_tmp59_ = TRUE;
#line 8338 "CssSelectorParser.c"
			} else {
				gchar* _tmp65_;
				gchar* _tmp66_;
				gchar* _tmp67_;
				GXmlCssElementSelector* _tmp68_;
				gchar* _tmp69_;
				gchar* _tmp70_;
				gchar* _tmp71_;
#line 665 "../gxml/CssSelectorParser.vala"
				_tmp65_ = gxml_dom_element_get_local_name (element);
#line 665 "../gxml/CssSelectorParser.vala"
				_tmp66_ = _tmp65_;
#line 665 "../gxml/CssSelectorParser.vala"
				_tmp67_ = _tmp66_;
#line 665 "../gxml/CssSelectorParser.vala"
				_tmp68_ = sel;
#line 665 "../gxml/CssSelectorParser.vala"
				_tmp69_ = gxml_css_element_selector_get_local_name (_tmp68_);
#line 665 "../gxml/CssSelectorParser.vala"
				_tmp70_ = _tmp69_;
#line 665 "../gxml/CssSelectorParser.vala"
				_tmp71_ = _tmp70_;
#line 665 "../gxml/CssSelectorParser.vala"
				_tmp59_ = g_strcmp0 (_tmp67_, _tmp71_) == 0;
#line 665 "../gxml/CssSelectorParser.vala"
				_g_free0 (_tmp71_);
#line 665 "../gxml/CssSelectorParser.vala"
				_g_free0 (_tmp67_);
#line 8367 "CssSelectorParser.c"
			}
#line 665 "../gxml/CssSelectorParser.vala"
			result = _tmp59_;
#line 665 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (sel);
#line 665 "../gxml/CssSelectorParser.vala"
			return result;
#line 8375 "CssSelectorParser.c"
		}
#line 667 "../gxml/CssSelectorParser.vala"
		_tmp72_ = sel;
#line 667 "../gxml/CssSelectorParser.vala"
		_tmp73_ = gxml_css_element_selector_get_prefix (_tmp72_);
#line 667 "../gxml/CssSelectorParser.vala"
		_tmp74_ = _tmp73_;
#line 667 "../gxml/CssSelectorParser.vala"
		_tmp75_ = _tmp74_;
#line 667 "../gxml/CssSelectorParser.vala"
		_tmp76_ = g_strcmp0 (_tmp75_, "*") == 0;
#line 667 "../gxml/CssSelectorParser.vala"
		_g_free0 (_tmp75_);
#line 667 "../gxml/CssSelectorParser.vala"
		if (_tmp76_) {
#line 8391 "CssSelectorParser.c"
			GXmlCssElementSelector* _tmp77_;
			gchar* _tmp78_;
			gchar* _tmp79_;
			gchar* _tmp80_;
			gchar* _tmp81_;
			gchar* _tmp82_;
			gchar* _tmp83_;
			gboolean _tmp84_;
#line 668 "../gxml/CssSelectorParser.vala"
			_tmp77_ = sel;
#line 668 "../gxml/CssSelectorParser.vala"
			_tmp78_ = gxml_css_element_selector_get_local_name (_tmp77_);
#line 668 "../gxml/CssSelectorParser.vala"
			_tmp79_ = _tmp78_;
#line 668 "../gxml/CssSelectorParser.vala"
			_tmp80_ = _tmp79_;
#line 668 "../gxml/CssSelectorParser.vala"
			_tmp81_ = gxml_dom_element_get_local_name (element);
#line 668 "../gxml/CssSelectorParser.vala"
			_tmp82_ = _tmp81_;
#line 668 "../gxml/CssSelectorParser.vala"
			_tmp83_ = _tmp82_;
#line 668 "../gxml/CssSelectorParser.vala"
			_tmp84_ = g_strcmp0 (_tmp80_, _tmp83_) == 0;
#line 668 "../gxml/CssSelectorParser.vala"
			_g_free0 (_tmp83_);
#line 668 "../gxml/CssSelectorParser.vala"
			_g_free0 (_tmp80_);
#line 668 "../gxml/CssSelectorParser.vala"
			result = _tmp84_;
#line 668 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (sel);
#line 668 "../gxml/CssSelectorParser.vala"
			return result;
#line 8426 "CssSelectorParser.c"
		}
#line 669 "../gxml/CssSelectorParser.vala"
		_tmp86_ = sel;
#line 669 "../gxml/CssSelectorParser.vala"
		_tmp87_ = gxml_css_element_selector_get_local_name (_tmp86_);
#line 669 "../gxml/CssSelectorParser.vala"
		_tmp88_ = _tmp87_;
#line 669 "../gxml/CssSelectorParser.vala"
		_tmp89_ = _tmp88_;
#line 669 "../gxml/CssSelectorParser.vala"
		_tmp90_ = gxml_dom_element_get_local_name (element);
#line 669 "../gxml/CssSelectorParser.vala"
		_tmp91_ = _tmp90_;
#line 669 "../gxml/CssSelectorParser.vala"
		_tmp92_ = _tmp91_;
#line 669 "../gxml/CssSelectorParser.vala"
		_tmp93_ = g_strcmp0 (_tmp89_, _tmp92_) == 0;
#line 669 "../gxml/CssSelectorParser.vala"
		_g_free0 (_tmp92_);
#line 669 "../gxml/CssSelectorParser.vala"
		_g_free0 (_tmp89_);
#line 669 "../gxml/CssSelectorParser.vala"
		if (_tmp93_) {
#line 8450 "CssSelectorParser.c"
			GXmlCssElementSelector* _tmp94_;
			gchar* _tmp95_;
			gchar* _tmp96_;
			gchar* _tmp97_;
			gchar* _tmp98_;
			gchar* _tmp99_;
			gchar* _tmp100_;
#line 669 "../gxml/CssSelectorParser.vala"
			_tmp94_ = sel;
#line 669 "../gxml/CssSelectorParser.vala"
			_tmp95_ = gxml_css_element_selector_get_prefix (_tmp94_);
#line 669 "../gxml/CssSelectorParser.vala"
			_tmp96_ = _tmp95_;
#line 669 "../gxml/CssSelectorParser.vala"
			_tmp97_ = _tmp96_;
#line 669 "../gxml/CssSelectorParser.vala"
			_tmp98_ = gxml_dom_element_get_prefix (element);
#line 669 "../gxml/CssSelectorParser.vala"
			_tmp99_ = _tmp98_;
#line 669 "../gxml/CssSelectorParser.vala"
			_tmp100_ = _tmp99_;
#line 669 "../gxml/CssSelectorParser.vala"
			_tmp85_ = g_strcmp0 (_tmp97_, _tmp100_) == 0;
#line 669 "../gxml/CssSelectorParser.vala"
			_g_free0 (_tmp100_);
#line 669 "../gxml/CssSelectorParser.vala"
			_g_free0 (_tmp97_);
#line 8478 "CssSelectorParser.c"
		} else {
#line 669 "../gxml/CssSelectorParser.vala"
			_tmp85_ = FALSE;
#line 8482 "CssSelectorParser.c"
		}
#line 669 "../gxml/CssSelectorParser.vala"
		result = _tmp85_;
#line 669 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (sel);
#line 669 "../gxml/CssSelectorParser.vala"
		return result;
#line 8490 "CssSelectorParser.c"
	}
#line 671 "../gxml/CssSelectorParser.vala"
	if (GXML_IS_CSS_NOT_SELECTOR (selector)) {
#line 8494 "CssSelectorParser.c"
		gboolean _tmp101_ = FALSE;
		GeeList* _tmp102_;
		GeeList* _tmp103_;
#line 672 "../gxml/CssSelectorParser.vala"
		_tmp102_ = gxml_css_not_selector_get_selectors (G_TYPE_CHECK_INSTANCE_CAST (selector, GXML_TYPE_CSS_NOT_SELECTOR, GXmlCssNotSelector));
#line 672 "../gxml/CssSelectorParser.vala"
		_tmp103_ = _tmp102_;
#line 672 "../gxml/CssSelectorParser.vala"
		_tmp101_ = gxml_css_selector_parser_match_element (element, element, (GeeCollection*) _tmp103_, &_inner_error0_);
#line 672 "../gxml/CssSelectorParser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8506 "CssSelectorParser.c"
			gboolean _tmp104_ = FALSE;
#line 672 "../gxml/CssSelectorParser.vala"
			g_propagate_error (error, _inner_error0_);
#line 672 "../gxml/CssSelectorParser.vala"
			return _tmp104_;
#line 8512 "CssSelectorParser.c"
		}
#line 672 "../gxml/CssSelectorParser.vala"
		result = !_tmp101_;
#line 672 "../gxml/CssSelectorParser.vala"
		return result;
#line 8518 "CssSelectorParser.c"
	}
#line 673 "../gxml/CssSelectorParser.vala"
	_tmp105_ = gxml_css_selector_get_selector_type (selector);
#line 673 "../gxml/CssSelectorParser.vala"
	_tmp106_ = _tmp105_;
#line 673 "../gxml/CssSelectorParser.vala"
	if (_tmp106_ == GXML_CSS_SELECTOR_TYPE_PSEUDO_CLASS) {
#line 8526 "CssSelectorParser.c"
		gboolean _tmp107_ = FALSE;
#line 674 "../gxml/CssSelectorParser.vala"
		_tmp107_ = gxml_css_selector_parser_match_pseudo (element, selector, &_inner_error0_);
#line 674 "../gxml/CssSelectorParser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8532 "CssSelectorParser.c"
			gboolean _tmp108_ = FALSE;
#line 674 "../gxml/CssSelectorParser.vala"
			g_propagate_error (error, _inner_error0_);
#line 674 "../gxml/CssSelectorParser.vala"
			return _tmp108_;
#line 8538 "CssSelectorParser.c"
		}
#line 674 "../gxml/CssSelectorParser.vala"
		result = _tmp107_;
#line 674 "../gxml/CssSelectorParser.vala"
		return result;
#line 8544 "CssSelectorParser.c"
	}
#line 675 "../gxml/CssSelectorParser.vala"
	result = FALSE;
#line 675 "../gxml/CssSelectorParser.vala"
	return result;
#line 8550 "CssSelectorParser.c"
}

static gboolean
gxml_css_selector_parser_match_element (GXmlDomElement* root,
                                        GXmlDomElement* element,
                                        GeeCollection* selectors,
                                        GError** error)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GXmlCssSelector* selector = NULL;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gpointer _tmp6_;
	GeeArrayList* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	GeeArrayList* _tmp13_;
	GeeArrayList* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gpointer _tmp17_;
	GXmlCssSelector* _tmp18_;
	GXmlCssCombiner _tmp19_;
	GXmlCssCombiner _tmp20_;
	gboolean _tmp21_;
	GeeArrayList* _tmp29_;
	GeeArrayList* _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	gpointer _tmp33_;
	GXmlCssSelector* _tmp34_;
	GXmlCssCombiner _tmp35_;
	GXmlCssCombiner _tmp36_;
	gboolean _tmp37_;
	GeeArrayList* _tmp45_;
	GeeArrayList* _tmp46_;
	gint _tmp47_;
	gint _tmp48_;
	gpointer _tmp49_;
	GXmlCssSelector* _tmp50_;
	GXmlCssCombiner _tmp51_;
	GXmlCssCombiner _tmp52_;
	gboolean _tmp53_;
	GeeArrayList* _tmp69_;
	GeeArrayList* _tmp70_;
	gint _tmp71_;
	gint _tmp72_;
	gpointer _tmp73_;
	GXmlCssSelector* _tmp74_;
	GXmlCssCombiner _tmp75_;
	GXmlCssCombiner _tmp76_;
	gboolean _tmp77_;
	GeeArrayList* _tmp91_;
	GeeArrayList* _tmp92_;
	gint _tmp93_;
	gint _tmp94_;
	gpointer _tmp95_;
	GXmlCssSelector* _tmp96_;
	GXmlCssCombiner _tmp97_;
	GXmlCssCombiner _tmp98_;
	gboolean _tmp99_;
	GeeArrayList* _tmp111_;
	GeeArrayList* _tmp112_;
	gint _tmp113_;
	gint _tmp114_;
	gpointer _tmp115_;
	GXmlCssSelector* _tmp116_;
	GXmlCssCombiner _tmp117_;
	GXmlCssCombiner _tmp118_;
	gboolean _tmp119_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 678 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (root != NULL, FALSE);
#line 678 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (element != NULL, FALSE);
#line 678 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (selectors != NULL, FALSE);
#line 679 "../gxml/CssSelectorParser.vala"
	_tmp0_ = gee_array_list_new (GXML_TYPE_CSS_SELECTOR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 679 "../gxml/CssSelectorParser.vala"
	list = _tmp0_;
#line 680 "../gxml/CssSelectorParser.vala"
	_tmp1_ = list;
#line 680 "../gxml/CssSelectorParser.vala"
	gee_array_list_add_all (_tmp1_, selectors);
#line 681 "../gxml/CssSelectorParser.vala"
	_tmp2_ = list;
#line 681 "../gxml/CssSelectorParser.vala"
	_tmp3_ = list;
#line 681 "../gxml/CssSelectorParser.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 681 "../gxml/CssSelectorParser.vala"
	_tmp5_ = _tmp4_;
#line 681 "../gxml/CssSelectorParser.vala"
	_tmp6_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp2_, _tmp5_ - 1);
#line 681 "../gxml/CssSelectorParser.vala"
	selector = (GXmlCssSelector*) _tmp6_;
#line 682 "../gxml/CssSelectorParser.vala"
	_tmp7_ = list;
#line 682 "../gxml/CssSelectorParser.vala"
	_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 682 "../gxml/CssSelectorParser.vala"
	_tmp9_ = _tmp8_;
#line 682 "../gxml/CssSelectorParser.vala"
	if (_tmp9_ == 0) {
#line 8661 "CssSelectorParser.c"
		gboolean _tmp10_ = FALSE;
		GXmlCssSelector* _tmp11_;
#line 683 "../gxml/CssSelectorParser.vala"
		_tmp11_ = selector;
#line 683 "../gxml/CssSelectorParser.vala"
		_tmp10_ = gxml_css_selector_parser_match_node (element, _tmp11_, &_inner_error0_);
#line 683 "../gxml/CssSelectorParser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8670 "CssSelectorParser.c"
			gboolean _tmp12_ = FALSE;
#line 683 "../gxml/CssSelectorParser.vala"
			g_propagate_error (error, _inner_error0_);
#line 683 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (selector);
#line 683 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (list);
#line 683 "../gxml/CssSelectorParser.vala"
			return _tmp12_;
#line 8680 "CssSelectorParser.c"
		}
#line 683 "../gxml/CssSelectorParser.vala"
		result = _tmp10_;
#line 683 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (selector);
#line 683 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (list);
#line 683 "../gxml/CssSelectorParser.vala"
		return result;
#line 8690 "CssSelectorParser.c"
	}
#line 684 "../gxml/CssSelectorParser.vala"
	_tmp13_ = list;
#line 684 "../gxml/CssSelectorParser.vala"
	_tmp14_ = list;
#line 684 "../gxml/CssSelectorParser.vala"
	_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
#line 684 "../gxml/CssSelectorParser.vala"
	_tmp16_ = _tmp15_;
#line 684 "../gxml/CssSelectorParser.vala"
	_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp13_, _tmp16_ - 1);
#line 684 "../gxml/CssSelectorParser.vala"
	_tmp18_ = (GXmlCssSelector*) _tmp17_;
#line 684 "../gxml/CssSelectorParser.vala"
	_tmp19_ = gxml_css_selector_get_combiner (_tmp18_);
#line 684 "../gxml/CssSelectorParser.vala"
	_tmp20_ = _tmp19_;
#line 684 "../gxml/CssSelectorParser.vala"
	_tmp21_ = _tmp20_ == GXML_CSS_COMBINER_AND;
#line 684 "../gxml/CssSelectorParser.vala"
	_g_object_unref0 (_tmp18_);
#line 684 "../gxml/CssSelectorParser.vala"
	if (_tmp21_) {
#line 8714 "CssSelectorParser.c"
		gboolean _tmp22_ = FALSE;
		gboolean _tmp23_ = FALSE;
		GXmlCssSelector* _tmp24_;
#line 685 "../gxml/CssSelectorParser.vala"
		_tmp24_ = selector;
#line 685 "../gxml/CssSelectorParser.vala"
		_tmp23_ = gxml_css_selector_parser_match_node (element, _tmp24_, &_inner_error0_);
#line 685 "../gxml/CssSelectorParser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8724 "CssSelectorParser.c"
			gboolean _tmp25_ = FALSE;
#line 685 "../gxml/CssSelectorParser.vala"
			g_propagate_error (error, _inner_error0_);
#line 685 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (selector);
#line 685 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (list);
#line 685 "../gxml/CssSelectorParser.vala"
			return _tmp25_;
#line 8734 "CssSelectorParser.c"
		}
#line 685 "../gxml/CssSelectorParser.vala"
		if (_tmp23_) {
#line 685 "../gxml/CssSelectorParser.vala"
			_tmp22_ = TRUE;
#line 8740 "CssSelectorParser.c"
		} else {
			gboolean _tmp26_ = FALSE;
			GeeArrayList* _tmp27_;
#line 685 "../gxml/CssSelectorParser.vala"
			_tmp27_ = list;
#line 685 "../gxml/CssSelectorParser.vala"
			_tmp26_ = gxml_css_selector_parser_match_element (root, root, (GeeCollection*) _tmp27_, &_inner_error0_);
#line 685 "../gxml/CssSelectorParser.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8750 "CssSelectorParser.c"
				gboolean _tmp28_ = FALSE;
#line 685 "../gxml/CssSelectorParser.vala"
				g_propagate_error (error, _inner_error0_);
#line 685 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (selector);
#line 685 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (list);
#line 685 "../gxml/CssSelectorParser.vala"
				return _tmp28_;
#line 8760 "CssSelectorParser.c"
			}
#line 685 "../gxml/CssSelectorParser.vala"
			_tmp22_ = _tmp26_;
#line 8764 "CssSelectorParser.c"
		}
#line 685 "../gxml/CssSelectorParser.vala"
		result = _tmp22_;
#line 685 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (selector);
#line 685 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (list);
#line 685 "../gxml/CssSelectorParser.vala"
		return result;
#line 8774 "CssSelectorParser.c"
	}
#line 686 "../gxml/CssSelectorParser.vala"
	_tmp29_ = list;
#line 686 "../gxml/CssSelectorParser.vala"
	_tmp30_ = list;
#line 686 "../gxml/CssSelectorParser.vala"
	_tmp31_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp30_);
#line 686 "../gxml/CssSelectorParser.vala"
	_tmp32_ = _tmp31_;
#line 686 "../gxml/CssSelectorParser.vala"
	_tmp33_ = gee_abstract_list_get ((GeeAbstractList*) _tmp29_, _tmp32_ - 1);
#line 686 "../gxml/CssSelectorParser.vala"
	_tmp34_ = (GXmlCssSelector*) _tmp33_;
#line 686 "../gxml/CssSelectorParser.vala"
	_tmp35_ = gxml_css_selector_get_combiner (_tmp34_);
#line 686 "../gxml/CssSelectorParser.vala"
	_tmp36_ = _tmp35_;
#line 686 "../gxml/CssSelectorParser.vala"
	_tmp37_ = _tmp36_ == GXML_CSS_COMBINER_NONE;
#line 686 "../gxml/CssSelectorParser.vala"
	_g_object_unref0 (_tmp34_);
#line 686 "../gxml/CssSelectorParser.vala"
	if (_tmp37_) {
#line 8798 "CssSelectorParser.c"
		gboolean _tmp38_ = FALSE;
		gboolean _tmp39_ = FALSE;
		GXmlCssSelector* _tmp40_;
#line 687 "../gxml/CssSelectorParser.vala"
		_tmp40_ = selector;
#line 687 "../gxml/CssSelectorParser.vala"
		_tmp39_ = gxml_css_selector_parser_match_node (element, _tmp40_, &_inner_error0_);
#line 687 "../gxml/CssSelectorParser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8808 "CssSelectorParser.c"
			gboolean _tmp41_ = FALSE;
#line 687 "../gxml/CssSelectorParser.vala"
			g_propagate_error (error, _inner_error0_);
#line 687 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (selector);
#line 687 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (list);
#line 687 "../gxml/CssSelectorParser.vala"
			return _tmp41_;
#line 8818 "CssSelectorParser.c"
		}
#line 687 "../gxml/CssSelectorParser.vala"
		if (_tmp39_) {
#line 8822 "CssSelectorParser.c"
			gboolean _tmp42_ = FALSE;
			GeeArrayList* _tmp43_;
#line 687 "../gxml/CssSelectorParser.vala"
			_tmp43_ = list;
#line 687 "../gxml/CssSelectorParser.vala"
			_tmp42_ = gxml_css_selector_parser_match_element (root, element, (GeeCollection*) _tmp43_, &_inner_error0_);
#line 687 "../gxml/CssSelectorParser.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8831 "CssSelectorParser.c"
				gboolean _tmp44_ = FALSE;
#line 687 "../gxml/CssSelectorParser.vala"
				g_propagate_error (error, _inner_error0_);
#line 687 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (selector);
#line 687 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (list);
#line 687 "../gxml/CssSelectorParser.vala"
				return _tmp44_;
#line 8841 "CssSelectorParser.c"
			}
#line 687 "../gxml/CssSelectorParser.vala"
			_tmp38_ = _tmp42_;
#line 8845 "CssSelectorParser.c"
		} else {
#line 687 "../gxml/CssSelectorParser.vala"
			_tmp38_ = FALSE;
#line 8849 "CssSelectorParser.c"
		}
#line 687 "../gxml/CssSelectorParser.vala"
		result = _tmp38_;
#line 687 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (selector);
#line 687 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (list);
#line 687 "../gxml/CssSelectorParser.vala"
		return result;
#line 8859 "CssSelectorParser.c"
	}
#line 688 "../gxml/CssSelectorParser.vala"
	_tmp45_ = list;
#line 688 "../gxml/CssSelectorParser.vala"
	_tmp46_ = list;
#line 688 "../gxml/CssSelectorParser.vala"
	_tmp47_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp46_);
#line 688 "../gxml/CssSelectorParser.vala"
	_tmp48_ = _tmp47_;
#line 688 "../gxml/CssSelectorParser.vala"
	_tmp49_ = gee_abstract_list_get ((GeeAbstractList*) _tmp45_, _tmp48_ - 1);
#line 688 "../gxml/CssSelectorParser.vala"
	_tmp50_ = (GXmlCssSelector*) _tmp49_;
#line 688 "../gxml/CssSelectorParser.vala"
	_tmp51_ = gxml_css_selector_get_combiner (_tmp50_);
#line 688 "../gxml/CssSelectorParser.vala"
	_tmp52_ = _tmp51_;
#line 688 "../gxml/CssSelectorParser.vala"
	_tmp53_ = _tmp52_ == GXML_CSS_COMBINER_AFTER;
#line 688 "../gxml/CssSelectorParser.vala"
	_g_object_unref0 (_tmp50_);
#line 688 "../gxml/CssSelectorParser.vala"
	if (_tmp53_) {
#line 8883 "CssSelectorParser.c"
		GXmlDomElement* _tmp54_;
		GXmlDomElement* _tmp55_;
		GXmlDomElement* _tmp56_;
		gboolean _tmp57_;
		gboolean _tmp58_ = FALSE;
		gboolean _tmp59_ = FALSE;
		GXmlCssSelector* _tmp60_;
#line 689 "../gxml/CssSelectorParser.vala"
		_tmp54_ = gxml_dom_non_document_type_child_node_get_previous_element_sibling ((GXmlDomNonDocumentTypeChildNode*) element);
#line 689 "../gxml/CssSelectorParser.vala"
		_tmp55_ = _tmp54_;
#line 689 "../gxml/CssSelectorParser.vala"
		_tmp56_ = _tmp55_;
#line 689 "../gxml/CssSelectorParser.vala"
		_tmp57_ = _tmp56_ == NULL;
#line 689 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_tmp56_);
#line 689 "../gxml/CssSelectorParser.vala"
		if (_tmp57_) {
#line 690 "../gxml/CssSelectorParser.vala"
			result = FALSE;
#line 690 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (selector);
#line 690 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (list);
#line 690 "../gxml/CssSelectorParser.vala"
			return result;
#line 8911 "CssSelectorParser.c"
		}
#line 691 "../gxml/CssSelectorParser.vala"
		_tmp60_ = selector;
#line 691 "../gxml/CssSelectorParser.vala"
		_tmp59_ = gxml_css_selector_parser_match_node (element, _tmp60_, &_inner_error0_);
#line 691 "../gxml/CssSelectorParser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8919 "CssSelectorParser.c"
			gboolean _tmp61_ = FALSE;
#line 691 "../gxml/CssSelectorParser.vala"
			g_propagate_error (error, _inner_error0_);
#line 691 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (selector);
#line 691 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (list);
#line 691 "../gxml/CssSelectorParser.vala"
			return _tmp61_;
#line 8929 "CssSelectorParser.c"
		}
#line 691 "../gxml/CssSelectorParser.vala"
		if (_tmp59_) {
#line 8933 "CssSelectorParser.c"
			gboolean _tmp62_ = FALSE;
			GXmlDomElement* _tmp63_;
			GXmlDomElement* _tmp64_;
			GXmlDomElement* _tmp65_;
			GeeArrayList* _tmp66_;
			gboolean _tmp67_;
#line 691 "../gxml/CssSelectorParser.vala"
			_tmp63_ = gxml_dom_non_document_type_child_node_get_previous_element_sibling ((GXmlDomNonDocumentTypeChildNode*) element);
#line 691 "../gxml/CssSelectorParser.vala"
			_tmp64_ = _tmp63_;
#line 691 "../gxml/CssSelectorParser.vala"
			_tmp65_ = _tmp64_;
#line 691 "../gxml/CssSelectorParser.vala"
			_tmp66_ = list;
#line 691 "../gxml/CssSelectorParser.vala"
			_tmp67_ = gxml_css_selector_parser_match_element (root, _tmp65_, (GeeCollection*) _tmp66_, &_inner_error0_);
#line 691 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (_tmp65_);
#line 691 "../gxml/CssSelectorParser.vala"
			_tmp62_ = _tmp67_;
#line 691 "../gxml/CssSelectorParser.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8956 "CssSelectorParser.c"
				gboolean _tmp68_ = FALSE;
#line 691 "../gxml/CssSelectorParser.vala"
				g_propagate_error (error, _inner_error0_);
#line 691 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (selector);
#line 691 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (list);
#line 691 "../gxml/CssSelectorParser.vala"
				return _tmp68_;
#line 8966 "CssSelectorParser.c"
			}
#line 691 "../gxml/CssSelectorParser.vala"
			_tmp58_ = _tmp62_;
#line 8970 "CssSelectorParser.c"
		} else {
#line 691 "../gxml/CssSelectorParser.vala"
			_tmp58_ = FALSE;
#line 8974 "CssSelectorParser.c"
		}
#line 691 "../gxml/CssSelectorParser.vala"
		result = _tmp58_;
#line 691 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (selector);
#line 691 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (list);
#line 691 "../gxml/CssSelectorParser.vala"
		return result;
#line 8984 "CssSelectorParser.c"
	}
#line 693 "../gxml/CssSelectorParser.vala"
	_tmp69_ = list;
#line 693 "../gxml/CssSelectorParser.vala"
	_tmp70_ = list;
#line 693 "../gxml/CssSelectorParser.vala"
	_tmp71_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp70_);
#line 693 "../gxml/CssSelectorParser.vala"
	_tmp72_ = _tmp71_;
#line 693 "../gxml/CssSelectorParser.vala"
	_tmp73_ = gee_abstract_list_get ((GeeAbstractList*) _tmp69_, _tmp72_ - 1);
#line 693 "../gxml/CssSelectorParser.vala"
	_tmp74_ = (GXmlCssSelector*) _tmp73_;
#line 693 "../gxml/CssSelectorParser.vala"
	_tmp75_ = gxml_css_selector_get_combiner (_tmp74_);
#line 693 "../gxml/CssSelectorParser.vala"
	_tmp76_ = _tmp75_;
#line 693 "../gxml/CssSelectorParser.vala"
	_tmp77_ = _tmp76_ == GXML_CSS_COMBINER_PRECEDED;
#line 693 "../gxml/CssSelectorParser.vala"
	_g_object_unref0 (_tmp74_);
#line 693 "../gxml/CssSelectorParser.vala"
	if (_tmp77_) {
#line 9008 "CssSelectorParser.c"
		gboolean res = FALSE;
		GXmlCssSelector* _tmp78_;
		GXmlDomElement* prev = NULL;
		GXmlDomElement* _tmp80_;
		GXmlDomElement* _tmp81_;
#line 694 "../gxml/CssSelectorParser.vala"
		_tmp78_ = selector;
#line 694 "../gxml/CssSelectorParser.vala"
		res = gxml_css_selector_parser_match_node (element, _tmp78_, &_inner_error0_);
#line 694 "../gxml/CssSelectorParser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9020 "CssSelectorParser.c"
			gboolean _tmp79_ = FALSE;
#line 694 "../gxml/CssSelectorParser.vala"
			g_propagate_error (error, _inner_error0_);
#line 694 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (selector);
#line 694 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (list);
#line 694 "../gxml/CssSelectorParser.vala"
			return _tmp79_;
#line 9030 "CssSelectorParser.c"
		}
#line 695 "../gxml/CssSelectorParser.vala"
		_tmp80_ = gxml_dom_non_document_type_child_node_get_previous_element_sibling ((GXmlDomNonDocumentTypeChildNode*) element);
#line 695 "../gxml/CssSelectorParser.vala"
		_tmp81_ = _tmp80_;
#line 695 "../gxml/CssSelectorParser.vala"
		prev = _tmp81_;
#line 696 "../gxml/CssSelectorParser.vala"
		while (TRUE) {
#line 9040 "CssSelectorParser.c"
			GXmlDomElement* _tmp82_;
			gboolean _tmp83_ = FALSE;
			GXmlDomElement* _tmp88_;
			GXmlDomElement* _tmp89_;
			GXmlDomElement* _tmp90_;
#line 696 "../gxml/CssSelectorParser.vala"
			_tmp82_ = prev;
#line 696 "../gxml/CssSelectorParser.vala"
			if (!(_tmp82_ != NULL)) {
#line 696 "../gxml/CssSelectorParser.vala"
				break;
#line 9052 "CssSelectorParser.c"
			}
#line 697 "../gxml/CssSelectorParser.vala"
			if (res) {
#line 9056 "CssSelectorParser.c"
				gboolean _tmp84_ = FALSE;
				GXmlDomElement* _tmp85_;
				GeeArrayList* _tmp86_;
#line 697 "../gxml/CssSelectorParser.vala"
				_tmp85_ = prev;
#line 697 "../gxml/CssSelectorParser.vala"
				_tmp86_ = list;
#line 697 "../gxml/CssSelectorParser.vala"
				_tmp84_ = gxml_css_selector_parser_match_element (root, _tmp85_, (GeeCollection*) _tmp86_, &_inner_error0_);
#line 697 "../gxml/CssSelectorParser.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9068 "CssSelectorParser.c"
					gboolean _tmp87_ = FALSE;
#line 697 "../gxml/CssSelectorParser.vala"
					g_propagate_error (error, _inner_error0_);
#line 697 "../gxml/CssSelectorParser.vala"
					_g_object_unref0 (prev);
#line 697 "../gxml/CssSelectorParser.vala"
					_g_object_unref0 (selector);
#line 697 "../gxml/CssSelectorParser.vala"
					_g_object_unref0 (list);
#line 697 "../gxml/CssSelectorParser.vala"
					return _tmp87_;
#line 9080 "CssSelectorParser.c"
				}
#line 697 "../gxml/CssSelectorParser.vala"
				_tmp83_ = _tmp84_;
#line 9084 "CssSelectorParser.c"
			} else {
#line 697 "../gxml/CssSelectorParser.vala"
				_tmp83_ = FALSE;
#line 9088 "CssSelectorParser.c"
			}
#line 697 "../gxml/CssSelectorParser.vala"
			if (_tmp83_) {
#line 698 "../gxml/CssSelectorParser.vala"
				result = TRUE;
#line 698 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (prev);
#line 698 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (selector);
#line 698 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (list);
#line 698 "../gxml/CssSelectorParser.vala"
				return result;
#line 9102 "CssSelectorParser.c"
			}
#line 699 "../gxml/CssSelectorParser.vala"
			_tmp88_ = prev;
#line 699 "../gxml/CssSelectorParser.vala"
			_tmp89_ = gxml_dom_non_document_type_child_node_get_previous_element_sibling ((GXmlDomNonDocumentTypeChildNode*) _tmp88_);
#line 699 "../gxml/CssSelectorParser.vala"
			_tmp90_ = _tmp89_;
#line 699 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (prev);
#line 699 "../gxml/CssSelectorParser.vala"
			prev = _tmp90_;
#line 9114 "CssSelectorParser.c"
		}
#line 693 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (prev);
#line 9118 "CssSelectorParser.c"
	}
#line 702 "../gxml/CssSelectorParser.vala"
	_tmp91_ = list;
#line 702 "../gxml/CssSelectorParser.vala"
	_tmp92_ = list;
#line 702 "../gxml/CssSelectorParser.vala"
	_tmp93_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp92_);
#line 702 "../gxml/CssSelectorParser.vala"
	_tmp94_ = _tmp93_;
#line 702 "../gxml/CssSelectorParser.vala"
	_tmp95_ = gee_abstract_list_get ((GeeAbstractList*) _tmp91_, _tmp94_ - 1);
#line 702 "../gxml/CssSelectorParser.vala"
	_tmp96_ = (GXmlCssSelector*) _tmp95_;
#line 702 "../gxml/CssSelectorParser.vala"
	_tmp97_ = gxml_css_selector_get_combiner (_tmp96_);
#line 702 "../gxml/CssSelectorParser.vala"
	_tmp98_ = _tmp97_;
#line 702 "../gxml/CssSelectorParser.vala"
	_tmp99_ = _tmp98_ == GXML_CSS_COMBINER_PARENT;
#line 702 "../gxml/CssSelectorParser.vala"
	_g_object_unref0 (_tmp96_);
#line 702 "../gxml/CssSelectorParser.vala"
	if (_tmp99_) {
#line 9142 "CssSelectorParser.c"
		gboolean _tmp100_ = FALSE;
		gboolean _tmp101_ = FALSE;
		GXmlCssSelector* _tmp102_;
#line 703 "../gxml/CssSelectorParser.vala"
		_tmp102_ = selector;
#line 703 "../gxml/CssSelectorParser.vala"
		_tmp101_ = gxml_css_selector_parser_match_node (element, _tmp102_, &_inner_error0_);
#line 703 "../gxml/CssSelectorParser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9152 "CssSelectorParser.c"
			gboolean _tmp103_ = FALSE;
#line 703 "../gxml/CssSelectorParser.vala"
			g_propagate_error (error, _inner_error0_);
#line 703 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (selector);
#line 703 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (list);
#line 703 "../gxml/CssSelectorParser.vala"
			return _tmp103_;
#line 9162 "CssSelectorParser.c"
		}
#line 703 "../gxml/CssSelectorParser.vala"
		if (_tmp101_) {
#line 9166 "CssSelectorParser.c"
			gboolean _tmp104_ = FALSE;
			GXmlDomElement* _tmp105_;
			GXmlDomElement* _tmp106_;
			GXmlDomElement* _tmp107_;
			GeeArrayList* _tmp108_;
			gboolean _tmp109_;
#line 703 "../gxml/CssSelectorParser.vala"
			_tmp105_ = gxml_dom_node_get_parent_element ((GXmlDomNode*) element);
#line 703 "../gxml/CssSelectorParser.vala"
			_tmp106_ = _tmp105_;
#line 703 "../gxml/CssSelectorParser.vala"
			_tmp107_ = _tmp106_;
#line 703 "../gxml/CssSelectorParser.vala"
			_tmp108_ = list;
#line 703 "../gxml/CssSelectorParser.vala"
			_tmp109_ = gxml_css_selector_parser_match_element (root, _tmp107_, (GeeCollection*) _tmp108_, &_inner_error0_);
#line 703 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (_tmp107_);
#line 703 "../gxml/CssSelectorParser.vala"
			_tmp104_ = _tmp109_;
#line 703 "../gxml/CssSelectorParser.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9189 "CssSelectorParser.c"
				gboolean _tmp110_ = FALSE;
#line 703 "../gxml/CssSelectorParser.vala"
				g_propagate_error (error, _inner_error0_);
#line 703 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (selector);
#line 703 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (list);
#line 703 "../gxml/CssSelectorParser.vala"
				return _tmp110_;
#line 9199 "CssSelectorParser.c"
			}
#line 703 "../gxml/CssSelectorParser.vala"
			_tmp100_ = _tmp104_;
#line 9203 "CssSelectorParser.c"
		} else {
#line 703 "../gxml/CssSelectorParser.vala"
			_tmp100_ = FALSE;
#line 9207 "CssSelectorParser.c"
		}
#line 703 "../gxml/CssSelectorParser.vala"
		result = _tmp100_;
#line 703 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (selector);
#line 703 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (list);
#line 703 "../gxml/CssSelectorParser.vala"
		return result;
#line 9217 "CssSelectorParser.c"
	}
#line 704 "../gxml/CssSelectorParser.vala"
	_tmp111_ = list;
#line 704 "../gxml/CssSelectorParser.vala"
	_tmp112_ = list;
#line 704 "../gxml/CssSelectorParser.vala"
	_tmp113_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp112_);
#line 704 "../gxml/CssSelectorParser.vala"
	_tmp114_ = _tmp113_;
#line 704 "../gxml/CssSelectorParser.vala"
	_tmp115_ = gee_abstract_list_get ((GeeAbstractList*) _tmp111_, _tmp114_ - 1);
#line 704 "../gxml/CssSelectorParser.vala"
	_tmp116_ = (GXmlCssSelector*) _tmp115_;
#line 704 "../gxml/CssSelectorParser.vala"
	_tmp117_ = gxml_css_selector_get_combiner (_tmp116_);
#line 704 "../gxml/CssSelectorParser.vala"
	_tmp118_ = _tmp117_;
#line 704 "../gxml/CssSelectorParser.vala"
	_tmp119_ = _tmp118_ == GXML_CSS_COMBINER_INSIDE;
#line 704 "../gxml/CssSelectorParser.vala"
	_g_object_unref0 (_tmp116_);
#line 704 "../gxml/CssSelectorParser.vala"
	if (_tmp119_) {
#line 9241 "CssSelectorParser.c"
		GXmlDomElement* parent = NULL;
		GXmlDomElement* _tmp120_;
		GXmlDomElement* _tmp121_;
		gboolean res = FALSE;
		GXmlCssSelector* _tmp122_;
#line 705 "../gxml/CssSelectorParser.vala"
		_tmp120_ = gxml_dom_node_get_parent_element ((GXmlDomNode*) element);
#line 705 "../gxml/CssSelectorParser.vala"
		_tmp121_ = _tmp120_;
#line 705 "../gxml/CssSelectorParser.vala"
		parent = _tmp121_;
#line 706 "../gxml/CssSelectorParser.vala"
		_tmp122_ = selector;
#line 706 "../gxml/CssSelectorParser.vala"
		res = gxml_css_selector_parser_match_node (element, _tmp122_, &_inner_error0_);
#line 706 "../gxml/CssSelectorParser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9259 "CssSelectorParser.c"
			gboolean _tmp123_ = FALSE;
#line 706 "../gxml/CssSelectorParser.vala"
			g_propagate_error (error, _inner_error0_);
#line 706 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (parent);
#line 706 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (selector);
#line 706 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (list);
#line 706 "../gxml/CssSelectorParser.vala"
			return _tmp123_;
#line 9271 "CssSelectorParser.c"
		}
#line 707 "../gxml/CssSelectorParser.vala"
		while (TRUE) {
#line 9275 "CssSelectorParser.c"
			GXmlDomElement* _tmp124_;
			gboolean _tmp125_ = FALSE;
			GXmlDomElement* _tmp130_;
			GXmlDomElement* _tmp131_;
			GXmlDomElement* _tmp132_;
#line 707 "../gxml/CssSelectorParser.vala"
			_tmp124_ = parent;
#line 707 "../gxml/CssSelectorParser.vala"
			if (!(_tmp124_ != NULL)) {
#line 707 "../gxml/CssSelectorParser.vala"
				break;
#line 9287 "CssSelectorParser.c"
			}
#line 708 "../gxml/CssSelectorParser.vala"
			if (res) {
#line 9291 "CssSelectorParser.c"
				gboolean _tmp126_ = FALSE;
				GXmlDomElement* _tmp127_;
				GeeArrayList* _tmp128_;
#line 708 "../gxml/CssSelectorParser.vala"
				_tmp127_ = parent;
#line 708 "../gxml/CssSelectorParser.vala"
				_tmp128_ = list;
#line 708 "../gxml/CssSelectorParser.vala"
				_tmp126_ = gxml_css_selector_parser_match_element (root, _tmp127_, (GeeCollection*) _tmp128_, &_inner_error0_);
#line 708 "../gxml/CssSelectorParser.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9303 "CssSelectorParser.c"
					gboolean _tmp129_ = FALSE;
#line 708 "../gxml/CssSelectorParser.vala"
					g_propagate_error (error, _inner_error0_);
#line 708 "../gxml/CssSelectorParser.vala"
					_g_object_unref0 (parent);
#line 708 "../gxml/CssSelectorParser.vala"
					_g_object_unref0 (selector);
#line 708 "../gxml/CssSelectorParser.vala"
					_g_object_unref0 (list);
#line 708 "../gxml/CssSelectorParser.vala"
					return _tmp129_;
#line 9315 "CssSelectorParser.c"
				}
#line 708 "../gxml/CssSelectorParser.vala"
				_tmp125_ = _tmp126_;
#line 9319 "CssSelectorParser.c"
			} else {
#line 708 "../gxml/CssSelectorParser.vala"
				_tmp125_ = FALSE;
#line 9323 "CssSelectorParser.c"
			}
#line 708 "../gxml/CssSelectorParser.vala"
			if (_tmp125_) {
#line 709 "../gxml/CssSelectorParser.vala"
				result = TRUE;
#line 709 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (parent);
#line 709 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (selector);
#line 709 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (list);
#line 709 "../gxml/CssSelectorParser.vala"
				return result;
#line 9337 "CssSelectorParser.c"
			}
#line 710 "../gxml/CssSelectorParser.vala"
			_tmp130_ = parent;
#line 710 "../gxml/CssSelectorParser.vala"
			_tmp131_ = gxml_dom_node_get_parent_element ((GXmlDomNode*) _tmp130_);
#line 710 "../gxml/CssSelectorParser.vala"
			_tmp132_ = _tmp131_;
#line 710 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (parent);
#line 710 "../gxml/CssSelectorParser.vala"
			parent = _tmp132_;
#line 9349 "CssSelectorParser.c"
		}
#line 704 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (parent);
#line 9353 "CssSelectorParser.c"
	}
#line 713 "../gxml/CssSelectorParser.vala"
	result = FALSE;
#line 713 "../gxml/CssSelectorParser.vala"
	_g_object_unref0 (selector);
#line 713 "../gxml/CssSelectorParser.vala"
	_g_object_unref0 (list);
#line 713 "../gxml/CssSelectorParser.vala"
	return result;
#line 9363 "CssSelectorParser.c"
}

/**
 * Test if provided {@link GXml.DomElement} match with parsed selectors
 * @param element a {@link GXml.DomElement} to match
 * @return true if element match, or false 
 */
gboolean
gxml_css_selector_parser_match (GXmlCssSelectorParser* self,
                                GXmlDomElement* element,
                                GError** error)
{
	gboolean _tmp0_ = FALSE;
	GeeArrayList* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 720 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 720 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (element != NULL, FALSE);
#line 721 "../gxml/CssSelectorParser.vala"
	_tmp1_ = self->priv->list;
#line 721 "../gxml/CssSelectorParser.vala"
	_tmp0_ = gxml_css_selector_parser_match_element (element, element, (GeeCollection*) _tmp1_, &_inner_error0_);
#line 721 "../gxml/CssSelectorParser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9390 "CssSelectorParser.c"
		gboolean _tmp2_ = FALSE;
#line 721 "../gxml/CssSelectorParser.vala"
		g_propagate_error (error, _inner_error0_);
#line 721 "../gxml/CssSelectorParser.vala"
		return _tmp2_;
#line 9396 "CssSelectorParser.c"
	}
#line 721 "../gxml/CssSelectorParser.vala"
	result = _tmp0_;
#line 721 "../gxml/CssSelectorParser.vala"
	return result;
#line 9402 "CssSelectorParser.c"
}

/**
 * Retrieve children and descendent nodes that match parsed selectors.
 * @param element a {@link GXml.DomElement}
 * @return a {@link GXml.DomNodeList} of selected nodes
 */
GXmlDomNodeList*
gxml_css_selector_parser_query_selector_all (GXmlCssSelectorParser* self,
                                             GXmlDomElement* element,
                                             GError** error)
{
	GXmlNodeList* list = NULL;
	GXmlNodeList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GXmlDomNodeList* result = NULL;
#line 728 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 728 "../gxml/CssSelectorParser.vala"
	g_return_val_if_fail (element != NULL, NULL);
#line 729 "../gxml/CssSelectorParser.vala"
	_tmp0_ = gxml_node_list_new ();
#line 729 "../gxml/CssSelectorParser.vala"
	list = _tmp0_;
#line 9427 "CssSelectorParser.c"
	{
		GXmlDomHTMLCollection* _child_list = NULL;
		GXmlDomHTMLCollection* _tmp1_;
		GXmlDomHTMLCollection* _tmp2_;
		gint _child_size = 0;
		GXmlDomHTMLCollection* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _child_index = 0;
#line 730 "../gxml/CssSelectorParser.vala"
		_tmp1_ = gxml_dom_parent_node_get_children ((GXmlDomParentNode*) element);
#line 730 "../gxml/CssSelectorParser.vala"
		_tmp2_ = _tmp1_;
#line 730 "../gxml/CssSelectorParser.vala"
		_child_list = _tmp2_;
#line 730 "../gxml/CssSelectorParser.vala"
		_tmp3_ = _child_list;
#line 730 "../gxml/CssSelectorParser.vala"
		_tmp4_ = gee_collection_get_size ((GeeCollection*) _tmp3_);
#line 730 "../gxml/CssSelectorParser.vala"
		_tmp5_ = _tmp4_;
#line 730 "../gxml/CssSelectorParser.vala"
		_child_size = _tmp5_;
#line 730 "../gxml/CssSelectorParser.vala"
		_child_index = -1;
#line 730 "../gxml/CssSelectorParser.vala"
		while (TRUE) {
#line 9455 "CssSelectorParser.c"
			gint _tmp6_;
			gint _tmp7_;
			GXmlDomElement* child = NULL;
			GXmlDomHTMLCollection* _tmp8_;
			gpointer _tmp9_;
			gboolean _tmp10_ = FALSE;
			GXmlDomElement* _tmp11_;
			GXmlDomNodeList* _tmp14_ = NULL;
			GXmlDomElement* _tmp15_;
			GXmlDomNodeList* _tmp16_;
			GXmlNodeList* _tmp17_;
#line 730 "../gxml/CssSelectorParser.vala"
			_child_index = _child_index + 1;
#line 730 "../gxml/CssSelectorParser.vala"
			_tmp6_ = _child_index;
#line 730 "../gxml/CssSelectorParser.vala"
			_tmp7_ = _child_size;
#line 730 "../gxml/CssSelectorParser.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 730 "../gxml/CssSelectorParser.vala"
				break;
#line 9477 "CssSelectorParser.c"
			}
#line 730 "../gxml/CssSelectorParser.vala"
			_tmp8_ = _child_list;
#line 730 "../gxml/CssSelectorParser.vala"
			_tmp9_ = gee_list_get ((GeeList*) _tmp8_, _child_index);
#line 730 "../gxml/CssSelectorParser.vala"
			child = (GXmlDomElement*) _tmp9_;
#line 731 "../gxml/CssSelectorParser.vala"
			_tmp11_ = child;
#line 731 "../gxml/CssSelectorParser.vala"
			_tmp10_ = gxml_css_selector_parser_match (self, _tmp11_, &_inner_error0_);
#line 731 "../gxml/CssSelectorParser.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 731 "../gxml/CssSelectorParser.vala"
				g_propagate_error (error, _inner_error0_);
#line 731 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (child);
#line 731 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (_child_list);
#line 731 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (list);
#line 731 "../gxml/CssSelectorParser.vala"
				return NULL;
#line 9501 "CssSelectorParser.c"
			}
#line 731 "../gxml/CssSelectorParser.vala"
			if (_tmp10_) {
#line 9505 "CssSelectorParser.c"
				GXmlNodeList* _tmp12_;
				GXmlDomElement* _tmp13_;
#line 732 "../gxml/CssSelectorParser.vala"
				_tmp12_ = list;
#line 732 "../gxml/CssSelectorParser.vala"
				_tmp13_ = child;
#line 732 "../gxml/CssSelectorParser.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, (GXmlDomNode*) _tmp13_);
#line 9514 "CssSelectorParser.c"
			}
#line 733 "../gxml/CssSelectorParser.vala"
			_tmp15_ = child;
#line 733 "../gxml/CssSelectorParser.vala"
			_tmp16_ = gxml_css_selector_parser_query_selector_all (self, _tmp15_, &_inner_error0_);
#line 733 "../gxml/CssSelectorParser.vala"
			_tmp14_ = _tmp16_;
#line 733 "../gxml/CssSelectorParser.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 733 "../gxml/CssSelectorParser.vala"
				g_propagate_error (error, _inner_error0_);
#line 733 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (child);
#line 733 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (_child_list);
#line 733 "../gxml/CssSelectorParser.vala"
				_g_object_unref0 (list);
#line 733 "../gxml/CssSelectorParser.vala"
				return NULL;
#line 9534 "CssSelectorParser.c"
			}
#line 733 "../gxml/CssSelectorParser.vala"
			_tmp17_ = list;
#line 733 "../gxml/CssSelectorParser.vala"
			gee_array_list_add_all ((GeeArrayList*) _tmp17_, (GeeCollection*) _tmp14_);
#line 730 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (_tmp14_);
#line 730 "../gxml/CssSelectorParser.vala"
			_g_object_unref0 (child);
#line 9544 "CssSelectorParser.c"
		}
#line 730 "../gxml/CssSelectorParser.vala"
		_g_object_unref0 (_child_list);
#line 9548 "CssSelectorParser.c"
	}
#line 735 "../gxml/CssSelectorParser.vala"
	result = (GXmlDomNodeList*) list;
#line 735 "../gxml/CssSelectorParser.vala"
	return result;
#line 9554 "CssSelectorParser.c"
}

GXmlCssSelectorParser*
gxml_css_selector_parser_construct (GType object_type)
{
	GXmlCssSelectorParser * self = NULL;
#line 207 "../gxml/CssSelectorParser.vala"
	self = (GXmlCssSelectorParser*) g_object_new (object_type, NULL);
#line 207 "../gxml/CssSelectorParser.vala"
	return self;
#line 9565 "CssSelectorParser.c"
}

GXmlCssSelectorParser*
gxml_css_selector_parser_new (void)
{
#line 207 "../gxml/CssSelectorParser.vala"
	return gxml_css_selector_parser_construct (GXML_TYPE_CSS_SELECTOR_PARSER);
#line 9573 "CssSelectorParser.c"
}

static GObject *
gxml_css_selector_parser_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GXmlCssSelectorParser * self;
	GeeArrayList* _tmp0_;
#line 444 "../gxml/CssSelectorParser.vala"
	parent_class = G_OBJECT_CLASS (gxml_css_selector_parser_parent_class);
#line 444 "../gxml/CssSelectorParser.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 444 "../gxml/CssSelectorParser.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GXML_TYPE_CSS_SELECTOR_PARSER, GXmlCssSelectorParser);
#line 445 "../gxml/CssSelectorParser.vala"
	_tmp0_ = gee_array_list_new (GXML_TYPE_CSS_SELECTOR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 445 "../gxml/CssSelectorParser.vala"
	_g_object_unref0 (self->priv->list);
#line 445 "../gxml/CssSelectorParser.vala"
	self->priv->list = _tmp0_;
#line 444 "../gxml/CssSelectorParser.vala"
	return obj;
#line 9599 "CssSelectorParser.c"
}

static void
gxml_css_selector_parser_class_init (GXmlCssSelectorParserClass * klass,
                                     gpointer klass_data)
{
#line 207 "../gxml/CssSelectorParser.vala"
	gxml_css_selector_parser_parent_class = g_type_class_peek_parent (klass);
#line 207 "../gxml/CssSelectorParser.vala"
	g_type_class_adjust_private_offset (klass, &GXmlCssSelectorParser_private_offset);
#line 207 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gxml_css_selector_parser_get_property;
#line 207 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (klass)->constructor = gxml_css_selector_parser_constructor;
#line 207 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (klass)->finalize = gxml_css_selector_parser_finalize;
#line 9616 "CssSelectorParser.c"
	/**
	 * a list of parsed {@link GXml.CssSelector}  as a
	 * {@link Gee.List} of {@link GXml.CssSelector}
	 */
#line 207 "../gxml/CssSelectorParser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_CSS_SELECTOR_PARSER_SELECTORS_PROPERTY, gxml_css_selector_parser_properties[GXML_CSS_SELECTOR_PARSER_SELECTORS_PROPERTY] = g_param_spec_object ("selectors", "selectors", "selectors", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 9623 "CssSelectorParser.c"
}

static void
gxml_css_selector_parser_instance_init (GXmlCssSelectorParser * self,
                                        gpointer klass)
{
#line 207 "../gxml/CssSelectorParser.vala"
	self->priv = gxml_css_selector_parser_get_instance_private (self);
#line 9632 "CssSelectorParser.c"
}

static void
gxml_css_selector_parser_finalize (GObject * obj)
{
	GXmlCssSelectorParser * self;
#line 207 "../gxml/CssSelectorParser.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GXML_TYPE_CSS_SELECTOR_PARSER, GXmlCssSelectorParser);
#line 442 "../gxml/CssSelectorParser.vala"
	_g_object_unref0 (self->priv->list);
#line 207 "../gxml/CssSelectorParser.vala"
	G_OBJECT_CLASS (gxml_css_selector_parser_parent_class)->finalize (obj);
#line 9645 "CssSelectorParser.c"
}

/**
 * CSS Selectors Level 3 parser. 
 */
static GType
gxml_css_selector_parser_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GXmlCssSelectorParserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_css_selector_parser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GXmlCssSelectorParser), 0, (GInstanceInitFunc) gxml_css_selector_parser_instance_init, NULL };
	GType gxml_css_selector_parser_type_id;
	gxml_css_selector_parser_type_id = g_type_register_static (G_TYPE_OBJECT, "GXmlCssSelectorParser", &g_define_type_info, 0);
	GXmlCssSelectorParser_private_offset = g_type_add_instance_private (gxml_css_selector_parser_type_id, sizeof (GXmlCssSelectorParserPrivate));
	return gxml_css_selector_parser_type_id;
}

GType
gxml_css_selector_parser_get_type (void)
{
	static volatile gsize gxml_css_selector_parser_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_css_selector_parser_type_id__volatile)) {
		GType gxml_css_selector_parser_type_id;
		gxml_css_selector_parser_type_id = gxml_css_selector_parser_get_type_once ();
		g_once_init_leave (&gxml_css_selector_parser_type_id__volatile, gxml_css_selector_parser_type_id);
	}
	return gxml_css_selector_parser_type_id__volatile;
}

static void
_vala_gxml_css_selector_parser_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	GXmlCssSelectorParser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_CSS_SELECTOR_PARSER, GXmlCssSelectorParser);
#line 207 "../gxml/CssSelectorParser.vala"
	switch (property_id) {
#line 207 "../gxml/CssSelectorParser.vala"
		case GXML_CSS_SELECTOR_PARSER_SELECTORS_PROPERTY:
#line 207 "../gxml/CssSelectorParser.vala"
		g_value_set_object (value, gxml_css_selector_parser_get_selectors (self));
#line 207 "../gxml/CssSelectorParser.vala"
		break;
#line 9689 "CssSelectorParser.c"
		default:
#line 207 "../gxml/CssSelectorParser.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 207 "../gxml/CssSelectorParser.vala"
		break;
#line 9695 "CssSelectorParser.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 371 "../gxml/Collections.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 9706 "CssSelectorParser.c"
		gssize i;
#line 371 "../gxml/Collections.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 371 "../gxml/Collections.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 371 "../gxml/Collections.vala"
				destroy_func (((gpointer*) array)[i]);
#line 9714 "CssSelectorParser.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 371 "../gxml/Collections.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 371 "../gxml/Collections.vala"
	g_free (array);
#line 9729 "CssSelectorParser.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 371 "../gxml/Collections.vala"
	if (array) {
#line 371 "../gxml/Collections.vala"
		while (((gpointer*) array)[length]) {
#line 371 "../gxml/Collections.vala"
			length++;
#line 9743 "CssSelectorParser.c"
		}
	}
#line 371 "../gxml/Collections.vala"
	return length;
#line 9748 "CssSelectorParser.c"
}

