/* Document.c generated by valac 0.54.7, the Vala compiler
 * generated from Document.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; c-basic-offset: 2; tab-width: 2 -*- */
/*
 *
 * Copyright (C) 2016-2019  Daniel Espinosa <esodan@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Daniel Espinosa <esodan@gmail.com>
 */

#include "gxml/gxml.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include "gxml.h"

enum  {
	GXML_DOCUMENT_0_PROPERTY,
	GXML_DOCUMENT_IMPLEMENTATION_PROPERTY,
	GXML_DOCUMENT_URL_PROPERTY,
	GXML_DOCUMENT_DOCUMENT_URI_PROPERTY,
	GXML_DOCUMENT_ORIGIN_PROPERTY,
	GXML_DOCUMENT_COMPAT_MODE_PROPERTY,
	GXML_DOCUMENT_CHARACTER_SET_PROPERTY,
	GXML_DOCUMENT_CONTENT_TYPE_PROPERTY,
	GXML_DOCUMENT_DOCTYPE_PROPERTY,
	GXML_DOCUMENT_DOCUMENT_ELEMENT_PROPERTY,
	GXML_DOCUMENT_CHILDREN_PROPERTY,
	GXML_DOCUMENT_FIRST_ELEMENT_CHILD_PROPERTY,
	GXML_DOCUMENT_LAST_ELEMENT_CHILD_PROPERTY,
	GXML_DOCUMENT_CHILD_ELEMENT_COUNT_PROPERTY,
	GXML_DOCUMENT_NUM_PROPERTIES
};
static GParamSpec* gxml_document_properties[GXML_DOCUMENT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_param_spec_unref0(var) ((var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	GXML_IMPLEMENTATION_0_PROPERTY,
	GXML_IMPLEMENTATION_NUM_PROPERTIES
};
static GParamSpec* gxml_implementation_properties[GXML_IMPLEMENTATION_NUM_PROPERTIES];
enum  {
	GXML_DOCUMENT_TYPE_0_PROPERTY,
	GXML_DOCUMENT_TYPE_NAME_PROPERTY,
	GXML_DOCUMENT_TYPE_PUBLIC_ID_PROPERTY,
	GXML_DOCUMENT_TYPE_SYSTEM_ID_PROPERTY,
	GXML_DOCUMENT_TYPE_NUM_PROPERTIES
};
static GParamSpec* gxml_document_type_properties[GXML_DOCUMENT_TYPE_NUM_PROPERTIES];
enum  {
	GXML_DOCUMENT_FRAGMENT_0_PROPERTY,
	GXML_DOCUMENT_FRAGMENT_CHILDREN_PROPERTY,
	GXML_DOCUMENT_FRAGMENT_FIRST_ELEMENT_CHILD_PROPERTY,
	GXML_DOCUMENT_FRAGMENT_LAST_ELEMENT_CHILD_PROPERTY,
	GXML_DOCUMENT_FRAGMENT_CHILD_ELEMENT_COUNT_PROPERTY,
	GXML_DOCUMENT_FRAGMENT_NUM_PROPERTIES
};
static GParamSpec* gxml_document_fragment_properties[GXML_DOCUMENT_FRAGMENT_NUM_PROPERTIES];

static gpointer gxml_document_parent_class = NULL;
static GXmlDomParentNodeIface * gxml_document_gxml_dom_parent_node_parent_iface = NULL;
static GXmlDomNonElementParentNodeIface * gxml_document_gxml_dom_non_element_parent_node_parent_iface = NULL;
static GXmlDomDocumentIface * gxml_document_gxml_dom_document_parent_iface = NULL;
static GXmlDomXMLDocumentIface * gxml_document_gxml_dom_xml_document_parent_iface = NULL;
static gpointer gxml_implementation_parent_class = NULL;
static GXmlDomImplementationIface * gxml_implementation_gxml_dom_implementation_parent_iface = NULL;
static gpointer gxml_document_type_parent_class = NULL;
static GXmlDomChildNodeIface * gxml_document_type_gxml_dom_child_node_parent_iface = NULL;
static GXmlDomDocumentTypeIface * gxml_document_type_gxml_dom_document_type_parent_iface = NULL;
static gpointer gxml_document_fragment_parent_class = NULL;
static GXmlDomParentNodeIface * gxml_document_fragment_gxml_dom_parent_node_parent_iface = NULL;
static GXmlDomNonElementParentNodeIface * gxml_document_fragment_gxml_dom_non_element_parent_node_parent_iface = NULL;
static GXmlDomDocumentFragmentIface * gxml_document_fragment_gxml_dom_document_fragment_parent_iface = NULL;

static GXmlParser* gxml_document_real_get_xml_parser (GXmlDomDocument* base);
static void gxml_document_real_set_xml_parser (GXmlDomDocument* base,
                                        GXmlParser* parser);
static GXmlDomElement* gxml_document_real_create_element (GXmlDomDocument* base,
                                                   const gchar* local_name,
                                                   GError** error);
static GXmlDomElement* gxml_document_real_create_element_ns (GXmlDomDocument* base,
                                                      const gchar* namespace_uri,
                                                      const gchar* qualified_name,
                                                      GError** error);
static GXmlDomHTMLCollection* gxml_document_real_get_elements_by_tag_name (GXmlDomDocument* base,
                                                                    const gchar* local_name);
static GXmlDomHTMLCollection* gxml_document_real_get_elements_by_tag_name_ns (GXmlDomDocument* base,
                                                                       const gchar* ns,
                                                                       const gchar* local_name);
static GXmlDomHTMLCollection* gxml_document_real_get_elements_by_class_name (GXmlDomDocument* base,
                                                                      const gchar* class_names);
static GXmlDomDocumentFragment* gxml_document_real_create_document_fragment (GXmlDomDocument* base);
static GXmlDomText* gxml_document_real_create_text_node (GXmlDomDocument* base,
                                                  const gchar* data,
                                                  GError** error);
static GXmlDomComment* gxml_document_real_gxml_dom_document_create_comment (GXmlDomDocument* base,
                                                                     const gchar* data,
                                                                     GError** error);
static GXmlDomProcessingInstruction* gxml_document_real_create_processing_instruction (GXmlDomDocument* base,
                                                                                const gchar* target,
                                                                                const gchar* data,
                                                                                GError** error);
static GXmlDomNode* gxml_document_real_import_node (GXmlDomDocument* base,
                                             GXmlDomNode* node,
                                             gboolean deep,
                                             GError** error);
static GXmlDomNode* gxml_document_real_adopt_node (GXmlDomDocument* base,
                                            GXmlDomNode* node,
                                            GError** error);
static GXmlDomEvent* gxml_document_real_create_event (GXmlDomDocument* base,
                                               const gchar* iface,
                                               GError** error);
static GXmlDomRange* gxml_document_real_create_range (GXmlDomDocument* base);
static GXmlDomNodeIterator* gxml_document_real_create_node_iterator (GXmlDomDocument* base,
                                                              GXmlDomNode* root,
                                                              gint what_to_show);
static GXmlDomTreeWalker* gxml_document_real_create_tree_walker (GXmlDomDocument* base,
                                                          GXmlDomNode* root,
                                                          gint what_to_show);
static GXmlDomNodeList* gxml_document_real_query_selector_all (GXmlDomParentNode* base,
                                                        const gchar* selectors,
                                                        GError** error);
static GXmlDomElement* gxml_document_real_get_element_by_id (GXmlDomNonElementParentNode* base,
                                                      const gchar* element_id,
                                                      GError** error);
static GObject * gxml_document_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void gxml_document_finalize (GObject * obj);
static GType gxml_document_get_type_once (void);
static void _vala_gxml_document_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static GXmlDomDocumentType* gxml_implementation_real_create_document_type (GXmlDomImplementation* base,
                                                                    const gchar* qualified_name,
                                                                    const gchar* public_id,
                                                                    const gchar* system_id,
                                                                    GError** error);
static GXmlDomXMLDocument* gxml_implementation_real_create_document (GXmlDomImplementation* base,
                                                              const gchar* namespace,
                                                              const gchar* qualified_name,
                                                              GXmlDomDocumentType* doctype,
                                                              GError** error);
static GXmlDomDocument* gxml_implementation_real_create_html_document (GXmlDomImplementation* base,
                                                                const gchar* title);
static GType gxml_implementation_get_type_once (void);
static void gxml_document_type_real_remove (GXmlDomChildNode* base);
static GObject * gxml_document_type_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void gxml_document_type_finalize (GObject * obj);
static GType gxml_document_type_get_type_once (void);
static void _vala_gxml_document_type_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static GXmlDomElement* gxml_document_fragment_real_query_selector (GXmlDomParentNode* base,
                                                            const gchar* selectors,
                                                            GError** error);
static GXmlDomNodeList* gxml_document_fragment_real_query_selector_all (GXmlDomParentNode* base,
                                                                 const gchar* selectors,
                                                                 GError** error);
static GXmlDomElement* gxml_document_fragment_real_get_element_by_id (GXmlDomNonElementParentNode* base,
                                                               const gchar* element_id,
                                                               GError** error);
static GType gxml_document_fragment_get_type_once (void);
static void _vala_gxml_document_fragment_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static GXmlDomImplementation*
gxml_document_real_get_implementation (GXmlDomDocument* base)
{
	GXmlDomImplementation* result;
	GXmlDocument* self;
	GXmlDomImplementation* _tmp0_;
#line 51 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 51 "../gxml/Document.vala"
	_tmp0_ = self->_implementation;
#line 51 "../gxml/Document.vala"
	result = _tmp0_;
#line 51 "../gxml/Document.vala"
	return result;
#line 217 "Document.c"
}

static const gchar*
gxml_document_real_get_url (GXmlDomDocument* base)
{
	const gchar* result;
	GXmlDocument* self;
	const gchar* _tmp0_;
#line 52 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 52 "../gxml/Document.vala"
	_tmp0_ = self->_url;
#line 52 "../gxml/Document.vala"
	result = _tmp0_;
#line 52 "../gxml/Document.vala"
	return result;
#line 234 "Document.c"
}

static const gchar*
gxml_document_real_get_document_uri (GXmlDomDocument* base)
{
	const gchar* result;
	GXmlDocument* self;
	const gchar* _tmp0_;
#line 53 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 53 "../gxml/Document.vala"
	_tmp0_ = self->_url;
#line 53 "../gxml/Document.vala"
	result = _tmp0_;
#line 53 "../gxml/Document.vala"
	return result;
#line 251 "Document.c"
}

static const gchar*
gxml_document_real_get_origin (GXmlDomDocument* base)
{
	const gchar* result;
	GXmlDocument* self;
	const gchar* _tmp0_;
#line 54 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 54 "../gxml/Document.vala"
	_tmp0_ = self->_origin;
#line 54 "../gxml/Document.vala"
	result = _tmp0_;
#line 54 "../gxml/Document.vala"
	return result;
#line 268 "Document.c"
}

static const gchar*
gxml_document_real_get_compat_mode (GXmlDomDocument* base)
{
	const gchar* result;
	GXmlDocument* self;
	const gchar* _tmp0_;
#line 55 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 55 "../gxml/Document.vala"
	_tmp0_ = self->_compat_mode;
#line 55 "../gxml/Document.vala"
	result = _tmp0_;
#line 55 "../gxml/Document.vala"
	return result;
#line 285 "Document.c"
}

static const gchar*
gxml_document_real_get_character_set (GXmlDomDocument* base)
{
	const gchar* result;
	GXmlDocument* self;
	const gchar* _tmp0_;
#line 56 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 56 "../gxml/Document.vala"
	_tmp0_ = self->_character_set;
#line 56 "../gxml/Document.vala"
	result = _tmp0_;
#line 56 "../gxml/Document.vala"
	return result;
#line 302 "Document.c"
}

static const gchar*
gxml_document_real_get_content_type (GXmlDomDocument* base)
{
	const gchar* result;
	GXmlDocument* self;
	const gchar* _tmp0_;
#line 57 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 57 "../gxml/Document.vala"
	_tmp0_ = self->_content_type;
#line 57 "../gxml/Document.vala"
	result = _tmp0_;
#line 57 "../gxml/Document.vala"
	return result;
#line 319 "Document.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 62 "../gxml/Document.vala"
	return self ? g_object_ref (self) : NULL;
#line 327 "Document.c"
}

static GXmlDomDocumentType*
gxml_document_real_get_doctype (GXmlDomDocument* base)
{
	GXmlDomDocumentType* result;
	GXmlDocument* self;
#line 60 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 337 "Document.c"
	{
		GXmlDomNodeList* _n_list = NULL;
		GXmlDomNodeList* _tmp0_;
		GXmlDomNodeList* _tmp1_;
		gint _n_size = 0;
		GXmlDomNodeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _n_index = 0;
#line 61 "../gxml/Document.vala"
		_tmp0_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 61 "../gxml/Document.vala"
		_tmp1_ = _tmp0_;
#line 61 "../gxml/Document.vala"
		_n_list = _tmp1_;
#line 61 "../gxml/Document.vala"
		_tmp2_ = _n_list;
#line 61 "../gxml/Document.vala"
		_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 61 "../gxml/Document.vala"
		_tmp4_ = _tmp3_;
#line 61 "../gxml/Document.vala"
		_n_size = _tmp4_;
#line 61 "../gxml/Document.vala"
		_n_index = -1;
#line 61 "../gxml/Document.vala"
		while (TRUE) {
#line 365 "Document.c"
			gint _tmp5_;
			gint _tmp6_;
			GXmlDomNode* n = NULL;
			GXmlDomNodeList* _tmp7_;
			gpointer _tmp8_;
			GXmlDomNode* _tmp9_;
#line 61 "../gxml/Document.vala"
			_n_index = _n_index + 1;
#line 61 "../gxml/Document.vala"
			_tmp5_ = _n_index;
#line 61 "../gxml/Document.vala"
			_tmp6_ = _n_size;
#line 61 "../gxml/Document.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 61 "../gxml/Document.vala"
				break;
#line 382 "Document.c"
			}
#line 61 "../gxml/Document.vala"
			_tmp7_ = _n_list;
#line 61 "../gxml/Document.vala"
			_tmp8_ = gee_list_get ((GeeList*) _tmp7_, _n_index);
#line 61 "../gxml/Document.vala"
			n = (GXmlDomNode*) _tmp8_;
#line 62 "../gxml/Document.vala"
			_tmp9_ = n;
#line 62 "../gxml/Document.vala"
			if (GXML_IS_DOM_DOCUMENT_TYPE (_tmp9_)) {
#line 394 "Document.c"
				GXmlDomNode* _tmp10_;
				GXmlDomDocumentType* _tmp11_;
#line 62 "../gxml/Document.vala"
				_tmp10_ = n;
#line 62 "../gxml/Document.vala"
				_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GXML_TYPE_DOM_DOCUMENT_TYPE, GXmlDomDocumentType));
#line 62 "../gxml/Document.vala"
				result = _tmp11_;
#line 62 "../gxml/Document.vala"
				_g_object_unref0 (n);
#line 62 "../gxml/Document.vala"
				_g_object_unref0 (_n_list);
#line 62 "../gxml/Document.vala"
				return result;
#line 409 "Document.c"
			}
#line 61 "../gxml/Document.vala"
			_g_object_unref0 (n);
#line 413 "Document.c"
		}
#line 61 "../gxml/Document.vala"
		_g_object_unref0 (_n_list);
#line 417 "Document.c"
	}
#line 64 "../gxml/Document.vala"
	result = NULL;
#line 64 "../gxml/Document.vala"
	return result;
#line 423 "Document.c"
}

static GXmlDomElement*
gxml_document_real_get_document_element (GXmlDomDocument* base)
{
	GXmlDomElement* result;
	GXmlDocument* self;
#line 68 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 433 "Document.c"
	{
		gint i = 0;
#line 69 "../gxml/Document.vala"
		i = 0;
#line 438 "Document.c"
		{
			gboolean _tmp0_ = FALSE;
#line 69 "../gxml/Document.vala"
			_tmp0_ = TRUE;
#line 69 "../gxml/Document.vala"
			while (TRUE) {
#line 445 "Document.c"
				GXmlDomNodeList* _tmp2_;
				GXmlDomNodeList* _tmp3_;
				GXmlDomNodeList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gboolean _tmp7_;
				GXmlDomNode* n = NULL;
				GXmlDomNodeList* _tmp8_;
				GXmlDomNodeList* _tmp9_;
				GXmlDomNodeList* _tmp10_;
				GXmlDomNode* _tmp11_;
				GXmlDomNode* _tmp12_;
				GXmlDomNode* _tmp13_;
#line 69 "../gxml/Document.vala"
				if (!_tmp0_) {
#line 461 "Document.c"
					gint _tmp1_;
#line 69 "../gxml/Document.vala"
					_tmp1_ = i;
#line 69 "../gxml/Document.vala"
					i = _tmp1_ + 1;
#line 467 "Document.c"
				}
#line 69 "../gxml/Document.vala"
				_tmp0_ = FALSE;
#line 69 "../gxml/Document.vala"
				_tmp2_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 69 "../gxml/Document.vala"
				_tmp3_ = _tmp2_;
#line 69 "../gxml/Document.vala"
				_tmp4_ = _tmp3_;
#line 69 "../gxml/Document.vala"
				_tmp5_ = gxml_dom_node_list_get_length (_tmp4_);
#line 69 "../gxml/Document.vala"
				_tmp6_ = _tmp5_;
#line 69 "../gxml/Document.vala"
				_tmp7_ = !(i < _tmp6_);
#line 69 "../gxml/Document.vala"
				_g_object_unref0 (_tmp4_);
#line 69 "../gxml/Document.vala"
				if (_tmp7_) {
#line 69 "../gxml/Document.vala"
					break;
#line 489 "Document.c"
				}
#line 70 "../gxml/Document.vala"
				_tmp8_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 70 "../gxml/Document.vala"
				_tmp9_ = _tmp8_;
#line 70 "../gxml/Document.vala"
				_tmp10_ = _tmp9_;
#line 70 "../gxml/Document.vala"
				_tmp11_ = gxml_dom_node_list_item (_tmp10_, i);
#line 70 "../gxml/Document.vala"
				_tmp12_ = _tmp11_;
#line 70 "../gxml/Document.vala"
				_g_object_unref0 (_tmp10_);
#line 70 "../gxml/Document.vala"
				n = _tmp12_;
#line 71 "../gxml/Document.vala"
				_tmp13_ = n;
#line 71 "../gxml/Document.vala"
				if (GXML_IS_DOM_ELEMENT (_tmp13_)) {
#line 509 "Document.c"
					GXmlDomNode* _tmp14_;
					GXmlDomElement* _tmp15_;
#line 72 "../gxml/Document.vala"
					_tmp14_ = n;
#line 72 "../gxml/Document.vala"
					_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GXML_TYPE_DOM_ELEMENT, GXmlDomElement));
#line 72 "../gxml/Document.vala"
					result = _tmp15_;
#line 72 "../gxml/Document.vala"
					_g_object_unref0 (n);
#line 72 "../gxml/Document.vala"
					return result;
#line 522 "Document.c"
				}
#line 69 "../gxml/Document.vala"
				_g_object_unref0 (n);
#line 526 "Document.c"
			}
		}
	}
#line 75 "../gxml/Document.vala"
	result = NULL;
#line 75 "../gxml/Document.vala"
	return result;
#line 534 "Document.c"
}

GXmlDocument*
gxml_document_construct (GType object_type)
{
	GXmlDocument * self = NULL;
#line 89 "../gxml/Document.vala"
	self = (GXmlDocument*) gxml_node_construct (object_type);
#line 89 "../gxml/Document.vala"
	return self;
#line 545 "Document.c"
}

GXmlDocument*
gxml_document_new (void)
{
#line 89 "../gxml/Document.vala"
	return gxml_document_construct (GXML_TYPE_DOCUMENT);
#line 553 "Document.c"
}

GXmlDocument*
gxml_document_construct_from_path (GType object_type,
                                   const gchar* path,
                                   GError** error)
{
	GXmlDocument * self = NULL;
	GFile* file = NULL;
	GFile* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 90 "../gxml/Document.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 91 "../gxml/Document.vala"
	_tmp0_ = g_file_new_for_path (path);
#line 91 "../gxml/Document.vala"
	file = _tmp0_;
#line 92 "../gxml/Document.vala"
	self = (GXmlDocument*) gxml_document_construct_from_file (object_type, file, &_inner_error0_);
#line 92 "../gxml/Document.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 92 "../gxml/Document.vala"
		g_propagate_error (error, _inner_error0_);
#line 92 "../gxml/Document.vala"
		_g_object_unref0 (file);
#line 92 "../gxml/Document.vala"
		_g_object_unref0 (self);
#line 92 "../gxml/Document.vala"
		return NULL;
#line 583 "Document.c"
	}
#line 90 "../gxml/Document.vala"
	_g_object_unref0 (file);
#line 90 "../gxml/Document.vala"
	return self;
#line 589 "Document.c"
}

GXmlDocument*
gxml_document_new_from_path (const gchar* path,
                             GError** error)
{
#line 90 "../gxml/Document.vala"
	return gxml_document_construct_from_path (GXML_TYPE_DOCUMENT, path, error);
#line 598 "Document.c"
}

/**
   * Creates a document parsing a URI file.
   */
GXmlDocument*
gxml_document_construct_from_uri (GType object_type,
                                  const gchar* uri,
                                  GError** error)
{
	GXmlDocument * self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 98 "../gxml/Document.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 99 "../gxml/Document.vala"
	_tmp0_ = g_file_new_for_uri (uri);
#line 99 "../gxml/Document.vala"
	_tmp1_ = _tmp0_;
#line 99 "../gxml/Document.vala"
	self = (GXmlDocument*) gxml_document_construct_from_file (object_type, _tmp1_, &_inner_error0_);
#line 99 "../gxml/Document.vala"
	_g_object_unref0 (_tmp1_);
#line 99 "../gxml/Document.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../gxml/Document.vala"
		g_propagate_error (error, _inner_error0_);
#line 99 "../gxml/Document.vala"
		_g_object_unref0 (self);
#line 99 "../gxml/Document.vala"
		return NULL;
#line 631 "Document.c"
	}
#line 98 "../gxml/Document.vala"
	return self;
#line 635 "Document.c"
}

GXmlDocument*
gxml_document_new_from_uri (const gchar* uri,
                            GError** error)
{
#line 98 "../gxml/Document.vala"
	return gxml_document_construct_from_uri (GXML_TYPE_DOCUMENT, uri, error);
#line 644 "Document.c"
}

/**
   * Creates a document parsing a file.
   */
GXmlDocument*
gxml_document_construct_from_file (GType object_type,
                                   GFile* file,
                                   GError** error)
{
	GXmlDocument * self = NULL;
	GXmlParser* parser = NULL;
	GXmlParser* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 105 "../gxml/Document.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 105 "../gxml/Document.vala"
	self = (GXmlDocument*) gxml_node_construct (object_type);
#line 106 "../gxml/Document.vala"
	_tmp0_ = gxml_dom_document_get_xml_parser ((GXmlDomDocument*) self);
#line 106 "../gxml/Document.vala"
	parser = _tmp0_;
#line 107 "../gxml/Document.vala"
	gxml_parser_read_file (parser, file, &_inner_error0_);
#line 107 "../gxml/Document.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 107 "../gxml/Document.vala"
		g_propagate_error (error, _inner_error0_);
#line 107 "../gxml/Document.vala"
		_g_object_unref0 (parser);
#line 107 "../gxml/Document.vala"
		_g_object_unref0 (self);
#line 107 "../gxml/Document.vala"
		return NULL;
#line 679 "Document.c"
	}
#line 105 "../gxml/Document.vala"
	_g_object_unref0 (parser);
#line 105 "../gxml/Document.vala"
	return self;
#line 685 "Document.c"
}

GXmlDocument*
gxml_document_new_from_file (GFile* file,
                             GError** error)
{
#line 105 "../gxml/Document.vala"
	return gxml_document_construct_from_file (GXML_TYPE_DOCUMENT, file, error);
#line 694 "Document.c"
}

/**
   * Search, instantiate and append the element marked as root,
   * with the nick equal to '::ROOT' (without ').
   */
static gpointer
_g_param_spec_ref0 (gpointer self)
{
#line 115 "../gxml/Document.vala"
	return self ? g_param_spec_ref (self) : NULL;
#line 706 "Document.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 725 "Document.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 747 "Document.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 751 "Document.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 757 "Document.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 761 "Document.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 765 "Document.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 773 "Document.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 801 "Document.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 810 "Document.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 824 "Document.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 833 "Document.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 847 "Document.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 856 "Document.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 865 "Document.c"
}

GXmlElement*
gxml_document_search_root_element_property (GXmlDocument* self)
{
	GObject* obj = NULL;
	GObjectClass* _tmp0_;
	guint _tmp1_ = 0;
	GParamSpec** _tmp2_;
	GObject* _tmp36_;
	GXmlElement* _tmp37_;
	GError* _inner_error0_ = NULL;
	GXmlElement* result = NULL;
#line 113 "../gxml/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 114 "../gxml/Document.vala"
	obj = NULL;
#line 115 "../gxml/Document.vala"
	_tmp0_ = G_OBJECT_GET_CLASS ((GObject*) self);
#line 115 "../gxml/Document.vala"
	_tmp2_ = g_object_class_list_properties (_tmp0_, &_tmp1_);
#line 887 "Document.c"
	{
		GParamSpec** spec_collection = NULL;
		gint spec_collection_length1 = 0;
		gint _spec_collection_size_ = 0;
		gint spec_it = 0;
#line 115 "../gxml/Document.vala"
		spec_collection = _tmp2_;
#line 115 "../gxml/Document.vala"
		spec_collection_length1 = _tmp1_;
#line 115 "../gxml/Document.vala"
		for (spec_it = 0; spec_it < spec_collection_length1; spec_it = spec_it + 1) {
#line 899 "Document.c"
			GParamSpec* _tmp3_;
			GParamSpec* spec = NULL;
#line 115 "../gxml/Document.vala"
			_tmp3_ = _g_param_spec_ref0 (spec_collection[spec_it]);
#line 115 "../gxml/Document.vala"
			spec = _tmp3_;
#line 906 "Document.c"
			{
				GParamSpec* _tmp4_;
				const gchar* _tmp5_;
#line 116 "../gxml/Document.vala"
				_tmp4_ = spec;
#line 116 "../gxml/Document.vala"
				_tmp5_ = g_param_spec_get_nick (_tmp4_);
#line 116 "../gxml/Document.vala"
				if (string_contains (_tmp5_, "::")) {
#line 916 "Document.c"
					gchar* name = NULL;
					GParamSpec* _tmp6_;
					const gchar* _tmp7_;
					gchar* _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
					const gchar* _tmp12_;
					GParamSpec* _tmp13_;
#line 117 "../gxml/Document.vala"
					_tmp6_ = spec;
#line 117 "../gxml/Document.vala"
					_tmp7_ = g_param_spec_get_nick (_tmp6_);
#line 117 "../gxml/Document.vala"
					_tmp8_ = g_utf8_strdown (_tmp7_, (gssize) -1);
#line 117 "../gxml/Document.vala"
					_tmp9_ = _tmp8_;
#line 117 "../gxml/Document.vala"
					_tmp10_ = string_replace (_tmp9_, "::", "");
#line 117 "../gxml/Document.vala"
					_tmp11_ = _tmp10_;
#line 117 "../gxml/Document.vala"
					_g_free0 (_tmp9_);
#line 117 "../gxml/Document.vala"
					name = _tmp11_;
#line 118 "../gxml/Document.vala"
					_tmp12_ = name;
#line 118 "../gxml/Document.vala"
					if (g_strcmp0 (_tmp12_, "root") != 0) {
#line 119 "../gxml/Document.vala"
						_g_free0 (name);
#line 119 "../gxml/Document.vala"
						_g_param_spec_unref0 (spec);
#line 119 "../gxml/Document.vala"
						continue;
#line 952 "Document.c"
					}
#line 121 "../gxml/Document.vala"
					_tmp13_ = spec;
#line 121 "../gxml/Document.vala"
					if (g_type_is_a (_tmp13_->value_type, GXML_TYPE_ELEMENT)) {
#line 958 "Document.c"
						GValue val = {0};
						GValue _tmp14_ = {0};
						GParamSpec* _tmp15_;
						const gchar* _tmp16_;
						GObject* _tmp17_;
						GObject* _tmp18_;
						GObject* _tmp19_;
#line 122 "../gxml/Document.vala"
						g_value_init (&_tmp14_, G_TYPE_OBJECT);
#line 122 "../gxml/Document.vala"
						val = _tmp14_;
#line 123 "../gxml/Document.vala"
						_tmp15_ = spec;
#line 123 "../gxml/Document.vala"
						_tmp16_ = _tmp15_->name;
#line 123 "../gxml/Document.vala"
						g_object_get_property ((GObject*) self, _tmp16_, &val);
#line 124 "../gxml/Document.vala"
						_tmp17_ = g_value_get_object (&val);
#line 124 "../gxml/Document.vala"
						_tmp18_ = _g_object_ref0 ((GObject*) (GXML_IS_ELEMENT (_tmp17_) ? ((GXmlElement*) _tmp17_) : NULL));
#line 124 "../gxml/Document.vala"
						_g_object_unref0 (obj);
#line 124 "../gxml/Document.vala"
						obj = _tmp18_;
#line 125 "../gxml/Document.vala"
						_tmp19_ = obj;
#line 125 "../gxml/Document.vala"
						if (_tmp19_ == NULL) {
#line 988 "Document.c"
							GParamSpec* _tmp20_;
							GXmlDomDocument* _tmp21_;
							GXmlDomDocument* _tmp22_;
							GObject* _tmp23_;
							GObject* _tmp24_;
							GObject* _tmp32_;
							GParamSpec* _tmp33_;
							const gchar* _tmp34_;
							GValue _tmp35_;
#line 126 "../gxml/Document.vala"
							_tmp20_ = spec;
#line 126 "../gxml/Document.vala"
							_tmp21_ = gxml_dom_node_get_owner_document ((GXmlDomNode*) self);
#line 126 "../gxml/Document.vala"
							_tmp22_ = _tmp21_;
#line 126 "../gxml/Document.vala"
							_tmp23_ = g_object_new (_tmp20_->value_type, "owner-document", _tmp22_, NULL);
#line 126 "../gxml/Document.vala"
							_tmp24_ = G_IS_INITIALLY_UNOWNED (_tmp23_) ? g_object_ref_sink (_tmp23_) : _tmp23_;
#line 126 "../gxml/Document.vala"
							_g_object_unref0 (obj);
#line 126 "../gxml/Document.vala"
							obj = _tmp24_;
#line 1012 "Document.c"
							{
								GObject* _tmp25_;
								GXmlDomNode* _tmp26_;
								GXmlDomNode* _tmp27_;
#line 127 "../gxml/Document.vala"
								_tmp25_ = obj;
#line 127 "../gxml/Document.vala"
								_tmp26_ = gxml_dom_node_append_child ((GXmlDomNode*) self, (GXmlDomNode*) (GXML_IS_ELEMENT (_tmp25_) ? ((GXmlElement*) _tmp25_) : NULL), &_inner_error0_);
#line 127 "../gxml/Document.vala"
								_tmp27_ = _tmp26_;
#line 127 "../gxml/Document.vala"
								_g_object_unref0 (_tmp27_);
#line 127 "../gxml/Document.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1027 "Document.c"
									goto __catch0_g_error;
								}
							}
							goto __finally0;
							__catch0_g_error:
							{
								GError* e = NULL;
								GError* _tmp28_;
								const gchar* _tmp29_;
								gchar* _tmp30_;
								gchar* _tmp31_;
#line 127 "../gxml/Document.vala"
								e = _inner_error0_;
#line 127 "../gxml/Document.vala"
								_inner_error0_ = NULL;
#line 129 "../gxml/Document.vala"
								_tmp28_ = e;
#line 129 "../gxml/Document.vala"
								_tmp29_ = _tmp28_->message;
#line 129 "../gxml/Document.vala"
								_tmp30_ = g_strdup_printf (_ ("Error while attempting to instantiate root property object: %s"), _tmp29_);
#line 129 "../gxml/Document.vala"
								_tmp31_ = _tmp30_;
#line 129 "../gxml/Document.vala"
								g_warning ("Document.vala:129: %s", _tmp31_);
#line 129 "../gxml/Document.vala"
								_g_free0 (_tmp31_);
#line 130 "../gxml/Document.vala"
								_g_object_unref0 (obj);
#line 130 "../gxml/Document.vala"
								obj = NULL;
#line 127 "../gxml/Document.vala"
								_g_error_free0 (e);
#line 1061 "Document.c"
							}
							__finally0:
#line 127 "../gxml/Document.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 127 "../gxml/Document.vala"
								G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 127 "../gxml/Document.vala"
								_g_free0 (name);
#line 127 "../gxml/Document.vala"
								_g_param_spec_unref0 (spec);
#line 127 "../gxml/Document.vala"
								spec_collection = (g_free (spec_collection), NULL);
#line 127 "../gxml/Document.vala"
								_g_object_unref0 (obj);
#line 127 "../gxml/Document.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 127 "../gxml/Document.vala"
								g_clear_error (&_inner_error0_);
#line 127 "../gxml/Document.vala"
								return NULL;
#line 1082 "Document.c"
							}
#line 132 "../gxml/Document.vala"
							_tmp32_ = obj;
#line 132 "../gxml/Document.vala"
							g_value_set_object (&val, _tmp32_);
#line 133 "../gxml/Document.vala"
							_tmp33_ = spec;
#line 133 "../gxml/Document.vala"
							_tmp34_ = _tmp33_->name;
#line 133 "../gxml/Document.vala"
							_tmp35_ = val;
#line 133 "../gxml/Document.vala"
							g_object_set_property ((GObject*) self, _tmp34_, &_tmp35_);
#line 1096 "Document.c"
						}
#line 125 "../gxml/Document.vala"
						G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 1100 "Document.c"
					}
#line 121 "../gxml/Document.vala"
					_g_free0 (name);
#line 1104 "Document.c"
				}
#line 116 "../gxml/Document.vala"
				_g_param_spec_unref0 (spec);
#line 1108 "Document.c"
			}
		}
#line 116 "../gxml/Document.vala"
		spec_collection = (g_free (spec_collection), NULL);
#line 1113 "Document.c"
	}
#line 138 "../gxml/Document.vala"
	_tmp36_ = obj;
#line 138 "../gxml/Document.vala"
	_tmp37_ = _g_object_ref0 (GXML_IS_ELEMENT (_tmp36_) ? ((GXmlElement*) _tmp36_) : NULL);
#line 138 "../gxml/Document.vala"
	result = _tmp37_;
#line 138 "../gxml/Document.vala"
	_g_object_unref0 (obj);
#line 138 "../gxml/Document.vala"
	return result;
#line 1125 "Document.c"
}

/**
   * Creates a document parsing a stream.
   */
GXmlDocument*
gxml_document_construct_from_stream (GType object_type,
                                     GInputStream* stream,
                                     GError** error)
{
	GXmlDocument * self = NULL;
	GXmlParser* parser = NULL;
	GXmlParser* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 144 "../gxml/Document.vala"
	g_return_val_if_fail (stream != NULL, NULL);
#line 144 "../gxml/Document.vala"
	self = (GXmlDocument*) gxml_node_construct (object_type);
#line 145 "../gxml/Document.vala"
	_tmp0_ = gxml_dom_document_get_xml_parser ((GXmlDomDocument*) self);
#line 145 "../gxml/Document.vala"
	parser = _tmp0_;
#line 146 "../gxml/Document.vala"
	gxml_parser_read_stream (parser, stream, &_inner_error0_);
#line 146 "../gxml/Document.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 146 "../gxml/Document.vala"
		g_propagate_error (error, _inner_error0_);
#line 146 "../gxml/Document.vala"
		_g_object_unref0 (parser);
#line 146 "../gxml/Document.vala"
		_g_object_unref0 (self);
#line 146 "../gxml/Document.vala"
		return NULL;
#line 1160 "Document.c"
	}
#line 144 "../gxml/Document.vala"
	_g_object_unref0 (parser);
#line 144 "../gxml/Document.vala"
	return self;
#line 1166 "Document.c"
}

GXmlDocument*
gxml_document_new_from_stream (GInputStream* stream,
                               GError** error)
{
#line 144 "../gxml/Document.vala"
	return gxml_document_construct_from_stream (GXML_TYPE_DOCUMENT, stream, error);
#line 1175 "Document.c"
}

/**
   * Creates a document parsing a string.
   */
GXmlDocument*
gxml_document_construct_from_string (GType object_type,
                                     const gchar* str,
                                     GError** error)
{
	GXmlDocument * self = NULL;
	GXmlParser* parser = NULL;
	GXmlParser* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 152 "../gxml/Document.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 152 "../gxml/Document.vala"
	self = (GXmlDocument*) gxml_node_construct (object_type);
#line 153 "../gxml/Document.vala"
	_tmp0_ = gxml_dom_document_get_xml_parser ((GXmlDomDocument*) self);
#line 153 "../gxml/Document.vala"
	parser = _tmp0_;
#line 154 "../gxml/Document.vala"
	gxml_parser_read_string (parser, str, &_inner_error0_);
#line 154 "../gxml/Document.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 154 "../gxml/Document.vala"
		g_propagate_error (error, _inner_error0_);
#line 154 "../gxml/Document.vala"
		_g_object_unref0 (parser);
#line 154 "../gxml/Document.vala"
		_g_object_unref0 (self);
#line 154 "../gxml/Document.vala"
		return NULL;
#line 1210 "Document.c"
	}
#line 152 "../gxml/Document.vala"
	_g_object_unref0 (parser);
#line 152 "../gxml/Document.vala"
	return self;
#line 1216 "Document.c"
}

GXmlDocument*
gxml_document_new_from_string (const gchar* str,
                               GError** error)
{
#line 152 "../gxml/Document.vala"
	return gxml_document_construct_from_string (GXML_TYPE_DOCUMENT, str, error);
#line 1225 "Document.c"
}

static GXmlParser*
gxml_document_real_get_xml_parser (GXmlDomDocument* base)
{
	GXmlDocument * self;
	GXmlElement* roote = NULL;
	GXmlElement* _tmp0_;
	GXmlParser* parser = NULL;
	GXmlElement* _tmp1_;
	GXmlParser* _tmp5_;
	GXmlParser* result = NULL;
#line 157 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 158 "../gxml/Document.vala"
	_tmp0_ = gxml_document_search_root_element_property (self);
#line 158 "../gxml/Document.vala"
	roote = _tmp0_;
#line 159 "../gxml/Document.vala"
	parser = NULL;
#line 160 "../gxml/Document.vala"
	_tmp1_ = roote;
#line 160 "../gxml/Document.vala"
	if (_tmp1_ != NULL) {
#line 1250 "Document.c"
		GXmlElement* _tmp2_;
		GXmlXParser* _tmp3_;
#line 161 "../gxml/Document.vala"
		_tmp2_ = roote;
#line 161 "../gxml/Document.vala"
		_tmp3_ = gxml_xparser_new ((GXmlDomNode*) _tmp2_);
#line 161 "../gxml/Document.vala"
		_g_object_unref0 (parser);
#line 161 "../gxml/Document.vala"
		parser = (GXmlParser*) _tmp3_;
#line 1261 "Document.c"
	} else {
		GXmlXParser* _tmp4_;
#line 163 "../gxml/Document.vala"
		_tmp4_ = gxml_xparser_new ((GXmlDomNode*) self);
#line 163 "../gxml/Document.vala"
		_g_object_unref0 (parser);
#line 163 "../gxml/Document.vala"
		parser = (GXmlParser*) _tmp4_;
#line 1270 "Document.c"
	}
#line 165 "../gxml/Document.vala"
	_tmp5_ = self->_parser;
#line 165 "../gxml/Document.vala"
	if (_tmp5_ != NULL) {
#line 1276 "Document.c"
		GXmlParser* _tmp6_;
		GXmlParser* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
		GXmlParser* _tmp10_;
		GXmlParser* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
		GXmlParser* _tmp14_;
		GXmlParser* _tmp15_;
		GCancellable* _tmp16_;
		GCancellable* _tmp17_;
#line 166 "../gxml/Document.vala"
		_tmp6_ = parser;
#line 166 "../gxml/Document.vala"
		_tmp7_ = self->_parser;
#line 166 "../gxml/Document.vala"
		_tmp8_ = gxml_parser_get_backup (_tmp7_);
#line 166 "../gxml/Document.vala"
		_tmp9_ = _tmp8_;
#line 166 "../gxml/Document.vala"
		gxml_parser_set_backup (_tmp6_, _tmp9_);
#line 167 "../gxml/Document.vala"
		_tmp10_ = parser;
#line 167 "../gxml/Document.vala"
		_tmp11_ = self->_parser;
#line 167 "../gxml/Document.vala"
		_tmp12_ = gxml_parser_get_indent (_tmp11_);
#line 167 "../gxml/Document.vala"
		_tmp13_ = _tmp12_;
#line 167 "../gxml/Document.vala"
		gxml_parser_set_indent (_tmp10_, _tmp13_);
#line 168 "../gxml/Document.vala"
		_tmp14_ = parser;
#line 168 "../gxml/Document.vala"
		_tmp15_ = self->_parser;
#line 168 "../gxml/Document.vala"
		_tmp16_ = gxml_parser_get_cancellable (_tmp15_);
#line 168 "../gxml/Document.vala"
		_tmp17_ = _tmp16_;
#line 168 "../gxml/Document.vala"
		gxml_parser_set_cancellable (_tmp14_, _tmp17_);
#line 1319 "Document.c"
	}
#line 170 "../gxml/Document.vala"
	result = parser;
#line 170 "../gxml/Document.vala"
	_g_object_unref0 (roote);
#line 170 "../gxml/Document.vala"
	return result;
#line 1327 "Document.c"
}

static void
gxml_document_real_set_xml_parser (GXmlDomDocument* base,
                                   GXmlParser* parser)
{
	GXmlDocument * self;
	GXmlParser* _tmp0_;
#line 173 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 173 "../gxml/Document.vala"
	g_return_if_fail (parser != NULL);
#line 174 "../gxml/Document.vala"
	_tmp0_ = _g_object_ref0 (parser);
#line 174 "../gxml/Document.vala"
	_g_object_unref0 (self->_parser);
#line 174 "../gxml/Document.vala"
	self->_parser = _tmp0_;
#line 1346 "Document.c"
}

static GXmlDomElement*
gxml_document_real_create_element (GXmlDomDocument* base,
                                   const gchar* local_name,
                                   GError** error)
{
	GXmlDocument * self;
	GXmlElement* e = NULL;
	GXmlElement* _tmp0_;
	GXmlDomElement* result = NULL;
#line 176 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 176 "../gxml/Document.vala"
	g_return_val_if_fail (local_name != NULL, NULL);
#line 177 "../gxml/Document.vala"
	_tmp0_ = gxml_element_new ();
#line 177 "../gxml/Document.vala"
	e = _tmp0_;
#line 178 "../gxml/Document.vala"
	gxml_element_initialize_document (e, (GXmlDomDocument*) self, local_name);
#line 179 "../gxml/Document.vala"
	result = (GXmlDomElement*) e;
#line 179 "../gxml/Document.vala"
	return result;
#line 1372 "Document.c"
}

static GXmlDomElement*
gxml_document_real_create_element_ns (GXmlDomDocument* base,
                                      const gchar* namespace_uri,
                                      const gchar* qualified_name,
                                      GError** error)
{
	GXmlDocument * self;
	gchar* n = NULL;
	gchar* _tmp0_;
	gchar* nsp = NULL;
	gboolean _tmp12_ = FALSE;
	const gchar* _tmp13_;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	const gchar* _tmp17_;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	const gchar* _tmp22_;
	GXmlElement* e = NULL;
	GXmlElement* _tmp25_;
	GXmlElement* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	GError* _inner_error0_ = NULL;
	GXmlDomElement* result = NULL;
#line 181 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 181 "../gxml/Document.vala"
	g_return_val_if_fail (qualified_name != NULL, NULL);
#line 183 "../gxml/Document.vala"
	_tmp0_ = g_strdup ("");
#line 183 "../gxml/Document.vala"
	n = _tmp0_;
#line 184 "../gxml/Document.vala"
	nsp = NULL;
#line 185 "../gxml/Document.vala"
	if (string_contains (qualified_name, ":")) {
#line 1412 "Document.c"
		gchar** s = NULL;
		gchar** _tmp1_;
		gchar** _tmp2_;
		gint s_length1;
		gint _s_size_;
		gchar** _tmp3_;
		gint _tmp3__length1;
		gchar** _tmp5_;
		gint _tmp5__length1;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 186 "../gxml/Document.vala"
		_tmp2_ = _tmp1_ = g_strsplit (qualified_name, ":", 0);
#line 186 "../gxml/Document.vala"
		s = _tmp2_;
#line 186 "../gxml/Document.vala"
		s_length1 = _vala_array_length (_tmp1_);
#line 186 "../gxml/Document.vala"
		_s_size_ = s_length1;
#line 187 "../gxml/Document.vala"
		_tmp3_ = s;
#line 187 "../gxml/Document.vala"
		_tmp3__length1 = s_length1;
#line 187 "../gxml/Document.vala"
		if (_tmp3__length1 != 2) {
#line 1442 "Document.c"
			GError* _tmp4_;
#line 188 "../gxml/Document.vala"
			_tmp4_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_NAMESPACE_ERROR, _ ("Creating a namespaced element with invalid node name"));
#line 188 "../gxml/Document.vala"
			_inner_error0_ = _tmp4_;
#line 188 "../gxml/Document.vala"
			g_propagate_error (error, _inner_error0_);
#line 188 "../gxml/Document.vala"
			s = (_vala_array_free (s, s_length1, (GDestroyNotify) g_free), NULL);
#line 188 "../gxml/Document.vala"
			_g_free0 (nsp);
#line 188 "../gxml/Document.vala"
			_g_free0 (n);
#line 188 "../gxml/Document.vala"
			return NULL;
#line 1458 "Document.c"
		}
#line 190 "../gxml/Document.vala"
		_tmp5_ = s;
#line 190 "../gxml/Document.vala"
		_tmp5__length1 = s_length1;
#line 190 "../gxml/Document.vala"
		_tmp6_ = _tmp5_[0];
#line 190 "../gxml/Document.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 190 "../gxml/Document.vala"
		_g_free0 (nsp);
#line 190 "../gxml/Document.vala"
		nsp = _tmp7_;
#line 191 "../gxml/Document.vala"
		_tmp8_ = s;
#line 191 "../gxml/Document.vala"
		_tmp8__length1 = s_length1;
#line 191 "../gxml/Document.vala"
		_tmp9_ = _tmp8_[1];
#line 191 "../gxml/Document.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 191 "../gxml/Document.vala"
		_g_free0 (n);
#line 191 "../gxml/Document.vala"
		n = _tmp10_;
#line 185 "../gxml/Document.vala"
		s = (_vala_array_free (s, s_length1, (GDestroyNotify) g_free), NULL);
#line 1486 "Document.c"
	} else {
		gchar* _tmp11_;
#line 193 "../gxml/Document.vala"
		_tmp11_ = g_strdup (qualified_name);
#line 193 "../gxml/Document.vala"
		_g_free0 (n);
#line 193 "../gxml/Document.vala"
		n = _tmp11_;
#line 1495 "Document.c"
	}
#line 194 "../gxml/Document.vala"
	_tmp13_ = nsp;
#line 194 "../gxml/Document.vala"
	if (g_strcmp0 (_tmp13_, "") == 0) {
#line 194 "../gxml/Document.vala"
		_tmp12_ = namespace_uri == NULL;
#line 1503 "Document.c"
	} else {
#line 194 "../gxml/Document.vala"
		_tmp12_ = FALSE;
#line 1507 "Document.c"
	}
#line 194 "../gxml/Document.vala"
	if (_tmp12_) {
#line 1511 "Document.c"
		GError* _tmp14_;
#line 195 "../gxml/Document.vala"
		_tmp14_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_NAMESPACE_ERROR, _ ("Creating a namespaced element with invalid namespace"));
#line 195 "../gxml/Document.vala"
		_inner_error0_ = _tmp14_;
#line 195 "../gxml/Document.vala"
		g_propagate_error (error, _inner_error0_);
#line 195 "../gxml/Document.vala"
		_g_free0 (nsp);
#line 195 "../gxml/Document.vala"
		_g_free0 (n);
#line 195 "../gxml/Document.vala"
		return NULL;
#line 1525 "Document.c"
	}
#line 197 "../gxml/Document.vala"
	_tmp17_ = n;
#line 197 "../gxml/Document.vala"
	if (g_strcmp0 (_tmp17_, "xmlns") == 0) {
#line 197 "../gxml/Document.vala"
		_tmp16_ = TRUE;
#line 1533 "Document.c"
	} else {
		const gchar* _tmp18_;
#line 197 "../gxml/Document.vala"
		_tmp18_ = nsp;
#line 197 "../gxml/Document.vala"
		_tmp16_ = g_strcmp0 (_tmp18_, "xmlns") == 0;
#line 1540 "Document.c"
	}
#line 197 "../gxml/Document.vala"
	if (_tmp16_) {
#line 198 "../gxml/Document.vala"
		_tmp15_ = g_strcmp0 (namespace_uri, "http://www.w3.org/2000/xmlns/") != 0;
#line 1546 "Document.c"
	} else {
#line 197 "../gxml/Document.vala"
		_tmp15_ = FALSE;
#line 1550 "Document.c"
	}
#line 197 "../gxml/Document.vala"
	if (_tmp15_) {
#line 1554 "Document.c"
		GError* _tmp19_;
#line 199 "../gxml/Document.vala"
		_tmp19_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_NAMESPACE_ERROR, _ ("Invalid namespace URI for xmlns prefix. Use http://www.w3.org/2000/xml" \
"ns/"));
#line 199 "../gxml/Document.vala"
		_inner_error0_ = _tmp19_;
#line 199 "../gxml/Document.vala"
		g_propagate_error (error, _inner_error0_);
#line 199 "../gxml/Document.vala"
		_g_free0 (nsp);
#line 199 "../gxml/Document.vala"
		_g_free0 (n);
#line 199 "../gxml/Document.vala"
		return NULL;
#line 1568 "Document.c"
	}
#line 201 "../gxml/Document.vala"
	_tmp22_ = n;
#line 201 "../gxml/Document.vala"
	if (g_strcmp0 (_tmp22_, "xmlns") != 0) {
#line 201 "../gxml/Document.vala"
		_tmp21_ = TRUE;
#line 1576 "Document.c"
	} else {
		const gchar* _tmp23_;
#line 201 "../gxml/Document.vala"
		_tmp23_ = nsp;
#line 201 "../gxml/Document.vala"
		_tmp21_ = g_strcmp0 (_tmp23_, "xmlns") != 0;
#line 1583 "Document.c"
	}
#line 201 "../gxml/Document.vala"
	if (_tmp21_) {
#line 202 "../gxml/Document.vala"
		_tmp20_ = g_strcmp0 (namespace_uri, "http://www.w3.org/2000/xmlns/") == 0;
#line 1589 "Document.c"
	} else {
#line 201 "../gxml/Document.vala"
		_tmp20_ = FALSE;
#line 1593 "Document.c"
	}
#line 201 "../gxml/Document.vala"
	if (_tmp20_) {
#line 1597 "Document.c"
		GError* _tmp24_;
#line 203 "../gxml/Document.vala"
		_tmp24_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_NAMESPACE_ERROR, _ ("Only xmlns prefixs can be used with http://www.w3.org/2000/xmlns/"));
#line 203 "../gxml/Document.vala"
		_inner_error0_ = _tmp24_;
#line 203 "../gxml/Document.vala"
		g_propagate_error (error, _inner_error0_);
#line 203 "../gxml/Document.vala"
		_g_free0 (nsp);
#line 203 "../gxml/Document.vala"
		_g_free0 (n);
#line 203 "../gxml/Document.vala"
		return NULL;
#line 1611 "Document.c"
	}
#line 205 "../gxml/Document.vala"
	_tmp25_ = gxml_element_new ();
#line 205 "../gxml/Document.vala"
	e = _tmp25_;
#line 206 "../gxml/Document.vala"
	_tmp26_ = e;
#line 206 "../gxml/Document.vala"
	_tmp27_ = nsp;
#line 206 "../gxml/Document.vala"
	_tmp28_ = n;
#line 206 "../gxml/Document.vala"
	gxml_element_initialize_document_with_namespace (_tmp26_, (GXmlDomDocument*) self, namespace_uri, _tmp27_, _tmp28_);
#line 207 "../gxml/Document.vala"
	result = (GXmlDomElement*) e;
#line 207 "../gxml/Document.vala"
	_g_free0 (nsp);
#line 207 "../gxml/Document.vala"
	_g_free0 (n);
#line 207 "../gxml/Document.vala"
	return result;
#line 1633 "Document.c"
}

static GXmlDomHTMLCollection*
gxml_document_real_get_elements_by_tag_name (GXmlDomDocument* base,
                                             const gchar* local_name)
{
	GXmlDocument * self;
	GXmlHTMLCollection* l = NULL;
	GXmlHTMLCollection* _tmp0_;
	GXmlDomElement* _tmp1_;
	GXmlDomElement* _tmp2_;
	GXmlDomElement* _tmp3_;
	gboolean _tmp4_;
	GXmlHTMLCollection* _tmp5_;
	GXmlDomElement* _tmp6_;
	GXmlDomElement* _tmp7_;
	GXmlDomElement* _tmp8_;
	GXmlDomHTMLCollection* _tmp9_;
	GXmlDomHTMLCollection* _tmp10_;
	GXmlDomHTMLCollection* result = NULL;
#line 210 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 210 "../gxml/Document.vala"
	g_return_val_if_fail (local_name != NULL, NULL);
#line 211 "../gxml/Document.vala"
	_tmp0_ = gxml_html_collection_new ();
#line 211 "../gxml/Document.vala"
	l = _tmp0_;
#line 212 "../gxml/Document.vala"
	_tmp1_ = gxml_dom_document_get_document_element ((GXmlDomDocument*) self);
#line 212 "../gxml/Document.vala"
	_tmp2_ = _tmp1_;
#line 212 "../gxml/Document.vala"
	_tmp3_ = _tmp2_;
#line 212 "../gxml/Document.vala"
	_tmp4_ = _tmp3_ == NULL;
#line 212 "../gxml/Document.vala"
	_g_object_unref0 (_tmp3_);
#line 212 "../gxml/Document.vala"
	if (_tmp4_) {
#line 212 "../gxml/Document.vala"
		result = (GXmlDomHTMLCollection*) l;
#line 212 "../gxml/Document.vala"
		return result;
#line 1678 "Document.c"
	}
#line 213 "../gxml/Document.vala"
	_tmp5_ = l;
#line 213 "../gxml/Document.vala"
	_tmp6_ = gxml_dom_document_get_document_element ((GXmlDomDocument*) self);
#line 213 "../gxml/Document.vala"
	_tmp7_ = _tmp6_;
#line 213 "../gxml/Document.vala"
	_tmp8_ = _tmp7_;
#line 213 "../gxml/Document.vala"
	_tmp9_ = gxml_dom_element_get_elements_by_tag_name (_tmp8_, local_name);
#line 213 "../gxml/Document.vala"
	_tmp10_ = _tmp9_;
#line 213 "../gxml/Document.vala"
	gee_array_list_add_all ((GeeArrayList*) _tmp5_, (GeeCollection*) _tmp10_);
#line 213 "../gxml/Document.vala"
	_g_object_unref0 (_tmp10_);
#line 213 "../gxml/Document.vala"
	_g_object_unref0 (_tmp8_);
#line 214 "../gxml/Document.vala"
	result = (GXmlDomHTMLCollection*) l;
#line 214 "../gxml/Document.vala"
	return result;
#line 1702 "Document.c"
}

static GXmlDomHTMLCollection*
gxml_document_real_get_elements_by_tag_name_ns (GXmlDomDocument* base,
                                                const gchar* ns,
                                                const gchar* local_name)
{
	GXmlDocument * self;
	GXmlHTMLCollection* l = NULL;
	GXmlHTMLCollection* _tmp0_;
	GXmlDomElement* _tmp1_;
	GXmlDomElement* _tmp2_;
	GXmlDomElement* _tmp3_;
	gboolean _tmp4_;
	GXmlHTMLCollection* _tmp5_;
	GXmlDomElement* _tmp6_;
	GXmlDomElement* _tmp7_;
	GXmlDomElement* _tmp8_;
	GXmlDomHTMLCollection* _tmp9_;
	GXmlDomHTMLCollection* _tmp10_;
	GXmlDomHTMLCollection* result = NULL;
#line 216 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 216 "../gxml/Document.vala"
	g_return_val_if_fail (local_name != NULL, NULL);
#line 217 "../gxml/Document.vala"
	_tmp0_ = gxml_html_collection_new ();
#line 217 "../gxml/Document.vala"
	l = _tmp0_;
#line 218 "../gxml/Document.vala"
	_tmp1_ = gxml_dom_document_get_document_element ((GXmlDomDocument*) self);
#line 218 "../gxml/Document.vala"
	_tmp2_ = _tmp1_;
#line 218 "../gxml/Document.vala"
	_tmp3_ = _tmp2_;
#line 218 "../gxml/Document.vala"
	_tmp4_ = _tmp3_ == NULL;
#line 218 "../gxml/Document.vala"
	_g_object_unref0 (_tmp3_);
#line 218 "../gxml/Document.vala"
	if (_tmp4_) {
#line 218 "../gxml/Document.vala"
		result = (GXmlDomHTMLCollection*) l;
#line 218 "../gxml/Document.vala"
		return result;
#line 1748 "Document.c"
	}
#line 219 "../gxml/Document.vala"
	_tmp5_ = l;
#line 219 "../gxml/Document.vala"
	_tmp6_ = gxml_dom_document_get_document_element ((GXmlDomDocument*) self);
#line 219 "../gxml/Document.vala"
	_tmp7_ = _tmp6_;
#line 219 "../gxml/Document.vala"
	_tmp8_ = _tmp7_;
#line 219 "../gxml/Document.vala"
	_tmp9_ = gxml_dom_element_get_elements_by_tag_name_ns (_tmp8_, ns, local_name);
#line 219 "../gxml/Document.vala"
	_tmp10_ = _tmp9_;
#line 219 "../gxml/Document.vala"
	gee_array_list_add_all ((GeeArrayList*) _tmp5_, (GeeCollection*) _tmp10_);
#line 219 "../gxml/Document.vala"
	_g_object_unref0 (_tmp10_);
#line 219 "../gxml/Document.vala"
	_g_object_unref0 (_tmp8_);
#line 220 "../gxml/Document.vala"
	result = (GXmlDomHTMLCollection*) l;
#line 220 "../gxml/Document.vala"
	return result;
#line 1772 "Document.c"
}

static GXmlDomHTMLCollection*
gxml_document_real_get_elements_by_class_name (GXmlDomDocument* base,
                                               const gchar* class_names)
{
	GXmlDocument * self;
	GXmlHTMLCollection* l = NULL;
	GXmlHTMLCollection* _tmp0_;
	GXmlDomElement* _tmp1_;
	GXmlDomElement* _tmp2_;
	GXmlDomElement* _tmp3_;
	gboolean _tmp4_;
	GXmlHTMLCollection* _tmp5_;
	GXmlDomElement* _tmp6_;
	GXmlDomElement* _tmp7_;
	GXmlDomElement* _tmp8_;
	GXmlDomHTMLCollection* _tmp9_;
	GXmlDomHTMLCollection* _tmp10_;
	GXmlDomHTMLCollection* result = NULL;
#line 222 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 222 "../gxml/Document.vala"
	g_return_val_if_fail (class_names != NULL, NULL);
#line 223 "../gxml/Document.vala"
	_tmp0_ = gxml_html_collection_new ();
#line 223 "../gxml/Document.vala"
	l = _tmp0_;
#line 224 "../gxml/Document.vala"
	_tmp1_ = gxml_dom_document_get_document_element ((GXmlDomDocument*) self);
#line 224 "../gxml/Document.vala"
	_tmp2_ = _tmp1_;
#line 224 "../gxml/Document.vala"
	_tmp3_ = _tmp2_;
#line 224 "../gxml/Document.vala"
	_tmp4_ = _tmp3_ == NULL;
#line 224 "../gxml/Document.vala"
	_g_object_unref0 (_tmp3_);
#line 224 "../gxml/Document.vala"
	if (_tmp4_) {
#line 224 "../gxml/Document.vala"
		result = (GXmlDomHTMLCollection*) l;
#line 224 "../gxml/Document.vala"
		return result;
#line 1817 "Document.c"
	}
#line 225 "../gxml/Document.vala"
	_tmp5_ = l;
#line 225 "../gxml/Document.vala"
	_tmp6_ = gxml_dom_document_get_document_element ((GXmlDomDocument*) self);
#line 225 "../gxml/Document.vala"
	_tmp7_ = _tmp6_;
#line 225 "../gxml/Document.vala"
	_tmp8_ = _tmp7_;
#line 225 "../gxml/Document.vala"
	_tmp9_ = gxml_dom_element_get_elements_by_class_name (_tmp8_, class_names);
#line 225 "../gxml/Document.vala"
	_tmp10_ = _tmp9_;
#line 225 "../gxml/Document.vala"
	gee_array_list_add_all ((GeeArrayList*) _tmp5_, (GeeCollection*) _tmp10_);
#line 225 "../gxml/Document.vala"
	_g_object_unref0 (_tmp10_);
#line 225 "../gxml/Document.vala"
	_g_object_unref0 (_tmp8_);
#line 226 "../gxml/Document.vala"
	result = (GXmlDomHTMLCollection*) l;
#line 226 "../gxml/Document.vala"
	return result;
#line 1841 "Document.c"
}

static GXmlDomDocumentFragment*
gxml_document_real_create_document_fragment (GXmlDomDocument* base)
{
	GXmlDocument * self;
	GXmlDocumentFragment* _tmp0_;
	GXmlDomDocumentFragment* result = NULL;
#line 229 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 230 "../gxml/Document.vala"
	_tmp0_ = gxml_document_fragment_new ((GXmlDomDocument*) self);
#line 230 "../gxml/Document.vala"
	result = (GXmlDomDocumentFragment*) _tmp0_;
#line 230 "../gxml/Document.vala"
	return result;
#line 1858 "Document.c"
}

static GXmlDomText*
gxml_document_real_create_text_node (GXmlDomDocument* base,
                                     const gchar* data,
                                     GError** error)
{
	GXmlDocument * self;
	GXmlText* _tmp0_;
	GXmlDomText* result = NULL;
#line 232 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 232 "../gxml/Document.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 233 "../gxml/Document.vala"
	_tmp0_ = gxml_text_new ((GXmlDomDocument*) self, data);
#line 233 "../gxml/Document.vala"
	result = (GXmlDomText*) _tmp0_;
#line 233 "../gxml/Document.vala"
	return result;
#line 1879 "Document.c"
}

static GXmlDomComment*
gxml_document_real_gxml_dom_document_create_comment (GXmlDomDocument* base,
                                                     const gchar* data,
                                                     GError** error)
{
	GXmlDocument * self;
	GXmlComment* _tmp0_;
	GXmlDomComment* result = NULL;
#line 235 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 235 "../gxml/Document.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 236 "../gxml/Document.vala"
	_tmp0_ = gxml_comment_new ((GXmlDomDocument*) self, data);
#line 236 "../gxml/Document.vala"
	result = (GXmlDomComment*) _tmp0_;
#line 236 "../gxml/Document.vala"
	return result;
#line 1900 "Document.c"
}

static GXmlDomProcessingInstruction*
gxml_document_real_create_processing_instruction (GXmlDomDocument* base,
                                                  const gchar* target,
                                                  const gchar* data,
                                                  GError** error)
{
	GXmlDocument * self;
	GXmlProcessingInstruction* _tmp0_;
	GXmlDomProcessingInstruction* result = NULL;
#line 238 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 238 "../gxml/Document.vala"
	g_return_val_if_fail (target != NULL, NULL);
#line 238 "../gxml/Document.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 239 "../gxml/Document.vala"
	_tmp0_ = gxml_processing_instruction_new ((GXmlDomDocument*) self, target, data);
#line 239 "../gxml/Document.vala"
	result = (GXmlDomProcessingInstruction*) _tmp0_;
#line 239 "../gxml/Document.vala"
	return result;
#line 1924 "Document.c"
}

static GXmlDomNode*
gxml_document_real_import_node (GXmlDomDocument* base,
                                GXmlDomNode* node,
                                gboolean deep,
                                GError** error)
{
	GXmlDocument * self;
	gboolean _tmp1_ = FALSE;
	GXmlDomNode* dst = NULL;
	GXmlDomNode* _tmp45_;
	GXmlDomNode* _tmp52_;
	GError* _inner_error0_ = NULL;
	GXmlDomNode* result = NULL;
#line 242 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 242 "../gxml/Document.vala"
	g_return_val_if_fail (node != NULL, NULL);
#line 243 "../gxml/Document.vala"
	if (GXML_IS_DOM_DOCUMENT (node)) {
#line 1946 "Document.c"
		GError* _tmp0_;
#line 244 "../gxml/Document.vala"
		_tmp0_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_NOT_SUPPORTED_ERROR, _ ("Can't import a Document"));
#line 244 "../gxml/Document.vala"
		_inner_error0_ = _tmp0_;
#line 244 "../gxml/Document.vala"
		g_propagate_error (error, _inner_error0_);
#line 244 "../gxml/Document.vala"
		return NULL;
#line 1956 "Document.c"
	}
#line 245 "../gxml/Document.vala"
	if (!GXML_IS_DOM_ELEMENT (node)) {
#line 1960 "Document.c"
		GXmlDomElement* _tmp2_;
		GXmlDomElement* _tmp3_;
		GXmlDomElement* _tmp4_;
#line 245 "../gxml/Document.vala"
		_tmp2_ = gxml_dom_document_get_document_element ((GXmlDomDocument*) self);
#line 245 "../gxml/Document.vala"
		_tmp3_ = _tmp2_;
#line 245 "../gxml/Document.vala"
		_tmp4_ = _tmp3_;
#line 245 "../gxml/Document.vala"
		_tmp1_ = _tmp4_ == NULL;
#line 245 "../gxml/Document.vala"
		_g_object_unref0 (_tmp4_);
#line 1974 "Document.c"
	} else {
#line 245 "../gxml/Document.vala"
		_tmp1_ = FALSE;
#line 1978 "Document.c"
	}
#line 245 "../gxml/Document.vala"
	if (_tmp1_) {
#line 1982 "Document.c"
		GError* _tmp5_;
#line 246 "../gxml/Document.vala"
		_tmp5_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_HIERARCHY_REQUEST_ERROR, _ ("Can't import a non Element type node to a Document"));
#line 246 "../gxml/Document.vala"
		_inner_error0_ = _tmp5_;
#line 246 "../gxml/Document.vala"
		g_propagate_error (error, _inner_error0_);
#line 246 "../gxml/Document.vala"
		return NULL;
#line 1992 "Document.c"
	}
#line 247 "../gxml/Document.vala"
	dst = NULL;
#line 248 "../gxml/Document.vala"
	if (GXML_IS_DOM_ELEMENT (node)) {
#line 1998 "Document.c"
		GXmlDomElement* _tmp6_ = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GXmlDomElement* _tmp10_;
		GXmlDomElement* _tmp11_;
		GXmlDomElement* _tmp12_;
		GXmlDomNode* _tmp13_;
		GXmlDomElement* _tmp14_;
		GXmlDomElement* _tmp15_;
		GXmlDomElement* _tmp16_;
		gboolean _tmp17_;
#line 249 "../gxml/Document.vala"
		_tmp7_ = gxml_dom_node_get_node_name (node);
#line 249 "../gxml/Document.vala"
		_tmp8_ = _tmp7_;
#line 249 "../gxml/Document.vala"
		_tmp9_ = _tmp8_;
#line 249 "../gxml/Document.vala"
		_tmp10_ = gxml_dom_document_create_element (G_TYPE_CHECK_INSTANCE_CAST (self, GXML_TYPE_DOM_DOCUMENT, GXmlDomDocument), _tmp9_, &_inner_error0_);
#line 249 "../gxml/Document.vala"
		_tmp11_ = _tmp10_;
#line 249 "../gxml/Document.vala"
		_g_free0 (_tmp9_);
#line 249 "../gxml/Document.vala"
		_tmp6_ = _tmp11_;
#line 249 "../gxml/Document.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 249 "../gxml/Document.vala"
			g_propagate_error (error, _inner_error0_);
#line 249 "../gxml/Document.vala"
			_g_object_unref0 (dst);
#line 249 "../gxml/Document.vala"
			return NULL;
#line 2033 "Document.c"
		}
#line 249 "../gxml/Document.vala"
		_tmp12_ = _tmp6_;
#line 249 "../gxml/Document.vala"
		_tmp6_ = NULL;
#line 249 "../gxml/Document.vala"
		_g_object_unref0 (dst);
#line 249 "../gxml/Document.vala"
		dst = (GXmlDomNode*) _tmp12_;
#line 250 "../gxml/Document.vala"
		_tmp13_ = dst;
#line 250 "../gxml/Document.vala"
		gxml_dom_node_copy ((GXmlDomDocument*) self, _tmp13_, node, deep, &_inner_error0_);
#line 250 "../gxml/Document.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 250 "../gxml/Document.vala"
			g_propagate_error (error, _inner_error0_);
#line 250 "../gxml/Document.vala"
			_g_object_unref0 (_tmp6_);
#line 250 "../gxml/Document.vala"
			_g_object_unref0 (dst);
#line 250 "../gxml/Document.vala"
			return NULL;
#line 2057 "Document.c"
		}
#line 251 "../gxml/Document.vala"
		_tmp14_ = gxml_dom_document_get_document_element ((GXmlDomDocument*) self);
#line 251 "../gxml/Document.vala"
		_tmp15_ = _tmp14_;
#line 251 "../gxml/Document.vala"
		_tmp16_ = _tmp15_;
#line 251 "../gxml/Document.vala"
		_tmp17_ = _tmp16_ == NULL;
#line 251 "../gxml/Document.vala"
		_g_object_unref0 (_tmp16_);
#line 251 "../gxml/Document.vala"
		if (_tmp17_) {
#line 2071 "Document.c"
			GXmlDomNode* _tmp18_;
			GXmlDomNode* _tmp19_;
			GXmlDomNode* _tmp20_;
#line 252 "../gxml/Document.vala"
			_tmp18_ = dst;
#line 252 "../gxml/Document.vala"
			_tmp19_ = gxml_dom_node_append_child ((GXmlDomNode*) self, _tmp18_, &_inner_error0_);
#line 252 "../gxml/Document.vala"
			_tmp20_ = _tmp19_;
#line 252 "../gxml/Document.vala"
			_g_object_unref0 (_tmp20_);
#line 252 "../gxml/Document.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 252 "../gxml/Document.vala"
				g_propagate_error (error, _inner_error0_);
#line 252 "../gxml/Document.vala"
				_g_object_unref0 (_tmp6_);
#line 252 "../gxml/Document.vala"
				_g_object_unref0 (dst);
#line 252 "../gxml/Document.vala"
				return NULL;
#line 2093 "Document.c"
			}
#line 253 "../gxml/Document.vala"
			result = dst;
#line 253 "../gxml/Document.vala"
			_g_object_unref0 (_tmp6_);
#line 253 "../gxml/Document.vala"
			return result;
#line 2101 "Document.c"
		}
#line 248 "../gxml/Document.vala"
		_g_object_unref0 (_tmp6_);
#line 2105 "Document.c"
	}
#line 256 "../gxml/Document.vala"
	if (GXML_IS_DOM_TEXT (node)) {
#line 2109 "Document.c"
		GXmlDomText* _tmp21_ = NULL;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		GXmlDomText* _tmp25_;
		GXmlDomText* _tmp26_;
		GXmlDomText* _tmp27_;
#line 257 "../gxml/Document.vala"
		_tmp22_ = gxml_dom_character_data_get_data ((GXmlDomCharacterData*) G_TYPE_CHECK_INSTANCE_CAST (node, GXML_TYPE_DOM_TEXT, GXmlDomText));
#line 257 "../gxml/Document.vala"
		_tmp23_ = _tmp22_;
#line 257 "../gxml/Document.vala"
		_tmp24_ = _tmp23_;
#line 257 "../gxml/Document.vala"
		_tmp25_ = gxml_dom_document_create_text_node ((GXmlDomDocument*) self, _tmp24_, &_inner_error0_);
#line 257 "../gxml/Document.vala"
		_tmp26_ = _tmp25_;
#line 257 "../gxml/Document.vala"
		_g_free0 (_tmp24_);
#line 257 "../gxml/Document.vala"
		_tmp21_ = _tmp26_;
#line 257 "../gxml/Document.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 257 "../gxml/Document.vala"
			g_propagate_error (error, _inner_error0_);
#line 257 "../gxml/Document.vala"
			_g_object_unref0 (dst);
#line 257 "../gxml/Document.vala"
			return NULL;
#line 2139 "Document.c"
		}
#line 257 "../gxml/Document.vala"
		_tmp27_ = _tmp21_;
#line 257 "../gxml/Document.vala"
		_tmp21_ = NULL;
#line 257 "../gxml/Document.vala"
		_g_object_unref0 (dst);
#line 257 "../gxml/Document.vala"
		dst = (GXmlDomNode*) _tmp27_;
#line 256 "../gxml/Document.vala"
		_g_object_unref0 (_tmp21_);
#line 2151 "Document.c"
	}
#line 258 "../gxml/Document.vala"
	if (GXML_IS_DOM_COMMENT (node)) {
#line 2155 "Document.c"
		GXmlDomComment* _tmp28_ = NULL;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		GXmlDomComment* _tmp32_;
		GXmlDomComment* _tmp33_;
		GXmlDomComment* _tmp34_;
#line 259 "../gxml/Document.vala"
		_tmp29_ = gxml_dom_character_data_get_data ((GXmlDomCharacterData*) G_TYPE_CHECK_INSTANCE_CAST (node, GXML_TYPE_DOM_COMMENT, GXmlDomComment));
#line 259 "../gxml/Document.vala"
		_tmp30_ = _tmp29_;
#line 259 "../gxml/Document.vala"
		_tmp31_ = _tmp30_;
#line 259 "../gxml/Document.vala"
		_tmp32_ = gxml_dom_document_create_comment (G_TYPE_CHECK_INSTANCE_CAST (self, GXML_TYPE_DOM_DOCUMENT, GXmlDomDocument), _tmp31_, &_inner_error0_);
#line 259 "../gxml/Document.vala"
		_tmp33_ = _tmp32_;
#line 259 "../gxml/Document.vala"
		_g_free0 (_tmp31_);
#line 259 "../gxml/Document.vala"
		_tmp28_ = _tmp33_;
#line 259 "../gxml/Document.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 259 "../gxml/Document.vala"
			g_propagate_error (error, _inner_error0_);
#line 259 "../gxml/Document.vala"
			_g_object_unref0 (dst);
#line 259 "../gxml/Document.vala"
			return NULL;
#line 2185 "Document.c"
		}
#line 259 "../gxml/Document.vala"
		_tmp34_ = _tmp28_;
#line 259 "../gxml/Document.vala"
		_tmp28_ = NULL;
#line 259 "../gxml/Document.vala"
		_g_object_unref0 (dst);
#line 259 "../gxml/Document.vala"
		dst = (GXmlDomNode*) _tmp34_;
#line 258 "../gxml/Document.vala"
		_g_object_unref0 (_tmp28_);
#line 2197 "Document.c"
	}
#line 260 "../gxml/Document.vala"
	if (GXML_IS_DOM_PROCESSING_INSTRUCTION (node)) {
#line 2201 "Document.c"
		GXmlDomProcessingInstruction* _tmp35_ = NULL;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		GXmlDomProcessingInstruction* _tmp42_;
		GXmlDomProcessingInstruction* _tmp43_;
		GXmlDomProcessingInstruction* _tmp44_;
#line 261 "../gxml/Document.vala"
		_tmp36_ = gxml_dom_processing_instruction_get_target (G_TYPE_CHECK_INSTANCE_CAST (node, GXML_TYPE_DOM_PROCESSING_INSTRUCTION, GXmlDomProcessingInstruction));
#line 261 "../gxml/Document.vala"
		_tmp37_ = _tmp36_;
#line 261 "../gxml/Document.vala"
		_tmp38_ = _tmp37_;
#line 261 "../gxml/Document.vala"
		_tmp39_ = gxml_dom_character_data_get_data ((GXmlDomCharacterData*) G_TYPE_CHECK_INSTANCE_CAST (node, GXML_TYPE_DOM_PROCESSING_INSTRUCTION, GXmlDomProcessingInstruction));
#line 261 "../gxml/Document.vala"
		_tmp40_ = _tmp39_;
#line 261 "../gxml/Document.vala"
		_tmp41_ = _tmp40_;
#line 261 "../gxml/Document.vala"
		_tmp42_ = gxml_dom_document_create_processing_instruction ((GXmlDomDocument*) self, _tmp38_, _tmp41_, &_inner_error0_);
#line 261 "../gxml/Document.vala"
		_tmp43_ = _tmp42_;
#line 261 "../gxml/Document.vala"
		_g_free0 (_tmp41_);
#line 261 "../gxml/Document.vala"
		_g_free0 (_tmp38_);
#line 261 "../gxml/Document.vala"
		_tmp35_ = _tmp43_;
#line 261 "../gxml/Document.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 261 "../gxml/Document.vala"
			g_propagate_error (error, _inner_error0_);
#line 261 "../gxml/Document.vala"
			_g_object_unref0 (dst);
#line 261 "../gxml/Document.vala"
			return NULL;
#line 2242 "Document.c"
		}
#line 261 "../gxml/Document.vala"
		_tmp44_ = _tmp35_;
#line 261 "../gxml/Document.vala"
		_tmp35_ = NULL;
#line 261 "../gxml/Document.vala"
		_g_object_unref0 (dst);
#line 261 "../gxml/Document.vala"
		dst = (GXmlDomNode*) _tmp44_;
#line 260 "../gxml/Document.vala"
		_g_object_unref0 (_tmp35_);
#line 2254 "Document.c"
	}
#line 262 "../gxml/Document.vala"
	_tmp45_ = dst;
#line 262 "../gxml/Document.vala"
	if (_tmp45_ != NULL) {
#line 2260 "Document.c"
		GXmlDomElement* _tmp46_;
		GXmlDomElement* _tmp47_;
		GXmlDomElement* _tmp48_;
		GXmlDomNode* _tmp49_;
		GXmlDomNode* _tmp50_;
		GXmlDomNode* _tmp51_;
#line 263 "../gxml/Document.vala"
		_tmp46_ = gxml_dom_document_get_document_element ((GXmlDomDocument*) self);
#line 263 "../gxml/Document.vala"
		_tmp47_ = _tmp46_;
#line 263 "../gxml/Document.vala"
		_tmp48_ = _tmp47_;
#line 263 "../gxml/Document.vala"
		_tmp49_ = dst;
#line 263 "../gxml/Document.vala"
		_tmp50_ = gxml_dom_node_append_child ((GXmlDomNode*) _tmp48_, GXML_IS_DOM_NODE (_tmp49_) ? ((GXmlDomNode*) _tmp49_) : NULL, &_inner_error0_);
#line 263 "../gxml/Document.vala"
		_tmp51_ = _tmp50_;
#line 263 "../gxml/Document.vala"
		_g_object_unref0 (_tmp51_);
#line 263 "../gxml/Document.vala"
		_g_object_unref0 (_tmp48_);
#line 263 "../gxml/Document.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 263 "../gxml/Document.vala"
			g_propagate_error (error, _inner_error0_);
#line 263 "../gxml/Document.vala"
			_g_object_unref0 (dst);
#line 263 "../gxml/Document.vala"
			return NULL;
#line 2291 "Document.c"
		}
#line 264 "../gxml/Document.vala"
		result = dst;
#line 264 "../gxml/Document.vala"
		return result;
#line 2297 "Document.c"
	}
#line 266 "../gxml/Document.vala"
	_tmp52_ = _g_object_ref0 (node);
#line 266 "../gxml/Document.vala"
	result = _tmp52_;
#line 266 "../gxml/Document.vala"
	_g_object_unref0 (dst);
#line 266 "../gxml/Document.vala"
	return result;
#line 2307 "Document.c"
}

static GXmlDomNode*
gxml_document_real_adopt_node (GXmlDomDocument* base,
                               GXmlDomNode* node,
                               GError** error)
{
	GXmlDocument * self;
	GXmlDomDocument* _tmp1_;
	GXmlDomDocument* _tmp2_;
	GXmlDomElement* dst = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GXmlDomElement* _tmp7_;
	GXmlDomElement* _tmp8_;
	GXmlDomElement* _tmp9_;
	GXmlDomNode* _tmp10_;
	GXmlDomNode* _tmp11_;
	GXmlDomNode* _tmp12_;
	gboolean _tmp13_;
	GXmlDomElement* _tmp28_;
	GXmlDomElement* _tmp29_;
	GXmlDomElement* _tmp30_;
	gboolean _tmp31_;
	GXmlDomElement* _tmp41_;
	GXmlDomNode* _tmp42_;
	GError* _inner_error0_ = NULL;
	GXmlDomNode* result = NULL;
#line 268 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 268 "../gxml/Document.vala"
	g_return_val_if_fail (node != NULL, NULL);
#line 269 "../gxml/Document.vala"
	if (GXML_IS_DOM_DOCUMENT (node)) {
#line 2343 "Document.c"
		GError* _tmp0_;
#line 270 "../gxml/Document.vala"
		_tmp0_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_NOT_SUPPORTED_ERROR, _ ("Can't adopt a Document"));
#line 270 "../gxml/Document.vala"
		_inner_error0_ = _tmp0_;
#line 270 "../gxml/Document.vala"
		g_propagate_error (error, _inner_error0_);
#line 270 "../gxml/Document.vala"
		return NULL;
#line 2353 "Document.c"
	}
#line 271 "../gxml/Document.vala"
	_tmp1_ = gxml_dom_node_get_owner_document (node);
#line 271 "../gxml/Document.vala"
	_tmp2_ = _tmp1_;
#line 271 "../gxml/Document.vala"
	if (G_TYPE_CHECK_INSTANCE_CAST (self, GXML_TYPE_DOM_DOCUMENT, GXmlDomDocument) == _tmp2_) {
#line 2361 "Document.c"
		GXmlDomNode* _tmp3_;
#line 271 "../gxml/Document.vala"
		_tmp3_ = _g_object_ref0 (node);
#line 271 "../gxml/Document.vala"
		result = _tmp3_;
#line 271 "../gxml/Document.vala"
		return result;
#line 2369 "Document.c"
	}
#line 272 "../gxml/Document.vala"
	_tmp4_ = gxml_dom_node_get_node_name (node);
#line 272 "../gxml/Document.vala"
	_tmp5_ = _tmp4_;
#line 272 "../gxml/Document.vala"
	_tmp6_ = _tmp5_;
#line 272 "../gxml/Document.vala"
	_tmp7_ = gxml_dom_document_create_element ((GXmlDomDocument*) self, _tmp6_, &_inner_error0_);
#line 272 "../gxml/Document.vala"
	_tmp8_ = _tmp7_;
#line 272 "../gxml/Document.vala"
	_g_free0 (_tmp6_);
#line 272 "../gxml/Document.vala"
	dst = _tmp8_;
#line 272 "../gxml/Document.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 272 "../gxml/Document.vala"
		g_propagate_error (error, _inner_error0_);
#line 272 "../gxml/Document.vala"
		return NULL;
#line 2391 "Document.c"
	}
#line 273 "../gxml/Document.vala"
	_tmp9_ = dst;
#line 273 "../gxml/Document.vala"
	gxml_dom_node_copy ((GXmlDomDocument*) self, (GXmlDomNode*) _tmp9_, node, TRUE, &_inner_error0_);
#line 273 "../gxml/Document.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 273 "../gxml/Document.vala"
		g_propagate_error (error, _inner_error0_);
#line 273 "../gxml/Document.vala"
		_g_object_unref0 (dst);
#line 273 "../gxml/Document.vala"
		return NULL;
#line 2405 "Document.c"
	}
#line 274 "../gxml/Document.vala"
	_tmp10_ = gxml_dom_node_get_parent_node (node);
#line 274 "../gxml/Document.vala"
	_tmp11_ = _tmp10_;
#line 274 "../gxml/Document.vala"
	_tmp12_ = _tmp11_;
#line 274 "../gxml/Document.vala"
	_tmp13_ = _tmp12_ != NULL;
#line 274 "../gxml/Document.vala"
	_g_object_unref0 (_tmp12_);
#line 274 "../gxml/Document.vala"
	if (_tmp13_) {
#line 2419 "Document.c"
		GXmlDomNode* _tmp14_;
		GXmlDomNode* _tmp15_;
		GXmlDomNode* _tmp16_;
		GXmlDomNodeList* _tmp17_;
		GXmlDomNodeList* _tmp18_;
		GXmlDomNodeList* _tmp19_;
		GXmlDomNode* _tmp20_;
		GXmlDomNode* _tmp21_;
		GXmlDomNode* _tmp22_;
		GXmlDomNodeList* _tmp23_;
		GXmlDomNodeList* _tmp24_;
		GXmlDomNodeList* _tmp25_;
		gpointer _tmp26_;
		GXmlDomNode* _tmp27_;
#line 275 "../gxml/Document.vala"
		_tmp14_ = gxml_dom_node_get_parent_node (node);
#line 275 "../gxml/Document.vala"
		_tmp15_ = _tmp14_;
#line 275 "../gxml/Document.vala"
		_tmp16_ = _tmp15_;
#line 275 "../gxml/Document.vala"
		_tmp17_ = gxml_dom_node_get_child_nodes (_tmp16_);
#line 275 "../gxml/Document.vala"
		_tmp18_ = _tmp17_;
#line 275 "../gxml/Document.vala"
		_tmp19_ = _tmp18_;
#line 275 "../gxml/Document.vala"
		_tmp20_ = gxml_dom_node_get_parent_node (node);
#line 275 "../gxml/Document.vala"
		_tmp21_ = _tmp20_;
#line 275 "../gxml/Document.vala"
		_tmp22_ = _tmp21_;
#line 275 "../gxml/Document.vala"
		_tmp23_ = gxml_dom_node_get_child_nodes (_tmp22_);
#line 275 "../gxml/Document.vala"
		_tmp24_ = _tmp23_;
#line 275 "../gxml/Document.vala"
		_tmp25_ = _tmp24_;
#line 275 "../gxml/Document.vala"
		_tmp26_ = gee_list_remove_at ((GeeList*) _tmp19_, gee_list_index_of ((GeeList*) _tmp25_, node));
#line 275 "../gxml/Document.vala"
		_tmp27_ = (GXmlDomNode*) _tmp26_;
#line 275 "../gxml/Document.vala"
		_g_object_unref0 (_tmp27_);
#line 275 "../gxml/Document.vala"
		_g_object_unref0 (_tmp25_);
#line 275 "../gxml/Document.vala"
		_g_object_unref0 (_tmp22_);
#line 275 "../gxml/Document.vala"
		_g_object_unref0 (_tmp19_);
#line 275 "../gxml/Document.vala"
		_g_object_unref0 (_tmp16_);
#line 2472 "Document.c"
	}
#line 276 "../gxml/Document.vala"
	_tmp28_ = gxml_dom_document_get_document_element ((GXmlDomDocument*) self);
#line 276 "../gxml/Document.vala"
	_tmp29_ = _tmp28_;
#line 276 "../gxml/Document.vala"
	_tmp30_ = _tmp29_;
#line 276 "../gxml/Document.vala"
	_tmp31_ = _tmp30_ == NULL;
#line 276 "../gxml/Document.vala"
	_g_object_unref0 (_tmp30_);
#line 276 "../gxml/Document.vala"
	if (_tmp31_) {
#line 2486 "Document.c"
		GXmlDomElement* _tmp32_;
		GXmlDomNode* _tmp33_;
		GXmlDomNode* _tmp34_;
#line 277 "../gxml/Document.vala"
		_tmp32_ = dst;
#line 277 "../gxml/Document.vala"
		_tmp33_ = gxml_dom_node_append_child ((GXmlDomNode*) self, GXML_IS_DOM_NODE (_tmp32_) ? ((GXmlDomNode*) _tmp32_) : NULL, &_inner_error0_);
#line 277 "../gxml/Document.vala"
		_tmp34_ = _tmp33_;
#line 277 "../gxml/Document.vala"
		_g_object_unref0 (_tmp34_);
#line 277 "../gxml/Document.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 277 "../gxml/Document.vala"
			g_propagate_error (error, _inner_error0_);
#line 277 "../gxml/Document.vala"
			_g_object_unref0 (dst);
#line 277 "../gxml/Document.vala"
			return NULL;
#line 2506 "Document.c"
		}
	} else {
		GXmlDomElement* _tmp35_;
		GXmlDomElement* _tmp36_;
		GXmlDomElement* _tmp37_;
		GXmlDomElement* _tmp38_;
		GXmlDomNode* _tmp39_;
		GXmlDomNode* _tmp40_;
#line 279 "../gxml/Document.vala"
		_tmp35_ = gxml_dom_document_get_document_element ((GXmlDomDocument*) self);
#line 279 "../gxml/Document.vala"
		_tmp36_ = _tmp35_;
#line 279 "../gxml/Document.vala"
		_tmp37_ = _tmp36_;
#line 279 "../gxml/Document.vala"
		_tmp38_ = dst;
#line 279 "../gxml/Document.vala"
		_tmp39_ = gxml_dom_node_append_child ((GXmlDomNode*) _tmp37_, GXML_IS_DOM_NODE (_tmp38_) ? ((GXmlDomNode*) _tmp38_) : NULL, &_inner_error0_);
#line 279 "../gxml/Document.vala"
		_tmp40_ = _tmp39_;
#line 279 "../gxml/Document.vala"
		_g_object_unref0 (_tmp40_);
#line 279 "../gxml/Document.vala"
		_g_object_unref0 (_tmp37_);
#line 279 "../gxml/Document.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 279 "../gxml/Document.vala"
			g_propagate_error (error, _inner_error0_);
#line 279 "../gxml/Document.vala"
			_g_object_unref0 (dst);
#line 279 "../gxml/Document.vala"
			return NULL;
#line 2539 "Document.c"
		}
	}
#line 280 "../gxml/Document.vala"
	_tmp41_ = dst;
#line 280 "../gxml/Document.vala"
	_tmp42_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, GXML_TYPE_DOM_NODE, GXmlDomNode));
#line 280 "../gxml/Document.vala"
	result = _tmp42_;
#line 280 "../gxml/Document.vala"
	_g_object_unref0 (dst);
#line 280 "../gxml/Document.vala"
	return result;
#line 2552 "Document.c"
}

static GXmlDomEvent*
gxml_document_real_create_event (GXmlDomDocument* base,
                                 const gchar* iface,
                                 GError** error)
{
	GXmlDocument * self;
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp3_;
	const gchar* _tmp5_;
	const gchar* _tmp7_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	GXmlDomEvent* _tmp17_;
	GXmlDomEvent* _tmp18_;
	GXmlDomEvent* result = NULL;
#line 283 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 283 "../gxml/Document.vala"
	g_return_val_if_fail (iface != NULL, NULL);
#line 284 "../gxml/Document.vala"
	_tmp0_ = g_utf8_strdown (iface, (gssize) -1);
#line 284 "../gxml/Document.vala"
	s = _tmp0_;
#line 285 "../gxml/Document.vala"
	_tmp1_ = s;
#line 285 "../gxml/Document.vala"
	if (g_strcmp0 (_tmp1_, "customevent") == 0) {
#line 2590 "Document.c"
		GXmlCustomEvent* _tmp2_;
#line 285 "../gxml/Document.vala"
		_tmp2_ = gxml_custom_event_new ();
#line 285 "../gxml/Document.vala"
		_g_object_unref0 (self->_constructor);
#line 285 "../gxml/Document.vala"
		self->_constructor = (GXmlDomEvent*) _tmp2_;
#line 2598 "Document.c"
	}
#line 286 "../gxml/Document.vala"
	_tmp3_ = s;
#line 286 "../gxml/Document.vala"
	if (g_strcmp0 (_tmp3_, "event") == 0) {
#line 2604 "Document.c"
		GXmlCustomEvent* _tmp4_;
#line 286 "../gxml/Document.vala"
		_tmp4_ = gxml_custom_event_new ();
#line 286 "../gxml/Document.vala"
		_g_object_unref0 (self->_constructor);
#line 286 "../gxml/Document.vala"
		self->_constructor = (GXmlDomEvent*) _tmp4_;
#line 2612 "Document.c"
	}
#line 287 "../gxml/Document.vala"
	_tmp5_ = s;
#line 287 "../gxml/Document.vala"
	if (g_strcmp0 (_tmp5_, "events") == 0) {
#line 2618 "Document.c"
		GXmlCustomEvent* _tmp6_;
#line 287 "../gxml/Document.vala"
		_tmp6_ = gxml_custom_event_new ();
#line 287 "../gxml/Document.vala"
		_g_object_unref0 (self->_constructor);
#line 287 "../gxml/Document.vala"
		self->_constructor = (GXmlDomEvent*) _tmp6_;
#line 2626 "Document.c"
	}
#line 288 "../gxml/Document.vala"
	_tmp7_ = s;
#line 288 "../gxml/Document.vala"
	if (g_strcmp0 (_tmp7_, "htmlevents") == 0) {
#line 2632 "Document.c"
		GXmlCustomEvent* _tmp8_;
#line 288 "../gxml/Document.vala"
		_tmp8_ = gxml_custom_event_new ();
#line 288 "../gxml/Document.vala"
		_g_object_unref0 (self->_constructor);
#line 288 "../gxml/Document.vala"
		self->_constructor = (GXmlDomEvent*) _tmp8_;
#line 2640 "Document.c"
	}
#line 289 "../gxml/Document.vala"
	_tmp9_ = s;
#line 289 "../gxml/Document.vala"
	if (g_strcmp0 (_tmp9_, "keyboardevent") == 0) {
#line 289 "../gxml/Document.vala"
		_g_object_unref0 (self->_constructor);
#line 289 "../gxml/Document.vala"
		self->_constructor = NULL;
#line 2650 "Document.c"
	}
#line 290 "../gxml/Document.vala"
	_tmp10_ = s;
#line 290 "../gxml/Document.vala"
	if (g_strcmp0 (_tmp10_, "keyevents") == 0) {
#line 290 "../gxml/Document.vala"
		_g_object_unref0 (self->_constructor);
#line 290 "../gxml/Document.vala"
		self->_constructor = NULL;
#line 2660 "Document.c"
	}
#line 291 "../gxml/Document.vala"
	_tmp11_ = s;
#line 291 "../gxml/Document.vala"
	if (g_strcmp0 (_tmp11_, "messageevent") == 0) {
#line 291 "../gxml/Document.vala"
		_g_object_unref0 (self->_constructor);
#line 291 "../gxml/Document.vala"
		self->_constructor = NULL;
#line 2670 "Document.c"
	}
#line 292 "../gxml/Document.vala"
	_tmp12_ = s;
#line 292 "../gxml/Document.vala"
	if (g_strcmp0 (_tmp12_, "mouseevent") == 0) {
#line 292 "../gxml/Document.vala"
		_g_object_unref0 (self->_constructor);
#line 292 "../gxml/Document.vala"
		self->_constructor = NULL;
#line 2680 "Document.c"
	}
#line 293 "../gxml/Document.vala"
	_tmp13_ = s;
#line 293 "../gxml/Document.vala"
	if (g_strcmp0 (_tmp13_, "mouseevents") == 0) {
#line 293 "../gxml/Document.vala"
		_g_object_unref0 (self->_constructor);
#line 293 "../gxml/Document.vala"
		self->_constructor = NULL;
#line 2690 "Document.c"
	}
#line 294 "../gxml/Document.vala"
	_tmp14_ = s;
#line 294 "../gxml/Document.vala"
	if (g_strcmp0 (_tmp14_, "touchevent") == 0) {
#line 294 "../gxml/Document.vala"
		_g_object_unref0 (self->_constructor);
#line 294 "../gxml/Document.vala"
		self->_constructor = NULL;
#line 2700 "Document.c"
	}
#line 295 "../gxml/Document.vala"
	_tmp15_ = s;
#line 295 "../gxml/Document.vala"
	if (g_strcmp0 (_tmp15_, "uievent") == 0) {
#line 295 "../gxml/Document.vala"
		_g_object_unref0 (self->_constructor);
#line 295 "../gxml/Document.vala"
		self->_constructor = NULL;
#line 2710 "Document.c"
	}
#line 296 "../gxml/Document.vala"
	_tmp16_ = s;
#line 296 "../gxml/Document.vala"
	if (g_strcmp0 (_tmp16_, "uievents") == 0) {
#line 296 "../gxml/Document.vala"
		_g_object_unref0 (self->_constructor);
#line 296 "../gxml/Document.vala"
		self->_constructor = NULL;
#line 2720 "Document.c"
	}
#line 297 "../gxml/Document.vala"
	_tmp17_ = self->_constructor;
#line 297 "../gxml/Document.vala"
	_tmp18_ = _g_object_ref0 (_tmp17_);
#line 297 "../gxml/Document.vala"
	result = _tmp18_;
#line 297 "../gxml/Document.vala"
	_g_free0 (s);
#line 297 "../gxml/Document.vala"
	return result;
#line 2732 "Document.c"
}

static GXmlDomRange*
gxml_document_real_create_range (GXmlDomDocument* base)
{
	GXmlDocument * self;
	GXmlRange* _tmp0_;
	GXmlDomRange* result = NULL;
#line 300 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 301 "../gxml/Document.vala"
	_tmp0_ = gxml_range_new ((GXmlDomDocument*) self);
#line 301 "../gxml/Document.vala"
	result = (GXmlDomRange*) _tmp0_;
#line 301 "../gxml/Document.vala"
	return result;
#line 2749 "Document.c"
}

static GXmlDomNodeIterator*
gxml_document_real_create_node_iterator (GXmlDomDocument* base,
                                         GXmlDomNode* root,
                                         gint what_to_show)
{
	GXmlDocument * self;
	GXmlNodeIterator* _tmp0_;
	GXmlDomNodeIterator* result = NULL;
#line 305 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 305 "../gxml/Document.vala"
	g_return_val_if_fail (root != NULL, NULL);
#line 307 "../gxml/Document.vala"
	_tmp0_ = gxml_node_iterator_new (root, what_to_show);
#line 307 "../gxml/Document.vala"
	result = (GXmlDomNodeIterator*) _tmp0_;
#line 307 "../gxml/Document.vala"
	return result;
#line 2770 "Document.c"
}

static GXmlDomTreeWalker*
gxml_document_real_create_tree_walker (GXmlDomDocument* base,
                                       GXmlDomNode* root,
                                       gint what_to_show)
{
	GXmlDocument * self;
	GXmlTreeWalker* _tmp0_;
	GXmlDomTreeWalker* result = NULL;
#line 309 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 309 "../gxml/Document.vala"
	g_return_val_if_fail (root != NULL, NULL);
#line 310 "../gxml/Document.vala"
	_tmp0_ = gxml_tree_walker_new (root, what_to_show);
#line 310 "../gxml/Document.vala"
	result = (GXmlDomTreeWalker*) _tmp0_;
#line 310 "../gxml/Document.vala"
	return result;
#line 2791 "Document.c"
}

static GXmlDomHTMLCollection*
gxml_document_real_get_children (GXmlDomParentNode* base)
{
	GXmlDomHTMLCollection* result;
	GXmlDocument* self;
	GXmlHTMLCollection* l = NULL;
	GXmlHTMLCollection* _tmp0_;
#line 314 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 315 "../gxml/Document.vala"
	_tmp0_ = gxml_html_collection_new ();
#line 315 "../gxml/Document.vala"
	l = _tmp0_;
#line 2807 "Document.c"
	{
		GXmlDomNodeList* _n_list = NULL;
		GXmlDomNodeList* _tmp1_;
		GXmlDomNodeList* _tmp2_;
		gint _n_size = 0;
		GXmlDomNodeList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _n_index = 0;
#line 316 "../gxml/Document.vala"
		_tmp1_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 316 "../gxml/Document.vala"
		_tmp2_ = _tmp1_;
#line 316 "../gxml/Document.vala"
		_n_list = _tmp2_;
#line 316 "../gxml/Document.vala"
		_tmp3_ = _n_list;
#line 316 "../gxml/Document.vala"
		_tmp4_ = gee_collection_get_size ((GeeCollection*) _tmp3_);
#line 316 "../gxml/Document.vala"
		_tmp5_ = _tmp4_;
#line 316 "../gxml/Document.vala"
		_n_size = _tmp5_;
#line 316 "../gxml/Document.vala"
		_n_index = -1;
#line 316 "../gxml/Document.vala"
		while (TRUE) {
#line 2835 "Document.c"
			gint _tmp6_;
			gint _tmp7_;
			GXmlDomNode* n = NULL;
			GXmlDomNodeList* _tmp8_;
			gpointer _tmp9_;
			GXmlDomNode* _tmp10_;
#line 316 "../gxml/Document.vala"
			_n_index = _n_index + 1;
#line 316 "../gxml/Document.vala"
			_tmp6_ = _n_index;
#line 316 "../gxml/Document.vala"
			_tmp7_ = _n_size;
#line 316 "../gxml/Document.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 316 "../gxml/Document.vala"
				break;
#line 2852 "Document.c"
			}
#line 316 "../gxml/Document.vala"
			_tmp8_ = _n_list;
#line 316 "../gxml/Document.vala"
			_tmp9_ = gee_list_get ((GeeList*) _tmp8_, _n_index);
#line 316 "../gxml/Document.vala"
			n = (GXmlDomNode*) _tmp9_;
#line 317 "../gxml/Document.vala"
			_tmp10_ = n;
#line 317 "../gxml/Document.vala"
			if (GXML_IS_DOM_ELEMENT (_tmp10_)) {
#line 2864 "Document.c"
				GXmlHTMLCollection* _tmp11_;
				GXmlDomNode* _tmp12_;
#line 317 "../gxml/Document.vala"
				_tmp11_ = l;
#line 317 "../gxml/Document.vala"
				_tmp12_ = n;
#line 317 "../gxml/Document.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GXML_TYPE_DOM_ELEMENT, GXmlDomElement));
#line 2873 "Document.c"
			}
#line 316 "../gxml/Document.vala"
			_g_object_unref0 (n);
#line 2877 "Document.c"
		}
#line 316 "../gxml/Document.vala"
		_g_object_unref0 (_n_list);
#line 2881 "Document.c"
	}
#line 319 "../gxml/Document.vala"
	result = (GXmlDomHTMLCollection*) l;
#line 319 "../gxml/Document.vala"
	return result;
#line 2887 "Document.c"
}

static GXmlDomElement*
gxml_document_real_get_first_element_child (GXmlDomParentNode* base)
{
	GXmlDomElement* result;
	GXmlDocument* self;
	GXmlDomNodeList* _tmp0_;
	GXmlDomNodeList* _tmp1_;
	GXmlDomNodeList* _tmp2_;
	gpointer _tmp3_;
	GXmlDomElement* _tmp4_;
#line 323 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 323 "../gxml/Document.vala"
	_tmp0_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 323 "../gxml/Document.vala"
	_tmp1_ = _tmp0_;
#line 323 "../gxml/Document.vala"
	_tmp2_ = _tmp1_;
#line 323 "../gxml/Document.vala"
	_tmp3_ = gee_list_first ((GeeList*) _tmp2_);
#line 323 "../gxml/Document.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST ((GXmlDomNode*) _tmp3_, GXML_TYPE_DOM_ELEMENT, GXmlDomElement);
#line 323 "../gxml/Document.vala"
	_g_object_unref0 (_tmp2_);
#line 323 "../gxml/Document.vala"
	result = _tmp4_;
#line 323 "../gxml/Document.vala"
	return result;
#line 2918 "Document.c"
}

static GXmlDomElement*
gxml_document_real_get_last_element_child (GXmlDomParentNode* base)
{
	GXmlDomElement* result;
	GXmlDocument* self;
	GXmlDomNodeList* _tmp0_;
	GXmlDomNodeList* _tmp1_;
	GXmlDomNodeList* _tmp2_;
	gpointer _tmp3_;
	GXmlDomElement* _tmp4_;
#line 326 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 326 "../gxml/Document.vala"
	_tmp0_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 326 "../gxml/Document.vala"
	_tmp1_ = _tmp0_;
#line 326 "../gxml/Document.vala"
	_tmp2_ = _tmp1_;
#line 326 "../gxml/Document.vala"
	_tmp3_ = gee_list_last ((GeeList*) _tmp2_);
#line 326 "../gxml/Document.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST ((GXmlDomNode*) _tmp3_, GXML_TYPE_DOM_ELEMENT, GXmlDomElement);
#line 326 "../gxml/Document.vala"
	_g_object_unref0 (_tmp2_);
#line 326 "../gxml/Document.vala"
	result = _tmp4_;
#line 326 "../gxml/Document.vala"
	return result;
#line 2949 "Document.c"
}

static gint
gxml_document_real_get_child_element_count (GXmlDomParentNode* base)
{
	gint result;
	GXmlDocument* self;
	GXmlDomNodeList* _tmp0_;
	GXmlDomNodeList* _tmp1_;
	GXmlDomNodeList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 328 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 328 "../gxml/Document.vala"
	_tmp0_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 328 "../gxml/Document.vala"
	_tmp1_ = _tmp0_;
#line 328 "../gxml/Document.vala"
	_tmp2_ = _tmp1_;
#line 328 "../gxml/Document.vala"
	_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 328 "../gxml/Document.vala"
	_tmp4_ = _tmp3_;
#line 328 "../gxml/Document.vala"
	_tmp5_ = _tmp4_;
#line 328 "../gxml/Document.vala"
	_g_object_unref0 (_tmp2_);
#line 328 "../gxml/Document.vala"
	result = _tmp5_;
#line 328 "../gxml/Document.vala"
	return result;
#line 2983 "Document.c"
}

static GXmlDomNodeList*
gxml_document_real_query_selector_all (GXmlDomParentNode* base,
                                       const gchar* selectors,
                                       GError** error)
{
	GXmlDocument * self;
	GXmlCssSelectorParser* cs = NULL;
	GXmlCssSelectorParser* _tmp0_;
	GXmlCssSelectorParser* _tmp1_;
	GXmlNodeList* l = NULL;
	GXmlNodeList* _tmp2_;
	GError* _inner_error0_ = NULL;
	GXmlDomNodeList* result = NULL;
#line 330 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 330 "../gxml/Document.vala"
	g_return_val_if_fail (selectors != NULL, NULL);
#line 331 "../gxml/Document.vala"
	_tmp0_ = gxml_css_selector_parser_new ();
#line 331 "../gxml/Document.vala"
	cs = _tmp0_;
#line 332 "../gxml/Document.vala"
	_tmp1_ = cs;
#line 332 "../gxml/Document.vala"
	gxml_css_selector_parser_parse (_tmp1_, selectors, &_inner_error0_);
#line 332 "../gxml/Document.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 332 "../gxml/Document.vala"
		g_propagate_error (error, _inner_error0_);
#line 332 "../gxml/Document.vala"
		_g_object_unref0 (cs);
#line 332 "../gxml/Document.vala"
		return NULL;
#line 3019 "Document.c"
	}
#line 333 "../gxml/Document.vala"
	_tmp2_ = gxml_node_list_new ();
#line 333 "../gxml/Document.vala"
	l = _tmp2_;
#line 3025 "Document.c"
	{
		GXmlDomNodeList* _e_list = NULL;
		GXmlDomNodeList* _tmp3_;
		GXmlDomNodeList* _tmp4_;
		gint _e_size = 0;
		GXmlDomNodeList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _e_index = 0;
#line 334 "../gxml/Document.vala"
		_tmp3_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 334 "../gxml/Document.vala"
		_tmp4_ = _tmp3_;
#line 334 "../gxml/Document.vala"
		_e_list = _tmp4_;
#line 334 "../gxml/Document.vala"
		_tmp5_ = _e_list;
#line 334 "../gxml/Document.vala"
		_tmp6_ = gee_collection_get_size ((GeeCollection*) _tmp5_);
#line 334 "../gxml/Document.vala"
		_tmp7_ = _tmp6_;
#line 334 "../gxml/Document.vala"
		_e_size = _tmp7_;
#line 334 "../gxml/Document.vala"
		_e_index = -1;
#line 334 "../gxml/Document.vala"
		while (TRUE) {
#line 3053 "Document.c"
			gint _tmp8_;
			gint _tmp9_;
			GXmlDomNode* e = NULL;
			GXmlDomNodeList* _tmp10_;
			gpointer _tmp11_;
			GXmlDomNode* _tmp12_;
			gboolean _tmp13_ = FALSE;
			GXmlCssSelectorParser* _tmp14_;
			GXmlDomNode* _tmp15_;
			GXmlDomNodeList* _tmp18_ = NULL;
			GXmlCssSelectorParser* _tmp19_;
			GXmlDomNode* _tmp20_;
			GXmlDomNodeList* _tmp21_;
			GXmlNodeList* _tmp22_;
#line 334 "../gxml/Document.vala"
			_e_index = _e_index + 1;
#line 334 "../gxml/Document.vala"
			_tmp8_ = _e_index;
#line 334 "../gxml/Document.vala"
			_tmp9_ = _e_size;
#line 334 "../gxml/Document.vala"
			if (!(_tmp8_ < _tmp9_)) {
#line 334 "../gxml/Document.vala"
				break;
#line 3078 "Document.c"
			}
#line 334 "../gxml/Document.vala"
			_tmp10_ = _e_list;
#line 334 "../gxml/Document.vala"
			_tmp11_ = gee_list_get ((GeeList*) _tmp10_, _e_index);
#line 334 "../gxml/Document.vala"
			e = (GXmlDomNode*) _tmp11_;
#line 335 "../gxml/Document.vala"
			_tmp12_ = e;
#line 335 "../gxml/Document.vala"
			if (!GXML_IS_DOM_ELEMENT (_tmp12_)) {
#line 335 "../gxml/Document.vala"
				_g_object_unref0 (e);
#line 335 "../gxml/Document.vala"
				continue;
#line 3094 "Document.c"
			}
#line 336 "../gxml/Document.vala"
			_tmp14_ = cs;
#line 336 "../gxml/Document.vala"
			_tmp15_ = e;
#line 336 "../gxml/Document.vala"
			_tmp13_ = gxml_css_selector_parser_match (_tmp14_, GXML_IS_DOM_ELEMENT (_tmp15_) ? ((GXmlDomElement*) _tmp15_) : NULL, &_inner_error0_);
#line 336 "../gxml/Document.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 336 "../gxml/Document.vala"
				g_propagate_error (error, _inner_error0_);
#line 336 "../gxml/Document.vala"
				_g_object_unref0 (e);
#line 336 "../gxml/Document.vala"
				_g_object_unref0 (_e_list);
#line 336 "../gxml/Document.vala"
				_g_object_unref0 (l);
#line 336 "../gxml/Document.vala"
				_g_object_unref0 (cs);
#line 336 "../gxml/Document.vala"
				return NULL;
#line 3116 "Document.c"
			}
#line 336 "../gxml/Document.vala"
			if (_tmp13_) {
#line 3120 "Document.c"
				GXmlNodeList* _tmp16_;
				GXmlDomNode* _tmp17_;
#line 337 "../gxml/Document.vala"
				_tmp16_ = l;
#line 337 "../gxml/Document.vala"
				_tmp17_ = e;
#line 337 "../gxml/Document.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 3129 "Document.c"
			}
#line 338 "../gxml/Document.vala"
			_tmp19_ = cs;
#line 338 "../gxml/Document.vala"
			_tmp20_ = e;
#line 338 "../gxml/Document.vala"
			_tmp21_ = gxml_css_selector_parser_query_selector_all (_tmp19_, GXML_IS_DOM_ELEMENT (_tmp20_) ? ((GXmlDomElement*) _tmp20_) : NULL, &_inner_error0_);
#line 338 "../gxml/Document.vala"
			_tmp18_ = _tmp21_;
#line 338 "../gxml/Document.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 338 "../gxml/Document.vala"
				g_propagate_error (error, _inner_error0_);
#line 338 "../gxml/Document.vala"
				_g_object_unref0 (e);
#line 338 "../gxml/Document.vala"
				_g_object_unref0 (_e_list);
#line 338 "../gxml/Document.vala"
				_g_object_unref0 (l);
#line 338 "../gxml/Document.vala"
				_g_object_unref0 (cs);
#line 338 "../gxml/Document.vala"
				return NULL;
#line 3153 "Document.c"
			}
#line 338 "../gxml/Document.vala"
			_tmp22_ = l;
#line 338 "../gxml/Document.vala"
			gee_array_list_add_all ((GeeArrayList*) _tmp22_, (GeeCollection*) _tmp18_);
#line 334 "../gxml/Document.vala"
			_g_object_unref0 (_tmp18_);
#line 334 "../gxml/Document.vala"
			_g_object_unref0 (e);
#line 3163 "Document.c"
		}
#line 334 "../gxml/Document.vala"
		_g_object_unref0 (_e_list);
#line 3167 "Document.c"
	}
#line 340 "../gxml/Document.vala"
	result = (GXmlDomNodeList*) l;
#line 340 "../gxml/Document.vala"
	_g_object_unref0 (cs);
#line 340 "../gxml/Document.vala"
	return result;
#line 3175 "Document.c"
}

static GXmlDomElement*
gxml_document_real_get_element_by_id (GXmlDomNonElementParentNode* base,
                                      const gchar* element_id,
                                      GError** error)
{
	GXmlDocument * self;
	GXmlDomElementList* l = NULL;
	GXmlDomElementList* _tmp0_;
	GXmlDomElementList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GXmlDomElementList* _tmp4_;
	GXmlDomElement* _tmp5_;
	GXmlDomElement* _tmp6_;
	GXmlDomElement* result = NULL;
#line 343 "../gxml/Document.vala"
	self = (GXmlDocument*) base;
#line 343 "../gxml/Document.vala"
	g_return_val_if_fail (element_id != NULL, NULL);
#line 344 "../gxml/Document.vala"
	_tmp0_ = gxml_dom_parent_node_get_elements_by_property_value ((GXmlDomParentNode*) self, "id", element_id);
#line 344 "../gxml/Document.vala"
	l = _tmp0_;
#line 345 "../gxml/Document.vala"
	_tmp1_ = l;
#line 345 "../gxml/Document.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 345 "../gxml/Document.vala"
	_tmp3_ = _tmp2_;
#line 345 "../gxml/Document.vala"
	if (_tmp3_ == 0) {
#line 345 "../gxml/Document.vala"
		result = NULL;
#line 345 "../gxml/Document.vala"
		_g_object_unref0 (l);
#line 345 "../gxml/Document.vala"
		return result;
#line 3215 "Document.c"
	}
#line 346 "../gxml/Document.vala"
	_tmp4_ = l;
#line 346 "../gxml/Document.vala"
	_tmp5_ = gxml_dom_html_collection_get_element ((GXmlDomHTMLCollection*) _tmp4_, 0);
#line 346 "../gxml/Document.vala"
	_tmp6_ = GXML_IS_DOM_ELEMENT (_tmp5_) ? ((GXmlDomElement*) _tmp5_) : NULL;
#line 346 "../gxml/Document.vala"
	if (_tmp6_ == NULL) {
#line 346 "../gxml/Document.vala"
		_g_object_unref0 (_tmp5_);
#line 3227 "Document.c"
	}
#line 346 "../gxml/Document.vala"
	result = _tmp6_;
#line 346 "../gxml/Document.vala"
	_g_object_unref0 (l);
#line 346 "../gxml/Document.vala"
	return result;
#line 3235 "Document.c"
}

static GObject *
gxml_document_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GXmlDocument * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 79 "../gxml/Document.vala"
	parent_class = G_OBJECT_CLASS (gxml_document_parent_class);
#line 79 "../gxml/Document.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 79 "../gxml/Document.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GXML_TYPE_DOCUMENT, GXmlDocument);
#line 80 "../gxml/Document.vala"
	_tmp0_ = g_strdup ("#document");
#line 80 "../gxml/Document.vala"
	_g_free0 (((GXmlNode*) self)->_local_name);
#line 80 "../gxml/Document.vala"
	((GXmlNode*) self)->_local_name = _tmp0_;
#line 81 "../gxml/Document.vala"
	((GXmlNode*) self)->_node_type = GXML_DOM_NODE_NODE_TYPE_DOCUMENT_NODE;
#line 82 "../gxml/Document.vala"
	_tmp1_ = g_strdup ("about:blank");
#line 82 "../gxml/Document.vala"
	_g_free0 (self->_url);
#line 82 "../gxml/Document.vala"
	self->_url = _tmp1_;
#line 83 "../gxml/Document.vala"
	_tmp2_ = g_strdup ("");
#line 83 "../gxml/Document.vala"
	_g_free0 (self->_origin);
#line 83 "../gxml/Document.vala"
	self->_origin = _tmp2_;
#line 84 "../gxml/Document.vala"
	_tmp3_ = g_strdup ("");
#line 84 "../gxml/Document.vala"
	_g_free0 (self->_compat_mode);
#line 84 "../gxml/Document.vala"
	self->_compat_mode = _tmp3_;
#line 85 "../gxml/Document.vala"
	_tmp4_ = g_strdup ("utf-8");
#line 85 "../gxml/Document.vala"
	_g_free0 (self->_character_set);
#line 85 "../gxml/Document.vala"
	self->_character_set = _tmp4_;
#line 86 "../gxml/Document.vala"
	_tmp5_ = g_strdup ("application/xml");
#line 86 "../gxml/Document.vala"
	_g_free0 (self->_content_type);
#line 86 "../gxml/Document.vala"
	self->_content_type = _tmp5_;
#line 87 "../gxml/Document.vala"
	_g_object_unref0 (self->_parser);
#line 87 "../gxml/Document.vala"
	self->_parser = NULL;
#line 79 "../gxml/Document.vala"
	return obj;
#line 3302 "Document.c"
}

static void
gxml_document_class_init (GXmlDocumentClass * klass,
                          gpointer klass_data)
{
#line 36 "../gxml/Document.vala"
	gxml_document_parent_class = g_type_class_peek_parent (klass);
#line 36 "../gxml/Document.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gxml_document_get_property;
#line 36 "../gxml/Document.vala"
	G_OBJECT_CLASS (klass)->constructor = gxml_document_constructor;
#line 36 "../gxml/Document.vala"
	G_OBJECT_CLASS (klass)->finalize = gxml_document_finalize;
#line 36 "../gxml/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_DOCUMENT_IMPLEMENTATION_PROPERTY, gxml_document_properties[GXML_DOCUMENT_IMPLEMENTATION_PROPERTY] = g_param_spec_object ("implementation", "implementation", "implementation", GXML_TYPE_DOM_IMPLEMENTATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 36 "../gxml/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_DOCUMENT_URL_PROPERTY, gxml_document_properties[GXML_DOCUMENT_URL_PROPERTY] = g_param_spec_string ("url", "url", "url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 36 "../gxml/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_DOCUMENT_DOCUMENT_URI_PROPERTY, gxml_document_properties[GXML_DOCUMENT_DOCUMENT_URI_PROPERTY] = g_param_spec_string ("document-uri", "document-uri", "document-uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 36 "../gxml/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_DOCUMENT_ORIGIN_PROPERTY, gxml_document_properties[GXML_DOCUMENT_ORIGIN_PROPERTY] = g_param_spec_string ("origin", "origin", "origin", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 36 "../gxml/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_DOCUMENT_COMPAT_MODE_PROPERTY, gxml_document_properties[GXML_DOCUMENT_COMPAT_MODE_PROPERTY] = g_param_spec_string ("compat-mode", "compat-mode", "compat-mode", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 36 "../gxml/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_DOCUMENT_CHARACTER_SET_PROPERTY, gxml_document_properties[GXML_DOCUMENT_CHARACTER_SET_PROPERTY] = g_param_spec_string ("character-set", "character-set", "character-set", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 36 "../gxml/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_DOCUMENT_CONTENT_TYPE_PROPERTY, gxml_document_properties[GXML_DOCUMENT_CONTENT_TYPE_PROPERTY] = g_param_spec_string ("content-type", "content-type", "content-type", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 36 "../gxml/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_DOCUMENT_DOCTYPE_PROPERTY, gxml_document_properties[GXML_DOCUMENT_DOCTYPE_PROPERTY] = g_param_spec_object ("doctype", "doctype", "doctype", GXML_TYPE_DOM_DOCUMENT_TYPE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 36 "../gxml/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_DOCUMENT_DOCUMENT_ELEMENT_PROPERTY, gxml_document_properties[GXML_DOCUMENT_DOCUMENT_ELEMENT_PROPERTY] = g_param_spec_object ("document-element", "document-element", "document-element", GXML_TYPE_DOM_ELEMENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 36 "../gxml/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_DOCUMENT_CHILDREN_PROPERTY, gxml_document_properties[GXML_DOCUMENT_CHILDREN_PROPERTY] = g_param_spec_object ("children", "children", "children", GXML_TYPE_DOM_HTML_COLLECTION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 36 "../gxml/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_DOCUMENT_FIRST_ELEMENT_CHILD_PROPERTY, gxml_document_properties[GXML_DOCUMENT_FIRST_ELEMENT_CHILD_PROPERTY] = g_param_spec_object ("first-element-child", "first-element-child", "first-element-child", GXML_TYPE_DOM_ELEMENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 36 "../gxml/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_DOCUMENT_LAST_ELEMENT_CHILD_PROPERTY, gxml_document_properties[GXML_DOCUMENT_LAST_ELEMENT_CHILD_PROPERTY] = g_param_spec_object ("last-element-child", "last-element-child", "last-element-child", GXML_TYPE_DOM_ELEMENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 36 "../gxml/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_DOCUMENT_CHILD_ELEMENT_COUNT_PROPERTY, gxml_document_properties[GXML_DOCUMENT_CHILD_ELEMENT_COUNT_PROPERTY] = g_param_spec_int ("child-element-count", "child-element-count", "child-element-count", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3343 "Document.c"
}

static void
gxml_document_gxml_dom_parent_node_interface_init (GXmlDomParentNodeIface * iface,
                                                   gpointer iface_data)
{
#line 113 "../gxml/Document.vala"
	gxml_document_gxml_dom_parent_node_parent_iface = g_type_interface_peek_parent (iface);
#line 113 "../gxml/Document.vala"
	iface->query_selector_all = (GXmlDomNodeList* (*) (GXmlDomParentNode*, const gchar*, GError**)) gxml_document_real_query_selector_all;
#line 113 "../gxml/Document.vala"
	iface->get_children = gxml_document_real_get_children;
#line 113 "../gxml/Document.vala"
	iface->get_first_element_child = gxml_document_real_get_first_element_child;
#line 113 "../gxml/Document.vala"
	iface->get_last_element_child = gxml_document_real_get_last_element_child;
#line 113 "../gxml/Document.vala"
	iface->get_child_element_count = gxml_document_real_get_child_element_count;
#line 3362 "Document.c"
}

static void
gxml_document_gxml_dom_non_element_parent_node_interface_init (GXmlDomNonElementParentNodeIface * iface,
                                                               gpointer iface_data)
{
#line 113 "../gxml/Document.vala"
	gxml_document_gxml_dom_non_element_parent_node_parent_iface = g_type_interface_peek_parent (iface);
#line 113 "../gxml/Document.vala"
	iface->get_element_by_id = (GXmlDomElement* (*) (GXmlDomNonElementParentNode*, const gchar*, GError**)) gxml_document_real_get_element_by_id;
#line 3373 "Document.c"
}

static void
gxml_document_gxml_dom_document_interface_init (GXmlDomDocumentIface * iface,
                                                gpointer iface_data)
{
#line 113 "../gxml/Document.vala"
	gxml_document_gxml_dom_document_parent_iface = g_type_interface_peek_parent (iface);
#line 113 "../gxml/Document.vala"
	iface->get_xml_parser = (GXmlParser* (*) (GXmlDomDocument*)) gxml_document_real_get_xml_parser;
#line 113 "../gxml/Document.vala"
	iface->set_xml_parser = (void (*) (GXmlDomDocument*, GXmlParser*)) gxml_document_real_set_xml_parser;
#line 113 "../gxml/Document.vala"
	iface->create_element = (GXmlDomElement* (*) (GXmlDomDocument*, const gchar*, GError**)) gxml_document_real_create_element;
#line 113 "../gxml/Document.vala"
	iface->create_element_ns = (GXmlDomElement* (*) (GXmlDomDocument*, const gchar*, const gchar*, GError**)) gxml_document_real_create_element_ns;
#line 113 "../gxml/Document.vala"
	iface->get_elements_by_tag_name = (GXmlDomHTMLCollection* (*) (GXmlDomDocument*, const gchar*)) gxml_document_real_get_elements_by_tag_name;
#line 113 "../gxml/Document.vala"
	iface->get_elements_by_tag_name_ns = (GXmlDomHTMLCollection* (*) (GXmlDomDocument*, const gchar*, const gchar*)) gxml_document_real_get_elements_by_tag_name_ns;
#line 113 "../gxml/Document.vala"
	iface->get_elements_by_class_name = (GXmlDomHTMLCollection* (*) (GXmlDomDocument*, const gchar*)) gxml_document_real_get_elements_by_class_name;
#line 113 "../gxml/Document.vala"
	iface->create_document_fragment = (GXmlDomDocumentFragment* (*) (GXmlDomDocument*)) gxml_document_real_create_document_fragment;
#line 113 "../gxml/Document.vala"
	iface->create_text_node = (GXmlDomText* (*) (GXmlDomDocument*, const gchar*, GError**)) gxml_document_real_create_text_node;
#line 113 "../gxml/Document.vala"
	iface->create_comment = (GXmlDomComment* (*) (GXmlDomDocument*, const gchar*, GError**)) gxml_document_real_gxml_dom_document_create_comment;
#line 113 "../gxml/Document.vala"
	iface->create_processing_instruction = (GXmlDomProcessingInstruction* (*) (GXmlDomDocument*, const gchar*, const gchar*, GError**)) gxml_document_real_create_processing_instruction;
#line 113 "../gxml/Document.vala"
	iface->import_node = (GXmlDomNode* (*) (GXmlDomDocument*, GXmlDomNode*, gboolean, GError**)) gxml_document_real_import_node;
#line 113 "../gxml/Document.vala"
	iface->adopt_node = (GXmlDomNode* (*) (GXmlDomDocument*, GXmlDomNode*, GError**)) gxml_document_real_adopt_node;
#line 113 "../gxml/Document.vala"
	iface->create_event = (GXmlDomEvent* (*) (GXmlDomDocument*, const gchar*, GError**)) gxml_document_real_create_event;
#line 113 "../gxml/Document.vala"
	iface->create_range = (GXmlDomRange* (*) (GXmlDomDocument*)) gxml_document_real_create_range;
#line 113 "../gxml/Document.vala"
	iface->create_node_iterator = (GXmlDomNodeIterator* (*) (GXmlDomDocument*, GXmlDomNode*, gint)) gxml_document_real_create_node_iterator;
#line 113 "../gxml/Document.vala"
	iface->create_tree_walker = (GXmlDomTreeWalker* (*) (GXmlDomDocument*, GXmlDomNode*, gint)) gxml_document_real_create_tree_walker;
#line 113 "../gxml/Document.vala"
	iface->get_implementation = gxml_document_real_get_implementation;
#line 113 "../gxml/Document.vala"
	iface->get_url = gxml_document_real_get_url;
#line 113 "../gxml/Document.vala"
	iface->get_document_uri = gxml_document_real_get_document_uri;
#line 113 "../gxml/Document.vala"
	iface->get_origin = gxml_document_real_get_origin;
#line 113 "../gxml/Document.vala"
	iface->get_compat_mode = gxml_document_real_get_compat_mode;
#line 113 "../gxml/Document.vala"
	iface->get_character_set = gxml_document_real_get_character_set;
#line 113 "../gxml/Document.vala"
	iface->get_content_type = gxml_document_real_get_content_type;
#line 113 "../gxml/Document.vala"
	iface->get_doctype = gxml_document_real_get_doctype;
#line 113 "../gxml/Document.vala"
	iface->get_document_element = gxml_document_real_get_document_element;
#line 3434 "Document.c"
}

static void
gxml_document_gxml_dom_xml_document_interface_init (GXmlDomXMLDocumentIface * iface,
                                                    gpointer iface_data)
{
#line 113 "../gxml/Document.vala"
	gxml_document_gxml_dom_xml_document_parent_iface = g_type_interface_peek_parent (iface);
#line 3443 "Document.c"
}

static void
gxml_document_instance_init (GXmlDocument * self,
                             gpointer klass)
{
	GXmlImplementation* _tmp0_;
#line 43 "../gxml/Document.vala"
	_tmp0_ = gxml_implementation_new ();
#line 43 "../gxml/Document.vala"
	self->_implementation = (GXmlDomImplementation*) _tmp0_;
#line 3455 "Document.c"
}

static void
gxml_document_finalize (GObject * obj)
{
	GXmlDocument * self;
#line 36 "../gxml/Document.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GXML_TYPE_DOCUMENT, GXmlDocument);
#line 43 "../gxml/Document.vala"
	_g_object_unref0 (self->_implementation);
#line 44 "../gxml/Document.vala"
	_g_free0 (self->_url);
#line 45 "../gxml/Document.vala"
	_g_free0 (self->_origin);
#line 46 "../gxml/Document.vala"
	_g_free0 (self->_compat_mode);
#line 47 "../gxml/Document.vala"
	_g_free0 (self->_character_set);
#line 48 "../gxml/Document.vala"
	_g_free0 (self->_content_type);
#line 49 "../gxml/Document.vala"
	_g_object_unref0 (self->_constructor);
#line 50 "../gxml/Document.vala"
	_g_object_unref0 (self->_parser);
#line 113 "../gxml/Document.vala"
	G_OBJECT_CLASS (gxml_document_parent_class)->finalize (obj);
#line 3482 "Document.c"
}

/**
 * A DOM4 implementation of {@link DomDocument}, for one step parsing.
 *
 * This object avoids pre and post XML parsing, by using a one step parsing
 * to translate text XML tree to an GObject based tree.
 *
 * If you define a property in a derived class with a nick's name '::ROOT' it
 * will be initialized and used as root node to parse documents, when you call
 * {@link DomDocument.read_from_string}, {@link DomDocument.read_from_file} or
 * the like.
 */
static GType
gxml_document_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GXmlDocumentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_document_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GXmlDocument), 0, (GInstanceInitFunc) gxml_document_instance_init, NULL };
	static const GInterfaceInfo gxml_dom_parent_node_info = { (GInterfaceInitFunc) gxml_document_gxml_dom_parent_node_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gxml_dom_non_element_parent_node_info = { (GInterfaceInitFunc) gxml_document_gxml_dom_non_element_parent_node_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gxml_dom_document_info = { (GInterfaceInitFunc) gxml_document_gxml_dom_document_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gxml_dom_xml_document_info = { (GInterfaceInitFunc) gxml_document_gxml_dom_xml_document_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gxml_document_type_id;
	gxml_document_type_id = g_type_register_static (GXML_TYPE_NODE, "GXmlDocument", &g_define_type_info, 0);
	g_type_add_interface_static (gxml_document_type_id, GXML_TYPE_DOM_PARENT_NODE, &gxml_dom_parent_node_info);
	g_type_add_interface_static (gxml_document_type_id, GXML_TYPE_DOM_NON_ELEMENT_PARENT_NODE, &gxml_dom_non_element_parent_node_info);
	g_type_add_interface_static (gxml_document_type_id, GXML_TYPE_DOM_DOCUMENT, &gxml_dom_document_info);
	g_type_add_interface_static (gxml_document_type_id, GXML_TYPE_DOM_XML_DOCUMENT, &gxml_dom_xml_document_info);
	return gxml_document_type_id;
}

GType
gxml_document_get_type (void)
{
	static volatile gsize gxml_document_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_document_type_id__volatile)) {
		GType gxml_document_type_id;
		gxml_document_type_id = gxml_document_get_type_once ();
		g_once_init_leave (&gxml_document_type_id__volatile, gxml_document_type_id);
	}
	return gxml_document_type_id__volatile;
}

static void
_vala_gxml_document_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	GXmlDocument * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_DOCUMENT, GXmlDocument);
#line 36 "../gxml/Document.vala"
	switch (property_id) {
#line 36 "../gxml/Document.vala"
		case GXML_DOCUMENT_IMPLEMENTATION_PROPERTY:
#line 36 "../gxml/Document.vala"
		g_value_set_object (value, gxml_dom_document_get_implementation ((GXmlDomDocument*) self));
#line 36 "../gxml/Document.vala"
		break;
#line 36 "../gxml/Document.vala"
		case GXML_DOCUMENT_URL_PROPERTY:
#line 36 "../gxml/Document.vala"
		g_value_set_string (value, gxml_dom_document_get_url ((GXmlDomDocument*) self));
#line 36 "../gxml/Document.vala"
		break;
#line 36 "../gxml/Document.vala"
		case GXML_DOCUMENT_DOCUMENT_URI_PROPERTY:
#line 36 "../gxml/Document.vala"
		g_value_set_string (value, gxml_dom_document_get_document_uri ((GXmlDomDocument*) self));
#line 36 "../gxml/Document.vala"
		break;
#line 36 "../gxml/Document.vala"
		case GXML_DOCUMENT_ORIGIN_PROPERTY:
#line 36 "../gxml/Document.vala"
		g_value_set_string (value, gxml_dom_document_get_origin ((GXmlDomDocument*) self));
#line 36 "../gxml/Document.vala"
		break;
#line 36 "../gxml/Document.vala"
		case GXML_DOCUMENT_COMPAT_MODE_PROPERTY:
#line 36 "../gxml/Document.vala"
		g_value_set_string (value, gxml_dom_document_get_compat_mode ((GXmlDomDocument*) self));
#line 36 "../gxml/Document.vala"
		break;
#line 36 "../gxml/Document.vala"
		case GXML_DOCUMENT_CHARACTER_SET_PROPERTY:
#line 36 "../gxml/Document.vala"
		g_value_set_string (value, gxml_dom_document_get_character_set ((GXmlDomDocument*) self));
#line 36 "../gxml/Document.vala"
		break;
#line 36 "../gxml/Document.vala"
		case GXML_DOCUMENT_CONTENT_TYPE_PROPERTY:
#line 36 "../gxml/Document.vala"
		g_value_set_string (value, gxml_dom_document_get_content_type ((GXmlDomDocument*) self));
#line 36 "../gxml/Document.vala"
		break;
#line 36 "../gxml/Document.vala"
		case GXML_DOCUMENT_DOCTYPE_PROPERTY:
#line 36 "../gxml/Document.vala"
		g_value_take_object (value, gxml_dom_document_get_doctype ((GXmlDomDocument*) self));
#line 36 "../gxml/Document.vala"
		break;
#line 36 "../gxml/Document.vala"
		case GXML_DOCUMENT_DOCUMENT_ELEMENT_PROPERTY:
#line 36 "../gxml/Document.vala"
		g_value_take_object (value, gxml_dom_document_get_document_element ((GXmlDomDocument*) self));
#line 36 "../gxml/Document.vala"
		break;
#line 36 "../gxml/Document.vala"
		case GXML_DOCUMENT_CHILDREN_PROPERTY:
#line 36 "../gxml/Document.vala"
		g_value_take_object (value, gxml_dom_parent_node_get_children ((GXmlDomParentNode*) self));
#line 36 "../gxml/Document.vala"
		break;
#line 36 "../gxml/Document.vala"
		case GXML_DOCUMENT_FIRST_ELEMENT_CHILD_PROPERTY:
#line 36 "../gxml/Document.vala"
		g_value_take_object (value, gxml_dom_parent_node_get_first_element_child ((GXmlDomParentNode*) self));
#line 36 "../gxml/Document.vala"
		break;
#line 36 "../gxml/Document.vala"
		case GXML_DOCUMENT_LAST_ELEMENT_CHILD_PROPERTY:
#line 36 "../gxml/Document.vala"
		g_value_take_object (value, gxml_dom_parent_node_get_last_element_child ((GXmlDomParentNode*) self));
#line 36 "../gxml/Document.vala"
		break;
#line 36 "../gxml/Document.vala"
		case GXML_DOCUMENT_CHILD_ELEMENT_COUNT_PROPERTY:
#line 36 "../gxml/Document.vala"
		g_value_set_int (value, gxml_dom_parent_node_get_child_element_count ((GXmlDomParentNode*) self));
#line 36 "../gxml/Document.vala"
		break;
#line 3613 "Document.c"
		default:
#line 36 "../gxml/Document.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "../gxml/Document.vala"
		break;
#line 3619 "Document.c"
	}
}

static GXmlDomDocumentType*
gxml_implementation_real_create_document_type (GXmlDomImplementation* base,
                                               const gchar* qualified_name,
                                               const gchar* public_id,
                                               const gchar* system_id,
                                               GError** error)
{
	GXmlImplementation * self;
	GXmlDocument* _tmp0_;
	GXmlDocument* _tmp1_;
	GXmlDocumentType* _tmp2_;
	GXmlDomDocumentType* _tmp3_;
	GXmlDomDocumentType* result = NULL;
#line 351 "../gxml/Document.vala"
	self = (GXmlImplementation*) base;
#line 351 "../gxml/Document.vala"
	g_return_val_if_fail (qualified_name != NULL, NULL);
#line 351 "../gxml/Document.vala"
	g_return_val_if_fail (public_id != NULL, NULL);
#line 351 "../gxml/Document.vala"
	g_return_val_if_fail (system_id != NULL, NULL);
#line 356 "../gxml/Document.vala"
	_tmp0_ = gxml_document_new ();
#line 356 "../gxml/Document.vala"
	_tmp1_ = _tmp0_;
#line 356 "../gxml/Document.vala"
	_tmp2_ = gxml_document_type_new_with_ids ((GXmlDomDocument*) _tmp1_, qualified_name, public_id, system_id);
#line 356 "../gxml/Document.vala"
	_tmp3_ = (GXmlDomDocumentType*) _tmp2_;
#line 356 "../gxml/Document.vala"
	_g_object_unref0 (_tmp1_);
#line 356 "../gxml/Document.vala"
	result = _tmp3_;
#line 356 "../gxml/Document.vala"
	return result;
#line 3658 "Document.c"
}

static GXmlDomXMLDocument*
gxml_implementation_real_create_document (GXmlDomImplementation* base,
                                          const gchar* namespace,
                                          const gchar* qualified_name,
                                          GXmlDomDocumentType* doctype,
                                          GError** error)
{
	GXmlImplementation * self;
	GXmlDocument* d = NULL;
	GXmlDocument* _tmp0_;
	GXmlDomElement* _tmp13_ = NULL;
	GXmlDocument* _tmp14_;
	GXmlDomElement* _tmp15_;
	GXmlDocument* _tmp16_;
	GXmlDomNode* _tmp17_;
	GXmlDomNode* _tmp18_;
	GXmlDocument* _tmp19_;
	GXmlDomXMLDocument* _tmp20_;
	GError* _inner_error0_ = NULL;
	GXmlDomXMLDocument* result = NULL;
#line 358 "../gxml/Document.vala"
	self = (GXmlImplementation*) base;
#line 363 "../gxml/Document.vala"
	_tmp0_ = gxml_document_new ();
#line 363 "../gxml/Document.vala"
	d = _tmp0_;
#line 364 "../gxml/Document.vala"
	if (doctype != NULL) {
#line 3689 "Document.c"
		GXmlDocument* _tmp1_;
		GXmlDocument* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		GXmlDocumentType* _tmp9_;
		GXmlDocumentType* _tmp10_;
		GXmlDomNode* _tmp11_;
		GXmlDomNode* _tmp12_;
#line 365 "../gxml/Document.vala"
		_tmp1_ = d;
#line 365 "../gxml/Document.vala"
		_tmp2_ = d;
#line 365 "../gxml/Document.vala"
		_tmp3_ = gxml_dom_document_type_get_name (doctype);
#line 365 "../gxml/Document.vala"
		_tmp4_ = _tmp3_;
#line 365 "../gxml/Document.vala"
		_tmp5_ = gxml_dom_document_type_get_public_id (doctype);
#line 365 "../gxml/Document.vala"
		_tmp6_ = _tmp5_;
#line 365 "../gxml/Document.vala"
		_tmp7_ = gxml_dom_document_type_get_system_id (doctype);
#line 365 "../gxml/Document.vala"
		_tmp8_ = _tmp7_;
#line 365 "../gxml/Document.vala"
		_tmp9_ = gxml_document_type_new_with_ids ((GXmlDomDocument*) _tmp2_, _tmp4_, _tmp6_, _tmp8_);
#line 365 "../gxml/Document.vala"
		_tmp10_ = _tmp9_;
#line 365 "../gxml/Document.vala"
		_tmp11_ = gxml_dom_node_append_child ((GXmlDomNode*) _tmp1_, (GXmlDomNode*) _tmp10_, &_inner_error0_);
#line 365 "../gxml/Document.vala"
		_tmp12_ = _tmp11_;
#line 365 "../gxml/Document.vala"
		_g_object_unref0 (_tmp12_);
#line 365 "../gxml/Document.vala"
		_g_object_unref0 (_tmp10_);
#line 365 "../gxml/Document.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 365 "../gxml/Document.vala"
			g_propagate_error (error, _inner_error0_);
#line 365 "../gxml/Document.vala"
			_g_object_unref0 (d);
#line 365 "../gxml/Document.vala"
			return NULL;
#line 3738 "Document.c"
		}
	}
#line 369 "../gxml/Document.vala"
	_tmp14_ = d;
#line 369 "../gxml/Document.vala"
	_tmp15_ = gxml_dom_document_create_element_ns ((GXmlDomDocument*) _tmp14_, namespace, qualified_name, &_inner_error0_);
#line 369 "../gxml/Document.vala"
	_tmp13_ = _tmp15_;
#line 369 "../gxml/Document.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 369 "../gxml/Document.vala"
		g_propagate_error (error, _inner_error0_);
#line 369 "../gxml/Document.vala"
		_g_object_unref0 (d);
#line 369 "../gxml/Document.vala"
		return NULL;
#line 3755 "Document.c"
	}
#line 369 "../gxml/Document.vala"
	_tmp16_ = d;
#line 369 "../gxml/Document.vala"
	_tmp17_ = gxml_dom_node_append_child ((GXmlDomNode*) _tmp16_, (GXmlDomNode*) _tmp13_, &_inner_error0_);
#line 369 "../gxml/Document.vala"
	_tmp18_ = _tmp17_;
#line 369 "../gxml/Document.vala"
	_g_object_unref0 (_tmp18_);
#line 369 "../gxml/Document.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 369 "../gxml/Document.vala"
		g_propagate_error (error, _inner_error0_);
#line 369 "../gxml/Document.vala"
		_g_object_unref0 (_tmp13_);
#line 369 "../gxml/Document.vala"
		_g_object_unref0 (d);
#line 369 "../gxml/Document.vala"
		return NULL;
#line 3775 "Document.c"
	}
#line 370 "../gxml/Document.vala"
	_tmp19_ = d;
#line 370 "../gxml/Document.vala"
	_tmp20_ = _g_object_ref0 (GXML_IS_DOM_XML_DOCUMENT (_tmp19_) ? ((GXmlDomXMLDocument*) _tmp19_) : NULL);
#line 370 "../gxml/Document.vala"
	result = _tmp20_;
#line 370 "../gxml/Document.vala"
	_g_object_unref0 (_tmp13_);
#line 370 "../gxml/Document.vala"
	_g_object_unref0 (d);
#line 370 "../gxml/Document.vala"
	return result;
#line 3789 "Document.c"
}

static GXmlDomDocument*
gxml_implementation_real_create_html_document (GXmlDomImplementation* base,
                                               const gchar* title)
{
	GXmlImplementation * self;
	GXmlXHtmlDocument* _tmp0_;
	GXmlDomDocument* result = NULL;
#line 372 "../gxml/Document.vala"
	self = (GXmlImplementation*) base;
#line 372 "../gxml/Document.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 373 "../gxml/Document.vala"
	_tmp0_ = gxml_xhtml_document_new ();
#line 373 "../gxml/Document.vala"
	result = (GXmlDomDocument*) _tmp0_;
#line 373 "../gxml/Document.vala"
	return result;
#line 3809 "Document.c"
}

GXmlImplementation*
gxml_implementation_construct (GType object_type)
{
	GXmlImplementation * self = NULL;
#line 350 "../gxml/Document.vala"
	self = (GXmlImplementation*) g_object_new (object_type, NULL);
#line 350 "../gxml/Document.vala"
	return self;
#line 3820 "Document.c"
}

GXmlImplementation*
gxml_implementation_new (void)
{
#line 350 "../gxml/Document.vala"
	return gxml_implementation_construct (GXML_TYPE_IMPLEMENTATION);
#line 3828 "Document.c"
}

static void
gxml_implementation_class_init (GXmlImplementationClass * klass,
                                gpointer klass_data)
{
#line 350 "../gxml/Document.vala"
	gxml_implementation_parent_class = g_type_class_peek_parent (klass);
#line 3837 "Document.c"
}

static void
gxml_implementation_gxml_dom_implementation_interface_init (GXmlDomImplementationIface * iface,
                                                            gpointer iface_data)
{
#line 350 "../gxml/Document.vala"
	gxml_implementation_gxml_dom_implementation_parent_iface = g_type_interface_peek_parent (iface);
#line 350 "../gxml/Document.vala"
	iface->create_document_type = (GXmlDomDocumentType* (*) (GXmlDomImplementation*, const gchar*, const gchar*, const gchar*, GError**)) gxml_implementation_real_create_document_type;
#line 350 "../gxml/Document.vala"
	iface->create_document = (GXmlDomXMLDocument* (*) (GXmlDomImplementation*, const gchar*, const gchar*, GXmlDomDocumentType*, GError**)) gxml_implementation_real_create_document;
#line 350 "../gxml/Document.vala"
	iface->create_html_document = (GXmlDomDocument* (*) (GXmlDomImplementation*, const gchar*)) gxml_implementation_real_create_html_document;
#line 3852 "Document.c"
}

static void
gxml_implementation_instance_init (GXmlImplementation * self,
                                   gpointer klass)
{
}

static GType
gxml_implementation_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GXmlImplementationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_implementation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GXmlImplementation), 0, (GInstanceInitFunc) gxml_implementation_instance_init, NULL };
	static const GInterfaceInfo gxml_dom_implementation_info = { (GInterfaceInitFunc) gxml_implementation_gxml_dom_implementation_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gxml_implementation_type_id;
	gxml_implementation_type_id = g_type_register_static (G_TYPE_OBJECT, "GXmlImplementation", &g_define_type_info, 0);
	g_type_add_interface_static (gxml_implementation_type_id, GXML_TYPE_DOM_IMPLEMENTATION, &gxml_dom_implementation_info);
	return gxml_implementation_type_id;
}

GType
gxml_implementation_get_type (void)
{
	static volatile gsize gxml_implementation_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_implementation_type_id__volatile)) {
		GType gxml_implementation_type_id;
		gxml_implementation_type_id = gxml_implementation_get_type_once ();
		g_once_init_leave (&gxml_implementation_type_id__volatile, gxml_implementation_type_id);
	}
	return gxml_implementation_type_id__volatile;
}

static const gchar*
gxml_document_type_real_get_name (GXmlDomDocumentType* base)
{
	const gchar* result;
	GXmlDocumentType* self;
	const gchar* _tmp0_;
#line 386 "../gxml/Document.vala"
	self = (GXmlDocumentType*) base;
#line 386 "../gxml/Document.vala"
	_tmp0_ = self->_name;
#line 386 "../gxml/Document.vala"
	result = _tmp0_;
#line 386 "../gxml/Document.vala"
	return result;
#line 3898 "Document.c"
}

static const gchar*
gxml_document_type_real_get_public_id (GXmlDomDocumentType* base)
{
	const gchar* result;
	GXmlDocumentType* self;
	const gchar* _tmp0_;
#line 387 "../gxml/Document.vala"
	self = (GXmlDocumentType*) base;
#line 387 "../gxml/Document.vala"
	_tmp0_ = self->_public_id;
#line 387 "../gxml/Document.vala"
	result = _tmp0_;
#line 387 "../gxml/Document.vala"
	return result;
#line 3915 "Document.c"
}

static const gchar*
gxml_document_type_real_get_system_id (GXmlDomDocumentType* base)
{
	const gchar* result;
	GXmlDocumentType* self;
	const gchar* _tmp0_;
#line 388 "../gxml/Document.vala"
	self = (GXmlDocumentType*) base;
#line 388 "../gxml/Document.vala"
	_tmp0_ = self->_system_id;
#line 388 "../gxml/Document.vala"
	result = _tmp0_;
#line 388 "../gxml/Document.vala"
	return result;
#line 3932 "Document.c"
}

GXmlDocumentType*
gxml_document_type_construct (GType object_type,
                              GXmlDomDocument* doc,
                              const gchar* name,
                              const gchar* public_id,
                              const gchar* system_id)
{
	GXmlDocumentType * self = NULL;
	GXmlDomDocument* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 394 "../gxml/Document.vala"
	g_return_val_if_fail (doc != NULL, NULL);
#line 394 "../gxml/Document.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 394 "../gxml/Document.vala"
	self = (GXmlDocumentType*) gxml_node_construct (object_type);
#line 395 "../gxml/Document.vala"
	_tmp0_ = _g_object_ref0 (doc);
#line 395 "../gxml/Document.vala"
	_g_object_unref0 (((GXmlNode*) self)->_document);
#line 395 "../gxml/Document.vala"
	((GXmlNode*) self)->_document = _tmp0_;
#line 396 "../gxml/Document.vala"
	_tmp1_ = g_strdup (name);
#line 396 "../gxml/Document.vala"
	_g_free0 (self->_name);
#line 396 "../gxml/Document.vala"
	self->_name = _tmp1_;
#line 397 "../gxml/Document.vala"
	_tmp2_ = g_strdup (public_id);
#line 397 "../gxml/Document.vala"
	_g_free0 (self->_public_id);
#line 397 "../gxml/Document.vala"
	self->_public_id = _tmp2_;
#line 398 "../gxml/Document.vala"
	_tmp3_ = g_strdup (system_id);
#line 398 "../gxml/Document.vala"
	_g_free0 (self->_system_id);
#line 398 "../gxml/Document.vala"
	self->_system_id = _tmp3_;
#line 394 "../gxml/Document.vala"
	return self;
#line 3979 "Document.c"
}

GXmlDocumentType*
gxml_document_type_new (GXmlDomDocument* doc,
                        const gchar* name,
                        const gchar* public_id,
                        const gchar* system_id)
{
#line 394 "../gxml/Document.vala"
	return gxml_document_type_construct (GXML_TYPE_DOCUMENT_TYPE, doc, name, public_id, system_id);
#line 3990 "Document.c"
}

GXmlDocumentType*
gxml_document_type_construct_with_name (GType object_type,
                                        GXmlDomDocument* doc,
                                        const gchar* name)
{
	GXmlDocumentType * self = NULL;
	GXmlDomDocument* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 400 "../gxml/Document.vala"
	g_return_val_if_fail (doc != NULL, NULL);
#line 400 "../gxml/Document.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 400 "../gxml/Document.vala"
	self = (GXmlDocumentType*) gxml_node_construct (object_type);
#line 401 "../gxml/Document.vala"
	_tmp0_ = _g_object_ref0 (doc);
#line 401 "../gxml/Document.vala"
	_g_object_unref0 (((GXmlNode*) self)->_document);
#line 401 "../gxml/Document.vala"
	((GXmlNode*) self)->_document = _tmp0_;
#line 402 "../gxml/Document.vala"
	_tmp1_ = g_strdup (name);
#line 402 "../gxml/Document.vala"
	_g_free0 (self->_name);
#line 402 "../gxml/Document.vala"
	self->_name = _tmp1_;
#line 403 "../gxml/Document.vala"
	_tmp2_ = g_strdup ("");
#line 403 "../gxml/Document.vala"
	_g_free0 (self->_public_id);
#line 403 "../gxml/Document.vala"
	self->_public_id = _tmp2_;
#line 404 "../gxml/Document.vala"
	_tmp3_ = g_strdup ("");
#line 404 "../gxml/Document.vala"
	_g_free0 (self->_system_id);
#line 404 "../gxml/Document.vala"
	self->_system_id = _tmp3_;
#line 400 "../gxml/Document.vala"
	return self;
#line 4035 "Document.c"
}

GXmlDocumentType*
gxml_document_type_new_with_name (GXmlDomDocument* doc,
                                  const gchar* name)
{
#line 400 "../gxml/Document.vala"
	return gxml_document_type_construct_with_name (GXML_TYPE_DOCUMENT_TYPE, doc, name);
#line 4044 "Document.c"
}

GXmlDocumentType*
gxml_document_type_construct_with_ids (GType object_type,
                                       GXmlDomDocument* doc,
                                       const gchar* name,
                                       const gchar* public_id,
                                       const gchar* system_id)
{
	GXmlDocumentType * self = NULL;
	GXmlDomDocument* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 406 "../gxml/Document.vala"
	g_return_val_if_fail (doc != NULL, NULL);
#line 406 "../gxml/Document.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 406 "../gxml/Document.vala"
	g_return_val_if_fail (public_id != NULL, NULL);
#line 406 "../gxml/Document.vala"
	g_return_val_if_fail (system_id != NULL, NULL);
#line 406 "../gxml/Document.vala"
	self = (GXmlDocumentType*) gxml_node_construct (object_type);
#line 407 "../gxml/Document.vala"
	_tmp0_ = _g_object_ref0 (doc);
#line 407 "../gxml/Document.vala"
	_g_object_unref0 (((GXmlNode*) self)->_document);
#line 407 "../gxml/Document.vala"
	((GXmlNode*) self)->_document = _tmp0_;
#line 408 "../gxml/Document.vala"
	_tmp1_ = g_strdup (name);
#line 408 "../gxml/Document.vala"
	_g_free0 (self->_name);
#line 408 "../gxml/Document.vala"
	self->_name = _tmp1_;
#line 409 "../gxml/Document.vala"
	_tmp2_ = g_strdup (public_id);
#line 409 "../gxml/Document.vala"
	_g_free0 (self->_public_id);
#line 409 "../gxml/Document.vala"
	self->_public_id = _tmp2_;
#line 410 "../gxml/Document.vala"
	_tmp3_ = g_strdup (system_id);
#line 410 "../gxml/Document.vala"
	_g_free0 (self->_system_id);
#line 410 "../gxml/Document.vala"
	self->_system_id = _tmp3_;
#line 406 "../gxml/Document.vala"
	return self;
#line 4095 "Document.c"
}

GXmlDocumentType*
gxml_document_type_new_with_ids (GXmlDomDocument* doc,
                                 const gchar* name,
                                 const gchar* public_id,
                                 const gchar* system_id)
{
#line 406 "../gxml/Document.vala"
	return gxml_document_type_construct_with_ids (GXML_TYPE_DOCUMENT_TYPE, doc, name, public_id, system_id);
#line 4106 "Document.c"
}

static void
gxml_document_type_real_remove (GXmlDomChildNode* base)
{
	GXmlDocumentType * self;
	GXmlDomNode* _tmp0_;
	GXmlDomNode* _tmp1_;
	GXmlDomNode* _tmp2_;
	gboolean _tmp3_;
	GXmlDomNode* _tmp4_;
	GXmlDomNode* _tmp5_;
	GXmlDomNode* _tmp6_;
	GXmlDomNodeList* _tmp7_;
	GXmlDomNodeList* _tmp8_;
	GXmlDomNodeList* _tmp9_;
	gboolean _tmp10_;
	gint i = 0;
	GXmlDomNode* _tmp11_;
	GXmlDomNode* _tmp12_;
	GXmlDomNode* _tmp13_;
	GXmlDomNodeList* _tmp14_;
	GXmlDomNodeList* _tmp15_;
	GXmlDomNodeList* _tmp16_;
	gint _tmp17_;
	GXmlDomNode* _tmp18_;
	GXmlDomNode* _tmp19_;
	GXmlDomNode* _tmp20_;
	GXmlDomNodeList* _tmp21_;
	GXmlDomNodeList* _tmp22_;
	GXmlDomNodeList* _tmp23_;
	gpointer _tmp24_;
	GXmlDomNode* _tmp25_;
#line 413 "../gxml/Document.vala"
	self = (GXmlDocumentType*) base;
#line 414 "../gxml/Document.vala"
	_tmp0_ = gxml_dom_node_get_parent_node ((GXmlDomNode*) self);
#line 414 "../gxml/Document.vala"
	_tmp1_ = _tmp0_;
#line 414 "../gxml/Document.vala"
	_tmp2_ = _tmp1_;
#line 414 "../gxml/Document.vala"
	_tmp3_ = _tmp2_ == NULL;
#line 414 "../gxml/Document.vala"
	_g_object_unref0 (_tmp2_);
#line 414 "../gxml/Document.vala"
	if (_tmp3_) {
#line 414 "../gxml/Document.vala"
		return;
#line 4156 "Document.c"
	}
#line 415 "../gxml/Document.vala"
	_tmp4_ = gxml_dom_node_get_parent_node ((GXmlDomNode*) self);
#line 415 "../gxml/Document.vala"
	_tmp5_ = _tmp4_;
#line 415 "../gxml/Document.vala"
	_tmp6_ = _tmp5_;
#line 415 "../gxml/Document.vala"
	_tmp7_ = gxml_dom_node_get_child_nodes (_tmp6_);
#line 415 "../gxml/Document.vala"
	_tmp8_ = _tmp7_;
#line 415 "../gxml/Document.vala"
	_tmp9_ = _tmp8_;
#line 415 "../gxml/Document.vala"
	_tmp10_ = _tmp9_ == NULL;
#line 415 "../gxml/Document.vala"
	_g_object_unref0 (_tmp9_);
#line 415 "../gxml/Document.vala"
	_g_object_unref0 (_tmp6_);
#line 415 "../gxml/Document.vala"
	if (_tmp10_) {
#line 415 "../gxml/Document.vala"
		return;
#line 4180 "Document.c"
	}
#line 416 "../gxml/Document.vala"
	_tmp11_ = gxml_dom_node_get_parent_node ((GXmlDomNode*) self);
#line 416 "../gxml/Document.vala"
	_tmp12_ = _tmp11_;
#line 416 "../gxml/Document.vala"
	_tmp13_ = _tmp12_;
#line 416 "../gxml/Document.vala"
	_tmp14_ = gxml_dom_node_get_child_nodes (_tmp13_);
#line 416 "../gxml/Document.vala"
	_tmp15_ = _tmp14_;
#line 416 "../gxml/Document.vala"
	_tmp16_ = _tmp15_;
#line 416 "../gxml/Document.vala"
	_tmp17_ = gee_list_index_of ((GeeList*) _tmp16_, (GXmlDomNode*) self);
#line 416 "../gxml/Document.vala"
	_g_object_unref0 (_tmp16_);
#line 416 "../gxml/Document.vala"
	_g_object_unref0 (_tmp13_);
#line 416 "../gxml/Document.vala"
	i = _tmp17_;
#line 417 "../gxml/Document.vala"
	_tmp18_ = gxml_dom_node_get_parent_node ((GXmlDomNode*) self);
#line 417 "../gxml/Document.vala"
	_tmp19_ = _tmp18_;
#line 417 "../gxml/Document.vala"
	_tmp20_ = _tmp19_;
#line 417 "../gxml/Document.vala"
	_tmp21_ = gxml_dom_node_get_child_nodes (_tmp20_);
#line 417 "../gxml/Document.vala"
	_tmp22_ = _tmp21_;
#line 417 "../gxml/Document.vala"
	_tmp23_ = _tmp22_;
#line 417 "../gxml/Document.vala"
	_tmp24_ = gee_list_remove_at ((GeeList*) _tmp23_, i);
#line 417 "../gxml/Document.vala"
	_tmp25_ = (GXmlDomNode*) _tmp24_;
#line 417 "../gxml/Document.vala"
	_g_object_unref0 (_tmp25_);
#line 417 "../gxml/Document.vala"
	_g_object_unref0 (_tmp23_);
#line 417 "../gxml/Document.vala"
	_g_object_unref0 (_tmp20_);
#line 4224 "Document.c"
}

static GObject *
gxml_document_type_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GXmlDocumentType * self;
	gchar* _tmp0_;
#line 390 "../gxml/Document.vala"
	parent_class = G_OBJECT_CLASS (gxml_document_type_parent_class);
#line 390 "../gxml/Document.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 390 "../gxml/Document.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GXML_TYPE_DOCUMENT_TYPE, GXmlDocumentType);
#line 391 "../gxml/Document.vala"
	((GXmlNode*) self)->_node_type = GXML_DOM_NODE_NODE_TYPE_DOCUMENT_TYPE_NODE;
#line 392 "../gxml/Document.vala"
	_tmp0_ = g_strdup ("!DOCTYPE");
#line 392 "../gxml/Document.vala"
	_g_free0 (((GXmlNode*) self)->_local_name);
#line 392 "../gxml/Document.vala"
	((GXmlNode*) self)->_local_name = _tmp0_;
#line 390 "../gxml/Document.vala"
	return obj;
#line 4252 "Document.c"
}

static void
gxml_document_type_class_init (GXmlDocumentTypeClass * klass,
                               gpointer klass_data)
{
#line 378 "../gxml/Document.vala"
	gxml_document_type_parent_class = g_type_class_peek_parent (klass);
#line 378 "../gxml/Document.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gxml_document_type_get_property;
#line 378 "../gxml/Document.vala"
	G_OBJECT_CLASS (klass)->constructor = gxml_document_type_constructor;
#line 378 "../gxml/Document.vala"
	G_OBJECT_CLASS (klass)->finalize = gxml_document_type_finalize;
#line 378 "../gxml/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_DOCUMENT_TYPE_NAME_PROPERTY, gxml_document_type_properties[GXML_DOCUMENT_TYPE_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 378 "../gxml/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_DOCUMENT_TYPE_PUBLIC_ID_PROPERTY, gxml_document_type_properties[GXML_DOCUMENT_TYPE_PUBLIC_ID_PROPERTY] = g_param_spec_string ("public-id", "public-id", "public-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 378 "../gxml/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_DOCUMENT_TYPE_SYSTEM_ID_PROPERTY, gxml_document_type_properties[GXML_DOCUMENT_TYPE_SYSTEM_ID_PROPERTY] = g_param_spec_string ("system-id", "system-id", "system-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4273 "Document.c"
}

static void
gxml_document_type_gxml_dom_child_node_interface_init (GXmlDomChildNodeIface * iface,
                                                       gpointer iface_data)
{
#line 378 "../gxml/Document.vala"
	gxml_document_type_gxml_dom_child_node_parent_iface = g_type_interface_peek_parent (iface);
#line 378 "../gxml/Document.vala"
	iface->remove = (void (*) (GXmlDomChildNode*)) gxml_document_type_real_remove;
#line 4284 "Document.c"
}

static void
gxml_document_type_gxml_dom_document_type_interface_init (GXmlDomDocumentTypeIface * iface,
                                                          gpointer iface_data)
{
#line 378 "../gxml/Document.vala"
	gxml_document_type_gxml_dom_document_type_parent_iface = g_type_interface_peek_parent (iface);
#line 378 "../gxml/Document.vala"
	iface->get_name = gxml_document_type_real_get_name;
#line 378 "../gxml/Document.vala"
	iface->get_public_id = gxml_document_type_real_get_public_id;
#line 378 "../gxml/Document.vala"
	iface->get_system_id = gxml_document_type_real_get_system_id;
#line 4299 "Document.c"
}

static void
gxml_document_type_instance_init (GXmlDocumentType * self,
                                  gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 382 "../gxml/Document.vala"
	_tmp0_ = g_strdup ("");
#line 382 "../gxml/Document.vala"
	self->_name = _tmp0_;
#line 383 "../gxml/Document.vala"
	_tmp1_ = g_strdup ("");
#line 383 "../gxml/Document.vala"
	self->_public_id = _tmp1_;
#line 384 "../gxml/Document.vala"
	_tmp2_ = g_strdup ("");
#line 384 "../gxml/Document.vala"
	self->_system_id = _tmp2_;
#line 4321 "Document.c"
}

static void
gxml_document_type_finalize (GObject * obj)
{
	GXmlDocumentType * self;
#line 378 "../gxml/Document.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GXML_TYPE_DOCUMENT_TYPE, GXmlDocumentType);
#line 382 "../gxml/Document.vala"
	_g_free0 (self->_name);
#line 383 "../gxml/Document.vala"
	_g_free0 (self->_public_id);
#line 384 "../gxml/Document.vala"
	_g_free0 (self->_system_id);
#line 378 "../gxml/Document.vala"
	G_OBJECT_CLASS (gxml_document_type_parent_class)->finalize (obj);
#line 4338 "Document.c"
}

static GType
gxml_document_type_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GXmlDocumentTypeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_document_type_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GXmlDocumentType), 0, (GInstanceInitFunc) gxml_document_type_instance_init, NULL };
	static const GInterfaceInfo gxml_dom_child_node_info = { (GInterfaceInitFunc) gxml_document_type_gxml_dom_child_node_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gxml_dom_document_type_info = { (GInterfaceInitFunc) gxml_document_type_gxml_dom_document_type_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gxml_document_type_type_id;
	gxml_document_type_type_id = g_type_register_static (GXML_TYPE_NODE, "GXmlDocumentType", &g_define_type_info, 0);
	g_type_add_interface_static (gxml_document_type_type_id, GXML_TYPE_DOM_CHILD_NODE, &gxml_dom_child_node_info);
	g_type_add_interface_static (gxml_document_type_type_id, GXML_TYPE_DOM_DOCUMENT_TYPE, &gxml_dom_document_type_info);
	return gxml_document_type_type_id;
}

GType
gxml_document_type_get_type (void)
{
	static volatile gsize gxml_document_type_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_document_type_type_id__volatile)) {
		GType gxml_document_type_type_id;
		gxml_document_type_type_id = gxml_document_type_get_type_once ();
		g_once_init_leave (&gxml_document_type_type_id__volatile, gxml_document_type_type_id);
	}
	return gxml_document_type_type_id__volatile;
}

static void
_vala_gxml_document_type_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	GXmlDocumentType * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_DOCUMENT_TYPE, GXmlDocumentType);
#line 378 "../gxml/Document.vala"
	switch (property_id) {
#line 378 "../gxml/Document.vala"
		case GXML_DOCUMENT_TYPE_NAME_PROPERTY:
#line 378 "../gxml/Document.vala"
		g_value_set_string (value, gxml_dom_document_type_get_name ((GXmlDomDocumentType*) self));
#line 378 "../gxml/Document.vala"
		break;
#line 378 "../gxml/Document.vala"
		case GXML_DOCUMENT_TYPE_PUBLIC_ID_PROPERTY:
#line 378 "../gxml/Document.vala"
		g_value_set_string (value, gxml_dom_document_type_get_public_id ((GXmlDomDocumentType*) self));
#line 378 "../gxml/Document.vala"
		break;
#line 378 "../gxml/Document.vala"
		case GXML_DOCUMENT_TYPE_SYSTEM_ID_PROPERTY:
#line 378 "../gxml/Document.vala"
		g_value_set_string (value, gxml_dom_document_type_get_system_id ((GXmlDomDocumentType*) self));
#line 378 "../gxml/Document.vala"
		break;
#line 4394 "Document.c"
		default:
#line 378 "../gxml/Document.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 378 "../gxml/Document.vala"
		break;
#line 4400 "Document.c"
	}
}

GXmlDocumentFragment*
gxml_document_fragment_construct (GType object_type,
                                  GXmlDomDocument* doc)
{
	GXmlDocumentFragment * self = NULL;
	GXmlDomDocument* _tmp0_;
	gchar* _tmp1_;
#line 427 "../gxml/Document.vala"
	g_return_val_if_fail (doc != NULL, NULL);
#line 427 "../gxml/Document.vala"
	self = (GXmlDocumentFragment*) gxml_node_construct (object_type);
#line 428 "../gxml/Document.vala"
	_tmp0_ = _g_object_ref0 (doc);
#line 428 "../gxml/Document.vala"
	_g_object_unref0 (((GXmlNode*) self)->_document);
#line 428 "../gxml/Document.vala"
	((GXmlNode*) self)->_document = _tmp0_;
#line 429 "../gxml/Document.vala"
	((GXmlNode*) self)->_node_type = GXML_DOM_NODE_NODE_TYPE_DOCUMENT_FRAGMENT_NODE;
#line 430 "../gxml/Document.vala"
	_tmp1_ = g_strdup ("#document-fragment");
#line 430 "../gxml/Document.vala"
	_g_free0 (((GXmlNode*) self)->_local_name);
#line 430 "../gxml/Document.vala"
	((GXmlNode*) self)->_local_name = _tmp1_;
#line 427 "../gxml/Document.vala"
	return self;
#line 4431 "Document.c"
}

GXmlDocumentFragment*
gxml_document_fragment_new (GXmlDomDocument* doc)
{
#line 427 "../gxml/Document.vala"
	return gxml_document_fragment_construct (GXML_TYPE_DOCUMENT_FRAGMENT, doc);
#line 4439 "Document.c"
}

static GXmlDomHTMLCollection*
gxml_document_fragment_real_get_children (GXmlDomParentNode* base)
{
	GXmlDomHTMLCollection* result;
	GXmlDocumentFragment* self;
	GXmlHTMLCollection* l = NULL;
	GXmlHTMLCollection* _tmp0_;
#line 434 "../gxml/Document.vala"
	self = (GXmlDocumentFragment*) base;
#line 435 "../gxml/Document.vala"
	_tmp0_ = gxml_html_collection_new ();
#line 435 "../gxml/Document.vala"
	l = _tmp0_;
#line 4455 "Document.c"
	{
		GXmlDomNodeList* _n_list = NULL;
		GXmlDomNodeList* _tmp1_;
		GXmlDomNodeList* _tmp2_;
		gint _n_size = 0;
		GXmlDomNodeList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _n_index = 0;
#line 436 "../gxml/Document.vala"
		_tmp1_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 436 "../gxml/Document.vala"
		_tmp2_ = _tmp1_;
#line 436 "../gxml/Document.vala"
		_n_list = _tmp2_;
#line 436 "../gxml/Document.vala"
		_tmp3_ = _n_list;
#line 436 "../gxml/Document.vala"
		_tmp4_ = gee_collection_get_size ((GeeCollection*) _tmp3_);
#line 436 "../gxml/Document.vala"
		_tmp5_ = _tmp4_;
#line 436 "../gxml/Document.vala"
		_n_size = _tmp5_;
#line 436 "../gxml/Document.vala"
		_n_index = -1;
#line 436 "../gxml/Document.vala"
		while (TRUE) {
#line 4483 "Document.c"
			gint _tmp6_;
			gint _tmp7_;
			GXmlDomNode* n = NULL;
			GXmlDomNodeList* _tmp8_;
			gpointer _tmp9_;
			GXmlDomNode* _tmp10_;
#line 436 "../gxml/Document.vala"
			_n_index = _n_index + 1;
#line 436 "../gxml/Document.vala"
			_tmp6_ = _n_index;
#line 436 "../gxml/Document.vala"
			_tmp7_ = _n_size;
#line 436 "../gxml/Document.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 436 "../gxml/Document.vala"
				break;
#line 4500 "Document.c"
			}
#line 436 "../gxml/Document.vala"
			_tmp8_ = _n_list;
#line 436 "../gxml/Document.vala"
			_tmp9_ = gee_list_get ((GeeList*) _tmp8_, _n_index);
#line 436 "../gxml/Document.vala"
			n = (GXmlDomNode*) _tmp9_;
#line 437 "../gxml/Document.vala"
			_tmp10_ = n;
#line 437 "../gxml/Document.vala"
			if (GXML_IS_DOM_ELEMENT (_tmp10_)) {
#line 4512 "Document.c"
				GXmlHTMLCollection* _tmp11_;
				GXmlDomNode* _tmp12_;
#line 437 "../gxml/Document.vala"
				_tmp11_ = l;
#line 437 "../gxml/Document.vala"
				_tmp12_ = n;
#line 437 "../gxml/Document.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GXML_TYPE_DOM_ELEMENT, GXmlDomElement));
#line 4521 "Document.c"
			}
#line 436 "../gxml/Document.vala"
			_g_object_unref0 (n);
#line 4525 "Document.c"
		}
#line 436 "../gxml/Document.vala"
		_g_object_unref0 (_n_list);
#line 4529 "Document.c"
	}
#line 439 "../gxml/Document.vala"
	result = (GXmlDomHTMLCollection*) l;
#line 439 "../gxml/Document.vala"
	return result;
#line 4535 "Document.c"
}

static GXmlDomElement*
gxml_document_fragment_real_get_first_element_child (GXmlDomParentNode* base)
{
	GXmlDomElement* result;
	GXmlDocumentFragment* self;
	GXmlDomHTMLCollection* _tmp0_;
	GXmlDomHTMLCollection* _tmp1_;
	GXmlDomHTMLCollection* _tmp2_;
	gpointer _tmp3_;
	GXmlDomElement* _tmp4_;
#line 442 "../gxml/Document.vala"
	self = (GXmlDocumentFragment*) base;
#line 442 "../gxml/Document.vala"
	_tmp0_ = gxml_dom_parent_node_get_children ((GXmlDomParentNode*) self);
#line 442 "../gxml/Document.vala"
	_tmp1_ = _tmp0_;
#line 442 "../gxml/Document.vala"
	_tmp2_ = _tmp1_;
#line 442 "../gxml/Document.vala"
	_tmp3_ = gee_list_first ((GeeList*) _tmp2_);
#line 442 "../gxml/Document.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST ((GXmlDomElement*) _tmp3_, GXML_TYPE_DOM_ELEMENT, GXmlDomElement);
#line 442 "../gxml/Document.vala"
	_g_object_unref0 (_tmp2_);
#line 442 "../gxml/Document.vala"
	result = _tmp4_;
#line 442 "../gxml/Document.vala"
	return result;
#line 4566 "Document.c"
}

static GXmlDomElement*
gxml_document_fragment_real_get_last_element_child (GXmlDomParentNode* base)
{
	GXmlDomElement* result;
	GXmlDocumentFragment* self;
	GXmlDomHTMLCollection* _tmp0_;
	GXmlDomHTMLCollection* _tmp1_;
	GXmlDomHTMLCollection* _tmp2_;
	gpointer _tmp3_;
	GXmlDomElement* _tmp4_;
#line 443 "../gxml/Document.vala"
	self = (GXmlDocumentFragment*) base;
#line 443 "../gxml/Document.vala"
	_tmp0_ = gxml_dom_parent_node_get_children ((GXmlDomParentNode*) self);
#line 443 "../gxml/Document.vala"
	_tmp1_ = _tmp0_;
#line 443 "../gxml/Document.vala"
	_tmp2_ = _tmp1_;
#line 443 "../gxml/Document.vala"
	_tmp3_ = gee_list_last ((GeeList*) _tmp2_);
#line 443 "../gxml/Document.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST ((GXmlDomElement*) _tmp3_, GXML_TYPE_DOM_ELEMENT, GXmlDomElement);
#line 443 "../gxml/Document.vala"
	_g_object_unref0 (_tmp2_);
#line 443 "../gxml/Document.vala"
	result = _tmp4_;
#line 443 "../gxml/Document.vala"
	return result;
#line 4597 "Document.c"
}

static gint
gxml_document_fragment_real_get_child_element_count (GXmlDomParentNode* base)
{
	gint result;
	GXmlDocumentFragment* self;
	GXmlDomHTMLCollection* _tmp0_;
	GXmlDomHTMLCollection* _tmp1_;
	GXmlDomHTMLCollection* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 444 "../gxml/Document.vala"
	self = (GXmlDocumentFragment*) base;
#line 444 "../gxml/Document.vala"
	_tmp0_ = gxml_dom_parent_node_get_children ((GXmlDomParentNode*) self);
#line 444 "../gxml/Document.vala"
	_tmp1_ = _tmp0_;
#line 444 "../gxml/Document.vala"
	_tmp2_ = _tmp1_;
#line 444 "../gxml/Document.vala"
	_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 444 "../gxml/Document.vala"
	_tmp4_ = _tmp3_;
#line 444 "../gxml/Document.vala"
	_tmp5_ = (gint) _tmp4_;
#line 444 "../gxml/Document.vala"
	_g_object_unref0 (_tmp2_);
#line 444 "../gxml/Document.vala"
	result = _tmp5_;
#line 444 "../gxml/Document.vala"
	return result;
#line 4631 "Document.c"
}

static GXmlDomElement*
gxml_document_fragment_real_query_selector (GXmlDomParentNode* base,
                                            const gchar* selectors,
                                            GError** error)
{
	GXmlDocumentFragment * self;
	GError* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 446 "../gxml/Document.vala"
	self = (GXmlDocumentFragment*) base;
#line 446 "../gxml/Document.vala"
	g_return_val_if_fail (selectors != NULL, NULL);
#line 448 "../gxml/Document.vala"
	_tmp0_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_SYNTAX_ERROR, _ ("DomElement query_selector is not implemented"));
#line 448 "../gxml/Document.vala"
	_inner_error0_ = _tmp0_;
#line 448 "../gxml/Document.vala"
	g_propagate_error (error, _inner_error0_);
#line 448 "../gxml/Document.vala"
	return NULL;
#line 4654 "Document.c"
}

static GXmlDomNodeList*
gxml_document_fragment_real_query_selector_all (GXmlDomParentNode* base,
                                                const gchar* selectors,
                                                GError** error)
{
	GXmlDocumentFragment * self;
	GError* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 450 "../gxml/Document.vala"
	self = (GXmlDocumentFragment*) base;
#line 450 "../gxml/Document.vala"
	g_return_val_if_fail (selectors != NULL, NULL);
#line 452 "../gxml/Document.vala"
	_tmp0_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_SYNTAX_ERROR, _ ("DomElement query_selector_all is not implemented"));
#line 452 "../gxml/Document.vala"
	_inner_error0_ = _tmp0_;
#line 452 "../gxml/Document.vala"
	g_propagate_error (error, _inner_error0_);
#line 452 "../gxml/Document.vala"
	return NULL;
#line 4677 "Document.c"
}

static GXmlDomElement*
gxml_document_fragment_real_get_element_by_id (GXmlDomNonElementParentNode* base,
                                               const gchar* element_id,
                                               GError** error)
{
	GXmlDocumentFragment * self;
	GXmlDomElementList* l = NULL;
	GXmlDomElementList* _tmp0_;
	GXmlDomElementList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GXmlDomElementList* _tmp4_;
	GXmlDomElement* _tmp5_;
	GXmlDomElement* _tmp6_;
	GXmlDomElement* _tmp7_;
	GXmlDomElement* result = NULL;
#line 456 "../gxml/Document.vala"
	self = (GXmlDocumentFragment*) base;
#line 456 "../gxml/Document.vala"
	g_return_val_if_fail (element_id != NULL, NULL);
#line 457 "../gxml/Document.vala"
	_tmp0_ = gxml_dom_parent_node_get_elements_by_property_value ((GXmlDomParentNode*) self, "id", element_id);
#line 457 "../gxml/Document.vala"
	l = _tmp0_;
#line 458 "../gxml/Document.vala"
	_tmp1_ = l;
#line 458 "../gxml/Document.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 458 "../gxml/Document.vala"
	_tmp3_ = _tmp2_;
#line 458 "../gxml/Document.vala"
	if (_tmp3_ == 0) {
#line 458 "../gxml/Document.vala"
		result = NULL;
#line 458 "../gxml/Document.vala"
		_g_object_unref0 (l);
#line 458 "../gxml/Document.vala"
		return result;
#line 4718 "Document.c"
	}
#line 459 "../gxml/Document.vala"
	_tmp4_ = l;
#line 459 "../gxml/Document.vala"
	_tmp5_ = gxml_dom_html_collection_get_element ((GXmlDomHTMLCollection*) _tmp4_, 0);
#line 459 "../gxml/Document.vala"
	_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GXML_TYPE_DOM_ELEMENT, GXmlDomElement);
#line 459 "../gxml/Document.vala"
	_tmp7_ = GXML_IS_DOM_ELEMENT (_tmp6_) ? ((GXmlDomElement*) _tmp6_) : NULL;
#line 459 "../gxml/Document.vala"
	if (_tmp7_ == NULL) {
#line 459 "../gxml/Document.vala"
		_g_object_unref0 (_tmp6_);
#line 4732 "Document.c"
	}
#line 459 "../gxml/Document.vala"
	result = _tmp7_;
#line 459 "../gxml/Document.vala"
	_g_object_unref0 (l);
#line 459 "../gxml/Document.vala"
	return result;
#line 4740 "Document.c"
}

static void
gxml_document_fragment_class_init (GXmlDocumentFragmentClass * klass,
                                   gpointer klass_data)
{
#line 422 "../gxml/Document.vala"
	gxml_document_fragment_parent_class = g_type_class_peek_parent (klass);
#line 422 "../gxml/Document.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gxml_document_fragment_get_property;
#line 422 "../gxml/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_DOCUMENT_FRAGMENT_CHILDREN_PROPERTY, gxml_document_fragment_properties[GXML_DOCUMENT_FRAGMENT_CHILDREN_PROPERTY] = g_param_spec_object ("children", "children", "children", GXML_TYPE_DOM_HTML_COLLECTION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 422 "../gxml/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_DOCUMENT_FRAGMENT_FIRST_ELEMENT_CHILD_PROPERTY, gxml_document_fragment_properties[GXML_DOCUMENT_FRAGMENT_FIRST_ELEMENT_CHILD_PROPERTY] = g_param_spec_object ("first-element-child", "first-element-child", "first-element-child", GXML_TYPE_DOM_ELEMENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 422 "../gxml/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_DOCUMENT_FRAGMENT_LAST_ELEMENT_CHILD_PROPERTY, gxml_document_fragment_properties[GXML_DOCUMENT_FRAGMENT_LAST_ELEMENT_CHILD_PROPERTY] = g_param_spec_object ("last-element-child", "last-element-child", "last-element-child", GXML_TYPE_DOM_ELEMENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 422 "../gxml/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_DOCUMENT_FRAGMENT_CHILD_ELEMENT_COUNT_PROPERTY, gxml_document_fragment_properties[GXML_DOCUMENT_FRAGMENT_CHILD_ELEMENT_COUNT_PROPERTY] = g_param_spec_int ("child-element-count", "child-element-count", "child-element-count", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4759 "Document.c"
}

static void
gxml_document_fragment_gxml_dom_parent_node_interface_init (GXmlDomParentNodeIface * iface,
                                                            gpointer iface_data)
{
#line 422 "../gxml/Document.vala"
	gxml_document_fragment_gxml_dom_parent_node_parent_iface = g_type_interface_peek_parent (iface);
#line 422 "../gxml/Document.vala"
	iface->query_selector = (GXmlDomElement* (*) (GXmlDomParentNode*, const gchar*, GError**)) gxml_document_fragment_real_query_selector;
#line 422 "../gxml/Document.vala"
	iface->query_selector_all = (GXmlDomNodeList* (*) (GXmlDomParentNode*, const gchar*, GError**)) gxml_document_fragment_real_query_selector_all;
#line 422 "../gxml/Document.vala"
	iface->get_children = gxml_document_fragment_real_get_children;
#line 422 "../gxml/Document.vala"
	iface->get_first_element_child = gxml_document_fragment_real_get_first_element_child;
#line 422 "../gxml/Document.vala"
	iface->get_last_element_child = gxml_document_fragment_real_get_last_element_child;
#line 422 "../gxml/Document.vala"
	iface->get_child_element_count = gxml_document_fragment_real_get_child_element_count;
#line 4780 "Document.c"
}

static void
gxml_document_fragment_gxml_dom_non_element_parent_node_interface_init (GXmlDomNonElementParentNodeIface * iface,
                                                                        gpointer iface_data)
{
#line 422 "../gxml/Document.vala"
	gxml_document_fragment_gxml_dom_non_element_parent_node_parent_iface = g_type_interface_peek_parent (iface);
#line 422 "../gxml/Document.vala"
	iface->get_element_by_id = (GXmlDomElement* (*) (GXmlDomNonElementParentNode*, const gchar*, GError**)) gxml_document_fragment_real_get_element_by_id;
#line 4791 "Document.c"
}

static void
gxml_document_fragment_gxml_dom_document_fragment_interface_init (GXmlDomDocumentFragmentIface * iface,
                                                                  gpointer iface_data)
{
#line 422 "../gxml/Document.vala"
	gxml_document_fragment_gxml_dom_document_fragment_parent_iface = g_type_interface_peek_parent (iface);
#line 4800 "Document.c"
}

static void
gxml_document_fragment_instance_init (GXmlDocumentFragment * self,
                                      gpointer klass)
{
}

static GType
gxml_document_fragment_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GXmlDocumentFragmentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_document_fragment_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GXmlDocumentFragment), 0, (GInstanceInitFunc) gxml_document_fragment_instance_init, NULL };
	static const GInterfaceInfo gxml_dom_parent_node_info = { (GInterfaceInitFunc) gxml_document_fragment_gxml_dom_parent_node_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gxml_dom_non_element_parent_node_info = { (GInterfaceInitFunc) gxml_document_fragment_gxml_dom_non_element_parent_node_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gxml_dom_document_fragment_info = { (GInterfaceInitFunc) gxml_document_fragment_gxml_dom_document_fragment_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gxml_document_fragment_type_id;
	gxml_document_fragment_type_id = g_type_register_static (GXML_TYPE_NODE, "GXmlDocumentFragment", &g_define_type_info, 0);
	g_type_add_interface_static (gxml_document_fragment_type_id, GXML_TYPE_DOM_PARENT_NODE, &gxml_dom_parent_node_info);
	g_type_add_interface_static (gxml_document_fragment_type_id, GXML_TYPE_DOM_NON_ELEMENT_PARENT_NODE, &gxml_dom_non_element_parent_node_info);
	g_type_add_interface_static (gxml_document_fragment_type_id, GXML_TYPE_DOM_DOCUMENT_FRAGMENT, &gxml_dom_document_fragment_info);
	return gxml_document_fragment_type_id;
}

GType
gxml_document_fragment_get_type (void)
{
	static volatile gsize gxml_document_fragment_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_document_fragment_type_id__volatile)) {
		GType gxml_document_fragment_type_id;
		gxml_document_fragment_type_id = gxml_document_fragment_get_type_once ();
		g_once_init_leave (&gxml_document_fragment_type_id__volatile, gxml_document_fragment_type_id);
	}
	return gxml_document_fragment_type_id__volatile;
}

static void
_vala_gxml_document_fragment_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	GXmlDocumentFragment * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_DOCUMENT_FRAGMENT, GXmlDocumentFragment);
#line 422 "../gxml/Document.vala"
	switch (property_id) {
#line 422 "../gxml/Document.vala"
		case GXML_DOCUMENT_FRAGMENT_CHILDREN_PROPERTY:
#line 422 "../gxml/Document.vala"
		g_value_take_object (value, gxml_dom_parent_node_get_children ((GXmlDomParentNode*) self));
#line 422 "../gxml/Document.vala"
		break;
#line 422 "../gxml/Document.vala"
		case GXML_DOCUMENT_FRAGMENT_FIRST_ELEMENT_CHILD_PROPERTY:
#line 422 "../gxml/Document.vala"
		g_value_take_object (value, gxml_dom_parent_node_get_first_element_child ((GXmlDomParentNode*) self));
#line 422 "../gxml/Document.vala"
		break;
#line 422 "../gxml/Document.vala"
		case GXML_DOCUMENT_FRAGMENT_LAST_ELEMENT_CHILD_PROPERTY:
#line 422 "../gxml/Document.vala"
		g_value_take_object (value, gxml_dom_parent_node_get_last_element_child ((GXmlDomParentNode*) self));
#line 422 "../gxml/Document.vala"
		break;
#line 422 "../gxml/Document.vala"
		case GXML_DOCUMENT_FRAGMENT_CHILD_ELEMENT_COUNT_PROPERTY:
#line 422 "../gxml/Document.vala"
		g_value_set_int (value, gxml_dom_parent_node_get_child_element_count ((GXmlDomParentNode*) self));
#line 422 "../gxml/Document.vala"
		break;
#line 4870 "Document.c"
		default:
#line 422 "../gxml/Document.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 422 "../gxml/Document.vala"
		break;
#line 4876 "Document.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 36 "../gxml/Document.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 4887 "Document.c"
		gssize i;
#line 36 "../gxml/Document.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 36 "../gxml/Document.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 36 "../gxml/Document.vala"
				destroy_func (((gpointer*) array)[i]);
#line 4895 "Document.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 36 "../gxml/Document.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 36 "../gxml/Document.vala"
	g_free (array);
#line 4910 "Document.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 36 "../gxml/Document.vala"
	if (array) {
#line 36 "../gxml/Document.vala"
		while (((gpointer*) array)[length]) {
#line 36 "../gxml/Document.vala"
			length++;
#line 4924 "Document.c"
		}
	}
#line 36 "../gxml/Document.vala"
	return length;
#line 4929 "Document.c"
}

